'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Explicit Off

Imports ESB.Core.Pipeline
Imports ESB.Core.XMLSchemaClasses
Imports System.Reflection



<System.Runtime.InteropServices.ComVisible(False)> Public Class InvokeViaConvention
    Inherits ServiceBase

#Region "Constants"
    Const STR_WorkflowAssembly As String = "WorkflowAssembly"
    Const STR_WorkflowClass As String = "WorkflowClass"
#End Region

    Dim m_oDocRq As Object 'Todo: replace 'Object' with your schema request class eg.Dim m_oDocRq As MemberEnquiryRQ.MemberDetailsEnquiryRQ
    Dim m_oDocRs As Object 'Todo: replace 'Object' with your schema response class eg. Dim m_oDocRs As MemberEnqRSUpdRQ.MemberEnqRSUpdRQ 

    Dim m_sComponentServer As String
    Dim m_sTransactionComponent As String

    'Service Entry Point 
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()

        Try
            MyBase.ProcessMsgSync(oEnv)

            '(This statement gets a document out of the request envelope. This is your service input.)
            'todo: replace this with your schema request class
            'm_oDocRq = oEnv.GetDocumentAsObject(GetType(MemberEnquiryRQ.MemberDetailsEnquiryRQ)  

            'todo: replace this with your schema response class
            'm_oDocRs = New MemberEnqRSUpdRQ.MemberEnqRSUpdRQ	  


            'Uncomment to get any custom parameters specified in the Pipeline config file for this request
            'sParam1 = m_oEnvrq.GetCustomParam(C_sCustomParamCSCInteropCore, "Param1Name")
            'sParam2 = m_oEnvrq.GetCustomParam(C_sCustomParamCSCInteropCore, "Param2Name")

            'This is where you manipulate your document, create a response etc.
            DoWork()

            'Example method to do XSLT
            'DoXslt()

            'Add the response document to the response envelope
            '(This is how your response is sent back)
            'm_oEnvRs.AddDocument(New InlineDocument(m_oDocRs))

            Return m_oEnvRs

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString())
            Throw

        Finally
            EndMethod()
        End Try
    End Function

    Protected Sub DoWork()
        'Service name =            m_oEnvRq.Context
        'Get path and assembly name for execution...
        'Path = 
        'C:\ESB\Dev\Source\ESB\LobSystems\Workflow\Source\ESB.Adaptors.Application.Services.Workflow\bin\ESB.Adaptors.Application.Services.Workflow.dll

        'Namespace =
        'ESB.Adaptors.Application.Services.Workflow.ProcessPurchaseOrder_v1_0_0_0 

        'ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices

        'Use this as an additional filter if possible...
        'PrimaryDocument name = m_oEnvRq.ResolveName

        'Sample Request header fragment...for:
        ' Context= WindowsWorkflow3.0.StartCase.ProcessWFTxn1.0.0.0
        ' ResolveName = WfMessage::http://www.wfmc.org/standards/docs/Wf-XML

        ' = = =
        ' <targetSystems>
        '  <targetSystem>
        '    <adminID>
        '    </adminID>
        '    <systemID>42</systemID>
        '    <url>
        '    </url>
        '    <environment>Dev</environment>
        '    <systemType>WindowsWorkflow</systemType>
        '    <systemVersion>3.0</systemVersion>
        '  </targetSystem>
        '</targetSystems>
        '<service>
        '  <name>ProcessWFTxn</name>
        '  <version>1.0.0.0</version>
        '  <context>StartCase</context>
        '  <description>Test Windows Workflow Service</description>
        '</service>

        'm_oenvrq.Context = ...
        '  systemType = WindowsWorkflow
        ' .
        '  systemVersion = 3.0
        ' .
        '  service/context = StartCase 
        ' .
        '  service/name = ProcessWFTxn
        '  service/version = 1.0.0.0


        If ShouldInvokeViaConvention() Then
            'Start path at LobSystems, as the ExpandRelativePaths will take care of the parent path value...

            'Path=LobSystems\ns\<Context>\bin  where ns=namespace/NoSystem (if no system type specified)
            'eg. "LobSystems\ns\au.com.myCompany.myServices\bin\au.com.myCompany.myServices.dll"
            '
            'or
            'Path=LobSystems\<SystemType>\<SystemVersion>\<Context>\bin\<ServiceName>.dll
            'eg. "LobSystems\Workflow\1.0.0.0\au.com.myCompany.myServices\bin\au.com.myCompany.myServices.dll"

            '      m_oenvrq.Context
            'm_oenvrq.
            'WindowsWorkflow3.0.StartCase.ProcessWFTxn1.0.0.0
            'AssemblyName=ServiceName
            'ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices

            'TransactionComponentName/ServiceName = ServiceName = m_oenvrq.ServiceName <rename to ServiceName...> &  'm_oenvrq.ServiceVersion...(replace "." with "_")
            'au.com.myCompany.myServices == ServiceName
            'ESB.Adaptors.Application.Services.Workflow <==Assembly Name
            'ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices <==FQ ClassName...
            'ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices_v1_0_0_0
            'eg. ServiceA, v1.0.0.0 ==> ServiceA_v1_0_0_0 for class name...
            'Add a RawContext property on the envelope...

            'Version not currently supported...Put into ServiceName...

            'Get the last . (period) separated entry
            'eg. Context= "ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices"
            'eg. Context= "ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices1.0.0.0"!!! Need to get Txn, Version etc. from envelope!!!
            'sServiceName = "EsbAwareSequentialWorkflowSampleWithESBServices"
            'sServiceNamespace = "ESB.Adaptors.Application.Services.Workflow"
            'sServiceNamespace = "ESB.Adaptors.Application.Services.Workflow1.0.0.0"
            Dim sServiceName As String = m_oEnvRq.Context.Split(".")(m_oEnvRq.Context.Split(".").GetLength(0) - 1)

            Dim sServiceNamespace As String = m_oEnvRq.Context.Remove(m_oEnvRq.Context.LastIndexOf("."))

            If m_oEnvRq.SystemType = "" Then
                'use the plain namespace format
                'Path=LobSystems\ns\<Context>\bin  where ns=namespace/NoSystem (if no system type specified)
                'eg. "LobSystems\ns\au.com.myCompany.myServices\bin\au.com.myCompany.myServices.dll"
                'eg. Context = "ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices"

                m_sComponentServer = Utils.ExpandRelativePath("LobSystems\ns\" & sServiceNamespace & "\bin\" & sServiceNamespace & ".dll")
                m_sTransactionComponent = sServiceNamespace & "." & sServiceName
            Else
                'use the System type format...
                'Path=LobSystems\<SystemType>\<SystemVersion>\<Context>\bin\<ServiceName>.dll
                'eg. "LobSystems\Workflow\1.0.0.0\au.com.myCompany.myServices\bin\au.com.myCompany.myServices.dll"
                'eg. Context = "WindowsWorkflow3.0.StartCase.ProcessWFTxn1.0.0.0"

                m_sComponentServer = "LobSystems\" & m_oEnvRq.SystemType & "\"
                If m_oEnvRq.SystemVersion <> "" Then
                    m_sComponentServer += m_oEnvRq.SystemVersion & "\"
                End If
                m_sComponentServer += sServiceNamespace & "\bin\" & sServiceNamespace & ".dll"
                m_sComponentServer = Utils.ExpandRelativePath(m_sComponentServer)
                m_sTransactionComponent = sServiceNamespace & "." & sServiceName

            End If

            '++ Call the actual Service...
            If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "About to create CLR based component ==>" & m_sTransactionComponent & "<== on Server==>" & m_sComponentServer & "<==" & "Resolve name sought was:" & m_oEnvRq.ResolveName & ";")
            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR sending:sXMLrq=", , m_oEnvRq.XML)


            InvokeObject(m_sTransactionComponent, m_sComponentServer, m_oEnvRq, m_oEnvRs)

            If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Successfully created CLR based component ==>" & m_sTransactionComponent & "<== on Server==>" & m_sComponentServer & "<==" & "Resolve name sought was:" & m_oEnvRq.ResolveName & ";")
            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR received:sXMLrq=", , m_oEnvRs.XML)
            '-- Call the actual Service...


            'm_oEnvRs.AddDocument(New InlineDocument("<a comment=""Convention over Configuration - Just executed:"" > <TransactionComponent>" & m_sTransactionComponent & "</TransactionComponent> <ComponentServer>" & m_sComponentServer & "</ComponentServer></a>"))

        Else
            'If we're not to do anything, return what we received so that the data is not changed at all...
            m_oEnvRs = m_oEnvRq
        End If
    End Sub

    ''' <summary>
    ''' Determine whether to actually do the convention over config processing...
    ''' </summary>
    ''' <returns>True if should do Convention over Config processing. False otherwise.</returns>
    ''' <remarks>Looks up the current context, gets the PipelineManager and subsequently the 
    ''' current PipelineConfig for this particular request.
    ''' Using this, it determines whether there are any handlers configured to run in the
    ''' 'Vertical'. If so then do nothing. Otherwise, do the convention over configuration invocation.
    ''' This allows us to configure handlers in the HorizontalPre/Post even for Convention over Config
    ''' implemented services.</remarks>
    Protected Function ShouldInvokeViaConvention() As Boolean

        Dim oServerContextImpl As ESB.Core.Services.Server.ServerContext = GetContext()

        'Different Pipeline Manager's are implemented differently cos of lck of MI support!!!
        'So, to get to PipelineManagerBase class, we expose a property on each of them, however...
        'This property is not currently available via an interface. So...
        'We know the method's there...Just get to it!!!
        'So...use dynamic features to do so...(i.e. late binding...)
        Dim oPipelineIf As Object = oServerContextImpl.PipelineManager
        Dim oPipelineBaseImpl As Pipeline.PipelineManagerBase = oPipelineIf.PipelineManagerBase



        Dim oCfg As ESB.Core.Pipeline.InteropPipelineCfg.Config

        '++The cached pipeline for this particular request
        oCfg = oPipelineBaseImpl.m_oPlgRequestPipelineCfgCLR

        Dim bProcessViaConvention As Boolean = False


        Dim oCE As InteropPipelineCfg.ContextEntry

        'See if there's anything here in the Vertical... If not, then look for a Service to invoke via the convention rules...
        'Note, there may actually be something deliberately set in the Horizontal Pre/Post config sections. We assume ther're deliberate 
        'and will still be executed by the default Pipeline Processing rules...

        'Look for something in the Vertical without an AlwaysExecute value set...
        Try
            For Each oCE In oCfg.PipelineConfig(0).Vertical(0).PipelineEntry(0).ContextEntry
                If oCE.ContextEntryType = InteropPipelineCfg.eContextEntryType.eVerticalHandler And (oCE.MultiLevelOverrides.AlwaysExecute = "0" Or oCE.MultiLevelOverrides.AlwaysExecute = "") Then
                    'This is a normal (process via convention) config entry - WE SHOULD NOT do the Convention thing then...
                    bProcessViaConvention = False

                    ''Tell the PipelineExecuter to ignore our response...
                    'oCE.MultiLevelOverrides.ResponseIsOverallPipelineResponse = "0"
                    Exit For
                Else
                    bProcessViaConvention = True
                    ''Tell the PipelineExecuter to use our response as the response for this request...
                    'oCE.MultiLevelOverrides.ResponseIsOverallPipelineResponse = "1"
                End If
            Next
            Return bProcessViaConvention

        Catch ex As Exception
            bProcessViaConvention = False
            Return bProcessViaConvention


        End Try




    End Function

    'This method shows you how to invoke an XSLT Transformation based upon config parameters
    'for a particular service configuration
    Protected Sub DoXslt()

        ' Get the custom parameters which indicate the xslt Resolvename and Context
        'These parameters are used to lookup the XSLT Pipeline Config file
        'which you need to configure to point to your XSLT file.
        Dim sXsltResolveName1 As String = m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, "XSLTResolveName1")
        Dim sXsltContext1 As String = m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, "XSLTContext1")

        ' Get the xml we will pass to xslt processing...
        'Get document from envelope by index or by type (or both)
        'sXsltInputXml = m_oEnvrq.GetDocument(GetType(<InsertDocumentTypeHere>)).GetAsString()
        'Get first document from Envelope & transform
        Dim sXsltInputXml As String = m_oEnvRq.GetDocument(0).GetAsString()

        LogMsg(LogDefs.eLogLevel.eLOG_INFO, "XSLT Input XML = " & sXsltInputXml)

        ' Output from xslt processing goes here... 

        'Get the XSLT Manager to do the transform for us to extract the address information...
        LogMsg(LogDefs.eLogLevel.eLOG_INFO, "Calling XSLT processing, passing ResolveName = " _
                                            & sXsltResolveName1 _
                                            & ", Context = " _
                                            & sXsltContext1)
        Dim sXsltOutputXml As String = ""

        GetContext.Transform(sXsltResolveName1, sXsltContext1, sXsltInputXml, sXsltOutputXml)

        LogMsg(LogDefs.eLogLevel.eLOG_INFO, "XSLT Input XML = " & sXsltInputXml & vbNewLine & " XSLT Output XML= " & sXsltOutputXml)

    End Sub

#Region "Helper Methods"
    Protected Overloads Sub InvokeObject(ByRef sTransactionComponent As String, ByRef sComponentServer As String, ByRef oEnvRq As Envelope, ByRef oEnvRs As Envelope)
        Dim sInterfaceName As String
        Dim oTimerCLR As ESB.Core.Util.Timer
        Dim sExecutionTime As String
        Dim lExecutionTime As Double

        'The Interface that takes the Keystroke Generic Envelope object as parameters.
        'This is the preferred interface for local calls as it is object based
        'and the XML Message does not need to be parsed...
        Dim oESBIf As ESB.Core.Interfaces.ProcessMsg.IProcessMsg


        oTimerCLR = New ESB.Core.Util.Timer
        oTimerCLR.StartTimer()


        'This should be a native CLR based object...
        oESBIf = CreateObjectCLR(sTransactionComponent, sComponentServer)
        If oESBIf Is Nothing Then
            'Error
            Dim sError As String
            sError = "Attempted to create object:" & sTransactionComponent & " in Assembly:" & sComponentServer & " Failed. "
            LogError(eLogLevel.eLOG_ERROR, sError)
            Throw New Exception(sError)
        Else
            'Everything OK- Object created successfully

            If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Successfully created CLR based component ==>" & sTransactionComponent & "<== on Server==>" & sComponentServer & "<==" & "Resolve name sought was:" & oEnvRq.ResolveName & ";")
            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR sending:sXMLrq=", , oEnvRq.XML)

            Dim sResolveNameAttribute As String = GetResolveNameFromHandlerAttributes(oESBIf)
            If sResolveNameAttribute <> oEnvRq.ResolveName Then
                'ResolveName Attribute on Loaded handler DOES NOT match that specified on the request.
                'Therefore, do not invoke the handler.
                'Add a response document Error/Warning, as per the core processing, indicating that there was no handler executed for the given request.
                If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Successfully created CLR based component ==>" & sTransactionComponent & "<== on Server==>" & sComponentServer & "<==" & "Resolve name sought was:" & oEnvRq.ResolveName & "; ResolveName from ServiceHandler Attributes was:" & sResolveNameAttribute & ". Handler NOT Invoked by Convention Over Configuration Handler.")
                m_oErrEntry.Description = "No handler configured for request. ResolveName:sResolveNameAttribute=" & sResolveNameAttribute & "; oEnvRq.ResolveName=" & oEnvRq.ResolveName & "; Context:m_sTransactionComponent=" & m_sTransactionComponent & ";Context=" & m_oEnvRq.Context
                m_oErrEntry.Code = "42"

                Dim mb As System.Reflection.MethodBase
                Dim Type As Type
                mb = System.Reflection.MethodBase.GetCurrentMethod
                Type = mb.DeclaringType
                m_oErrEntry.Source = Type.FullName & ":" & mb.Name & ". In Assembly:" & Type.Assembly.Location

                m_oErr.ErrorEntry.Add(m_oErrEntry)
                m_oEnvRs.AddDocument(New InlineDocument(m_oErr))
                Return
            End If

            'If all is OK till now, check to see if the Service Handler is a SequentialWorkflow class.
            'If so, invoke it via the SequentialWorkflow adaptor...
            If TypeOf oESBIf Is System.Workflow.Activities.SequentialWorkflowActivity Then
                'Invoke Component via Sequential Workflow Adaptor
                'Create the thing below, and give it the Custom params...unfortunately, this will re-create the object...
                'Because the Sequential Workflow Adaptor does not inherit from "System.Workflow.Activities.SequentialWorkflowActivity"
                'we can call ourself (this method) again (once recursion?)...

                oEnvRq.SetCustomParam(ESBConstants.C_sCustomParamESBCore, STR_WorkflowAssembly, sComponentServer)
                oEnvRq.SetCustomParam(ESBConstants.C_sCustomParamESBCore, STR_WorkflowClass, sTransactionComponent)

                If ShouldLog(LogDefs.eLogLevel.eLOG_CONVENTION_HANDLER_WORKFLOW_INVOKED) Then LogMsg(LogDefs.eLogLevel.eLOG_CONVENTION_HANDLER_WORKFLOW_INVOKED, m_sTransactionComponent & "." & m_sComponentServer)

                If DoSimulate(oEnvRq, m_oCE, oEnvRs) Then Return

                InvokeSequentialWorkflowAdaptor(oEnvRq, oEnvRs)

            Else
                'Invoke Component Directly
                If ShouldLog(LogDefs.eLogLevel.eLOG_CONVENTION_HANDLER_INVOKED) Then LogMsg(LogDefs.eLogLevel.eLOG_CONVENTION_HANDLER_INVOKED, m_sTransactionComponent & "." & m_sComponentServer)

                oEnvRs = InvokeObjectCLR(oESBIf, oEnvRq)
               
            End If

            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR returned:sXMLrs=", , oEnvRs.XML)
            oTimerCLR.StopTimer()
            sInterfaceName = "CLR"
            sExecutionTime = oTimerCLR.Duration
            lExecutionTime = oTimerCLR.ElapsedTime
        End If

        LogTiming(eLogLevel.eLOG_TIMING, "Pipeline Executer - Execution time on interface:" & sInterfaceName & "=" & sExecutionTime)


    End Sub
    Protected Overloads Sub InvokeSequentialWorkflowAdaptor(ByVal oEnvRq As Envelope, ByRef oEnvRs As Envelope)
        Dim sInterfaceName As String
        Dim oTimerCLR As ESB.Core.Util.Timer
        Dim sExecutionTime As String
        Dim lExecutionTime As Double

        'The Interface that takes the Keystroke Generic Envelope object as parameters.
        'This is the preferred interface for local calls as it is object based
        'and the XML Message does not need to be parsed...
        Dim oESBIf As ESB.Core.Interfaces.ProcessMsg.IProcessMsg

        Dim sTransactionComponent As String = "ESB.Adaptors.Application.Workflow.SequentialWorkflowAdaptor"
        Dim sComponentServer As String = Utils.ExpandRelativePath("Base\ApplicationAdaptors\ESB.Adaptors.Application.Workflow\bin\ESB.Adaptors.Application.Workflow.dll")

        oTimerCLR = New ESB.Core.Util.Timer
        oTimerCLR.StartTimer()


        'This should be a native CLR based object...
        oESBIf = CreateObjectCLR(sTransactionComponent, sComponentServer)
        If oESBIf Is Nothing Then
            'Error
            Dim sError As String
            sError = "Attempted to create object:" & sTransactionComponent & " in Assembly:" & sComponentServer & " Failed. "
            LogError(eLogLevel.eLOG_ERROR, sError)
            Throw New Exception(sError)
        Else
            'Everything OK- Object created successfully

            If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Successfully created CLR based component ==>" & sTransactionComponent & "<== on Server==>" & sComponentServer & "<==" & "Resolve name sought was:" & oEnvRq.ResolveName & ";")
            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR sending:sXMLrq=", , oEnvRq.XML)

      
            'Invoke Component Directly
            oEnvRs = InvokeObjectCLR(oESBIf, oEnvRq)
        End If

        If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR returned:sXMLrs=", , oEnvRs.XML)
        oTimerCLR.StopTimer()
        sInterfaceName = "CLR"
        sExecutionTime = oTimerCLR.Duration
        lExecutionTime = oTimerCLR.ElapsedTime

        LogTiming(eLogLevel.eLOG_TIMING, "Pipeline Executer - Execution time on interface:" & sInterfaceName & "=" & sExecutionTime)


    End Sub
    Private Function CreateObjectCLR(ByRef sTransactionComponent As String, ByRef sComponentServer As String) As ESB.Core.Interfaces.ProcessMsg.IProcessMsg
        StartMethod()
        'try & create a .NET object first...
        Dim oESBIf As ESB.Core.Interfaces.ProcessMsg.IProcessMsg
        Try
            oESBIf = ESBClassFactory.CreateObjectByStringName(sTransactionComponent, sComponentServer)
            Return oESBIf
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(eLogLevel.eLOG_ERROR, "error creating object from :" & "sTransactionComponent=" & sTransactionComponent & "sComponentServer(Assembly file path) = " & sComponentServer & ". Error=" & ex.ToString)
            Return Nothing
        Finally
            EndMethod()
        End Try
    End Function
    Private Function InvokeObjectCLR(ByRef oESBIf As ESB.Core.Interfaces.ProcessMsg.IProcessMsg, ByRef oEnvRq As Envelope) As Envelope
        'try & create a .NET object first...
        StartMethod()
        Dim oEnvRs As IEnvelope = Nothing
        Try
            oEnvRs = oESBIf.ProcessMsgSync(oEnvRq)
            Return oEnvRs
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(eLogLevel.eLOG_ERROR, ex.ToString)

            'better return something...???
            If oEnvRs Is Nothing Then
                oEnvRs = oEnvRq.CreateResponse()


                'TODO: (MINA) Add this functionality to the ErrorXML object or something...
                Dim oErrXML As New ErrorXML.ErrorXML
                Dim oErrEntry As New ErrorXML.ErrorEntry
                oErrEntry.Description = ex.ToString
                oErrEntry.Source = ex.Source
                oErrXML.ErrorEntry.Add(oErrEntry)
                oEnvRs.AddDocument(New InlineDocument(oErrXML))
            End If
            Return oEnvRs
        Finally
            EndMethod()
        End Try
    End Function


    Protected Function GetResolveNameFromHandlerAttributes(ByVal oESBIf As Object) As String
        StartMethod()
        Dim oType As Type = oESBIf.GetType()

        Dim attr As Attribute
        ' Iterate through all the attributes of the method.
        For Each attr In oType.GetCustomAttributes(GetType(Util.Attributes.DocumentsAttribute), False)
            If TypeOf attr Is Util.Attributes.DocumentsAttribute Then
                Return DirectCast(attr, Util.Attributes.DocumentsAttribute).RequestDocumentRootElementName & "::" & DirectCast(attr, Util.Attributes.DocumentsAttribute).RequestDocumentNamespace
            End If
        Next
        'No ResolveName was retrieved via Service Handler Class Attributes. Return empty...
        Return ""
        EndMethod()
    End Function

    
    Private Function DoSimulate(ByVal oEnvRq As Envelope, ByVal oCE As InteropPipelineCfg.ContextEntry, ByRef oEnvRs As Envelope) As Boolean

        If Not GetContext.ExecutionMode = eExecutionMode.eSimulate Then
            Return False
        End If

        oenvrs = oevnrq.createresponse()
        Return True

    End Function


#End Region
End Class

'Configure this class name 
'i.e. "ESB.Adaptors.Application.Service1.ServicedComponent"
'in the ESB.NET Service Pipeline if this service is to be hosted by COM+ rather than directly by the .NET Runtime
<EventTrackingEnabled(True), Transaction(TransactionOption.Supported), System.Runtime.InteropServices.ProgId("ESB.Adaptors.Application.Service1.ServicedComponent")> _
Public Class Service1ServicedComponent
    Inherits ESBServicedComponent

    Public Overrides Function ProcessMsgSync(ByVal oEnvRq As IEnvelope) As IEnvelope
        Dim o As New InvokeViaConvention
        Return o.ProcessMsgSync(oEnvRq)
    End Function
End Class