'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Explicit Off

Imports ESB.Core.Pipeline
Imports ESB.Core.XMLSchemaClasses
Imports System.Reflection



<System.Runtime.InteropServices.ComVisible(False)> Public Class InvokeViaConvention
    Inherits ServiceBase

#Region "Constants"
    Const STR_WorkflowAssembly As String = "WorkflowAssembly"
    Const STR_WorkflowClass As String = "WorkflowClass"
    Private Const STR_ESBConventionOverConfigurationHandlerAssembliesRootPath As String = "ESB.ConventionOverConfiguration.HandlerAssembliesRootPath"
#End Region

    Dim m_oDocRq As Object
    Dim m_oDocRs As Object

    Dim m_bInit As Boolean
    Dim m_sComponentServerAssemblyBase As String
    Dim m_sComponentServer As String
    Dim m_sTransactionComponent As String

    Dim m_bPipelineOnlyContainsConventionOverConfigHandler As Boolean = False


    'Service Entry Point 
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()

        Try
            MyBase.ProcessMsgSync(oEnv)
            init()
           
            DoWork()

            Return m_oEnvRs

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString())
            Throw

        Finally
            EndMethod()
        End Try
    End Function

    Protected Sub DoWork()
        ''Service name =            m_oEnvRq.Context
        ''Get path and assembly name for execution...
        ''Path = 
        ''C:\ESB\Dev\Source\ESB\LobSystems\Workflow\Source\ESB.Adaptors.Application.Services.Workflow\bin\ESB.Adaptors.Application.Services.Workflow.dll

        ''Namespace =
        ''ESB.Adaptors.Application.Services.Workflow.ProcessPurchaseOrder_v1_0_0_0 

        ''ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices

        ''Use this as an additional filter if possible...
        ''PrimaryDocument name = m_oEnvRq.ResolveName

        ''Sample Request header fragment...for:
        '' Context= WindowsWorkflow3.0.StartCase.ProcessWFTxn1.0.0.0
        '' ResolveName = WfMessage::http://www.wfmc.org/standards/docs/Wf-XML

        '' = = =
        '' <targetSystems>
        ''  <targetSystem>
        ''    <adminID>
        ''    </adminID>
        ''    <systemID>42</systemID>
        ''    <url>
        ''    </url>
        ''    <environment>Dev</environment>
        ''    <systemType>WindowsWorkflow</systemType>
        ''    <systemVersion>3.0</systemVersion>
        ''  </targetSystem>
        ''</targetSystems>
        ''<service>
        ''  <name>ProcessWFTxn</name>
        ''  <version>1.0.0.0</version>
        ''  <context>StartCase</context>
        ''  <description>Test Windows Workflow Service</description>
        ''</service>

        ''m_oenvrq.Context = ...
        ''  systemType = WindowsWorkflow
        '' .
        ''  systemVersion = 3.0
        '' .
        ''  service/context = StartCase 
        '' .
        ''  service/name = ProcessWFTxn
        ''  service/version = 1.0.0.0


        If ShouldInvokeViaConvention() Then
            ''Start path at LobSystems, as the ExpandRelativePaths will take care of the parent path value...

            ''Path=LobSystems\ns\<Context>\bin  where ns=namespace/NoSystem (if no system type specified)
            ''eg. "LobSystems\ns\au.com.myCompany.myServices\bin\au.com.myCompany.myServices.dll"
            ''
            ''or
            ''Path=LobSystems\<SystemType>\<SystemVersion>\<Context>\bin\<ServiceName>.dll
            ''eg. "LobSystems\Workflow\1.0.0.0\au.com.myCompany.myServices\bin\au.com.myCompany.myServices.dll"

            ''      m_oenvrq.Context
            ''m_oenvrq.
            ''WindowsWorkflow3.0.StartCase.ProcessWFTxn1.0.0.0
            ''AssemblyName=ServiceName
            ''ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices

            ''TransactionComponentName/ServiceName = ServiceName = m_oenvrq.ServiceName <rename to ServiceName...> &  'm_oenvrq.ServiceVersion...(replace "." with "_")
            ''au.com.myCompany.myServices == ServiceName
            ''ESB.Adaptors.Application.Services.Workflow <==Assembly Name
            ''ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices <==FQ ClassName...
            ''ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices_v1_0_0_0
            ''eg. ServiceA, v1.0.0.0 ==> ServiceA_v1_0_0_0 for class name...
            ''Add a RawContext property on the envelope...

            ''Version not currently supported...Put into ServiceName...

            ''Get the last . (period) separated entry
            ''eg. Context= "ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices"
            ''eg. Context= "ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices1.0.0.0"!!! Need to get Txn, Version etc. from envelope!!!
            ''sServiceName = "EsbAwareSequentialWorkflowSampleWithESBServices"
            ''sServiceNamespace = "ESB.Adaptors.Application.Services.Workflow"
            ''sServiceNamespace = "ESB.Adaptors.Application.Services.Workflow1.0.0.0"

            Dim sServiceName As String
            Dim sServiceNamespace As String
            If m_oEnvRq.ServiceName = "" Then
                If ShouldLog(eLogLevel.eLOG_NAVIGATION) Then LogMsg(eLogLevel.eLOG_NAVIGATION, "ConventionOverConfig Adaptor - m_oEnvRq.ServiceName="" - not executing any handlers via convention ", , m_oEnvRq.XML)

            Else
                sServiceName = m_oEnvRq.ServiceName.Split(".")(m_oEnvRq.ServiceName.Split(".").GetLength(0) - 1)
                sServiceNamespace = m_oEnvRq.ServiceName.Remove(m_oEnvRq.ServiceName.LastIndexOf("."))
            End If

            If m_oEnvRq.SystemType = "" Then
                'use the plain namespace format
                'Path=LobSystems\ns\<Context>\bin  where ns=namespace/NoSystem (if no system type specified)
                'eg. "LobSystems\ns\au.com.myCompany.myServices\bin\au.com.myCompany.myServices.dll"
                'eg. Context = "ESB.Adaptors.Application.Services.Workflow.EsbAwareSequentialWorkflowSampleWithESBServices"


                m_sComponentServer = Utils.ExpandRelativePath(m_sComponentServerAssemblyBase & "\" & sServiceNamespace & "\bin\" & sServiceNamespace & ".dll")
                m_sTransactionComponent = sServiceNamespace & "." & sServiceName
            Else
                'use the System type format...
                'Path=LobSystems\<SystemType>\<SystemVersion>\<Context>\bin\<ServiceName>.dll
                'eg. "LobSystems\Workflow\1.0.0.0\au.com.myCompany.myServices\bin\au.com.myCompany.myServices.dll"
                'eg. Context = "WindowsWorkflow3.0.StartCase.ProcessWFTxn1.0.0.0"

                'Problem: m_oEnvRq.Context Includes the SystemType and SystemVersion!!!
                'Which then gives us something like:
                '"LobSystems\Workflow\1.0.0.0\Workflow1.0.0.0.au.com.myCompany.myServices\bin\au.com.myCompany.myServices.dll"
                'Need overload on Context to NOT return the SystemType/Version...
                'Can't do it ourselves, as different Envelopes have different Contexts...


                m_sComponentServer = m_sComponentServerAssemblyBase & "\" & m_oEnvRq.SystemType & "\"
                If m_oEnvRq.SystemVersion <> "" Then
                    m_sComponentServer += m_oEnvRq.SystemVersion & "\"
                End If
                m_sComponentServer += sServiceNamespace & "\bin\" & sServiceNamespace & ".dll"
                m_sComponentServer = Utils.ExpandRelativePath(m_sComponentServer)
                m_sTransactionComponent = sServiceNamespace & "." & sServiceName

            End If

            '++ Call the actual Service...
            If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "About to create CLR based component ==>" & m_sTransactionComponent & "<== on Server==>" & m_sComponentServer & "<==" & "Resolve name sought was:" & m_oEnvRq.ResolveName & ";")
            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR sending:sXMLrq=", , m_oEnvRq.XML)


            InvokeObject(m_sTransactionComponent, m_sComponentServer, m_oEnvRq, m_oEnvRs)

            If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Successfully created CLR based component ==>" & m_sTransactionComponent & "<== on Server==>" & m_sComponentServer & "<==" & "Resolve name sought was:" & m_oEnvRq.ResolveName & ";")
            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR received:sXMLrq=", , m_oEnvRs.XML)
            '-- Call the actual Service...


            'm_oEnvRs.AddDocument(New InlineDocument("<a comment=""Convention over Configuration - Just executed:"" > <TransactionComponent>" & m_sTransactionComponent & "</TransactionComponent> <ComponentServer>" & m_sComponentServer & "</ComponentServer></a>"))

        Else
            'If we're not to do anything, return what we received so that the data is not changed at all...
            'm_oEnvRs = m_oEnvRq
        End If
    End Sub

    ''' <summary>
    ''' Determine whether to actually do the convention over config processing...
    ''' </summary>
    ''' <returns>True if should do Convention over Config processing. False otherwise.</returns>
    ''' <remarks>Looks up the current context, gets the PipelineManager and subsequently the 
    ''' current PipelineConfig for this particular request.
    ''' Using this, it determines whether there are any handlers configured to run in the
    ''' 'Vertical'. If so then do nothing. Otherwise, do the convention over configuration invocation.
    ''' This allows us to configure handlers in the HorizontalPre/Post even for Convention over Config
    ''' implemented services.</remarks>
    Protected Function ShouldInvokeViaConvention() As Boolean
        Dim bProcessViaConvention As Boolean = False
        m_bPipelineOnlyContainsConventionOverConfigHandler = False

        Dim oServerContextImpl As ESB.Core.Services.Server.ServerContext = GetContext()

        'Different Pipeline Manager's are implemented differently cos of lack of MI support!!!
        'So, to get to PipelineManagerBase class, we expose a property on each of them, however...
        'This property is not currently available via an interface. So...
        'We know the method's there...Just get to it!!!
        'So...use dynamic features to do so...(i.e. late binding...)
        Dim oPipelineIf As Object = oServerContextImpl.PipelineManager
        Dim oPipelineBaseImpl As Pipeline.PipelineManagerBase = oPipelineIf.PipelineManagerBase



        Dim oCfg As ESB.Core.Pipeline.InteropPipelineCfg.Config

        '++The cached pipeline for this particular request
        oCfg = oPipelineBaseImpl.m_oPlgRequestPipelineCfgCLR



        Dim oCE As InteropPipelineCfg.ContextEntry

        'See if there's anything here in the Vertical... If not, then look for a Service to invoke via the convention rules...
        'Generally, this is either because of a convention based request 
        ' OR
        'a mis-configured request...
        'Another approach is to load up all configured requests...(YUK) and look for a miss/match.
        'Although this may be more precise, it means we need to do a lot of parsing... at startup, and as we add
        'new services, need to refresh/invalidate this cache...

        'Note, there may actually be something deliberately set in the Horizontal Pre/Post config sections. We assume ther're deliberate 
        'and will still be executed by the default Pipeline Processing rules...


        'Also, if the service does not have a name , then it's a configured service...
        'and... if the service name does not have a "." in it (i.e. used to derive the namespace), then again it's not a convention based service

        'Look for something in the Vertical without an AlwaysExecute value set...
        Try
            For Each oCE In oCfg.PipelineConfig(0).Vertical(0).PipelineEntry(0).ResolveNameEntry(0).ContextEntry
                If (oCE.eContextEntryType = InteropPipelineCfg.ContextEntryEContextEntryType.eVerticalHandler) And _
                   ((oCE.MultiLevelOverrides.AlwaysExecute Is Nothing) _
                   Or (oCE.MultiLevelOverrides.AlwaysExecute.Value Is Nothing) _
                   Or (oCE.MultiLevelOverrides.AlwaysExecute.Value = "0") _
                   Or (oCE.MultiLevelOverrides.AlwaysExecute.Value = "")) _
                   Or m_oEnvRq.ServiceName = "" _
                   Or m_oEnvRq.ServiceName.LastIndexOf(".") = -1 Then

                    'This is a normal (process via configuration) config entry - WE SHOULD NOT do the Convention thing then...
                    bProcessViaConvention = False

                    'Return what the previous handler returned.
                    m_oEnvRs = oPipelineBaseImpl.m_oEnvRs

                    Exit For
                Else
                    If m_oEnvRq.ServiceName = "" Then
                        bProcessViaConvention = False
                        m_bPipelineOnlyContainsConventionOverConfigHandler = True

                        'Return what the previous handler returned.
                        m_oEnvRs = oPipelineBaseImpl.m_oEnvRs

                        If ShouldLog(eLogLevel.eLOG_NAVIGATION) Then LogMsg(eLogLevel.eLOG_NAVIGATION, "ConventionOverConfig Adaptor - m_oEnvRq.ServiceName="" - not executing any handlers via convention ", , m_oEnvRq.XML)
                        Exit For
                    Else
                        bProcessViaConvention = True
                        ''Tell the PipelineExecuter to use our response as the response for this request...
                        'oCE.MultiLevelOverrides.ResponseIsOverallPipelineResponse = "1"
                    End If
                End If
            Next
            Return bProcessViaConvention

        Catch ex As Exception
            bProcessViaConvention = False
            Return bProcessViaConvention


        End Try




    End Function

#Region "Helper Methods"
    Protected Overloads Sub InvokeObject(ByVal sTransactionComponent As String, ByVal sComponentServer As String, ByVal oEnvRq As Envelope, ByRef oEnvRs As Envelope)
        Dim sInterfaceName As String
        Dim oTimerCLR As ESB.Core.Util.Timer
        Dim sExecutionTime As String
        Dim lExecutionTime As Double

        'The Interface that takes the Keystroke Generic Envelope object as parameters.
        'This is the preferred interface for local calls as it is object based
        'and the XML Message does not need to be parsed...
        Dim oESBIf As ESB.Core.Interfaces.ProcessMsg.IProcessMsg


        oTimerCLR = New ESB.Core.Util.Timer
        oTimerCLR.StartTimer()


        'This should be a native CLR based object...
        oESBIf = CreateObjectCLR(sTransactionComponent, sComponentServer)
        If oESBIf Is Nothing Then
            'Error
            Dim sError As String
            sError = "Attempted to create object:" & sTransactionComponent & " in Assembly:" & sComponentServer & " Failed. "
            LogError(eLogLevel.eLOG_ERROR, sError)
            Throw New Exception(sError)
        Else
            'Everything OK- Object created successfully

            If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Successfully created CLR based component ==>" & sTransactionComponent & "<== on Server==>" & sComponentServer & "<==" & "Resolve name sought was:" & oEnvRq.ResolveName & ";")
            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR sending:sXMLrq=", , oEnvRq.XML)

            Dim sResolveNameAttribute As String = ""
            Dim sServiceVersionAttribute As String = ""
            GetResolveNameAndServiceVersionFromServiceHandlerAttributes(oESBIf, sResolveNameAttribute, sServiceVersionAttribute)
            If sResolveNameAttribute <> oEnvRq.ResolveName Or sServiceVersionAttribute <> oEnvRq.ServiceVersion Then
                'ResolveName Attribute on Loaded handler DOES NOT match that specified on the request.
                'Therefore, do not invoke the handler.
                'Add a response document Error/Warning, as per the core processing, indicating that there was no handler executed for the given request.
                Dim sErrorMsg As String = "No handler configured for request. Successfully created CLR based component but it did not match the service request parameters, so it was not invoked ==>" & _
                    sTransactionComponent & "<== on Server==>" & sComponentServer & "<==" & _
                    "Component Server = " & sComponentServer & _
                    "; Resolve name sought was:" & oEnvRq.ResolveName & "; ResolveName from ServiceHandler Attributes was:" & sResolveNameAttribute & _
                    "; Service Version sought was:" & oEnvRq.ServiceVersion & "; Service Version from ServiceHandler Attributes was:" & sServiceVersionAttribute & _
                    "; Context:m_sTransactionComponent=" & sTransactionComponent & ";Context=" & m_oEnvRq.Context & _
                    "; Handler NOT Invoked by Convention Over Configuration Handler."

                If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, sErrorMsg)
                m_oErrEntry.Description = sErrorMsg
                m_oErrEntry.Code = "42"

                Dim mb As System.Reflection.MethodBase
                Dim Type As Type
                mb = System.Reflection.MethodBase.GetCurrentMethod
                Type = mb.DeclaringType
                m_oErrEntry.Source = Type.FullName & ":" & mb.Name & ". In Assembly:" & Type.Assembly.Location

                m_oErr.ErrorEntry.Add(m_oErrEntry)
                m_oEnvRs.AddDocument(New InlineDocument(m_oErr))
                Return
            End If

            'If all is OK till now, check to see if the Service Handler is a SequentialWorkflow class.
            'If so, invoke it via the SequentialWorkflow adaptor...
            If TypeOf oESBIf Is System.Workflow.Activities.SequentialWorkflowActivity Then
                'Invoke Component via Sequential Workflow Adaptor
                'Create the thing below, and give it the Custom params...unfortunately, this will re-create the object...
                'Because the Sequential Workflow Adaptor does not inherit from "System.Workflow.Activities.SequentialWorkflowActivity"
                'we can call ourself (this method) again (once recursion?)...

                oEnvRq.SetCustomParam(ESBConstants.C_sCustomParamESBCore, STR_WorkflowAssembly, sComponentServer)
                oEnvRq.SetCustomParam(ESBConstants.C_sCustomParamESBCore, STR_WorkflowClass, sTransactionComponent)

                If ShouldLog(LogDefs.eLogLevel.eLOG_CONVENTION_HANDLER_WORKFLOW_INVOKED) Then LogMsg(LogDefs.eLogLevel.eLOG_CONVENTION_HANDLER_WORKFLOW_INVOKED, "", m_sTransactionComponent & "." & m_sComponentServer)
                If DoSimulate(oEnvRq, oEnvRs) Then Return
                InvokeSequentialWorkflowAdaptor(oEnvRq, oEnvRs)


            Else
                If ShouldLog(LogDefs.eLogLevel.eLOG_CONVENTION_HANDLER_INVOKED) Then LogMsg(LogDefs.eLogLevel.eLOG_CONVENTION_HANDLER_INVOKED, "", m_sTransactionComponent & "." & m_sComponentServer)
                If DoSimulate(oEnvRq, oEnvRs) Then Return

                'Invoke Component Directly
                oEnvRs = InvokeObjectCLR(oESBIf, oEnvRq)

            End If

            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR returned:sXMLrs=", , oEnvRs.XML)
            oTimerCLR.StopTimer()
            sInterfaceName = "CLR"
            sExecutionTime = oTimerCLR.Duration
            lExecutionTime = oTimerCLR.ElapsedTime
        End If

        LogTiming(eLogLevel.eLOG_TIMING, "Pipeline Executer - Execution time on interface:" & sInterfaceName & "=" & sExecutionTime)


    End Sub
    Protected Overloads Sub InvokeSequentialWorkflowAdaptor(ByVal oEnvRq As Envelope, ByRef oEnvRs As Envelope)
        Dim sInterfaceName As String
        Dim oTimerCLR As ESB.Core.Util.Timer
        Dim sExecutionTime As String
        Dim lExecutionTime As Double

        'The Interface that takes the Keystroke Generic Envelope object as parameters.
        'This is the preferred interface for local calls as it is object based
        'and the XML Message does not need to be parsed...
        Dim oESBIf As ESB.Core.Interfaces.ProcessMsg.IProcessMsg

        Dim sTransactionComponent As String = "ESB.Adaptors.Application.Workflow.SequentialWorkflowAdaptor"
        Dim sComponentServer As String = Utils.ExpandRelativePath("Base\ApplicationAdaptors\ESB.Adaptors.Application.Workflow\bin\ESB.Adaptors.Application.Workflow.dll")

        oTimerCLR = New ESB.Core.Util.Timer
        oTimerCLR.StartTimer()


        'This should be a native CLR based object...
        oESBIf = CreateObjectCLR(sTransactionComponent, sComponentServer)
        If oESBIf Is Nothing Then
            'Error
            Dim sError As String
            sError = "Attempted to create object:" & sTransactionComponent & " in Assembly:" & sComponentServer & " Failed. "
            LogError(eLogLevel.eLOG_ERROR, sError)
            Throw New Exception(sError)
        Else
            'Everything OK- Object created successfully

            If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Successfully created CLR based component ==>" & sTransactionComponent & "<== on Server==>" & sComponentServer & "<==" & "Resolve name sought was:" & oEnvRq.ResolveName & ";")
            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR sending:sXMLrq=", , oEnvRq.XML)

            'Invoke Component Directly
            oEnvRs = InvokeObjectCLR(oESBIf, oEnvRq)
        End If

        If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "InvokeObjectCLR returned:sXMLrs=", , oEnvRs.XML)
        oTimerCLR.StopTimer()
        sInterfaceName = "CLR"
        sExecutionTime = oTimerCLR.Duration
        lExecutionTime = oTimerCLR.ElapsedTime

        LogTiming(eLogLevel.eLOG_TIMING, "Pipeline Executer - Execution time on interface:" & sInterfaceName & "=" & sExecutionTime)


    End Sub
    Protected Overridable Function CreateObjectCLR(ByVal sTransactionComponent As String, ByVal sComponentServer As String) As ESB.Core.Interfaces.ProcessMsg.IProcessMsg
        StartMethod()
        'try & create a .NET object first...
        Dim oESBIf As ESB.Core.Interfaces.ProcessMsg.IProcessMsg
        Try
            oESBIf = ESBClassFactory.CreateObjectByStringName(sTransactionComponent, sComponentServer)
            Return oESBIf
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(eLogLevel.eLOG_ERROR, "error creating object from :" & "sTransactionComponent=" & sTransactionComponent & "sComponentServer(Assembly file path) = " & sComponentServer & ". Error=" & ex.ToString)
            Return Nothing
        Finally
            EndMethod()
        End Try
    End Function
    Protected Overridable Function InvokeObjectCLR(ByVal oESBIf As ESB.Core.Interfaces.ProcessMsg.IProcessMsg, ByVal oEnvRq As Envelope) As Envelope
        'try & create a .NET object first...
        StartMethod()
        Dim oEnvRs As IEnvelope = Nothing
        Try
            oEnvRs = oESBIf.ProcessMsgSync(oEnvRq)
            Return oEnvRs
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(eLogLevel.eLOG_ERROR, ex.ToString)

            'better return something...???
            If oEnvRs Is Nothing Then
                oEnvRs = oEnvRq.CreateResponse()

                'TODO: (MINA) Add this functionality to the ErrorXML object or something...
                Dim oErrXML As New ErrorXML.ErrorXML
                Dim oErrEntry As New ErrorXML.ErrorEntry
                oErrEntry.Description = ex.ToString
                oErrEntry.Source = ex.Source
                oErrXML.ErrorEntry.Add(oErrEntry)
                oEnvRs.AddDocument(New InlineDocument(oErrXML))
            End If
            Return oEnvRs
        Finally
            EndMethod()
        End Try
    End Function


    Protected Sub GetResolveNameAndServiceVersionFromServiceHandlerAttributes(ByVal oESBIf As Object, ByRef sResolveNameAttribute As String, ByRef sServiceVersionAttribute As String)
        StartMethod()
        Dim oType As Type = oESBIf.GetType()

        Dim attr As Attribute

        sResolveNameAttribute = ""
        'Get ResolveName through Documents Attribute
        ' Iterate through all the attributes of the method.
        For Each attr In oType.GetCustomAttributes(GetType(Util.Attributes.DocumentsAttribute), False)
            If TypeOf attr Is Util.Attributes.DocumentsAttribute Then
                sResolveNameAttribute = DirectCast(attr, Util.Attributes.DocumentsAttribute).RequestDocumentRootElementName & "::" & DirectCast(attr, Util.Attributes.DocumentsAttribute).RequestDocumentNamespace
            End If
        Next
        'No ResolveName was retrieved via Service Handler Class Attributes. Return empty...

        oType = oESBIf.GetType()
        attr = Nothing
        sServiceVersionAttribute = ""
        'Get VersionNumber through ServiceVersion Attribute
        For Each attr In oType.GetCustomAttributes(GetType(Util.Attributes.ServiceVersionAttribute), False)
            If TypeOf attr Is Util.Attributes.ServiceVersionAttribute Then
                sServiceVersionAttribute = DirectCast(attr, Util.Attributes.ServiceVersionAttribute).ServiceVersion
            End If
        Next
        'No ServiceVersion was retrieved via Service Handler Class Attributes. Return empty...

        'Cheers Minas
        EndMethod()

    End Sub

    Public Sub init()
        If Not m_bInit Then
            m_sComponentServerAssemblyBase = System.Configuration.ConfigurationManager.AppSettings(STR_ESBConventionOverConfigurationHandlerAssembliesRootPath)
            m_bInit = True
        End If
    End Sub

    Private Function DoSimulate(ByVal oEnvRq As Envelope, ByRef oEnvRs As Envelope) As Boolean

        If Not GetContext.ExecutionMode = eExecutionMode.eSimulate Then
            Return False
        End If

        oEnvRs = oEnvRq.CreateResponse()
        Return True

    End Function

#End Region
End Class
