'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
'Base class for ESB components

Imports ESB.Core.Services.Logger
Imports ESB.Core.XMLSchemaClasses.ErrorXML
Imports ESB.Core.XMLSchemaClasses.ESBEnvelope
Imports ESB.Core.Services
Imports ESB.Core.Interfaces.ServerContext
Imports Microsoft.ApplicationBlocks.ConfigurationManagement
Imports System
Imports System.ComponentModel
Imports System.Activities
Imports ESB.Core.Interfaces.Envelope
Imports ESB.Core.XMLSchemaClasses

Public Class ESBWorkflowBase
    Inherits Activity(Of IEnvelope)  'Define the activity output argument as being of type IEnvelope
    '   Inherits CodeActivity(Of IEnvelope)  'Define the activity output argument as being of type IEnvelope
    'Implements ESB.Core.Interfaces.ProcessMsg.IProcessMsg

    'Define an activity input argument of type IEnvelope
    <RequiredArgument(), Description("ESB request envelope object interface")> _
    Property EnvRq() As InOutArgument(Of IEnvelope)

    Dim m_oServerContext As ESB.Core.Interfaces.ServerContext.IServerContext

    Protected m_oCfgData As CustomConfigurationData

    Protected m_oEnvRq As IEnvelope
    Protected m_oEnvRs As IEnvelope

    Protected m_oErr As ErrorXML
    Protected m_oErrEntry As ErrorEntry
    Protected m_oWarningEntry As WarningEntry

    Private m_oContext As ServerContext

    Property WfContext As System.Activities.CodeActivityContext



    'Protected Overrides Function Execute(ByVal context As System.Activities.CodeActivityContext) As Core.Interfaces.Envelope.IEnvelope
    '    'Obtain the runtime value of the Envelope input argument
    '    WfContext = context

    '    Dim oEnv As IEnvelope
    '    oEnv = context.GetValue(Me.EnvRq)
    '    Return ProcessMsgSync(oEnv)

    'End Function


    'Look at keeping a local pointer to the thing...
    ''' <summary>
    ''' TODO: Need to change this to somehow get the context (or thread ID) from the parent - ESBEnvelope custom param maybe...???
    ''' and save it somewhere...
    ''' Then, this method needs to use that threadID to get the context...so that all Workflow threads (even the ESBWorkflow Adaptor initiating thread) use the same 
    ''' context as the original request handling code. We then get a complete request trace as required.
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overridable Function GetContext() As ESB.Core.Interfaces.ServerContext.IServerContext
        If m_oServerContext Is Nothing Then
            m_oServerContext = DirectCast(DirectCast(ESB.Core.Services.ContextManager.getContextManager(True), ESB.Core.Services.ContextManager).GetExistingContext, ESB.Core.Interfaces.ServerContext.IServerContext)
        End If
        Return m_oServerContext
    End Function

    Public Sub New()
        m_oErr = New ErrorXML
        m_oErrEntry = New ErrorEntry
        m_oWarningEntry = New WarningEntry
    End Sub

    Protected Overridable Sub GetConfigData()
        Dim m_sSourceSection As String = "ESB.Adaptors.Application.Services.Workflow"
        m_oCfgData = CType(ConfigurationManager.Read(m_sSourceSection), CustomConfigurationData)
        If m_oCfgData Is Nothing Then
            Throw New ApplicationException("no config on provider.")
        End If
    End Sub

End Class

