Option Explicit On
Imports System.Workflow.Runtime.Hosting
Imports System.Workflow.Runtime


''' 
'''  <summary>
''' 
''' </summary>
''' <remarks></remarks>
Public Class SequentialWorkflowAdaptor
    Inherits ServiceBase

#Region "ESB.NET Documents"
    Dim m_oDocRq As Object 'Todo: replace 'Object' with your schema request class eg.Dim m_oDocRq As MemberEnquiryRQ.MemberDetailsEnquiryRQ
    Dim m_oDocRs As Object 'Todo: replace 'Object' with your schema response class eg. Dim m_oDocRs As MemberEnqRSUpdRQ.MemberEnqRSUpdRQ 
#End Region
#Region "Workflow"
#Region "Constants"
    Const STR_WorkflowAssembly As String = "WorkflowAssembly"
    Const STR_WorkflowClass As String = "WorkflowClass"
#End Region
#Region "Event Handles"
    Dim m_evtWaitHandle As New AutoResetEvent(False)
#End Region
#Region "Custom Params"
    Protected m_sWorkflowAssembly As String
    Protected m_sWorkflowClass As String
#End Region
#End Region

    Shared WithEvents m_oCurrentWorkflowRuntime As WorkflowRuntime

    Shared Sub New()
        ' Create the WorkflowRuntime

        'Specify the 'WorkflowRuntime' Configuration in the web.config file that this is
        'getting hosted by...
        m_oCurrentWorkflowRuntime = New WorkflowRuntime("WorkflowRuntime")
        'Dim manualService As New System.Workflow.Runtime.Hosting.ManualWorkflowSchedulerService
        'm_oCurrentWorkflowRuntime.AddService(manualService)

        m_oCurrentWorkflowRuntime.StartRuntime()

        Trace.WriteLine("Runtime Started.")

    End Sub

    ''' <summary>
    ''' Just create a default constructor, cos class creation seems to have started failing
    ''' after adding the shared sub new method above...!!!???
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()

    End Sub
    '!!!Using Project Template that has older version of assemblies!!!
    ' Need to Fix asap & ship!!!
    'Service Entry Point 
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()

        Try

            MyBase.ProcessMsgSync(oEnv)
            '(This statement gets a document out of the request envelope. This is your service input.)
            'todo: replace this with your schema request class
            'm_oDocRq = oEnv.GetDocumentAsObject(GetType(MemberEnquiryRQ.MemberDetailsEnquiryRQ)  

            'todo: replace this with your schema response class
            'm_oDocRs = New MemberEnqRSUpdRQ.MemberEnqRSUpdRQ	  

            'Uncomment to get any custom parameters specified in the Pipeline config file for this request
            'sParam1 = m_oEnvrq.GetCustomParam(C_sCustomParamCSCInteropCore, "Param1Name")
            'sParam2 = m_oEnvrq.GetCustomParam(C_sCustomParamCSCInteropCore, "Param2Name")

            'This is where you manipulate your document, create a response etc.
            DoWork()

            'Example method to do XSLT
            'DoXslt()

            'Add the response document to the response envelope
            '(This is how your response is sent back)
            ' m_oEnvRs.AddDocument(New InlineDocument(m_oDocRs))

            Return m_oEnvRs

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString())
            Throw

        Finally
            EndMethod()
        End Try
    End Function

    Protected Sub DoWork()
        'Todo: Populate this method with your logic
        Try

            GetWorkflowCustomParams()

            
            ' Listen for the workflow events
            'Problem - now we're adding events from multiple instances of this class, onto the
            'shared m_oCurrentWorkflowRuntime...
            'We then need to at least check that the Workflow Instance ID is the one for this class...
            'and ignore the others...???
            'Nooo! This particular workflow instance will be associated with this particular instance of the 
            'SequentialWorkflowAdaptor...
            'What we must do, is to remove the Handler when we're done...
            AddHandler m_oCurrentWorkflowRuntime.WorkflowCompleted, AddressOf OnWorkflowCompleted
            AddHandler m_oCurrentWorkflowRuntime.WorkflowTerminated, AddressOf OnWorkflowTerminated

            ' Set up the parameters
            ' "amount" is an "in" parameter and specifics the order amount
            '  if the amount is < 500 the status will be "approved"; "rejected" otherwise
            Dim parameters As Dictionary(Of String, Object) = New Dictionary(Of String, Object)()
            parameters.Add("ESBRequestMessageEnvelope", m_oEnvRq)
            parameters.Add("ESBContextThread", Threading.Thread.CurrentThread.ManagedThreadId().ToString())
           
            'Load the requested assembly
            Dim oAsm As System.Reflection.Assembly = System.Reflection.Assembly.LoadFrom(m_sWorkflowAssembly)

            'Get a reference to the System.Type for the OrderWorkflows.Workflow1
            Dim oWorkflowType As System.Type = oAsm.GetType(m_sWorkflowClass)

            ' Create and start an instance of the workflow
            Dim oWorkflowInstance As WorkflowInstance = m_oCurrentWorkflowRuntime.CreateWorkflow(oWorkflowType, parameters)
            Dim guidWorkflowInstanceID As Guid = oWorkflowInstance.InstanceId

            Dim manualScheduler As ManualWorkflowSchedulerService = m_oCurrentWorkflowRuntime.GetService(GetType(ManualWorkflowSchedulerService))
            oWorkflowInstance.Start()

            'TODO - sort this branch out...
            If manualScheduler.RunWorkflow(guidWorkflowInstanceID) = True Then
                'cool
            Else
                'hmmm
            End If

            'lifetime of ESB.NET Managed Thread ID and Workflow lifetime are in sync etc.
            ' so we can share the same ESBcontext...
            'a hashtable of WorkflowID GUID to ESB.NET Core Managed ThreadID will give us
            'the required contextKey from within the Workflow...
            'Hang this Other Hashtable off the ContextManager as well...
            'so that it's easily available, and centrally managed? or maybe not?
            'Maybe have a collection of these, so we can map many other contextID's to our
            'ContextKey - eg. WCF? if required in future...
            'Maybe not - leave core alone and map it here in the WfAdaptor...
            'How do both WfAdaptor and Workflows get to this mp then?
            'umm too hard, put it in core..shared singleton etc...???
            'in ESBWorkflowServiceBase?


            '' Wait for the event to be signaled
            m_evtWaitHandle.WaitOne()

            RemoveHandler m_oCurrentWorkflowRuntime.WorkflowCompleted, AddressOf OnWorkflowCompleted
            RemoveHandler m_oCurrentWorkflowRuntime.WorkflowTerminated, AddressOf OnWorkflowTerminated

        Catch exception As Exception
            ExceptionManager.Publish(exception)
            LogError(LogDefs.eLogLevel.eLOG_ERROR, exception.ToString())
            Throw
        End Try

    End Sub

    ' This method will be called when a workflow instance is completed; since we have started only a single
    ' instance we are ignoring the event args and signaling the waitHandle so the main thread can continue
    ' and exit the program.
    Sub OnWorkflowCompleted(ByVal sender As Object, ByVal e As WorkflowCompletedEventArgs)
        Try

            'The Response Envelope is stored in the "ESBResponseMessageEnvelope" Output parameter
            Dim oResponseMessageEnvelope As IEnvelope = e.OutputParameters("ESBResponseMessageEnvelope")
            Trace.WriteLine("Response from Sequential Workflow was: " + oResponseMessageEnvelope.ToXML())
            m_oEnvRs = oResponseMessageEnvelope

        Catch ex As Exception
            Throw
        Finally
            m_evtWaitHandle.Set()
        End Try
    End Sub


    Sub OnWorkflowTerminated(ByVal sender As Object, ByVal e As WorkflowTerminatedEventArgs)

        'TODO: - Generate an error in the envelope here...
        Trace.WriteLine(e.Exception.Message)
        m_evtWaitHandle.Set()
    End Sub

    ''' <summary>
    ''' Gets the CustomParam values from the request Envelope.
    ''' These have been copied there from the Pipeline Config file Custom Params section for this service
    ''' The parameters refer to the assembly and workflow classes that will be loaded and that these operations will be
    ''' performed upon.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Sub GetWorkflowCustomParams()
        StartMethod()
        m_sWorkflowAssembly = ESB.Core.Util.Utils.ExpandRelativePath(m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, STR_WorkflowAssembly))
        m_sWorkflowClass = m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, STR_WorkflowClass)
        EndMethod()
    End Sub

    'This method shows you how to invoke an XSLT Transformation based upon config parameters
    'for a particular service configuration
    Protected Sub DoXslt()

        ' Get the custom parameters which indicate the xslt Resolvename and Context
        'These parameters are used to lookup the XSLT Pipeline Config file
        'which you need to configure to point to your XSLT file.
        Dim sXsltResolveName1 As String = m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, "XSLTResolveName1")
        Dim sXsltContext1 As String = m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, "XSLTContext1")

        ' Get the xml we will pass to xslt processing...
        'Get document from envelope by index or by type (or both)
        'sXsltInputXml = m_oEnvrq.GetDocument(GetType(<InsertDocumentTypeHere>)).GetAsString()
        'Get first document from Envelope & transform
        Dim sXsltInputXml As String = m_oEnvRq.GetDocument(0).GetAsString()

        LogMsg(LogDefs.eLogLevel.eLOG_INFO, "XSLT Input XML = " & sXsltInputXml)

        ' Output from xslt processing goes here... 

        'Get the XSLT Manager to do the transform for us to extract the address information...
        LogMsg(LogDefs.eLogLevel.eLOG_INFO, "Calling XSLT processing, passing ResolveName = " _
                                            & sXsltResolveName1 _
                                            & ", Context = " _
                                            & sXsltContext1)
        Dim sXsltOutputXml As String = ""

        GetContext.Transform(sXsltResolveName1, sXsltContext1, sXsltInputXml, sXsltOutputXml)

        LogMsg(LogDefs.eLogLevel.eLOG_INFO, "XSLT Input XML = " & sXsltInputXml & vbNewLine & " XSLT Output XML= " & sXsltOutputXml)

    End Sub
End Class

'Configure this class name 
'i.e. "ESB.Adaptors.Application.Service1.ServicedComponent"
'in the ESB.NET Service Pipeline if this service is to be hosted by COM+ rather than directly by the .NET Runtime
<EventTrackingEnabled(True), Transaction(TransactionOption.Supported), System.Runtime.InteropServices.ProgId("ESB.Adaptors.Application.Workflow.SequentialWorkflowAdaptor.ServicedComponent")> _
Public Class SequentialWorkflowAdaptorServicedComponent
    Inherits ESBServicedComponent

    Public Overrides Function ProcessMsgSync(ByVal oEnvRq As IEnvelope) As IEnvelope
        Dim o As New SequentialWorkflowAdaptor
        Return o.ProcessMsgSync(oEnvRq)
    End Function
End Class