Option Explicit On

Imports System
Imports System.Workflow.Runtime.Hosting
Imports System.Workflow.Runtime
Imports System.Collections.Generic
Imports System.Collections.ObjectModel

Imports ESB.Adaptors.Application.Workflow.Interfaces.StateBasedServices

''' 
'''  <summary>
''' 
''' </summary>
''' <remarks></remarks>
Public Class StateBasedWorkflowAdaptor
    Inherits ServiceBase

   
    'Event AssemblyResolve As ResolveEventHandler



#Region "ESB.NET Documents"
    Dim m_oDocRq As Object 'Todo: replace 'Object' with your schema request class eg.Dim m_oDocRq As MemberEnquiryRQ.MemberDetailsEnquiryRQ
    Dim m_oDocRs As Object 'Todo: replace 'Object' with your schema response class eg. Dim m_oDocRs As MemberEnqRSUpdRQ.MemberEnqRSUpdRQ 
#End Region
#Region "Workflow"
#Region "Constants"
    Const STR_WorkflowAssembly As String = "WorkflowAssembly"
    Const STR_WorkflowClass As String = "WorkflowClass"
#End Region
#Region "Event Handles"
    Dim m_evtWaitHandle As New AutoResetEvent(False)
#End Region
#Region "Custom Params"
    Protected m_sWorkflowAssembly As String
    Protected m_sWorkflowClass As String
#End Region
#End Region

    Shared WithEvents m_oCurrentWorkflowRuntime As WorkflowRuntime
    Private Shared m_oOrderService As OrderService

    '     System.AppDomain.CurrentDomain.AssemblyResolve


    Private m_sCurrentState As String
    Private m_sWorkflowStatus As String = "blah"


    ''' <summary>
    ''' Add code to load an assembly from a given location...
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="args"></param>
    ''' <returns></returns>
    ''' <remarks>gets called by the .NET Runtime when the workflow runtime fails to load an assembly...
    ''' ...Potentially...look at other uses for this event...</remarks>
    Public Function MyResolveEventHandler(ByVal sender As Object, ByVal args As ResolveEventArgs) As Reflection.Assembly
        StartMethod()
        'args.Name ==>Class Type Name
        'OK...we're sooooo lucky here, that we already know what assembly we're supposed to be loading from...
        'however...what if this workflow calls another???
        Dim oAsm As System.Reflection.Assembly = System.Reflection.Assembly.LoadFrom(m_sWorkflowAssembly)
        Return oAsm
        EndMethod()
    End Function


    Shared Sub New()
        StartMethod()
        ' Create the WorkflowRuntime, adding in the DataExchangeService and whatever...

        'Specify the 'WorkflowRuntime' Configuration in the web.config file that this is getting hosted by...
        m_oCurrentWorkflowRuntime = New WorkflowRuntime("WorkflowRuntime")


        ' Add the External Data Exchange Service
        Dim oDataExchangeService As New ExternalDataExchangeService()
        m_oCurrentWorkflowRuntime.AddService(oDataExchangeService)

        ' Add a new instance of the OrderService to the External Data Exchange Service
        m_oOrderService = New OrderService()
        oDataExchangeService.AddService(m_oOrderService)

        m_oCurrentWorkflowRuntime.StartRuntime()

        If ShouldLog(eLogLevel.eLOG_INFO) Then LogMsg(LogDefs.eLogLevel.eLOG_INFO, "ESB.Adaptors.Application.Workflow.StateBasedWorkflowAdaptor::Workflow Runtime Started.")


        EndMethod()
    End Sub

    ''' <summary>
    ''' Just create a default constructor, cos class creation seems to have started failing
    ''' after adding the shared sub new method above...!!!???
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()
        StartMethod()
        AddHandler System.AppDomain.CurrentDomain.AssemblyResolve, AddressOf MyResolveEventHandler
        EndMethod()
    End Sub
    '!!!Using Project Template that has older version of assemblies!!!
    ' Need to Fix asap & ship!!!
    'Service Entry Point 
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()

        Try

            MyBase.ProcessMsgSync(oEnv)
            '(This statement gets a document out of the request envelope. This is your service input.)
            'todo: replace this with your schema request class
            'm_oDocRq = oEnv.GetDocumentAsObject(GetType(MemberEnquiryRQ.MemberDetailsEnquiryRQ)  

            'todo: replace this with your schema response class
            'm_oDocRs = New MemberEnqRSUpdRQ.MemberEnqRSUpdRQ	  


            'Uncomment to get any custom parameters specified in the Pipeline config file for this request
            'sParam1 = m_oEnvrq.GetCustomParam(C_sCustomParamCSCInteropCore, "Param1Name")
            'sParam2 = m_oEnvrq.GetCustomParam(C_sCustomParamCSCInteropCore, "Param2Name")

            'This is where you manipulate your document, create a response etc.
            DoWork()

            'Example method to do XSLT
            'DoXslt()

            'Add the response document to the response envelope
            '(This is how your response is sent back)
            ' m_oEnvRs.AddDocument(New InlineDocument(m_oDocRs))

            Return m_oEnvRs

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString())
            Throw

        Finally
            EndMethod()
        End Try
    End Function

    Protected Sub DoWork()
        StartMethod()
        'Todo: Populate this method with your logic
        Try

            GetWorkflowCustomParams()


            ' Listen for the workflow events
            'Problem - now we're adding events from multiple instances of this class, onto the
            'shared m_oCurrentWorkflowRuntime...
            'We then need to at least check that the Workflow Instance ID is the one for this class...
            'and ignore the others...???
            'Nooo! This particular workflow instance will be associated with this particular instance of the 
            'SequentialWorkflowAdaptor...
            'What we must do, is to remove the Handler when we're done...
            AddHandler m_oCurrentWorkflowRuntime.WorkflowCompleted, AddressOf OnWorkflowCompleted
            AddHandler m_oCurrentWorkflowRuntime.WorkflowTerminated, AddressOf OnWorkflowTerminated
            AddHandler m_oCurrentWorkflowRuntime.WorkflowIdled, AddressOf OnWorkflowIdled

            ' Set up the parameters
            ' "amount" is an "in" parameter and specifics the order amount
            '  if the amount is < 500 the status will be "approved"; "rejected" otherwise
            'Dim parameters As Dictionary(Of String, Object) = New Dictionary(Of String, Object)()
            'parameters.Add("ESBRequestMessageEnvelope", m_oEnvRq)
            ' parameters.Add("ESBContextThread", Threading.Thread.CurrentThread.ManagedThreadId().ToString())

            'Load the requested assembly
            Dim oAsm As System.Reflection.Assembly = System.Reflection.Assembly.LoadFrom(m_sWorkflowAssembly)

            'Get a reference to the System.Type for the OrderWorkflows.Workflow1
            Dim oWorkflowType As System.Type = oAsm.GetType(m_sWorkflowClass)

            ' Create and start an instance of the workflow
            Dim oWorkflowInstance As WorkflowInstance = m_oCurrentWorkflowRuntime.CreateWorkflow(oWorkflowType)
            If oWorkflowInstance Is Nothing Then
                LogError(eLogLevel.eLOG_ERROR, "Could not Create Workflow Instance for:" & m_sWorkflowAssembly & ", " & m_sWorkflowClass)
                Throw New Exception("Could not Create Workflow Instance for:" & m_sWorkflowAssembly & ", " & m_sWorkflowClass)
            End If

            Dim guidWorkflowInstanceID As Guid = oWorkflowInstance.InstanceId

            Dim manualScheduler As ManualWorkflowSchedulerService = m_oCurrentWorkflowRuntime.GetService(GetType(ManualWorkflowSchedulerService))
            oWorkflowInstance.Start()

            'TODO: - See if this makes the workflow not Terminate Immadiately...
            m_oOrderService.RaiseOrderCreatedEvent("test", guidWorkflowInstanceID)


            'TODO - sort this branch out...
            If manualScheduler.RunWorkflow(guidWorkflowInstanceID) = True Then
                'cool
                If ShouldLog(eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Started New Instance of Workflow:" & m_sWorkflowAssembly & ", " & m_sWorkflowClass & ", " & guidWorkflowInstanceID.ToString)

            Else
                'hmmm
            End If

            'lifetime of ESB.NET Managed Thread ID and Workflow lifetime are in sync etc.
            ' so we can share the same ESBcontext...

            '' Wait for the event to be signaled
            If ShouldLog(eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Waiting for Workflow Signal:" & guidWorkflowInstanceID.ToString)
            m_evtWaitHandle.WaitOne()
            If ShouldLog(eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Signal Received for Workflow:" & guidWorkflowInstanceID.ToString)

            RemoveHandler m_oCurrentWorkflowRuntime.WorkflowCompleted, AddressOf OnWorkflowCompleted
            RemoveHandler m_oCurrentWorkflowRuntime.WorkflowTerminated, AddressOf OnWorkflowTerminated
            RemoveHandler m_oCurrentWorkflowRuntime.WorkflowIdled, AddressOf OnWorkflowIdled

            EndMethod()
        Catch exception As Exception
            ExceptionManager.Publish(exception)
            LogError(LogDefs.eLogLevel.eLOG_ERROR, exception.ToString())
            Throw
        End Try

    End Sub

    ' This method will be called when a workflow instance is completed; since we have started only a single
    ' instance we are ignoring the event args and signaling the waitHandle so the main thread can continue
    ' and exit the program.
    Sub OnWorkflowCompleted(ByVal sender As Object, ByVal e As WorkflowCompletedEventArgs)
        StartMethod()
        Try
            If ShouldLog(eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Workflow *Completed* for Workflow:" & e.WorkflowInstance.InstanceId.ToString & ". About to Signal...")

            m_sWorkflowStatus = "Completed"

            'The Response Envelope is stored in the "ESBResponseMessageEnvelope" Output parameter
            Dim oResponseMessageEnvelope As IEnvelope = e.OutputParameters("ESBResponseMessageEnvelope")
            Trace.WriteLine("Response from State Based Workflow was: " + oResponseMessageEnvelope.ToXML())
            m_oEnvRs = oResponseMessageEnvelope


        Catch ex As Exception
            LogError(eLogLevel.eLOG_ERROR, ex.ToString)
            ExceptionManager.Publish(ex)

        Finally
            m_evtWaitHandle.Set()
            EndMethod()
        End Try

    End Sub


    Sub OnWorkflowTerminated(ByVal sender As Object, ByVal e As WorkflowTerminatedEventArgs)
        StartMethod()
        Try
            If ShouldLog(eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Workflow *Terminated* for Workflow:" & e.WorkflowInstance.InstanceId.ToString & ". About to Signal...")
            m_sWorkflowStatus = "Terminated"
        Catch ex As Exception
            LogError(eLogLevel.eLOG_ERROR, ex.ToString)
            ExceptionManager.Publish(ex)
        Finally
            m_evtWaitHandle.Set()
            EndMethod()
        End Try
    End Sub

    Sub OnWorkflowIdled(ByVal sender As Object, ByVal e As WorkflowEventArgs)
        'Trace.WriteLine(e.Exception.Message)
        StartMethod()
        Try
            If ShouldLog(eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Workflow *Idled* for Workflow:" & e.WorkflowInstance.InstanceId.ToString & ". About to Signal...")
            If m_sWorkflowStatus.Equals("Completed") Or m_sWorkflowStatus.Equals("Terminated") Then Return

            m_sWorkflowStatus = "Running"


            ' Get the underlying WorkflowInstance

            'TODO: Falls over because it's not running the workflow from it's own directory (tries to create it again from the assembly...etc.)
            '==>1)Look at old method of loading the Workflow adaptor and Workflows, from the Transport Adaptor's directory :( Yuuuukkk...
            '===>>>2)First, however, try & locate the Workflows in the Workflow Adaptor directory...See how that goes...???
            '==>Well, that (2) didn't work...Try option (1)...
            '==>Woohoo! (1) Worked. Unfortunately, now we need to store them under the Transport Adaptor...
            '==>Also, we need to update the post build steps (or maybe the output directory) for the workflows, to copy the binaries
            '==>to the Transport Adaptor / Workflow directory...
            '==>OK, Woohoo, schmoo again... See MyResolveEventHandler... :) leave the files in their home...


            'Also - TODO - persist to Database, read in...etc...
            Dim oStateMachineInstance As New StateMachineWorkflowInstance(m_oCurrentWorkflowRuntime, e.WorkflowInstance.InstanceId)
      
            If oStateMachineInstance Is Nothing OrElse oStateMachineInstance.CurrentState Is Nothing Then Return


            ' Update the Workflow State & Status on the ListItem 
            m_sCurrentState = oStateMachineInstance.CurrentState.Name
            If ShouldLog(eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Workflow State for Workflow:" & e.WorkflowInstance.InstanceId.ToString & "is:" & m_sCurrentState)

            Dim sAllowedMessages As String
            'Get the set of allowable next messages for the current state
            Dim subActivities As ReadOnlyCollection(Of WorkflowQueueInfo) = oStateMachineInstance.WorkflowInstance.GetWorkflowQueueData()
            Dim MessagesAllowed As New Collection(Of String)()
            For Each queueInfo As WorkflowQueueInfo In subActivities

                ' Cast the Queue Name to the class Event Queue Name to get the event name string
                Dim queuename As EventQueueName = TryCast(queueInfo.QueueName, EventQueueName)

                If queuename IsNot Nothing Then
                    MessagesAllowed.Add(queuename.MethodName)
                    sAllowedMessages += queuename.MethodName
                    sAllowedMessages += ";"
                    sAllowedMessages += vbNewLine

                End If
            Next

            If ShouldLog(eLogLevel.eLOG_TRACE) Then LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Allowed Messages for Workflow:" & e.WorkflowInstance.InstanceId.ToString & "is:" & sAllowedMessages)


        Catch ex As Exception
            LogError(eLogLevel.eLOG_ERROR, ex.ToString)
            ExceptionManager.Publish(ex)
        Finally
            m_evtWaitHandle.Set()
            EndMethod()
        End Try
    End Sub

    ''' <summary>
    ''' Gets the CustomParam values from the request Envelope.
    ''' These have been copied there from the Pipeline Config file Custom Params section for this service
    ''' The parameters refer to the assembly and workflow classes that will be loaded and that these operations will be
    ''' performed upon.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Sub GetWorkflowCustomParams()
        StartMethod()
        m_sWorkflowAssembly = ESB.Core.Util.Utils.ExpandRelativePath(m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, STR_WorkflowAssembly))
        m_sWorkflowClass = m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, STR_WorkflowClass)
        EndMethod()
    End Sub

    'This method shows you how to invoke an XSLT Transformation based upon config parameters
    'for a particular service configuration
    Protected Sub DoXslt()

        ' Get the custom parameters which indicate the xslt Resolvename and Context
        'These parameters are used to lookup the XSLT Pipeline Config file
        'which you need to configure to point to your XSLT file.
        Dim sXsltResolveName1 As String = m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, "XSLTResolveName1")
        Dim sXsltContext1 As String = m_oEnvRq.GetCustomParam(ESBConstants.C_sCustomParamESBCore, "XSLTContext1")

        ' Get the xml we will pass to xslt processing...
        'Get document from envelope by index or by type (or both)
        'sXsltInputXml = m_oEnvrq.GetDocument(GetType(<InsertDocumentTypeHere>)).GetAsString()
        'Get first document from Envelope & transform
        Dim sXsltInputXml As String = m_oEnvRq.GetDocument(0).GetAsString()

        If ShouldLog(eLogLevel.eLOG_INFO) Then LogMsg(LogDefs.eLogLevel.eLOG_INFO, "XSLT Input XML = " & sXsltInputXml)

        ' Output from xslt processing goes here... 

        'Get the XSLT Manager to do the transform for us to extract the address information...
        If ShouldLog(eLogLevel.eLOG_INFO) Then LogMsg(LogDefs.eLogLevel.eLOG_INFO, "Calling XSLT processing, passing ResolveName = " _
                                            & sXsltResolveName1 _
                                            & ", Context = " _
                                            & sXsltContext1)
        Dim sXsltOutputXml As String = ""

        GetContext.Transform(sXsltResolveName1, sXsltContext1, sXsltInputXml, sXsltOutputXml)

        LogMsg(LogDefs.eLogLevel.eLOG_INFO, "XSLT Input XML = " & sXsltInputXml & vbNewLine & " XSLT Output XML= " & sXsltOutputXml)

    End Sub

   
End Class

'Configure this class name 
'i.e. "ESB.Adaptors.Application.Service1.ServicedComponent"
'in the ESB.NET Service Pipeline if this service is to be hosted by COM+ rather than directly by the .NET Runtime
<EventTrackingEnabled(True), Transaction(TransactionOption.Supported), System.Runtime.InteropServices.ProgId("ESB.Adaptors.Application.Workflow.StateBasedWorkflowAdaptor.ServicedComponent")> _
Public Class StateBasedWorkflowAdaptorComponent
    Inherits ESBServicedComponent

    Public Overrides Function ProcessMsgSync(ByVal oEnvRq As IEnvelope) As IEnvelope
        Dim o As New SequentialWorkflowAdaptor
        Return o.ProcessMsgSync(oEnvRq)
    End Function
End Class