Imports System
Imports System.ComponentModel
Imports System.Workflow.ComponentModel
Imports ESB.Core.XMLSchemaClasses

Namespace XsdValidation

    Public Class XsdValidationActivity
        Inherits EsbWorkflowActivityBase


#Region "Activity Property Exposure Registration Statements - One for each of the Workflow Activity Properties to be exposed to the Designer"
        Dim sXsdPath As String()   'need a collection of these!!!
        Dim sXmlToValidate As String
        Dim sErrors As String

        Public Shared XsdPathProperty As DependencyProperty = DependencyProperty.Register("XsdPath", GetType(System.String()), GetType(XsdValidationActivity))
        Public Shared XmlToValidateProperty As DependencyProperty = DependencyProperty.Register("XmlToValidate", GetType(System.String), GetType(XsdValidationActivity))
        Public Shared ValidationErrorsProperty As DependencyProperty = DependencyProperty.Register("ValidationErrors", GetType(System.String), GetType(XsdValidationActivity))
        Public Shared ValidationSucceededProperty As DependencyProperty = DependencyProperty.Register("ValidationSucceeded", GetType(System.Boolean), GetType(XsdValidationActivity))

#End Region
#Region "Activity Designer category Constants"
        ' Define constant values for the Property categories.  
        Private Const ESBServiceParametersCategory As String = "ESB Service in/out Parameters"
        Private Const ESBRuntimeCategory As String = "ESB Runtime"
        Private Const ESBActivityInvocationParametersCategory As String = "ESB Activity Invocation Parameters"
#End Region
#Region "Workflow Activity Properties"
        <DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
       <BrowsableAttribute(True)> _
       <DescriptionAttribute("The XsdPathProperty property is used to specify the XSD Schema to validate the XML against.")> _
       <CategoryAttribute(ESBActivityInvocationParametersCategory)> _
       Public Property XsdPath() As String()

            Get
                Return CType(MyBase.GetValue(XsdValidationActivity.XsdPathProperty), String())
            End Get
            Set(ByVal value As String())
                MyBase.SetValue(XsdValidationActivity.XsdPathProperty, value)
            End Set
        End Property

        <DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
       <BrowsableAttribute(True)> _
       <DescriptionAttribute("The XmlToValidate property is used to specify the XML to validate againse the XSD Schema.")> _
       <CategoryAttribute(ESBActivityInvocationParametersCategory)> _
        Public Property XmlToValidate() As String

            Get
                Return CType(MyBase.GetValue(XsdValidationActivity.XmlToValidateProperty), String)
            End Get
            Set(ByVal value As String)
                MyBase.SetValue(XsdValidationActivity.XmlToValidateProperty, value)
            End Set
        End Property

        <DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <BrowsableAttribute(True)> _
        <DescriptionAttribute("The ValidationErrors returns any XSD Validation errors.")> _
        <CategoryAttribute(ESBServiceParametersCategory)> _
        Public Property ValidationErrors() As String
            Get
                Return CType(MyBase.GetValue(XsdValidationActivity.ValidationErrorsProperty), String)
            End Get
            Set(ByVal value As String)
                MyBase.SetValue(XsdValidationActivity.ValidationErrorsProperty, value)
            End Set
        End Property

        <DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <BrowsableAttribute(True)> _
        <DescriptionAttribute("The ValidationSucceededProperty returns whether the XSD Validation Passed (true) or failed (false).")> _
        <CategoryAttribute(ESBServiceParametersCategory)> _
        Public Property ValidationSucceeded() As Boolean
            Get
                Return CType(MyBase.GetValue(XsdValidationActivity.ValidationSucceededProperty), Boolean)
            End Get
            Set(ByVal value As Boolean)
                MyBase.SetValue(XsdValidationActivity.ValidationSucceededProperty, value)
            End Set

        End Property

       
#End Region
#Region "Workflow Execution Method"
        Protected Overrides Function Execute(ByVal executionContext As System.Workflow.ComponentModel.ActivityExecutionContext) As System.Workflow.ComponentModel.ActivityExecutionStatus
            StartMethod()
            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil()

            ValidationSucceeded = oXmlUtil.ValidateXMLAgainstXSD(XsdPath, XmlToValidate, ValidationErrors, TriState.False)

            EndMethod()
            Return MyBase.Execute(executionContext)
        End Function
#End Region
    End Class
End Namespace
