Imports System
Imports System.ComponentModel
Imports System.Workflow.ComponentModel
Imports ESB.Core.XMLSchemaClasses

Namespace InvokeComponent

    Public Class InvokeEsbComponentActivity
        Inherits EsbWorkflowActivityBase

#Region "Activity Property Exposure Registration Statements - One for each of the Workflow Activity Properties to be exposed to the Designer"
        Public Shared ActivityClassNameProperty As DependencyProperty = DependencyProperty.Register("ActivityClassName", GetType(System.String), GetType(InvokeEsbComponentActivity))
        Public Shared ActivityAssemblyNameProperty As DependencyProperty = DependencyProperty.Register("ActivityAssemblyName", GetType(System.String), GetType(InvokeEsbComponentActivity))
        Public Shared ESBRequestMessageEnvelopeActivityProperty As DependencyProperty = DependencyProperty.Register("ESBRequestMessageEnvelopeActivity", GetType(IEnvelope), GetType(InvokeEsbComponentActivity))
        Public Shared ESBResponseMessageEnvelopeActivityProperty As DependencyProperty = DependencyProperty.Register("ESBResponseMessageEnvelopeActivity", GetType(IEnvelope), GetType(InvokeEsbComponentActivity))
        Public Shared ESBContextThreadActivityProperty As DependencyProperty = DependencyProperty.Register("ESBContextThreadActivity", GetType(System.String), GetType(InvokeEsbComponentActivity))
#End Region
#Region "Activity Designer category Constants"
        ' Define constant values for the Property categories.  
        Private Const ESBServiceParametersCategory As String = "ESB Service in/out Parameters"
        Private Const ESBRuntimeCategory As String = "ESB Runtime"
        Private Const InvokeEsbComponentActivityInvocationParametersCategory As String = "ESB Activity Invocation Parameters"
#End Region
#Region "Workflow Activity Properties"
        <DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
       <BrowsableAttribute(True)> _
       <DescriptionAttribute("The ActivityClassName property is used to specify the class to be invoked.")> _
       <CategoryAttribute(InvokeEsbComponentActivityInvocationParametersCategory)> _
       Public Property ActivityClassName() As String

            Get
                Return CType(MyBase.GetValue(InvokeEsbComponentActivity.ActivityClassNameProperty), String)
            End Get
            Set(ByVal value As String)
                MyBase.SetValue(InvokeEsbComponentActivity.ActivityClassNameProperty, value)
            End Set
        End Property

        <DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
       <BrowsableAttribute(True)> _
       <DescriptionAttribute("The ActivityAssemblyName property is used to specify the assembly the class is to be loaded from.")> _
       <CategoryAttribute(InvokeEsbComponentActivityInvocationParametersCategory)> _
        Public Property ActivityAssemblyName() As String

            Get
                Return CType(MyBase.GetValue(InvokeEsbComponentActivity.ActivityAssemblyNameProperty), String)
            End Get
            Set(ByVal value As String)
                MyBase.SetValue(InvokeEsbComponentActivity.ActivityAssemblyNameProperty, value)
            End Set
        End Property

        <DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <BrowsableAttribute(True)> _
        <DescriptionAttribute("The Request Message Envelope. Bind this to the workflow ESBRequestMessageEnvelopeActivity base class parameter.")> _
        <CategoryAttribute(ESBServiceParametersCategory)> _
        Public Property ESBRequestMessageEnvelopeActivity() As IEnvelope
            Get
                Return CType(MyBase.GetValue(InvokeEsbComponentActivity.ESBRequestMessageEnvelopeActivityProperty), IEnvelope)
            End Get
            Set(ByVal value As IEnvelope)
                MyBase.SetValue(InvokeEsbComponentActivity.ESBRequestMessageEnvelopeActivityProperty, value)
            End Set
        End Property

        <DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <BrowsableAttribute(True)> _
        <DescriptionAttribute("The Request Message Envelope.  Bind this to the workflow ESBResponseMessageEnvelopeActivity base class parameter.")> _
        <CategoryAttribute(ESBServiceParametersCategory)> _
        Public Property ESBResponseMessageEnvelopeActivity() As IEnvelope
            Get
                Return CType(MyBase.GetValue(InvokeEsbComponentActivity.ESBResponseMessageEnvelopeActivityProperty), IEnvelope)
            End Get
            Set(ByVal value As IEnvelope)
                MyBase.SetValue(InvokeEsbComponentActivity.ESBResponseMessageEnvelopeActivityProperty, value)
            End Set

        End Property

        <DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <BrowsableAttribute(True)> _
        <DescriptionAttribute("The Managed threadID that the ESB Runtime uses to match up the ESB Context for this request. Bind this property to the workflow ESBContextThread base class parameter")> _
        <CategoryAttribute(ESBRuntimeCategory)> _
        Public Property ESBContextThreadActivity() As String

            Get
                Return CType(MyBase.GetValue(InvokeEsbComponentActivity.ESBContextThreadActivityProperty), String)
            End Get
            Set(ByVal value As String)
                MyBase.SetValue(InvokeEsbComponentActivity.ESBContextThreadActivityProperty, value)
            End Set
        End Property
#End Region
#Region "Workflow Execution Method"
        Protected Overrides Function Execute(ByVal executionContext As System.Workflow.ComponentModel.ActivityExecutionContext) As System.Workflow.ComponentModel.ActivityExecutionStatus
            StartMethod()
            'InvokeObject(ActivityClassName, ESB.Core.Util.Utils.ExpandRelativePath(ActivityAssemblyName), ESBRequestMessageEnvelopeActivity, ESBResponseMessageEnvelopeActivity)
            'getcontext.Transform( 
            EndMethod()
            Return MyBase.Execute(executionContext)
        End Function
#End Region


    End Class
End Namespace
