﻿Imports System.Activities
Imports System.Net.Mail
Imports System.Collections.Specialized
Imports System.ComponentModel

'<ActivityValidator(GetType(Email.SendEmailValidator))> _
Public NotInheritable Class SendEmailCodeActivity
    Inherits CodeActivity




#Region "InArguments"
    Property iaFromAddress As InArgument(Of String)
    Property iaToAddress As InArgument(Of String)
    Property iaBody As InArgument(Of String)
    Property iaSubject As InArgument(Of String)

    <Description("Whether email body is HTML or plain text")> _
    Property iaIsHtmlBody As InArgument(Of Boolean)
    Property iaCcAddresses As InArgument(Of String)
    Property iaBccAddresses As InArgument(Of String)
    Property iaPort As InArgument(Of Integer)
    Property iaSmtpHost As InArgument(Of String)
    Property iaReplyToAddress As InArgument(Of StringCollection)
#End Region

    Public Sub New()

    End Sub

#Region "Properties"
    Private m_sFromAddress As String
    Protected Property FromAddress() As String
        Get
            Return Me.iaFromAddress.Get(CodeActivityContext)
        End Get
        Set(ByVal value As String)
            Me.iaFromAddress = value
        End Set
    End Property
    Private m_sToAddress As String
    Protected Property ToAddress() As String
        Get
            Return Me.iaToAddress.Get(CodeActivityContext)
        End Get
        Set(ByVal value As String)
            Me.iaToAddress = value
        End Set
    End Property

    Private m_sBody As String
    Protected Property Body() As String
        Get
            Return Me.iaBody.Get(CodeActivityContext)
        End Get
        Set(ByVal value As String)
            Me.iaBody = value
        End Set
    End Property
    Private m_sSubject As String
    Protected Property Subject() As String
        Get
            Return Me.iaSubject.Get(CodeActivityContext)
        End Get
        Set(ByVal value As String)
            Me.iaSubject = value
        End Set
    End Property
    Private m_bIsHtmlBody As Boolean
    Protected Property IsHtmlBody() As Boolean
        Get
            Return Me.iaIsHtmlBody.Get(CodeActivityContext)
        End Get
        Set(ByVal value As Boolean)
            Me.iaIsHtmlBody = value
        End Set
    End Property
    Private m_sCcAddresses As String
    Protected Property CcAddresses() As String
        Get
            Return Me.iaCcAddresses.Get(CodeActivityContext)
        End Get
        Set(ByVal value As String)
            Me.iaCcAddresses = value
        End Set
    End Property
    Private m_sBccAddresses As String
    Protected Property BccAddresses() As String
        Get
            Return Me.iaBccAddresses.Get(CodeActivityContext)
        End Get
        Set(ByVal value As String)
            Me.iaBccAddresses = value
        End Set
    End Property
    Private m_sPort As Integer
    Protected Property Port() As Integer
        Get
            Return Me.iaPort.Get(CodeActivityContext)
        End Get
        Set(ByVal value As Integer)
            Me.iaPort = value
        End Set
    End Property
    Private m_sSmtpHost As String
    Protected Property SmtpHost() As String
        Get
            Return Me.iaSmtpHost.Get(CodeActivityContext)
        End Get
        Set(ByVal value As String)
            Me.iaSmtpHost = value
        End Set
    End Property
    Private m_sReplyToAddress As StringCollection
    Protected Property ReplyToAddress() As StringCollection
        Get
            Return Me.iaReplyToAddress.Get(CodeActivityContext)
        End Get
        Set(ByVal value As StringCollection)
            Me.iaReplyToAddress = value
        End Set
    End Property

#End Region


    Private m_oCodeActivityContext As CodeActivityContext
    Protected Property CodeActivityContext() As CodeActivityContext
        Get
            Return m_oCodeActivityContext
        End Get
        Set(ByVal value As CodeActivityContext)
            m_oCodeActivityContext = value
        End Set
    End Property




    Sub init(ByVal context As CodeActivityContext)
        CodeActivityContext = context
    End Sub

    ' If your activity returns a value, derive from CodeActivity(Of TResult)
    ' and return the value from the Execute method.
    Protected Overrides Sub Execute(ByVal context As CodeActivityContext)
        init(context)

        Me.iaToAddress = "minas_casiou@hotmail.com"
        Me.iaFromAddress = "minas_casiou@hotmail.com"
        Me.iaSmtpHost = "192.168.1.1"
        Me.iaSubject = "Test"
        Me.iaPort = 25

        Console.WriteLine("START attempt to send email")
        Try

            SendEmailUsingSmtp(context)

        Catch ex As Exception

        End Try

        Console.WriteLine("END attempt to send email")
    End Sub
    Protected Sub SendEmailUsingSmtp(ByVal context As CodeActivityContext)
        ' Create a new SmtpClient for sending the email
        Dim client As New SmtpClient()

        ' Use the properties of the activity to construct a new MailMessage
        Dim message As New MailMessage()
        message.From = New MailAddress(Me.FromAddress)
        message.To.Add(Me.ToAddress)


        ' Assign the message values if they are valid.
        If Not String.IsNullOrEmpty(Me.CcAddresses) Then
            message.CC.Add(Me.CcAddresses)
        End If

        If Not String.IsNullOrEmpty(Me.BccAddresses) Then
            message.Bcc.Add(Me.BccAddresses)
        End If

        If Not String.IsNullOrEmpty(Me.Subject) Then
            message.Subject = Me.Subject
        End If

        If Not String.IsNullOrEmpty(Me.Body) Then
            message.Body = Me.Body
        End If

        If Not IsNothing(Me.ReplyToAddress) Then
            For Each s As String In Me.ReplyToAddress
                message.ReplyToList.Add(s)
            Next
        End If

        message.IsBodyHtml = Me.IsHtmlBody

        ' Set the SMTP host and send the mail
        client.Host = Me.SmtpHost
        client.Port = Me.Port
        client.Send(message)
    End Sub
End Class
