<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:wsdlsoap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xsd="http://www.w3.org/2001/XMLSchema"
                xmlns:a="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0" xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:exsl="http://exslt.org/common" extension-element-prefixes="exsl">
	<xsl:import href="WsdlGenerationParameters.xslt"/>
	<xsl:output method="xml" encoding="UTF-8" indent="yes"/>
	<!-- Parameters -->
	<!-- Name for the WSDL definition, which is also uses as a prefix for portType, binding, and service -->
	<xsl:param name="serviceName" select="$cfgServiceName"/>
	<xsl:param name="serviceNamespace" select="$cfgServiceNamespace"/>
	<!-- Location where the service can be found -->
	<!--<xsl:param name="location" />-->
	<xsl:param name="serviceEndpoint" select="$cfgServiceEndpoint"/>
	<xsl:param name="esbEnvelopeSchemaLocation" select="$cfgEsbEnvelopeSchemaLocation"/>
	<!-- Namespace of the schema -->
	<xsl:param name="schemaNamespace" select="/xsd:schema/@targetNamespace"/>
	<!-- Prefix for namespace of the schema -->
	<xsl:param name="schemaPrefix" select="'schema'"/>
	<!-- WSDL Namespace, by default the same as the schema namespace -->
	<xsl:param name="targetNamespace" select="$serviceNamespace"/>
	<!-- Prefix for WSDL -->
	<xsl:param name="prefix" select="'tns'"/>
	<xsl:param name="requestSuffix" select="'Request'"/>
	<xsl:param name="responseSuffix" select="'Response'"/>
	<xsl:param name="messageSuffix" select="'Message'"/>
	<xsl:param name="inputSuffix" select="'Input'"/>
	<xsl:param name="outputSuffix" select="'Output'"/>
	<xsl:param name="portTypeSuffix" select="'PortType'"/>
	<xsl:param name="bindingSuffix" select="'Binding'"/>
	<xsl:param name="serviceSuffix" select="'Service'"/>
	<xsl:param name="portSuffix" select="'Port'"/>
	<xsl:param name="soapActionPrefix" select="$targetNamespace"/>
	<xsl:template match="/">
		<xsl:call-template name="definitions"/>
	</xsl:template>
	<!-- WSDL definitions -->
	<xsl:template name="definitions">
		<wsdl:definitions xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd"
		                  xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:wsp="http://schemas.xmlsoap.org/ws/2004/09/policy"
		                  xmlns:wsap="http://schemas.xmlsoap.org/ws/2004/08/addressing/policy" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msc="http://schemas.microsoft.com/ws/2005/12/wsdl/contract"
		                  xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl" xmlns:soap12="http://schemas.xmlsoap.org/wsdl/soap12/" xmlns:wsa10="http://www.w3.org/2005/08/addressing" xmlns:wsx="http://schemas.xmlsoap.org/ws/2004/09/mex">
			<!-- Set Attribute Values from SD	-->
			<xsl:namespace name="tns" select="$serviceNamespace"/>

			<xsl:attribute name="name">
				<xsl:value-of select="$serviceName"/>
			</xsl:attribute>
			<xsl:attribute name="targetNamespace">
				<xsl:value-of select="$serviceNamespace"/>
			</xsl:attribute>

			<xsl:call-template name="types"/>
			<xsl:call-template name="message"/>
			<xsl:call-template name="portType"/>
			<xsl:call-template name="binding"/>
			<xsl:call-template name="service"/>
		</wsdl:definitions>
	</xsl:template>
	<!-- WSDL definitions -->

	<!-- WSDL types -->
	<xsl:template name="types">
		<wsdl:types>
			<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:EsbEnv="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0" elementFormDefault="qualified">
				<xsl:attribute name="targetNamespace">
					<xsl:value-of select="$serviceNamespace"/>
				</xsl:attribute>
				<xsd:import namespace="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0">
					<xsl:attribute name="schemaLocation">
						<xsl:value-of select="$esbEnvelopeSchemaLocation"/>
					</xsl:attribute>
				</xsd:import>
				<xsd:complexType name="ESBMessage">
					<xsd:sequence>
						<xsd:element name="EnvelopeXML" type="EsbEnv:ESBEnvelopeType" minOccurs="0"/>
						<xsd:element name="Attachment" type="xsd:base64Binary" minOccurs="0" maxOccurs="unbounded"/>
					</xsd:sequence>
				</xsd:complexType>
				<xsd:element name="ESBMessage" type="tns:ESBMessage" nillable="true"/>
				
				<!-- Create a Type for each Service Definition (WSDL operation) -->
				<xsl:for-each select="a:Services/a:ServiceDefinition">
					<xsd:element>
						<xsl:attribute name="name">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
						</xsl:attribute>
						<xsd:complexType>
							<xsd:sequence>
								<xsd:element ref="tns:ESBMessage"/>
							</xsd:sequence>
						</xsd:complexType>
					</xsd:element>
					<xsd:element>
						<xsl:attribute name="name">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
						</xsl:attribute>
						<xsd:complexType>
							<xsd:sequence>
								<xsd:element ref="tns:ESBMessage"/>
							</xsd:sequence>
						</xsd:complexType>
					</xsd:element>
				</xsl:for-each>

			</xsd:schema>
		</wsdl:types>
	</xsl:template>
	<!-- WSDL types -->

	<!-- WSDL message -->
	<xsl:template name="message">
	<!-- Create a message for each Service Definition (WSDL operation) -->
	<xsl:for-each select="a:Services/a:ServiceDefinition">
		<wsdl:message>
			<xsl:attribute name="name">
				<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
			</xsl:attribute>
			<wsdl:part name="parameters">
				<xsl:attribute name="element">
					<xsl:value-of select="concat('tns:', a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
				</xsl:attribute>
			</wsdl:part>
		</wsdl:message>
		<wsdl:message>
			<xsl:attribute name="name">
				<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
			</xsl:attribute>
			<wsdl:part name="parameters">
				<xsl:attribute name="element">
					<xsl:value-of select="concat('tns:', a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
				</xsl:attribute>
			</wsdl:part>
		</wsdl:message>

		</xsl:for-each>

	</xsl:template>
	<!-- WSDL message -->

	<!-- WSDL portType -->
	<xsl:template name="portType">
		<wsdl:portType>
			<xsl:attribute name="name">
				<xsl:value-of select="concat($serviceName,'Interface')"/>
			</xsl:attribute>

			<!-- Create an operation for each Service Definition (WSDL operation) -->
			<xsl:for-each select="a:Services/a:ServiceDefinition">
				<wsdl:operation>
					<xsl:attribute name="name">
						<xsl:value-of select="a:Service/a:DistinguishedServiceName/a:ServiceName"/>
					</xsl:attribute>
					<wsdl:input>
						<xsl:attribute name="name">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
						</xsl:attribute>
						<xsl:attribute name="message">
							<xsl:value-of select="concat('tns:', a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
						</xsl:attribute>
						<xsl:attribute name="wsaw:Action">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceNamespace, ':', a:Services/a:ServiceDefinition/a:Service/a:DistinguishedServiceName/a:ServiceName )"/>
						</xsl:attribute>
					</wsdl:input>
					<wsdl:output>
						<xsl:attribute name="name">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
						</xsl:attribute>
						<xsl:attribute name="message">
							<xsl:value-of select="concat('tns:', a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
						</xsl:attribute>
						<xsl:attribute name="wsaw:Action">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceNamespace, '/', a:ServiceGroup/a:ServiceDefinition/a:Service/a:DistinguishedServiceName/a:ServiceName, 'Interface', '/', a:Services/a:ServiceDefinition/a:Service/a:DistinguishedServiceName/a:ServiceName, 'Response')"/>
						</xsl:attribute>
					</wsdl:output>
				</wsdl:operation>
			</xsl:for-each>
		</wsdl:portType>
	</xsl:template>
	<!-- WSDL portType -->

	<!-- WSDL binding -->
	<xsl:template name="binding">
		<wsdl:binding>
			<xsl:attribute name="name">
				<xsl:value-of select="concat($serviceName,'Binding')"/>
			</xsl:attribute>
			<xsl:attribute name="type">
				<xsl:value-of select="concat('tns:', $serviceName,'Interface')"/>
			</xsl:attribute>
			<soap:binding transport="http://schemas.xmlsoap.org/soap/http"/>
			<!-- Create a wsdl:operation for each Service Definition (WSDL operation) -->
			<xsl:for-each select="a:Services/a:ServiceDefinition">
		
			<wsdl:operation>
				<xsl:attribute name="name">
					<xsl:value-of select="a:Service/a:DistinguishedServiceName/a:ServiceName"/>
				</xsl:attribute>
				<soap:operation style="document">
					<xsl:attribute name="soapAction">
						<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceNamespace, ':', a:Services/a:ServiceDefinition/a:Service/a:DistinguishedServiceName/a:ServiceName )"/>
					</xsl:attribute>
				</soap:operation>
				<wsdl:input>
					<xsl:attribute name="name">
						<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
					</xsl:attribute>
					<soap:body use="literal"/>
				</wsdl:input>
				<wsdl:output>
					<xsl:attribute name="name">
						<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
					</xsl:attribute>
					<soap:body use="literal"/>
				</wsdl:output>
			</wsdl:operation>
			</xsl:for-each>
		</wsdl:binding>
	</xsl:template>
	<!-- WSDL binding -->

	<!-- WSDL service -->
	<xsl:template name="service">
		<wsdl:service>
			<xsl:attribute name="name">
				<xsl:value-of select="$serviceName"/>
			</xsl:attribute>
			<wsdl:port>
				<xsl:attribute name="name">
					<xsl:value-of select="concat($serviceName, 'Interface')"/>
				</xsl:attribute>
				<xsl:attribute name="binding">
					<xsl:value-of select="concat('tns:',$serviceName, 'Binding')"/>
				</xsl:attribute>
				<soap:address>
					<xsl:attribute name="location">
						<xsl:value-of select="$serviceEndpoint"/>
					</xsl:attribute>
				</soap:address>
			</wsdl:port>
		</wsdl:service>
	</xsl:template>
	<!-- WSDL service -->
</xsl:stylesheet>