<?xml version='1.0' ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:wsdlsoap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:a="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0" xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:exsl="http://exslt.org/common" extension-element-prefixes="exsl">
	<xsl:import href="WsdlGenerationParameters.xslt"/>
	<xsl:output method="xml" encoding="UTF-8" indent="yes"/><!-- Parameters --><!-- Name for the WSDL definition, which is also uses as a prefix for portType, binding, and service -->
	<xsl:param name="serviceName" select="$cfgServiceName"/>
	<xsl:param name="serviceNamespace" select="$cfgServiceNamespace"/><!-- Location where the service can be found --><!--<xsl:param name="location" />-->
	<xsl:param name="serviceEndpoint" select="$cfgServiceEndpoint"/>
	<xsl:param name="esbEnvelopeSchemaLocation" select="$cfgEsbEnvelopeSchemaLocation"/><!-- Namespace of the schema -->
	<xsl:param name="schemaNamespace" select="/xsd:schema/@targetNamespace"/><!-- Prefix for namespace of the schema -->
	<xsl:param name="schemaPrefix" select="'schema'"/><!-- WSDL Namespace, by default the same as the schema namespace -->
	<xsl:param name="targetNamespace" select="$serviceNamespace"/><!-- Prefix for WSDL -->
	<xsl:param name="prefix" select="'tns'"/>
	<xsl:param name="requestSuffix" select="'Request'"/>
	<xsl:param name="responseSuffix" select="'Response'"/>
	<xsl:param name="messageSuffix" select="'Message'"/>
	<xsl:param name="inputSuffix" select="'Input'"/>
	<xsl:param name="outputSuffix" select="'Output'"/>
	<xsl:param name="portTypeSuffix" select="'PortType'"/>
	<xsl:param name="bindingSuffix" select="'Binding'"/>
	<xsl:param name="serviceSuffix" select="'Service'"/>
	<xsl:param name="portSuffix" select="'Port'"/>
	<xsl:param name="soapActionPrefix" select="$targetNamespace"/>
	<xsl:template match="/">
		<xsl:call-template name="definitions"/>
	</xsl:template><!-- WSDL definitions -->
	<xsl:template name="definitions">
		<wsdl:definitions xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:wsp="http://schemas.xmlsoap.org/ws/2004/09/policy" xmlns:wsap="http://schemas.xmlsoap.org/ws/2004/08/addressing/policy" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msc="http://schemas.microsoft.com/ws/2005/12/wsdl/contract" xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl" xmlns:soap12="http://schemas.xmlsoap.org/wsdl/soap12/" xmlns:wsa10="http://www.w3.org/2005/08/addressing" xmlns:wsx="http://schemas.xmlsoap.org/ws/2004/09/mex"><!-- Set Attribute Values from SD	-->
			<xsl:namespace name="tns" select="$serviceNamespace"/>
			<xsl:attribute name="name">
				<xsl:value-of select="$serviceName"/>
			</xsl:attribute>
			<xsl:attribute name="targetNamespace">
				<xsl:value-of select="$serviceNamespace"/>
			</xsl:attribute>
			<xsl:call-template name="types"/>
			<xsl:call-template name="message"/>
			<xsl:call-template name="portType"/>
			<xsl:call-template name="binding"/>
			<xsl:call-template name="service"/>
		</wsdl:definitions>
	</xsl:template><!-- WSDL definitions --><!-- WSDL types -->
	<xsl:template name="types">
		<wsdl:types>
			<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:EsbEnv="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_6_0" elementFormDefault="qualified">
				<xsl:attribute name="targetNamespace">
					<xsl:value-of select="$serviceNamespace"/>
				</xsl:attribute>
				<xsd:import namespace="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_6_0">
					<xsl:attribute name="schemaLocation">
						<xsl:value-of select="$esbEnvelopeSchemaLocation"/>
					</xsl:attribute>
				</xsd:import>
				<xsd:complexType name="ESBMessage">
					<xsd:sequence>
						<xsd:element name="EnvelopeXML" type="EsbEnv:ESBEnvelopeType" minOccurs="0"/>
						<xsd:element name="Attachment" type="xsd:base64Binary" minOccurs="0" maxOccurs="unbounded"/>
					</xsd:sequence>
				</xsd:complexType>
				<xsd:element name="ESBMessage" type="tns:ESBMessage" nillable="true"/><!-- Create a Type for each Service Definition (WSDL operation) -->
				<xsl:for-each select="a:ServiceGroup/a:ServiceDefinition">
					<xsd:element>
						<xsl:attribute name="name">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
						</xsl:attribute>
						<xsd:complexType>
							<xsd:sequence>
								<xsd:element ref="tns:ESBMessage"/>
							</xsd:sequence>
						</xsd:complexType>
					</xsd:element>
					<xsd:element>
						<xsl:attribute name="name">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
						</xsl:attribute>
						<xsd:complexType>
							<xsd:sequence>
								<xsd:element ref="tns:ESBMessage"/>
							</xsd:sequence>
						</xsd:complexType>
					</xsd:element>
				</xsl:for-each>
			</xsd:schema>
		</wsdl:types>
	</xsl:template><!-- WSDL types --><!-- WSDL message -->
	<xsl:template name="message"><!-- Create a message for each Service Definition (WSDL operation) -->
		<xsl:for-each select="a:ServiceGroup/a:ServiceDefinition">
			<wsdl:message>
				<xsl:attribute name="name">
					<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
				</xsl:attribute>
				<wsdl:part name="parameters">
					<xsl:attribute name="element">
						<xsl:value-of select="concat('tns:', a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
					</xsl:attribute>
				</wsdl:part>
			</wsdl:message>
			<wsdl:message>
				<xsl:attribute name="name">
					<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
				</xsl:attribute>
				<wsdl:part name="parameters">
					<xsl:attribute name="element">
						<xsl:value-of select="concat('tns:', a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
					</xsl:attribute>
				</wsdl:part>
			</wsdl:message>
		</xsl:for-each>
	</xsl:template><!-- WSDL message --><!-- WSDL portType -->
	<xsl:template name="portType">
		<wsdl:portType>
			<xsl:attribute name="name">
				<xsl:value-of select="concat($serviceName,'Interface')"/>
			</xsl:attribute><!-- Create an operation for each Service Definition (WSDL operation) -->
			<xsl:for-each select="a:ServiceGroup/a:ServiceDefinition">
				<wsdl:operation>
					<xsl:attribute name="name">
						<xsl:value-of select="a:Service/a:DistinguishedServiceName/a:ServiceName"/>
					</xsl:attribute>
					<wsdl:input>
						<xsl:attribute name="name">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
						</xsl:attribute>
						<xsl:attribute name="message">
							<xsl:value-of select="concat('tns:', a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
						</xsl:attribute>
						<xsl:attribute name="wsaw:Action">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceNamespace,                ':',                 a:ServiceGroup/a:ServiceDefinition/a:Service/a:DistinguishedServiceName/a:ServiceName )"/>
						</xsl:attribute>
					</wsdl:input>
					<wsdl:output>
						<xsl:attribute name="name">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
						</xsl:attribute>
						<xsl:attribute name="message">
							<xsl:value-of select="concat('tns:', a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
						</xsl:attribute>
						<xsl:attribute name="wsaw:Action">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceNamespace,                '/',                 a:ServiceGroup/a:ServiceDefinition/a:Service/a:DistinguishedServiceName/a:ServiceName,                'Interface',                '/',                a:ServiceGroup/a:ServiceDefinition/a:Service/a:DistinguishedServiceName/a:ServiceName,                'Response')"/>
						</xsl:attribute>
					</wsdl:output>
				</wsdl:operation>
			</xsl:for-each>
		</wsdl:portType>
	</xsl:template><!-- WSDL portType --><!-- WSDL binding -->
	<xsl:template name="binding">
		<wsdl:binding>
			<xsl:attribute name="name">
				<xsl:value-of select="concat($serviceName,'Binding')"/>
			</xsl:attribute>
			<xsl:attribute name="type">
				<xsl:value-of select="concat('tns:', $serviceName,'Interface')"/>
			</xsl:attribute>
			<soap:binding transport="http://schemas.xmlsoap.org/soap/http"/><!-- Create a wsdl:operation for each Service Definition (WSDL operation) -->
			<xsl:for-each select="a:ServiceGroup/a:ServiceDefinition">
				<wsdl:operation>
					<xsl:attribute name="name">
						<xsl:value-of select="a:Service/a:DistinguishedServiceName/a:ServiceName"/>
					</xsl:attribute>
					<soap:operation style="document">
						<xsl:attribute name="soapAction">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceNamespace,                ':',                 a:ServiceGroup/a:ServiceDefinition/a:Service/a:DistinguishedServiceName/a:ServiceName )"/>
						</xsl:attribute>
					</soap:operation>
					<wsdl:input>
						<xsl:attribute name="name">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
						</xsl:attribute>
						<soap:body use="literal"/>
					</wsdl:input>
					<wsdl:output>
						<xsl:attribute name="name">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
						</xsl:attribute>
						<soap:body use="literal"/>
					</wsdl:output>
				</wsdl:operation>
			</xsl:for-each>
		</wsdl:binding>
	</xsl:template><!-- WSDL binding --><!-- WSDL service -->
	<xsl:template name="service">
		<wsdl:service>
			<xsl:attribute name="name">
				<xsl:value-of select="$serviceName"/>
			</xsl:attribute>
			<wsdl:port>
				<xsl:attribute name="name">
					<xsl:value-of select="concat($serviceName, 'Interface')"/>
				</xsl:attribute>
				<xsl:attribute name="binding">
					<xsl:value-of select="concat('tns:',$serviceName, 'Binding')"/>
				</xsl:attribute>
				<soap:address>
					<xsl:attribute name="location">
						<xsl:value-of select="$serviceEndpoint"/>
					</xsl:attribute>
				</soap:address>
			</wsdl:port>
		</wsdl:service>
	</xsl:template><!-- WSDL service -->
</xsl:stylesheet><!-- Stylus Studio meta-information - (c) 2004-2006. Progress Software Corporation. All rights reserved.
<metaInformation>
<scenarios ><scenario default="no" name="ServiceDefinitionToWsdl" userelativepaths="yes" externalpreview="no" url="Input\ServiceDefinition.createClassificationCodeOltp.version_1_0_0_0.xml" htmlbaseurl="" outputurl="Output\WsdlOutputFromServiceDefinition.wsdl" processortype="saxon8" useresolver="yes" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="yes" validator="internal" customvalidator="" ><parameterValue name="location" value="'http://mrp6wtb2.police.nsw.gov.au/classification/classificationCodesServiceOltp.svc'"/><parameterValue name="name" value="'classificationService'"/><advancedProp name="sInitialMode" value=""/><advancedProp name="bXsltOneIsOkay" value="true"/><advancedProp name="bSchemaAware" value="true"/><advancedProp name="bXml11" value="false"/><advancedProp name="iValidation" value="0"/><advancedProp name="bExtensions" value="true"/><advancedProp name="iWhitespace" value="0"/><advancedProp name="sInitialTemplate" value=""/><advancedProp name="bTinyTree" value="true"/><advancedProp name="bWarnings" value="true"/><advancedProp name="bUseDTD" value="false"/><validatorSchema value="Output\xsd\wsdl.xsd"/></scenario><scenario default="yes" name="MergedServiceDefinitionsToWsdlScenario" userelativepaths="yes" externalpreview="no" url="..\Input\ServiceDefinitions\Classification\ServiceDefinition.createClassificationCodeOltp.version_1_0_0_0.xml" htmlbaseurl="" outputurl="Output\WsdlOutputFromServiceDefinition_Merged.wsdl" processortype="saxon8" useresolver="yes" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="yes" validator="internal" customvalidator="" ><advancedProp name="sInitialMode" value=""/><advancedProp name="bXsltOneIsOkay" value="true"/><advancedProp name="bSchemaAware" value="true"/><advancedProp name="bXml11" value="false"/><advancedProp name="iValidation" value="0"/><advancedProp name="bExtensions" value="true"/><advancedProp name="iWhitespace" value="0"/><advancedProp name="sInitialTemplate" value=""/><advancedProp name="bTinyTree" value="true"/><advancedProp name="bWarnings" value="true"/><advancedProp name="bUseDTD" value="false"/><validatorSchema value="..\Output\Xsd\wsdl.xsd"/></scenario></scenarios><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="..\Output\Xsd\wsdl.xsd" destSchemaRoot="definitions" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no" ><SourceSchema srcSchemaPath="..\Input\Xsd\ServiceDefinition.xsd" srcSchemaRoot="Services" AssociatedInstance="" loaderFunction="document" loaderFunctionUsesURI="no"/></MapperInfo><MapperBlockPosition><template match="/"><block path="xsl:call&#x2D;template" x="356" y="0"/></template><template name="definitions"><block path="wsdl:definitions/xsl:attribute/xsl:value&#x2D;of" x="384" y="104"/><block path="wsdl:definitions/xsl:attribute[1]/xsl:value&#x2D;of" x="430" y="288"/><block path="wsdl:definitions/xsl:call&#x2D;template" x="390" y="18"/><block path="wsdl:definitions/xsl:call&#x2D;template[1]" x="430" y="18"/><block path="wsdl:definitions/xsl:call&#x2D;template[2]" x="350" y="18"/><block path="wsdl:definitions/xsl:call&#x2D;template[3]" x="310" y="18"/><block path="wsdl:definitions/xsl:call&#x2D;template[4]" x="270" y="18"/></template><template name="service"><block path="wsdl:service/xsl:attribute/xsl:value&#x2D;of" x="384" y="51"/><block path="wsdl:service/wsdl:port/xsl:attribute/xsl:value&#x2D;of" x="344" y="51"/><block path="wsdl:service/wsdl:port/xsl:attribute[1]/xsl:value&#x2D;of" x="424" y="51"/><block path="wsdl:service/wsdl:port/wsdlsoap:address/xsl:attribute/xsl:value&#x2D;of" x="304" y="51"/></template><template name="bindingOperation"><block path="wsdl:operation/xsl:attribute/xsl:value&#x2D;of" x="384" y="51"/><block path="wsdl:operation/wsdlsoap:operation/xsl:attribute/xsl:value&#x2D;of" x="304" y="51"/><block path="wsdl:operation/xsl:for&#x2D;each" x="424" y="51"/><block path="wsdl:operation/xsl:for&#x2D;each/wsdl:input/xsl:attribute/xsl:value&#x2D;of" x="264" y="51"/><block path="wsdl:operation/xsl:for&#x2D;each[1]" x="344" y="51"/><block path="wsdl:operation/xsl:for&#x2D;each[1]/wsdl:output/xsl:attribute/xsl:value&#x2D;of" x="224" y="51"/></template><template name="portTypeOperation"><block path="wsdl:operation/xsl:attribute/xsl:value&#x2D;of" x="384" y="51"/><block path="wsdl:operation/xsl:for&#x2D;each" x="424" y="51"/><block path="wsdl:operation/xsl:for&#x2D;each/wsdl:input/xsl:attribute/xsl:value&#x2D;of" x="264" y="51"/><block path="wsdl:operation/xsl:for&#x2D;each/wsdl:input/xsl:attribute[1]/xsl:value&#x2D;of" x="304" y="51"/><block path="wsdl:operation/xsl:for&#x2D;each[1]" x="344" y="51"/><block path="wsdl:operation/xsl:for&#x2D;each[1]/wsdl:output/xsl:attribute/xsl:value&#x2D;of" x="184" y="51"/><block path="wsdl:operation/xsl:for&#x2D;each[1]/wsdl:output/xsl:attribute[1]/xsl:value&#x2D;of" x="224" y="51"/></template><template name="types"><block path="wsdl:types/xsd:schema/xsl:attribute/xsl:value&#x2D;of" x="390" y="80"/><block path="wsdl:types/xsd:schema/xsd:import/xsl:attribute/xsl:value&#x2D;of" x="430" y="80"/><block path="wsdl:types/xsd:schema/xsl:for&#x2D;each" x="356" y="253"/><block path="wsdl:types/xsd:schema/xsl:for&#x2D;each/xsd:element/xsl:attribute/xsl:value&#x2D;of" x="396" y="253"/><block path="wsdl:types/xsd:schema/xsl:for&#x2D;each/xsd:element[1]/xsl:attribute/xsl:value&#x2D;of" x="316" y="253"/></template><template name="ImportServiceDefinitions"></template><template name="Blah"></template><template name="message"><block path="xsl:for&#x2D;each" x="356" y="126"/><block path="xsl:for&#x2D;each/wsdl:message/xsl:attribute/xsl:value&#x2D;of" x="396" y="144"/><block path="xsl:for&#x2D;each/wsdl:message/wsdl:part/xsl:attribute/xsl:value&#x2D;of" x="356" y="198"/><block path="xsl:for&#x2D;each/wsdl:message[1]/xsl:attribute/xsl:value&#x2D;of" x="316" y="142"/><block path="xsl:for&#x2D;each/wsdl:message[1]/wsdl:part/xsl:attribute/xsl:value&#x2D;of" x="276" y="142"/></template><template name="binding"><block path="wsdl:binding/xsl:attribute[1]/xsl:value&#x2D;of" x="390" y="0"/><block path="wsdl:binding/wsdl:operation/soap:operation/xsl:attribute/xsl:value&#x2D;of" x="390" y="0"/><block path="wsdl:binding/wsdl:operation/wsdl:input/xsl:attribute/xsl:value&#x2D;of" x="390" y="0"/><block path="wsdl:binding/wsdl:operation/wsdl:output/xsl:attribute/xsl:value&#x2D;of" x="390" y="0"/></template></MapperBlockPosition><TemplateContext><template name="definitions" mode="" srcContextPath="/ServiceGroup" srcContextFile="file:///d:/Source/Services/TechnologyServices/Utilities/Xslt/ServiceDefinitionToWsdl/Input/xsd/ServiceDefinition.xsd" targetContextPath="" targetContextFile=""/></TemplateContext><MapperFilter side="source"></MapperFilter></MapperMetaTag>
</metaInformation>
-->