<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:wsdlsoap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xsd="http://www.w3.org/2001/XMLSchema"
                xmlns:a="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0" xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:soap12="http://schemas.xmlsoap.org/wsdl/soap12/"
                xmlns:exsl="http://exslt.org/common" extension-element-prefixes="exsl" xmlns:err="urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0">
	<xsl:import href="WsdlGenerationParameters.xslt"/>
	<xsl:output method="xml" encoding="UTF-8" indent="yes"/>
	<!-- Parameters -->
	<!-- Name for the WSDL definition, which is also uses as a prefix for portType, binding, and service -->
	<xsl:param name="serviceName" select="$cfgServiceName"/>
	<xsl:param name="serviceNamespace" select="$cfgServiceNamespace"/>
	<!-- Location where the service can be found -->
	<!--<xsl:param name="location" />-->
	<xsl:param name="serviceEndpoint" select="$cfgServiceEndpoint"/>
	<xsl:param name="esbErrorDocSchemaLocation" select="$cfgEsbErrorDocSchemaLocation"/>
	<xsl:param name="esbSchemaLobSystemsLocationRoot" select="$cfgEsbSchemaLobSystemsLocationRoot"/>
	<xsl:param name="esbInstanceLocationRoot" select="$cfgEsbInstanceLocationRoot"/>




	<!-- Namespace of the schema -->
	<xsl:param name="schemaNamespace" select="/xsd:schema/@targetNamespace"/>
	<!-- Prefix for namespace of the schema -->
	<xsl:param name="schemaPrefix" select="'schema'"/>
	<!-- WSDL Namespace, by default the same as the schema namespace -->
	<xsl:param name="targetNamespace" select="$serviceNamespace"/>
	<!-- Prefix for WSDL -->
	<xsl:param name="prefix" select="'tns'"/>
	<xsl:param name="requestSuffix" select="'Request'"/>
	<xsl:param name="responseSuffix" select="'Response'"/>
	<xsl:param name="messageSuffix" select="'Message'"/>
	<xsl:param name="inputSuffix" select="'Input'"/>
	<xsl:param name="outputSuffix" select="'Output'"/>
	<xsl:param name="portTypeSuffix" select="'PortType'"/>
	<xsl:param name="bindingSuffix" select="'Binding'"/>
	<xsl:param name="serviceSuffix" select="'Service'"/>
	<xsl:param name="portSuffix" select="'Port'"/>
	<xsl:param name="soapActionPrefix" select="$targetNamespace"/>



	<xsl:template match="/">
		<xsl:call-template name="definitions"/>
	</xsl:template>
	<!-- WSDL definitions -->
	<xsl:template name="definitions">
		<wsdl:definitions xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd"
		                  xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:wsp="http://schemas.xmlsoap.org/ws/2004/09/policy"
		                  xmlns:wsap="http://schemas.xmlsoap.org/ws/2004/08/addressing/policy" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msc="http://schemas.microsoft.com/ws/2005/12/wsdl/contract"
		                  xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl" xmlns:soap12="http://schemas.xmlsoap.org/wsdl/soap12/" xmlns:wsa10="http://www.w3.org/2005/08/addressing" xmlns:wsx="http://schemas.xmlsoap.org/ws/2004/09/mex">
			<!-- Set Attribute Values from SD	-->
			<xsl:namespace name="tns" select="$serviceNamespace"/>

			<!-- Add namespace prefixes for request and response documents -->
			<xsl:for-each select="a:Services/a:ServiceDefinition">
				<xsl:namespace name="rqdoc1" select="a:Service/a:Request/a:Document/a:Schema/a:Namespace"/>
				<xsl:namespace name="rsdoc1" select="a:Service/a:Response/a:Document/a:Schema/a:Namespace"/>
			</xsl:for-each>

			<xsl:attribute name="name">
				<xsl:value-of select="$serviceName"/>
			</xsl:attribute>
			<xsl:attribute name="targetNamespace">
				<xsl:value-of select="$serviceNamespace"/>
			</xsl:attribute>

			<xsl:call-template name="types"/>
			<xsl:call-template name="message"/>
			<xsl:call-template name="portType"/>
			<xsl:call-template name="binding"/>
			<xsl:call-template name="service"/>
		</wsdl:definitions>
	</xsl:template>
	<!-- WSDL definitions -->

	<!-- WSDL types -->
	<xsl:template name="types">
		<wsdl:types>
			<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
				<xsl:attribute name="targetNamespace">
					<xsl:value-of select="$serviceNamespace"/>
				</xsl:attribute>

				<xsd:import>
					<xsl:attribute name="namespace">
							<xsl:value-of select="'urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0'"/>
						</xsl:attribute>
						<xsl:attribute name="schemaLocation">
							<xsl:value-of select="$esbErrorDocSchemaLocation"/>
						</xsl:attribute>
				</xsd:import>
				<xsl:for-each select="a:Services/a:ServiceDefinition">
					<xsd:import>
						<xsl:attribute name="namespace">
							<xsl:value-of select="a:Service/a:Request/a:Document/a:Schema/a:Namespace"/>
						</xsl:attribute>
						<xsl:attribute name="schemaLocation">
							<xsl:value-of select="concat($esbInstanceLocationRoot,a:Service/a:Request/a:Document/a:Schema/a:Url)"/>
						</xsl:attribute>
					</xsd:import>

					<xsd:import>
						<xsl:attribute name="namespace">
							<xsl:value-of select="a:Service/a:Response/a:Document/a:Schema/a:Namespace"/>
						</xsl:attribute>
						<xsl:attribute name="schemaLocation">
							<xsl:value-of select="concat($esbInstanceLocationRoot,a:Service/a:Response/a:Document/a:Schema/a:Url)"/>
						</xsl:attribute>
					</xsd:import>
				</xsl:for-each>

				<!--<xsd:complexType name="ESBMessage">
					<xsd:sequence>
						<xsd:element name="EnvelopeXML" type="EsbEnv:ESBEnvelopeType" minOccurs="0"/>
						<xsd:element name="Attachment" type="xsd:base64Binary" minOccurs="0" maxOccurs="unbounded"/>
					</xsd:sequence>
				</xsd:complexType>
				<xsd:element name="ESBMessage" type="tns:ESBMessage" nillable="true"/>-->

				<!-- Create a Type for each Service Definition (WSDL operation) -->
				<xsl:for-each select="a:Services/a:ServiceDefinition">
					<xsd:element>
						<xsl:attribute name="name">
							<xsl:value-of select="a:Service/a:DistinguishedServiceName/a:ServiceName"/>
						</xsl:attribute>
						<xsd:complexType>
							<xsd:sequence>
								<xsd:element>
									<xsl:attribute name="ref">
										<xsl:value-of select="concat('rqdoc1', ':', a:Service/a:Request/a:Document/a:Schema/a:Name)"/>
									</xsl:attribute>
								</xsd:element>
							</xsd:sequence>
						</xsd:complexType>
					</xsd:element>
					<xsd:element>
						<xsl:attribute name="name">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
						</xsl:attribute>
						<xsd:complexType>
							<xsd:sequence>
								<xsd:element>
									<!--<xsl:attribute name="minOccurs">
										<xsl:value-of select="'0'"/>
									</xsl:attribute>-->
									<xsl:attribute name="ref">
										<xsl:value-of select="concat('rsdoc1', ':', a:Service/a:Response/a:Document/a:Schema/a:Name)"/>
									</xsl:attribute>
								</xsd:element>
								<!--<xsd:element>
									<xsl:attribute name="minOccurs">
										<xsl:value-of select="'0'"/>
									</xsl:attribute>
									<xsl:attribute name="maxOccurs">
										<xsl:value-of select="'unbounded'"/>
									</xsl:attribute>
									<xsl:attribute name="ref">
										<xsl:value-of select="'err:ErrorXML'"/>
									</xsl:attribute>
								</xsd:element>-->
							</xsd:sequence>
						</xsd:complexType>
					</xsd:element>
				</xsl:for-each>
			</xsd:schema>
		</wsdl:types>
	</xsl:template>
	<!-- WSDL types -->

	<!-- WSDL message -->
	<xsl:template name="message">
		<!-- Create a message for each Service Definition (WSDL operation) -->
		<xsl:for-each select="a:Services/a:ServiceDefinition">
			<wsdl:message>
				<xsl:attribute name="name">
					<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'SoapIn')"/>
				</xsl:attribute>
				<wsdl:part name="parameters">
					<xsl:attribute name="element">
						<xsl:value-of select="concat('tns:',a:Service/a:DistinguishedServiceName/a:ServiceName)"/>
					</xsl:attribute>
				</wsdl:part>
			</wsdl:message>
			<wsdl:message>
				<xsl:attribute name="name">
					<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'SoapOut')"/>
				</xsl:attribute>
				<wsdl:part name="parameters">
					<xsl:attribute name="element">
						<xsl:value-of select="concat('tns:',a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
					</xsl:attribute>
				</wsdl:part>
			</wsdl:message>
		</xsl:for-each>
	</xsl:template>
	<!-- WSDL message -->

	<!-- WSDL portType -->
	<xsl:template name="portType">
		<wsdl:portType>
			<xsl:attribute name="name">
				<xsl:value-of select="concat($serviceName,'Soap12Port')"/>
			</xsl:attribute>

			<!-- Create an operation for each Service Definition (WSDL operation) -->
			<xsl:for-each select="a:Services/a:ServiceDefinition">
				<wsdl:operation>
					<xsl:attribute name="name">
						<xsl:value-of select="a:Service/a:DistinguishedServiceName/a:ServiceName"/>
					</xsl:attribute>
					<wsdl:input>

						<xsl:attribute name="message">
							<xsl:value-of select="concat('tns:', a:Service/a:DistinguishedServiceName/a:ServiceName,'SoapIn')"/>
						</xsl:attribute>
					</wsdl:input>
					<wsdl:output>

						<xsl:attribute name="message">
							<xsl:value-of select="concat('tns:', a:Service/a:DistinguishedServiceName/a:ServiceName,'SoapOut')"/>
						</xsl:attribute>
					</wsdl:output>
				</wsdl:operation>
			</xsl:for-each>
		</wsdl:portType>
	</xsl:template>
	<!-- WSDL portType -->

	<!-- WSDL binding -->
	<xsl:template name="binding">
		<wsdl:binding>
			<xsl:attribute name="name">
				<xsl:value-of select="concat($serviceName,'Soap12Binding')"/>
			</xsl:attribute>
			<xsl:attribute name="type">
				<xsl:value-of select="concat('tns:', $serviceName,'Soap12Port')"/>
			</xsl:attribute>
			<soap12:binding transport="http://schemas.xmlsoap.org/soap/http"/>
			<!-- Create a wsdl:operation for each Service Definition (WSDL operation) -->
			<xsl:for-each select="a:Services/a:ServiceDefinition">

				<wsdl:operation>
					<xsl:attribute name="name">
						<xsl:value-of select="a:Service/a:DistinguishedServiceName/a:ServiceName"/>
					</xsl:attribute>
					<soap12:operation style="document">
						<xsl:attribute name="soapAction">
							<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceNamespace, '.', a:Service/a:DistinguishedServiceName/a:ServiceName )"/>
						</xsl:attribute>
					</soap12:operation>
					<wsdl:input>
						<!--<xsl:attribute name="name">
						<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Request')"/>
					</xsl:attribute>-->
						<soap12:body use="literal"/>
					</wsdl:input>
					<wsdl:output>
						<!--<xsl:attribute name="name">
						<xsl:value-of select="concat(a:Service/a:DistinguishedServiceName/a:ServiceName,'Response')"/>
					</xsl:attribute>-->
						<soap12:body use="literal"/>
					</wsdl:output>
				</wsdl:operation>
			</xsl:for-each>
		</wsdl:binding>
	</xsl:template>
	<!-- WSDL binding -->

	<!-- WSDL service -->
	<xsl:template name="service">
		<wsdl:service>
			<xsl:attribute name="name">
				<xsl:value-of select="$serviceName"/>
			</xsl:attribute>
			<wsdl:port>
				<xsl:attribute name="name">
					<xsl:value-of select="concat($serviceName, 'Soap12Port')"/>
				</xsl:attribute>
				<xsl:attribute name="binding">
					<xsl:value-of select="concat('tns:',$serviceName, 'Soap12Binding')"/>
				</xsl:attribute>
				<soap12:address>
					<xsl:attribute name="location">
						<xsl:value-of select="$serviceEndpoint"/>
					</xsl:attribute>
				</soap12:address>
			</wsdl:port>
		</wsdl:service>
	</xsl:template>
	<!-- WSDL service -->
</xsl:stylesheet><!-- Stylus Studio meta-information - (c) 2004-2006. Progress Software Corporation. All rights reserved.
<metaInformation>
<scenarios ><scenario default="yes" name="Scenario1" userelativepaths="yes" externalpreview="no" url="..\..\ServiceDefinition.RetrieveAccountPortfolio1.0.0.0.xml" htmlbaseurl="" outputurl="..\Output\Wsdl\services.activity.basic1.Service11.0.0.0_TF.wsdl" processortype="internal" useresolver="yes" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal" customvalidator=""/></scenarios><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="..\Output\Wsdl\services.activity.basic1.Service11.0.0.0_TF.wsdl" destSchemaRoot="definitions" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no" ><SourceSchema srcSchemaPath="..\..\ServiceDefinition.RetrieveAccountPortfolio1.0.0.0.xml" srcSchemaRoot="Services" AssociatedInstance="" loaderFunction="document" loaderFunctionUsesURI="no"/></MapperInfo><MapperBlockPosition><template match="/"><block path="xsl:call&#x2D;template" x="374" y="0"/></template><template name="types"></template><template name="service"><block path="wsdl:service/xsl:attribute/xsl:value&#x2D;of" x="426" y="121"/><block path="wsdl:service/wsdl:port/xsl:attribute/xsl:value&#x2D;of" x="466" y="121"/><block path="wsdl:service/wsdl:port/xsl:attribute[1]/xsl:value&#x2D;of" x="386" y="121"/><block path="wsdl:service/wsdl:port/soap:address/xsl:attribute/xsl:value&#x2D;of" x="346" y="121"/></template><template name="binding"></template><template name="message"></template><template name="definitions"><block path="wsdl:definitions/xsl:attribute/xsl:value&#x2D;of" x="266" y="36"/><block path="wsdl:definitions/xsl:attribute[1]/xsl:value&#x2D;of" x="426" y="54"/><block path="wsdl:definitions/xsl:call&#x2D;template" x="426" y="18"/><block path="wsdl:definitions/xsl:call&#x2D;template[1]" x="466" y="18"/><block path="wsdl:definitions/xsl:call&#x2D;template[2]" x="386" y="18"/><block path="wsdl:definitions/xsl:call&#x2D;template[3]" x="346" y="18"/><block path="wsdl:definitions/xsl:call&#x2D;template[4]" x="306" y="18"/></template></MapperBlockPosition><TemplateContext></TemplateContext><MapperFilter side="source"></MapperFilter></MapperMetaTag>
</metaInformation>
-->