<?xml version="1.0"?>
<!-- When this file is changed, the JSKEnvelopehelper2 needs to have it's resources updated. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:JSK="urn:schemas-biztalk-org:biztalk:biztalk_1" xmlns="urn:Keystroke-com-au:ESB:Envelope:e3Envelope:Version:1-0-0" xmlns:e3="urn:Keystroke-com-au:ESB:Envelope:e3Envelope:Version:1-0-0" exclude-result-prefixes="JSK" version="1.0">
	<xsl:output encoding="UTF-8"/>
	<xsl:template match="/">
		<xsl:apply-templates select="JSK:biztalk_1"/>
	</xsl:template>
	<xsl:template match="JSK:biztalk_1">
		<e3Envelope>
			<header>
				<delivery>
					<message>
						<messageID>
							<xsl:copy-of select="JSK:header/JSK:delivery/JSK:message/JSK:messageID/text()"/>
						</messageID>
						<sent>
							<xsl:copy-of select="JSK:header/JSK:delivery/JSK:message/JSK:sent/text()"/>
						</sent>
						<subject></subject>
						<!-- <xsl:copy-of select="JSK:header/JSK:delivery/JSK:message/node()"/> -->
					</message>
					<to>
						<address>
							<xsl:value-of select="JSK:header/JSK:delivery/JSK:to/JSK:address/text()"/>
						</address>
						<addressType>
							<xsl:copy-of select="JSK:header/JSK:delivery/JSK:message/JSK:subject/JSK:custom/JSK:ESBCore/JSK:ToAddressTransportType/text()"/>
						</addressType>
						<state>
							<process>
								<xsl:value-of select="JSK:header/JSK:delivery/JSK:to/JSK:state/JSK:process/text()"/>
							</process>
							<handle>
								<xsl:value-of select="JSK:header/JSK:delivery/JSK:to/JSK:state/JSK:handle/text()"/>
							</handle>
							<referenceID><xsl:value-of select="JSK:header/JSK:delivery/JSK:to/JSK:state/JSK:referenceID/text()"/></referenceID>
						</state>
					</to>
					<from>
						<address>
							<xsl:value-of select="JSK:header/JSK:delivery/JSK:from/JSK:address/text()"/>
						</address>
						<addressType>
							<xsl:copy-of select="JSK:header/JSK:delivery/JSK:message/JSK:subject/JSK:custom/JSK:ESBCore/JSK:FromAddressTransportType/text()"/>
						</addressType>
						<state>
							<process>
								<xsl:value-of select="JSK:header/JSK:delivery/JSK:from/JSK:state/JSK:process/text()"/>
							</process>
							<handle>
								<xsl:value-of select="JSK:header/JSK:delivery/JSK:from/JSK:state/JSK:handle/text()"/>
							</handle>
							<referenceID><xsl:value-of select="JSK:header/JSK:delivery/JSK:from/JSK:state/JSK:referenceID/text()"/></referenceID>
						</state>
					</from>
					<CallSynchronizationType>
						<xsl:copy-of select="JSK:header/JSK:delivery/JSK:message/JSK:subject/JSK:custom/JSK:ESBCore/JSK:RunAsyncOnSync/text()"/>
					</CallSynchronizationType>
				</delivery>
				<manifest>
					<xsl:for-each select="JSK:header/JSK:manifest/JSK:document">
						<document>
							<name>
								<xsl:copy-of select="JSK:name/text()"/>
							</name>
							<description>
								<xsl:copy-of select="JSK:description/text()"/>
							</description>
						</document>
					</xsl:for-each>
					<xsl:for-each select="JSK:header/JSK:manifest/JSK:attachment">
						<attachment>
							<index>
								<xsl:copy-of select="JSK:index/text()"/>
							</index>
							<filename>
								<xsl:copy-of select="JSK:filename/text()"/>
							</filename>
							<description>
								<xsl:copy-of select="JSK:description/text()"/>
							</description>
							<type>
								<xsl:copy-of select="JSK:type/text()"/>
							</type>
						</attachment>
					</xsl:for-each>
				</manifest>
				<Systems>
					<xsl:for-each select="JSK:header/JSK:delivery/JSK:message/JSK:subject/JSK:custom/JSK:e3/JSK:Systems/e3:System">
						<System>
							<!-- <xsl:copy-of select="node()"/> ' This puts the namespace in!  -->
							<AdminID>
								<xsl:copy-of select="e3:AdminID/text()"/>
							</AdminID>
							<SystemID>
								<xsl:copy-of select="e3:SystemID/text()"/>
							</SystemID>
							<URL>
								<xsl:copy-of select="e3:URL/text()"/>
							</URL>
							<Environment>
								<xsl:copy-of select="e3:Environment/text()"/>
							</Environment>
							<SystemType>
								<xsl:copy-of select="e3:SystemType/text()"/>
							</SystemType>
							<SystemVersion>
								<xsl:copy-of select="e3:SystemVersion/text()"/>
							</SystemVersion>
						</System>
					</xsl:for-each>
				</Systems>
				<BusinessServiceName>
					<xsl:copy-of select="JSK:header/JSK:delivery/JSK:message/JSK:subject/JSK:custom/JSK:e3/JSK:BusinessServiceName/text()"/>
				</BusinessServiceName>
			</header>
			<body>
				<DocumentBodies>
					<xsl:for-each select="JSK:body/node()">
						<DocumentBody>
							<xsl:copy-of select="self::node()"/>
						</DocumentBody>
					</xsl:for-each>
				</DocumentBodies>
			</body>
		</e3Envelope>
	</xsl:template>
</xsl:stylesheet>
