<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:acord="http://ACORD.org/Standards/Life/2"
	exclude-result-prefixes="acord">
	<xsl:import href="CommonVariables.xsl" />
	<xsl:import href="FigtreeCommonVariables.xsl" />
	<xsl:output method="xml" />
	<xsl:template match="/acord:OLifE">
		<!-- Enquiry (Get Claim Details) -->
		<Figtree_Systems>
			<head>
				<version>
					<xsl:value-of select="$fcvVersion" />
				</version>
				<function type="request" number="003" />
				<module>
					<xsl:value-of select="$fcvModule-WC" />
				</module>
				<client>
					<xsl:value-of select="$fcvClient-Disability" />
				</client>
				<cob />
				<date format="dd/mm/yyyy">
					<xsl:value-of select="$cvTodayDateddMMyyyy" />
				</date>
				<time>
					<xsl:value-of select="$cvCurrentTime12AMPM" />
				</time>
				<time_requested>
					<xsl:value-of select="$cvCurrentTime12AMPM" />
				</time_requested>
				<requested_by>
					<xsl:value-of select="$fcvRequestBy-CSCInterop" />
				</requested_by>
			</head>
			<security>
				<encryption type="1" />
				<username>
					<xsl:value-of select="$fcvUsername" />
				</username>
				<password>
					<xsl:value-of select="$fcvPassword" />
				</password>
			</security>
			<request>
				<format structure="" />
				<xsl:element name="criteria">
					<xsl:attribute name="table">
						<xsl:value-of select="'claim'" />
					</xsl:attribute>
					<xsl:attribute name="incident_number">
						<xsl:value-of select="acord:Holding/acord:Policy/acord:Claim/acord:HOClaimReferenceID" />
					</xsl:attribute>
				</xsl:element>
			</request>
		</Figtree_Systems>
	</xsl:template>
</xsl:stylesheet>