<?xml version="1.0"?>
<!-- When this file is changed, the JSKEnvelopehelper2 needs to have it's resources updated. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:e3="urn:Keystroke-com-au:ESB:Envelope:e3Envelope:Version:1-0-0" xmlns="urn:schemas-biztalk-org:biztalk:biztalk_1" exclude-result-prefixes="e3" version="1.0">
	<xsl:output encoding="UTF-8"/>
	<xsl:template match="/">
		<xsl:apply-templates select="e3:e3Envelope"/>
	</xsl:template>
	<xsl:template match="e3:e3Envelope">
		<biztalk_1>
			<header>
				<delivery>
					<message>
						<messageID>
							<xsl:copy-of select="e3:header/e3:delivery/e3:message/e3:messageID/text()"/>
						</messageID>
						<sent>
							<xsl:copy-of select="e3:header/e3:delivery/e3:message/e3:sent/text()"/>
						</sent>
						<subject>
							<custom>
								<xsl:copy-of select="e3:header/e3:delivery/e3:message/e3:subject/e3:custom/node()"/>
								<e3>
									<Context><xsl:value-of select="e3:header/e3:Context/text()"/></Context>
									<BusinessServiceName><xsl:value-of select="e3:header/e3:BusinessServiceName/text()"/></BusinessServiceName>
									<Systems>
										<xsl:copy-of select="e3:header/e3:Systems/node()"/>
									</Systems>
								</e3>
								<ESBCore>
									<ToAddressTransportType>
										<xsl:value-of select="e3:header/e3:delivery/e3:to/e3:addressType/text()"/>
									</ToAddressTransportType>
									<FromAddressTransportType>
										<xsl:value-of select="e3:header/e3:delivery/e3:from/e3:addressType/text()"/>
									</FromAddressTransportType>
									<!-- CallSynchronizationType: Synchronous = Blank, 0 or 2Asynchronous = 1Balking = 4 (Not implemented in ESB)Timeout = 8(Not implemented in ESB)Synchronous and Asynchronous are mutually exclusive.Balking and Timeout can be added to either Sync or Async for those features.-->
									<RunAsyncOnSync>
										<xsl:value-of select="e3:header/e3:delivery/e3:CallSynchronizationType/text()"/>
									</RunAsyncOnSync>
								</ESBCore>
							</custom>
						</subject>
					</message>
					<to>
						<address>
							<xsl:value-of select="e3:header/e3:delivery/e3:to/e3:address/text()"/>
						</address>
						<state>
							<process>
								<xsl:copy-of select="e3:header/e3:Systems/e3:System/e3:SystemType/text()"/>
								<xsl:copy-of select="e3:header/e3:Systems/e3:System/e3:SystemVersion/text()"/>
								.
								<xsl:value-of select="e3:header/e3:Context/text()"/>
								.
								<xsl:value-of select="e3:header/e3:BusinessServiceName/text()"/>
							</process>
							<handle></handle>
							<referenceID>
								<!-- <custom><e3><Systems><xsl:copy-of select="e3:header/e3:Systems/node()"/></Systems></e3></custom> -->
							</referenceID>
						</state>
					</to>
					<from>
						<address>
							<xsl:value-of select="e3:header/e3:delivery/e3:from/e3:address/text()"/>
						</address>
						<state>
							<process>
								<xsl:value-of select="e3:header/e3:delivery/e3:from/e3:state/e3:process/text()"/>
							</process>
							<handle>
								<xsl:value-of select="e3:header/e3:delivery/e3:from/e3:state/e3:handle/text()"/>
							</handle>
							<referenceID>
								<xsl:value-of select="e3:header/e3:Systems/e3:System/e3:Environment/text()"/>
							</referenceID>
						</state>
					</from>
				</delivery>
				<manifest>
					<xsl:for-each select="e3:header/e3:manifest/e3:document">
						<document>
							<name>
								<xsl:copy-of select="e3:name/text()"/>
							</name>
							<description>
								<xsl:copy-of select="e3:description/text()"/>
							</description>
						</document>
					</xsl:for-each>
					<xsl:for-each select="e3:header/e3:manifest/e3:attachment">
						<attachment>
							<index>
								<xsl:copy-of select="e3:index/text()"/>
							</index>
							<filename>
								<xsl:copy-of select="e3:filename/text()"/>
							</filename>
							<description>
								<xsl:copy-of select="e3:description/text()"/>
							</description>
							<type>
								<xsl:copy-of select="e3:type/text()"/>
							</type>
						</attachment>
					</xsl:for-each>
				</manifest>
			</header>
			<body>
				<xsl:copy-of select="e3:body/e3:DocumentBodies/e3:DocumentBody/node()"/>
			</body>
		</biztalk_1>
	</xsl:template>
</xsl:stylesheet>
