Option Strict Off
Option Explicit On
Module LogDefs
	
	'Public Declare Function LogMsg Lib "3rProductLog" Alias "#1" (ByVal lLoglevel As Long, ByVal sLogText As String) As Integer
	Public Declare Function LogMsgToQ Lib "3rProductLog"  Alias "Log"(ByVal lLoglevel As Integer, ByVal sLogText As String) As Short
	
	'#define LOG_NULL    -1
	'#define LOG_FATAL   0
	'#define LOG_SEVERE  1
	'#define LOG_ERROR   2
	'#define LOG_WARNING 3
	'#define LOG_INFO    4
	'#define LOG_TRACE   5
	'#define LOG_DEBUG   6
	'#define LOG_END     7
	'
	'#define LOG_PERFORMANCE     16  // Include 0x10
	'#define LOG_NAVIGATION      17  // Include 0x20
	'#define LOG_SQL             18  // Include 0x40
	'#define LOG_DATAXFER        19  // Include 0x80
	'#define LOG_CONSDEST        20  // Include 0x100
	
	
	
	'Const LOG_NULL
	Public Const LOG_FATAL As Short = 1
	Public Const LOG_SEVERE As Short = 2
	Public Const LOG_ERROR As Short = 4
	Public Const LOG_WARNING As Short = 8
	Public Const LOG_INFO As Short = 16
	Public Const LOG_TRACE As Short = 32
	Public Const LOG_DEBUG As Short = 64
	Public Const LOG_END As Short = 128
	Public Const LOG_PERFORMANCE As Short = 256
	Public Const LOG_NAVIGATION As Short = 512
	Public Const LOG_SQL As Short = 1024
	Public Const LOG_DATAXFER As Short = 2048
	Public Const LOG_CONSDEST As Short = 4096
	Public Const LOG_REFCOUNT As Short = 8192
	Public Const LOG_TIMING As Short = 16384
	Public Const LOG_RALGITCOOKIE As Integer = 32768
	Public Const LOG_XMLRALSTRING As Integer = 65536
	Public Const LOG_RALGITCOOKIE_VERBOSE As Integer = 131072
	Public Const LOG_TRACKERROR As Integer = 262144
	Public Const LOG_TRANSACTIONCOUNT As Integer = 524288
	Public Const LOG_TRANSACTIONSTART As Integer = 1048576
	Public Const LOG_TRANSACTIONFINISH As Integer = 2097152
	'
	'
	'Log Types...
	
	Public Const LOG_LOCATION_QUEUE As Short = 1
	Public Const LOG_LOCATION_EVENTLOG As Short = 2
	Public Const LOG_LOCATION_TSSLOG As Short = 4
	
	Public Enum eErrorHandlingType
		eInfrastructure = 1
		eLogic = 2
	End Enum
	
	Public Enum eLogLevel
		eLOG_FATAL = 1
		eLOG_SEVERE = 2
		eLOG_ERROR = 4
		eLOG_WARNING = 8
		eLOG_INFO = 16
		eLOG_TRACE = 32
		eLOG_DEBUG = 64
		eLOG_END = 128
		eLOG_PERFORMANCE = 256
		eLOG_NAVIGATION = 512
		eLOG_SQL = 1024
		eLOG_DATAXFER = 2048
		eLOG_CONSDEST = 4096
		eLOG_REFCOUNT = 8192
		eLOG_TIMING = 16384
		eLOG_RALGITCOOKIE = 32768
		eLOG_XMLRALSTRING = 65536
		eLOG_RALGITCOOKIE_VERBOSE = 131072
		eLOG_TRACKERROR = 262144
		eLOG_TRANSACTIONCOUNT = 524288
		eLOG_TRANSACTIONSTART = 1048576
		eLOG_TRANSACTIONFINISH = 2097152
		'
	End Enum
	
	
	'lLogLevel not used...
	'Dilemma - look up registry for where to log, or #if...
	'look up registry only on client?
	'default log to Q?
	'#if needs rebuild, registry slows down...
	'Or... have 2 files... 1 for client, 1 for server, only client uses registry
    'to determine where to log...
    <Conditional("DEBUG")> _
 Public Function LogMsg(ByVal lLoglevel As Integer, ByVal sLogText As String) As Short

#If 1 = LOG_CLIENT Then
		'UPGRADE_NOTE: #If #EndIf block was not upgraded because the expression 1 = LOG_CLIENT did not evaluate to True or was not evaluated. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1035"'
		On Error GoTo LogMsgErr
		'Look up registry to determine whether to log to Queue or to TSSLOG, or EventLog

		Dim lLogLocation As Long
		Dim oReg As REGISTRYLib.Registry
		Set oReg = CreateObject("Registry.Registry")

		lLogLocation = 0

		oReg.SetPathReadOnly "HKEY_LOCAL_MACHINE", "SOFTWARE\Keystroke\ESB\Logging"
		lLogLocation = oReg.GetNumber("ClientLogLocation")
		Set oReg = Nothing

		If LOG_LOCATION_QUEUE = lLogLocation Then
		'log to Queue
		LogMsgToQ lLoglevel, sLogText

		'        Dim q As MY3RMSMQLib.MSMQ
		'        Set q = CreateObject("msmq.msmq")
		'        q.StaticLog (sLogText)
		'        Set q = Nothing
		LogMsg = 1
		Exit Function
		End If

		'if there's no entries for logging location, then use the EventLog
		If LOG_LOCATION_EVENTLOG = lLogLocation Or 0 = lLogLocation Then
		'Log to EventLog
		If 0 = lLogLocation Then
		App.LogEvent "A log location has not been set in the registry. Please set one in: ", vbLogEventTypeInformation
		End If
		If LOG_ERROR >= lLoglevel Then
		App.LogEvent sLogText, vbLogEventTypeError
		LogMsg = 1
		Exit Function
		End If
		If LOG_WARNING >= lLoglevel Then
		App.LogEvent sLogText, vbLogEventTypeWarning
		LogMsg = 1
		Exit Function
		Else
		App.LogEvent sLogText, vbLogEventTypeInformation
		LogMsg = 1
		Exit Function
		End If
		End If

		'+++++ONLY SUPPORT TSS IF WE REALLY NEED TO!!!
		#If 1 = LOG_TSS_SUPPORT Then 

		If LOG_LOCATION_TSSLOG = lLogLocation Then
		'Log to TSSLOG - convert between log levels...
		Dim lTssLogLevel As Long
		lTssLogLevel = Log(lLoglevel) / Log(2)
		If lTssLogLevel > 6 Then
		lTssLogLevel = lTssLogLevel + 8
		End If

		Dim oLog As Toolkit3r.Logger
		Set oLog = CreateObject("3r.Toolkit.Logger")
		oLog.Log lTssLogLevel, sLogText
		Set oLog = Nothing
		LogMsg = 1
		Exit Function
		End If

		#End If
		'-----ONLY SUPPORT TSS IF WE REALLY NEED TO!!!

		LogMsgErr:
		Set oReg = Nothing

		#If 1 = LOG_TSS_SUPPORT Then 
		Set oLog = Nothing
		#End If

		App.LogEvent "LogDefs - LOG ERROR: The following message could not be logged, hence it has appeared here. Check the logger for Problems:" & sLogText, vbLogEventTypeError


#Else
        'Unconditionally log using ProductLog
        Dim lErrNumber As Integer
        Dim sErrDesc As String
        Dim sErrHelpContext As String
        Dim sErrHelpFile As String
        Dim sErrLastDllError As String
        Dim sErrSource As String
        'On Error statement resets Err object. Keep it in case there is something
        If Err.Number <> 0 Then
            lErrNumber = Err.Number
            sErrDesc = Err.Description
            sErrHelpContext = CStr(Err.HelpContext)
            sErrHelpFile = Err.HelpFile
            sErrLastDllError = CStr(Err.LastDllError)
            sErrSource = Err.Source
        End If


        On Error GoTo LogMsgErr

        LogMsgToQ(lLoglevel, sLogText)

        LogMsg = 1
        If lErrNumber <> 0 Then
            'Reset Error object
            Err.Number = lErrNumber
            Err.Description = sErrDesc
            Err.HelpContext = sErrHelpContext
            Err.HelpFile = sErrHelpFile
            Err.Source = sErrSource

        End If
        Exit Function
LogMsgErr:
        'UPGRADE_ISSUE: Constant vbLogEventTypeError was not upgraded. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup2070"'
        'UPGRADE_ISSUE: App method App.LogEvent was not upgraded. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup2069"'
        'App.LogEvent("LogDefs - LOG ERROR: The following message could not be logged, hence it has appeared here. Check the logger for Problems:" & sLogText, vbLogEventTypeError)

        Dim myLog As New EventLog

        If Not myLog.SourceExists("ESB Logger") Then
            myLog.CreateEventSource("ESB Logger", "Application")
        End If
        myLog.Source = "ESB Logger"
        myLog.WriteEntry("LogDefs - LOG ERROR: The following message could not be logged, hence it has appeared here. Check the logger for Problems:" & sLogText, EventLogEntryType.Error)

#End If

    End Function
    <Conditional("DEBUG")> _
Public Function LogMsgErr(ByRef oErr As ErrObject, Optional ByRef sErrorSourceFile As Object = Nothing) As Short

        'UPGRADE_NOTE: IsMissing() was changed to IsNothing(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1021"'
        If Not IsNothing(sErrorSourceFile) Then
            'UPGRADE_WARNING: Couldn't resolve default property of object sErrorSourceFile. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
            LogMsg(LOG_ERROR, sErrorSourceFile & " ErrorNumber=" & Err.Number & "ErrorDescrption=" & Err.Description & "ErrorSource=" & oErr.Source & "ErrorHelpContext=" & oErr.HelpContext & "ErrorHelpFile=" & oErr.HelpFile)
        Else
            LogMsg(LOG_ERROR, "ErrorNumber=" & Err.Number & "ErrorDescrption=" & Err.Description & "ErrorSource=" & oErr.Source & "ErrorHelpContext=" & oErr.HelpContext & "ErrorHelpFile=" & oErr.HelpFile)
        End If
    End Function
    <Conditional("DEBUG")> _
    Public Function LogMsg2(ByRef LogLevel As eLogLevel, ByVal sLogText As String) As Short
        LogMsg(LogLevel, sLogText)
    End Function

    <Conditional("DEBUG")> _
Public Function HandleError(ByRef eErrorType As eErrorHandlingType, Optional ByRef oErr As Object = Nothing, Optional ByRef lNumber As Integer = 0, Optional ByRef sSource As String = "", Optional ByRef sDesc As String = "", Optional ByRef sHelpfile As String = "", Optional ByRef sHelpcontext As String = "") As Object

        Dim lENum As Integer
        Dim sESrc As String
        Dim sEDesc As String
        Dim sEHlpfile As String
        Dim sEHlpCntx As String

        'UPGRADE_NOTE: IsMissing() was changed to IsNothing(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1021"'
        If Not IsNothing(lNumber) Then
            lENum = lNumber
        Else
            lENum = -999
        End If

        'UPGRADE_NOTE: IsMissing() was changed to IsNothing(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1021"'
        If Not IsNothing(sSource) Then
            sESrc = sSource
        Else
            sESrc = ""
        End If

        'UPGRADE_NOTE: IsMissing() was changed to IsNothing(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1021"'
        If Not IsNothing(sDesc) Then
            sEDesc = sDesc
        Else
            sEDesc = ""
        End If

        'UPGRADE_NOTE: IsMissing() was changed to IsNothing(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1021"'
        If Not IsNothing(sHelpfile) Then
            sEHlpfile = sHelpfile
        Else
            sEHlpfile = ""
        End If

        'UPGRADE_NOTE: IsMissing() was changed to IsNothing(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1021"'
        If Not IsNothing(sHelpcontext) Then
            sEHlpCntx = sHelpcontext
        Else
            sEHlpCntx = ""
        End If

        LogMsg(LOG_ERROR, "ErrorNumber=" & lENum & " ErrorSource=" & sESrc & " ErrorDescrption=" & sEDesc & " ErrorHelpContext=" & sEHlpCntx & " ErrorHelpFile=" & sEHlpfile)


        Select Case eErrorType
            Case eErrorHandlingType.eInfrastructure
                'raise an error
                'Err.Raise lENum, sESrc, sEDesc, sEHlpfile, sEHlpCntx
                Err.Raise(Number:=lENum, Source:=sESrc, Description:=sEDesc, HelpFile:=sEHlpfile, HelpContext:=sEHlpCntx)

            Case eErrorHandlingType.eLogic
                'add an error to PlgErrXML
                'UPGRADE_NOTE: IsMissing() was changed to IsNothing(). Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1021"'
                If Not IsNothing(oErr) Then
                    If Not oErr Is Nothing Then
                        'UPGRADE_WARNING: Couldn't resolve default property of object oErr.AddError. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
                        oErr.AddError(lENum, sEDesc, sESrc)
                    End If
                End If

        End Select

    End Function
    <Conditional("DEBUG")> _
Public Sub GetLineNumber()
        'create the stack frame for the function that called this function
        Dim sf As New StackFrame(1, True)
        Dim x As String
        x = "File Name: " & sf.GetFileName() & " Method Name: " & sf.GetMethod().ToString() & " Line number: " & sf.GetFileLineNumber() & " - Column number: " & sf.GetFileColumnNumber()
        LogMsg2(LogDefs.eLogLevel.eLOG_ERROR, x)
    End Sub
    <Conditional("DEBUG")> _
    Public Sub GetLineNumber(ByVal s As String)
        'create the stack frame for the function that called this function
        Dim sf As New StackFrame(1, True)
        Dim x As String
        x = s & ". File Name: " & sf.GetFileName() & " Method Name: " & sf.GetMethod().ToString() & " Line number: " & sf.GetFileLineNumber() & " - Column number: " & sf.GetFileColumnNumber()
        LogMsg2(LogDefs.eLogLevel.eLOG_ERROR, x)
    End Sub
    <Conditional("DEBUG")> _
    Public Sub GetLineNumber(ByVal eLoglevel As LogDefs.eLogLevel, ByVal s As String)
        'create the stack frame for the function that called this function
        Dim sf As New StackFrame(1, True)
        Dim x As String
        x = s & ". File Name: " & sf.GetFileName() & " Method Name: " & sf.GetMethod().ToString() & " Line number: " & sf.GetFileLineNumber() & " - Column number: " & sf.GetFileColumnNumber()
        LogMsg2(eLoglevel, x)
    End Sub
    '<Conditional("DEBUG")> _
Public Sub StartMethod()
        'create the stack frame for the function that called this function
        Dim sf As New StackFrame(1, True)
        Dim x As String
        x = "Start. File Name: " & sf.GetFileName() & " Method Name: " & sf.GetMethod().ToString() & " Line number: " & sf.GetFileLineNumber() & " - Column number: " & sf.GetFileColumnNumber()
        LogMsg2(LogDefs.eLogLevel.eLOG_TRACE, x)
    End Sub
    ' <Conditional("DEBUG")> _
 Public Sub EndMethod()
        'create the stack frame for the function that called this function
        Dim sf As New StackFrame(1, True)
        Dim x As String
        x = "Finish. File Name: " & sf.GetFileName() & " Method Name: " & sf.GetMethod().ToString() & " Line number: " & sf.GetFileLineNumber() & " - Column number: " & sf.GetFileColumnNumber()
        LogMsg2(LogDefs.eLogLevel.eLOG_TRACE, x)

    End Sub
    <Conditional("DEBUG")> _
Public Function GetCurrentSourceLocation() As String
        'create the stack frame for the function that called this function
        Dim sf As New StackFrame(1, True)
        Dim sLocation As String
        sLocation = "File Name: " & sf.GetFileName() & " Method Name: " & sf.GetMethod().ToString() & " Line number: " & sf.GetFileLineNumber() & " - Column number: " & sf.GetFileColumnNumber()
        Return sLocation
    End Function

    '<Conditional("DEBUG")> _
    Public Sub LogMsg3(ByVal eLoglevel As LogDefs.eLogLevel, ByVal s As String)

        'create the stack frame for the function that called this function
        Dim sf As New StackFrame(1, True)
        Dim x As String
        x = s & ". File Name: " & sf.GetFileName() & " Method Name: " & sf.GetMethod().ToString() & " Line number: " & sf.GetFileLineNumber() & " - Column number: " & sf.GetFileColumnNumber()
        'LogMsg2(eLoglevel, x)

    End Sub
    '<Conditional("DEBUG")> Private Sub GetLineNumber()
    '    'create the stack frame for the function that called this function
    '    Dim sf As New StackFrame(1, True)
    '    Dim x As String
    '    x = sf.GetMethod().ToString() & " " & sf.GetFileName() & " " & sf.GetFileLineNumber()
    '    LogMsg2(MemberEnquiry.LogDefs.eLogLevel.eLOG_ERROR, x)
    'End Sub


End Module