Option Strict Off
Option Explicit On
Module PluginHelper
	
	
	'Links Plugin to First Doc in envelope
	Function InitPlugin(ByRef oYourPlugin As Object, ByVal sYourPluginProgID As String, ByRef oEnv As JSK.Envelope, Optional ByVal strXML As String = "") As JSK.PlugIn2
		
		
		
		On Error GoTo InitPluginErr
		oYourPlugin = CreateObject(sYourPluginProgID)
		If oYourPlugin Is Nothing Then
			LogMsg(LOG_ERROR, "PluginHelper (InitPlugin) - CreateObject(sYourPluginProgID) - failed!")
			Err.Raise(1, "PluginHelper (InitPlugin)", "CreateObject(sYourPluginProgID) - failed!")
		End If
		oEnv = CreateObject(C_sProgID_JSKEnvelope)
		If oEnv Is Nothing Then
			LogMsg(LOG_ERROR, "PluginHelper (InitPlugin) - CreateObject(C_sProgID_JSKEnvelope) - failed!")
			Err.Raise(1, "PluginHelper (InitPlugin)", "CreateObject(C_sProgID_JSKEnvelope) - failed!")
		End If
		Dim PlgIf As JSK.PlugIn2
		Dim PlgIferr As JSK.PlugIn2
		
		PlgIf = oYourPlugin
		
		
		
		InitPlugin = PlgIf ' in case anyone ever wants it... we don't want to lose anything...
		
		
		If Not strXML = "" Then
			oEnv.XML = strXML
			'One or more documents have already been added to the message by the fact that we've assigned it the XML
			'We must set the plugin to the correct document...
			
			AddDocumentToEnvelope(oEnv, PlgIf, oYourPlugin)
		Else
			oEnv.manifest.addDocument(PlgIf.DocumentElementName, PlgIf.Namespace, "", oYourPlugin)
		End If
		
		
		Exit Function
		
InitPluginErr: 
		'an error occured initialising plugin
		'UPGRADE_NOTE: Object InitPlugin may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		InitPlugin = Nothing
		LogMsg(LOG_ERROR, "PluginHelper::InitPlugin - error initialising plugin - Error Number:" & Err.Number & " Description:" & Err.Description & " Source:" & Err.Source)
		Err.Raise(Err.Number)
	End Function
	
	'Links Plugin to First Doc in envelope
	Function InitPlugin2(ByRef oYourPlugin As Object, ByVal sYourPluginProgID As String, ByRef oEnv As JSK.Envelope, Optional ByVal strXML As String = "", Optional ByVal bInitErrorXMLHelper As Boolean = False, Optional ByRef oErr As PlgErrorXML.ErrorXMLHelper = Nothing) As JSK.PlugIn2
		
		On Error GoTo InitPlugin2Err
		oYourPlugin = CreateObject(sYourPluginProgID)
		If oYourPlugin Is Nothing Then
			LogMsg(LOG_ERROR, "PluginHelper (InitPlugin2) - CreateObject(sYourPluginProgID) - failed!")
			Err.Raise(1, "PluginHelper (InitPlugin2)", "CreateObject(sYourPluginProgID) - failed!")
		End If
		oEnv = CreateObject(C_sProgID_JSKEnvelope)
		If oEnv Is Nothing Then
			LogMsg(LOG_ERROR, "PluginHelper (InitPlugin2) - CreateObject(C_sProgID_JSKEnvelope) - failed!")
			Err.Raise(1, "PluginHelper (InitPlugin2)", "CreateObject(C_sProgID_JSKEnvelope) - failed!")
		End If
		
		Dim PlgIf As JSK.PlugIn2
		Dim PlgIferr As JSK.PlugIn2
		
		PlgIf = oYourPlugin
		InitPlugin2 = PlgIf ' in case anyone ever wants it... we don't want to lose anything...
		If InitPlugin2 Is Nothing Then
			GoTo InitPlugin2Err
		End If
		
		If Not strXML = "" Then
			oEnv.XML = strXML
			'One or more documents have already been added to the message by the fact that we've assigned it the XML
			'We must set the plugin to the correct document...
			
			AddDocumentToEnvelope(oEnv, PlgIf, oYourPlugin)
		Else
			oEnv.manifest.addDocument(PlgIf.DocumentElementName, PlgIf.Namespace, "", oYourPlugin)
		End If
		
		'initialise the error plugin as well if it's been passed in...
		
		If bInitErrorXMLHelper = True Then
			'If Not IsMissing(oErr) Then
			'initialise the error plugin as well...
			oErr = CreateObject(C_sProgID_PlgErrorXML_ErrorXMLHelper)
			oErr.Initialise()
			
			'Add the Error plugin to the documents of the message.
			PlgIf = oErr.ErrorPlugin
			oEnv.manifest.addDocument(PlgIf.DocumentElementName, PlgIf.Namespace, "", oErr.ErrorPlugin)
			
		End If
		
		
		Exit Function
		
InitPlugin2Err: 
		'an error occured initialising plugin
		'UPGRADE_NOTE: Object InitPlugin2 may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		InitPlugin2 = Nothing
		LogMsg(LOG_ERROR, "PluginHelper::InitPlugin2 - error initialising plugin - Error Number:" & Err.Number & " Description:" & Err.Description & " Source:" & Err.Source)
		Err.Raise(Err.Number)
	End Function
	
	
	'Links Plugin to n(th) Doc in envelope in an XML String with multiple documents
	'Will not create a new JSKEnvelope if one has already been created.
	Function InitPlugin3(ByRef oYourPlugin As Object, ByVal sYourPluginProgID As String, ByRef oEnv As JSK.Envelope, Optional ByRef strXML As String = "", Optional ByVal lIndexOfDesiredDocumentToLinkPlugin As Integer = -1, Optional ByVal bInitErrorXMLHelper As Boolean = False, Optional ByRef oErr As PlgErrorXML.ErrorXMLHelper = Nothing) As JSK.PlugIn2
		'try to use byref for string? Minimizes copying & stack size problems...maybe...check it doesn't crash anywhere!!!
		
		On Error GoTo InitPlugin3Err
		oYourPlugin = CreateObject(sYourPluginProgID)
		If oYourPlugin Is Nothing Then
			LogMsg(LOG_ERROR, "PluginHelper (InitPlugin2) - CreateObject(sYourPluginProgID) - failed!")
			Err.Raise(1, "PluginHelper (InitPlugin2)", "CreateObject(sYourPluginProgID) - failed!")
		End If
		
		If oEnv Is Nothing Then
			oEnv = CreateObject(C_sProgID_JSKEnvelope)
		End If
		If oEnv Is Nothing Then
			LogMsg(LOG_ERROR, "PluginHelper (InitPlugin2) - CreateObject(C_sProgID_JSKEnvelope) - failed!")
			Err.Raise(1, "PluginHelper (InitPlugin2)", "CreateObject(C_sProgID_JSKEnvelope) - failed!")
		End If
		
		Dim PlgIf As JSK.PlugIn2
		Dim PlgIferr As JSK.PlugIn2
		
		PlgIf = oYourPlugin
		InitPlugin3 = PlgIf ' in case anyone ever wants it... we don't want to lose anything...
		If InitPlugin3 Is Nothing Then
			GoTo InitPlugin3Err
		End If
		
		If (strXML = "") Then ' And (lIndexOfDesiredDocumentToLinkPlugin <> -1) Then
			
			If (lIndexOfDesiredDocumentToLinkPlugin <> -1) Then
				'We have Plugins NOT created in this function
				'We want to point our input plugin to one of them
				'oEnv has the Plugin Pointers already in it
				AddDocumentToEnvelope2(oEnv, PlgIf, oYourPlugin, lIndexOfDesiredDocumentToLinkPlugin, True)
			Else
				oEnv.manifest.addDocument(PlgIf.DocumentElementName, PlgIf.Namespace, "", oYourPlugin)
				
			End If
			
		Else
			
			oEnv.XML = strXML
			If (lIndexOfDesiredDocumentToLinkPlugin <> -1) Then
				'One or more documents have already been added to the message by the fact that we've assigned it the XML
				'We must set the plugin to the correct document...
				'We have no Plugins apart from the ones we created in this function
				'oEnv does not have any Plugin pointers hanging off it
				AddDocumentToEnvelope2(oEnv, PlgIf, oYourPlugin, lIndexOfDesiredDocumentToLinkPlugin, False)
				
			Else
				AddDocumentToEnvelope(oEnv, PlgIf, oYourPlugin)
				
			End If
		End If
		
		If bInitErrorXMLHelper = True Then
			'If Not IsMissing(oErr) Then
			'initialise the error plugin as well...
			oErr = CreateObject(C_sProgID_PlgErrorXML_ErrorXMLHelper)
			oErr.Initialise()
			
			'Add the Error plugin to the documents of the message.
			PlgIf = oErr.ErrorPlugin
			oEnv.manifest.addDocument(PlgIf.DocumentElementName, PlgIf.Namespace, "", oErr.ErrorPlugin)
			
		End If
		
		
		
		
		Exit Function
		
InitPlugin3Err: 
		'an error occured initialising plugin
		'UPGRADE_NOTE: Object InitPlugin3 may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
		InitPlugin3 = Nothing
		LogMsg(LOG_ERROR, "PluginHelper::InitPlugin3 - error initialising plugin - Error Number:" & Err.Number & " Description:" & Err.Description & " Source:" & Err.Source)
		Err.Raise(Err.Number)
	End Function
	
	
	
	Function AddDocumentToEnvelope(ByRef oEnv As JSK.Envelope, ByRef PlgIf As JSK.PlugIn2, ByRef oYourPlugin As Object) As Object
		On Error GoTo AddDocumentToEnvelopeErr
		
		
		'check the namespace value here. need to ensure it's the same as the value in: PlgIf.Namespace below...before adding
		'needs to be done in add so that it gets all documents? TOO LATE...This all assumes that the envelope only ever
		'contains one PLUGIN - you can see by the fact that only one plugin & progid are passable(if that's a word!) in...!!!
		'
		
		
		Dim i As Integer
		i = 1
		Dim doc As JSK.clsDocument
		Dim sErrDetails As String
		For	Each doc In oEnv.manifest.document
			If doc.Name = PlgIf.DocumentElementName Then
				'check the namespaces match...
				'if the namespace found in the XML String passed in, matches the namespace of our plugin,
				'then we're OK - otherwise, they're different namespaces or versions...Tell someone
				'Most likely cause - Client<->Server mismatch in plugins...
				If doc.DocumentNode.namespaceURI = PlgIf.Namespace Then ' or some object...see which ones have the details in them...
					doc.Plugin = oYourPlugin 'same as line below...
					'Set oEnv.manifest.document(i).Plugin = oYourPlugin
					Exit For
				Else
					sErrDetails = doc.Name & " " & PlgIf.DocumentElementName & " " & doc.DocumentNode.namespaceURI & " " & PlgIf.Namespace
					Err.Raise(7, "PluginHelper::AddDocumentToEnvelope", "XML Schema Namespace Mismatch - Most likely cause - check version numbers of XML Schema documents - Client<->Server mismatch in plugins... Plugin Details:" & sErrDetails, "http://sv-nsyd-win2k4/XMLSchemas/VersionNumbers.htm")
				End If
			End If
			i = i + 1
		Next doc
		
		Exit Function
AddDocumentToEnvelopeErr: 
		LogMsg(LOG_ERROR, "PluginHelper::AddDocumentToEnvelope - error trying to AddDocumentToEnvelope plugin - Error Number:" & Err.Number & " Description:" & Err.Description & " Source:" & Err.Source)
		Err.Raise(Err.Number)
	End Function
	
	Function AddDocumentToEnvelope2(ByRef oEnv As JSK.Envelope, ByRef PlgIf As JSK.PlugIn2, ByRef oYourPlugin As Object, ByVal lIndexToDesiredDocumentInEnvelope As Integer, ByRef bLinkToExistingClientPlugin As Boolean) As Object
		On Error GoTo AddDocumentToEnvelope2Err
		
		
		'check the namespace value here. need to ensure it's the same as the value in: PlgIf.Namespace below...before adding
		'needs to be done in add so that it gets all documents? TOO LATE...This all assumes that the envelope only ever
		'contains one PLUGIN - you can see by the fact that only one plugin & progid are passable(if that's a word!) in...!!!
		'
		
		
		'Dim i As Long
		'i = 1
		Dim doc As JSK.clsDocument
		'For Each doc In oEnv.manifest.document
		Dim sErrDetails As String
		If oEnv.manifest.document(lIndexToDesiredDocumentInEnvelope).Name = PlgIf.DocumentElementName Then
			'check the namespaces match...
			'if the namespace found in the XML String passed in, matches the namespace of our plugin,
			'then we're OK - otherwise, they're different namespaces or versions...Tell someone
			'Most likely cause - Client<->Server mismatch in plugins...
			If oEnv.manifest.document(lIndexToDesiredDocumentInEnvelope).DocumentNode.namespaceURI = PlgIf.Namespace Then ' or some object...see which ones have the details in them...
				'Set doc.Plugin = oYourPlugin 'same as line below...
				'Set oenv.manifest.document(lIndexToDesiredDocumentInEnvelope).Plugin = oYourPlugin
				
				If bLinkToExistingClientPlugin = True Then
					oYourPlugin = oEnv.manifest.document(lIndexToDesiredDocumentInEnvelope).Plugin
				Else
					oEnv.manifest.document(lIndexToDesiredDocumentInEnvelope).Plugin = oYourPlugin
				End If
				'Exit For
			Else
				sErrDetails = doc.Name & " " & PlgIf.DocumentElementName & " " & doc.DocumentNode.namespaceURI & " " & PlgIf.Namespace
				Err.Raise(7, "PluginHelper::AddDocumentToEnvelope2", "XML Schema Namespace Mismatch - Most likely cause - check version numbers of XML Schema documents - Client<->Server mismatch in plugins... Plugin Details:" & sErrDetails, "http://sv-nsyd-win2k4/XMLSchemas/VersionNumbers.htm")
			End If
		End If
		'    i = i + 1
		'Next
		
		Exit Function
AddDocumentToEnvelope2Err: 
		LogMsg(LOG_ERROR, "PluginHelper::AddDocumentToEnvelope2 - error trying to AddDocumentToEnvelope plugin - Error Number:" & Err.Number & " Description:" & Err.Description & " Source:" & Err.Source)
		Err.Raise(Err.Number)
	End Function
	
	
	Public Function GetXMLKeepingRoutingInfo(ByRef oEnvWithCorrectRouting As JSK.Envelope, ByVal sXMLin As String) As String
		
		On Error GoTo GetXMLKeepingRoutingInfoErr
		
		Dim sXMLout As String
		Dim oEnvOut As JSK.Envelope
		Dim oEnvIn As JSK.Envelope
		
		oEnvOut = CreateObject(C_sProgID_JSKEnvelope)
		If oEnvOut Is Nothing Then
			LogMsg(LOG_ERROR, "PluginHelper (GetXMLKeepingRoutingInfo) - CreateObject(C_sProgID_JSKEnvelope) - failed!")
			Err.Raise(1, "PluginHelper (GetXMLKeepingRoutingInfo)", "CreateObject(C_sProgID_JSKEnvelope) - failed!")
		End If
		
		oEnvOut.XML = sXMLin
		oEnvOut.toAddress = oEnvWithCorrectRouting.toAddress
		oEnvOut.fromAddress = oEnvWithCorrectRouting.fromAddress
		
		'Set up the correct routing...
		GetXMLKeepingRoutingInfo = oEnvOut.XML
		
		Exit Function
		
GetXMLKeepingRoutingInfoErr: 
		LogMsg(LOG_ERROR, "PluginHelper::GetXMLKeepingRoutingInfo - error initialising plugin - Error Number:" & Err.Number & " Description:" & Err.Description & " Source:" & Err.Source)
		Err.Raise(Err.Number)
	End Function
	
	Public Function GetEnvelopeRoutingInfo(ByRef oRequestEnvelope As JSK.Envelope, ByRef oResponseEnvelope As JSK.Envelope) As Object
		
		On Error GoTo GetEnvelopeRoutingInfoErr
		'Switch addresses around...
		oResponseEnvelope.toAddress = oRequestEnvelope.fromAddress
		oResponseEnvelope.fromAddress = oRequestEnvelope.toAddress
		
		Exit Function
		
GetEnvelopeRoutingInfoErr: 
		LogMsg(LOG_ERROR, "PluginHelper::GetEnvelopeRoutingInfo- Error Number:" & Err.Number & " Description:" & Err.Description & " Source:" & Err.Source)
		Err.Raise(Err.Number)
	End Function
	
	
	Public Function CloneEnvelope(ByRef oEnvSrc As JSK.Envelope, ByRef oEnvDest As JSK.Envelope) As String
		'Returns Destination as an EnvelopeObject via the OUT parameter, and as a string via the return parameter
		
		Dim lDocCount As Integer
		Dim lIndex As Integer
		
		lDocCount = oEnvSrc.manifest.document.Count
		lIndex = 1
		
		Dim oDoc As JSK.clsDocument
		For	Each oDoc In oEnvSrc.manifest.document
			CloneEnvelope = CopyDocAcrossEnvelopes(oEnvSrc, lIndex, oEnvDest)
			lIndex = lIndex + 1
		Next oDoc
		
	End Function
	
	Public Function CopyDocAcrossEnvelopes(ByRef oEnvSrc As JSK.Envelope, ByVal lSrcDocIndex As Integer, ByRef oEnvDest As JSK.Envelope, Optional ByVal lDestDocIndex As Integer = -1) As String
		'Note that you will not get good behaviour if you overwrite documents!!!
		'Keep in mind that if you initialise an error XML, then the doc you add to increments by one!
		'This method should optionally?only? NOT HAVE the lDestDocIndex as a parameter for the above reason...
		
		If oEnvDest Is Nothing Then
			oEnvDest = CreateObject(C_sProgID_JSKEnvelope)
		End If
		
		Dim lInternalDestDocIndex As Integer
		If lDestDocIndex = -1 Then
			'get max docs in Dest & add one to it!
			lInternalDestDocIndex = oEnvDest.manifest.document.Count + 1
		Else
			lInternalDestDocIndex = lDestDocIndex
		End If
		Dim oClsDoc As JSK.clsDocument
		Dim oXMLDomNode As MSXML2.IXMLDOMNode
		Dim oXMLDomNode2 As MSXML2.IXMLDOMNode
		Dim oTempPlugin As JSK.PlugIn2
		
		oXMLDomNode2 = oEnvSrc.manifest.document(lSrcDocIndex).DocumentNode.cloneNode(True)
		oTempPlugin = oEnvSrc.manifest.document(lSrcDocIndex).Plugin
		
		oTempPlugin.Cache(oXMLDomNode2)
		oClsDoc = oEnvDest.manifest.addDocument(oEnvSrc.manifest.document(lSrcDocIndex).Plugin.DocumentElementName, oEnvSrc.manifest.document(lSrcDocIndex).Plugin.Namespace, "", oTempPlugin)
		
		oXMLDomNode = oEnvDest.XMLDoc.selectSingleNode("biztalk_1/body").replaceChild(oXMLDomNode2, oEnvDest.manifest.document(lInternalDestDocIndex).DocumentNode)
		oEnvDest.manifest.document(lInternalDestDocIndex).Plugin.Cache(oXMLDomNode2)
		
		CopyDocAcrossEnvelopes = oEnvDest.XML
		
	End Function
	
	
	
	Public Function WrapDocStrInEnvStr(ByRef sDoc As String) As String
		
		Dim sPre As String
		Dim sPostDocName As String
		Dim sPost As String
		Dim sDocName As String
		Dim lEndDocPos As Integer
		
		'Dim sDelivery As String
		'sDelivery = "<delivery><message/><to><address/><state><process></process><handle/><referenceID/></state></to><from><state><referenceID></referenceID></state></from></delivery>"
		
		sPre = "<?xml version=""1.0""?><biztalk_1 xmlns=""urn:schemas-biztalk-org:biztalk:biztalk_1""><header><delivery><message/><to><address/><state><process></process><handle/><referenceID/></state></to><from><state><referenceID></referenceID></state></from></delivery><manifest><document><name>"
		sPostDocName = "</name><description></description></document></manifest></header><body>"
		sPost = "</body></biztalk_1>"
		
		'lEndDocPos = InStr(sDoc, " ")
		'sDocName = Mid(sDoc, 2, lEndDocPos - 2)
		
		Dim oXML As MSXML2.FreeThreadedDOMDocument30
		oXML = CreateObject("Msxml2.DOMDocument.3.0")
		
		
		Dim oDocToBeFragged As MSXML2.FreeThreadedDOMDocument30
		oDocToBeFragged = CreateObject("Msxml2.DOMDocument.3.0")
		oDocToBeFragged.loadXML(sDoc)
		
		'Get first node which is not the <?xml version=""
		'and get it's name...
		Dim i As Integer
		For i = 1 To oDocToBeFragged.childNodes.length
			If oDocToBeFragged.childNodes(i - 1).baseName <> "xml" Then
				
				'oXMLDocFrag.appendChild oXMLDomNode2List(i - 1).cloneNode(True)
				sDocName = oDocToBeFragged.childNodes(i - 1).baseName
				Exit For
			End If
		Next 
		
		
		'The base JSKEnvelope
		oXML.loadXML(sPre & sDocName & sPostDocName & sPost)
		
		
		Dim oXMLDocFrag As MSXML2.IXMLDOMDocumentFragment
		Dim oXMLDomNode As MSXML2.IXMLDOMNode
		Dim oXMLDomNode2 As MSXML2.IXMLDOMNode
		Dim oXMLDomNode2List As MSXML2.IXMLDOMNodeList
		Dim oXMLDomNodeTest As MSXML2.IXMLDOMNode
		
		oXMLDocFrag = oDocToBeFragged.createDocumentFragment
		oXMLDomNode = oXML.selectSingleNode("biztalk_1/body")
		
		oXMLDomNode2List = oDocToBeFragged.selectNodes("self:node()")
		
		
		Dim l As Integer
		For l = 1 To oXMLDomNode2List.length
			If oXMLDomNode2List(l - 1).baseName <> "xml" Then
				
				oXMLDocFrag.appendChild(oXMLDomNode2List(l - 1).cloneNode(True))
				
			End If
		Next 
		
		'UPGRADE_WARNING: Couldn't resolve default property of object oXMLDocFrag. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
		oXMLDomNode.appendChild(oXMLDocFrag)
		
		WrapDocStrInEnvStr = oXML.XML
		
	End Function
	
	Public Function CheckForErrors(ByRef sXML As String) As Boolean
		
		On Error GoTo CheckForErrorsErr
		'Check to see that it's a valid JSK XML Response...
		Dim oEnv As New JSK.Envelope
		oEnv.XML = sXML
		
		'if we haven't spewed by now, it should be OK...
		
		'Now see if there's any errors in the Error Schema
		Dim oErrorXMLHlp As New PlgErrorXML.ErrorXMLHelper
		oErrorXMLHlp.Initialise() 'not needed...
		CheckForErrors = oErrorXMLHlp.AnyErrors(sXML)
		
		Exit Function
		
CheckForErrorsErr: 
		CheckForErrors = True
		
	End Function
	
	
	Public Function SetCustomParam(ByVal sParamName As String, ByVal sParamValue As String, ByRef oEnvRq As JSK.Envelope) As JSK.Envelope
		
		On Error GoTo SetCustomParamErr
		
		LogMsg2(LogDefs.eLogLevel.eLOG_TRACE, "PluginHelper::SetCustomParam::Start")
		
		Dim oJSKEnvNode As MSXML2.IXMLDOMNode
		Dim oNewNode As MSXML2.IXMLDOMNode
		
		Dim oSubjectNode As MSXML2.IXMLDOMNode
		Dim oParamNode As MSXML2.IXMLDOMNode
		Dim oCustomNode As MSXML2.IXMLDOMNode
		
		oJSKEnvNode = oEnvRq.XMLDoc
		
		'    <biztalk_1 xmlns="urn:schemas-biztalk-org:biztalk:biztalk_1">
		'    <header>
		'        <delivery>
		'            <message><messageID></messageID><sent>2002-04-16T16:57:05:00-10:00</sent><subject>20.18.33.250</subject></message>
		'            <to>
		'                <address>http://20.18.32.25:81/HTTPRecvSync.asp</address>
		'            </to>
		'            <from>
		'                <address>MSMQ:.\private$\SV-NSYD-WIN2K2_2184_1880__</address>
		'            </from>
		'        </delivery>
		'    </header>
		
		
		
		'Ensure we have a referenceID node
		oSubjectNode = oEnvRq.BodyAsNode.selectSingleNode("/biztalk_1/header/delivery/message/subject")
		If oSubjectNode Is Nothing Then
			oEnvRq.subject = ""
		End If
		
		oSubjectNode = oEnvRq.BodyAsNode.selectSingleNode("/biztalk_1/header/delivery/message/subject")
		If oSubjectNode Is Nothing Then
			'LogMsg
			'error...
		End If
		
		'Get a oParamNode
		oParamNode = oEnvRq.BodyAsNode.selectSingleNode("/biztalk_1/header/delivery/message/subject/" & sParamName)
		If oParamNode Is Nothing Then
			oParamNode = oEnvRq.BodyAsNode.ownerDocument.createNode(MSXML2.tagDOMNodeType.NODE_ELEMENT, sParamName, "")
		End If
		
		oCustomNode = oEnvRq.BodyAsNode.selectSingleNode("/biztalk_1/header/delivery/message/subject/custom")
		If oCustomNode Is Nothing Then
			oCustomNode = oEnvRq.BodyAsNode.ownerDocument.createNode(MSXML2.tagDOMNodeType.NODE_ELEMENT, "custom", "")
		End If
		
		oNewNode = oCustomNode.appendChild(oParamNode)
		oNewNode = oSubjectNode.appendChild(oCustomNode)
		
		'Set the Param
		oParamNode.Text = sParamValue
		
		LogMsg2(LogDefs.eLogLevel.eLOG_TRACE, "PluginHelper::SetCustomParam::Finish")
		
		Exit Function
		
SetCustomParamErr: 
		HandleError(LogDefs.eErrorHandlingType.eInfrastructure,  ,  , "PluginHelper::SetCustomParam")
		
	End Function
	
	Public Function GetCustomParam(ByVal sParamName As String, ByRef oEnvRq As JSK.Envelope) As String
		
		On Error GoTo GetCustomParamErr
		
		LogMsg2(LogDefs.eLogLevel.eLOG_TRACE, "PluginHelper::GetCustomParam::Start")
		
		Dim oJSKEnvNode As MSXML2.IXMLDOMNode
		Dim oNewNode As MSXML2.IXMLDOMNode
		
		Dim oParamNode As MSXML2.IXMLDOMNode
		Dim oCustomNode As MSXML2.IXMLDOMNode
		
		oJSKEnvNode = oEnvRq.XMLDoc
		
		'    'Ensure we have a referenceID node
		'    If oEnvRq.toState.nodeReferenceID Is Nothing Then
		'        oEnvRq.toState.referenceID = ""
		'    End If
		
		'Get a oParamNode
		oParamNode = oEnvRq.BodyAsNode.selectSingleNode("/biztalk_1/header/delivery/message/subject/custom/" & sParamName)
		If oParamNode Is Nothing Then
			GetCustomParam = ""
			Exit Function
		Else
			GetCustomParam = oParamNode.Text
		End If
		
		
		LogMsg2(LogDefs.eLogLevel.eLOG_TRACE, "PluginHelper::GetCustomParam::Finish")
		
		Exit Function
		
GetCustomParamErr: 
		HandleError(LogDefs.eErrorHandlingType.eInfrastructure,  ,  , "PluginHelper::GetCustomParam")
		
	End Function
End Module