'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Imports System.Xml.Serialization
Imports System.IO
Imports System.Xml
Imports System.Text

Public Interface ILogWriter
    Sub Log(ByVal eLoglevel As LogDefs.eLogLevel, ByVal sLogMessage As String, Optional ByVal sLogSummary As String = "", Optional ByVal sLogXML As String = "")
End Interface

Public Interface IDetailLogWriter
    Sub Log(ByRef oLogDetails As LogDetail) 'Relational Loggers
    Sub LogRequestStart(ByRef oLogDetails As LogDetail) 'Relational Loggers
    Sub LogRequestFinish(ByRef oLogDetails As LogDetail) 'Relational Loggers
End Interface

Public Interface IStringLogWriter
    Sub Log(ByRef sLogString As String) 'Non-relational(flat) Loggers
    Sub LogRequestStart(ByRef sLogString As String) 'Non-relational(flat) Loggers
    Sub LogRequestFinish(ByRef sLogString As String) 'Non-relational(flat) Loggers
    Sub LogMetering(ByRef sLogString As String) 'Non-relational(flat) Loggers

End Interface

Public Interface ILogDetailCol
    Inherits IEnumerable
    Inherits IEnumerator
End Interface

Public Interface ILogStringCol
    Inherits IEnumerable
    Inherits IEnumerator
End Interface
<Serializable()> _
Public Class LogDetail
    Public eLoglevel As LogDefs.eLogLevel
    Public ePerformanceCounterlevel As LogDefs.ePerformanceCounterLevel
    Public sTimestamp As String
    Public sProcessID As String
    Public sThreadID As String
    Public sComputerName As String
    Public sUserName As String
    Public sChannel As String
    Public sMessageID As String
    Public sDomainInternalMessageID As String  'was: sInternalMessageID
    Public sActivityID As String
    Public sStatus As String
    Public sLogMessage As String
    Public sLogMessageSummary As String 'optional - generated?
    Public sXML As String
    Public sSourceCodeMethodDetails As String
    Public sSourceCodeLocationDetails As String
    Public sResolveName As String
    Public sContext As String
    Public sRequestSourceHost As String
    Public sRequestSourceUserAgent As String
    Public sRequestSourceUrlReferrer As String
    Public sMessageExchangePattern As String

    Public sNodeRequestID As String
    Public sConversationID As String
    Public sClusterName As String
    Public sESBServiceDomainName As String
    Public bIsServiceDomainEntryPoint As Boolean
    Public sESBInstanceName As String
    Public bIsServiceDomainRequestMessage As Boolean
    Public bIsNodeInstanceRequestMessage As Boolean

    Public sTransportUrl As String
    Public sTransportType As String
    Public sTransportProfile As String

    Public sExecutionTime As String ' Don't make this available to the ToString() method...

    Public tsServiceInvocationCPUUsage As Double

    Public ExecutionMode As eExecutionMode = LogDefs.eExecutionMode.eExecute

    ReadOnly Property FullyQualifiedInstanceName() As String
        Get
            Return sESBServiceDomainName & "." & sClusterName & "." & sESBInstanceName
        End Get
    End Property


    Public Overrides Function ToString() As String
        Return Serialize(Me)
    End Function
    Public Function FromString(ByVal sLogDetail As String) As LogDetail
        Return DeSerialize(sLogDetail, GetType(LogDetail))
    End Function
    Public Function Serialize(ByVal oObjectToSerialize As System.Object) As String
        Dim oSer As System.Xml.Serialization.XmlSerializer
        oSer = New XmlSerializer(oObjectToSerialize.GetType())
        Dim oMemStream As New MemoryStream
        Dim sw As New StreamWriter(oMemStream, New System.Text.UTF8Encoding)
        Dim sXML As String
        oSer.Serialize(sw, oObjectToSerialize)
        sXML = Encoding.UTF8.GetString(oMemStream.ToArray())
        oMemStream.Flush()
        oMemStream.Close()
        Return sXML
    End Function

    Public Function DeSerialize(ByVal sXMLStringToDeSerialize As String, ByVal tType As Type) As Object
        'Deserialize to the original objects
        Dim sr As New StringReader(sXMLStringToDeSerialize)
        Dim x1 As Object
        Dim oSer As System.Xml.Serialization.XmlSerializer
        oSer = New XmlSerializer(tType)
        x1 = oSer.Deserialize(sr)
        Return x1
    End Function
End Class