''-----------------------------------------------------------------------------
'' <summary>
'' Copyright Keystroke IT 2003
'' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
'' </summary>
''-----------------------------------------------------------------------------
Option Strict Off
Option Explicit On 

Public Module LogDefs

    Public Enum eErrorHandlingType
        eInfrastructure = 1
        eLogic = 2
    End Enum

    <Flags()> _
    Public Enum eLogLevel
        eLOG_FATAL = 1
        eLOG_SEVERE = 2
        eLOG_ERROR = 4
        eLOG_WARNING = 8
        eLOG_INFO = 16
        eLOG_TRACE = 32
        eLOG_DEBUG = 64
        eLOG_TRANSPORT_INVOKED = 128
        eLOG_PERFORMANCE = 256
        eLOG_NAVIGATION = 512
        eLOG_SQL = 1024
        eLOG_DATAXFER = 2048
        eLOG_CONSDEST = 4096
        eLOG_XML_ENVELOPE_FLOW = 8192
        eLOG_TIMING = 16384
        eLOG_ACTIVITY_HANDLER_INVOKED = 32768
        eLOG_SEP_HANDLER_INVOKED = 65536
        eLOG_PIPELINE_HANDLER_INVOKED = 131072
        eLOG_TRANSFORMATION_HANDLER_INVOKED = 262144
        eLOG_SERVICE_INVOCATION_COUNT = 524288
        eLOG_SERVICE_INVOCATION_START = 1048576
        eLOG_SERVICE_INVOCATION_FINISH = 2097152
        eLOG_CONVENTION_HANDLER_INVOKED = 4194304
        eLOG_CONVENTION_HANDLER_WORKFLOW_INVOKED = 8388608
        eLOG_CONVENTION_HANDLER_BROKER_INVOKED = 16777216
        eLOG_AUDIT = 33554432
    End Enum

    <Flags()> _
   Public Enum ePerformanceCounterLevel
        eLOG_Services = 1
        eLOG_ServiceHandlers = 2
        eLOG_Transports_Wcf = 4
        eLOG_Transports_Wse = 8
        eLOG_Transports_HttpGenericWebService = 16
        eLOG_Transports_Http = 32
        eLOG_Transports_HttpInternalAsync = 64
    End Enum

    Enum eExecutionMode As Integer
        eExecute = 1
        eSimulate = 2
    End Enum
End Module
