Imports ESB.Core.Interfaces.Envelope
Imports ESB.Core.Interfaces.Logging

Public Interface IServerContext
    Inherits ESB.Core.Interfaces.ProcessMsg.IProcessMsg
    Inherits ESB.Core.Interfaces.ServerContext.IXsltManager

#Region "InterfaceProperties"
    'todo - make an interface for the error schema...
    Property Status() As ESB.Core.XMLSchemaClasses.ErrorXML.ErrorXML
    Property ThreadLogDetail() As LogDetail
    Property VirginEnvelopeRequest() As String
    Property EnvRq() As IEnvelope
    Property EnvRs() As IEnvelope
    Property ContinueProcessingPipeline() As Boolean
    Property LastAdaptorProcessingStatus() As Boolean
    Property ContinueProcessingPipelineOnAppAdaptorProcessingError() As Boolean
    ReadOnly Property XsltManager() As ESB.Core.Interfaces.ServerContext.IXsltManager
    Property PipelineTransitionData() As IPipelineTransitionData
    ReadOnly Property ESBRootPath() As String
    ReadOnly Property FullyQualifiedInstanceName() As String
    Property ResolveName() As String
    Property Context() As String
    Property IsServiceDomainRequestMessage() As Boolean
    Property IsNodeInstanceRequestMessage() As Boolean
    Property ExecutionMode() As eExecutionMode

#End Region
#Region "InterfaceMethods"
    Sub InitLoggingParams()
    Function GetLogManager() As ILogWriter
    Sub ClearPipelineCache()
    Sub ClearXsltCache()
    Sub ClearAllCaches()
    Function ShouldLog(ByVal eLogLevel As LogDefs.eLogLevel) As Boolean
#End Region


   
End Interface
