create database TraceStore
go

use TraceStore
go

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Traces]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Traces]
GO

CREATE TABLE [dbo].[Traces] (
	[TraceDateTime] [datetime] NULL ,
	[TraceCategory] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[TraceDescription] [varchar] (1024) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[StackTrace] [varchar] (2048) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[DetailedErrorDescription] [varchar] (2048) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[usp_AddTrace]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[usp_AddTrace]
go

create procedure usp_AddTrace

@r_dtTraceDateTime	datetime,
@r_vcTraceCategory	varchar(50),
@r_vcTraceDescription	varchar(1024),
@r_vcStackTrace		varchar(2048),
@r_vcDetailedErrorDescription	varchar(2048)

as
begin
	insert
		Traces 	(TraceDateTime, TraceCategory, TraceDescription, StackTrace, DetailedErrorDescription)
	values
			(@r_dtTraceDateTime, @r_vcTraceCategory, @r_vcTraceDescription, @r_vcStackTrace, @r_vcDetailedErrorDescription)
	return @@error
end
go

