'''-----------------------------------------------------------------------------
''' <summary>
''' Copyright Keystroke IT 2003
''' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
''' </summary>
'''-----------------------------------------------------------------------------
Public MustInherit Class BaseLogDetailLogger
    Implements IDetailLogWriter

    Protected m_oLogDetailCol As LogDetailCol

    Public MustOverride Sub Log(ByRef oLogDetails As Interfaces.Logging.LogDetail) Implements Interfaces.Logging.IDetailLogWriter.Log



    Public Overridable Sub LogRequestStart(ByRef oLogDetails As Interfaces.Logging.LogDetail) Implements Interfaces.Logging.IDetailLogWriter.LogRequestStart

    End Sub
    Public Overridable Sub LogRequestFinish(ByRef oLogDetails As Interfaces.Logging.LogDetail) Implements Interfaces.Logging.IDetailLogWriter.LogRequestFinish

    End Sub
    Public ReadOnly Property LogDetails() As LogDetailCol
        Get
            Return m_oLogDetailCol
        End Get
    End Property


End Class

Public MustInherit Class BaseLogStringLogger
    Inherits Collections.Specialized.StringCollection
    Implements IStringLogWriter

    Protected m_oLogStringCol As Specialized.StringCollection

    Public MustOverride Sub Log(ByRef sLogString As String) Implements Interfaces.Logging.IStringLogWriter.Log

    Public Overridable Sub LogRequestStart(ByRef sLogString As String) Implements Interfaces.Logging.IStringLogWriter.LogRequestStart

    End Sub
    Public Overridable Sub LogRequestFinish(ByRef sLogString As String) Implements Interfaces.Logging.IStringLogWriter.LogRequestFinish

    End Sub
    Public Overridable Sub LogMetering(ByRef sLogString As String) Implements Interfaces.Logging.IStringLogWriter.LogMetering

    End Sub


    Public Overridable ReadOnly Property LogStrings() As Specialized.StringCollection
        Get
            Return m_oLogStringCol
        End Get
    End Property

End Class

Public Class LogDetailCol
    Inherits CollectionBase


    Public Sub Add(ByVal item As LogDetail)
        List.Add(item)
    End Sub
    Public Sub Remove(ByVal index As Integer)
        If index > Count - 1 Or index < 0 Then
            'ERROR!!!
            Exit Sub
        End If
        List.RemoveAt(index)

    End Sub
    Public Sub Insert(ByVal index As Integer, ByVal item As LogDetail)
        If index > Count Or index < 0 Then
            'ERROR!!!
            Exit Sub
        End If
        List.Insert(index, item)
    End Sub
    Default Public Property Item(ByVal index As Integer) As LogDetail
        Get
            Return CType(List.Item(index), LogDetail)
        End Get
        Set(ByVal value As LogDetail)
            List.Insert(index, value)
        End Set

    End Property

End Class