'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Strict On
Option Explicit On 


Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.IO


Public Class MsSqlLogger
    Inherits BaseLogDetailLogger

    Const C_s_EMPTY_ As String = "_EMPTY_"
#Region "Private Fields"
    Dim m_bConnected As Boolean = False
    Dim m_bIsMsSql2005 As Boolean = False
    Dim m_LogConn As SqlConnection
    Dim m_sLogConnString As String

    Dim m_addLog As SqlCommand
    Dim m_addLogRqStart As SqlCommand
    Dim m_addLogRqFinish As SqlCommand

    Dim m_oAddPrepared As Boolean = False
    Dim m_oAddLogRqStartPrepared As Boolean = False
    Dim m_oAddLogRqFinishPrepared As Boolean = False
#End Region

    Public Function Connect() As Boolean
        If m_bConnected = False Then

            m_sLogConnString = System.Configuration.ConfigurationManager.AppSettings("MsSqlLoggerConnectionString")
            m_bIsMsSql2005 = Boolean.Parse(System.Configuration.ConfigurationManager.AppSettings("MsSqlLogger.IsMsSql2005"))

            m_LogConn = New SqlConnection(m_sLogConnString)
            m_LogConn.Open()

            m_bConnected = True

            m_addLog = New SqlCommand("INSERT INTO ESBLogDetail ( LogLevel, LogTime, LogSummary, LogText, ProcessID, ThreadID,  MessageID, DomainInternalMessageID, ActivityID, Status, SourceCodeLocationDetails, SourceCodeMethodDetails, XmlLogData, ExecutionMode, ESBInstanceName) Values(@LogLevel, @LogTime, @LogSummary, @LogText, @ProcessID, @ThreadID, @MessageID, @DomainInternalMessageID, @ActivityID, @Status, @SourceCodeLocationDetails, @SourceCodeMethodDetails, @XmlLogData, @ExecutionMode, @ESBInstanceName)", m_LogConn)
            m_addLog.Prepare()

            m_addLogRqStart = New SqlCommand("INSERT INTO ESBLogHeader (  LogTime,  MessageID, DomainInternalMessageID, ActivityID, UserName, ComputerName, ResolveName, Context, RequestSourceHost, Status, RequestXML, ServiceDomainName, ClusterName, ConversationID, NodeRequestID, IsServiceDomainEntryPoint, ESBInstanceName, IsServiceDomainRequestMessage, IsNodeInstanceRequestMessage, TransportProfile, TransportType, TransportUrl, ExecutionMode ) Values(@LogTime, @MessageID, @DomainInternalMessageID, @ActivityID, @UserName, @ComputerName , @ResolveName, @Context, @RequestSourceHost, @Status, @RequestXML, @ServiceDomainName, @ClusterName, @ConversationID, @NodeRequestID, @IsServiceDomainEntryPoint, @ESBInstanceName, @IsServiceDomainRequestMessage, @IsNodeInstanceRequestMessage, @TransportProfile, @TransportType, @TransportUrl, @ExecutionMode)", m_LogConn)
            m_addLogRqStart.Prepare()



            m_addLogRqFinish = New SqlCommand("Update ESBLogHeader Set Duration=@Duration, Status=@Status, RequestSourceHost=@RequestSourceHost, ResponseXML=@ResponseXML where ActivityID=@ActivityID", m_LogConn)
            m_addLogRqFinish.Prepare()


            Return True

        End If
        Return True
    End Function
    Public Function Disconnect() As Boolean
        If Not m_LogConn Is Nothing Then
            m_LogConn.Close()
        End If
        m_bConnected = False
        Return True
    End Function
    Public Sub MakeFieldsNotNull(ByRef oLogDetails As Interfaces.Logging.LogDetail)
        'Yucky Yucky Yucky Poo - what are we gonna do?
        With oLogDetails
            If .eLoglevel = 0 Then
                '???
            End If
            If .sActivityID = "" Then
                .sActivityID = C_s_EMPTY_
            End If
            If .sComputerName = "" Then
                .sComputerName = C_s_EMPTY_
            End If
            If .sUserName = "" Then
                .sUserName = C_s_EMPTY_
            End If
            If .sContext = "" Then
                .sContext = C_s_EMPTY_
            End If
            If .sDomainInternalMessageID = "" Then
                .sDomainInternalMessageID = C_s_EMPTY_
            End If

            If .sNodeRequestID = "" Then
                .sNodeRequestID = C_s_EMPTY_
            End If
            If .sConversationID = "" Then
                .sConversationID = C_s_EMPTY_
            End If
            If .sClusterName = "" Then
                .sClusterName = C_s_EMPTY_
            End If
            If .sESBServiceDomainName = "" Then
                .sESBServiceDomainName = C_s_EMPTY_
            End If

            If .sESBInstanceName = "" Then
                .sESBInstanceName = C_s_EMPTY_
            End If

            'If .bIsServiceDomainRequestMessage <> True Then
            '    .bIsServiceDomainRequestMessage = False
            'End If

            'If .bIsNodeInstanceRequestMessage <> True Then
            '    .bIsNodeInstanceRequestMessage = False
            'End If

            'If .bIsServiceDomainEntryPoint <> True Then
            '    .bIsServiceDomainEntryPoint = False
            'End If

            If .sLogMessage = "" Then
                .sLogMessage = C_s_EMPTY_
            End If
            If .sLogMessageSummary = "" Then
                .sLogMessageSummary = C_s_EMPTY_
            End If
            If .sMessageID = "" Then
                .sMessageID = C_s_EMPTY_
            End If
            If .sProcessID = "" Then
                .sProcessID = C_s_EMPTY_
            End If
            If .sRequestSourceHost = "" Then
                .sRequestSourceHost = C_s_EMPTY_
            End If
            If .sResolveName = "" Then
                .sResolveName = C_s_EMPTY_
            End If
            If .sSourceCodeLocationDetails = "" Then
                .sSourceCodeLocationDetails = C_s_EMPTY_
            End If
            If .sSourceCodeMethodDetails = "" Then
                .sSourceCodeMethodDetails = C_s_EMPTY_
            End If
            If .sStatus = "" Then
                .sStatus = C_s_EMPTY_
            End If
            If .sThreadID = "" Then
                .sThreadID = C_s_EMPTY_
            End If
            If .sTimestamp = "" Then
                .sTimestamp = DateAndTime.Now.ToString("yyyy-MM-dd:HH:mm:ss.fffffff") & " DBLogGen"
            End If
            If .sXML = "" Then
                .sXML = C_s_EMPTY_
            End If
            If .sExecutionTime = "" Then
                .sExecutionTime = C_s_EMPTY_
            End If

            If .sESBServiceDomainName = "" Then
                .sESBServiceDomainName = C_s_EMPTY_
            End If

            If .sClusterName = "" Then
                .sClusterName = C_s_EMPTY_
            End If
            If .sConversationID = "" Then
                .sConversationID = C_s_EMPTY_
            End If
            If .sNodeRequestID = "" Then
                .sNodeRequestID = C_s_EMPTY_
            End If

            If .sTransportProfile = "" Then
                .sTransportProfile = C_s_EMPTY_
            End If
            If .sTransportType = "" Then
                .sTransportType = C_s_EMPTY_
            End If
            If .sTransportUrl = "" Then
                .sTransportUrl = C_s_EMPTY_
            End If
            
        End With

    End Sub
    Public Overrides Sub Log(ByRef oLogDetails As Interfaces.Logging.LogDetail)
        Try
            Connect()
            'Dim addLog As New SqlCommand("INSERT INTO ESBLogDetail ( LogLevel, LogTime, LogSummary, LogText, ProcessID, ThreadID, UserName, ComputerName, MessageID, InternalMessageID, ActivityID, Status, ResolveName, Context, RequestSourceHost, SourceCodeLocationDetails, SourceCodeMethodDetails) Values(@LogLevel, @LogTime, @LogSummary, @LogText, @ProcessID, @ThreadID, @UserName, @ComputerName , @MessageID, @InternalMessageID, @ActivityID, @Status, @ResolveName, @Context, @RequestSourceHost, @SourceCodeLocationDetails, @SourceCodeMethodDetails)", m_LogConn)
            'if the field is empty, then we need to set it to something so the query doesn't fail...
            MakeFieldsNotNull(oLogDetails)

            With oLogDetails
                If m_oAddPrepared = False Then
                    m_addLog.Parameters.Add("@LogLevel", SqlDbType.Int).Value = .eLoglevel
                    m_addLog.Parameters.Add("@LogTime", SqlDbType.NVarChar).Value = .sTimestamp
                    m_addLog.Parameters.Add("@LogSummary", SqlDbType.NVarChar).Value = .sLogMessageSummary
                    m_addLog.Parameters.Add("@LogText", SqlDbType.NText).Value = .sLogMessage
                    m_addLog.Parameters.Add("@ProcessID", SqlDbType.NVarChar).Value = .sProcessID
                    m_addLog.Parameters.Add("@ThreadID", SqlDbType.NVarChar).Value = .sThreadID
                    m_addLog.Parameters.Add("@MessageID", SqlDbType.NVarChar).Value = .sMessageID
                    m_addLog.Parameters.Add("@DomainInternalMessageID", SqlDbType.NVarChar).Value = .sDomainInternalMessageID
                    m_addLog.Parameters.Add("@ActivityID", SqlDbType.NVarChar).Value = .sActivityID
                    m_addLog.Parameters.Add("@Status", SqlDbType.NVarChar).Value = .sStatus
                    m_addLog.Parameters.Add("@SourceCodeLocationDetails", SqlDbType.NVarChar).Value = .sSourceCodeLocationDetails
                    m_addLog.Parameters.Add("@SourceCodeMethodDetails", SqlDbType.NVarChar).Value = .sSourceCodeMethodDetails

                    'If using SQL 2005, we should have this type as an XML type to allow us to do some nice BAM stuff...
                    If m_bIsMsSql2005 Then
                        m_addLog.Parameters.Add("@XmlLogData", SqlDbType.Xml).Value = SwitchXMLEncoding(.sXML)
                    Else
                        m_addLog.Parameters.Add("@XmlLogData", SqlDbType.NText).Value = .sXML
                    End If
                    m_addLog.Parameters.Add("@ExecutionMode", SqlDbType.NVarChar).Value = .ExecutionMode.ToString
                    m_addLog.Parameters.Add("@ESBInstanceName", SqlDbType.NVarChar).Value = Util.ESBGlobalVariables.ESBInstanceName

                    m_oAddPrepared = True
                Else
                    m_addLog.Parameters("@LogLevel").Value = .eLoglevel
                    m_addLog.Parameters("@LogTime").Value = .sTimestamp
                    m_addLog.Parameters("@LogSummary").Value = .sLogMessageSummary
                    m_addLog.Parameters("@LogText").Value = .sLogMessage
                    m_addLog.Parameters("@ProcessID").Value = .sProcessID
                    m_addLog.Parameters("@ThreadID").Value = .sThreadID
                    m_addLog.Parameters("@MessageID").Value = .sMessageID
                    m_addLog.Parameters("@DomainInternalMessageID").Value = .sDomainInternalMessageID
                    m_addLog.Parameters("@ActivityID").Value = .sActivityID
                    m_addLog.Parameters("@Status").Value = .sStatus
                    m_addLog.Parameters("@SourceCodeLocationDetails").Value = .sSourceCodeLocationDetails
                    m_addLog.Parameters("@SourceCodeMethodDetails").Value = .sSourceCodeMethodDetails

                    'If using SQL 2005, we should have this type as an XML type to allow us to do some nice BAM stuff...
                    If m_bIsMsSql2005 Then
                        m_addLog.Parameters("@XmlLogData").Value = SwitchXMLEncoding(.sXML)
                    Else
                        m_addLog.Parameters("@XmlLogData").Value = .sXML
                    End If

                    m_addLog.Parameters("@ExecutionMode").Value = .ExecutionMode.ToString
                    m_addLog.Parameters("@ESBInstanceName").Value = Util.ESBGlobalVariables.ESBInstanceName


                End If
            End With
            Dim nRows As Integer
            nRows = m_addLog.ExecuteNonQuery()
            If nRows = 0 Then
                Throw New Exception("Error - 0 rows added by MsSqlLogger")
            End If

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Dim sErrorMsg As String = m_addLog.CommandText
            sErrorMsg += vbNewLine
            Dim sSqlParams As String = ""
            With oLogDetails
                sErrorMsg += sSqlParams.Format("@LogLevel={0}, @LogTime={1}, @LogSummary={2}, @LogText={3}, @ProcessID={4}, @ThreadID={5}, @MessageID={6}, @DomainInternalMessageID={7}, @ActivityID={8}, @Status={9}, @SourceCodeLocationDetails={10}, @SourceCodeMethodDetails={11}, @XmlLogData={12}", .eLoglevel, .sTimestamp, .sLogMessageSummary, .sLogMessage, .sProcessID, .sThreadID, .sMessageID, .sDomainInternalMessageID, .sActivityID, .sStatus, .sSourceCodeLocationDetails, .sSourceCodeMethodDetails, .sXML)
            End With
            Dim ex2 As New Exception(sErrorMsg & sSqlParams)
            ExceptionManager.Publish(ex2)

        Finally

        End Try
    End Sub
    Public Overrides Sub LogRequestStart(ByRef oLogDetails As Interfaces.Logging.LogDetail)
        Try
            'm_oTimer.StartTimer()

            Connect()
            'if the field is empty, then we need to set it to something so the query doesn't fail...
            MakeFieldsNotNull(oLogDetails)

            With oLogDetails
                If m_oAddLogRqStartPrepared = False Then
                    m_addLogRqStart.Parameters.Add("@LogTime", SqlDbType.NVarChar).Value = .sTimestamp
                    m_addLogRqStart.Parameters.Add("@MessageID", SqlDbType.NVarChar).Value = .sMessageID
                    m_addLogRqStart.Parameters.Add("@DomainInternalMessageID", SqlDbType.NVarChar).Value = .sDomainInternalMessageID
                    m_addLogRqStart.Parameters.Add("@ActivityID", SqlDbType.NVarChar).Value = .sActivityID
                    m_addLogRqStart.Parameters.Add("@UserName", SqlDbType.NVarChar).Value = .sUserName
                    m_addLogRqStart.Parameters.Add("@ComputerName", SqlDbType.NVarChar).Value = .sComputerName
                    m_addLogRqStart.Parameters.Add("@ResolveName", SqlDbType.NVarChar).Value = .sResolveName
                    m_addLogRqStart.Parameters.Add("@Context", SqlDbType.NVarChar).Value = .sContext
                    m_addLogRqStart.Parameters.Add("@RequestSourceHost", SqlDbType.NVarChar).Value = .sRequestSourceHost
                    m_addLogRqStart.Parameters.Add("@Status", SqlDbType.NVarChar).Value = .sStatus

                    'If using SQL 2005, we should have this type as an XML type to allow us to do some nice BAM stuff...
                    If m_bIsMsSql2005 Then
                        m_addLogRqStart.Parameters.Add("@RequestXML", SqlDbType.Xml).Value = SwitchXMLEncoding(.sXML)
                    Else
                        m_addLogRqStart.Parameters.Add("@RequestXML", SqlDbType.NText).Value = .sXML
                    End If

                    m_addLogRqStart.Parameters.Add("@ServiceDomainName", SqlDbType.NVarChar).Value = .sESBServiceDomainName
                    m_addLogRqStart.Parameters.Add("@ClusterName", SqlDbType.NVarChar).Value = .sClusterName
                    m_addLogRqStart.Parameters.Add("@ConversationID", SqlDbType.NVarChar).Value = .sConversationID
                    m_addLogRqStart.Parameters.Add("@NodeRequestID", SqlDbType.NVarChar).Value = .sNodeRequestID
                    m_addLogRqStart.Parameters.Add("@IsServiceDomainEntryPoint", SqlDbType.Bit).Value = .bIsServiceDomainEntryPoint

                    m_addLogRqStart.Parameters.Add("@ESBInstanceName", SqlDbType.NVarChar).Value = .sESBInstanceName
                    m_addLogRqStart.Parameters.Add("@IsServiceDomainRequestMessage", SqlDbType.Bit).Value = .bIsServiceDomainRequestMessage
                    m_addLogRqStart.Parameters.Add("@IsNodeInstanceRequestMessage", SqlDbType.Bit).Value = .bIsNodeInstanceRequestMessage

                    m_addLogRqStart.Parameters.Add("@TransportProfile", SqlDbType.NVarChar).Value = .sTransportProfile
                    m_addLogRqStart.Parameters.Add("@TransportType", SqlDbType.NVarChar).Value = .sTransportType
                    m_addLogRqStart.Parameters.Add("@TransportUrl", SqlDbType.NVarChar).Value = .sTransportUrl
                    m_addLogRqStart.Parameters.Add("@ExecutionMode", SqlDbType.NVarChar).Value = .ExecutionMode.ToString


                    m_oAddLogRqStartPrepared = True
                Else
                    m_addLogRqStart.Parameters("@LogTime").Value = .sTimestamp
                    m_addLogRqStart.Parameters("@MessageID").Value = .sMessageID
                    m_addLogRqStart.Parameters("@DomainInternalMessageID").Value = .sDomainInternalMessageID
                    m_addLogRqStart.Parameters("@ActivityID").Value = .sActivityID
                    m_addLogRqStart.Parameters("@UserName").Value = .sUserName
                    m_addLogRqStart.Parameters("@ComputerName").Value = .sComputerName
                    m_addLogRqStart.Parameters("@ResolveName").Value = .sResolveName
                    m_addLogRqStart.Parameters("@Context").Value = .sContext
                    m_addLogRqStart.Parameters("@RequestSourceHost").Value = .sRequestSourceHost
                    m_addLogRqStart.Parameters("@Status").Value = .sStatus

                    'If using SQL 2005, we should have this type as an XML type to allow us to do some nice BAM stuff...
                    If m_bIsMsSql2005 Then
                        m_addLogRqStart.Parameters("@RequestXML").Value = SwitchXMLEncoding(.sXML)
                    Else
                        m_addLogRqStart.Parameters("@RequestXML").Value = .sXML
                    End If

                    m_addLogRqStart.Parameters("@ServiceDomainName").Value = .sESBServiceDomainName
                    m_addLogRqStart.Parameters("@ClusterName").Value = .sClusterName
                    m_addLogRqStart.Parameters("@ConversationID").Value = .sConversationID
                    m_addLogRqStart.Parameters("@NodeRequestID").Value = .sNodeRequestID
                    m_addLogRqStart.Parameters("@IsServiceDomainEntryPoint").Value = .bIsServiceDomainEntryPoint

                    m_addLogRqStart.Parameters("@ESBInstanceName").Value = .sESBInstanceName
                    m_addLogRqStart.Parameters("@IsServiceDomainRequestMessage").Value = .bIsServiceDomainRequestMessage
                    m_addLogRqStart.Parameters("@IsNodeInstanceRequestMessage").Value = .bIsNodeInstanceRequestMessage

                    m_addLogRqStart.Parameters("@TransportProfile").Value = .sTransportProfile
                    m_addLogRqStart.Parameters("@TransportType").Value = .sTransportType
                    m_addLogRqStart.Parameters("@TransportUrl").Value = .sTransportUrl
                    m_addLogRqStart.Parameters("@ExecutionMode").Value = .ExecutionMode.ToString

                End If
            End With
            Dim nRows As Integer
            nRows = m_addLogRqStart.ExecuteNonQuery()
            If nRows = 0 Then
                Throw New Exception("Error - 0 rows added by MsSqlLogger")
            End If

        Catch ex As Exception
            ExceptionManager.Publish(ex)
        Finally

        End Try

    End Sub
    Public Overrides Sub LogRequestFinish(ByRef oLogDetails As Interfaces.Logging.LogDetail)
        Try
            Connect()

            With oLogDetails

                If m_oAddLogRqFinishPrepared = False Then
                    'Setup sql update statement
                    m_addLogRqFinish.Parameters.Add("@ActivityID", SqlDbType.NVarChar).Value = .sActivityID
                    m_addLogRqFinish.Parameters.Add("@Duration", SqlDbType.NVarChar).Value = .sExecutionTime
                    m_addLogRqFinish.Parameters.Add("@Status", SqlDbType.NVarChar).Value = .sStatus
                    m_addLogRqFinish.Parameters.Add("@RequestSourceHost", SqlDbType.NVarChar).Value = .sRequestSourceHost

                    'If using SQL 2005, we should have this type as an XML type to allow us to do some nice BAM stuff...
                    If m_bIsMsSql2005 Then
                        m_addLogRqFinish.Parameters.Add("@ResponseXML", SqlDbType.Xml).Value = SwitchXMLEncoding(.sXML)
                    Else
                        m_addLogRqFinish.Parameters.Add("@ResponseXML", SqlDbType.NText).Value = .sXML
                    End If

                    m_oAddLogRqFinishPrepared = True
                Else
                    m_addLogRqFinish.Parameters("@ActivityID").Value = .sActivityID
                    m_addLogRqFinish.Parameters("@Duration").Value = .sExecutionTime
                    m_addLogRqFinish.Parameters("@Status").Value = .sStatus
                    m_addLogRqFinish.Parameters("@RequestSourceHost").Value = .sRequestSourceHost

                    'If using SQL 2005, we should have this type as an XML type to allow us to do some nice BAM stuff...
                    If m_bIsMsSql2005 Then
                        m_addLogRqFinish.Parameters("@ResponseXML").Value = SwitchXMLEncoding(.sXML)
                    Else
                        m_addLogRqFinish.Parameters("@ResponseXML").Value = .sXML

                    End If
                End If

            End With
            Dim nRows As Integer
            nRows = m_addLogRqFinish.ExecuteNonQuery()
            If nRows = 0 Then
                Throw New Exception("Error - 0 rows added by MsSqlLogger")
            End If

        Catch ex As Exception
            ExceptionManager.Publish(ex)
        Finally

        End Try


    End Sub
    Protected Function SwitchXMLEncoding(ByVal sXMLin As String) As String
        Return sXMLin.Replace("utf-8", "utf-16")
    End Function
    'todo: see how this fairs...
    'not too good - crashes etc...try putting an is nothing check around Close method in Disconnect method...
    'done but not tested...so just leave for now...
    'Protected Overrides Sub Finalize()
    '    Disconnect()
    '    MyBase.Finalize()
    'End Sub
End Class

#Region "Sample XQuery"

'XQuery to get data out of the XML field in the ESBSummaryLog table...
'WITH XMLNAMESPACES (
''urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0' AS e,
''urn:schemas-biztalk-org:biztalk:BuildCmd2:BuildCmd2' as d
')

'SELECT RequestXml.query('
'/e:ESBEnvelope/e:body/e:documentBody/d:BuildCmd2/d:BuildCmdString') as Result

'FROM ESBLogSummary
'where 
'RequestXml.value
'('contains 
'	(string 
'		( 
'			(/e:ESBEnvelope/e:body/e:documentBody/d:BuildCmd2/d:BuildCmdString
'			)[1]
'		), "Hello BAM World"
'	)','bit' 
')=1
#End Region

