'''-----------------------------------------------------------------------------
''' <summary>
''' Copyright Keystroke IT 2003
''' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
''' </summary>
'''-----------------------------------------------------------------------------
Public Class MsmqLogger
    Inherits BaseLogStringLogger

    Dim m_oMsgQHeader As Messaging
    Dim m_oMsgQDetail As Messaging
    Dim m_oMsgQMetering As Messaging

    Protected m_sQueuePathName_Header As String
    Protected m_sQueuePathName_Detail As String
    Protected m_sQueuePathName_Metering As String

    Dim m_bInit As Boolean = False


    Public Sub New()
        init()
    End Sub

    Public ReadOnly Property IsInitialized() As Boolean
        Get
            Return m_bInit
        End Get
    End Property

    Protected Overridable Sub init()
        If m_bInit = False Then
            m_oMsgQHeader = New Messaging
            m_sQueuePathName_Header = System.Configuration.ConfigurationManager.AppSettings("MSMQLoggerQueuePathName_Header")
            If m_sQueuePathName_Header = "" Then
                m_sQueuePathName_Header = ".\private$\ESB." & Util.ESBGlobalVariables.ESBInstanceName & ".LogHeaderQ"
            End If

            m_oMsgQDetail = New Messaging
            m_sQueuePathName_Detail = System.Configuration.ConfigurationManager.AppSettings("MSMQLoggerQueuePathName_Detail")
            If m_sQueuePathName_Detail = "" Then
                m_sQueuePathName_Detail = ".\private$\ESB." & Util.ESBGlobalVariables.ESBInstanceName & ".LogDetailQ"
            End If

            m_oMsgQMetering = New Messaging
            m_sQueuePathName_Metering = System.Configuration.ConfigurationManager.AppSettings("MSMQLoggerQueuePathName_Metering")
            If m_sQueuePathName_Metering = "" Then
                m_sQueuePathName_Metering = ".\private$\ESB." & Util.ESBGlobalVariables.ESBInstanceName & ".ServiceMeteringQ"
            End If

            m_bInit = True
        End If
    End Sub

    Public Overrides Sub Log(ByRef sLogString As String)
        init()
        m_oMsgQDetail.AddMsgToQueueQLeaveOpen(m_sQueuePathName_Detail, sLogString)
    End Sub
    Public Overrides Sub LogRequestStart(ByRef sLogString As String)
        init()
        m_oMsgQHeader.AddMsgToQueueQLeaveOpen(m_sQueuePathName_Header, sLogString, "RequestStart")
    End Sub
    Public Overrides Sub LogRequestFinish(ByRef sLogString As String)
        init()
        m_oMsgQHeader.AddMsgToQueueQLeaveOpen(m_sQueuePathName_Header, sLogString, "RequestFinish")
    End Sub
    Public Overrides Sub LogMetering(ByRef sLogString As String)
        init()
        m_oMsgQMetering.AddMsgToQueueQLeaveOpen(m_sQueuePathName_Metering, sLogString)
    End Sub
End Class
