﻿Imports Microsoft.VisualBasic

Imports System.Messaging
Imports System.Text

Imports ESB.Core.Services.Logger

Public Class MessagingWrapper
    Private m_bLogQInit As Boolean = False
    Private m_mq As MessageQueue

    ''' <summary>
    ''' 
    ''' 
    ''' </summary>
    ''' <param name="sQPath"></param>
    ''' <param name="bLeaveOpen"></param>
    ''' <param name="nTimeout"></param>
    ''' <param name="oMsg">Out parameter - returned message in message object form</param>
    ''' <returns>message contents as a string</returns>
    ''' <remarks></remarks>
    Public Function GetNextMsgFromQueue(ByVal sQPath As String, ByRef oMsg As Message, Optional ByVal bLeaveOpen As Boolean = False, Optional ByVal nTimeout As Integer = 0) As String
        Dim msg As Message
        Dim formatter As XmlMessageFormatter

        Try
            If (Not MessageQueue.Exists(sQPath)) Then
                Throw New Exception("The queue " & sQPath & " does not exist!")
            End If
            If m_mq Is Nothing Then
                m_mq = New MessageQueue(sQPath)
                formatter = CType(m_mq.Formatter, XmlMessageFormatter)
                formatter.TargetTypeNames = New String() {"System.String,mscorlib"}
            End If

            Dim ts As New TimeSpan(0, 0, 0, 0, nTimeout)
            Try
                If nTimeout <= 0 Then
                    msg = m_mq.Receive()
                Else
                    msg = m_mq.Receive(ts)
                End If

                If Not msg Is Nothing Then
                    oMsg = msg
                    Return CStr(msg.Body())
                Else
                    oMsg = Nothing
                    Return ""
                End If

            Catch ex As MessageQueueException
                'Timeout reading from Q...
                If Not m_mq Is Nothing Then
                    m_mq.Close()
                    m_mq = Nothing
                End If
                Return ""
            Catch ex As InvalidOperationException
                ExceptionManager.Publish(ex)
                'Swallow?
                Throw
            End Try
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            'Swallow? exception for now - not sure why it's happening...
            'Losing messages if swallow...better not...
            Throw
            Return ""
        Finally
            If bLeaveOpen = False Then : If Not m_mq Is Nothing Then : m_mq.Close() : End If : End If
        End Try

    End Function

End Class
