'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Explicit On


Module RequestConstants
    Public eRequestInvocationPeriod As String = "Standard"
    Public eRequestPriority As String = "5"
End Module


Public Class ServiceActivityLogger


    Public Sub Log(ByVal oLogDetail As ESB.Core.Interfaces.Logging.LogDetail)
        'Insert into SQL DB...
        Dim oDS As New ServiceMeteringDataSet
        Dim oTA As New ServiceMeteringDataSetTableAdapters.Services_EnterprisePacks_Management_ESBServiceMeteringTableAdapter1
        Dim oDT As New ServiceMeteringDataSet.Services_EnterprisePacks_Management_ESBServiceMeteringDataTable
        Dim oDRow As ServiceMeteringDataSet.Services_EnterprisePacks_Management_ESBServiceMeteringRow


        Dim dExecutionTime As Double
        If oLogDetail.sExecutionTime = "" Then
            dExecutionTime = 0
        Else
            dExecutionTime = Double.Parse(oLogDetail.sExecutionTime)
        End If

        With oLogDetail
            oDT = oTA.GetDataByRequestParams(.sResolveName, .sContext, RequestConstants.eRequestPriority, _
                        RequestConstants.eRequestInvocationPeriod, .sMessageExchangePattern, .sComputerName, .FullyQualifiedInstanceName, _
                        .sESBServiceDomainName, .sClusterName, .bIsServiceDomainEntryPoint, .sESBInstanceName, .sChannel, .sUserName, _
                        .sTransportProfile, .sTransportType, .sTransportUrl)
        End With
        'oTA.Fill(oDT)
        If oDT.Count > 0 Then
            'Update existing row...
            oDRow = oDT(0)

            With oDRow
                'ONLY UPDATE Changes...
                .ExecutionTime += dExecutionTime
                .LastInvocation = Now
                .RequestInvocationCount += 1   'Increment this count...
                .ServiceInvocationCPUUsage += oLogDetail.tsServiceInvocationCPUUsage
            End With

        Else
            'Add New Row...
            oDRow = oDT.NewServices_EnterprisePacks_Management_ESBServiceMeteringRow

            With oDRow

                .ResolveName = oLogDetail.sResolveName
                .Context = oLogDetail.sContext
                .FirstInvocation = Now '(Should only do this if empty...) :(
                .LastInvocation = Now
                .RequestInvocationCount = 1   'First time through...
                .RequestInvocationPeriod = RequestConstants.eRequestInvocationPeriod ' "Standard" '?
                .RequestPriority = RequestConstants.eRequestPriority '"5" '?
                .MessageExchangePattern = oLogDetail.sMessageExchangePattern
                .UserName = oLogDetail.sUserName

                .Channel = oLogDetail.sChannel
                .TransportProfile = oLogDetail.sTransportProfile
                .TransportType = oLogDetail.sTransportType
                .TransportUrl = oLogDetail.sTransportUrl
                .ExecutionTime = dExecutionTime
                .ServiceInvocationCPUUsage = oLogDetail.tsServiceInvocationCPUUsage

                .host = oLogDetail.sComputerName
                .FullyQualifiedInstanceName = oLogDetail.FullyQualifiedInstanceName
                .ServiceDomainName = oLogDetail.sESBServiceDomainName
                .ClusterName = oLogDetail.sClusterName
                .IsServiceDomainEntryPoint = oLogDetail.bIsServiceDomainEntryPoint
                .ESBInstanceName = oLogDetail.sESBInstanceName

            End With

            oDT.AddServices_EnterprisePacks_Management_ESBServiceMeteringRow(oDRow)

        End If
        oTA.Update(oDT)

    End Sub

End Class

