'''-----------------------------------------------------------------------------
''' <summary>
''' Copyright Keystroke IT 2003
''' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
''' </summary>
'''-----------------------------------------------------------------------------
#Region "Imports"
Imports System
Imports System.IO
Imports System.Xml
Imports System.Xml.XPath

Imports ESB.Core.Util

#End Region


Namespace ESB.Core.Logging.AsyncLogger

    Partial Class MsmqToMsSql
        Inherits System.Web.UI.Page 'TODO: Handler...???

        Private Shared m_bGotInstanceName As Boolean = False

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub


        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region


        Private Shared m_sLogHeaderQName As String
        Private Shared m_sLogDetailQName As String
        Private Shared m_sLogMeteringQName As String
        Private Shared m_sLogDBConnectionString As String

        'DB does NOT have referential integrity for header/detail at DB level ... so we can log to table in any order...

        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        ''' <remarks></remarks>
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try

                'Ensure we only get one set of threads...otherwise things go haywire...esp. with Metering...
                If Application("Initialized") = "True" Then Return


                Dim oTimer As New Stopwatch
                oTimer.Start()

                If Not m_bGotInstanceName Then : GetInstanceName() : End If

                '10,000 ticks in 1 millisecond
                '10 ticks in 1 micro second
                oTimer.Stop()
                Dim sTime As String = String.Format("{0} Ticks = {1} microseconds = {2} milliseconds", oTimer.Elapsed.Ticks, oTimer.Elapsed.Ticks / 10, oTimer.Elapsed.Ticks / 10000)

                GetConfigSettings()


                'do in a background thread...see how this goes...
                System.Threading.ThreadPool.QueueUserWorkItem(AddressOf LogQueueMessagesToSQL_Header)
                System.Threading.ThreadPool.QueueUserWorkItem(AddressOf LogQueueMessagesToSQL_Detail)
                System.Threading.ThreadPool.QueueUserWorkItem(AddressOf LogQueueMessagesToSQL_Metering)

                Application("Initialized") = "True"
                ''Just for kicks...remove later maybe...
                'Try

                '    Dim oPerfmon As New PerfMonManager()
                '    oPerfmon.Init("AsyncLogger", m_oContext)
                '    oPerfmon.SetCounterValues(True, oTimer.ElapsedTicks)

                '    oTimer.Reset()

                'Catch ex As Exception
                '    ExceptionManager.Publish(ex)
                '    'Swallow the exception...
                'End Try

                'Response.Write(sSoapXmlResponse)

            Catch ex As Exception
                ExceptionManager.Publish(ex)
            Finally

            End Try

        End Sub

        Private Sub GetConfigSettings()

            'm_sLogHeaderQName = ".\private$\esb.source.logheaderq"   'construct from InstanceName     (Util.ESBGlobalVariables.ESBInstanceName)
            'm_sLogDetailQName = ".\private$\esb.source.logdetailq"   ' ""
            'm_sLogDBConnectionString = "Data Source=localhost\sqldev; Integrated Security=SSPI; Initial Catalog=ESBLog;"

            m_sLogHeaderQName = ".\private$\esb." & Util.ESBGlobalVariables.ESBInstanceName & ".logheaderq"
            m_sLogDetailQName = ".\private$\esb." & Util.ESBGlobalVariables.ESBInstanceName & ".logdetailq"
            m_sLogMeteringQName = ".\private$\esb." & Util.ESBGlobalVariables.ESBInstanceName & ".servicemeteringq"

            m_sLogDBConnectionString = System.Configuration.ConfigurationManager.AppSettings("MsSqlLoggerConnectionString")


        End Sub

        Private Shared Sub LogQueueMessagesToSQL_Header(ByVal stateInfo As Object)
            Dim oMsg As System.Messaging.Message = Nothing
            Dim oLogDetail As New ESB.Core.Interfaces.Logging.LogDetail
            Dim sXmlLogMsg As String = ""

            Dim oLogHeaderQ As New MessagingWrapper
            Dim oSQLLogger As New ESB.Core.Loggers.MsSqlLogger


            'Nested while/try/while, to ensure try is not done for every loop & associated overhead...
            While (1)
                Try
                    While (1)
                        'ensure 1 thread does this whole loop at a time...
                        'SyncLock (oLogDetail)

                        sXmlLogMsg = oLogHeaderQ.GetNextMsgFromQueue(m_sLogHeaderQName, oMsg, True, 1000)
                        If sXmlLogMsg <> "" Then
                            If oMsg.Label = "RequestStart" Then
                                oSQLLogger.LogRequestStart(oLogDetail.FromString(sXmlLogMsg))
                            End If

                            If oMsg.Label = "RequestFinish" Then
                                oSQLLogger.LogRequestFinish(oLogDetail.FromString(sXmlLogMsg))
                            End If
                        End If


                        If Not oMsg Is Nothing Then oMsg.Dispose()
                        'End SyncLock

                    End While

                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                End Try

            End While

        End Sub
        Private Shared Sub LogQueueMessagesToSQL_Detail(ByVal stateInfo As Object)
            Dim oMsg As System.Messaging.Message = Nothing
            Dim oLogDetail As New ESB.Core.Interfaces.Logging.LogDetail
            Dim sXmlLogMsg As String = ""

            Dim oLogDetailQ As New MessagingWrapper
            Dim oSQLLogger As New ESB.Core.Loggers.MsSqlLogger

            'Nested while/try/while, to ensure try is not done for every loop & associated overhead...
            While (1)
                Try
                    While (1)
                        sXmlLogMsg = oLogDetailQ.GetNextMsgFromQueue(m_sLogDetailQName, oMsg, True, 1000)
                        If sXmlLogMsg <> "" Then
                            oSQLLogger.Log(oLogDetail.FromString(sXmlLogMsg))
                        End If
                        If Not oMsg Is Nothing Then oMsg.Dispose()


                    End While
                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                End Try
            End While

        End Sub


        Private Shared Sub LogQueueMessagesToSQL_Metering(ByVal stateInfo As Object)
            Dim oMsg As System.Messaging.Message = Nothing
            Dim oLogDetail As New ESB.Core.Interfaces.Logging.LogDetail
            Dim sXmlLogMsg As String = ""

            Dim oLogMeteringQ As New MessagingWrapper
            Dim oServiceActivityLogger As New ServiceActivityLogger()

            'Nested while/try/while, to ensure try is not done for every loop & associated overhead...
            While (1)
                'ensure 1 thread does this whole loop at a time...
                'SyncLock (oLogDetail)
                Try
                    While (1)
                        sXmlLogMsg = oLogMeteringQ.GetNextMsgFromQueue(m_sLogMeteringQName, oMsg, True, 1000)
                        If sXmlLogMsg <> "" Then
                            oServiceActivityLogger.Log(oLogDetail.FromString(sXmlLogMsg))
                        End If
                        If Not oMsg Is Nothing Then oMsg.Dispose()
                    End While

                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                End Try

                'End SyncLock

            End While

        End Sub

        ''' <summary>
        ''' Get the Instance Name of this Transport Adaptor and write it out to the Global Variables in the Utils...
        ''' </summary>
        ''' <remarks>Only need to run this once and then cache it...</remarks>
        Private Sub GetInstanceName()
            If Not m_bGotInstanceName Then

                'Get the Query String so that we can figure out the Instance name...then cache it to the Utils.GlobalVariables...

                Dim sQueryString As String = Me.Context.Request.ApplicationPath          'Me.Context.Request.ApplicationPath
                Dim sThisInstanceName As String = Utils.GetInstanceName(Me.Context.Request.ApplicationPath) '?Request.ApplicationPath?
                Util.ESBGlobalVariables.ESBInstanceName = sThisInstanceName
                Util.ESBGlobalVariables.DnsSafeHostName = Me.Context.Request.Url.DnsSafeHost
                m_bGotInstanceName = True
            End If

        End Sub


    End Class

End Namespace
