'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Imports System.Data.SqlClient
Imports System.Security.Principal
Imports System.Web
Imports System.Web.Security
Imports System.Web.SessionState
Imports System.Text



Namespace ESB.Management.Portal

    Public Class [Global]
        Inherits System.Web.HttpApplication

#Region " Component Designer Generated Code "

        Public Sub New()
            MyBase.New()

            'This call is required by the Component Designer.
            InitializeComponent()

            'Add any initialization after the InitializeComponent() call

        End Sub

        'Required by the Component Designer
        Private components As System.ComponentModel.IContainer

        'NOTE: The following procedure is required by the Component Designer
        'It can be modified using the Component Designer.
        'Do not modify it using the code editor.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            components = New System.ComponentModel.Container()
        End Sub

#End Region

        Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)
            ' Fires when the application is started

            'Set the ESB Root Path on the ServerContextManager
            'Dim oDIESB As New System.IO.DirectoryInfo(Server.MapPath(""))
            Dim oDIESB As New System.IO.DirectoryInfo(AppDomain.CurrentDomain.BaseDirectory)

            'Go up 5 levels to the ESB Root Path... ==> now 3 levels (as of version 7.0.28.0)
            'Dim sESBRootPath As String = oDIESB.Parent.Parent.Parent.Parent.Parent.FullName '& "\"
			Dim sESBRootPath As String = oDIESB.Parent.Parent.Parent.FullName '& "\"
            ESB.Core.Util.ESBGlobalVariables.ESBRootPath = sESBRootPath
            ESB.Core.Util.ESBGlobalVariables.ComputerName = My.Computer.Name


        End Sub

        Sub Application_BeginRequest(ByVal sender As Object, ByVal e As EventArgs)
            ' Fires at the beginning of each request
            If ESB.Core.Util.ESBGlobalVariables.ESBInstanceName Is Nothing Then
                Dim sQueryString As String = Me.Context.Request.ApplicationPath
                Dim sThisInstanceName As String = Utils.GetInstanceName(sQueryString)
                ESB.Core.Util.ESBGlobalVariables.DnsSafeHostName = Me.Context.Request.Url.DnsSafeHost
                ESB.Core.Util.ESBGlobalVariables.ESBInstanceName = sThisInstanceName
                ESB.Core.Util.ESBGlobalVariables.RequestAbsoluteUri = Me.Context.Request.Url.AbsoluteUri
            End If


        End Sub

        Sub Application_AuthenticateRequest(ByVal sender As Object, ByVal e As EventArgs)
            ' Fires upon attempting to authenticate the user

            Dim app As HttpApplication = sender

            If app.Request.IsAuthenticated Then
                If (TypeOf (app.User.Identity) Is FormsIdentity) Then
                    Dim identity As FormsIdentity = app.User.Identity

                    'Find out what role (if any) the user belongs to
                    Dim role As String = GetUserRole2(identity.Name)

                    ' Create a GenericPrincipal containing the role name
                    ' and assign it to the current request
                    If Not role Is Nothing Then
                        app.Context.User = New GenericPrincipal(identity, New String() {role})
                    End If
                End If
            Else
                'Response.Redirect("~/logon/loginpage.aspx")
                Dim s As String = Request.Url.LocalPath

                'make sure all url's are lower case...
                If Request.Url.LocalPath <> Request.Url.LocalPath.ToLower And Request.Url.LocalPath.EndsWith(".aspx") Then
                    Response.Redirect(Request.Url.AbsoluteUri.ToLower)
                End If

                End If
        End Sub


        'Private Function GetUserRole(ByVal name As String) As String
        '    Dim connection As New SqlConnection("server=localhost;database=weblogin;uid=sa;pwd=password")

        '    Try
        '        connection.Open()

        '        Dim builder As New StringBuilder
        '        builder.Append("select role from users " + _
        '            "where username = '")
        '        builder.Append(name)
        '        builder.Append("'")

        '        Dim command As New SqlCommand(builder.ToString(), _
        '            connection)

        '        Dim role As Object = command.ExecuteScalar()

        '        If (TypeOf role Is DBNull) Then
        '            Return Nothing
        '        End If

        '        Return role

        '    Catch e As SqlException
        '        Return Nothing

        '    Finally
        '        connection.Close()
        '    End Try
        'End Function


        Private Function GetUserRole2(ByVal sUserName As String) As String
            Try
                Dim role As Object = Nothing
                'Authenticate to XML
                Dim MyXMLDocument As System.Xml.XmlDocument
                MyXMLDocument = New System.Xml.XmlDocument

                Dim sPath As String
                'sPath = Server.MapPath("") + "\web.config"
                'sPath = Server.MapPath("\ESBManagementPortal\") + "Logon\Users.config"
                'sPath = Server.MapPath("\ESB\Source\Manage\") + "Logon\Users.config"
                sPath = Server.MapPath(Request.ApplicationPath()) + "\Logon\Users.config"
                'sPath = "C:\Data\Downloaded\WebDevelopment\Logon\web.config"

                MyXMLDocument.Load(sPath)

                Dim MyXpath As String
                'MyXpath = "/configuration/system.web/authentication/forms/credentials/user"
                MyXpath = "/configuration/user"

                Dim MyNodeList As System.Xml.XmlNodeList
                Dim MyNode As System.Xml.XmlNode
                Dim sName As String
                Dim sRole As String

                MyNodeList = MyXMLDocument.SelectNodes(MyXpath)

                For Each MyNode In MyNodeList
                    sName = MyNode.Attributes("name").InnerXml.ToString
                    sRole = MyNode.Attributes("role").InnerXml.ToString
                    If sName = sUserName Then
                        'found user, return user's role
                        role = sRole

                        'Application("UserRole") = sRole

                        '++This results in a 'Thread was ending' or something exception
                        'when trying to do a redirect on the LogonPage...
                        'Have no idea why!!!

                        'Session("UserRole") = sRole
                        '--

                        'If Session("UserRole") Is Nothing Then
                        '    Session.Add("UserRole", sRole)
                        'Else
                        '    Session("UserRole") = sRole
                        'End If
                        'Session.Add("UserRole", sRole)

                        Exit For
                    End If
                Next

                Return role
            Catch e As Exception
                Return Nothing
            Finally
            End Try
        End Function
    End Class

End Namespace
