Imports System
Imports System.Reflection

Imports System.Text
Imports System.IO
Imports System.Xml
Imports System.Collections.Specialized
Imports ESB.Core.Util

Public Class LocallyConfiguredServices
    Dim m_oScMatchingFiles As New StringCollection()
    Dim m_oScNonMatchingFiles As New StringCollection()
    Dim m_oScAssemblies As New StringCollection()
    Dim m_oScSvcs As New StringCollection()
    Dim m_oScMessages As New StringCollection()

    'Dim m_oWriter As StringWriter

    Dim m_oWriter As StringWriterWithEncoding
    Dim m_oXmlWriter As XmlTextWriter

    Dim m_index As Integer = 0

#Region " Public Properties - N/A any more "
    Public Property MatchingFiles() As StringCollection
        Get
            Return m_oScMatchingFiles
        End Get
        Set(ByVal value As StringCollection)
            m_oScMatchingFiles = value
        End Set
    End Property
    Public Property NonMatchingFiles() As StringCollection
        Get
            Return m_oScNonMatchingFiles
        End Get
        Set(ByVal value As StringCollection)
            m_oScNonMatchingFiles = value
        End Set
    End Property
    Public Property Assemblies() As StringCollection
        Get
            Return m_oScAssemblies
        End Get
        Set(ByVal value As StringCollection)
            m_oScAssemblies = value
        End Set
    End Property
    Public Property UnconfiguredServices() As StringCollection
        Get
            Return m_oScSvcs
        End Get
        Set(ByVal value As StringCollection)
            m_oScSvcs = value
        End Set
    End Property
    Public Property Messages() As StringCollection
        Get
            Return m_oScMessages
        End Get
        Set(ByVal value As StringCollection)
            m_oScMessages = value
        End Set
    End Property
#End Region

    Public Function GetLocallyConfiguredServicesAsXml(ByVal sBasePath As String) As String


        WriteStart()
        ParseLocallyConfiguredServices(sBasePath)
        WriteEnd()

        Dim sXml As String = m_oWriter.ToString

        Return sXml

    End Function

    Private Sub WriteStart()
        'm_oWriter = New StringWriter()
        m_oWriter = New StringWriterWithEncoding(Encoding.UTF8)


        m_oXmlWriter = New XmlTextWriter(m_oWriter)
        m_oXmlWriter.Formatting = Formatting.Indented


        m_oXmlWriter.WriteStartDocument()
        m_oXmlWriter.WriteStartElement("Services", C_sServicePipelineCfg)
    End Sub

    Private Sub WriteEnd()
        m_oXmlWriter.WriteEndElement()

    End Sub

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="sBasePath"></param>
    ''' <remarks>
    '''        LobSystems\lcs
    '''                      \ctx  (when Context is specified)
    '''                          \MyFirstLcsService\Config\Lcs.MyFirstLcsService.config
    '''                 OR
    '''                      \rn   (when only Resolve Name is specified - i.e. No Context), or neither ResolveName nor Context are specified (prb. silly scenario).
    '''                          \MyFirstLcsServiceWithBlankContext(ResolveName)\Config\Lcs.MyFirstLcsServiceWithBlankContext(ResolveName).config
    ''' 
    '''</remarks>
    Private Sub ParseLocallyConfiguredServices(ByVal sBasePath As String)
        'Dim sBasePath As String = "C:\ESB\Dev\Source\ESB\LobSystems\ns"


        Dim oDi As New DirectoryInfo(sBasePath)
        Dim oFis As FileInfo() = oDi.GetFiles("*.lcs", SearchOption.AllDirectories)

        Dim oDoc As New XmlDocument
        Dim sConcatenatedLocallyConfiguredServices As String = ""

        For Each oFi As FileInfo In oFis
            'read & write into a single file...
            oDoc = New XmlDocument

            'need to get rid of: <?xml version="1.0" encoding="utf-8"?> etc.
            oDoc.LoadXml(ESB.Core.Util.File.Read(oFi.FullName))

            '  sConcatenatedLocallyConfiguredServices += ESB.Core.Util.File.Read(oFi.FullName)
            'My.Computer.FileSystem.WriteAllText(sBasePath & "\Tmp_LocallyConfiguredServicesConcat.xml", ESB.Core.Util.File.Read(oFi.FullName), True)
            m_oXmlWriter.WriteComment(oFi.FullName)
            m_oXmlWriter.WriteRaw(oDoc.DocumentElement.OuterXml)

        Next


    End Sub

    



  
End Class

'Public Class StringWriterWithEncoding : Inherits StringWriter
'    Private m_Encoding As Encoding

'    Public Sub New(ByVal encoding As Encoding)
'        m_Encoding = encoding
'    End Sub


'    Public Overrides ReadOnly Property Encoding() As System.Text.Encoding
'        Get
'            Return m_Encoding
'        End Get
'    End Property
'End Class