﻿Imports Microsoft.VisualBasic
Imports System.IO

Public Class ServiceDefinitionHelper
    Dim m_oServer As System.Web.HttpServerUtility
    Dim m_sWebSiteDnsName As String


    Public Const C_sServiceTypeConfigured As String = "Configured.Instance"
    Public Const C_sServiceTypeConfiguredLocally As String = "Configured.ServiceLocal"
    Public Const C_sServiceTypeConventionOverConfiguration As String = "Configured.Convention"
    Public Const C_sServiceDefinitionPrefix As String = ""
    'Public Const C_sServiceDefinitionPrefix As String = "ServiceDefinition."

#Region "Inputs"
    Public m_sUrlEncodedContext As String
    Public m_sServiceType As String
    Public m_sContext As String
    Public m_sResolveName As String
    Public m_sSchemaNamespace As String
    Public m_sRootElementName As String
    Public m_sServiceVersion As String
    Public m_sServiceHandler As String
    Public m_bCreateBSDLInSameDirAsLCS As Boolean = True

#End Region

#Region "BSDL_Outputs"
    Public m_sServiceDefinitionFileNameExpanded As String
#End Region

#Region "Internal"
    Protected m_sConfigurationRootPathName As String
    Protected m_sESBInstanceRootPathName As String
    Protected m_sSchemasRootPathName As String
    Protected m_sSchemasCoreRootPathName As String
    Protected m_sSchemasLobSystemsRootPathName As String

    Dim m_bInit As Boolean
    Dim m_sComponentServerAssemblyBase As String
#End Region

#Region "Constants"
    Private Const STR_ESBConventionOverConfigurationHandlerAssembliesRootPath As String = "ESB.ConventionOverConfiguration.HandlerAssembliesRootPath"
#End Region


    Public Sub New(ByVal oServer As System.Web.HttpServerUtility, Optional ByVal sWebSiteDnsName As String = "localhost")
        m_oServer = oServer
        m_sWebSiteDnsName = sWebSiteDnsName
        init()
    End Sub
    Public Sub init()
        If Not m_bInit Then
            m_sComponentServerAssemblyBase = System.Configuration.ConfigurationManager.AppSettings(STR_ESBConventionOverConfigurationHandlerAssembliesRootPath)
            m_bInit = True
        End If
    End Sub
    Public Class ConventionOverConfiguration : Inherits ServiceDefinitionHelper
        Public Sub New(ByVal oServer As System.Web.HttpServerUtility)
            MyBase.New(oServer)
        End Sub

        Public Function GetServiceDefinitionFullPath(ByVal sUrlEncodedContext As String, ByVal sServiceHandlerName As String, Optional ByVal bCreateDirectory As Boolean = False) As String
            Dim sServiceFolderName As String = sServiceHandlerName.Substring(0, sServiceHandlerName.LastIndexOf("."))
            'Dim sServiceFolderFullPathName As String = My.Computer.FileSystem.CombinePath(m_oServer.MapPath("~"), "..\..\..\..\..\" & m_sComponentServerAssemblyBase & "\" & sServiceFolderName)
            Dim sServiceFolderFullPathName As String = My.Computer.FileSystem.CombinePath(Utils.ExpandRelativePath(m_sComponentServerAssemblyBase), sServiceFolderName)
            Dim sServiceDefinitionsFolderFullPathName As String = My.Computer.FileSystem.CombinePath(sServiceFolderFullPathName, "BSDL\")

            Dim sServiceDefinitionFileName As String = "BSDL\" & C_sServiceDefinitionPrefix & sUrlEncodedContext & ".bsdl"
            Dim sServiceDefinitionFileNameExpanded As String = My.Computer.FileSystem.CombinePath(Utils.ExpandRelativePath(m_sComponentServerAssemblyBase), m_sComponentServerAssemblyBase & "\" & sServiceFolderName)
            sServiceDefinitionFileNameExpanded = My.Computer.FileSystem.CombinePath(sServiceDefinitionFileNameExpanded, sServiceDefinitionFileName)

            If Not My.Computer.FileSystem.DirectoryExists(sServiceDefinitionsFolderFullPathName) Then
                My.Computer.FileSystem.CreateDirectory(sServiceDefinitionsFolderFullPathName)
            End If

            Return sServiceDefinitionFileNameExpanded
        End Function
        Public Function GetWSDLFullPath(ByVal sServiceHandlerName As String, ByVal sRootPathName As String) As String
            Return My.Computer.FileSystem.CombinePath(sRootPathName, "BSDL\BSDLtoWSDL\Output\WSDL\" & sServiceHandlerName & ".wsdl")
        End Function
        Public Function GetWSDLRelativeIISPath(ByVal sUrlEncodedContext As String) As String
            Return "~/BSDL/BSDLtoWSDL/Output/WSDL/" & sUrlEncodedContext & ".wsdl"
        End Function
        Public Function GetServiceName(ByVal sServiceHandler As String) As String
            Return sServiceHandler.Substring(sServiceHandler.LastIndexOf(".") + 1)
        End Function
        Public Function GetServiceNamespace(ByVal sServiceHandler As String) As String
            Return sServiceHandler.Remove(sServiceHandler.LastIndexOf("."))
        End Function
    End Class

    Public Class InstanceConfigured : Inherits ServiceDefinitionHelper
        Public Sub New(ByVal oServer As System.Web.HttpServerUtility)
            MyBase.New(oServer)
        End Sub
        Public Function GetServiceDefinitionFullPath(ByVal sUrlEncodedContext As String) As String
            Dim sServiceDefinitionFileName As String = "BSDL\" & C_sServiceDefinitionPrefix & sUrlEncodedContext & ".bsdl"
            Dim sServiceDefinitionFileNameExpanded As String = My.Computer.FileSystem.CombinePath(m_oServer.MapPath("~"), "..\..\Configuration\" & sServiceDefinitionFileName)

            Return sServiceDefinitionFileNameExpanded
        End Function
        Public Function GetWSDLFullPath(ByVal sUrlEncodedContext As String, ByVal sRootPathName As String) As String
            Return My.Computer.FileSystem.CombinePath(sRootPathName, "BSDL\BSDLtoWSDL\Output\WSDL\" & sUrlEncodedContext & ".wsdl")
        End Function
        Public Function GetWSDLRelativeIISPath(ByVal sUrlEncodedContext As String) As String
            Return "~/BSDL/BSDLtoWSDL/Output/WSDL/" & sUrlEncodedContext & ".wsdl"
        End Function
        Public Function GetServiceName(ByVal sUrlEncodedContext As String) As String
            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil
            Dim oSD As ServiceDefinition.Services = oXmlUtil.DeSerialize(ESB.Core.Util.File.Read(GetServiceDefinitionFullPath(sUrlEncodedContext)), GetType(ServiceDefinition.Services))

            Return oSD.ServiceDefinition(0).Service.DistinguishedServiceName.ServiceName

            'Return sUrlEncodedContext

        End Function
        Public Function GetServiceNamespace(ByVal sUrlEncodedContext As String) As String
            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil
            Dim oSD As ServiceDefinition.Services = oXmlUtil.DeSerialize(ESB.Core.Util.File.Read(GetServiceDefinitionFullPath(sUrlEncodedContext)), GetType(ServiceDefinition.Services))

            Return oSD.ServiceDefinition(0).Service.DistinguishedServiceName.ServiceNamespace
            '            Return sUrlEncodedContext   
        End Function
    End Class

    Public Class LocallyConfigured : Inherits ServiceDefinitionHelper
        Const STR_ESBConventionOverConfiguration_LocallyConfiguredServicesRootPath As String = "ESB.ConventionOverConfiguration.LocallyConfiguredServiceRootPath"

        Public CreateBSDLInSameDirAsLCS As Boolean = True
        '"LobSystems\lcs" equivalent from config
        Dim m_LocallyConfiguredServiceRootPath_Relative As String = System.Configuration.ConfigurationManager.AppSettings(STR_ESBConventionOverConfiguration_LocallyConfiguredServicesRootPath)
        Dim m_LocallyConfiguredServiceRootPath_Absolute As String = Utils.ExpandRelativePath(m_LocallyConfiguredServiceRootPath_Relative)         'm_LocallyConfiguredServiceRootPath

        Public Sub New(ByVal oServer As System.Web.HttpServerUtility)
            MyBase.New(oServer)
        End Sub

        ''' <summary>
        ''' Generate the path for the ServiceDefinition.
        ''' </summary>
        ''' <param name="sUrlEncodedContext"></param>
        ''' <returns></returns>
        ''' <remarks>
        ''' Using the convention rules for the service definition file, generate the appropriate path.
        ''' Also looks for a LocallyConfigured pipeline file (in a particular set of paths given a specific path pattern)
        ''' and favours creation of the service definition file in the location of the LocallyConfigured pipeline file if flagged to do so.
        ''' If a BSDL file is already created, then it MUST return the EXISTING BSDL path. Only the fully extended path is checked here.
        ''' </remarks>
        Public Function GetServiceDefinitionFullPath(ByVal sUrlEncodedContext As String) As String
            'C:\ESB\Dev\Source\ESB\LobSystems\lcs\<ServiceName>.<ResolveName>
            'lcs file can be at: (as well as ResolveName variations... that are not handled by convention parent paths atm...see below code in comments...)

            '"D:\ESB\Dev\Source\ESB\LobSystems\lcs\Ctx\esb.net.services.process.workflow2\Config\Lcs.esb.net.services.process.workflow2.workflow1.step1.config"
            'or
            '"D:\ESB\Dev\Source\ESB\LobSystems\lcs\Ctx\esb.net.services.process.workflow2.workflow1\Config\Lcs.esb.net.services.process.workflow2.workflow1.step1.config"
            'or
            '"D:\ESB\Dev\Source\ESB\LobSystems\lcs\Ctx\esb.net.services.process.workflow2.workflow1.step1\Config\Lcs.esb.net.services.process.workflow2.workflow1.step1.config"
            '...

            Dim bLcsFileFound As Boolean = False

            If sUrlEncodedContext <> "" Then


                If File.Exists(m_LocallyConfiguredServiceRootPath_Absolute & "\Ctx\" & sUrlEncodedContext & "\Config\" & C_sServiceDefinitionPrefix & sUrlEncodedContext & ".bsdl") Then
                    Return m_LocallyConfiguredServiceRootPath_Absolute & "\Ctx\" & sUrlEncodedContext & "\Config\" & C_sServiceDefinitionPrefix & sUrlEncodedContext & ".bsdl"
                End If

                If CreateBSDLInSameDirAsLCS Then

                    'Go look for LCS files...!!!
                    '...and create BSDL file in the same dir as a matching .LCS file if found.
                    'Else use path below...
                    Dim sLcsPathForRequest As String = String.Empty
                    Dim bNumDirectoryLevelsToGoUp As Integer = 0
                    Dim sTempSvcName As String = sUrlEncodedContext

                    Do
                        sTempSvcName = GetParentServiceName(sUrlEncodedContext, bNumDirectoryLevelsToGoUp)
                        If sTempSvcName = "" Then
                            bLcsFileFound = False
                            Exit Do
                        End If
                        sLcsPathForRequest = GetLcsPathForRequest(sTempSvcName, sUrlEncodedContext, m_sResolveName)
                        If My.Computer.FileSystem.FileExists(ESB.Core.Util.ExpandRelativePath(sLcsPathForRequest)) Then
                            'found one - create BSDL here  in this directory...
                            bLcsFileFound = True
                            Return Path.Combine(Path.GetDirectoryName(sLcsPathForRequest), C_sServiceDefinitionPrefix & sUrlEncodedContext & ".bsdl")
                        End If
                        bNumDirectoryLevelsToGoUp += 1
                    Loop Until sLcsPathForRequest = ""    'bAllParentPathOptionsExhausted
                Else
                    Return m_LocallyConfiguredServiceRootPath_Absolute & "\Ctx\" & sUrlEncodedContext & "\Config\" & C_sServiceDefinitionPrefix & sUrlEncodedContext & ".bsdl"
                End If
            Else
                Return ""
            End If


            ''Service Definition must be at:
            ''"D:\ESB\Dev\Source\ESB\LobSystems\lcs\Ctx\esb.net.services.process.workflow2.workflow1\Config\ServiceDefinition.esb.net.services.process.workflow2.workflow1.xml"

            ''TODO:...Need to change service definition to work in same way as lcs file...


            'Dim sUrlEncodedServiceName As String = MakeValidFileName(sServiceName)
            'Dim sUrlEncodedResolveName As String = MakeValidFileName(sResolveName)

            'If sUrlEncodedServiceName = "" And sUrlEncodedResolveName = "" Then
            '    Return ESB.Core.Util.ExpandRelativePath(m_LocallyConfiguredServiceRootPath & "\rn\Config\Lcs.config")  ' Can only have one of these per ESB.NET instance...
            'End If

            'If sUrlEncodedServiceName = "" And sUrlEncodedResolveName <> "" Then
            '    Return ESB.Core.Util.ExpandRelativePath(m_LocallyConfiguredServiceRootPath & "\rn\" & sUrlEncodedResolveName & "\Config\Lcs." & sUrlEncodedResolveName & ".config")
            'End If

            'If sUrlEncodedServiceName <> "" And sUrlEncodedResolveName = "" Then
            '    Return ESB.Core.Util.ExpandRelativePath(m_LocallyConfiguredServiceRootPath & "\ctx\" & sUrlEncodedServiceName & "\Config\Lcs." & sUrlEncodedServiceName & ".config")
            'End If

            'If sUrlEncodedServiceName <> "" And sUrlEncodedResolveName <> "" Then
            '    'i.e. same as above - DO NOT take ResolveName into account here, as otherwise file paths will be a disaster!
            '    Return ESB.Core.Util.ExpandRelativePath(m_LocallyConfiguredServiceRootPath & "\ctx\" & sUrlEncodedServiceName & "\Config\Lcs." & sUrlEncodedServiceName & ".config")
            'End If

            'Throw New Exception("Error getting LcsPathForRequest: Context = " & sUrlEncodedServiceName & ". ResolveName =" & sUrlEncodedResolveName)


        End Function

        ''' <summary>
        '''sServiceName = esb.net.services.process.workflow2.workflow1.step1
        ''' Return:
        ''' esb.net.services.process.workflow2.workflow1, 
        ''' esb.net.services.process.workflow2
        ''' esb.net.services.process
        ''' ...
        ''' depending upon lNumLevels to go up
        ''' </summary>
        ''' <param name="sServiceName"></param>
        ''' <param name="lNumLevels"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Private Function GetParentServiceName(ByVal sServiceName As String, ByVal lNumLevels As Integer) As String
            Dim arrSvcNameParts() As String = sServiceName.Split(".")

            Dim sRet As String = String.Empty

            For i As Integer = 0 To arrSvcNameParts.Length - lNumLevels - 1

                If i = arrSvcNameParts.Length - lNumLevels - 1 Then
                    sRet += arrSvcNameParts(i)
                Else
                    sRet += arrSvcNameParts(i) & "."
                End If

            Next

            Return sRet

        End Function

        Public Function GetWSDLFullPath(ByVal sUrlEncodedContext As String, ByVal sRootPathName As String) As String
            Return My.Computer.FileSystem.CombinePath(sRootPathName, "BSDL\BSDLtoWSDL\Output\WSDL\" & sUrlEncodedContext & ".wsdl")
        End Function
        Public Function GetWSDLRelativeIISPath(ByVal sUrlEncodedContext As String) As String

            'If sUrlEncodedContext <> "" Then
            '    Return m_sSchemasLobSystemsRootPathName & "/Lcs/Ctx/<ServiceName>/Config/Lcs.<ServiceName>.config"
            'End If


            'or
            'Return m_sSchemasLobSystemsRootPathName & "/Lcs/Rn/<ResolveName>/Config/Lcs.<ResolveName>.config"
            'or
            'Return m_sSchemasLobSystemsRootPathName & "/Lcs/Config/Lcs.config" 'Rn & Ctx both = ""

            'issue: what DNS name do we use for this??? BSDL??? - use hostname above...

            Return "~/BSDL/BSDLtoWSDL/Output/WSDL/" & sUrlEncodedContext & ".wsdl"
        End Function
        Public Function GetServiceName(ByVal sUrlEncodedContext As String) As String
            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil
            Dim oSD As ServiceDefinition.Services = oXmlUtil.DeSerialize(ESB.Core.Util.File.Read(GetServiceDefinitionFullPath(sUrlEncodedContext)), GetType(ServiceDefinition.Services))

            Return oSD.ServiceDefinition(0).Service.DistinguishedServiceName.ServiceName
        End Function
        Public Function GetServiceNamespace(ByVal sUrlEncodedContext As String) As String
            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil
            Dim oSD As ServiceDefinition.Services = oXmlUtil.DeSerialize(ESB.Core.Util.File.Read(GetServiceDefinitionFullPath(sUrlEncodedContext)), GetType(ServiceDefinition.Services))

            Return oSD.ServiceDefinition(0).Service.DistinguishedServiceName.ServiceNamespace
        End Function
        Private Function MakeValidFileName(ByVal sFileName As String) As String
            Return System.Web.HttpUtility.UrlEncode(sFileName)
        End Function



        ''' <summary>
        '''         NOTE: This method lifted from InjectLocalConfigIntoPipeline PipelineHandler
        ''' 
        ''' </summary>
        ''' <param name="sServiceName"></param>
        ''' <param name="sResolveName"></param>
        ''' <returns></returns>
        ''' <remarks>
        '''  3.2 - When PipelineID is specified, also needs to qry same LCS config file and inject appropriate entry
        '''   3.3 - Needs different directory (slightly mod'd convention) for when a service request does not contain a Context.
        '''         i.e. for Pub-Sub scenarios where just a document (ResolveName) is specified
        '''         Use a different directory in this case.
        '''         eg.
        '''            LobSystems\lcs
        '''                      \ctx  (when Context is specified)
        '''                          \MyFirstLcsService\Config\Lcs.MyFirstLcsService.config
        '''                 OR
        '''                      \rn   (when only Resolve Name is specified - i.e. No Context), or neither ResolveName nor Context are specified (prb. silly scenario).
        '''                          \MyFirstLcsServiceWithBlankContext(ResolveName)\Config\Lcs.MyFirstLcsServiceWithBlankContext(ResolveName).config
        ''' 
        '''          In Both cases, when the PipelineID is specified, the same file will be queried, but only the single ContextEntry 
        '''          for the given PipelineID will be injected as opposed to the whole PipelineEntry.
        ''' </remarks>
        Private Function GetLcsPathForRequest(ByVal sServiceNameForDirectory As String, ByVal sServiceNameForConfigFile As String, ByVal sResolveName As String) As String
            ''  C:\ESB\Dev\Source\ESB\LobSystems\lcs\<ServiceName>.<ResolveName>
            'sServiceNameForConfigFile is the ACTUAL ServiceName
            'sServiceNameForDirectory is any parent of the ServiceName parts

            'lcs file can be at:
            '"D:\ESB\Dev\Source\ESB\LobSystems\lcs\Ctx\esb.net.services.process.workflow2\Config\Lcs.esb.net.services.process.workflow2.config"
            'or
            '"D:\ESB\Dev\Source\ESB\LobSystems\lcs\Ctx\esb.net.services.process.workflow2.workflow1\Config\Lcs.esb.net.services.process.workflow2.workflow1.config"
            'or
            '"D:\ESB\Dev\Source\ESB\LobSystems\lcs\Ctx\esb.net.services.process.workflow2.workflow1.step1\Config\Lcs.esb.net.services.process.workflow2.workflow1.step1.config"

            'Service Definition must be at:
            '"D:\ESB\Dev\Source\ESB\LobSystems\lcs\Ctx\esb.net.services.process.workflow2.workflow1\Config\ServiceDefinition.esb.net.services.process.workflow2.workflow1.xml"

            '...So we may need to recurse before calling thie method until we exhaust all possible options, only then return a failure.

            Dim sUrlEncodedServiceNameForConfigFile As String = MakeValidFileName(sServiceNameForConfigFile)
            Dim sUrlEncodedResolveName As String = MakeValidFileName(sResolveName)
            Dim sUrlEncodedServiceNameForDirectory As String = MakeValidFileName(sServiceNameForDirectory)



            If sUrlEncodedServiceNameForConfigFile = "" And sUrlEncodedResolveName = "" Then
                Return ESB.Core.Util.ExpandRelativePath(m_LocallyConfiguredServiceRootPath_Absolute & "\rn\Config\default.lcs")  ' Can only have one of these per ESB.NET instance...
            End If

            If sUrlEncodedServiceNameForConfigFile = "" And sUrlEncodedResolveName <> "" Then
                Return ESB.Core.Util.ExpandRelativePath(m_LocallyConfiguredServiceRootPath_Absolute & "\rn\" & sUrlEncodedResolveName & "\Config\" & sUrlEncodedResolveName & ".lcs")
            End If

            If sUrlEncodedServiceNameForConfigFile <> "" And sUrlEncodedResolveName = "" Then
                Return ESB.Core.Util.ExpandRelativePath(m_LocallyConfiguredServiceRootPath_Absolute & "\ctx\" & sUrlEncodedServiceNameForDirectory & "\Config\" & sUrlEncodedServiceNameForConfigFile & ".lcs")
            End If

            If sUrlEncodedServiceNameForConfigFile <> "" And sUrlEncodedResolveName <> "" Then
                'i.e. same as above - DO NOT take ResolveName into account here, as otherwise file paths will be a disaster!
                Return ESB.Core.Util.ExpandRelativePath(m_LocallyConfiguredServiceRootPath_Absolute & "\ctx\" & sUrlEncodedServiceNameForDirectory & "\Config\" & sUrlEncodedServiceNameForConfigFile & ".lcs")
            End If

            Throw New Exception("Error getting LcsPathForRequest: Context = " & sUrlEncodedServiceNameForConfigFile & ". ResolveName =" & sUrlEncodedResolveName)

        End Function

    End Class

    Public Sub CreateServiceDefinitionFile()

        Dim sa() As String = Split(m_sResolveName, "::", 2)
        If sa.GetLength(0) > 0 Then m_sRootElementName = sa(0)
        If sa.GetLength(0) > 1 Then m_sSchemaNamespace = sa(1)

        If C_sServiceTypeConventionOverConfiguration = m_sServiceType Then
            Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.ConventionOverConfiguration(m_oServer)
            m_sServiceDefinitionFileNameExpanded = oServiceDefinitionHelper.GetServiceDefinitionFullPath(m_sUrlEncodedContext, m_sServiceHandler, True)
        ElseIf C_sServiceTypeConfigured = m_sServiceType Then
            'assume configured/virtualized service
            Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.InstanceConfigured(m_oServer)
            m_sServiceDefinitionFileNameExpanded = oServiceDefinitionHelper.GetServiceDefinitionFullPath(m_sUrlEncodedContext)
        ElseIf C_sServiceTypeConfiguredLocally = m_sServiceType Then
            Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.LocallyConfigured(m_oServer)
            oServiceDefinitionHelper.CreateBSDLInSameDirAsLCS = m_bCreateBSDLInSameDirAsLCS
            m_sServiceDefinitionFileNameExpanded = oServiceDefinitionHelper.GetServiceDefinitionFullPath(m_sUrlEncodedContext)
        Else
            Throw New Exception(m_sServiceType & ": Unknown Service Type")
        End If

        Dim oFi As New FileInfo(m_sServiceDefinitionFileNameExpanded)
        If Not oFi.Exists Then
            'Create the file...& folder...
            Try
                Dim oDi As New DirectoryInfo(m_sServiceDefinitionFileNameExpanded)
                oDi.Parent.Create()

                ESB.Core.Util.File.Write(m_sServiceDefinitionFileNameExpanded, GetServiceDefinitionXML())
            Catch ex As Exception
                Throw ex
            End Try
        End If

    End Sub
    Protected Function GetServiceDefinitionXML() As String
        'AlwaysExecute Services do not have these values set.
        If m_sUrlEncodedContext = "" Then
            Return "<z>z</z>"
        Else
            Dim sd As String

            Dim oSvcs As New ServiceDefinition.Services
            Dim oSd As New ServiceDefinition.ServiceDefinition()
            oSd.Service.ServiceProviderName = "Keystroke IT Australia"

            If C_sServiceTypeConventionOverConfiguration = m_sServiceType Then
                'Convention
                oSd.Service.DistinguishedServiceName.ServiceName = m_sServiceHandler
                oSd.Service.DistinguishedServiceName.ServiceVersion = m_sServiceVersion
            Else
                'Configured/Virtualized
                oSd.Service.DistinguishedServiceName.ServiceName = m_sContext
            End If

            Dim oDoc As New ServiceDefinition.Document()
            oDoc.Schema.Name = m_sRootElementName
            oDoc.Schema.Namespace = m_sSchemaNamespace
            oSd.Service.Request.Document.Add(oDoc)

            oSvcs.ServiceDefinition.Add(oSd)

            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil
            sd = oXmlUtil.Serialize(oSvcs)

            Return sd
        End If

    End Function

    Private Sub InitPaths()
        m_sConfigurationRootPathName = My.Computer.FileSystem.CombinePath(m_oServer.MapPath("~"), "..\..\Configuration\")
        'm_sSchemasRootPathName = My.Computer.FileSystem.CombinePath(m_oServer.MapPath("~"), "..\..\XMLSchemas\")
        m_sESBInstanceRootPathName = "http://" & m_sWebSiteDnsName & "/ESB/" & ESB.Core.Util.ESBGlobalVariables.ESBInstanceName
        m_sSchemasRootPathName = m_sESBInstanceRootPathName & "/Manage/XMLSchemas"
        m_sSchemasCoreRootPathName = m_sSchemasRootPathName & "/ESB.Core.XmlSchemas"
        m_sSchemasLobSystemsRootPathName = m_sESBInstanceRootPathName & "/LobSystems"

    
    End Sub

    ''' <summary>
    ''' Create a WSDL Given a Services BSDL
    ''' Use the Session Parameters to determine BSDL file path.
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function CreateWSDLFile() As WSDL
        'm_sFileNameExpanded
        Dim sServiceName As String
        Dim sServiceNamespace As String
        Dim sWSDLOutputFileNameRelativePathIIS As String
        Dim sWSDLOutputFileName As String

        InitPaths()

        Dim sa() As String = Split(m_sResolveName, "::", 2)
        If sa.GetLength(0) > 0 Then m_sRootElementName = sa(0)
        If sa.GetLength(0) > 1 Then m_sSchemaNamespace = sa(1)

        If C_sServiceTypeConventionOverConfiguration = m_sServiceType Then
            Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.ConventionOverConfiguration(m_oServer)
            m_sServiceDefinitionFileNameExpanded = oServiceDefinitionHelper.GetServiceDefinitionFullPath(m_sUrlEncodedContext, m_sServiceHandler, False)
        ElseIf C_sServiceTypeConfiguredLocally = m_sServiceType Then
            'assume configured/virtualized service
            Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.LocallyConfigured(m_oServer)
            m_sServiceDefinitionFileNameExpanded = oServiceDefinitionHelper.GetServiceDefinitionFullPath(m_sUrlEncodedContext)

        ElseIf C_sServiceTypeConfigured = m_sServiceType Then
            Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.InstanceConfigured(m_oServer)
            m_sServiceDefinitionFileNameExpanded = oServiceDefinitionHelper.GetServiceDefinitionFullPath(m_sUrlEncodedContext)

        End If

        If C_sServiceTypeConventionOverConfiguration = m_sServiceType Then
            'Convention Over Configuration based service
            Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.ConventionOverConfiguration(m_oServer)
            sWSDLOutputFileName = oServiceDefinitionHelper.GetWSDLFullPath(m_sServiceHandler, m_sConfigurationRootPathName)
            sWSDLOutputFileNameRelativePathIIS = oServiceDefinitionHelper.GetWSDLRelativeIISPath(m_sUrlEncodedContext)
            sServiceName = oServiceDefinitionHelper.GetServiceName(m_sServiceHandler)
            sServiceNamespace = oServiceDefinitionHelper.GetServiceNamespace(m_sServiceHandler)

        ElseIf C_sServiceTypeConfiguredLocally = m_sServiceType Then
            'assume configured/virtualized service
            Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.LocallyConfigured(m_oServer)
            sWSDLOutputFileName = oServiceDefinitionHelper.GetWSDLFullPath(m_sUrlEncodedContext, m_sConfigurationRootPathName)
            sWSDLOutputFileNameRelativePathIIS = oServiceDefinitionHelper.GetWSDLRelativeIISPath(m_sUrlEncodedContext)
            sServiceName = oServiceDefinitionHelper.GetServiceName(m_sUrlEncodedContext)
            sServiceNamespace = oServiceDefinitionHelper.GetServiceNamespace(m_sUrlEncodedContext)

        ElseIf C_sServiceTypeConfigured = m_sServiceType Then

            'assume configured/virtualized service
            Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.InstanceConfigured(m_oServer)
            sWSDLOutputFileName = oServiceDefinitionHelper.GetWSDLFullPath(m_sUrlEncodedContext, m_sConfigurationRootPathName)
            sWSDLOutputFileNameRelativePathIIS = oServiceDefinitionHelper.GetWSDLRelativeIISPath(m_sUrlEncodedContext)
            sServiceName = oServiceDefinitionHelper.GetServiceName(m_sUrlEncodedContext)
            sServiceNamespace = oServiceDefinitionHelper.GetServiceNamespace(m_sUrlEncodedContext)
        End If

        'bin\Transform.exe -t input\Xml\dummy.xml  %1 >output\Temp\MergedServiceDefinitions.xml
        'bin\Transform.exe -t output\Temp\MergedServiceDefinitions.xml  Xslt\TransformMergedServiceDefinitionsToWsdl.xslt >%2  serviceName=%3 serviceNamespace=%4 serviceEndpoint=%5

        'Need to copy BSDL service definition to:
        File.WriteAllText(My.Computer.FileSystem.CombinePath(m_sConfigurationRootPathName, "BSDL\BSDLtoWSDL\Input\BSDL\ServiceDefinition.xml"), File.ReadAllText(m_sServiceDefinitionFileNameExpanded))

        'Don't do this - need consistency between CoC & Virtualized/Configured services...
        'Dim sWsdlServiceVersion As String = m_sServiceVersion
        'If sWsdlServiceVersion <> "" Then sWsdlServiceVersion = "." & sWsdlServiceVersion

        Dim sWsdlServiceNameAndVersion As String = sServiceName & m_sServiceVersion

        If sServiceNamespace = "" Or sWsdlServiceNameAndVersion = "" Then
            Throw New Exception("sServiceNamespace=" & sServiceNamespace & "; sWsdlServiceNameAndVersion=" & sWsdlServiceNameAndVersion)
        End If

        'Tool Friendly
        Dim sCmd As String = "bin\Transform.exe input\Xml\dummy.xml  Xslt\MergeSingleServiceDefinition.xslt >output\Temp\MergedServiceDefinitions.xml" & vbNewLine & _
                             "bin\Transform.exe output\Temp\MergedServiceDefinitions.xml  Xslt\TransformMergedServiceDefinitionsToWsdl_ToolFriendlyWsdl.xslt >" & "Output\WSDL\" & m_sUrlEncodedContext & ".wsdl" & " " & _
                                    "serviceEndpoint=http://" & m_sWebSiteDnsName & "/ESB/" & ESB.Core.Util.ESBGlobalVariables.ESBInstanceName & "/CoreInternetTransportAdaptors/Wse3/ESBHTTPGenericWebServiceTransport_TF.asmx " & _
                                    "serviceName=" & sWsdlServiceNameAndVersion & " " & _
                                    "serviceNamespace=" & sServiceNamespace & " " & _
                                    "esbEnvelopeSchemaLocation=" & m_sSchemasCoreRootPathName & "/ESBEnvelope/1.0.7/ESBEnvelope.xsd" & " " & _
                                    "esbErrorDocSchemaLocation=" & m_sSchemasCoreRootPathName & "/ErrorXML/1.0.0/ErrorXML.xsd" & " " & _
                                    "esbSchemaLobSystemsLocationRoot=" & m_sSchemasLobSystemsRootPathName & " " & _
                                    "esbInstanceLocationRoot=" & m_sESBInstanceRootPathName & "/"


        Dim oSI As New System.Diagnostics.ProcessStartInfo()
        oSI.CreateNoWindow = True
        oSI.FileName = My.Computer.FileSystem.CombinePath(m_sConfigurationRootPathName, "BSDL\BSDLtoWSDL\DoTransformX.cmd")

        oSI.WorkingDirectory = My.Computer.FileSystem.CombinePath(m_sConfigurationRootPathName, "BSDL\BSDLtoWSDL\")



        File.WriteAllText(oSI.FileName, sCmd)
        Dim oProcess As System.Diagnostics.Process = System.Diagnostics.Process.Start(oSI)
        'Wait 15 seconds for XSLT to complete, then timeout...
        oProcess.WaitForExit(15000)



        Dim oWsdl As New WSDL
        oWsdl.m_oOutputs.sServiceName = sServiceName
        oWsdl.m_oOutputs.sServiceNamespace = sServiceNamespace
        oWsdl.m_oOutputs.sWSDLOutputFileName = sWSDLOutputFileName
        oWsdl.m_oOutputs.sWSDLOutputFileNameRelativePathIIS = sWSDLOutputFileNameRelativePathIIS

        Return oWsdl
    End Function

    Class BSDL
        Public m_oInputs As New BSDL.Inputs
        Public m_oOutputs As New BSDL.Outputs

        Class Inputs
            Public m_sUrlEncodedContext As String
            Public m_sServiceType As String
            Public m_sContext As String
            Public m_sResolveName As String
            Public m_sSchemaNamespace As String
            Public m_sRootElementName As String
            Public m_sServiceVersion As String
            Public m_sServiceHandler As String
        End Class

        Class Outputs
            Public m_sServiceDefinitionFileNameExpanded As String
        End Class
    End Class

    Class WSDL
        Public m_oInputs As New WSDL.Inputs
        Public m_oOutputs As New WSDL.Outputs

        Class Inputs
            Public m_sUrlEncodedContext As String
            Public m_sServiceType As String
            Public m_sContext As String
            Public m_sResolveName As String
            Public m_sSchemaNamespace As String
            Public m_sRootElementName As String
            Public m_sServiceVersion As String
            Public m_sServiceHandler As String
        End Class

        Class Outputs
            Public sWSDLOutputFileName As String
            Public sWSDLOutputFileNameRelativePathIIS As String
            Public sServiceName As String
            Public sServiceNamespace As String
        End Class
    End Class
End Class
