Imports System
Imports System.Reflection

Imports System.Text
Imports System.IO
Imports System.Xml
Imports System.Collections.Specialized
Imports ESB.Core.Util

Public Class UnconfiguredServices
    Private Const STR_ServiceDefinitionFileExtension As String = ".bsdl"
    Dim m_oScMatchingFiles As New StringCollection()
    Dim m_oScNonMatchingFiles As New StringCollection()
    Dim m_oScAssemblies As New StringCollection()
    Dim m_oScSvcs As New StringCollection()
    Dim m_oScMessages As New StringCollection()

    'Dim m_oWriter As StringWriter
    Dim m_oWriter As StringWriterWithEncoding

    Dim m_oXmlWriter As XmlTextWriter

    Dim m_index As Integer = 0
#Region " Public Properties - N/A any more "
    Public Property MatchingFiles() As StringCollection
        Get
            Return m_oScMatchingFiles
        End Get
        Set(ByVal value As StringCollection)
            m_oScMatchingFiles = value
        End Set
    End Property
    Public Property NonMatchingFiles() As StringCollection
        Get
            Return m_oScNonMatchingFiles
        End Get
        Set(ByVal value As StringCollection)
            m_oScNonMatchingFiles = value
        End Set
    End Property
    Public Property Assemblies() As StringCollection
        Get
            Return m_oScAssemblies
        End Get
        Set(ByVal value As StringCollection)
            m_oScAssemblies = value
        End Set
    End Property
    Public Property UnconfiguredServices() As StringCollection
        Get
            Return m_oScSvcs
        End Get
        Set(ByVal value As StringCollection)
            m_oScSvcs = value
        End Set
    End Property
    Public Property Messages() As StringCollection
        Get
            Return m_oScMessages
        End Get
        Set(ByVal value As StringCollection)
            m_oScMessages = value
        End Set
    End Property
#End Region

    Public Function GetUnconfiguredServicesAsXml(ByVal sBasePath As String) As String


        WriteStart()
        ParseUnconfiguredServices(sBasePath)
        WriteEnd()
        Dim sXml As String = m_oWriter.ToString

        Return sXml

    End Function

    Private Sub WriteStart()
        'm_oWriter = New StringWriter()
        m_oWriter = New StringWriterWithEncoding(Encoding.UTF8)

        m_oXmlWriter = New XmlTextWriter(m_oWriter)
        m_oXmlWriter.Formatting = Formatting.Indented

        m_oXmlWriter.WriteStartDocument()
        m_oXmlWriter.WriteStartElement("Services", C_sServicePipelineCfg)
    End Sub

    Private Sub WriteEnd()
        m_oXmlWriter.WriteEndElement()

    End Sub

    Private Sub ParseUnconfiguredServices(ByVal sBasePath As String)
        'Dim sBasePath As String = "C:\ESB\Dev\Source\ESB\LobSystems\ns"
        Dim oDi As New DirectoryInfo(sBasePath)
        Dim oDi2s As DirectoryInfo() = oDi.GetDirectories()

        Dim sFilename As String

        For Each odi3 As DirectoryInfo In oDi2s
            sFilename = sBasePath & "\" & odi3.Name & "\bin\" & odi3.Name & ".dll"
            Dim oFi As New FileInfo(sFilename)
            If oFi.Exists Then
                'Files that DO match directory and filename criteria
                m_oScMatchingFiles.Add(sBasePath & "\" & odi3.Name & "\bin\" & odi3.Name & ".dll")
                'Generate XML for each one...
            Else
                'Files that DO NOT match directory and filename criteria
                m_oScNonMatchingFiles.Add(sBasePath & "\" & odi3.Name & "\bin\" & odi3.Name & ".dll")
            End If

        Next
        'Generate XML for each one...
        ProcessAssembliesWithCompliantServices(m_oScMatchingFiles, m_oScAssemblies, m_oScSvcs)

    End Sub

    Private Sub ProcessAssembliesWithCompliantServices(ByVal oScAllFiles As StringCollection, ByVal oScAssembliesWithServices As StringCollection, ByRef oScServices As StringCollection)
        For Each s As String In oScAllFiles
            Dim osc As StringCollection
            osc = GetAssemblyClasses(s)
            If Not osc Is Nothing Then
                'add to ass with svcs files col,...
                oScAssembliesWithServices.Add(s)
                For Each str As String In osc
                    oScServices.Add(str)
                Next
            End If
        Next

    End Sub

    Private Function GetAssemblyClasses(ByVal sAssemblyFilepath As String) As StringCollection
        ' This variable holds the amount of indenting that 
        ' should be used when displaying each line of information.
        Dim oScServices As New StringCollection



        Dim indent As Int32 = 0
        Dim a As [Assembly] = System.Reflection.Assembly.LoadFrom(sAssemblyFilepath)
        Display(indent, "Assembly identity={0}", a.FullName)
        Display(indent + 1, "Codebase={0}", a.CodeBase)

        ' Display information about each class
        Dim t As Type
        indent += 1
        Try
            For Each t In a.GetTypes()
                ' For each class, show its members & their custom attributes.
                indent += 1
                DisplayAttributes(indent, t, sAssemblyFilepath, oScServices)
                indent -= 1

            Next
        Catch ex As Exception
            indent += 1
            DisplayAttributes(indent, GetType(Exception), "Error getting assembly attributes for:" & sAssemblyFilepath, oScServices)
            indent -= 1
            'TODO: Add an error here to show in the services list...
        End Try
        indent -= 1
        Return oScServices
    End Function

    ' Displays the custom attributes applied to the specified member.
    Private Function DisplayAttributes(ByVal indent As Int32, ByVal t As Type, ByVal sAssemblyFilepath As String, ByRef oScServices As StringCollection) As Boolean
        Dim attr As Attribute
        Dim attrSvc As Attribute
        Dim attrSvcVersion As ESB.Core.Util.Attributes.ServiceVersionAttribute
        Dim sServiceVersion As String

        For Each attrSvc In t.GetCustomAttributes(GetType(ESB.Core.Util.Attributes.ServiceAttribute), False)
            sServiceVersion = ""
            If TypeOf attrSvc Is ESB.Core.Util.Attributes.ServiceAttribute Then
                m_oXmlWriter.WriteStartElement("ServiceData", C_sServicePipelineCfg)

                For Each attrSvcVersion In t.GetCustomAttributes(GetType(ESB.Core.Util.Attributes.ServiceVersionAttribute), False)
                    If TypeOf attrSvcVersion Is ESB.Core.Util.Attributes.ServiceVersionAttribute Then
                        sServiceVersion = attrSvcVersion.ServiceVersion
                    End If
                Next

                Dim sServiceDefinitionDirectory As String

                For Each attr In t.GetCustomAttributes(GetType(ESB.Core.Util.Attributes.DocumentsAttribute), False)
                    If TypeOf attr Is ESB.Core.Util.Attributes.DocumentsAttribute Then
                        m_index += 1

                        Display(indent, "Type: {0}", t)
                        Dim sDoc As String = DirectCast(attr, ESB.Core.Util.Attributes.DocumentsAttribute).RequestDocumentRootElementName & "::" & DirectCast(attr, ESB.Core.Util.Attributes.DocumentsAttribute).RequestDocumentNamespace
                        Display(indent + 2, "{0}", sDoc)
                        oScServices.Add("Service=" & t.ToString & "; Document=" & sDoc)

                        m_oXmlWriter.WriteAttributeString("Index", "C" & m_index)
                        m_oXmlWriter.WriteAttributeString("Context", t.ToString & sServiceVersion)
                        m_oXmlWriter.WriteAttributeString("ResolveName", sDoc)
                        m_oXmlWriter.WriteAttributeString("AlwaysExecute", 0)
                        m_oXmlWriter.WriteAttributeString("ServiceVersion", sServiceVersion)
                        m_oXmlWriter.WriteAttributeString("Layer", "Vertical")
                        m_oXmlWriter.WriteAttributeString("UrlEncodedContext", t.ToString & sServiceVersion)
                        m_oXmlWriter.WriteAttributeString("ServiceHandler", t.ToString)

                        sServiceDefinitionDirectory = My.Computer.FileSystem.GetParentPath(My.Computer.FileSystem.GetParentPath(sAssemblyFilepath))
                        m_oXmlWriter.WriteAttributeString("ServiceDefinition", sServiceDefinitionDirectory & "\ServiceDefinition." & t.ToString & sServiceVersion & STR_ServiceDefinitionFileExtension)
                        m_oXmlWriter.WriteAttributeString("ServiceType", "Configured.Convention")


                    End If
                Next

                m_oXmlWriter.WriteEndElement()
                Return True
            End If
        Next

        Return False
    End Function

    ' Display a formatted string indented by the specified amount.
    Sub Display(ByVal indent As Int32, ByVal format As String, ByVal ParamArray params() As Object)

        m_oScMessages.Add(New String(" "c, indent * 2))
        Dim s As String
        s = String.Format(format, params)

        m_oScMessages.Add(s + vbNewLine)
    End Sub

    Public Function StringCollectionToString(ByVal oSc As StringCollection) As String
        'Dim s As String
        Dim sb As New StringBuilder
        For Each S1 As String In oSc
            sb.Append(S1)

            's += S1
        Next
        Return sb.ToString
    End Function


End Class

