'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Imports Microsoft.ApplicationBlocks.ConfigurationManagement
Imports ESB.Core.Services.Server
Imports System.Collections.Generic

Imports System.Web.Configuration

Namespace ESB.Management.Portal

    Partial Class LoggingDevices
        Inherits System.Web.UI.Page

        Dim m_oCfgDataServicesServer As ESB.Core.Services.Server.CustomConfigurationData.CustomConfigurationData
        Dim m_ As String
        Dim m_File As String

        Shared s_sSystemEntryPointMatchName As String


#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load, Me.Load
            m_ = Request.Params("")

            m_File = Utils.ExpandRelativePath("Base/Configuration/XMLConfigFiles/" & m_ & ".config")

            GetConfigData()

            'only do this the first time...
            If Not IsPostBack Then
                'Label1.Text += " (" & m_ & ")"
                Label1.Text = "Logging Devices (" & m_ & ")"

                ReadLoggingSettingsFromConfig()
            End If

        End Sub

        Private Sub ReadLoggingSettingsFromConfig()

            Dim lIndex As Integer = -1
            Dim lLogLevel As Integer = -1

            txtQueuePathName.Text = System.Configuration.ConfigurationManager.AppSettings(C_sLoggingValue_QueuePathName_Detail)
            'txtQueuePathName_Header.Text = System.Configuration.ConfigurationManager.AppSettings(C_sLoggingValue_QueuePathName_Header)

            'Dim oCustom As ESB.Core.Services.Server.CustomConfigurationData.Custom

            'oCustom = oSep.Custom.Find(AddressOf FindMSMQCustomParam_LogQueuePathNameMatch)
            'txtQueuePathName.Text = oCustom.ParamValue

            SetLoggerCheckBox()
            SetSystemEntryPointsCheckBox()

        End Sub

        ''' <summary>
        ''' Populate Loggers CheckBox list from Config
        ''' </summary>
        ''' <remarks></remarks>
        Private Sub SetLoggerCheckBox()
            chkServerLogDevices.Items.Clear()

            For Each oLogger As CustomConfigurationData.Logger In m_oCfgDataServicesServer.ServerLogManager.RegisteredLoggers
                Dim oListItem As New Web.UI.WebControls.ListItem
                oListItem.Text = oLogger.ObjectName
                'oListItem.Attributes.Add("AssemblyPath", oLogger.AssemblyPath.ToString)
                oListItem.Value = oLogger.AssemblyPath


                oListItem.Selected = oLogger.Enabled
                chkServerLogDevices.Items.Add(oListItem)
            Next
        End Sub

        Private Sub UpdateLoggersFromLoggerCheckBox()

            m_oCfgDataServicesServer.ServerLogManager.RegisteredLoggers.Clear()

            Dim oLogger As CustomConfigurationData.Logger
            For Each oListItem As Web.UI.WebControls.ListItem In chkServerLogDevices.Items
                oLogger = New CustomConfigurationData.Logger
                oLogger.Enabled = oListItem.Selected
                oLogger.ObjectName = oListItem.Text
                oLogger.AssemblyPath = oListItem.Value
                'oLogger.AssemblyPath = oListItem.Attributes("AssemblyPath").ToString
                m_oCfgDataServicesServer.ServerLogManager.RegisteredLoggers.Add(oLogger)
            Next
        End Sub

        ''' <summary>
        ''' Populate Loggers CheckBox list from Config
        ''' </summary>
        ''' <remarks></remarks>
        Private Sub SetSystemEntryPointsCheckBox()
            chkSystemEntryPoints.Items.Clear()

            For Each oSep As CustomConfigurationData.SystemEntryPoint In m_oCfgDataServicesServer.SystemEntryPointManager
                Dim oListItem As New Web.UI.WebControls.ListItem
                oListItem.Text = oSep.name

                'Attributes not working! Hack it and set the Value field...
                'oListItem.Attributes.Add("AssemblyPath", oLogger.AssemblyPath.ToString)
                oListItem.Value = oSep.AssemblyPath
                oListItem.Selected = oSep.enabled
                chkSystemEntryPoints.Items.Add(oListItem)
            Next
        End Sub

        Private Sub UpdateSystemEntryPointsCheckBox()

            'm_oCfgDataServicesServer.ServerLogManager.RegisteredLoggers.Clear()

            Dim oSep As CustomConfigurationData.SystemEntryPoint
            For Each oListItem As Web.UI.WebControls.ListItem In chkSystemEntryPoints.Items
                s_sSystemEntryPointMatchName = oListItem.Text
                oSep = m_oCfgDataServicesServer.SystemEntryPointManager.Find(AddressOf FindSystemEntryPointByNameMatch)
                oSep.enabled = oListItem.Selected
            Next
        End Sub


        Private Shared Function FindMSMQSystemEntryPointMatch(ByVal oSep As ESB.Core.Services.Server.CustomConfigurationData.SystemEntryPoint) As Boolean
            If oSep.name = "MSMQSystemEntryPoint" Then
                Return True
            Else
                Return False
            End If
        End Function
        Private Shared Function FindMSMQCustomParam_LogQueuePathNameMatch(ByVal oCustom As ESB.Core.Services.Server.CustomConfigurationData.Custom) As Boolean
            If oCustom.ParamName = C_sLoggingValue_QueuePathName_Detail Then
                Return True
            Else
                Return False
            End If
        End Function
        Private Shared Function FindMSSqlSystemEntryPointMatch(ByVal oSep As ESB.Core.Services.Server.CustomConfigurationData.SystemEntryPoint) As Boolean
            If oSep.name = "MSSqlSystemEntryPoint" Then
                Return True
            Else
                Return False
            End If
        End Function

        Private Shared Function FindSystemEntryPointByNameMatch(ByVal oSep As ESB.Core.Services.Server.CustomConfigurationData.SystemEntryPoint) As Boolean
            If oSep.name = s_sSystemEntryPointMatchName Then
                Return True
            Else
                Return False
            End If
        End Function


        Private Sub btnUpdateSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdateSettings.Click

            System.Configuration.ConfigurationManager.AppSettings.Set(C_sLoggingValue_QueuePathName_Detail, txtQueuePathName.Text)

            Dim cfg As System.Configuration.Configuration
            cfg = WebConfigurationManager.OpenWebConfiguration("~")

            Dim setting As KeyValueConfigurationElement = CType(cfg.AppSettings.Settings(C_sLoggingValue_QueuePathName_Detail), KeyValueConfigurationElement)

            If Not setting Is Nothing Then
                setting.Value = txtQueuePathName.Text
                cfg.Save()
            End If

            UpdateLoggersFromLoggerCheckBox()
            UpdateSystemEntryPointsCheckBox()

            SaveConfigData()

        End Sub


        'Replace these methods with something that can handle multiple files of the same format...
        'i.e. just a file read & deserialize...
        'Don't really need? to protect from concurrent access, as only one Management Console will write to the file t  time
        'The server does not write to the file - just reads...
        Public Sub GetConfigData()
            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil
            Dim oXmlDoc As New System.Xml.XmlDocument
            oXmlDoc.Load(m_File)

            m_oCfgDataServicesServer = oXmlUtil.DeSerialize(oXmlDoc.DocumentElement.ChildNodes(0).ChildNodes(0).OuterXml, GetType(CustomConfigurationData.CustomConfigurationData))

            If m_oCfgDataServicesServer Is Nothing Then
                Throw New ApplicationException("no config on provider.")
            End If
        End Sub
        Public Overridable Sub SaveConfigData()
            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil

            '++Write the changes
            Dim oXmlWriter As New System.Xml.XmlTextWriter(m_File, System.Text.Encoding.UTF8)
            oXmlWriter.WriteStartDocument()
            oXmlWriter.WriteStartElement("configuration")
            oXmlWriter.WriteStartElement("ESB.Core.Services.Server")

            Dim oXmlDoc As New System.Xml.XmlDocument()
            oXmlDoc.LoadXml(oXmlUtil.Serialize(m_oCfgDataServicesServer))

            oXmlWriter.WriteRaw(oXmlDoc.DocumentElement.OuterXml())
            oXmlWriter.WriteEndElement()
            oXmlWriter.WriteEndElement()
            oXmlWriter.WriteEndDocument()
            oXmlWriter.Flush()
            oXmlWriter.Close()

            '--Write the changes

            '++Read file contents, indent XML then save...
            My.Computer.FileSystem.WriteAllText(m_File, oXmlUtil.PrettyFormatXML(My.Computer.FileSystem.ReadAllText(m_File)), False)


        End Sub

    End Class

End Namespace
