'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Imports System.Globalization
Imports Microsoft.ApplicationBlocks.ConfigurationManagement
Imports ESB.Core.Services.Server



Namespace ESB.Management.Portal

    Partial Class SetLoggingLevels
        Inherits System.Web.UI.Page
        Protected WithEvents Button1 As System.Web.UI.WebControls.Button

        Dim m_oCfgDataServicesServer As ESB.Core.Services.Server.CustomConfigurationData.CustomConfigurationData
        Dim m_ As String
        Dim m_File As String


#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            m_ = Request.Params("")
            m_File = Utils.ExpandRelativePath("Base/Configuration/XMLConfigFiles/" & m_ & ".config")

            GetConfigData()
            If Not IsPostBack Then
                InitCheckBoxList()
                LabelHeading.Text = "Logging Levels (" & m_ & ")"
            End If

        End Sub

        Private Sub btnUpdateLoggingLevels_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdateLoggingLevels.Click
            Dim oChkBox As ListItem


            Dim i As Long = 0
            Dim lEnumValue As Long
            Dim lTotalEnumValues As Int32

            Dim sEnumName As String
            Dim sChkBoxName As String


            For Each oChkBox In chkLoggingLevels.Items
                'chkChkBox = oChkBox
                If oChkBox.Selected Then
                    sChkBoxName = oChkBox.Text()

                    'Try & get the value of the enum with the name = sEnumName (= Checkbox name)
                    For Each sEnumName In LogDefs.eLogLevel.GetNames(GetType(LogDefs.eLogLevel))
                        If sEnumName = sChkBoxName Then
                            lEnumValue = LogDefs.eLogLevel.Parse(GetType(LogDefs.eLogLevel), sEnumName)
                            lTotalEnumValues += lEnumValue
                        End If
                    Next
                End If

            Next

            txtLogLevel.Text = String.Format("0x{0,8:X8}", lTotalEnumValues)

            'update the Log mask in config
            m_oCfgDataServicesServer.ServerLogManager.LogMask = lTotalEnumValues
            SaveConfigData() 'save to file...

        End Sub

        Private Sub InitCheckBoxList()
            Dim sEnumName As String

            If chkLoggingLevels.Items.Count = 0 Then

                'chkLoggingLevels.Items.Clear()
                'look at:
                ''            You can just set the datasource of the checkbox list to
                '          oItem.GetNames(GetType(LogDefs.eLogLevel))



                For Each sEnumName In LogDefs.eLogLevel.GetNames(GetType(LogDefs.eLogLevel))
                    chkLoggingLevels.Items.Add(sEnumName)
                Next
                chkLoggingLevels.Items(0).Selected = True
                chkLoggingLevels.Items(1).Selected = True
                chkLoggingLevels.Items(2).Selected = True

                ReadLoggingSettingsFromConfig()

            End If
        End Sub

        '     Public Sub New()
        ' 
        '     End Sub


        Private Sub ReadLoggingSettingsFromConfig()
            'update the Log mask in the registry
            Dim lLogMask As Long = 0

            'Read from Config
            lLogMask = m_oCfgDataServicesServer.ServerLogManager.LogMask

            'Write to TextBox
            txtLogLevel.Text = String.Format("0x{0,8:X8}", lLogMask)

            Dim myInts() As Integer = {lLogMask}

            Dim ba As New BitArray(myInts)

            'Set Check Boxes
            SetCheckBoxValues(ba)


        End Sub

        Private Sub PrintValues(ByVal myList As IEnumerable, ByVal myWidth As Integer)
            Dim myEnumerator As System.Collections.IEnumerator = myList.GetEnumerator()
            Dim i As Integer = myWidth
            While myEnumerator.MoveNext()
                If i <= 0 Then
                    i = myWidth
                    Console.WriteLine()
                End If
                i -= 1
                Console.Write(ControlChars.Tab + "{0}", myEnumerator.Current)
            End While
            Console.WriteLine()
        End Sub

        Private Sub SetCheckBoxValues(ByVal myList As IEnumerable)
            Dim myEnumerator As System.Collections.IEnumerator = myList.GetEnumerator()
            Dim i As Integer = 0

            While myEnumerator.MoveNext()
                If i < chkLoggingLevels.Items.Count Then
                    chkLoggingLevels.Items(i).Selected = myEnumerator.Current()  'returns t/f...
                    i += 1
                End If
            End While

        End Sub

        Private Sub btnSetProdLevels_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetProdLevels.Click


            Dim item As Object
            Dim i As Integer = 0
            For Each item In chkLoggingLevels.Items
                chkLoggingLevels.Items(i).Selected = False
                i += 1
            Next

            chkLoggingLevels.Items(0).Selected = True
            chkLoggingLevels.Items(1).Selected = True
            chkLoggingLevels.Items(2).Selected = True

            btnUpdateLoggingLevels_Click(sender, e)

        End Sub

        Private Sub btnSetAllLogs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetAllLogs.Click
            Dim item As Object
            Dim i As Integer = 0
            For Each item In chkLoggingLevels.Items
                chkLoggingLevels.Items(i).Selected = True
                i += 1
            Next
            btnUpdateLoggingLevels_Click(sender, e)

        End Sub

        Private Sub btnSetFromTextBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetFromTextBox.Click

            Dim lLogMask As Integer = 0

            Dim sTmp As String = txtLogLevel.Text
            sTmp = sTmp.Substring(2) 'HEX representation...

            'need to convert HEX string to integer...
            lLogMask = Integer.Parse(sTmp, NumberStyles.HexNumber)

            'oReg.LocalMachine.OpenSubKey("SOFTWARE\Keystroke\ESB\Logging", True).SetValue("LogMask", lLogMask)
            m_oCfgDataServicesServer.ServerLogManager.LogMask = lLogMask
            SaveConfigData() 'save to file...

            ReadLoggingSettingsFromConfig()

        End Sub

        'Public Overridable Function GetConfigData() As CustomConfigurationData
        '    Dim sourceSection As String = "ESB.Core.Services.Server"
        '    'Dim sourceSection As String = m_ ' passed in as querystring parameter

        '    m_oCfgDataServicesServer = CType(ConfigurationManager.Read(sourceSection), CustomConfigurationData)
        '    If m_oCfgDataServicesServer Is Nothing Then
        '        Throw New ApplicationException("no config on provider.")
        '    End If
        'End Function
        'Public Overridable Sub SaveConfigData()
        '    'Dim sourceSection As String = m_ ' passed in as querystring parameter
        '    Dim sourceSection As String = "ESB.Core.Services.Server"
        '    ConfigurationManager.Write(sourceSection, m_oCfgDataServicesServer)
        'End Sub

        'Replace these methods with something that can handle multiple files of the same format...
        'i.e. just a file read & deserialize...
        'Don't really need? to protect from concurrent access, as only one Management Console will write to the file t  time
        'The server does not write to the file - just reads...
        Public Sub GetConfigData()
            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil
            Dim oXmlDoc As New System.Xml.XmlDocument
            oXmlDoc.Load(m_File)

            m_oCfgDataServicesServer = oXmlUtil.DeSerialize(oXmlDoc.DocumentElement.ChildNodes(0).ChildNodes(0).OuterXml, GetType(CustomConfigurationData.CustomConfigurationData))

            If m_oCfgDataServicesServer Is Nothing Then
                Throw New ApplicationException("no config on provider.")
            End If
        End Sub
        Public Overridable Sub SaveConfigData()
            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil

            '++Write the changes
            Dim oXmlWriter As New System.Xml.XmlTextWriter(m_File, System.Text.Encoding.UTF8)
            oXmlWriter.WriteStartDocument()
            oXmlWriter.WriteStartElement("configuration")
            oXmlWriter.WriteStartElement("ESB.Core.Services.Server")

            Dim oXmlDoc As New System.Xml.XmlDocument()
            oXmlDoc.LoadXml(oXmlUtil.Serialize(m_oCfgDataServicesServer))

            oXmlWriter.WriteRaw(oXmlDoc.DocumentElement.OuterXml())
            oXmlWriter.WriteEndElement()
            oXmlWriter.WriteEndElement()
            oXmlWriter.WriteEndDocument()
            oXmlWriter.Flush()
            oXmlWriter.Close()

            '--Write the changes

            '++Read file in & indent XML...
            My.Computer.FileSystem.WriteAllText(m_File, oXmlUtil.PrettyFormatXML(My.Computer.FileSystem.ReadAllText(m_File)), False)


        End Sub
    End Class

End Namespace
