''-----------------------------------------------------------------------------
'' <summary>
'' Copyright Keystroke IT 2003
'' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
'' </summary>
''-----------------------------------------------------------------------------
Imports System.Messaging

Imports System.Text
Imports System.IO
Imports System.Xml

Imports System.Xml.Serialization
Imports System
Imports System.Xml.Xsl
Imports System.Reflection

Imports system.Web.UI.WebControls

Namespace ESB.Management.Portal

    Partial Class ManageDocumentTransformCfg
        Inherits System.Web.UI.Page
        Protected WithEvents Label2 As System.Web.UI.WebControls.Label

        Protected m_sSerializedFilteredItems As String



#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private Sub DisplayCfgFileContents()
            Dim sPiplineCfgPath As String
            sPiplineCfgPath = GetPipelineManagerCfgFilePath()

            Dim oFile As New ESB.Core.Util.File
            ctlRawCfgTextBox.Text = Core.Util.File.Read(sPiplineCfgPath)
            ctlRawCfgTextBox.Font.Size = GetFontSize()  'ctlRawCfgTextBox.Font.Size.XSmall

        End Sub

        Private Sub SaveCfgFileContents()
            Dim sPiplineCfgPath As String
            sPiplineCfgPath = GetPipelineManagerCfgFilePath()

            Try


                Dim oFile As New ESB.Core.Util.File
                Core.Util.File.Write(sPiplineCfgPath, ctlRawCfgTextBox.Text)

            Catch ex As Exception
                txtStatus.Text = "Failed to save Pipeline Configuration File"
            End Try

        End Sub


        Private Function GetPipelineManagerCfgFilePath() As String
            Dim sPath As String
            sPath = System.Configuration.ConfigurationManager.AppSettings("ESBDocumentTransformConfigurationPath")
            Utils.ExpandRelativePath(sPath)

            Return sPath
        End Function


        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Dim sPiplineCfgPath As String
            sPiplineCfgPath = GetPipelineManagerCfgFilePath()

            txtCfgFilePath.Text = sPiplineCfgPath


            GetFontSize()

            ShowConfiguredItemsInGrid()
           
            ShowConfiguredItemsInGrid()

            If Me.IsPostBack = False Then
                'first time through


                If Not Application.Get("ScreenResolution") Is Nothing Then
                    UpdateWindowDimensions(Application.Get("ScreenResolution"))
                Else
                    UpdateWindowDimensions(2)
                End If

                DisplayCfgFileContents()

                DisplayXmlFile(sPiplineCfgPath, TreeView1)


            Else
                If Not Application.Get("ScreenResolution") Is Nothing Then
                    UpdateWindowDimensions(Application.Get("ScreenResolution"))
                Else
                    UpdateWindowDimensions(2)
                End If

            End If

            ShowNodes(TreeView1)

        End Sub

        Private Sub UpdateWindowDimensions(ByVal index As Long)
            Dim w1, h1, w2, h2, w3, h3 As WebControls.Unit

            Dim x As Long = 700
            Dim y As Long = 450

            Select Case index
                Case 0
                    x = 700
                    y = 450
                Case 1
                    x = 1000
                    y = 600
                Case 2
                    x = 1200
                    y = 800

            End Select

            If txtStatus.Text = "" Then
                txtStatus.Text = "x=" & x & "" & "y=" & y
            End If

            w1 = WebControls.Unit.Pixel(x)
            h1 = WebControls.Unit.Pixel(y)

            w2 = WebControls.Unit.Pixel(x * 0.95)
            h2 = WebControls.Unit.Pixel(y * 0.95)

            w3 = WebControls.Unit.Pixel(x * 0.95 / 2)
            h3 = WebControls.Unit.Pixel(y * 0.95 / 2)

            ctlRawCfgTextBox.Height = h2
            ctlRawCfgTextBox.Width = w2
            '        ctlFilteredItemsTextBox.Height = h2
            '        ctlFilteredItemsTextBox.Width = w2



        End Sub

        Private Sub ShowConfiguredItemsInGrid()
            Dim sPiplineCfgPath As String
            sPiplineCfgPath = GetPipelineManagerCfgFilePath()


            ShowConfiguredItems(False)

            'Dim oFile As New ESB.core.Util.File()
            'oFile.Write(sPiplineCfgPath & ".Filtered.XML", m_sSerializedFilteredItems)



            'DisplayXmlFile(sPiplineCfgPath, TreeView1)


        End Sub

        Private Sub ShowConfiguredItems(Optional ByVal bDoNotDisplay As Boolean = False)
            Dim sPiplineCfgPath As String

            Try
                sPiplineCfgPath = GetPipelineManagerCfgFilePath()

                Dim x As New XmlDocument
                x.Load(sPiplineCfgPath)

                Dim oNL As XmlNodeList
                Dim nsmgr As New XmlNamespaceManager(x.NameTable)
                nsmgr.AddNamespace("PL", C_sServicePipelineCfg)
                oNL = x.SelectNodes("configuration/ESB.Core.PipelineXslt/PL:Config/PL:PipelineConfig/*/PL:PipelineMapSection/PL:PipelineEntry/PL:ResolveNameEntry/PL:ContextEntry", nsmgr)

                If oNL Is Nothing Then
                    txtStatus.Text = "XPath Query returned no results."
                Else
                    txtStatus.Text = "XPath Query returned " & oNL.Count & " items."

                    Dim sResult As String = ""
                    Dim oNode As XmlNode

                    Dim sResolveName As String
                    Dim sContext As String

                    Dim sProgID As String
                    Dim lCount As Long = 0

                    Dim oDocFiltered As New XmlDocument
                    Dim oElNode As XmlElement

                    Dim oOuterNode As XmlNode

                    oElNode = oDocFiltered.CreateElement("items")
                    oDocFiltered.AppendChild(oElNode)

                    For Each oNode In oNL
                        Try
                            oOuterNode = oDocFiltered.CreateElement("item")

                            Dim oNodeCounter As XmlNode
                            oNodeCounter = oDocFiltered.CreateElement("Number")
                            oNodeCounter.InnerText = lCount + 1
                            oOuterNode.AppendChild(oNodeCounter)
                            Dim oNodeTmp As XmlNode
                            Try
                                oNodeTmp = oNode.SelectSingleNode("PL:ResolveName", nsmgr)
                                oNodeTmp.Attributes.RemoveAll()
                                oOuterNode.AppendChild(oDocFiltered.ImportNode(oNodeTmp, True))
                                'oOuterNode.AppendChild(oDocFiltered.ImportNode(oNode.SelectSingleNode("PL:ResolveName", nsmgr), True))
                            Catch
                            End Try

                            Try
                                oNodeTmp = oNode.SelectSingleNode("PL:Context", nsmgr)
                                oNodeTmp.Attributes.RemoveAll()
                                oOuterNode.AppendChild(oDocFiltered.ImportNode(oNodeTmp, True))
                                'oOuterNode.AppendChild(oDocFiltered.ImportNode(oNode.SelectSingleNode("PL:Context", nsmgr), True))
                            Catch
                            End Try
                            Try
                                oNodeTmp = oNode.SelectSingleNode("PL:MultiLevelOverrides/PL:TransactionComponent", nsmgr)
                                oNodeTmp.Attributes.RemoveAll()
                                oOuterNode.AppendChild(oDocFiltered.ImportNode(oNodeTmp, True))
                                'oOuterNode.AppendChild(oDocFiltered.ImportNode(oNode.SelectSingleNode("PL:MultiLevelOverrides/PL:TransactionComponent", nsmgr), True))
                            Catch
                            End Try

                            oDocFiltered.DocumentElement.AppendChild(oOuterNode)

                            lCount += 1
                            sResolveName = oNode.SelectSingleNode("PL:ResolveName", nsmgr).InnerText
                            sContext = oNode.SelectSingleNode("PL:Context", nsmgr).InnerText
                            sProgID = oNode.SelectSingleNode("PL:MultiLevelOverrides/PL:TransactionComponent", nsmgr).InnerText

                            sResult += vbNewLine & lCount & ": Resolve Name='" & sResolveName & "' Context='" & sContext & "' ProgID='" & sProgID & "'"
                            'sResult += vbNewLine & oNode.InnerText
                        Catch ex As Exception
                            txtStatus.Text = txtStatus.Text & "Failed to get details for node."
                        End Try

                    Next

                    m_sSerializedFilteredItems = oDocFiltered.DocumentElement.OuterXml().ToString

                    'ctlFilteredItemsTextBox.Text = sResult
                    'ctlFilteredItemsTextBox.Font.Size = GetFontSize() 'ctlFilteredItemsTextBox.Font.Size.XSmall
                End If

            Catch ex As Exception
                txtStatus.Text = "Failed to show Configured items." & ex.ToString
            End Try

        End Sub

        Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click
            DisplayCfgFileContents()
        End Sub

        Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
            SaveCfgFileContents()
        End Sub

        Private Sub btnShowItems_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnShowItems.Click
            'ShowConfiguredItems(False)
            ShowConfiguredItemsInGrid()
        End Sub

     
        Private Function Serialize(ByRef oObjectToSerialize As System.Object) As String
            Dim oSer As System.Xml.Serialization.XmlSerializer
            oSer = New XmlSerializer(oObjectToSerialize.GetType())
            Dim oS As New MemoryStream
            Dim sw As New StringWriter
            Dim sXML As String
            oSer.Serialize(sw, oObjectToSerialize)
            sXML = sw.ToString

            Return sXML
        End Function

        Private Function GetFontSize() As System.Web.UI.WebControls.FontUnit
            Dim y As New System.Web.UI.WebControls.FontUnit
            Dim sFontValue As String = Session("FontSize")

            txtStatus.Text += "Session Font Value=" & sFontValue

            If sFontValue = "" Then
                Session("FontSize") = "XX-Small"
            End If

            sFontValue = Session("FontSize")

            y = System.Web.UI.WebControls.FontUnit.Parse(sFontValue)

            Return y

        End Function
        ''''''''''''''''''
        Sub DisplayXmlFile(ByVal filename As String, ByVal tvw As TreeView)
            Dim xmldoc As New XmlDocument
            xmldoc.Load(filename)
            ' Add it to the TreeView Nodes collection
            Dim oNode As XmlNode
            Dim nsmgr As New XmlNamespaceManager(xmldoc.NameTable)
            nsmgr.AddNamespace("PL", C_sServicePipelineCfg)

            oNode = xmldoc.SelectSingleNode("configuration/ESB.Core.PipelineXslt/PL:Config", nsmgr)
            DisplayXmlNode(oNode, tvw.Nodes)
            'DisplayXmlNode(xmldoc, tvw.Nodes)
            ' Expand the root node.
            'tvw.Nodes(0).Expand()
            'tvw.Nodes(0).Expanded = True
            'tvw.Nodes(0).Nodes(1).Expanded = True
            'tvw.Nodes(0).Nodes(1).Nodes(2).Expanded = True
            'tvw.Nodes(0).Nodes(1).Nodes(2).Nodes(0).Expanded = True
            'tvw.Nodes(0).Nodes(1).Nodes(2).Nodes(0).Nodes(1).Expanded = True
            'tvw.Nodes(0).Nodes(1).Nodes(2).Nodes(0).Nodes(1).Nodes(5).Expanded = True
            'tvw.Nodes(0).Nodes(1).Nodes(2).Nodes(0).Nodes(1).Nodes(6).Expanded = True
            'tvw.Nodes(0).Nodes(1).Nodes(2).Nodes(0).Nodes(1).Nodes(7).Expanded = True

            'tvw.ExpandLevel = txtNumwTreeLevelsToShow.Text
            ShowNodes(tvw)
        End Sub

        Sub ShowNodes(ByRef tvw As TreeView)
            Try
                'tvw.Nodes(0).Expanded = True
                'tvw.Nodes(0).Nodes(1).Expanded = True
                'tvw.Nodes(0).Nodes(1).Nodes(2).Expanded = True
                'tvw.Nodes(0).Nodes(1).Nodes(2).Nodes(0).Expanded = True
                'tvw.Nodes(0).Nodes(1).Nodes(2).Nodes(0).Nodes(1).Expanded = True
                'tvw.Nodes(0).Nodes(1).Nodes(2).Nodes(0).Nodes(1).Nodes(5).Expanded = True
                'tvw.Nodes(0).Nodes(1).Nodes(2).Nodes(0).Nodes(1).Nodes(6).Expanded = True
                'tvw.Nodes(0).Nodes(1).Nodes(2).Nodes(0).Nodes(1).Nodes(7).Expanded = True

                'tvw.ExpandLevel = txtNumwTreeLevelsToShow.Text
                'tvw.Nodes(0).Nodes(1).Nodes(0).Expanded = False

                tvw.Nodes(0).Expanded = True
                tvw.Nodes(0).ChildNodes(1).Expanded = True
                'tvw.Nodes(0).Nodes(1).Nodes(0).Expanded = True
                tvw.Nodes(0).ChildNodes(1).ChildNodes(5).Expanded = True
                tvw.Nodes(0).ChildNodes(1).ChildNodes(6).Expanded = True
                tvw.Nodes(0).ChildNodes(1).ChildNodes(7).Expanded = True

                tvw.ExpandDepth = txtNumwTreeLevelsToShow.Text
            Catch ex As Exception
                txtStatus.Text = ex.Message
            End Try

        End Sub
        Sub DisplayXmlNode(ByVal xmlnode As XmlNode, ByVal nodes As TreeNodeCollection)
            ' Add a TreeView node for this XmlNode.
            ' (Using the node's Name is OK for most XmlNode types.)

            Dim tvNode As New TreeNode

            '++ Display a summary (the InnerText) of the nodes below...
            Dim len As Long = 200
            Dim len2 As Long
            len2 = xmlnode.InnerText.Length
            If len2 < len Then
                len = len2
                tvNode.Text = xmlnode.Name & "............................==>(" & xmlnode.InnerText.Substring(0, len) & ")"
            Else
                tvNode.Text = xmlnode.Name & "............................==>(" & xmlnode.InnerText.Substring(0, len) & "...)"
            End If
            '-- Display a summary (the InnerText) of the nodes below...

            nodes.Add(tvNode)

            Select Case xmlnode.NodeType
                Case XmlNodeType.Element
                    ' This is an element: Check whether there are attributes.
                    If xmlnode.Attributes.Count > 0 Then
                        ' Create an ATTRIBUTES node.
                        Dim attrNode As New TreeNode
                        attrNode.Text = "(ATTRIBUTES)"
                        tvNode.ChildNodes.Add(attrNode)
                        ' Add all the attributes as children of the new node.
                        Dim xmlAttr As XmlAttribute
                        For Each xmlAttr In xmlnode.Attributes
                            ' Each node shows name and value.
                            Dim oAttrNode As New TreeNode
                            oAttrNode.Text = xmlAttr.Name & " = '" & xmlAttr.Value & "'"
                            attrNode.ChildNodes.Add(oAttrNode)
                        Next
                    End If
                Case XmlNodeType.Text, XmlNodeType.CDATA
                    ' For these node types we display the value
                    tvNode.Text = xmlnode.Value
                Case XmlNodeType.Comment

                    'tvNode.Text = "<!--" & xmlnode.Name & " " & xmlnode.Value & "-->"

                    'tvNode.Text = "<!--" & xmlnode.Value & "-->"
                    'tvNode.Text = "&lt!--" & xmlnode.Value & "--&gt"
                    'tvNode.Text = "&lt!--" & xmlnode.Value & "--&gt"

                    'tvNode.Text = "&lt!--" & xmlnode.Value & "--&gt"
                    'tvNode.Text = xmlnode.Name
                    tvNode.Text = "&lt!--" & xmlnode.Value & "--&gt"
                    tvNode.ImageUrl = "~/images/arrow.GIF"
                    'tvNode.Text = xmlnode.Value
                    'Exit Sub
                    'nodes.Add(tvNode)

                Case XmlNodeType.ProcessingInstruction, XmlNodeType.XmlDeclaration
                    tvNode.Text = "<?" & xmlnode.Name & " " & xmlnode.Value & "?>"
                    'tvNode.Text = "&lt?" & xmlnode.Name & " " & xmlnode.Value & "?&gt"
                    'tvNode.Text = xmlnode.Name & " " & xmlnode.Value

                Case Else
                    ' ignore other node types.
            End Select

            ' Call this routine recursively for each child node.

            Dim xmlChild As XmlNode = xmlnode.FirstChild
            Do Until xmlChild Is Nothing
                DisplayXmlNode(xmlChild, tvNode.ChildNodes)
                xmlChild = xmlChild.NextSibling
            Loop
        End Sub

        Protected Sub Menu1_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu1.PreRender
            For Each oItem As MenuItem In Menu1.Items
                If oItem.Selected = True Then
                    oItem.SeparatorImageUrl = "~/images/selectedtab.jpg"
                Else
                    oItem.SeparatorImageUrl = "~/images/unselectedtab.gif"
                End If
            Next
        End Sub

        Protected Sub Menu1_MenuItemClick(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.MenuEventArgs) Handles Menu1.MenuItemClick
            MultiView1.ActiveViewIndex = Int32.Parse(e.Item.Value)

        End Sub

        Protected Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
            XmlDataSource1.DataFile = Utils.ExpandRelativePath("Base\Configuration\XMLConfigFiles\DocumentTransformPipeline.config")
            XmlDataSource1.TransformFile = Utils.ExpandRelativePath("Base\Configuration\XMLConfigFiles\XSLT\DocumentTransformPipeline.xslt")

            GridView1.DataBind()
        End Sub
    End Class

End Namespace
