'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Imports System.Messaging

Imports System.Text
Imports System.IO
Imports System.Xml

Imports System.Xml.Serialization
Imports System
Imports System.Xml.Xsl
Imports System.Reflection

Imports System.Web.UI.WebControls

Imports ESB.Core.Interfaces.Envelope
Imports ESB.Core.XMLSchemaClasses

Namespace ESB.Management.Portal

    Partial Class ManagePipelineCfg
        Inherits System.Web.UI.Page

        Protected m_sSerializedConfiguredServices As String
        Protected m_sConfiguredServices As String
        Protected m_sUnconfiguredServiceXml As String
        Protected m_sPiplineCfgPath As String

        Dim C_sServiceTypeConfigured As String = "Configured"
        Dim C_sServiceTypeConventionOverConfiguration As String = "ConventionOverConfiguration"

        Protected m_sServiceType As String
        Protected m_sContext As String
        Protected m_sResolveName As String
        Protected m_sServiceVersion As String
        Protected m_sServiceHandler As String
        Protected m_sUrlEncodedContext As String

        Protected m_sRootElementName As String
        Protected m_sSchemaNamespace As String
        Protected m_sServiceDefinitionFileName As String
        Protected m_sServiceDefinitionFileNameExpanded As String

        Public Const C_sServiceDefinitionPrefix As String = "ServiceDefinition."


#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region
        ''' <summary>
        ''' Shows the contents of the current ESB Instance Pipeline Config file
        ''' </summary>
        ''' <remarks></remarks>
        Private Sub DisplayCfgFileContents()
            Dim sPiplineCfgPath As String
            sPiplineCfgPath = GetPipelineManagerCfgFilePath()

            Dim oFile As New ESB.Core.Util.File
            ctlRawCfgTextBox.Text = Core.Util.File.Read(sPiplineCfgPath)
            ctlRawCfgTextBox.Font.Size = GetFontSize()  'ctlRawCfgTextBox.Font.Size.XSmall

        End Sub
        Private Sub SaveCfgFileContents()
            Dim sPiplineCfgPath As String
            sPiplineCfgPath = GetPipelineManagerCfgFilePath()

            Try
                ESB.Core.Util.File.Write(sPiplineCfgPath, ctlRawCfgTextBox.Text)
            Catch ex As Exception
                txtStatus.Text = "Failed to save Pipeline Configuration File"
            End Try
        End Sub
        Private Function GetPipelineManagerCfgFilePath() As String
            Dim sPath As String
            sPath = System.Configuration.ConfigurationManager.AppSettings("ESBPiplineConfigurationPath")
            Utils.ExpandRelativePath(sPath)

            Return sPath
        End Function
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            m_sPiplineCfgPath = GetPipelineManagerCfgFilePath()

            XmlDataSource2_ConfiguredServicesView_InstanceConfigured.DataFile = m_sPiplineCfgPath
            XmlDataSource3_ConfiguredServicesView_LocallyConfigured.DataFile = ESB.Core.Util.ExpandRelativePath("Base\Manage\EMC\Authenticated\System\XMLConfigurationFiles\Temp\LocallyConfiguredServicesAsUIServicePipeline.xml")
            XmlDataSource4_AllServicesView.DataFile = ESB.Core.Util.ExpandRelativePath("Base\Manage\EMC\Authenticated\System\XMLConfigurationFiles\Temp\MergedServices.xml")

            txtCfgFilePath.Text = m_sPiplineCfgPath

            GetFontSize()

            If Me.IsPostBack = False Then
                'first time through

                If Not Application.Get("ScreenResolution") Is Nothing Then
                    UpdateWindowDimensions(Application.Get("ScreenResolution"))
                Else
                    UpdateWindowDimensions(2)
                End If

                DisplayCfgFileContents()
                DisplayXmlFile(m_sPiplineCfgPath, TreeView1)

                'If we navigate to this page with service name, do the search & filter...
                If Request.Params("ServiceName") <> "" Then
                    txtServiceSearch.Text = Request.Params("ServiceName")
                    XmlDataSource4_AllServicesView.XPath = "*/*[(contains(@Context,'" & txtServiceSearch.Text & "'))]"
                End If
            Else

                If Not Application.Get("ScreenResolution") Is Nothing Then
                    UpdateWindowDimensions(Application.Get("ScreenResolution"))
                Else
                    UpdateWindowDimensions(2)
                End If

            

            End If

            ShowUnconfiguredItemsInGrid()

            ShowNodes(TreeView1)

        End Sub
        Private Sub UpdateWindowDimensions(ByVal index As Long)
            Dim w1, h1, w2, h2, w3, h3 As WebControls.Unit

            Dim x As Long = 700
            Dim y As Long = 450

            Select Case index
                Case 0
                    x = 700
                    y = 450
                Case 1
                    x = 1000
                    y = 600
                Case 2
                    x = 1200
                    y = 800

            End Select

            If txtStatus.Text = "" Then
                txtStatus.Text = "x=" & x & "" & "y=" & y
            End If

            w1 = WebControls.Unit.Pixel(x)
            h1 = WebControls.Unit.Pixel(y)

            w2 = WebControls.Unit.Pixel(x * 0.95)
            h2 = WebControls.Unit.Pixel(y * 0.95)

            w3 = WebControls.Unit.Pixel(x * 0.95 / 2)
            h3 = WebControls.Unit.Pixel(y * 0.95 / 2)

            ctlRawCfgTextBox.Height = h2
            ctlRawCfgTextBox.Width = w2

        End Sub
        Private Sub ShowConfiguredItemsInGrid()
            Dim sPiplineCfgPath As String
            sPiplineCfgPath = GetPipelineManagerCfgFilePath()

            ShowConfiguredItems(False)
            ShowConfiguredServiceHandlers()
            SaveTempServiceFiles()
        End Sub
        Sub SaveTempServiceFiles()

            'Write out Locally Configured Services
            Dim sLocallyConfiguredServiceXml As String = GetLocallyConfiguredServicesXml()
            Dim sMergedLocallyConfiguredServicesPipelinePath As String = "Base\Manage\EMC\Authenticated\System\XMLConfigurationFiles\Temp\LocallyConfiguredServices.xml"
            File.WriteAllText(ESB.Core.Util.ExpandRelativePath(sMergedLocallyConfiguredServicesPipelinePath), sLocallyConfiguredServiceXml, System.Text.Encoding.UTF8)
            'transform using xslt?...

            'Write out Configured Services
            Dim oXslt As New ESB.Core.Pipeline.XsltManager()

            Dim sXmlIn As String = File.ReadAllText(sMergedLocallyConfiguredServicesPipelinePath)
            Dim sXmlOut As String = ""
            Dim sMergedLocallyConfiguredServicesAsUIServicePipelinePath As String = "Base\Manage\EMC\Authenticated\System\XMLConfigurationFiles\Temp\LocallyConfiguredServicesAsUIServicePipeline.xml"

            oXslt.Transform(ESB.Core.Util.ExpandRelativePath("Base\Manage\EMC\Authenticated\System\XMLConfigurationFiles\ServicePipelineTransform_LCS.xslt"), sXmlIn, sXmlOut)
            sXmlOut = "<?xml version=""1.0"" ?>" & sXmlOut
            File.WriteAllText(ESB.Core.Util.ExpandRelativePath(sMergedLocallyConfiguredServicesAsUIServicePipelinePath), sXmlOut)


            'Write out Unconfigured Services
            Dim sUnconfiguredServiceXml As String = GetUnconfiguredServicesXml()
            'sUnconfiguredServiceXml = sUnconfiguredServiceXml.Replace("encoding=""utf-16""", "")
            File.WriteAllText(ESB.Core.Util.ExpandRelativePath("Base\Manage\EMC\Authenticated\System\XMLConfigurationFiles\Temp\UnconfiguredServices.xml"), sUnconfiguredServiceXml, System.Text.Encoding.UTF8)

            'Write out Configured Services
            oXslt = New ESB.Core.Pipeline.XsltManager()
            sXmlOut = ""
            sXmlIn = File.ReadAllText(m_sPiplineCfgPath)
            oXslt.Transform(ESB.Core.Util.ExpandRelativePath("Base\Manage\EMC\Authenticated\System\XMLConfigurationFiles\ServicePipelineTransform.xslt"), sXmlIn, sXmlOut)

            'sXmlOut = "<?xml version=""1.0"" encoding=""utf-16"" ?>" & sXmlOut
            sXmlOut = "<?xml version=""1.0"" ?>" & sXmlOut
            File.WriteAllText(ESB.Core.Util.ExpandRelativePath("Base\Manage\EMC\Authenticated\System\XMLConfigurationFiles\Temp\ConfiguredServices.xml"), sXmlOut)

            oXslt = New ESB.Core.Pipeline.XsltManager()
            Dim sXmlOutMerged As String = ""
            'Dim oXmlDummyIn As String = "test" 'not used as XSLT just merges 2 files...
            Dim oXmlDummyIn As String = sXmlOut 'not used as XSLT just merges 2 files...but didy XSLTManager complains...
            oXslt.Transform(ESB.Core.Util.ExpandRelativePath("Base\Manage\EMC\Authenticated\System\XMLConfigurationFiles\MergeConfiguredAndUnconfiguredServices.xslt"), oXmlDummyIn, sXmlOutMerged)

            sXmlOutMerged = "<?xml version=""1.0"" ?>" & sXmlOutMerged
            File.WriteAllText(ESB.Core.Util.ExpandRelativePath("Base\Manage\EMC\Authenticated\System\XMLConfigurationFiles\Temp\MergedServices.xml"), sXmlOutMerged)

        End Sub
        ''' <summary>
        ''' Get the XML string that lists the Configured service handlers.
        ''' Use it to populate the GridView control...
        ''' </summary>
        ''' <remarks></remarks>
        Private Sub ShowConfiguredServiceHandlers()

            Dim set1 As New DataSet()

            Dim reader As New StringReader(m_sSerializedConfiguredServices)
            set1.ReadXml(reader)

            ' Get a DataView of the table contained in the dataset.
            Dim tables As DataTableCollection = set1.Tables
            Dim view1 As New DataView(tables(0))

            GridView3.DataSource = set1

            ' Create a DataGridView control and add it to the form.
            GridView3.AutoGenerateColumns = True
            GridView3.DataBind()


        End Sub
        ''' <summary>
        ''' Get the XML string that lists the Unconfigured Services.
        ''' Use it to populate the GridView control...
        ''' </summary>
        ''' <remarks></remarks>
        Private Sub ShowUnconfiguredItemsInGrid()
            Dim set1 As New DataSet()
            Dim sUnconfiguredServiceXml As String = GetUnconfiguredServicesXml()
            ' Read the xml.
            Dim reader As New StringReader(sUnconfiguredServiceXml)
            set1.ReadXml(reader)

            ' Get a DataView of the table contained in the dataset.
            Dim tables As DataTableCollection = set1.Tables
            Dim view1 As New DataView(tables(0))

            GridView2.DataSource = set1

            ' Create a DataGridView control and add it to the form.
            'GridView2.AutoGenerateColumns = True
            GridView2.DataBind()
        End Sub
        Private Function GetUnconfiguredServicesXml() As String
            Const STR_ESBConventionOverConfigurationHandlerAssembliesRootPath As String = "ESB.ConventionOverConfiguration.HandlerAssembliesRootPath"

            '"LobSystems\ns" equivalent from config
            Dim sComponentServerAssemblyBase As String = System.Configuration.ConfigurationManager.AppSettings(STR_ESBConventionOverConfigurationHandlerAssembliesRootPath)
            Dim sBasePath As String = Utils.ExpandRelativePath(sComponentServerAssemblyBase)

            lblBaseConventionOverConfigurationServicesPath.Text = sBasePath
            Dim oSvcCfg As New UnconfiguredServices

            Dim sXml As String = oSvcCfg.GetUnconfiguredServicesAsXml(sBasePath)

            Return sXml

        End Function

        Private Function GetLocallyConfiguredServicesXml() As String
            Const STR_ESBConventionOverConfiguration_LocallyConfiguredServicesRootPath As String = "ESB.ConventionOverConfiguration.LocallyConfiguredServiceRootPath"

            '"LobSystems\lcs" equivalent from config
            Dim sLocallyConfiguredServicesBase As String = System.Configuration.ConfigurationManager.AppSettings(STR_ESBConventionOverConfiguration_LocallyConfiguredServicesRootPath)
            Dim sBasePath As String = Utils.ExpandRelativePath(sLocallyConfiguredServicesBase)

            lblBaseConventionOverConfigurationServicesPath.Text = sBasePath
            Dim oSvcCfg As New LocallyConfiguredServices

            Dim sXml As String = oSvcCfg.GetLocallyConfiguredServicesAsXml(sBasePath)

            Return sXml

        End Function

        Private Sub ShowConfiguredItems(Optional ByVal bDoNotDisplay As Boolean = False)
            Dim sPiplineCfgPath As String

            Try
                sPiplineCfgPath = GetPipelineManagerCfgFilePath()

                Dim x As New XmlDocument
                x.Load(sPiplineCfgPath)

                Dim oNL As XmlNodeList
                Dim nsmgr As New XmlNamespaceManager(x.NameTable)
                nsmgr.AddNamespace("PL", C_sServicePipelineCfg)

                oNL = x.SelectNodes("configuration/ESB.Core.Pipeline/PL:Config/PL:PipelineConfig/*/PL:PipelineMapSection/PL:PipelineEntry/PL:ResolveNameEntry/PL:ContextEntry", nsmgr)


                If oNL Is Nothing Then
                    txtStatus.Text = "XPath Query returned no results."
                Else
                    txtStatus.Text = "XPath Query returned " & oNL.Count & " items."

                    Dim sResult As String
                    Dim oNode As XmlNode

                    Dim sResolveName As String
                    Dim sContext As String

                    Dim lCount As Long = 0

                    Dim oDocFiltered As New XmlDocument
                    Dim oElNode As XmlElement

                    Dim oOuterNode As XmlNode
                    Dim scServicesList As New Specialized.StringCollection



                    oElNode = oDocFiltered.CreateElement("items")
                    oDocFiltered.AppendChild(oElNode)

                    For Each oNode In oNL
                        Try
                            oOuterNode = oDocFiltered.CreateElement("item")

                            Dim oNodeCounter As XmlNode
                            oNodeCounter = oDocFiltered.CreateAttribute("Index")
                            oNodeCounter.InnerText = lCount + 1
                            oOuterNode.Attributes.Append(oNodeCounter)

                            sResolveName = ""
                            sContext = ""
                            sResolveName = oNode.SelectSingleNode("PL:ResolveName", nsmgr).InnerText
                            sContext = oNode.SelectSingleNode("PL:Context", nsmgr).InnerText

                            sResult = sResolveName & sContext
                            If (chkFilterDuplicates.Checked = False) Or ((scServicesList.Contains(sResult) = False) And (chkFilterDuplicates.Checked = True)) Then
                                'Don't put in duplicates...
                                scServicesList.Add(sResult)

                                Dim oNodeTmp As XmlNode
                                Dim oNodeTmpAtt As XmlNode
                                Try
                                    oNodeTmp = oNode.SelectSingleNode("PL:ResolveName", nsmgr)
                                    If Not oNodeTmp Is Nothing Then
                                        oNodeTmpAtt = oDocFiltered.CreateAttribute("ResolveName")
                                        oNodeTmpAtt.InnerText = oNodeTmp.InnerText
                                        oOuterNode.Attributes.Append(oNodeTmpAtt)
                                    End If
                                Catch
                                End Try

                                Try
                                    oNodeTmp = oNode.SelectSingleNode("PL:Context", nsmgr)
                                    If Not oNodeTmp Is Nothing Then
                                        oNodeTmpAtt = oDocFiltered.CreateAttribute("Context")
                                        oNodeTmpAtt.InnerText = oNodeTmp.InnerText
                                        oOuterNode.Attributes.Append(oNodeTmpAtt)
                                    End If
                                Catch
                                End Try

                                If chkFilterDuplicates.Checked = True Then
                                    'make up some other nodes...

                                Else
                                    Try
                                        oNodeTmp = oNode.SelectSingleNode("PL:MultiLevelOverrides/PL:TransactionComponent", nsmgr)
                                        If Not oNodeTmp Is Nothing Then
                                            oNodeTmpAtt = oDocFiltered.CreateAttribute("TransactionComponent")
                                            oNodeTmpAtt.InnerText = oNodeTmp.InnerText
                                            oOuterNode.Attributes.Append(oNodeTmpAtt)
                                        End If
                                    Catch
                                    End Try
                                End If

                                oDocFiltered.DocumentElement.AppendChild(oOuterNode)

                                lCount += 1
                            End If


                        Catch ex As Exception
                            txtStatus.Text = txtStatus.Text & "Failed to get details for node."
                        End Try

                    Next

                    m_sSerializedConfiguredServices = oDocFiltered.DocumentElement.OuterXml().ToString

                End If

            Catch ex As Exception
                txtStatus.Text = "Failed to show Configured items." & ex.ToString
            End Try

        End Sub
     
        Private Function MakeValidFileName(ByVal sFileName As String) As String
            Return System.Web.HttpUtility.UrlEncode(sFileName)
        End Function
        Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click
            DisplayCfgFileContents()
        End Sub
        Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
            SaveCfgFileContents()
        End Sub
        Private Sub btnShowItems_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnShowItems.Click
            'ShowConfiguredItems(False)
            ShowConfiguredItemsInGrid()
        End Sub
        Private Sub btnPopulateGrid_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnPopulateGrid.Click
            ShowConfiguredItemsInGrid()
        End Sub
        Private Function Serialize(ByRef oObjectToSerialize As System.Object) As String
            Dim oSer As System.Xml.Serialization.XmlSerializer
            oSer = New XmlSerializer(oObjectToSerialize.GetType())
            Dim oS As New MemoryStream
            Dim sw As New StringWriter
            Dim sXML As String
            oSer.Serialize(sw, oObjectToSerialize)
            sXML = sw.ToString

            Return sXML
        End Function
        Private Function GetFontSize() As System.Web.UI.WebControls.FontUnit
            Dim y As New System.Web.UI.WebControls.FontUnit
            Dim sFontValue As String = Session("FontSize")

            txtStatus.Text += "Session Font Value=" & sFontValue

            If sFontValue = "" Then
                Session("FontSize") = "XX-Small"
            End If

            sFontValue = Session("FontSize")

            y = FontUnit.Parse(sFontValue)

            Return y

        End Function
        ''''''''''''''''''
        Sub DisplayXmlFile(ByVal filename As String, ByVal tvw As TreeView)
            Dim xmldoc As New XmlDocument
            xmldoc.Load(filename)
            ' Add it to the TreeView Nodes collection
            Dim oNode As XmlNode
            Dim nsmgr As New XmlNamespaceManager(xmldoc.NameTable)
            nsmgr.AddNamespace("PL", C_sServicePipelineCfg)

            oNode = xmldoc.SelectSingleNode("configuration/ESB.Core.Pipeline/PL:Config", nsmgr)
            DisplayXmlNode(oNode, tvw.Nodes)
            ShowNodes(tvw)

        End Sub
        Sub ShowNodes(ByRef tvw As TreeView)
            Try
                tvw.Nodes(0).Expanded = True
                tvw.Nodes(0).ChildNodes(1).Expanded = True
                tvw.Nodes(0).ChildNodes(1).ChildNodes(5).Expanded = True
                tvw.Nodes(0).ChildNodes(1).ChildNodes(6).Expanded = True
                tvw.Nodes(0).ChildNodes(1).ChildNodes(7).Expanded = True

                tvw.ExpandDepth = txtNumwTreeLevelsToShow.Text
            Catch ex As Exception
                txtStatus.Text = ex.Message
            End Try

        End Sub
        Sub DisplayXmlNode(ByVal xmlnode As XmlNode, ByVal nodes As TreeNodeCollection)
            ' Add a TreeView node for this XmlNode.
            ' (Using the node's Name is OK for most XmlNode types.)

            Dim tvNode As New TreeNode

            '++ Display a summary (the InnerText) of the nodes below...
            Dim len As Long = 200
            Dim len2 As Long
            len2 = xmlnode.InnerText.Length
            If len2 < len Then
                len = len2
                tvNode.Text = xmlnode.Name & "............................==>(" & xmlnode.InnerText.Substring(0, len) & ")"
            Else
                tvNode.Text = xmlnode.Name & "............................==>(" & xmlnode.InnerText.Substring(0, len) & "...)"
            End If
            '-- Display a summary (the InnerText) of the nodes below...

            nodes.Add(tvNode)

            Select Case xmlnode.NodeType
                Case XmlNodeType.Element
                    ' This is an element: Check whether there are attributes.
                    If xmlnode.Attributes.Count > 0 Then
                        ' Create an ATTRIBUTES node.
                        Dim attrNode As New TreeNode
                        attrNode.Text = "(ATTRIBUTES)"
                        tvNode.ChildNodes.Add(attrNode)
                        ' Add all the attributes as children of the new node.
                        Dim xmlAttr As XmlAttribute
                        For Each xmlAttr In xmlnode.Attributes
                            ' Each node shows name and value.
                            Dim oAttrNode As New TreeNode
                            oAttrNode.Text = xmlAttr.Name & " = '" & xmlAttr.Value & "'"
                            attrNode.ChildNodes.Add(oAttrNode)
                        Next
                    End If
                Case XmlNodeType.Text, XmlNodeType.CDATA
                    ' For these node types we display the value
                    tvNode.Text = xmlnode.Value
                Case XmlNodeType.Comment

                    tvNode.Text = "&lt!--" & xmlnode.Value & "--&gt"
                    tvNode.ImageUrl = "~/images/arrow.GIF"

                Case XmlNodeType.ProcessingInstruction, XmlNodeType.XmlDeclaration
                    tvNode.Text = "<?" & xmlnode.Name & " " & xmlnode.Value & "?>"
                   
                Case Else
                    ' ignore other node types.
            End Select

            ' Call this routine recursively for each child node.

            Dim xmlChild As XmlNode = xmlnode.FirstChild
            Do Until xmlChild Is Nothing
                DisplayXmlNode(xmlChild, tvNode.ChildNodes)
                xmlChild = xmlChild.NextSibling
            Loop
        End Sub
        Protected Sub Menu1_MenuItemClick(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.MenuEventArgs) Handles Menu1.MenuItemClick
            MultiView1.ActiveViewIndex = Int32.Parse(e.Item.Value)

        End Sub
        Protected Sub Menu1_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu1.PreRender
            For Each oItem As MenuItem In Menu1.Items
                If oItem.Selected = True Then
                    oItem.SeparatorImageUrl = "~/images/selectedtab.jpg"
                Else
                    oItem.SeparatorImageUrl = "~/images/unselectedtab.gif"
                End If
            Next
        End Sub
        Protected Sub btnFormatXml_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnFormatXml.Click
            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil

            ctlRawCfgTextBox.Text = oXmlUtil.PrettyFormatXML(ctlRawCfgTextBox.Text)

        End Sub

#Region "Service Definitions - BSDL and WSDL"
        Protected Sub GridView2_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles GridView2.PageIndexChanging
            GridView2.PageIndex = e.NewPageIndex
        End Sub
        Protected Sub GridView3_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles GridView3.PageIndexChanging
            GridView3.PageIndex = e.NewPageIndex
        End Sub

        Enum eGVServices
            index = 5
            context = 6
            resolvename = 7
            urlencodedcontext = 10
            servicetype = 11
            serviceversion = 12
            servicehandler = 13
        End Enum

        Sub SetSessionVars(ByVal oGridview As GridView, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs)
            Dim index As Integer = Convert.ToInt32(e.CommandArgument)

            m_sServiceType = oGridview.Rows(index).Cells(eGVServices.servicetype).Text
            m_sContext = oGridview.Rows(index).Cells(eGVServices.context).Text
            m_sResolveName = oGridview.Rows(index).Cells(eGVServices.resolvename).Text
            m_sUrlEncodedContext = CType(oGridview.Rows(index).Cells(eGVServices.urlencodedcontext).Controls(0).FindControl("Label1"), Label).Text

            If e.CommandName.StartsWith("ConventionServicesView_") Or e.CommandName.StartsWith("AllServicesView_") Then
                m_sServiceVersion = Replace(oGridview.Rows(index).Cells(eGVServices.serviceversion).Text, "&nbsp;", "")
                m_sServiceHandler = oGridview.Rows(index).Cells(eGVServices.servicehandler).Text
            Else
                m_sServiceVersion = ""
                m_sServiceHandler = ""
            End If

            Dim sa() As String = Split(m_sResolveName, "::", 2)
            If sa.GetLength(0) > 0 Then m_sRootElementName = sa(0)
            If sa.GetLength(0) > 1 Then m_sSchemaNamespace = sa(1)


            If ServiceDefinitionHelper.C_sServiceTypeConventionOverConfiguration = m_sServiceType Then
                Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.ConventionOverConfiguration(Server)
                m_sServiceDefinitionFileNameExpanded = oServiceDefinitionHelper.GetServiceDefinitionFullPath(m_sUrlEncodedContext, m_sServiceHandler, False)
            ElseIf ServiceDefinitionHelper.C_sServiceTypeConfigured = m_sServiceType Then
                Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.InstanceConfigured(Server)
                m_sServiceDefinitionFileNameExpanded = oServiceDefinitionHelper.GetServiceDefinitionFullPath(m_sUrlEncodedContext)
            ElseIf ServiceDefinitionHelper.C_sServiceTypeConfiguredLocally = m_sServiceType Then
                Dim oServiceDefinitionHelper As New ServiceDefinitionHelper.LocallyConfigured(Server)
                m_sServiceDefinitionFileNameExpanded = oServiceDefinitionHelper.GetServiceDefinitionFullPath(m_sUrlEncodedContext)
            Else
                Throw New Exception("Unknown Service Type:" & m_sServiceType)
            End If

            'Set Session Variables
            SetSessionFromMemberVars()

        End Sub

        Sub SetSessionFromMemberVars()
            Session("context") = m_sContext
            Session("resolvename") = m_sResolveName
            Session("serviceversion") = m_sServiceVersion
            Session("servicehandler") = m_sServiceHandler
            Session("urlencodedcontext") = m_sUrlEncodedContext
            Session("servicetype") = m_sServiceType

            Session("rootelementname") = m_sRootElementName
            Session("schemanamespace") = m_sSchemaNamespace
            Session("servicedefinitionfilename") = m_sServiceDefinitionFileName
            Session("servicedefinitionfilenameexpanded") = m_sServiceDefinitionFileNameExpanded

        End Sub
        Sub ClearSessionVars()
            '?
            m_sContext = ""
            m_sResolveName = ""
            m_sServiceVersion = ""
            m_sServiceHandler = ""
            m_sUrlEncodedContext = ""
            m_sServiceType = ""

            m_sRootElementName = ""
            m_sSchemaNamespace = ""
            m_sServiceDefinitionFileName = ""
            m_sServiceDefinitionFileNameExpanded = ""

            SetSessionFromMemberVars()
        End Sub

        Protected Sub GridViewsRowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles GridView1.RowCommand, GridView2.RowCommand, GridView4.RowCommand, GridView5.RowCommand
            ClearSessionVars()
            'Sender = GridView
            Select Case e.CommandName
                Case "ConventionServicesView_ViewBSDL", "InstanceConfiguredServicesView_ViewBSDL", "AllServicesView_ViewBSDL", "LocallyConfiguredServicesView_ViewBSDL"
                    SetSessionVars(sender, e)
                    Server.Transfer("~/authenticated/system/xmlconfigurationfiles/urlencodeandshowBSDL.aspx")

                Case "ConventionServicesView_GenerateSampleRequestFromBSDL", "InstanceConfiguredServicesView_GenerateSampleRequestFromBSDL", "AllServicesView_GenerateSampleRequestFromBSDL", "LocallyConfiguredServicesView_GenerateSampleRequestFromBSDL"
                    SetSessionVars(sender, e)
                    ShowSendRequestControl()

                Case "ConventionServicesView_ViewWSDL", "InstanceConfiguredServicesView_ViewWSDL", "AllServicesView_ViewWSDL", "LocallyConfiguredServicesView_ViewWSDL"
                    SetSessionVars(sender, e)
                    Server.Transfer("~/authenticated/system/xmlconfigurationfiles/urlencodeandshowWSDL.aspx")
            End Select
        End Sub

        

        Protected Sub GridViews_RowCreated(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView2.RowCreated, GridView1.RowCreated, GridView4.RowCreated, GridView5.RowCreated
            If e.Row.RowType = DataControlRowType.DataRow Then

                'Try & Number the Rows - not working yet
                Dim lblId As Label = CType(e.Row.Cells(1).Controls(2).FindControl("Label1"), Label)
                lblId.Text = e.Row.RowIndex.ToString()

                ' Retrieve the LinkButton control from the first column - BSDL
                Dim btnBSDL As LinkButton = CType(e.Row.Cells(1).Controls(1), LinkButton)

                ' Set the LinkButton's CommandArgument property with the row's index.
                btnBSDL.CommandArgument = e.Row.RowIndex.ToString()

                ' Retrieve the LinkButton control from the first column - WSDL
                Dim btnWSDL As LinkButton = CType(e.Row.Cells(2).Controls(1), LinkButton)

                ' Set the LinkButton's CommandArgument property with the row's index.
                btnWSDL.CommandArgument = e.Row.RowIndex.ToString()


                ' Retrieve the LinkButton control from the first column - WSDL
                Dim btnGenSampleFromBSDL As LinkButton = CType(e.Row.Cells(3).Controls(1), LinkButton)

                ' Set the LinkButton's CommandArgument property with the row's index.
                btnGenSampleFromBSDL.CommandArgument = e.Row.RowIndex.ToString()
            End If
        End Sub


        ''' <summary>
        ''' Get the Auto-Generated XML Request for the selected service, and display the SendRequest User Control, ready for the user to 
        ''' submit the request.
        ''' </summary>
        ''' <remarks></remarks>
        Protected Sub ShowSendRequestControl()
            Dim sXmlRq As String
            sXmlRq = GetSampleXmlForBSDL(m_sServiceDefinitionFileNameExpanded)
            ShowSendRequestControl(sXmlRq)
        End Sub
        Protected Sub ShowSendRequestControl(ByVal sXmlRq As String)
            SendRequestUserControl1.RequestXml = sXmlRq
            SendRequestUserControl1.ShowRequestListTree = False
            MultiView1.ActiveViewIndex = 7
        End Sub

        Protected Function GetSampleXmlForBSDL(ByVal sBsdlFileName As String) As String

            '+++++    Make sure we have a BSDL...
            Dim oServiceDefinitionHelper As New ServiceDefinitionHelper(Server, ESB.Core.Util.Utils.GetDNSName(ESB.Core.Util.ESBGlobalVariables.RequestAbsoluteUri))
            oServiceDefinitionHelper.m_sServiceType = Session("servicetype")
            oServiceDefinitionHelper.m_sContext = Session("context")
            oServiceDefinitionHelper.m_sResolveName = Session("resolvename")
            oServiceDefinitionHelper.m_sServiceVersion = Session("serviceversion")
            oServiceDefinitionHelper.m_sServiceHandler = Session("servicehandler")
            oServiceDefinitionHelper.m_sUrlEncodedContext = Session("urlencodedcontext")

            oServiceDefinitionHelper.CreateServiceDefinitionFile()
            '-----    Make sure we have a BSDL...


            'Create Envelope (default)
            'Add generated sample XML from BSDL Request Nodes...
            Dim oEnv As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope

            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil

            Dim oServiceDefinitions As ServiceDefinition.Services
            Dim oServiceDefinition As ServiceDefinition.ServiceDefinition
            oServiceDefinitions = oXmlUtil.DeSerialize(File.ReadAllText(sBsdlFileName), GetType(ServiceDefinition.Services))

            oServiceDefinition = oServiceDefinitions.ServiceDefinition(0)
            'Get BSDL file contents - Service name, Schema names, root element name...
            oEnv.ServiceName = oServiceDefinition.Service.DistinguishedServiceName.ServiceName
            oEnv.ServiceVersion = oServiceDefinition.Service.DistinguishedServiceName.ServiceVersion
            oEnv.ServiceNamespace = oServiceDefinition.Service.DistinguishedServiceName.ServiceNamespace

            'if XSD path exists, create a sample XML from it...
            Dim sDocXml As String
            'Should only be one Service Definition!!! So get the First one.
            For Each oDoc As ServiceDefinition.Document In oServiceDefinition.Service.Request.Document
                'For Each request entry with XSD path...(We need the XSD to generate a sample XML...)
                If oDoc.Schema.Url <> String.Empty Then
                    sDocXml = oXmlUtil.CreateSampleXmlFromSchema(ESB.Core.Util.ExpandRelativePath(oDoc.Schema.Url), oDoc.Schema.Name, oDoc.Schema.Namespace, 2, 2)
                    If sDocXml <> String.Empty Then
                        oEnv.AddDocument(New ESB.Core.XMLSchemaClasses.InlineDocument(sDocXml))
                    Else
                        Throw New Exception("oXmlUtil.CreateSampleXmlFromSchema returned Empty String")
                    End If
                End If
            Next

            Return oEnv.XML
        End Function

#End Region

        Protected Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
            ShowUnconfiguredItemsInGrid()
            ShowConfiguredItemsInGrid()

        End Sub

        Protected Sub btnSearch_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSearch.Click
            XmlDataSource4_AllServicesView.XPath = "*/*[(contains(@Context,'" & txtServiceSearch.Text & "'))]"
        End Sub

        Protected Sub btnClearServiceSearch_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnClearServiceSearch.Click
            XmlDataSource4_AllServicesView.XPath = "*/*"
        End Sub

        Protected Sub btnViewBSDL_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnViewBSDL.Click

           


            'Dim oChk As CheckBox
            'Dim oLbl As Label
            'Dim oSvcCollection As New StringCollection

            'Dim oD As System.Web.UI.WebControls.DataControlFieldCell



            'For Each oRow As System.Web.UI.WebControls.GridViewRow In GridView1.Rows
            '    'oD = oRow.Controls(0)
            '    'oChk = oD.Controls(1)
            '    '  oChk = oRow.Controls(0)
            '    Dim isChecked As Boolean = DirectCast(oRow.FindControl("chkSelected"), System.Web.UI.WebControls.CheckBox).Checked

            '    If isChecked Then
            '        oLbl = oRow.Controls(6)
            '        oSvcCollection.Add(oLbl.Text) 'svc name...
            '        txtSelectedServices.Text += oLbl.Text

            '    End If


            'Next


        End Sub
    End Class

End Namespace
