<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:SD="urn:au.com.keystroke.serviceDefinition.version_1_0_0_0" xmlns:fn="http://www.w3.org/2005/xpath-functions" xmlns:xdt="http://www.w3.org/2005/xpath-datatypes" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
	<xsl:output version="1.0" method="html" indent="no" encoding="UTF-8" doctype-public="-//W3C//DTD HTML 4.0 Transitional//EN" doctype-system="http://www.w3.org/TR/html4/loose.dtd"/>
	<xsl:param name="SV_OutputFormat" select="'HTML'"/>
	<xsl:variable name="XML" select="/"/>
	<xsl:template match="/">
		<html>
			<head>
				<title/>
			</head>
			<body>
				<hr style="color:blue; "/>
				<span style="color:blue; font-size:x-large; font-weight:bold; ">
					<xsl:text>Service Definition</xsl:text>
				</span>
				<br/>
				<hr style="color:blue; "/>
				<br/>
				<span style="color:blue; font-size:x-large; font-style:italic; font-weight:bold; ">
					<xsl:text>Service Provider</xsl:text>
				</span>
				<br/>
				<hr style="color:blue; "/>
				<xsl:for-each select="$XML">
					<xsl:for-each select="SD:Services">
						<xsl:for-each select="SD:ServiceDefinition">
							<xsl:for-each select="SD:Service">
								<xsl:for-each select="SD:ServiceProviderName">
									<input size="79">
										<xsl:attribute name="value">
											<xsl:value-of select="string(.)"/>
										</xsl:attribute>
									</input>
								</xsl:for-each>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:for-each>
				</xsl:for-each>
				<br/>
				<br/>
				<span style="color:blue; font-size:x-large; font-style:italic; font-weight:bold; ">
					<xsl:text>Service</xsl:text>
				</span>
				<br/>
				<hr style="color:blue; "/>
				<table border="1">
					<tbody>
						<tr>
							<th>
								<span>
									<xsl:text>SD:Context</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:DistinguishedServiceName">
												<td width="581">
													<xsl:for-each select="SD:Context">
														<input size="146">
															<xsl:attribute name="value">
																<xsl:value-of select="string(.)"/>
															</xsl:attribute>
														</input>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:Description</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:DistinguishedServiceName">
												<td width="581">
													<xsl:for-each select="SD:Description">
														<input size="146">
															<xsl:attribute name="value">
																<xsl:value-of select="string(.)"/>
															</xsl:attribute>
														</input>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:ServiceName</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:DistinguishedServiceName">
												<td width="581">
													<xsl:for-each select="SD:ServiceName">
														<input size="146">
															<xsl:attribute name="value">
																<xsl:value-of select="string(.)"/>
															</xsl:attribute>
														</input>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:ServiceNamespace</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:DistinguishedServiceName">
												<td width="581">
													<xsl:for-each select="SD:ServiceNamespace">
														<input size="146">
															<xsl:attribute name="value">
																<xsl:value-of select="string(.)"/>
															</xsl:attribute>
														</input>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:ServiceVersion</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:DistinguishedServiceName">
												<td width="581">
													<xsl:for-each select="SD:ServiceVersion">
														<input size="146">
															<xsl:attribute name="value">
																<xsl:value-of select="string(.)"/>
															</xsl:attribute>
														</input>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:SystemName</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:DistinguishedServiceName">
												<td width="581">
													<xsl:for-each select="SD:SystemName">
														<input size="146">
															<xsl:attribute name="value">
																<xsl:value-of select="string(.)"/>
															</xsl:attribute>
														</input>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:SystemVersion</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:DistinguishedServiceName">
												<td width="581">
													<xsl:for-each select="SD:SystemVersion">
														<input size="146">
															<xsl:attribute name="value">
																<xsl:value-of select="string(.)"/>
															</xsl:attribute>
														</input>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
					</tbody>
				</table>
				<br/>
				<span style="color:blue; font-size:x-large; font-style:italic; font-weight:bold; ">
					<xsl:text>Data</xsl:text>
				</span>
				<br/>
				<hr style="color:blue; "/>
				<span style="color:blue; font-size:larger; font-style:italic; font-weight:bold; ">
					<xsl:text>Request</xsl:text>
				</span>
				<br/>
				<hr style="color:aqua; "/>
				<table border="1">
					<tbody>
						<tr>
							<th>
								<span>
									<xsl:text>@Validate</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:Request">
												<td>
													<xsl:for-each select="@Validate">
														<span>
															<xsl:value-of select="string(.)"/>
														</span>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:Attachment</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:Request">
												<td>
													<xsl:for-each select="SD:Attachment">
														<table border="1">
															<tbody>
																<tr>
																	<th>
																		<span>
																			<xsl:text>SD:Description</xsl:text>
																		</span>
																	</th>
																	<td>
																		<xsl:for-each select="SD:Description">
																			<xsl:apply-templates/>
																		</xsl:for-each>
																	</td>
																</tr>
																<tr>
																	<th>
																		<span>
																			<xsl:text>SD:Index</xsl:text>
																		</span>
																	</th>
																	<td>
																		<xsl:for-each select="SD:Index">
																			<xsl:apply-templates/>
																		</xsl:for-each>
																	</td>
																</tr>
																<tr>
																	<th>
																		<span>
																			<xsl:text>SD:Name</xsl:text>
																		</span>
																	</th>
																	<td>
																		<xsl:for-each select="SD:Name">
																			<xsl:apply-templates/>
																		</xsl:for-each>
																	</td>
																</tr>
																<tr>
																	<th>
																		<span>
																			<xsl:text>SD:Type</xsl:text>
																		</span>
																	</th>
																	<td>
																		<xsl:for-each select="SD:Type">
																			<xsl:apply-templates/>
																		</xsl:for-each>
																	</td>
																</tr>
															</tbody>
														</table>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:Document</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:Request">
												<td>
													<xsl:for-each select="SD:Document">
														<table border="1">
															<thead>
																<tr>
																	<th>
																		<span>
																			<xsl:text>SD:Description</xsl:text>
																		</span>
																	</th>
																	<th>
																		<span>
																			<xsl:text>SD:Schema</xsl:text>
																		</span>
																	</th>
																</tr>
															</thead>
															<tbody>
																<tr>
																	<td>
																		<xsl:for-each select="SD:Description">
																			<xsl:apply-templates/>
																		</xsl:for-each>
																	</td>
																	<td>
																		<xsl:for-each select="SD:Schema">
																			<table border="1">
																				<tbody>
																					<tr>
																						<th>
																							<span>
																								<xsl:text>@Validate</xsl:text>
																							</span>
																						</th>
																						<td>
																							<xsl:for-each select="@Validate">
																								<span>
																									<xsl:value-of select="string(.)"/>
																								</span>
																							</xsl:for-each>
																						</td>
																					</tr>
																					<tr>
																						<th>
																							<span>
																								<xsl:text>SD:Name</xsl:text>
																							</span>
																						</th>
																						<td>
																							<xsl:for-each select="SD:Name">
																								<xsl:apply-templates/>
																							</xsl:for-each>
																						</td>
																					</tr>
																					<tr>
																						<th>
																							<span>
																								<xsl:text>SD:Namespace</xsl:text>
																							</span>
																						</th>
																						<td>
																							<xsl:for-each select="SD:Namespace">
																								<xsl:apply-templates/>
																							</xsl:for-each>
																						</td>
																					</tr>
																					<tr>
																						<th>
																							<span>
																								<xsl:text>SD:NodeConstraints</xsl:text>
																							</span>
																						</th>
																						<td>
																							<xsl:for-each select="SD:NodeConstraints">
																								<xsl:apply-templates/>
																							</xsl:for-each>
																						</td>
																					</tr>
																					<tr>
																						<th>
																							<span>
																								<xsl:text>SD:Url</xsl:text>
																							</span>
																						</th>
																						<td>
																							<xsl:for-each select="SD:Url">
																								<xsl:apply-templates/>
																							</xsl:for-each>
																						</td>
																					</tr>
																				</tbody>
																			</table>
																		</xsl:for-each>
																	</td>
																</tr>
															</tbody>
														</table>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
					</tbody>
				</table>
				<br/>
				<span style="color:blue; font-size:larger; font-style:italic; font-weight:bold; ">
					<xsl:text>Response</xsl:text>
				</span>
				<br/>
				<hr style="color:aqua; "/>
				<table border="1">
					<tbody>
						<tr>
							<th>
								<span>
									<xsl:text>@Validate</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:Response">
												<td>
													<xsl:for-each select="@Validate">
														<span>
															<xsl:value-of select="string(.)"/>
														</span>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:Attachment</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:Response">
												<td>
													<xsl:for-each select="SD:Attachment">
														<table border="1">
															<tbody>
																<tr>
																	<th>
																		<span>
																			<xsl:text>SD:Description</xsl:text>
																		</span>
																	</th>
																	<td>
																		<xsl:for-each select="SD:Description">
																			<xsl:apply-templates/>
																		</xsl:for-each>
																	</td>
																</tr>
																<tr>
																	<th>
																		<span>
																			<xsl:text>SD:Index</xsl:text>
																		</span>
																	</th>
																	<td>
																		<xsl:for-each select="SD:Index">
																			<xsl:apply-templates/>
																		</xsl:for-each>
																	</td>
																</tr>
																<tr>
																	<th>
																		<span>
																			<xsl:text>SD:Name</xsl:text>
																		</span>
																	</th>
																	<td>
																		<xsl:for-each select="SD:Name">
																			<xsl:apply-templates/>
																		</xsl:for-each>
																	</td>
																</tr>
																<tr>
																	<th>
																		<span>
																			<xsl:text>SD:Type</xsl:text>
																		</span>
																	</th>
																	<td>
																		<xsl:for-each select="SD:Type">
																			<xsl:apply-templates/>
																		</xsl:for-each>
																	</td>
																</tr>
															</tbody>
														</table>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:Document</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Service">
											<xsl:for-each select="SD:Response">
												<td>
													<xsl:for-each select="SD:Document">
														<table border="1">
															<tbody>
																<tr>
																	<th>
																		<span>
																			<xsl:text>SD:Description</xsl:text>
																		</span>
																	</th>
																	<td>
																		<xsl:for-each select="SD:Description">
																			<xsl:apply-templates/>
																		</xsl:for-each>
																	</td>
																</tr>
																<tr>
																	<th>
																		<span>
																			<xsl:text>SD:Schema</xsl:text>
																		</span>
																	</th>
																	<td>
																		<xsl:for-each select="SD:Schema">
																			<table border="1">
																				<tbody>
																					<tr>
																						<th>
																							<span>
																								<xsl:text>@Validate</xsl:text>
																							</span>
																						</th>
																						<td>
																							<xsl:for-each select="@Validate">
																								<span>
																									<xsl:value-of select="string(.)"/>
																								</span>
																							</xsl:for-each>
																						</td>
																					</tr>
																					<tr>
																						<th>
																							<span>
																								<xsl:text>SD:Name</xsl:text>
																							</span>
																						</th>
																						<td>
																							<xsl:for-each select="SD:Name">
																								<xsl:apply-templates/>
																							</xsl:for-each>
																						</td>
																					</tr>
																					<tr>
																						<th>
																							<span>
																								<xsl:text>SD:Namespace</xsl:text>
																							</span>
																						</th>
																						<td>
																							<xsl:for-each select="SD:Namespace">
																								<xsl:apply-templates/>
																							</xsl:for-each>
																						</td>
																					</tr>
																					<tr>
																						<th>
																							<span>
																								<xsl:text>SD:NodeConstraints</xsl:text>
																							</span>
																						</th>
																						<td>
																							<xsl:for-each select="SD:NodeConstraints">
																								<xsl:apply-templates/>
																							</xsl:for-each>
																						</td>
																					</tr>
																					<tr>
																						<th>
																							<span>
																								<xsl:text>SD:Url</xsl:text>
																							</span>
																						</th>
																						<td>
																							<xsl:for-each select="SD:Url">
																								<xsl:apply-templates/>
																							</xsl:for-each>
																						</td>
																					</tr>
																				</tbody>
																			</table>
																		</xsl:for-each>
																	</td>
																</tr>
															</tbody>
														</table>
													</xsl:for-each>
												</td>
											</xsl:for-each>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
					</tbody>
				</table>
				<br/>
				<br/>
				<span style="color:blue; font-size:x-large; font-style:italic; font-weight:bold; ">
					<xsl:text>Service Characteristics</xsl:text>
				</span>
				<br/>
				<hr style="color:blue; "/>
				<table border="1">
					<tbody>
						<tr>
							<th>
								<span>
									<xsl:text>SD:AggregatedResult</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Characteristics">
											<td>
												<xsl:for-each select="SD:AggregatedResult">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:Availability</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Characteristics">
											<td>
												<xsl:for-each select="SD:Availability">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:MessageExchangePattern</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Characteristics">
											<td>
												<xsl:for-each select="SD:MessageExchangePattern">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:ParallelProviders</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Characteristics">
											<td>
												<xsl:for-each select="SD:ParallelProviders">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:PeakLoad</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Characteristics">
											<td>
												<xsl:for-each select="SD:PeakLoad">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:Priority</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Characteristics">
											<td>
												<xsl:for-each select="SD:Priority">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:ResponseTimeTarget</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Characteristics">
											<td>
												<xsl:for-each select="SD:ResponseTimeTarget">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:ServiceType</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Characteristics">
											<td>
												<xsl:for-each select="SD:ServiceType">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:SynchronizationType</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Characteristics">
											<td>
												<xsl:for-each select="SD:SynchronizationType">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:Transactional</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Characteristics">
											<td>
												<xsl:for-each select="SD:Transactional">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
					</tbody>
				</table>
				<br/>
				<br/>
				<span style="color:blue; font-size:x-large; font-style:italic; font-weight:bold; ">
					<xsl:text>Service Documentation</xsl:text>
				</span>
				<br/>
				<hr style="color:blue; "/>
				<table border="1">
					<tbody>
						<tr>
							<th>
								<span>
									<xsl:text>SD:Description</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Documentation">
											<td>
												<xsl:for-each select="SD:Description">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:IntegrationArchitecturePattern</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Documentation">
											<td>
												<xsl:for-each select="SD:IntegrationArchitecturePattern">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:MessageAndAttributeFlow</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Documentation">
											<td>
												<xsl:for-each select="SD:MessageAndAttributeFlow">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
						<tr>
							<th>
								<span>
									<xsl:text>SD:SpecialRequirementsConstraintsAndComments</xsl:text>
								</span>
							</th>
							<xsl:for-each select="$XML">
								<xsl:for-each select="SD:Services">
									<xsl:for-each select="SD:ServiceDefinition">
										<xsl:for-each select="SD:Documentation">
											<td>
												<xsl:for-each select="SD:SpecialRequirementsConstraintsAndComments">
													<xsl:apply-templates/>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:for-each>
						</tr>
					</tbody>
				</table>
				<br/>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
