Imports System.IO


Partial Class UrlEncodeAndShowServiceDefinition
    Inherits System.Web.UI.Page

    Dim m_sUrlEncodedContext As String
    Dim m_sFileName As String
    Dim m_sFileNameExpanded As String

    Dim m_sContext As String
    Dim m_sResolveName As String
    Dim m_sSchemaNamespace As String
    Dim m_sRootElementName As String
    Dim m_sServiceVersion As String
    Dim m_sServiceHandler As String


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Protected Sub Menu1_MenuItemClick(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.MenuEventArgs) Handles Menu1.MenuItemClick
        MultiView1.ActiveViewIndex = e.Item.Value
    End Sub

    Protected Function CreateServiceDefinition() As String
        'AlwaysExecute Services do not have these values set.
        If m_sUrlEncodedContext = "" Then
            Return "<z>z</z>"
        Else
            'Return "<x>x</x>"
            Dim sd As String

            Dim oSvcs As New ServiceDefinition.Services
            Dim oSd As New ServiceDefinition.ServiceDefinition()
            oSd.Service.ServiceProviderName = "Keystroke IT Australia"
            oSd.Service.DistinguishedServiceName.ServiceName = m_sServiceHandler
            oSd.Service.DistinguishedServiceName.ServiceVersion = m_sServiceVersion

            Dim oDoc As New ServiceDefinition.Document()
            oDoc.Schema.Name = m_sRootElementName
            oDoc.Schema.Namespace = m_sSchemaNamespace
            oSd.Service.Request.Document.Add(oDoc)

            oSvcs.ServiceDefinition.Add(oSd)

            Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil
            sd = oXmlUtil.Serialize(oSvcs)

            Return sd
        End If

    End Function

    Protected Sub Page_PreLoad(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreLoad
        m_sContext = Session("context")
        m_sResolveName = Session("resolvename")
        m_sServiceVersion = Session("serviceversion")
        m_sServiceHandler = Session("servicehandler")
        m_sUrlEncodedContext = Session("urlencodedcontext")

        m_sRootElementName = Split(m_sResolveName, "::", 2)(0)
        m_sSchemaNamespace = Split(m_sResolveName, "::", 2)(1)

        If m_sServiceHandler = "" Then
            'assume Convention service
            m_sFileName = "~/ServiceDefinitions/" & m_sUrlEncodedContext & ".xml"
            'assume configured/virtualized service
        Else
            m_sFileName = "~/ServiceDefinitions/" & m_sServiceHandler & m_sServiceVersion & ".xml"
        End If

        m_sFileNameExpanded = Server.MapPath(m_sFileName)

        Label1.Text = m_sUrlEncodedContext

        Label2.Text = m_sFileNameExpanded
        Xml1.DocumentSource = m_sFileNameExpanded
        'Xml1.DocumentSource = m_sFileName



        Dim oFi As New FileInfo(m_sFileNameExpanded)
        If Not oFi.Exists Then
            'Create the file...
            '& "&ResolveName=" & DataBinder.Eval(Container.DataItem,"ResolveName") & "&ServiceVersion=" & DataBinder.Eval(Container.DataItem,"ServiceVersion") & "&ServiceName=" & DataBinder.Eval(Container.DataItem,"ServiceHandler") 
            Try
                ESB.Core.Util.File.Write(m_sFileNameExpanded, CreateServiceDefinition())
            Catch ex As Exception
                Throw ex 'New Exception("Service Definition ==>" & m_sFileNameExpanded & "<== does not exist.")
            End Try

        End If

    End Sub
End Class
