Imports Microsoft.ApplicationBlocks.ConfigurationManagement
Imports ESB.Core.Services.Server

Partial Class UserControls_InstanceSettingsUserControl
    Inherits System.Web.UI.UserControl

    Dim m_oCfgDataServicesServer As ESB.Core.Services.Server.CustomConfigurationData.CustomConfigurationData
    Dim m_ As String
    Dim m_File As String

    Public Sub New()
    End Sub
    'Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load, Me.Load
    '    'm_ = Request.Params("")
    '    '        m_ = lblTitle.Text

    '    m_File = Utils.ExpandRelativePath("Base/Configuration/XMLConfigFiles/" & m_ & ".config")

    '    GetConfigData()

    '    'only do this the first time...
    '    If Not IsPostBack Then
    '        'Label1.Text += " (" & m_ & ")"
    '        'Label1.Text = "Logging Devices (" & m_ & ")"

    '        ReadInstanceSettings()
    '    End If

    'End Sub
    Protected Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
        m_File = Utils.ExpandRelativePath("Base/Configuration/XMLConfigFiles/" & m_ & ".config")
        GetConfigData()
        ReadInstanceSettings()
    End Sub

    'Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load, Me.Load
    '    m_File = Utils.ExpandRelativePath("Base/Configuration/XMLConfigFiles/" & m_ & ".config")
    '    GetConfigData()
    '    ReadInstanceSettings()
    'End Sub

    Private Sub ReadInstanceSettings()
        'Can't be set here - it's the IIS Virtual Directory path...
        txtInstanceName.Enabled = False
        txtInstanceName.Text = Utils.GetInstanceName(Me.Context.Request.ApplicationPath)

        With m_oCfgDataServicesServer.ServerContext

            chkIsServiceDomainEntryPoint.Checked = .IsServiceDomainEntryPoint
            txtClusterName.Text = .ClusterName
            txtServiceDomainName.Text = .ServiceDomainName

            txtFullyQualifiedInstanceName.Text = .ServiceDomainName & "." & .ClusterName & "." & txtInstanceName.Text
        End With

    End Sub

    'Replace these methods with something that can handle multiple files of the same format...
    'i.e. just a file read & deserialize...
    'Don't really need? to protect from concurrent access, as only one Management Console will write to the file t  time
    'The server does not write to the file - just reads...
    Public Sub GetConfigData()
        Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil
        Dim oXmlDoc As New System.Xml.XmlDocument
        oXmlDoc.Load(m_File)

        m_oCfgDataServicesServer = oXmlUtil.DeSerialize(oXmlDoc.DocumentElement.ChildNodes(0).ChildNodes(0).OuterXml, GetType(CustomConfigurationData.CustomConfigurationData))

        If m_oCfgDataServicesServer Is Nothing Then
            Throw New ApplicationException("no config on provider.")
        End If
    End Sub
    Public Overridable Sub SaveConfigData()
        Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil

        '++Write the changes
        Dim oXmlWriter As New System.Xml.XmlTextWriter(m_File, System.Text.Encoding.UTF8)
        oXmlWriter.WriteStartDocument()
        oXmlWriter.WriteStartElement("configuration")
        oXmlWriter.WriteStartElement("ESB.Core.Services.Server")

        Dim oXmlDoc As New System.Xml.XmlDocument()
        oXmlDoc.LoadXml(oXmlUtil.Serialize(m_oCfgDataServicesServer))

        oXmlWriter.WriteRaw(oXmlDoc.DocumentElement.OuterXml())
        oXmlWriter.WriteEndElement()
        oXmlWriter.WriteEndElement()
        oXmlWriter.WriteEndDocument()
        oXmlWriter.Flush()
        oXmlWriter.Close()

        '--Write the changes

        '++Read file in & indent XML...
        My.Computer.FileSystem.WriteAllText(m_File, oXmlUtil.PrettyFormatXML(My.Computer.FileSystem.ReadAllText(m_File)), False)


    End Sub
    Protected Sub btnUpdateSettings_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnUpdateSettings.Click
        GetConfigData()
        With m_oCfgDataServicesServer.ServerContext

            .IsServiceDomainEntryPoint = chkIsServiceDomainEntryPoint.Checked
            .ClusterName = txtClusterName.Text
            .ServiceDomainName = txtServiceDomainName.Text()

        End With
        SaveConfigData()
    End Sub

    Public Enum eTransportAdaptor
        Wcf = 1 '"ESB.Core.Services.Server.Wcf"
        Wse3 = 2 ' "ESB.Core.Services.Server"
    End Enum

    Private m_sTransportAdaptorName As eTransportAdaptor
    Public Property TransportAdaptorName() As eTransportAdaptor
        Get
            Return m_sTransportAdaptorName
        End Get
        Set(ByVal value As eTransportAdaptor)
            m_sTransportAdaptorName = value

            If value = eTransportAdaptor.Wcf Then : m_ = "ESB.Core.Services.Server.Wcf" : End If
            If value = eTransportAdaptor.Wse3 Then : m_ = "ESB.Core.Services.Server" : End If
            lblTitle.Text = m_ & "   ( " & m_sTransportAdaptorName.ToString & " Transport )"
            m_File = Utils.ExpandRelativePath("Base/Configuration/XMLConfigFiles/" & m_ & ".config")

        End Set
    End Property


    Private m_bIsReadOnly As Boolean
    Public Property IsReadOnly() As Boolean
        Get
            Return m_bIsReadOnly
        End Get
        Set(ByVal value As Boolean)
            m_bIsReadOnly = value
            btnUpdateSettings.Enabled = Not value
            btnUpdateSettings.Visible = Not value
            LblInstanceCanNotBeEditedHere.Visible = Not value
            chkIsServiceDomainEntryPoint.Enabled = Not value
            txtClusterName.Enabled = Not value
            txtServiceDomainName.Enabled = Not value
            txtFullyQualifiedInstanceName.Enabled = Not value
        End Set
    End Property

    Public ReadOnly Property IsServiceDomainEntryPoint() As Boolean
        Get
            Return chkIsServiceDomainEntryPoint.Checked
        End Get
    End Property

    Public ReadOnly Property ServiceDomainName() As String
        Get
            Return txtServiceDomainName.Text
        End Get
    End Property

    Public ReadOnly Property ClusterName() As String
        Get
            Return txtClusterName.Text
        End Get
    End Property

    Public ReadOnly Property InstanceName() As String
        Get
            Return txtInstanceName.Text
        End Get
    End Property
    Public ReadOnly Property FullyQualifiedInstanceName() As String
        Get
            Return txtFullyQualifiedInstanceName.Text
        End Get
    End Property

End Class
