'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Imports System.IO
Imports ESB.Core.XMLSchemaClasses.Management

Namespace ESB.Management.Portal.UserControls

    Partial Class SendRequestUserControl
        Inherits System.Web.UI.UserControl

        Protected WithEvents btnSelectRequestFile As System.Web.UI.WebControls.Button

        Dim m_sThisInstance As String

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region


#Region " External Settings "

        Public ReadOnly Property Multiview() As MultiView
            Get
                Return MultiView1
            End Get
        End Property


        Private m_bShowRequestListTree As Boolean
        Public Property ShowRequestListTree() As Boolean
            Get
                Return m_bShowRequestListTree
            End Get
            Set(ByVal value As Boolean)
                m_bShowRequestListTree = value

                If value = False Then
                    'hide the tab and menu item
                    Menu1.Items.Item(0).Enabled = False
                    MultiView1.ActiveViewIndex = 1

                Else
                    'show the tab and menu item
                    Menu1.Items.Item(0).Enabled = True
                    MultiView1.ActiveViewIndex = 0
                End If

            End Set
        End Property



        Public Property RequestXml() As String
            Get
                Return txtXMLRequest.Text
            End Get
            Set(ByVal value As String)
                txtXMLRequest.Text = value
            End Set
        End Property


#End Region

#Region " General Methods "


        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            'Put user code to initialize the page here
            Dim oCtrl As System.Web.UI.Control
            Dim oCtrl2 As System.Web.UI.Control
            Dim oWebCtrl As System.Web.UI.WebControls.WebControl
            For Each oCtrl In Me.Controls
                Try
                    If oCtrl.HasControls Then
                        For Each oCtrl2 In oCtrl.Controls

                            Try
                                oWebCtrl = oCtrl2
                                oWebCtrl.Font.Size = GetFontSize()
                            Catch
                                'ignore if not a WebControl...
                            End Try
                        Next
                    End If
                    oWebCtrl = oCtrl
                    oWebCtrl.Font.Size = GetFontSize()
                Catch
                    'ignore if not a WebControl...
                End Try

            Next

            txtXMLRequest.Font.Size = GetFontSize()
            txtXMLResponse.Font.Size = GetFontSize()
            txtResponseTime.Font.Size = GetFontSize()
            txtRequestFilePath2.Font.Size = GetFontSize()


            If Me.IsPostBack = False Then
                'first time through
                PopulateTreeControl()
            End If

        End Sub

        Private Function GetFontSize() As System.Web.UI.WebControls.FontUnit
            Dim y As New System.Web.UI.WebControls.FontUnit
            Dim sFontValue As String = Session("FontSize")

            If sFontValue = "" Then
                Session("FontSize") = "XX-Small"
            End If

            sFontValue = Session("FontSize")

            y = System.Web.UI.WebControls.FontUnit.Parse(sFontValue)

            Return y

        End Function

        Private Sub PopulateTreeControl()
            Dim oNode As System.Web.UI.WebControls.TreeNode
            Dim oOuterFS As System.IO.DirectoryInfo

            Try

                Dim sPath As String
                sPath = Server.MapPath(Request.ApplicationPath) + "\Testing\XMLRequests\"

                oOuterFS = New System.IO.DirectoryInfo(sPath)
                Dim oOuterDir As DirectoryInfo
                Dim oInnerDir As DirectoryInfo
                Dim oFile As FileInfo

                Dim i As Long = 0
                For Each oOuterDir In oOuterFS.GetDirectories()

                    'Create the outer node...
                    oNode = New System.Web.UI.WebControls.TreeNode
                    oNode.Text = oOuterDir.Name
                    TreeView1.Nodes(0).ChildNodes.Add(oNode)

                    'iterate through the files in this directory...
                    oInnerDir = New System.IO.DirectoryInfo(oOuterDir.FullName)
                    For Each oFile In oInnerDir.GetFiles()
                        oNode = New System.Web.UI.WebControls.TreeNode
                        oNode.Text = oFile.Name
                        oNode.Value = oFile.FullName 'so we can pull the contents out of the file...
                        TreeView1.Nodes(0).ChildNodes(i).ChildNodes.Add(oNode)
                    Next
                    i += 1
                Next

            Catch ex As Exception
                Response.Write(ex.ToString)
            End Try

        End Sub

        Private Sub btnDisplayRequest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisplayRequest.Click

            Try

                Dim oFile As New ESB.Core.Util.File
                Dim sPath As String = TreeView1.SelectedValue

                txtRequestFilePath.Text = sPath
                txtRequestFilePath2.Text = sPath

                If sPath <> "" Then
                    txtXMLRequest.Text = ESB.Core.Util.File.Read(sPath)
                Else
                    Throw New Exception("Request file not specified.")
                End If
                txtXMLResponse.Text = ""


                MultiView1.ActiveViewIndex = 1
                Menu1.Items(1).Selected = True


            Catch ex As Exception
                txtXMLRequest.Text = ex.Message
            End Try

        End Sub

        Private Sub btnSendRequest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendRequest.Click
            Try

                '#If DEBUG Then
                '            System.Diagnostics.Debugger.Launch()
                '            System.Diagnostics.Debugger.Break()
                '#End If

                Dim oServer As New ESB.Core.Adaptors.Transport.RequestHandlerProxy.Sender(Session("SendUrl"), Session("TransportType"), Session("TransportClientEndPointName"))

                Dim oTimer As New ESB.Core.Util.Timer
                oTimer.StartTimer()
                Dim sXMLResponse As String = ""

                'Add in a Custom Parameter which tells the Send Transport Adaptors (if they choose to honour it...)
                'how many times to execute this request at their level
                'Note that they run their own loop, independent of the one in here.
                'That ensures all connection and data setup times are removed from those timings
                'Use the GetBaseContext.m_sExecutionTime to get those timings...
                Dim oEnv As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope
                oEnv.XML = txtXMLRequest.Text
                oEnv.SetCustomParam(ESBConstants.C_sClientNumExecutionTimes, txtNumExecutionTimesAdaptor.Text)

                If chkGenerateSenderMessageID.Checked = True Then
                    oEnv.MessageID = Guid.NewGuid.ToString
                End If

                If chkEnableSimulation.Checked = True Then
                    Dim oSim As New au.com.keystroke.esb.management.simulation.version_1_0_0_0.SimulationRq
                    oSim.ExecutionMode = au.com.keystroke.esb.management.simulation.version_1_0_0_0.SimulationRqExecutionMode.Simulate
                    oSim.ExecutionModeSpecified = True
                    oEnv.AddDocument(New ESB.Core.XMLSchemaClasses.InlineDocument(oSim))

                    'oEnv.SetCustomParam(C_sSimulation, "True")
                    'oEnv.SetCustomParam(C_sCustomParamESBCore, C_sSimulation, "True")
                End If

                '++Make the call
                For nExecutionTimes As Integer = 1 To txtNumExecutionTimes.Text
                    oServer.ProcessMsgSync(oEnv.XML, sXMLResponse)
                    '--Make the call
                Next

                oTimer.StopTimer()
                txtXMLResponse.Text = sXMLResponse

                Dim oXMLUtil As New ESB.Core.XMLSchemaClasses.XMLUtil
                txtXMLResponse.Text = oXMLUtil.PrettyFormatXML(sXMLResponse)
                txtResponseTime.Text = oTimer.Duration() & ";" & GetBaseContext.ExecutionTime

                Try
                    Dim oEnvRs As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope(sXMLResponse)
                    Dim sMsgID As String = oEnv.MessageID
                    If oEnv.MessageID = "" Then
                        sMsgID = oEnvRs.MessageID
                    End If
                    lnkViewLog.NavigateUrl = "~/Authenticated/System/Instrumentation/LogsManagement/ViewLogsDB3.aspx?SenderMessageID="
                    lnkViewLog.NavigateUrl += sMsgID

                Catch ex As Exception

                End Try

            Catch ex As Exception
                txtXMLResponse.Text = ex.ToString & Environment.NewLine & ex.StackTrace.ToString
            Finally
                'errors are displayed here as well...
                MultiView1.ActiveViewIndex = 2
                Menu1.Items(2).Selected = True
            End Try
        End Sub

        Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
            txtXMLRequest.Text = ""
            txtXMLResponse.Text = ""
            txtResponseTime.Text = ""
        End Sub

        Private Sub btnFormatRequestXML_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFormatRequestXML.Click
            Dim oEnv As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope
            txtXMLRequest.Text = oEnv.PrettyFormatXML(txtXMLRequest.Text)

        End Sub

        Private Sub btnFormatResponseXML_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFormatResponseXML.Click
            Dim oEnv As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope
            txtXMLResponse.Text = oEnv.PrettyFormatXML(txtXMLResponse.Text)
        End Sub

        Private Sub btnSaveRequest_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSaveRequest.Click
            Try
                ESB.Core.Util.File.Write(txtRequestFilePath2.Text, txtXMLRequest.Text)
            Catch ex As Exception
                txtXMLRequest.Text = ex.Message
            End Try
        End Sub

        Private Sub btnSaveResponse_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSaveResponse.Click
            Dim oFile As New ESB.Core.Util.File

            Try
                ESB.Core.Util.File.Write(txtRequestFilePath.Text & ".Response.xml", txtXMLResponse.Text)
            Catch ex As Exception
                txtXMLRequest.Text = ex.Message
            End Try
        End Sub

        Public Overridable Function GetBaseContext() As ESB.Core.Services.BaseContext
            Dim oContext As ESB.Core.Services.BaseContext
            oContext = CType(CType(ESB.Core.Services.ContextManager.getContextManager(), ESB.Core.Services.ContextManager).GetExistingContext, ESB.Core.Services.BaseContext)
            Return oContext
        End Function

        Protected Sub Menu1_MenuItemClick(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.MenuEventArgs) Handles Menu1.MenuItemClick
            MultiView1.ActiveViewIndex = e.Item.Value

        End Sub


        Protected Sub Menu1_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu1.PreRender

            For Each oItem As MenuItem In Menu1.Items
                If oItem.Selected = True Then
                    oItem.SeparatorImageUrl = "~/images/selectedtab.jpg"
                Else
                    oItem.SeparatorImageUrl = "~/images/unselectedtab.gif"
                End If
            Next
        End Sub

        Protected Sub View2_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles View2.PreRender
            Dim oEnv As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope(txtXMLRequest.Text)
            txtResolveName.Text = oEnv.ResolveName
            txtContext.Text = oEnv.Context
        End Sub
#End Region


        Protected Sub btnTestSerializeEnvelope_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnTestSerializeEnvelope.Click
            Dim oEnv As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope(txtXMLRequest.Text)

            Dim oEnv2 As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope

            oEnv2.XML = oEnv.XML

            txtXMLRequest.Text = oEnv2.PrettyFormatXML(oEnv2.ToXMLDocument.OuterXml)
            'txtXMLRequest.Text = oEnv.ToXMLDocument.OuterXml

        End Sub

        Protected Sub btnSwapToFromAddresses_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSwapToFromAddresses.Click
            Dim oEnv As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope(txtXMLRequest.Text)

            oEnv.SwapToAndFromAddresses()

            txtXMLRequest.Text = oEnv.PrettyFormatXML(oEnv.ToXMLDocument.OuterXml)
        End Sub


        'Protected Sub btnSaveRequestAs_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSaveRequestAs.Click
        '    Try

        '        ESB.Core.Util.File.Write(txtRequestFilePath2.Text, txtXMLRequest.Text)
        '    Catch ex As Exception
        '        txtXMLRequest.Text = ex.Message
        '    End Try
        'End Sub


        Protected Sub btnViewInServiceCatalog_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnViewInServiceCatalog.Click
            Response.Redirect(Request.ApplicationPath().ToLower & "/Authenticated/System/XMLConfigurationFiles/ManagePipelineCfg.aspx?ServiceName=" & txtContext.Text)
        End Sub

        Protected Sub btnInvalidateServicePipelineCache_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnInvalidateServicePipelineCache.Click
            'invalidates service pipeline cache
            TouchServicePipelineCfgFile()
        End Sub


        Private Function GetPipelineManagerCfgFilePath() As String
            Dim sPath As String
            sPath = System.Configuration.ConfigurationManager.AppSettings("ESBPiplineConfigurationPath")
            Utils.ExpandRelativePath(sPath)

            Return sPath
        End Function
        Private Function ReadCfgFileContents() As String
            Dim sPiplineCfgPath As String
            sPiplineCfgPath = GetPipelineManagerCfgFilePath()

            Dim oFile As New ESB.Core.Util.File
            Return Core.Util.File.Read(sPiplineCfgPath)

        End Function
        Private Sub TouchServicePipelineCfgFile()
            Dim sPiplineCfgPath As String
            sPiplineCfgPath = GetPipelineManagerCfgFilePath()
            lblTouchConfigFile.Text = ""
            Try
                ESB.Core.Util.File.Write(sPiplineCfgPath, ReadCfgFileContents())
            Catch ex As Exception
                lblTouchConfigFile.Text = "Failed to save Pipeline Configuration File"
            End Try
        End Sub


    End Class

End Namespace

