'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Imports System.IO

Partial Class UserControls_SetEndpointWebUserControl
    Inherits System.Web.UI.UserControl
    Dim m_sThisInstance As String


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        m_sThisInstance = GetInstanceName(Request.ApplicationPath)

        Dim sOldInstance As String
        Dim i As Integer
        Dim cnt As Integer

        cnt = drpSOAPURL.Items.Count()

        For i = 0 To cnt - 1
            sOldInstance = GetInstanceName(drpSOAPURL.Items(i).Text)
            drpSOAPURL.Items(i).Text = Replace(drpSOAPURL.Items(i).Text, sOldInstance, m_sThisInstance)
            drpSOAPURL.Items(i).Value = Replace(drpSOAPURL.Items(i).Value, sOldInstance, m_sThisInstance)
        Next i

        For i = 0 To cnt - 1
            sOldInstance = GetInstanceName(drpSOAPURL.Items(i).Text)
            drpSOAPURL.Items(i).Text = Replace(drpSOAPURL.Items(i).Text, "localhost", Request.Url.DnsSafeHost)
            drpSOAPURL.Items(i).Value = Replace(drpSOAPURL.Items(i).Value, "localhost", Request.Url.DnsSafeHost)
        Next i

        If Me.IsPostBack = False Then
            'first time through
            Session("SendUrl") = drpSOAPURL.SelectedValue
            rblWcfClientEndPointName_SelectedIndexChanged(Nothing, Nothing)
        End If
    End Sub
    Private Sub drpSOAPURL_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles drpSOAPURL.SelectedIndexChanged
        txtSOAPURL.Text = drpSOAPURL.SelectedValue
        Session("SendUrl") = txtSOAPURL.Text
    End Sub

    Private Sub btnCopyURL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCopyURL.Click
        txtSOAPURL.Text = drpSOAPURL.SelectedValue
        Session("SendUrl") = txtSOAPURL.Text
    End Sub

    Private Sub rblTransportType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rblTransportType.SelectedIndexChanged
        SetUrlForTransportType()
    End Sub
    Private Function GetInstanceName(ByVal sApplicationPath As String) As String
        Dim sThisInstance As String = ""
        Dim i As Integer = 0
        Dim sAppPath As String = ""
        Dim sSeparator As String = Format(Path.DirectorySeparatorChar)

        'eg. Request.ApplicationPath = "/ESB/ThisInstance/Manage"
        If InStr(sApplicationPath, "/") > 0 Then
            sAppPath = Replace(sApplicationPath, "/", sSeparator)
        End If

        If InStr(sApplicationPath, "\") > 0 Then
            sAppPath = Replace(sApplicationPath, "\", sSeparator)
        End If

        Dim myArray() As String = Split(sAppPath, sSeparator)

        For i = 0 To myArray.Length - 1
            If myArray(i) = "ESB" Then
                sThisInstance = myArray(i + 1)
                Exit For
            End If
        Next i

        GetInstanceName = sThisInstance

    End Function
    Private Sub btnSetUrlFromTextBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSetUrlFromTextBox.Click
        Session("SendUrl") = txtSOAPURL.Text
    End Sub

    Protected Sub rblWcfClientEndPointName_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles rblWcfClientEndPointName.SelectedIndexChanged
        SetToWcfTransportType()
        SetUrlForTransportType()
    End Sub

    Private Sub SetToWcfTransportType()
        If rblWcfClientEndPointName.Text = "ESBSoapXmlDocTransportSoapRM" Or rblWcfClientEndPointName.Text = "ESBSoapXmlDocTransportSoap" Then
            rblTransportType.Text = "SOAP"
        End If

    End Sub

    Private Sub SetUrlForWcfEndPointName()
        If rblWcfClientEndPointName.Text = "ESBSoapXmlDocTransportSoapRM" Then
            session("TransportClientEndPointName") = "ESBSoapXmlDocTransportSoapRM"

            SetDropListValue("http://" & Request.Url.DnsSafeHost & "/ESB/" & m_sThisInstance & "/CoreInternetTransportAdaptors/Wcf/ESBSoapXmlDocTransport.svc/Reliable")
        ElseIf rblWcfClientEndPointName.Text = "ESBSoapXmlDocTransportSoap" Then
            session("TransportClientEndPointName") = "ESBSoapXmlDocTransportSoap"

            SetDropListValue("http://" & Request.Url.DnsSafeHost & "/ESB/" & m_sThisInstance & "/CoreInternetTransportAdaptors/Wcf/ESBSoapXmlDocTransport.svc/Default")
        End If

    End Sub

    Private Sub SetDropListValue(ByVal sValue As String)
        If chkDisableSmartSettings.Checked = False Then
            'add to list if not exist...
            If drpSOAPURL.Items.FindByText(sValue) Is Nothing Then
                drpSOAPURL.Items.Add(sValue)
            End If
            drpSOAPURL.Text = sValue

        End If
    End Sub

    Private Sub SetUrlForTransportType()


        If rblTransportType.Text = "SOAP" Then
            session("TransportType") = "SOAP"
            SetUrlForWcfEndPointName()
        ElseIf rblTransportType.Text = "SOAP-WSE3" Then
            session("TransportType") = "SOAP-WSE3"
            SetDropListValue("http://" & Request.Url.DnsSafeHost & "/ESB/" & m_sThisInstance & "/CoreInternetTransportAdaptors/Wse3/ESBSoapXmlDocTransport.asmx")
        ElseIf rblTransportType.Text = "HTTP" Then
            session("TransportType") = "HTTP"
            SetDropListValue("http://" & Request.Url.DnsSafeHost & "/ESB/" & m_sThisInstance & "/CoreInternetTransportAdaptors/Wse3/ESBHttpTransport.aspx")
        ElseIf rblTransportType.Text = "INPROC" Then
            Session("TransportType") = "inproc"
            SetDropListValue("inproc://")
        End If

        Session("SendUrl") = drpSOAPURL.Text
        txtSOAPURL.Text = Session("SendUrl")
    End Sub
End Class
