''-----------------------------------------------------------------------------
'' <summary>
'' Copyright Keystroke IT 2003
'' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
'' </summary>
''-----------------------------------------------------------------------------
Option Explicit On 


Namespace ESB.Management.Portal

Partial  Class SimpleDataGridWebUserControl
    Inherits System.Web.UI.UserControl

    Dim ds As DataSet
    Dim lNumBaseColumns As Integer = 3
    Dim m_dsXMLFilePath As String
    Dim m_dsXMLStream As New System.IO.MemoryStream()
    Dim bUseStreamDataSource As Boolean = True  'otherwise use a file...

        Public m_lNumRowsPerPage As Integer = 5


    Dim m_del As Boolean = False
#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Public ReadOnly Property btnAdd() As System.Web.UI.WebControls.Button
        Get
            Return m_btnAdd
        End Get
    End Property

    Public ReadOnly Property dgMain() As System.Web.UI.WebControls.DataGrid
        Get
            Return m_dgMain
        End Get
    End Property

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Trace.Write("Page_Load")

        If m_dsXMLFilePath = "" Then
            'Response.Write("Data source file path has not been set...")
            Return
        End If
        'Response.Write("m_dsXMLFilePath =" & m_dsXMLFilePath & ".")
        If Me.IsPostBack = False Then
            ' do this only first time around...
            BindGrid()
        End If
    End Sub

    Private Sub dgMain_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m_dgMain.SelectedIndexChanged
        Trace.Write("dgMain_SelectedIndexChanged")

    End Sub

    Private Sub dgMain_DeleteCommand(ByVal source As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles m_dgMain.DeleteCommand
        Trace.Write("dgMain_DeleteCommand")
        'Here we cheat!
        'We update the datasource, then refresh it
        'we incur an extra round trip on the back end
        BindGrid()

        'The ItemIndex property does not get the overall value of the items in 
        'the whole grid, rather, it is an offset from the current page.
        'We need to multiply the current page index by the  m_lNumRowsPerPage (make this a property as well...)
        'and add the ItemIndex to it before deleting that row...

        'ds.Tables(0).Rows(e.Item.ItemIndex()).Delete()
        If ds.Tables.Count = 0 Then
            Exit Sub
        End If

        If ds.Tables(0).Rows.Count() = 0 Then
            Exit Sub
        End If

        ds.Tables(0).Rows(e.Item.ItemIndex() + m_lNumRowsPerPage * m_dgMain.CurrentPageIndex).Delete()

        Dim dsc As DataSet
        dsc = ds.GetChanges()

        If Not dsc Is Nothing Then
            'dsc = ds.GetChanges()
            dsc.WriteXml(m_dsXMLFilePath)

        Else

            If ds.Tables(0).Rows.Count = 0 Then
                'there's no data left...
                dsc = New DataSet
                dsc.WriteXml(m_dsXMLFilePath)
                BindGrid()

                Exit Sub
            End If
        End If
        BindGrid()

        m_dgMain.CurrentPageIndex = Math.Floor((ds.Tables(0).Rows.Count - 1) / m_lNumRowsPerPage)
        BindGrid()
        m_del = True

    End Sub
    Private Sub dgMain_UpdateCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles m_dgMain.UpdateCommand
        'End Sub
        'Private Sub dgMain_UpdateCommand(ByVal source As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        Trace.Write("dgMain_UpdateCommand")

        m_dgMain.EditItemIndex = -1
        'e.Item.ItemIndex() --> Gets the selected ROW...

        'update the row by iterating all the items...!!! CRAP...
        Dim oCell As TableCell
        Dim i As Integer = 0

        Dim dsupd As New DataSet

        'dsupd.ReadXml(m_dsXMLFilePath)
        ReadFromDataSet(dsupd)

        For Each oCell In m_dgMain.Items(e.Item.ItemIndex()).Cells
            If i > lNumBaseColumns - 1 Then
                'The ItemIndex property does not get the overall value of the items in 
                'the whole grid, rather, it is an offset from the current page.
                'We need to multiply the current page index by the  m_lNumRowsPerPage (make this a property as well...)
                'and add the ItemIndex to it before deleting that row...
                dsupd.Tables(0).Rows(e.Item.ItemIndex() + m_lNumRowsPerPage * m_dgMain.CurrentPageIndex).Item(i - lNumBaseColumns) = CType(e.Item.Cells(i).Controls(0), TextBox).Text
            End If
            i += 1
        Next

        Dim dsc As DataSet
        dsc = dsupd.GetChanges()
        'dsc.WriteXml(m_dsXMLFilePath)
        dsc.WriteXml(m_dsXMLFilePath)
        ReadFromDataSet(dsc)
        BindGrid()

    End Sub
    Private Sub m_dgMain_CancelCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles m_dgMain.CancelCommand
        Trace.Write("dgMain_CancelCommand")
        m_dgMain.EditItemIndex = -1
        BindGrid()
    End Sub

    Private Sub dgMain_EditCommand(ByVal source As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles m_dgMain.EditCommand
        Trace.Write("dgMain_EditCommand")
        m_dgMain.EditItemIndex = e.Item.ItemIndex
        BindGrid()
    End Sub

    Public Sub BindGrid()
        Trace.Write("BindGrid")
        Try
            ds = New DataSet
            'ds.ReadXml(m_dsXMLFilePath)
            ReadFromDataSet(ds)
            m_dgMain.DataSource = ds
            m_dgMain.DataBind()
                Trace.Write("update cmd name = " & DataGrid.UpdateCommandName)
        Catch ex As Exception
            Trace.Write("BindGrid::" & ex.ToString)
        Finally
        End Try
    End Sub

    Sub BindGridTemplate()
        Trace.Write("BindGrid")
        Try
            ds = New DataSet
            ReadFromDataSet(ds, m_dsXMLFilePath & ".Template")
            'ds.ReadXml(m_dsXMLFilePath & ".Template")
            m_dgMain.DataSource = ds
            m_dgMain.DataBind()
                Trace.Write("update cmd name = " & DataGrid.UpdateCommandName)
        Catch ex As Exception
            Trace.Write("BindGrid::" & ex.ToString)
        Finally
        End Try
    End Sub

    Private Sub dgMain_PageIndexChanged(ByVal source As System.Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles m_dgMain.PageIndexChanged
        ' Set CurrentPageIndex to the page the user clicked.
        Trace.Write("new page index =" & e.NewPageIndex)

        ds = New DataSet
        'ds.ReadXml(m_dsXMLFilePath)
        ReadFromDataSet(ds)

        If ds.Tables.Count = 0 Then
            Exit Sub
        End If
        If ds.Tables(0).Rows.Count() = 0 Then
            Exit Sub
        End If

        Dim lNumRows As Integer = 0
        lNumRows = ds.Tables(0).Rows.Count()

        Dim ldRem As Double = 0

        If m_del = True Then
            m_del = False

            Trace.Write("numrows=" & lNumRows)
            m_dgMain.CurrentPageIndex = Math.Floor((ds.Tables(0).Rows.Count - 1) / m_lNumRowsPerPage)

            ldRem = GetRemainder(ds.Tables(0).Rows.Count, m_lNumRowsPerPage) - 1

            'ldRem = System.Math.IEEERemainder(lNumRows, m_lNumRowsPerPage)
            Trace.Write("Remainder =" & ldRem)


            If ldRem > 0 Then
                m_dgMain.CurrentPageIndex = e.NewPageIndex
            Else
                m_dgMain.CurrentPageIndex = e.NewPageIndex - 1
            End If


        Else
            m_dgMain.CurrentPageIndex = e.NewPageIndex
        End If

        Trace.Write("dgMain.CurrentPageIndex  set to:" & m_dgMain.CurrentPageIndex)

        BindGrid()

        ' Rebind the data. 

        'Databind
    End Sub


    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m_btnAdd.Click
        BindGrid()

        'If there's no data, load up a dummy row from a template file
        'which has the number of columns we want...
        If ds.Tables.Count = 0 Then
            BindGridTemplate()
        Else
            ds.Tables(0).Rows.Add(ds.Tables(0).NewRow())
            Dim i As Integer = 0
            'For i = 0 To ds.Tables(0).Columns.Count - 1
            'ds.Tables(0).Rows(ds.Tables(0).Rows.Count - 1).Item(i) = i
            'Next
            ds.Tables(0).Rows(ds.Tables(0).Rows.Count - 1).Item(0) = ds.Tables(0).Rows.Count
        End If

        Dim dsc As DataSet
        dsc = ds.GetChanges()
        'dsc.WriteXml(m_dsXMLFilePath)

        SaveToDataSet(dsc)

        BindGrid()

        Dim ldRem As Double = 0
        ldRem = GetRemainder(ds.Tables(0).Rows.Count, m_lNumRowsPerPage) - 1
        m_dgMain.CurrentPageIndex = Math.Floor((ds.Tables(0).Rows.Count - 1) / m_lNumRowsPerPage)

        m_dgMain.EditItemIndex = CType(ldRem, Integer)
        BindGrid()
    End Sub

    Public Property DataSourceXMLFilePath() As String
        Get
            Return m_dsXMLFilePath
        End Get
        Set(ByVal sPath As String)
            m_dsXMLFilePath = sPath
            bUseStreamDataSource = False

        End Set
    End Property

    Public Property DataSourceXMLStream() As System.IO.Stream
        Get
            Return m_dsXMLStream
        End Get
        Set(ByVal oStream As System.IO.Stream)
            m_dsXMLStream = oStream
            bUseStreamDataSource = True

        End Set
    End Property

    Public Property DataSourceXMLString() As String
        Get
            Dim encoding As System.Text.Encoding = System.Text.Encoding.UTF8
            Dim sXMLString As String = encoding.GetString(m_dsXMLStream.ToArray())

            Return sXMLString
        End Get
        Set(ByVal sXMLString As String)
            'do this: m_dsXMLStream = sXMLString
            Dim encoding As System.Text.Encoding = System.Text.Encoding.UTF8
            Dim inputByteArray() As Byte = encoding.GetBytes(sXMLString)
            m_dsXMLStream = New System.IO.MemoryStream
            m_dsXMLStream.Write(inputByteArray, 0, inputByteArray.Length())

            bUseStreamDataSource = True
        End Set
    End Property


    Private Function GetRemainder(ByVal dNum As Double, ByVal dNumToDivideBy As Double) As Long
            Return dNum - Math.Floor(dNum / dNumToDivideBy) * dNumToDivideBy

    End Function

        Private Sub SaveToDataSet(ByRef ds As DataSet)

            If bUseStreamDataSource = True Then
                ds.WriteXml(m_dsXMLStream)
            Else
                ds.WriteXml(m_dsXMLFilePath)
            End If

        End Sub

        Private Sub ReadFromDataSet(ByRef ds As DataSet)

            If bUseStreamDataSource = True Then
                m_dsXMLStream.Position = 0
                Dim myXmlReader As New System.Xml.XmlTextReader(m_dsXMLStream)
                ' Read the XML document into the DataSet.
                ds.ReadXml(myXmlReader)
                ' Close the XmlTextReader
                'myXmlReader.Close()
                'ds.ReadXml(m_dsXMLStream)
            Else
                ds.ReadXml(m_dsXMLFilePath)
            End If


        End Sub

        Private Sub ReadFromDataSet(ByRef ds As DataSet, ByVal sFilePath As String)
            If bUseStreamDataSource = True Then
                'not valid!!!it'll probably die here...
                ds.ReadXml(m_dsXMLStream)

            Else
                ds.ReadXml(sFilePath)
            End If

        End Sub

    Sub ReadOnlyGrid()
        'Simpledatagridwebusercontrol1.btnAdd.Visible = False
        m_btnAdd.Visible = False
        'Remove those control columns required for updates...
        'Don't leave in the select column...because
        'when you press it, it enables the others again...
        'Simpledatagridwebusercontrol1.dgMain.Columns.RemoveAt(0)
        'Simpledatagridwebusercontrol1.dgMain.Columns.RemoveAt(0)
        'Simpledatagridwebusercontrol1.dgMain.Columns.RemoveAt(0)
        m_dgMain.Columns.RemoveAt(1)
        m_dgMain.Columns.RemoveAt(1)
        'dgMain.Columns.RemoveAt(0)

    End Sub




End Class

End Namespace

