'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Strict Off
Option Explicit On

Imports System.EnterpriseServices
Imports System.IO
Imports ESB.Core.XMLSchemaClasses
Imports ESB.Core.XMLSchemaClasses.Management
Imports System.Messaging
Imports System.Text
Imports System.Xml

Imports ESB.Core.Util
Imports System.Collections.Generic

Public Class BaseLogReader


    Private bDefaultQ As Boolean = True
    Dim m_sQName As String = "LogQ"
    Dim m_sQueueComputer As String = ""
    Dim m_sPrivateQ As String = "true"
    Public m_sc As New Collections.Specialized.StringCollection
    Public m_sMessageID As String = ""

    'TODO: Read from config file not registry
    Dim m_sMappingQPathName As String '= ESBRegistryConfig.Read("SOFTWARE\Keystroke\ESB\Queues", "ESBMessageIDToActivityIDmapQueue")
    Dim m_colActivityIDs As New Collections.Specialized.StringCollection

    Private m_oPlgLog As New CIMRetrieveLogsRS.CIMRetrieveLogsRS

    Public Function GetQPath() As String
        Dim sQPath As String
        Dim sQName As String
        Dim sQueueComputer As String
        Dim sPrivateQ As String

        sQName = m_sQName 'Request.Params("Queue")
        sQueueComputer = m_sQueueComputer 'Request.Params("host")
        sPrivateQ = m_sPrivateQ 'Request.Params("PrivateQ")

        If sQName = "" Then
            'sQName = ".\private$\LogQ"
            'todo:Read from Config file not registry
            'sQName = ESBRegistryConfig.Read("SOFTWARE\Keystroke\ESB\Logging", "QueuePathName")
            bDefaultQ = True

            Return sQName
        Else
            bDefaultQ = False
        End If

        If sQueueComputer <> "" Then
            sQPath = sQueueComputer & "\"
        Else
            sQPath = ".\"
        End If

        If sPrivateQ = "true" Then
            sQPath += "private$\"
        End If

        sQPath += sQName

        Return sQPath
    End Function

    'Populate an object that maps to the XML Schema for the Logging txn/info...
    Public Function GetLogData(ByRef oPlg As CIMRetrieveLogsRS.CIMRetrieveLogsRS) As String

        Dim msg As System.Messaging.Message = Nothing
        Dim sMsg As String = ""
        Dim sBld As New StringBuilder
        Dim sQPath As String = ""
        Dim mq As MessageQueue = Nothing
        Dim i As Long = 1

        Try
            sQPath = GetQPath()
            If (Not MessageQueue.Exists(sQPath)) Then
                LogError(LogDefs.eLogLevel.eLOG_ERROR, "The queue " & m_sMappingQPathName & " does not exist!")
                Return "The queue " & m_sMappingQPathName & " does not exist!"
            End If

            mq = New MessageQueue
            mq.Path = sQPath

            Dim ts As New TimeSpan(0, 0, 0, 0, 1000)
            Try

                'Get the list of ActivityID's for this messageID
                'm_colActivityIDs = GetActivityIDsForMessageID(m_sMessageID)

                Dim myEnumerator As MessageEnumerator = mq.GetMessageEnumerator2()

                m_oPlgLog.Instance = New List(Of ESB.Core.XMLSchemaClasses.Management.CIMRetrieveLogsRS.Instance)

                While myEnumerator.MoveNext()
                    msg = myEnumerator.Current()

                    Dim oStream As New System.IO.MemoryStream
                    oStream = msg.BodyStream()
                    Dim encoding As System.Text.Encoding = System.Text.Encoding.Unicode
                    'Get the string out of the current message
                    sMsg = encoding.GetString(oStream.ToArray())

                    If m_sMessageID = "" Or LogEntryIsForMessageID(sMsg) = True Then
                        'only return the message if the filter criteria matches...
                        'm_sc.Add("<Log>" & i & sMsg & "</Log>")

                        'need to create a CIMRetrieveLogsRS.CIMRetrieveLogsRS....object & populate it...
                        'PopulatePlugin(oPlg, sMsg, i)

                        'Get the string out of the current message
                        sMsg = "<Log>" & sMsg & "</Log>"

                        Dim oStream2 As New MemoryStream
                        Dim inputByteArray() As Byte = encoding.UTF8.GetBytes(sMsg)

                        oStream2.Write(inputByteArray, 0, inputByteArray.Length)
                        oStream2.Position = 0

                        'PopulatePlugin(oStream2, i)
                        PopulatePlugin(sMsg, i)
                        'PopulatePlugin(oPlg, oStream, i)

                        i += 1

                    End If
                End While

                oPlg = m_oPlgLog

                Return ""

            Catch ex As MessageQueueException
                If i > 1 Then
                    Return "There are no more messages in the queue"
                Else
                    Return "There are no messages in the queue"
                End If

                Exit Function
            Catch ex As InvalidOperationException
                Return "The message removed from the queue is not a string" & ex.ToString
                Exit Function
            End Try
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Return ex.ToString
        Finally
            mq.Close()
        End Try

    End Function

    'Populates a StringArray
    Public Function GetLogData() As String

        Dim msg As System.Messaging.Message
        Dim sMsg As String
        Dim sBld As New StringBuilder
        Dim sQPath As String
        Dim mq As MessageQueue = Nothing
        Dim i As Long = 1

        Try
            sQPath = GetQPath()
            If (Not MessageQueue.Exists(sQPath)) Then
                LogError(LogDefs.eLogLevel.eLOG_ERROR, "The queue " & m_sMappingQPathName & " does not exist!")
                Return Nothing
            End If

            mq = New MessageQueue
            mq.Path = sQPath

            Dim ts As New TimeSpan(0, 0, 0, 0, 1000)
            Try
                sBld.Append("<?xml version=""1.0"" ?>")
                sBld.Append("<Log>")
                sBld.Append(vbNewLine)

                'Get the list of ActivityID's for this messageID
                'm_colActivityIDs = GetActivityIDsForMessageID(m_sMessageID)


                Dim myEnumerator As MessageEnumerator = mq.GetMessageEnumerator2()

                While myEnumerator.MoveNext()
                    msg = myEnumerator.Current()

                    Dim oStream As New System.IO.MemoryStream
                    oStream = msg.BodyStream()
                    Dim encoding As System.Text.Encoding = System.Text.Encoding.Unicode
                    'Get the string out of the current message
                    sMsg = encoding.GetString(oStream.ToArray())

                    If m_sMessageID = "" Or LogEntryIsForMessageID(sMsg) = True Then
                        'only return the message if the filter criteria matches...

                        m_sc.Add("<Log>" & i & sMsg & "</Log>")
                        i += 1
                        'need to create a CIMRetrieveLogsRS.CIMRetrieveLogsRS....object & populate it...



                    End If
                End While

                'Write to logfile...
                Dim sLogFilePath As String
                sLogFilePath = Environment.ExpandEnvironmentVariables("%ProgramFiles%")
                ESB.Core.Util.File.Write(sLogFilePath & "\Keystroke\ESB\Base\LogFiles\Log.xml", sBld.ToString)

                Return ""

            Catch ex As MessageQueueException
                If i > 1 Then
                    Return "There are no more messages in the queue"
                Else
                    Return "There are no messages in the queue"
                End If

                Exit Function
            Catch ex As InvalidOperationException
                Return "The message removed from the queue is not a string" & ex.ToString
                Exit Function
            End Try
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Return ex.ToString
        Finally
            mq.Close()
        End Try

    End Function

    Public Function GetActivityIDsForMessageID(ByVal sMessageID As String, Optional ByRef colMsgArriveTime As Collections.Specialized.StringCollection = Nothing) As Collections.Specialized.StringCollection




        Dim msg As System.Messaging.Message
        Dim sMsg As String

        Dim mq As MessageQueue
        Dim i As Long = 1

        Dim colActivityIDs As New Collections.Specialized.StringCollection
        colMsgArriveTime = New Collections.Specialized.StringCollection

        If (Not MessageQueue.Exists(m_sMappingQPathName)) Then
            LogError(LogDefs.eLogLevel.eLOG_ERROR, "The queue " & m_sMappingQPathName & " does not exist!")
            Return Nothing
        End If

        mq = New MessageQueue

        Dim formatter As XmlMessageFormatter = CType(mq.Formatter, XmlMessageFormatter)
        formatter.TargetTypeNames = New String() {"System.String,mscorlib"}

        mq.MessageReadPropertyFilter.ArrivedTime = True
        mq.Path = m_sMappingQPathName

        Dim ts As New TimeSpan(0, 0, 0, 0, 1000)
        Try
            Dim myEnumerator As MessageEnumerator = mq.GetMessageEnumerator2()
            While myEnumerator.MoveNext()

                msg = myEnumerator.Current()

                'Dim oStream As New System.IO.MemoryStream()
                'oStream = msg.BodyStream()
                'Dim encoding As System.Text.Encoding = System.Text.Encoding.Unicode
                'Get the string out of the current message
                'sMsg = encoding.GetString(oStream.ToArray())

                sMsg = msg.Body

                'If sMsg.IndexOf(m_sMessageID) > 0 Then
                If GetMessageIDFromMessage(sMsg) = m_sMessageID Then
                    'This message in the Mapping Queue has a Mapping
                    'for our particular MessageID, so add it to the list
                    colActivityIDs.Add(GetActivityIDFromMessage(sMsg))
                    colMsgArriveTime.Add(msg.ArrivedTime())
                End If

            End While

            Return colActivityIDs

        Catch ex As MessageQueueException
            Throw New Exception("There are no messages in the queue")

            Exit Function
        Catch ex As InvalidOperationException
            Throw New Exception("The message removed from the queue is not a string" & ex.ToString)
            Exit Function

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Throw
            Exit Function

        Finally
            mq.Close()
        End Try

    End Function

    Public Function LogEntryIsForMessageID(ByVal sMessage As String) As Boolean
        'Check to see whether this LogEntry has one of the ActivityID's 
        'registered under this MessageID.
        Dim sActivityID As String = ""

        'Check to see if any of the ActivityID's in this collection
        'are in the message

        'For Each sActivityID In m_colActivityIDs
        If GetActivityIDFromMessage(sMessage) = sActivityID Then
            ' break at the first match...
            Return True
        End If
        'Next

        Return False

    End Function

    Public Function GetActivityIDFromMessage(ByVal sQueueMsg As String) As String
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID>
        'Dim sActivityID As String
        'Magic number - 12 = length of <ActivityID> tag
        'sActivityID = sQueueMsg.Substring(sQueueMsg.IndexOf("<ActivityID>") + 12, sQueueMsg.IndexOf("</ActivityID>") - sQueueMsg.IndexOf("<ActivityID>") - 12)
        'Return sActivityID

        Return GetField("ActivityID", sQueueMsg)

    End Function

    Public Function GetMessageIDFromMessage(ByVal sQueueMsg As String) As String
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID>
        'Dim sMessageID As String


        'Magic number - 11 = length of <MessageID> tag
        'sMessageID = sQueueMsg.Substring(sQueueMsg.IndexOf("<MessageID>") + 11, sQueueMsg.IndexOf("</MessageID>") - sQueueMsg.IndexOf("<MessageID>") - 11)
        'Return sMessageID

        Return GetField("MessageID", sQueueMsg)

    End Function


    'Public Function PopulatePlugin(ByRef oPlgLog As CIMRetrieveLogsRQ.CIMRetrieveLogsRQ, ByRef sLogMessage As String, ByVal lLogEntry As Long)
    Public Function PopulatePlugin(ByRef oLogMessageStream As MemoryStream, ByVal lLogEntry As Long) As String
        Return ""

        'This is the format of our log messages...
        '<Log>
        '<Timestamp>2003:4:14:16:4:12:062 </Timestamp>
        '<PID>2628</PID>
        '<TID>952</TID>
        '<ComputerName>SV-NSYD-WIN2K5</ComputerName>
        '<ActivityID>{EA146A42-AF52-47D1-85ED-4928C317B531}</ActivityID>
        '<Error>0</Error>
        '<LogText>SOAPAdaptorRecv::ManagerWrapper::ProcessMsgSynch::Start</LogText>
        '</Log>

        'use an XMLReader... to parse the log etc...

        'PopulateXML(oLogMessageStream)
        'Dim s As String = PrettyFormatXML(oLogMessageStream)

        'Dim reader As New XmlTextReader(oLogMessageStream)

        'Dim writer As New StringWriter()

    End Function

    Public Sub PopulatePlugin(ByRef sXML As String, ByVal lLogEntry As Long)
        PopulateXML(sXML, lLogEntry)
    End Sub

    Public Sub PopulateXML(ByRef sXML As String, ByVal lLogEntry As Long)
        Dim i As Long = 0

        Dim sTabPrefix As String = "" 'vbTab

        Dim bIsElementError As Boolean = False

        Dim oLogEntry As ESB.Core.XMLSchemaClasses.Management.CIMRetrieveLogsRS.LogEntry

        Try

            oLogEntry = New ESB.Core.XMLSchemaClasses.Management.CIMRetrieveLogsRS.LogEntry
            ' oLogEntry.HostNam = GetField("ComputerName", sXML)
            oLogEntry.DateTime = GetField("Timestamp", sXML)
            oLogEntry.PID = GetField("PID", sXML)
            oLogEntry.TID = GetField("TID", sXML)
            oLogEntry.ActivityID = GetField("ActivityID", sXML)

            If GetField("LogText", sXML) = "1" Then
                oLogEntry.Status = "Error"
            Else
                oLogEntry.Status = ""
            End If
            oLogEntry.LogText = GetField("LogText", sXML)

            oLogEntry.ID = lLogEntry

            Dim lSummaryLen As Long = 0
            If oLogEntry.LogText.Length >= 49 Then
                lSummaryLen = 49
            Else
                lSummaryLen = oLogEntry.LogText.Length - 1
            End If
            oLogEntry.Summary = oLogEntry.LogText.Substring(0, lSummaryLen)

            m_oPlgLog.Instance(0).LogEntry.Add(oLogEntry)



        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Throw
        Finally

        End Try

    End Sub

    Private Function GetField(ByRef sFieldName As String, ByVal sMsg As String) As String

        Dim arr() As String
        arr = Split(sMsg, "<" & sFieldName & ">")

        Dim s1 As String
        s1 = arr(1)

        Dim arr2() As String
        arr2 = Split(s1, "</" & sFieldName & ">")

        Dim s2 As String
        s2 = arr2(0)


        Return s2


    End Function


    Public Overridable Overloads Function PrettyFormatXML(ByRef oStream As MemoryStream, Optional ByVal bXMLDOMParseFirst As Boolean = True) As String

        'bXMLDOMParseFirst 
        'Not good for large XML (100's of KBytes,MBytes etc.) as it does an XMLDOM parse etc...
        'Default to using it though till we fix the other way. Not using the XMLDom 
        'results in non-well formed XML being produced for Empty XML nodes written in
        'shorthand such as <aaa/>. It leaves out the / at some point making the
        'XML useless...!!!

        If bXMLDOMParseFirst = True Then
            Dim oXMLDoc As New XmlDocument
            oXMLDoc.Load(oStream)

            Dim Strwriter As New StringWriter
            Dim XMLwriter As New XmlTextWriter(Strwriter)
            XMLwriter.Formatting = Formatting.Indented
            oXMLDoc.Save(XMLwriter)

            Dim buf2 As String = Strwriter.ToString
            Strwriter.Close()

            Return buf2
        End If


        'TODO: Fix this thing below...
        'results in non-well formed XML being produced for Empty XML nodes written in
        'shorthand such as <aaa/>. It leaves out the / at some point making the
        'XML useless...!!!

        Dim reader As New XmlTextReader(oStream)
        Dim writer As New StringWriter
        Dim sTabPrefix As String = "" 'vbTab

        While reader.Read()

            If reader.NodeType = XmlNodeType.Element Or reader.NodeType = XmlNodeType.XmlDeclaration Then
                sTabPrefix = New String(vbTab, reader.Depth)
                'writer.WriteLine("{0}<{1}>", sTabPrefix, reader.Name)

                If reader.NodeType = XmlNodeType.Element And reader.NodeType = XmlNodeType.EndElement Then
                    writer.Write("{0}<{1}/>", sTabPrefix, Trim(reader.Name))
                Else
                    writer.Write("{0}<{1}", sTabPrefix, Trim(reader.Name))
                End If

                If reader.HasAttributes Then
                    While reader.MoveToNextAttribute()
                        'Dim i As Long = 0
                        'If i > 0 Then
                        '    writer.Write(",")
                        'End If
                        writer.Write(" ")
                        writer.Write(Trim(reader.Name))
                        writer.Write("=""")
                        writer.Write(Trim(reader.Value))
                        writer.Write("""")
                        'i += 1
                    End While
                    reader.MoveToElement()
                End If
                writer.WriteLine(">")

            Else
                If reader.NodeType = XmlNodeType.Text Then
                    sTabPrefix = New String(vbTab, reader.Depth + 1)
                    writer.WriteLine("{0}{1}", sTabPrefix, Trim(reader.Value))
                End If
                If reader.NodeType = XmlNodeType.EndElement Then
                    sTabPrefix = New String(vbTab, reader.Depth)
                    writer.WriteLine("{0}</{1}>", sTabPrefix, Trim(reader.Name))
                End If
            End If
        End While

        Dim buf As String = writer.ToString
        writer.Close()
        reader.Close()

        Return buf

    End Function


    Public Overloads Function PrettyFormatXML(ByVal sXML As String) As String
        Dim oStream As New MemoryStream
        Dim inputByteArray() As Byte = Encoding.UTF8.GetBytes(sXML)

        oStream.Write(inputByteArray, 0, inputByteArray.Length)
        oStream.Position = 0

        Return PrettyFormatXML(oStream)
    End Function


End Class
