'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Strict Off
Option Explicit On 

Imports System.EnterpriseServices
Imports System.IO
'Imports ESB.Base
Imports ESB.core.XMLSchemaClasses
Imports ESB.core.XMLSchemaClasses.Management
Imports System.Messaging
Imports System.Text
Imports System.Xml

Imports ESB.core.Util
Imports Microsoft.ApplicationBlocks.ConfigurationManagement
Imports ESB.Core.Services.Server

Public Class LogHelper


    Private bDefaultQ As Boolean = True
    Dim m_sQName As String = "LogQ"
    Dim m_sQueueComputer As String = ""
    Dim m_sPrivateQ As String = "true"
    Public m_sc As New Collections.Specialized.StringCollection
    Public m_sMessageID As String = ""

    Dim m_sMappingQPathName As String
    Dim m_colActivityIDs As New Collections.Specialized.StringCollection

    Private m_oPlgLog As New CIMRetrieveLogsRS.CIMRetrieveLogsRS
    Dim m_oCfgDataServicesServer As ESB.Core.Services.Server.CustomConfigurationData.CustomConfigurationData

    Public Sub New()
        GetConfigData()
        m_sMappingQPathName = m_oCfgDataServicesServer.MSMQSystemEntryPoint.MessageIDToActivityIDmapQueue
    End Sub

    Public Function GetQPath() As String
        Dim sQPath As String
        Dim sQName As String
        Dim sQueueComputer As String
        Dim sPrivateQ As String

        sQName = m_sQName 'Request.Params("Queue")
        sQueueComputer = m_sQueueComputer 'Request.Params("host")
        sPrivateQ = m_sPrivateQ 'Request.Params("PrivateQ")

        If sQName = "" Then
            'sQName = ".\private$\LogQ"
            'sQName = ESBRegistryConfig.Read("SOFTWARE\Keystroke\ESB\Logging", "QueuePathName")
            sQName = System.Configuration.ConfigurationManager.AppSettings("MSMQLoggerQueuePathName")

            bDefaultQ = True

            Return sQName
        Else
            bDefaultQ = False
        End If

        If sQueueComputer <> "" Then
            sQPath = sQueueComputer & "\"
        Else
            sQPath = ".\"
        End If

        If sPrivateQ = "true" Then
            sQPath += "private$\"
        End If

        sQPath += sQName

        Return sQPath
    End Function

    'Populate an object that maps to the XML Schema for the Logging txn/info...
    Public Function GetLogData(ByRef oPlg As CIMRetrieveLogsRS.CIMRetrieveLogsRS)

        Dim msg As System.Messaging.Message
        Dim sMsg As String
        Dim sBld As New StringBuilder
        Dim sQPath As String
        Dim mq As MessageQueue
        Dim i As Long = 1

        Try

            sQPath = GetQPath()
            If (Not MessageQueue.Exists(sQPath)) Then
                If ShouldLog(LogDefs.eLogLevel.eLOG_ERROR) Then : LogMsg(LogDefs.eLogLevel.eLOG_ERROR, "The queue " & m_sMappingQPathName & " does not exist!") : End If
                Return "The queue " & m_sMappingQPathName & " does not exist!"
            End If

            mq = New MessageQueue
            mq.Path = sQPath

            Dim formatter As XmlMessageFormatter = CType(mq.Formatter, XmlMessageFormatter)
            formatter.TargetTypeNames = New String() {"System.String,mscorlib"}


            Dim ts As New TimeSpan(0, 0, 0, 0, 1000)
            Try

                'Get the list of ActivityID's for this messageID
                m_colActivityIDs = GetActivityIDsForMessageID(m_sMessageID)

                Dim myEnumerator As MessageEnumerator = mq.GetMessageEnumerator2()

                m_oPlgLog.Host = New ESB.core.XMLSchemaClasses.Management.CIMRetrieveLogsRS.Host(0) {}
                m_oPlgLog.Host(0) = New ESB.core.XMLSchemaClasses.Management.CIMRetrieveLogsRS.Host

                While myEnumerator.MoveNext()
                    msg = myEnumerator.Current()

                    sMsg = GetLogMsg(msg)

                    If m_sMessageID = "" Or LogEntryIsForMessageID(sMsg) = True Then
                        'only return the message if the filter criteria matches...
                        'm_sc.Add("<Log>" & i & sMsg & "</Log>")

                        'need to create a CIMRetrieveLogsRS.CIMRetrieveLogsRS....object & populate it...

                        'Get the string out of the current message
                        sMsg = "<Log>" & sMsg & "</Log>"

                        Dim oStream2 As New MemoryStream
                        Dim inputByteArray() As Byte = Encoding.UTF8.GetBytes(sMsg)

                        oStream2.Write(inputByteArray, 0, inputByteArray.Length)
                        oStream2.Position = 0

                        PopulatePlugin(sMsg, i)

                        i += 1

                    End If
                End While

                oPlg = m_oPlgLog

                Return ""

            Catch ex As MessageQueueException
                If i > 1 Then
                    Return "There are no more messages in the queue"
                Else
                    Return "There are no messages in the queue"
                End If

                Exit Function
            Catch ex As InvalidOperationException
                Return "The message removed from the queue is not a string" & ex.ToString
                Exit Function
            End Try
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Return ex.tostring
        Finally
            mq.Close()
        End Try

    End Function

    'Populates a StringArray
    Public Function GetLogData()

        Dim msg As System.Messaging.Message
        Dim sMsg As String
        Dim sBld As New StringBuilder
        Dim sQPath As String
        Dim mq As MessageQueue
        Dim i As Long = 1

        Try

            sQPath = GetQPath()
            If (Not MessageQueue.Exists(sQPath)) Then
                If ShouldLog(LogDefs.eLogLevel.eLOG_ERROR) Then : LogError(LogDefs.eLogLevel.eLOG_ERROR, "The queue " & m_sMappingQPathName & " does not exist!") : End If
                Return "The queue " & m_sMappingQPathName & " does not exist!"
            End If

            mq = New MessageQueue
            mq.Path = sQPath
            Dim formatter As XmlMessageFormatter = CType(mq.Formatter, XmlMessageFormatter)

            Dim ts As New TimeSpan(0, 0, 0, 0, 1000)
            Try
                sBld.Append("<?xml version=""1.0"" ?>")
                sBld.Append("<Log>")
                sBld.Append(vbNewLine)

                'Get the list of ActivityID's for this messageID
                'm_colActivityIDs = GetActivityIDsForMessageID(m_sMessageID)


                Dim myEnumerator As MessageEnumerator = mq.GetMessageEnumerator2()

                While myEnumerator.MoveNext()
                    msg = myEnumerator.Current()

                    sMsg = GetLogMsg(msg)

                    If m_sMessageID = "" Or LogEntryIsForMessageID(sMsg) = True Then
                        'only return the message if the filter criteria matches...

                        m_sc.Add("<Log>" & i & sMsg & "</Log>")
                        i += 1
                        'need to create a CIMRetrieveLogsRS.CIMRetrieveLogsRS....object & populate it...



                    End If
                End While

                'Write to logfile...
                Dim oFile As New ESB.core.Util.File
                Dim sLogFilePath As String
                sLogFilePath = Environment.ExpandEnvironmentVariables("%ProgramFiles%")
                oFile.Write(sLogFilePath & "\Keystroke\ESB\Base\LogFiles\Log.xml", sBld.ToString)

                Return ""

            Catch ex As MessageQueueException
                If i > 1 Then
                    Return "There are no more messages in the queue"
                Else
                    Return "There are no messages in the queue"
                End If

                Exit Function
            Catch ex As InvalidOperationException
                Return "The message removed from the queue is not a string" & ex.ToString
                Exit Function
            End Try
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Return ex.tostring
        Finally
            mq.Close()
        End Try

    End Function

    Public Function GetActivityIDsForMessageID(ByVal sMessageID As String, Optional ByRef colMsgArriveTime As Collections.Specialized.StringCollection = Nothing) As Collections.Specialized.StringCollection




        Dim msg As System.Messaging.Message
        Dim sMsg As String

        Dim mq As MessageQueue
        Dim i As Long = 1

        Dim colActivityIDs As New Collections.Specialized.StringCollection
        colMsgArriveTime = New Collections.Specialized.StringCollection

        If (Not MessageQueue.Exists(m_sMappingQPathName)) Then
            If ShouldLog(LogDefs.eLogLevel.eLOG_ERROR) Then : LogError(LogDefs.eLogLevel.eLOG_ERROR, "The queue " & m_sMappingQPathName & " does not exist!") : End If
            Return Nothing
        End If

        mq = New MessageQueue

        Dim formatter As XmlMessageFormatter = CType(mq.Formatter, XmlMessageFormatter)
        formatter.TargetTypeNames = New String() {"System.String,mscorlib"}

        mq.MessageReadPropertyFilter.ArrivedTime = True
        mq.Path = m_sMappingQPathName

        Dim ts As New TimeSpan(0, 0, 0, 0, 1000)
        Try
            Dim myEnumerator As MessageEnumerator = mq.GetMessageEnumerator2()
            While myEnumerator.MoveNext()

                msg = myEnumerator.Current()
                sMsg = GetLogMsg(msg)

                'If sMsg.IndexOf(m_sMessageID) > 0 Then
                If GetMessageIDFromMessage(sMsg) = m_sMessageID Then
                    'This message in the Mapping Queue has a Mapping
                    'for our particular MessageID, so add it to the list
                    colActivityIDs.Add(GetActivityIDFromMessage(sMsg))
                    colMsgArriveTime.Add(msg.ArrivedTime())
                End If

            End While

            Return colActivityIDs

        Catch ex As MessageQueueException
            Throw New Exception("There are no messages in the queue")

        Catch ex As InvalidOperationException
            Throw New Exception("The message removed from the queue is not a string" & ex.ToString)

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Throw
        Finally
            mq.Close()
        End Try

    End Function
    Public Function GetActivityIDsForInternalMessageID(ByVal sIntMsgID As String, Optional ByRef colMsgArriveTime As Collections.Specialized.StringCollection = Nothing) As Collections.Specialized.StringCollection

        Dim msg As System.Messaging.Message
        Dim sMsg As String

        Dim mq As MessageQueue
        Dim i As Long = 1

        Dim colActivityIDs As New Collections.Specialized.StringCollection
        colMsgArriveTime = New Collections.Specialized.StringCollection

        If (Not MessageQueue.Exists(m_sMappingQPathName)) Then
            If ShouldLog(LogDefs.eLogLevel.eLOG_ERROR) Then : LogError(LogDefs.eLogLevel.eLOG_ERROR, "The queue " & m_sMappingQPathName & " does not exist!") : End If
            Return Nothing
        End If

        mq = New MessageQueue

        Dim formatter As XmlMessageFormatter = CType(mq.Formatter, XmlMessageFormatter)
        formatter.TargetTypeNames = New String() {"System.String,mscorlib"}

        mq.MessageReadPropertyFilter.ArrivedTime = True
        mq.Path = m_sMappingQPathName

        Dim ts As New TimeSpan(0, 0, 0, 0, 1000)
        Try
            Dim myEnumerator As MessageEnumerator = mq.GetMessageEnumerator2()
            While myEnumerator.MoveNext()

                msg = myEnumerator.Current()
                sMsg = GetLogMsg(msg)

                If GetInternalMessageIDFromMessage(sMsg) = sIntMsgID Then
                    colActivityIDs.Add(GetActivityIDFromMessage(sMsg))
                    colMsgArriveTime.Add(msg.ArrivedTime())
                End If

            End While

            Return colActivityIDs

        Catch ex As MessageQueueException
            Throw New Exception("There are no messages in the queue")

        Catch ex As InvalidOperationException
            Throw New Exception("The message removed from the queue is not a string" & ex.ToString)

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Throw
        Finally
            mq.Close()
        End Try

    End Function

    Public Function LogEntryIsForMessageID(ByVal sMessage As String) As Boolean
        'Check to see whether this LogEntry has one of the ActivityID's 
        'registered under this MessageID.
        Dim sActivityID As String

        'Check to see if any of the ActivityID's in this collection
        'are in the message

        For Each sActivityID In m_colActivityIDs
            If GetActivityIDFromMessage(sMessage) = sActivityID Then
                ' break at the first match...
                Return True
            End If
        Next

        Return False

    End Function

    Public Function GetActivityIDFromMessage(ByVal sQueueMsg As String) As String
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID>
        'Dim sActivityID As String
        'Magic number - 12 = length of <ActivityID> tag
        'sActivityID = sQueueMsg.Substring(sQueueMsg.IndexOf("<ActivityID>") + 12, sQueueMsg.IndexOf("</ActivityID>") - sQueueMsg.IndexOf("<ActivityID>") - 12)
        'Return sActivityID

        Return GetField("ActivityID", sQueueMsg)

    End Function

    Public Function GetMessageIDFromMessage(ByVal sQueueMsg As String) As String
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID>
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID><Status>Error/Warning/OK</Status>

        Return GetField("MessageID", sQueueMsg)

    End Function

    Public Function GetInternalMessageIDFromMessage(ByVal sQueueMsg As String) As String
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID>
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID><Status>Error/Warning/OK</Status>

        Return GetField("InternalMessageID", sQueueMsg)

    End Function


    Public Function GetStatusFromMessage(ByVal sQueueMsg As String) As String
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID>
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID><Status>Error/Warning/OK</Status>
        Try
            Return GetField("Status", sQueueMsg)
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Return ""
        End Try

    End Function

    Public Function GetResolveNameFromMessage(ByVal sQueueMsg As String) As String
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID>
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID><Status>Error/Warning/OK</Status>

        Return GetField("ResolveName", sQueueMsg)

    End Function
    Public Function GetContextFromMessage(ByVal sQueueMsg As String) As String
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID>
        '<MessageID>aaaaaaaa</MessageID><ActivityID>bbbbbbbbbb</ActivityID><Status>Error/Warning/OK</Status>

        Return GetField("Context", sQueueMsg)

    End Function


    Public Function PopulatePlugin(ByRef oLogMessageStream As MemoryStream, ByVal lLogEntry As Long) As String
        Return ""
        'This is the format of our log messages...
        '<Log>
        '<Timestamp>2003:4:14:16:4:12:062 </Timestamp>
        '<PID>2628</PID>
        '<TID>952</TID>
        '<ComputerName>SV-NSYD-WIN2K5</ComputerName>
        '<ActivityID>{EA146A42-AF52-47D1-85ED-4928C317B531}</ActivityID>
        '<Error>0</Error>
        '<LogText>SOAPAdaptorRecv::ManagerWrapper::ProcessMsgSynch::Start</LogText>
        '</Log>

        'use an XMLReader... to parse the log etc...

        'PopulateXML(oLogMessageStream)
        'Dim s As String = PrettyFormatXML(oLogMessageStream)

        'Dim reader As New XmlTextReader(oLogMessageStream)

        'Dim writer As New StringWriter()

    End Function

    Public Sub PopulatePlugin(ByRef sXML As String, ByVal lLogEntry As Long)
        PopulateXML(sXML, lLogEntry)
    End Sub

    Public Sub PopulateXML(ByRef sXML As String, ByVal lLogEntry As Long)
        Dim i As Long = 0

        Dim sTabPrefix As String = "" 'vbTab

        Dim bIsElementError As Boolean = False

        Dim oLogEntry As ESB.Core.XMLSchemaClasses.Management.CIMRetrieveLogsRS.LogEntry

        Try

            oLogEntry = New ESB.Core.XMLSchemaClasses.Management.CIMRetrieveLogsRS.LogEntry
            oLogEntry.HostName = GetField("ComputerName", sXML)
            oLogEntry.DateTime = GetField("Timestamp", sXML)
            oLogEntry.PID = GetField("PID", sXML)
            oLogEntry.TID = GetField("TID", sXML)
            oLogEntry.ActivityID = GetField("ActivityID", sXML)


            oLogEntry.Status = GetField("Status", sXML)
            'If GetField("Status", sXML).Trim.ToUpper <> "OK" Then
            '    oLogEntry.Status = "Error"
            'Else
            '    oLogEntry.Status = "OK"
            'End If
            oLogEntry.LogText = GetField("LogText", sXML)

            oLogEntry.ID = lLogEntry

            Dim lSummaryLen As Long = 0
            If oLogEntry.LogText.Length >= 49 Then
                lSummaryLen = 49
            Else
                lSummaryLen = oLogEntry.LogText.Length - 1
            End If
            oLogEntry.Summary = oLogEntry.LogText.Substring(0, lSummaryLen)

            m_oPlgLog.Host(0).Log.Add(oLogEntry)



        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Throw
        Finally

        End Try

    End Sub

    Private Function GetField(ByRef sFieldName As String, ByVal sMsg As String) As String

        Try
            Dim arr() As String
            arr = Split(sMsg, "<" & sFieldName & ">")

            Dim s1 As String
            s1 = arr(1)

            Dim arr2() As String
            arr2 = Split(s1, "</" & sFieldName & ">")

            Dim s2 As String
            s2 = arr2(0)


            Return s2
        Catch ex As Exception
            Return ""
        Finally
        End Try

    End Function


    Public Overridable Overloads Function PrettyFormatXML(ByRef oStream As MemoryStream, Optional ByVal bXMLDOMParseFirst As Boolean = True) As String

        'bXMLDOMParseFirst 
        'Not good for large XML (100's of KBytes,MBytes etc.) as it does an XMLDOM parse etc...
        'Default to using it though till we fix the other way. Not using the XMLDom 
        'results in non-well formed XML being produced for Empty XML nodes written in
        'shorthand such as <aaa/>. It leaves out the / at some point making the
        'XML useless...!!!

        If bXMLDOMParseFirst = True Then
            Dim oXMLDoc As New XmlDocument
            oXMLDoc.Load(oStream)

            Dim Strwriter As New StringWriter
            Dim XMLwriter As New XmlTextWriter(Strwriter)
            XMLwriter.Formatting = Formatting.Indented
            oXMLDoc.Save(XMLwriter)

            Dim buf2 As String = Strwriter.ToString
            Strwriter.Close()

            Return buf2
        End If


        'TODO: Fix this thing below...
        'results in non-well formed XML being produced for Empty XML nodes written in
        'shorthand such as <aaa/>. It leaves out the / at some point making the
        'XML useless...!!!

        Dim reader As New XmlTextReader(oStream)
        Dim writer As New StringWriter
        Dim sTabPrefix As String = "" 'vbTab

        While reader.Read()

            If reader.NodeType = XmlNodeType.Element Or reader.NodeType = XmlNodeType.XmlDeclaration Then
                sTabPrefix = New String(vbTab, reader.Depth)
                'writer.WriteLine("{0}<{1}>", sTabPrefix, reader.Name)

                'If reader.NodeType = XmlNodeType.Element And reader.NodeType = XmlNodeType.EndElement Then

                If reader.NodeType = XmlNodeType.EndElement Then
                    writer.Write("{0}<{1}/>", sTabPrefix, Trim(reader.Name))
                Else
                    writer.Write("{0}<{1}", sTabPrefix, Trim(reader.Name))
                End If

                If reader.HasAttributes Then
                    While reader.MoveToNextAttribute()
                        'Dim i As Long = 0
                        'If i > 0 Then
                        '    writer.Write(",")
                        'End If
                        writer.Write(" ")
                        writer.Write(Trim(reader.Name))
                        writer.Write("=""")
                        writer.Write(Trim(reader.Value))
                        writer.Write("""")
                        'i += 1
                    End While
                    reader.MoveToElement()
                End If
                writer.WriteLine(">")

            Else
                If reader.NodeType = XmlNodeType.Text Then
                    sTabPrefix = New String(vbTab, reader.Depth + 1)
                    writer.WriteLine("{0}{1}", sTabPrefix, Trim(reader.Value))
                End If
                If reader.NodeType = XmlNodeType.EndElement Then
                    sTabPrefix = New String(vbTab, reader.Depth)
                    writer.WriteLine("{0}</{1}>", sTabPrefix, Trim(reader.Name))
                End If
            End If
        End While

        Dim buf As String = writer.ToString
        writer.Close()
        reader.Close()

        Return buf

    End Function


    Public Overloads Function PrettyFormatXML(ByVal sXML As String) As String
        Dim oStream As New MemoryStream
        Dim inputByteArray() As Byte = Encoding.UTF8.GetBytes(sXML)

        oStream.Write(inputByteArray, 0, inputByteArray.Length)
        oStream.Position = 0

        Return PrettyFormatXML(oStream)
    End Function


    Public Overridable Sub GetConfigData()
        Dim sourceSection As String = "ESB.Core.Services.Server.Wcf"

        m_oCfgDataServicesServer = CType(ConfigurationManager.Read(sourceSection), ESB.Core.Services.Server.CustomConfigurationData.CustomConfigurationData)
        If m_oCfgDataServicesServer Is Nothing Then
            Throw New ApplicationException("no config on provider.")
        End If

        m_sMappingQPathName = m_oCfgDataServicesServer.MSMQSystemEntryPoint.MessageIDToActivityIDmapQueue
    End Sub

    Private Function GetLogMsg(ByVal msg As Message) As String
        Dim smsg As String
        Try
            Try
                smsg = CStr(msg.Body())
            Catch ex As Exception
                Dim oStream As New System.IO.MemoryStream
                oStream = msg.BodyStream()
                Dim encoding As System.Text.Encoding = System.Text.Encoding.UTF8
                smsg = encoding.GetString(oStream.ToArray())

            End Try

            Return smsg

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Return "Error reading message from Q"
        End Try

    End Function


End Class
