'''''''''''''''''''''''''''''''''''''''''''''
'
'  Web Server Creation Utility  
'
'''''''''''''''''''''''''''''''''''''''''''''

'  Description:
'  ------------
'  This sample admin script allows you to create a web server.
'
'  To Run:  
'  -------
'  This is the format for this script:
'  
'      Keystrokeript mkwebsrv.vbs <rootdir> [-n <instancenum>][-c <comment>][-p <portnum>][-X (don't start)]
'  
'  NOTE:  If you want to execute this script directly from Windows, use 
'  'wscript' instead of 'Keystrokeript'. 
'
'''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

' Initialize error checking
On Error Resume Next

' Initialize variables
Dim ArgCount, WRoot, WNumber, WComment, WPort, BindingsList, ServerRun
Dim ServiceObj, ServerObj, VDirObj

' Default values
ArgCount = 0
WRoot = ""
WNumber = 10
WComment = "SampleServer"
BindingsList = Array(0)
BindingsList(0) = ":84:"
WPort = BindingsList  ' Port property is a collection of port bindings
ServerRun = True

  ' ** Parse Command Line

    ' Loop through arguments
    While ArgCount < Wscript.Arguments.Count
      
      ' Determine switches used
      Select Case Wscript.Arguments(ArgCount)

         Case "-n":   ' Set server instance number
            ' Move to next arg, which should be parameter
            ArgCount =  ArgCount + 1  
            If ArgCount => Wscript.Arguments.Count Then
               Call UsageMsg
            Else
               WNumber = Wscript.Arguments(ArgCount)
            End If

         Case "-c":   ' Set server comment (friendly name)
            ' Move to next arg, which should be parameter
            ArgCount =  ArgCount + 1  
            If ArgCount => Wscript.Arguments.Count Then
               Call UsageMsg
            Else
               WComment = Wscript.Arguments(ArgCount)
            End If

         Case "-p":   ' Port binding
            ' Move to next arg, which should be parameter
            ArgCount =  ArgCount + 1  
            If ArgCount => Wscript.Arguments.Count Then
               Call UsageMsg
            Else
               BindingsList(0) = ":" & Wscript.Arguments(ArgCount) & ":"
               WPort = BindingsList   '  Takes collection as value
            End If

         Case "-X":   ' Do NOT start the server upon creation
            ServerRun = False

         Case "-h", "-?", "/?":
            Call UsageMsg

         Case Else:
            If WRoot <> "" Then  ' Only one name allowed
               Call UsageMsg
            Else
               WRoot = Wscript.Arguments(ArgCount)
            End If

      End Select

      ' Move pointer to next argument
      ArgCount = ArgCount + 1

    Wend

 
  ' Screen to make sure WRoot was set
  If WRoot = "" Then Call UsageMsg  


  ' ** Create Server **
  ' First, create instance of Web service

'  Set ServiceObj = GetObject("IIS://Localhost/W3SVC/8/Root")
  Set ServiceObj = GetObject("IIS://Localhost/W3SVC/" & WNumber & "/Root")
  
  ' Second, create a new virtual server at the service
  ' Set ServerObj = ServiceObj.Create("IIsWebServer", WNumber)
  

'wscript.echo "Got Object"


    ' Error creating?
    If (Err.Number <> 0) Then    ' Error!
       Wscript.Echo "Error:  ADSI Create failed to create server."
       Wscript.Quit
    End If
  
  ' Next, configure new server
'  ServiceObj.ServerSize = 1   ' Medium-sized server
'  ServiceObj.ServerComment = WComment
'  ServiceObj.ServerBindings = WPort

  ' Write info back to Metabase
'  ServerObj.SetInfo

'dim sUsername
'dim sPassword

'dim sDomain 

'Dim WshShell
'Set WshShell = WScript.CreateObject("WScript.Shell")

'sDomain= WshShell.ExpandEnvironmentStrings("%USERDOMAIN%") & "\"


'sUsername = InputBox ("Enter the fully qualified Username for which the IIS Services should run under", "Domain\Username", sDomain)

'wscript.echo sUsername

'sPassword = InputBox ("Enter the password for the user for which the IIS Services should run under" )

'wscript.echo sPassword 



  ' Configure new virtual root
'wscript.echo    ServiceObj.Path
'wscript.echo    ServiceObj.AccessRead

'wscript.echo    "ServiceObj.AccessScript =" & ServiceObj.AccessScript
	  ServiceObj.AccessScript=true
'wscript.echo    "ServiceObj.AccessScript =" & ServiceObj.AccessScript

'wscript.echo    "ServiceObj.AccessWrite=" & ServiceObj.AccessWrite
'ServiceObj.AccessWrite = False
'wscript.echo    "ServiceObj.AccessWrite=" & ServiceObj.AccessWrite

'wscript.echo    ServiceObj.EnableDirBrowsing

'wscript.echo    "ServiceObj.AnonymousUserName=" & ServiceObj.AnonymousUserName
'wscript.echo    "ServiceObj.AnonymousUserPass=" & ServiceObj.AnonymousUserPass
'ServiceObj.AnonymousUserPass="keravnos"
'wscript.echo    "ServiceObj.AnonymousUserPass=" & ServiceObj.AnonymousUserPass





'wscript.echo ServiceObj.ScriptMaps   
'ServiceObj.ScriptMaps = ".wsdl,C:\Progra~1\Common~1\MSSoap\Binaries\SOAPISAP.dll,5,GET, POST, HEAD"
'ServiceObj.ScriptMaps = ServiceObj.ScriptMaps  & ".wsdl,C:\Progra~1\Common~1\MSSoap\Binaries\SOAPISAP.dll,5,GET, POST, HEAD"
'ServiceObj.ScriptMaps =  ".wsdm,C:\Progra~1\Common~1\MSSoap\Binaries\SOAPIS30.dll,5,GET, POST, HEAD"
'ServiceObj.ScriptMaps =  ".wsdm,C:\Progra~1\Common~1\MSSoap\Binaries\SOAPIS30.dll,5,GET, POST, HEAD, .wsdl,C:\Progra~1\Common~1\MSSoap\Binaries\SOAPISAP.dll,5,GET, POST, HEAD"
'ServiceObj.ScriptMaps  ".wsdl,C:\Progra~1\Common~1\MSSoap\Binaries\SOAPIS30.dll,5,GET, HEAD, POST"

ServiceObj.SetInfo

' Displays usage message, then QUITS
Sub UsageMsg
   Wscript.Echo "Usage:  Keystrokeript mkwebsrv.vbs <rootdir> [-n <instancenum>][-c <comment>][-p <portnum>][-X (don't start)]"
   Wscript.Quit
End Sub





