' VBScript source code
option explicit

if WScript.Arguments.Count < 2 OR WScript.Arguments.Count > 3 then
   WScript.Echo "Usage:"
   WScript.Echo WScript.ScriptFullName & " AppPoolName vdirname <physical path for vdir>"
   WScript.Quit
end if 
dim basepath         :   basepath = "IIS://localhost/w3svc/1/root"

dim AppPoolName      :   AppPoolName = WScript.Arguments(0)
dim vdirname         :   vdirname = WScript.Arguments(1)
dim VDirPhysicalPath

if WScript.Arguments.Count < 3 then
   VDirPhysicalPath = "c:\inetpub\wwwroot"
else
   VDirPhysicalPath = WScript.Arguments(2)
end if

if CreateNewUser(username, password) = false then
   WScript.Echo "Error creating user " & username & ". "
   WScript.Quit
end if 

if AddUserToIIS_WPG(username) = false then
   WScript.Echo "Error adding user " & username & " IIS_WPG. "
   WScript.Quit
end if

if CreateNewAppPool(username, password, AppPoolName) = false then
   WScript.Echo "Error creating AppPool " & AppPoolName & " running as user " & username & ". "
   WScript.Quit
end if 

if CreateNewVDir(vdirname, vdirphysicalpath) = false then
   WScript.Echo "Error creating new virtual directory " & vdirname & ". " 
   WScript.Quit
end if 

if AssignAppPool(vdirname, AppPoolName) = false then
   WScript.Echo "Error assigning Application Pool " & AppPoolName & " to vdir " & vdirname & ". "  
   WScript.Quit
end if

dim wsh : set wsh = CreateObject("WScript.Shell")
WScript.Echo "Waiting for iisreset to return"
wsh.Run "iisreset /restart",,true
wsh.Run "http://localhost/" & vdirname
wsh.Run "taskmgr"

function AssignAppPool(vdirname, AppPoolName)
   dim vdirobj
   
   set vdirobj = GetObject(basepath & "/" & vdirname)
   vdirobj.AppPoolId = AppPoolName
   vdirobj.SetInfo
   if err = 0 then
      AssignAppPool = true
   else
      AssignAppPool = false
   end if 
end function

function CreateNewVDir (vdirname, vdirphysicalpath)
   dim VdirObj, VRoot
   set VRoot = GetObject(basepath)
   set VdirObj = VRoot.Create("IIsWebVirtualDir", vdirname)
   VdirObj.AccessRead = True
   VdirObj.AccessScript = True
   VdirObj.Put "Path", vdirphysicalpath
   VdirObj.SetInfo
   
   vdirobj.AppCreate true
   vdirobj.SetInfo
   if err = 0 then
      CreateNewVDir = True
   else
      CreateNewVdir = false
   end if
end function

function CreateNewAppPool(username, password, AppPoolName)
   dim AppPools, newAppPool
   set AppPools = GetObject("IIS://localhost/w3svc/AppPools")
   set newAppPool = AppPools.Create("IIsApplicationPool", AppPoolName)
   newAppPool.WamUserName = username
   newAppPool.WamUserPass = password
      newAppPool.LogonMethod =1 
   newAppPool.AppPoolIdentityType=3
   newAppPool.SetInfo
   if err = 0 then
      CreateNewAppPool = True
   else
      CreateNewAppPool = false
   end if
end function

function AddUserToIIS_WPG (username)
   dim nw : set nw = CreateObject("WScript.Network")
   dim computername : computername = nw.Computername
   dim MyUser
   dim IIS_WPG
   
   set IIS_WPG = GetObject("WinNT://" & computername & "/IIS_WPG,group")
   set MyUser = GetObject("WinNT://" & computername & "/" & username & ",user")
   if not IIS_WPG.IsMember(MyUser.AdsPath) then
      IIS_WPG.Add(MyUser.AdsPath)
   end if
   if err = 0 then
      AddUserToIIS_WPG = True
   else
      AddUserToIIS_WPG = false
   end if
   
end function   

function CreateNewUser(username, password) 
   dim nw             :   set nw = CreateObject("WScript.Network")
   dim computername   :   computername = nw.Computername
   dim container      :   set container = GetObject("WinNT://" & computername)
   dim newuser        :   set newuser = container.Create( "user", username)
   newuser.SetPassword(password)
   newuser.SetInfo
   if err = 0 then
      CreateNewUser = True
   else
      WScript.Echo "Error: " & err.Description & " - " & err.number
      CreateNewUser = false
   end if
   
end function

