@echo off
setlocal

rem We may want to support separate Debug and Release builds at some stage
rem (Maybe just to allow for different installation options)
rem but we don't need it at the moment.

set INSTALL_TYPE=INVALID
if %1x==x set INSTALL_TYPE=DebugAndRelease
if %1x==DEBx set INSTALL_TYPE=Debug
if %1x==RELx set INSTALL_TYPE=Release
if %INSTALL_TYPE%==INVALID goto InvalidParams

goto Begin

:InvalidParams
echo Invalid or no parameters specified
echo Usage:
echo  Debug Installation...
echo   InstallCILServer DEB
echo.
echo  Release Installation...
echo   InstallCILServer REL
echo.
pause

goto End

:Begin

rem Install Options - =Y/N
set DO_CHECK_BUILD_FIRST=Y
set DO_STOP_IISADMIN=Y
set DO_REMOVE_EXISTING_SERVER=Y
set DO_CREATE_DIR_STRUCTURE=Y
set DO_COPY_DLLS=Y
rem DO_COPY_PDBS currently unfinished
set DO_COPY_PDBS=N
set DO_REGISTER_TLBS=Y
set DO_REGISTER_DLLS=Y
set DO_UPDATE_PATH=N
set DO_DELETE_TEMP_REGISTER_FILE_LIST=Y
set DO_COMPLUS_REGISTRATION=N
set DO_CHECK_PERS_COMMS_EXISTS=Y
set DO_DEPLOY_CECIL_FILES=Y
set DO_START_IISADMIN=Y

rem *****************************************************************
rem Debug/Release Installation Files

:CommonDLLs
set FILES_DLL_BIN_TO_BASE=CILDLLs_Bin_To_Base.txt
set FILES_DLL_BINSERVER_TO_BASE=CILDLLs_BinServer_To_Base.txt
set FILES_DLL_BIN_TO_CIL=CILDLLs_Bin_To_CIL.txt
set FILES_DLL_BINSERVER_TO_COMPLUS_BASE=CILDLLs_BinServer_To_ComPlusBase.txt
set FILES_DLL_BINSERVER_TO_COMPLUS_CIL=CILDLLs_BinServer_To_ComPlusCIL.txt
set FILES_DLL_BIN_TO_BIN=CILDLLs_Bin_To_Bin.txt
set FILES_TLB_TO_BASE=CILDLLs_Tlb_To_TlbBase.txt
set FILES_WEB_TO_WEB=CILDLLs_Web_To_Web.txt
set FILES_TOOLS_TO_TOOLS=CILDLLs_TestAreaTools_To_BinTools.txt
set FILES_TESTDATA_TO_TESTDATA=CILDLLs_TestData_To_TestData.txt

set FILES_DATABASE_TO_DATABASE=CILDLLs_Database_To_Database.txt
set FILES_DBSCRIPTS_TO_DBSCRIPTS=CILDLLs_DatabaseScripts_To_DatabaseScripts.txt
set FILES_INSTALL_TO_INSTALL=CILDLLs_Install_To_Install.txt
set FILES_INSTALLDB_TO_INSTALLDB=CILDLLs_InstallDB_To_InstallDB.txt
set FILES_INSTALLSCRIPTS_TO_INSTALLSCRIPTS=CILDLLs_InstallScripts_To_InstallScripts.txt

set ERROR_LOG=CILServerInstallErrors.log

if %INSTALL_TYPE%==Debug goto DebugDLLs
if %INSTALL_TYPE%==Release goto ReleaseDLLs
if %INSTALL_TYPE%==DebugAndRelease goto CommonSettings

echo Invalid INSTALL_TYPE in script
goto end

rem *****************************************************************
rem Debug Only Installation Files

:DebugDLLs
set ERROR_LOG=CILServerInstallDebug.log

goto CommonSettings

rem *****************************************************************
rem Release Only Installation Files

:ReleaseDLLs
set ERROR_LOG=CILServerInstallErrors.log

goto CommonSettings

rem *****************************************************************
rem Common Settings

:CommonSettings
rem NB: DLLS_TO_REGISTER will be deleted and then generated
set DLLS_TO_REGISTER=__FilesToRegister_regsvr32.txt
set TLBS_TO_REGISTER=__FilesToRegister_regtlib.txt

set SOURCE_DIR=Y:
rem set SOURCE_DIR=K:\Project

set SOURCE_SUBDIR_BASE=\Bin
set SOURCE_SUBDIR_SERVER=\Bin\Server
set SOURCE_SUBDIR_TLB=\Bin\Tlb
set SOURCE_SUBDIR_WEB=\Custom\MicrosoftBiztalkJSK\Bin\Web
set SOURCE_SUBDIR_TOOLS=\Custom\TestArea\Tools
set SOURCE_SUBDIR_DATABASE=\Custom\ESB\Database
set SOURCE_SUBDIR_DBSCRIPTS=\Custom\ESB\Database\Scripts
set SOURCE_SUBDIR_TESTDATA=\Custom\Testing\TestObjects\TestData
set SOURCE_SUBDIR_INSTALL=\Install
set SOURCE_SUBDIR_INSTALL_DB=\Install\MiddleTier\Database
set SOURCE_SUBDIR_INSTALL_SCRIPTS=\Install\MiddleTier\InstallScripts
set SOURCE_BUILD_INFO_FILE=%SOURCE_DIR%\CIL2.*.txt

set SOURCE_DIR_BASE=%SOURCE_DIR%%SOURCE_SUBDIR_BASE%
set SOURCE_DIR_SERVER=%SOURCE_DIR%%SOURCE_SUBDIR_SERVER%
set SOURCE_DIR_TLB=%SOURCE_DIR%%SOURCE_SUBDIR_TLB%
set SOURCE_DIR_WEB=%SOURCE_DIR%%SOURCE_SUBDIR_WEB%
set SOURCE_DIR_TOOLS=%SOURCE_DIR%%SOURCE_SUBDIR_TOOLS%
set SOURCE_DIR_DATABASE=%SOURCE_DIR%%SOURCE_SUBDIR_DATABASE%
set SOURCE_DIR_DBSCRIPTS=%SOURCE_DIR%%SOURCE_SUBDIR_DBSCRIPTS%
set SOURCE_DIR_TESTDATA=%SOURCE_DIR%%SOURCE_SUBDIR_TESTDATA%
set SOURCE_DIR_INSTALL=%SOURCE_DIR%%SOURCE_SUBDIR_INSTALL%
set SOURCE_DIR_INSTALL_DB=%SOURCE_DIR%%SOURCE_SUBDIR_INSTALL_DB%
set SOURCE_DIR_INSTALL_SCRIPTS=%SOURCE_DIR%%SOURCE_SUBDIR_INSTALL_SCRIPTS%
set SOURCE_CECIL_TEMPLATE=%SOURCE_DIR_INSTALL%\cecil_template.ws

set DEST_DIR=%PROGRAMFILES%\ESB
set DEST_CECIL_DIR="%PROGRAMFILES%\Personal Communications\private"
set DEST_CECIL_FILE=cecil
set DEST_CECIL_EXT=.ws
set DEST_SUBDIR_BIN=\Bin
set DEST_SUBDIR_COMPLUS=%DEST_SUBDIR_BIN%\ComPlus
set DEST_SUBDIR_TLB=\Tlb
set DEST_SUBDIR_CIL=\CIL
set DEST_SUBDIR_BASE=\Base
set DEST_SUBDIR_DATABASE=\Database
set DEST_SUBDIR_SCRIPTS=%DEST_SUBDIR_DATABASE%\Scripts
set DEST_SUBDIR_WEB=\Web
set DEST_SUBDIR_TESTDATA=\Testing\TestData
set DEST_SUBDIR_TOOLS=\Tools
set DEST_SUBDIR_INSTALL=\Install
set DEST_SUBDIR_INSTALL_DB=\Install\MiddleTier\Database
set DEST_SUBDIR_INSTALL_SCRIPTS=\Install\MiddleTier\InstallScripts

set DEST_BIN=%DEST_DIR%%DEST_SUBDIR_BIN%
set DEST_BIN_CIL=%DEST_DIR%%DEST_SUBDIR_BIN%%DEST_SUBDIR_CIL%
set DEST_BIN_BASE=%DEST_DIR%%DEST_SUBDIR_BIN%%DEST_SUBDIR_BASE%
set DEST_BIN_COMPLUS_CIL=%DEST_DIR%%DEST_SUBDIR_COMPLUS%%DEST_SUBDIR_CIL%
set DEST_BIN_COMPLUS_BASE=%DEST_DIR%%DEST_SUBDIR_COMPLUS%%DEST_SUBDIR_BASE%
set DEST_TLB_BASE=%DEST_DIR%%DEST_SUBDIR_TLB%%DEST_SUBDIR_BASE%
set DEST_DATABASE=%DEST_DIR%%DEST_SUBDIR_DATABASE%
set DEST_DBSCRIPTS=%DEST_DIR%%DEST_SUBDIR_SCRIPTS%
set DEST_WEB=%DEST_DIR%%DEST_SUBDIR_WEB%
set DEST_TESTDATA=%DEST_DIR%%DEST_SUBDIR_TESTDATA%
set DEST_TOOLS=%DEST_DIR%%DEST_SUBDIR_BIN%%DEST_SUBDIR_TOOLS%
set DEST_INSTALL=%DEST_DIR%%DEST_SUBDIR_INSTALL%
set DEST_INSTALL_DB=%DEST_DIR%%DEST_SUBDIR_INSTALL_DB%
set DEST_INSTALL_SCRIPTS=%DEST_DIR%%DEST_SUBDIR_INSTALL_SCRIPTS%

set ERROR_LOG="%DEST_INSTALL%\CILServerInstall.log"
echo ******
echo %ERROR_LOG%

if exist %ERROR_LOG% del %ERROR_LOG%
if exist %DLLS_TO_REGISTER% del %DLLS_TO_REGISTER%
if exist %TLBS_TO_REGISTER% del %TLBS_TO_REGISTER%

rem *****************************************************************
rem Check we're pointing to a valid build
if not %DO_CHECK_BUILD_FIRST%==Y goto RemoveExistingServer
set TEMP_SHOW_BUILD_FILE="%DEST_DIR%\_temp_show_build_no.cmd"
if not exist %SOURCE_BUILD_INFO_FILE% goto UnableToFindBuild

if exist %TEMP_SHOW_BUILD_FILE%. (
  del %TEMP_SHOW_BUILD_FILE%
  if exist %TEMP_SHOW_BUILD_FILE% goto UnableToDeleteTempBuildFile
)
type %SOURCE_BUILD_INFO_FILE% > %TEMP_SHOW_BUILD_FILE%
cls
echo Press any key to install the following %INSTALL_TYPE% build...
type %TEMP_SHOW_BUILD_FILE%
echo.
echo Press Ctrl-C to abort,
echo.
pause

goto StopIISAdmin

:UnableToFindBuild
echo.>>%ERROR_LOG%
echo Unable to locate build in %SOURCE_DIR%>>%ERROR_LOG%
echo.>>%ERROR_LOG%
goto End

:UnableToDeleteTempBuildFile
echo.>>%ERROR_LOG%
echo Unable to delete file %TEMP_SHOW_BUILD_FILE%>>%ERROR_LOG%
echo.>>%ERROR_LOG%

goto End

rem *****************************************************************
rem Stop IIS Admin. If this is running, we won't be able to copy files
rem to ..\ESB\Web

:StopIISAdmin
if not %DO_STOP_IISADMIN%==Y goto RemoveExistingServer
echo.
echo Stopping IISAdmin...
echo.
net stop IISAdmin /y

rem *****************************************************************
rem Remove existing server installation

:RemoveExistingServer
if not %DO_REMOVE_EXISTING_SERVER%==Y goto CreateDirectoryStructure
echo.
echo Removing existing server installation...
echo.
rd /q /s "%DEST_DIR%"

rem *****************************************************************
rem Create Directory Structure

:CreateDirectoryStructure
if not %DO_CREATE_DIR_STRUCTURE%==Y goto CopyDlls
echo.
echo Creating directory structure...
echo.
if not exist "%DEST_BIN_CIL%"\nul md "%DEST_BIN_CIL%"
if not exist "%DEST_BIN_BASE%"\nul md "%DEST_BIN_BASE%"
if not exist "%DEST_BIN_COMPLUS_CIL%"\nul md "%DEST_BIN_COMPLUS_CIL%"
if not exist "%DEST_BIN_COMPLUS_BASE%"\nul md "%DEST_BIN_COMPLUS_BASE%"
if not exist "%DEST_TLB_BASE%"\nul md "%DEST_TLB_BASE%"
if not exist "%DEST_DATABASE%"\nul md "%DEST_DATABASE%"
if not exist "%DEST_DBSCRIPTS%"\nul md "%DEST_DBSCRIPTS%"
if not exist "%DEST_WEB%"\nul md "%DEST_WEB%"
if not exist "%DEST_TESTDATA%"\nul md "%DEST_TESTDATA%"
if not exist "%DEST_TOOLS%"\nul md "%DEST_TOOLS%"
if not exist "%DEST_INSTALL%"\nul md "%DEST_INSTALL%"
if not exist "%DEST_INSTALL_DB%"\nul md "%DEST_INSTALL_DB%"
if not exist "%DEST_INSTALL_SCRIPTS%"\nul md "%DEST_INSTALL_SCRIPTS%"

rem *****************************************************************
rem Copy DLLs from Source to Destination

:CopyDlls
if not %DO_COPY_DLLS%==Y goto RegisterTlbs
echo.
echo Copying DLLs...
echo.

call CopyDLLsInFile %FILES_DLL_BIN_TO_BASE% "%SOURCE_DIR_BASE%" "%DEST_BIN_BASE%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
call CopyDLLsInFile %FILES_DLL_BINSERVER_TO_BASE% "%SOURCE_DIR_SERVER%" "%DEST_BIN_BASE%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
call CopyDLLsInFile %FILES_DLL_BIN_TO_CIL% "%SOURCE_DIR_BASE%" "%DEST_BIN_CIL%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
call CopyDLLsInFile %FILES_DLL_BINSERVER_TO_COMPLUS_BASE% "%SOURCE_DIR_SERVER%" "%DEST_BIN_COMPLUS_BASE%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
call CopyDLLsInFile %FILES_DLL_BINSERVER_TO_COMPLUS_CIL% "%SOURCE_DIR_SERVER%" "%DEST_BIN_COMPLUS_CIL%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
call CopyDLLsInFile %FILES_DLL_BIN_TO_BIN% "%SOURCE_DIR_BASE%" "%DEST_BIN%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
call CopyDLLsInFile %FILES_TLB_TO_BASE% "%SOURCE_DIR_TLB%" "%DEST_TLB_BASE%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
call CopyDLLsInFile %FILES_WEB_TO_WEB% "%SOURCE_DIR_WEB%" "%DEST_WEB%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
call CopyDLLsInFile %FILES_TOOLS_TO_TOOLS% "%SOURCE_DIR_TOOLS%" "%DEST_TOOLS%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
call CopyDLLsInFile %FILES_TESTDATA_TO_TESTDATA% "%SOURCE_DIR_TESTDATA%" "%DEST_TESTDATA%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%

rem call CopyDLLsInFile %FILES_DATABASE_TO_DATABASE% "%SOURCE_DIR_DATABASE%" "%DEST_DATABASE%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
rem call CopyDLLsInFile %FILES_DBSCRIPTS_TO_DBSCRIPTS% "%SOURCE_DIR_DBSCRIPTS%" "%DEST_DBSCRIPTS%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
rem call CopyDLLsInFile %FILES_INSTALL_TO_INSTALL% "%SOURCE_DIR_INSTALL%" "%DEST_INSTALL%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
rem call CopyDLLsInFile %FILES_INSTALLDB_TO_INSTALLDB% "%SOURCE_DIR_INSTALL_DB%" "%DEST_INSTALL_DB%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%
rem call CopyDLLsInFile %FILES_INSTALLSCRIPTS_TO_INSTALLSCRIPTS% "%SOURCE_DIR_INSTALL_SCRIPTS%" "%DEST_INSTALL_SCRIPTS%" %ERROR_LOG% %DLLS_TO_REGISTER% %TLBS_TO_REGISTER% %DO_COPY_PDBS%

@echo on

xcopy "%SOURCE_DIR_INSTALL%\*.*" "%DEST_INSTALL%"  /c /e /f /r /v /y 

@echo off

rem *****************************************************************
rem Register Tlbs

:RegisterTlbs
if not %DO_REGISTER_TLBS%==Y goto RegisterDlls
echo.
echo Registering files...
echo.
call RegisterDLLsInFile.cmd %TLBS_TO_REGISTER% %ERROR_LOG% TLB

rem *****************************************************************
rem Register DLLs

:RegisterDlls
if not %DO_REGISTER_DLLS%==Y goto DeleteTempRegfile
echo.
echo Registering files...
echo.
call RegisterDLLsInFile.cmd %DLLS_TO_REGISTER% %ERROR_LOG% DLL

rem *****************************************************************
rem Delete the temporary file containing list of files to be registered
rem we created earlier

:DeleteTempRegfile
if not %DO_DELETE_TEMP_REGISTER_FILE_LIST%==Y goto UpdatePath
echo.
echo Deleting files to register temporary file...
echo.
del %DLLS_TO_REGISTER%
del %TLBS_TO_REGISTER%

rem *****************************************************************
rem Update path

:UpdatePath
if not %DO_UPDATE_PATH%==Y goto COMPlusRegistration
echo.
echo Updating path...
set path=%path%;%DEST_BIN%

rem *****************************************************************
rem COM Plus Registration

:COMPlusRegistration
if not %DO_COMPLUS_REGISTRATION%==Y goto CheckPersonalCommsExists
echo cd "%DEST_INSTALL%"
cd "%DEST_INSTALL%"
call InstalCOMPLUSApplications.cmd

rem *****************************************************************
rem Check Personal Communications directory exists

:CheckPersonalCommsExists
if not %DO_CHECK_PERS_COMMS_EXISTS%==Y goto DeployCecilFiles
if exist %DEST_CECIL_DIR% goto DeployCecilFiles

:NoPersonalCommsDir
echo.>>%ERROR_LOG%
echo Unable to locate %DEST_CECIL_DIR% >>%ERROR_LOG%
echo.>>%ERROR_LOG%
goto End

rem *****************************************************************
rem Deploy Cecil files

:DeployCecilFiles
if not %DO_DEPLOY_CECIL_FILES%==Y goto StartIISAdmin
echo.
echo Deploying Cecil files...
echo.
set DEST_CECIL_PRE=%DEST_CECIL_DIR%\%DEST_CECIL_FILE%
rem Deploy 10 Cecil files

if not exist %SOURCE_CECIL_TEMPLATE% echo %SOURCE_CECIL_TEMPLATE% does not exist. >> %ERROR_LOG%
if not exist %SOURCE_CECIL_TEMPLATE% goto StartIISAdmin

for /L %%a in (1,1,10) do (
  echo Copying %SOURCE_CECIL_TEMPLATE% to %DEST_CECIL_PRE%%%a%DEST_CECIL_EXT%
  copy /y /z %SOURCE_CECIL_TEMPLATE% %DEST_CECIL_PRE%%%a%DEST_CECIL_EXT%
  if not exist %DEST_CECIL_PRE%%%a%DEST_CECIL_EXT% echo Failed to copy %SOURCE_CECIL_TEMPLATE% to %DEST_CECIL_PRE%%%a%DEST_CECIL_EXT% >> %ERROR_LOG%
)

rem *****************************************************************
rem Restart IIS Admin.

:StartIISAdmin
if not %DO_START_IISADMIN%==Y goto End
echo.
echo Starting IISAdmin...
echo.
net start IISAdmin
echo.
echo Starting Web Server...
echo.
net start w3svc

rem *****************************************************************

:end
echo.

if exist %ERROR_LOG% (
echo.
echo Errors occurred during installation...
type %ERROR_LOG%
echo.
)

pause

endlocal