'*******************************************************************
' File: SETUP_JUMPSTART.VBS
' Purpose:  This script will install the virtual web directory
'			of BizTalk JumpStart. It also removes same.
'
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT
' WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES
' OF MERCHANTABILITY AND/OR FITNESS FOR A  PARTICULAR
' PURPOSE.
'
' Microsoft BizTalk JumpStart
' Copyright (C) Microsoft Corporation, 1999
'*******************************************************************
' ------------------------
' GLOBAL VAR'S & CONSTANTS
' ------------------------
Const SCRIPT_TITLE = "BizTalk Virtual Web Installer"
Dim CRLF: CRLF = Chr(13) & Chr(10)
Dim g_strInstallDir
Dim g_strWebDir
Dim g_strInstRemove

' ------------------------
' MAIN SECTION
' ------------------------
' Argument 1 is the Virtual Web directory name
' Argument 2 is the installation directory
' Argument 3 is either "Install" or "Remove"

if not ( Wscript.Arguments.length = 3 or Wscript.Arguments.length = 5  ) then
	Wscript.echo "Wrong number of arguments." & CRLF
	Wscript.quit( 1 )
end if
g_strWebDir     = Wscript.Arguments.Item(0)
g_strInstallDir = Wscript.Arguments.Item(1)
g_strInstRemove = Wscript.Arguments.Item(2)

g_strUsername = Wscript.Arguments.Item(3)
g_strPassword = Wscript.Arguments.Item(4)


' Create the IIS Virtual Web
Call CreateVirtualWeb( g_strWebDir, g_strInstallDir, g_strInstRemove, g_strUsername, g_strPassword )
Wscript.quit(0)


' -----------------------
' SUBROUTINES & FUNCTIONS
' -----------------------

'**********************************************************************
' Sub:      CreateVirtualWeb
' Purpose:  Create the Virtual Web
'**********************************************************************
Sub CreateVirtualWeb( webName, installDir, instRemove, sUsername, sPassword )
    On Error Resume Next
    
    WriteToLog ( "Calling CreateVirtualWeb ( " & webName & ", " & installDir & ", " & instRemove & ", " & sUsername & ", " & sPassword & " ) " )    	    
    
    Dim objIIS
    Dim objVirtualDirectory
            
    Set objIIS = GetObject("IIS://localhost/W3SVC/1/Root")
                        
    '
	' DELETE EXISTING VIRTUAL DIRECTOR

	'
    'objIIS.Delete "IISWebVirtualDir", webName
    'Err.Clear

'msgbox susername & " " & spassword

    '
	' CREATE VIRTUAL DIRECTORY
	if ( instRemove = "Install" ) then
		Set objVirtualDirectory = objIIS.Create("IISWebVirtualDir", webName)
		objVirtualDirectory.AccessScript = True
		objVirtualDirectory.Path = installDir
		objVirtualDirectory.AppCreate True		' True = InProc
		objVirtualDirectory.AnonymousUserName = sUsername 
		objVirtualDirectory.AnonymousUserPass = sPassword 
		objVirtualDirectory.AnonymousPasswordSync = False

		objVirtualDirectory.SetInfo 
		
		objIIS.SetInfo
	else
		objIIS.Delete "IISWebVirtualDir", webName
		Err.Clear
	end if
    	
End Sub

