
' ------------------------
' GLOBAL VAR'S & CONSTANTS
' ------------------------
Const SCRIPT_TITLE = "BizTalk Virtual Web Installer"
Dim CRLF: CRLF = Chr(13) & Chr(10)
Dim g_strInstallDir
Dim g_strWebDir
Dim g_strInstRemove

' ------------------------
' MAIN SECTION
' ------------------------
' Argument 1 is the Virtual Web directory name
' Argument 2 is the installation directory
' Argument 3 is either "Install" or "Remove"

if ( Wscript.Arguments.length <> 3 ) then
	Wscript.echo "Wrong number of arguments." & CRLF
	Wscript.quit( 1 )
end if
g_strWebDir     = Wscript.Arguments.Item(0)
g_strInstallDir = Wscript.Arguments.Item(1)
g_strInstRemove = Wscript.Arguments.Item(2)

' Create the IIS Virtual Web
Call CreateVirtualWeb( g_strWebDir, g_strInstallDir, g_strInstRemove)

Wscript.quit(0)


' -----------------------
' SUBROUTINES & FUNCTIONS
' -----------------------

'**********************************************************************
' Sub:      CreateVirtualWeb
' Purpose:  Create the Virtual Web
'**********************************************************************
Sub CreateVirtualWeb( webName, installDir, instRemove )
    On Error Resume Next
 
	WriteToLog ( "Calling CreateVirtualWeb ( " & webName & ", " & installDir & ", " & instRemove & " )" )
    
    Dim objIIS
    Dim objVirtualDirectory
            
    Set objIIS = GetObject("IIS://localhost/W3SVC/1/Root/ESB")
                        
    '
	' DELETE EXISTING VIRTUAL DIRECTOR

	'
    'objIIS.Delete "IISWebVirtualDir", webName
    'Err.Clear

    '
	' CREATE VIRTUAL DIRECTORY
	if ( instRemove = "Install" ) then
		Set objVirtualDirectory = objIIS.Create("IISWebVirtualDir", webName)
		objVirtualDirectory.AccessScript = True
		objVirtualDirectory.Path = installDir
		objVirtualDirectory.SetInfo 
		objVirtualDirectory.AppCreate True		' True = InProc
		objIIS.SetInfo
	else
	    objIIS.Delete "IISWebVirtualDir", webName
	    Err.Clear
	end if
    	
End Sub

