'*******************************************************************
' ------------------------
' GLOBAL VAR'S & CONSTANTS
' ------------------------
Const SCRIPT_TITLE = "BizTalk Virtual Web Installer"
Dim CRLF: CRLF = Chr(13) & Chr(10)
Dim g_strInstallDir
Dim g_strWebDir
Dim g_strInstRemove

' ------------------------
' MAIN SECTION
' ------------------------
' Argument 1 is the Virtual Web directory name
' Argument 2 is the installation directory
' Argument 3 is either "Install" or "Remove"

if ( Wscript.Arguments.length <> 5 ) then
	Wscript.echo "Wrong number of arguments." & CRLF
	Wscript.quit( 1 )
end if
g_strWebDir     = Wscript.Arguments.Item(0)
g_strInstallDir = Wscript.Arguments.Item(1)
g_strInstRemove = Wscript.Arguments.Item(2)
g_strInstanceName = Wscript.Arguments.Item(3)
g_strAppPoolName = Wscript.Arguments.Item(4)

dim basepath         :   basepath = "IIS://localhost/w3svc/1/root"


' Create the IIS Virtual Web
Call CreateVirtualWeb( g_strWebDir, g_strInstallDir, g_strInstRemove, g_strInstanceName, g_strInstanceName & "_" & g_strAppPoolName )
Wscript.quit(0)


' -----------------------
' SUBROUTINES & FUNCTIONS
' -----------------------

'**********************************************************************
' Sub:      CreateVirtualWeb
' Purpose:  Create the Virtual Web
'**********************************************************************
Sub CreateVirtualWeb( webName, installDir, instRemove, InstanceName, sAppPoolName  )

    On Error Resume Next

	WriteToLog ( "Calling CreateVirtualWeb ( " & webName & ", " & installDir & ", " & instRemove & ", " & InstanceName & " )" )
    	    
    Dim objIIS
    Dim objVirtualDirectory
            
    Set objIIS = GetObject("IIS://localhost/W3SVC/1/Root/ESB/" & InstanceName )
                        
    ' DELETE EXISTING VIRTUAL DIRECTORY

	
    objIIS.Delete "IISWebVirtualDir", webName
    Err.Clear

    
	' CREATE VIRTUAL DIRECTORY
	if ( instRemove = "Install" ) then
		Set objVirtualDirectory = objIIS.Create("IISWebVirtualDir", webName)
		objVirtualDirectory.AccessScript = True
		objVirtualDirectory.Path = installDir
		objVirtualDirectory.SetInfo 
		objVirtualDirectory.AppCreate True		' True = InProc
		'objVirtualDirectory.AppPoolID = sAppPoolName
		objIIS.SetInfo
	end if

	basepath = "IIS://localhost/W3SVC/1/Root/ESB/" & InstanceName 

	if AssignAppPool(webName , sAppPoolName) = false then
	   WScript.Echo "Error assigning Application Pool " & sAppPoolName & " to vdir " & webName & ". "  
	   WScript.Quit
	end if


    	
End Sub

function AssignAppPool(vdirname, AppPoolName)
   dim vdirobj
   
   set vdirobj = GetObject(basepath & "/" & vdirname)
   vdirobj.AppPoolId = AppPoolName
   vdirobj.SetInfo
   if err = 0 then
      AssignAppPool = true
   else
      AssignAppPool = false
   end if 
end function
