'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Explicit On

''' 
'''  <summary>
''' 
''' </summary>
''' <remarks></remarks>

Public Class ReturnSimulationData
    Inherits ServiceBase


    'Service Entry Point
    ''' <summary>
    ''' Returns the Simulation Log Data from the ESB Log Database
    ''' </summary>
    ''' <param name="oEnv"></param>
    ''' <returns></returns>
    ''' <remarks>Configure as a HorizontalPost Always Execute handler, after CoC type handlers.</remarks>
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()

        Try
            MyBase.ProcessMsgSync(oEnv)
            DoWork()
            Return m_oEnvRs

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString())
            Throw

        Finally
            EndMethod()
        End Try
    End Function

    Protected Sub DoWork()

        If GetContext.IsServiceDomainRequestMessage = True Then

            If GetContext.ExecutionMode = LogDefs.eExecutionMode.eSimulate Then
                'This is the Node & Instance that received the original request & hence should look up the DB to get the entire Simulation Response...
                'TODO: Return Log Data Here...     as a DataSet...
                'Point to DB & get new Typed DataSet... :)
                Dim oLogData As New ESBLogDetail
                Dim oLogDataTbl As New ESBLogDetail.ESBLogDetailDataTable

                Dim oLDAdaptor As New ESBLogDetailTableAdapters.ESBLogDetailTableAdapter
                oLDAdaptor.Connection.ConnectionString = System.Configuration.ConfigurationManager.ConnectionStrings("ESBLogConnectionString").ConnectionString

                oLDAdaptor.Fill(oLogDataTbl, GetContext.ThreadLogDetail.sMessageID)
                oLogData.Merge(oLogDataTbl, True, MissingSchemaAction.Ignore)

                m_oEnvRs.AddDocument(New InlineDocument(oLogData))

            Else
                'GetContext.
                'Should override this to ensure it doesn't override response...
                '                          <ResponseIsOverallPipelineResponse>1</ResponseIsOverallPipelineResponse>


                Dim oServerContextImpl As ESB.Core.Services.Server.ServerContext = GetContext()

                'Different Pipeline Manager's are implemented differently cos of lack of MI support!!!
                'So, to get to PipelineManagerBase class, we expose a property on each of them, however...
                'This property is not currently available via an interface. So...
                'We know the method's there...Just get to it!!!
                'So...use dynamic features to do so...(i.e. late binding...)
                Dim oPipelineIf As Object = oServerContextImpl.PipelineManager
                Dim oPipelineBaseImpl As Pipeline.PipelineManagerBase = oPipelineIf.PipelineManagerBase
                oPipelineBaseImpl.PipelineExecuter.ResponseIsOverallPipelineResponse = False


            End If

        End If


    End Sub

  
End Class

