'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Imports ESB.Core.XMLSchemaClasses.ESBEnvelope
Imports Microsoft.ApplicationBlocks.ConfigurationManagement
Imports ESB.Core.Interfaces.ServerContext

Imports Simulation = ESB.Core.XMLSchemaClasses.Management.au.com.keystroke.esb.management.simulation.version_1_0_0_0

Public Class SystemEntryPoint
    Implements ISystemEntryPoint

    'Protected m_sConfigSourceSection As String = "ESB.Core.Services.Server"
    Protected m_sConfigSourceSection As String = "ESB.SystemEntryPoints.RequestReMapping"

    Protected m_bInit As Boolean '= False
    Protected m_oCtx As IServerContext
    Protected m_oTimer As ESB.Core.Util.Timer
    Protected m_sExecutionTime As String

    Private m_bEnabled As Boolean = True

#Region "Basic Plumbing"

    Public Sub New()
        'Init()          
    End Sub

    Public Sub New(ByRef oCtx As IServerContext)
        m_oCtx = oCtx
        Init()
    End Sub



    Public Sub SystemEntryPoint() Implements ISystemEntryPoint.SystemEntryPoint
        StartMethod()
        'GetConfigData()
        'Dim oDS As System.Data.DataSet = m_oCtx.EnvRq.GetDocument("kk").GetAsDataSet()
        Try
            If m_bEnabled = True Then
                'If m_oCtx.IsServiceDomainRequestMessage = True Then
                Dim oSvrCxt As ESB.Core.Services.Server.ServerContext = m_oCtx
                'If this feature is enabled...continue, otherwise, save some cpu cycles...
                If Configuration.ConfigurationManager.AppSettings("ESB.SimulationEnabled") = False Then
                    oSvrCxt.ExecutionMode = LogDefs.eExecutionMode.eExecute
                    Return
                End If

                'Look for a ESBMSimulationRq document

                Dim bSimulate As Boolean = False
                Dim oSim As Simulation.SimulationRq = m_oCtx.EnvRq.GetDocument(GetType(au.com.keystroke.esb.management.simulation.version_1_0_0_0.SimulationRq)).GetAsObject(GetType(au.com.keystroke.esb.management.simulation.version_1_0_0_0.SimulationRq))
                bSimulate = (oSim.ExecutionMode = au.com.keystroke.esb.management.simulation.version_1_0_0_0.SimulationRqExecutionMode.Simulate)

                If Not bSimulate Then
                    'If Not m_oCtx.EnvRq.GetCustomParam(C_sSimulation) = "True" Then

                    'We've NOT been asked to simulate
                    m_oCtx.ExecutionMode = LogDefs.eExecutionMode.eExecute 'Default
                    m_oCtx.ThreadLogDetail.ExecutionMode = eExecutionMode.eExecute
                Else
                    m_oCtx.ExecutionMode = eExecutionMode.eSimulate
                    m_oCtx.ThreadLogDetail.ExecutionMode = eExecutionMode.eSimulate

                    'Set the log level to that required for the actual log entries to be written for this request...
                    m_oCtx.ThreadLogDetail.eLoglevel += eLogLevel.eLOG_ACTIVITY_HANDLER_INVOKED + _
                                                        eLogLevel.eLOG_CONVENTION_HANDLER_BROKER_INVOKED + _
                                                        eLogLevel.eLOG_CONVENTION_HANDLER_WORKFLOW_INVOKED + _
                                                        eLogLevel.eLOG_CONVENTION_HANDLER_INVOKED + _
                                                        eLogLevel.eLOG_PIPELINE_HANDLER_INVOKED + _
                                                        eLogLevel.eLOG_SEP_HANDLER_INVOKED + _
                                                        eLogLevel.eLOG_TRANSFORMATION_HANDLER_INVOKED + _
                                                        eLogLevel.eLOG_TRANSPORT_INVOKED
                    'End If
                End If
            End If
        Catch ex As Exception
            ExceptionManager.Publish(ex)
        Finally
            EndMethod()
        End Try
    End Sub

    Public Sub SystemExitPoint() Implements ISystemEntryPoint.SystemExitPoint

        'TODO:
        '!!! Too late to return this here!!!
        'Response has already been givein to caller by now...
        'Need to do as part of a std. pipeline handler... 
        'See handler at: Base\ApplicationAdaptors\ESB.Adaptors.Application.RequestExecutionSimulation



    End Sub

    Public Sub Init() Implements ISystemEntryPoint.Init
        Try

            'initialise database connection
            If m_bEnabled = True Then
                'm_oSqlLogger = New ESB.Core.Loggers.MsSqlLogger
                'm_oSqlLogger.Connect() '...DisConnect when??? ==> Never :(
            End If
        Catch ex As Exception
            ExceptionManager.Publish(ex)
        End Try
    End Sub

    Public Sub SetContext(ByVal oCtx As IServerContext) Implements ISystemEntryPoint.SetContext
        m_oCtx = oCtx
    End Sub

    Public Function GetContext() As IServerContext Implements ISystemEntryPoint.GetContext
        Return m_oCtx
    End Function

    Private Function ShouldLog(ByVal eLoglevel As LogDefs.eLogLevel) As Boolean
        Return m_oCtx.ShouldLog(eLoglevel)
    End Function

#End Region

End Class
