'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Imports ESB.Core.XMLSchemaClasses.ESBEnvelope
Imports Microsoft.ApplicationBlocks.ConfigurationManagement
Imports ESB.Core.Interfaces.ServerContext


Public Class SystemEntryPoint
    Implements ISystemEntryPoint

    'Protected m_sConfigSourceSection As String = "ESB.Core.Services.Server"
    Protected m_sConfigSourceSection As String = "ESB.SystemEntryPoints.RequestReMapping"

    Protected m_bInit As Boolean '= False
    Protected m_oCtx As IServerContext
    Protected m_oTimer As ESB.Core.Util.Timer
    Protected m_sExecutionTime As String
    Private m_oCfgData As RequestReMapping.CustomConfigurationData.RequestReMaps

    Private m_bEnabled As Boolean = True

#Region "Basic Plumbing"

    Public Sub New()
        'Init()          
    End Sub

    Public Sub New(ByRef oCtx As IServerContext)
        m_oCtx = oCtx
        Init()
    End Sub



    Public Sub SystemEntryPoint() Implements ISystemEntryPoint.SystemEntryPoint
        StartMethod()
        'GetConfigData()

        Try
            If m_bEnabled = True Then
                'TODO: Testing...
                'm_oCtx.ResolveName = "aaa"
                'm_oCtx.Context = "bbb"


            End If
        Catch ex As Exception
            ExceptionManager.Publish(ex)
        Finally
            EndMethod()
        End Try
    End Sub

    Public Sub SystemExitPoint() Implements ISystemEntryPoint.SystemExitPoint
       
    End Sub

    Public Sub Init() Implements ISystemEntryPoint.Init
        Try
            AddHandler Microsoft.ApplicationBlocks.ConfigurationManagement.ConfigurationManager.ConfigChanges, AddressOf configChangedHandler
            GetConfigData()

            'initialise database connection
            If m_bEnabled = True Then
                'm_oSqlLogger = New ESB.Core.Loggers.MsSqlLogger
                'm_oSqlLogger.Connect() '...DisConnect when??? ==> Never :(
            End If
        Catch ex As Exception
            ExceptionManager.Publish(ex)
        End Try
    End Sub

    Public Sub SetContext(ByVal oCtx As IServerContext) Implements ISystemEntryPoint.SetContext
        m_oCtx = oCtx
    End Sub

    Public Function GetContext() As IServerContext Implements ISystemEntryPoint.GetContext
        Return m_oCtx
    End Function
    Protected Sub GetConfigData()
        '!!! Bloody App Blocks. Have config as type...can't cast to this prj's config type...
        'Need to reference the ServerContext assembly & use its CustomConfigData to work...
        'Stuff it, don't really need that Enabled flag anyway...
        m_oCfgData = DirectCast(ConfigurationManager.Read(m_sConfigSourceSection), RequestReMapping.CustomConfigurationData.RequestReMaps)
        If m_oCfgData Is Nothing Then
            Throw New ApplicationException("no config on provider.")
        End If

        ConfigChanged()
    End Sub


    Private Function ShouldLog(ByVal eLoglevel As LogDefs.eLogLevel) As Boolean
        Return m_oCtx.ShouldLog(eLoglevel)
    End Function



    Private Sub ConfigChangedHandler(ByVal storageProvider As IConfigurationStorageReader, _
                           ByVal sectionName As String)
        ConfigChanged()
        'EventLog.WriteEntry("ESB.NET", "Received Update Notification for: " & sectionName, EventLogEntryType.Information)
    End Sub
    Private Sub ConfigChanged()
        'Dim oSep As ESB.Core.Services.Server.CustomConfigurationData.SystemEntryPoint
    End Sub
    

#End Region

End Class
