﻿'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Imports ESB.Core.XMLSchemaClasses.ESBEnvelope
Imports Microsoft.ApplicationBlocks.ConfigurationManagement
Imports ESB.Core.Interfaces.ServerContext



'System entry point/exit point...
'Handler ? To remove CSWSDL_...
'targetNamespace="CSWSDLs_group_namespace_goes_here_CSWSDLe .au.com.keystroke.samples.banking.services“>
'Add another class to the Request re-mapping... Project to do this...
'consider: special tag & namespace prefix to identify grouping & ignore part of the WSDL namespace...
'BSDL 
'<DistinguishedServiceName>
'<ServiceName>RetrieveAccountPortfolio_v2_0_0_0</ServiceName>
'<ServiceNamespace>au.com.keystroke.samples.banking.services</ServiceNamespace>
'<ServiceVersion></ServiceVersion>
'<ClientSideWSDL namespace=“group_namespace_goes_here” servicename=“servicename_goes_here” />
'(generated request needs to enclose this in CSWSDLs...CSWSDLe.
'</DistinguishedServiceName>
'New RequestHandlerProxy  client-side handler  to inspect  BSDL and construct this...if Client Abstraction flag is enabled on request envelope...or always if  AlwaysCheckClientAbstraction config  flag is set.
'WSDL - Current
'<wsdl:definitions 
'name="RetrieveAccountPortfolio_v2_0_0_0“
'targetNamespace="au.com.keystroke.samples.banking.services">
'WSDL – With CSWSDL group
'name="CSWSDLs_servicename_goes_here_CSWSDLe.RetrieveAccountPortfolio_v2_0_0_0“
'targetNamespace="CSWSDLs_group_namespace_goes_here_CSWSDLe.au.com.keystroke.samples.banking.services“>
'Request envelope
'ResolveName – no change
'Context -  Namespace + ServiceName etc...
'Current
'<Context>au.com.keystroke.samples.banking.services.RetrieveAccountPortfolio_v2_0_0_0</Context>
'With change
'<Context> CSWSDLs_group_namespace_goes_here_CSWSDLe.au.com.keystroke.samples.banking.services . CSWSDLs_servicename_goes_here_CSWSDLe.RetrieveAccountPortfolio_v2_0_0_0 </Context>

Namespace ClientSideServiceDefinition





    ''' <summary>
    ''' Supports Client-side WSDL and BSDL namespaces and service names...
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    Public Class SystemEntryPoint
        Implements ISystemEntryPoint

        'Protected m_sConfigSourceSection As String = "ESB.Core.Services.Server"
        Protected m_sConfigSourceSection As String = "ESB.SystemEntryPoints.RequestReMapping" 'TODO: put config changesd in here...

        Protected m_bInit As Boolean '= False
        Protected m_oCtx As IServerContext
        Protected m_oTimer As ESB.Core.Util.Timer
        Protected m_sExecutionTime As String
        Private m_oCfgData As RequestReMapping.CustomConfigurationData.RequestReMaps

        Private m_bEnabled As Boolean = True

        Dim C_sDelimeterStart As String = "CSWSDLs"
        Dim C_sDelimeterEnd As String = "CSWSDLe"


#Region "Basic Plumbing"

        Public Sub New()
            'Init()          
        End Sub

        Public Sub New(ByRef oCtx As IServerContext)
            m_oCtx = oCtx
            Init()
        End Sub



        Public Sub SystemEntryPoint() Implements ISystemEntryPoint.SystemEntryPoint
            StartMethod()
            'GetConfigData()

            Try
                If m_bEnabled = True Then
                    RemapRequest()
                End If
            Catch ex As Exception
                ExceptionManager.Publish(ex)
            Finally
                EndMethod()
            End Try
        End Sub

        Public Sub SystemExitPoint() Implements ISystemEntryPoint.SystemExitPoint

        End Sub

        Public Sub Init() Implements ISystemEntryPoint.Init
            Try
                AddHandler Microsoft.ApplicationBlocks.ConfigurationManagement.ConfigurationManager.ConfigChanges, AddressOf ConfigChangedHandler
                GetConfigData()

                'initialise database connection
                If m_bEnabled = True Then
                    'm_oSqlLogger = New ESB.Core.Loggers.MsSqlLogger
                    'm_oSqlLogger.Connect() '...DisConnect when??? ==> Never :(
                End If
            Catch ex As Exception
                ExceptionManager.Publish(ex)
            End Try
        End Sub

        Public Sub SetContext(ByVal oCtx As IServerContext) Implements ISystemEntryPoint.SetContext
            m_oCtx = oCtx
        End Sub

        Public Function GetContext() As IServerContext Implements ISystemEntryPoint.GetContext
            Return m_oCtx
        End Function
        Protected Sub GetConfigData()
            '!!! Bloody App Blocks. Have config as type...can't cast to this prj's config type...
            'Need to reference the ServerContext assembly & use its CustomConfigData to work...
            'Stuff it, don't really need that Enabled flag anyway...
            m_oCfgData = DirectCast(ConfigurationManager.Read(m_sConfigSourceSection), RequestReMapping.CustomConfigurationData.RequestReMaps)
            If m_oCfgData Is Nothing Then
                Throw New ApplicationException("no config on provider.")
            End If

            ConfigChanged()
        End Sub


        Private Function ShouldLog(ByVal eLoglevel As LogDefs.eLogLevel) As Boolean
            Return m_oCtx.ShouldLog(eLoglevel)
        End Function



        Private Sub ConfigChangedHandler(ByVal storageProvider As IConfigurationStorageReader, _
                               ByVal sectionName As String)
            ConfigChanged()
            'EventLog.WriteEntry("ESB.NET", "Received Update Notification for: " & sectionName, EventLogEntryType.Information)
        End Sub
        Private Sub ConfigChanged()
            'Dim oSep As ESB.Core.Services.Server.CustomConfigurationData.SystemEntryPoint
        End Sub


#End Region


        ''' <summary>
        ''' Replace the context with the stripped down/naked version which is what the server understands...
        ''' Same for the Envelope request...Change the Service Name, Namespace, Version...etc. 
        ''' i.e. All the fields that are used to derive the Context...
        ''' </summary>
        ''' <remarks></remarks>
        Sub RemapRequest()
            'm_oCtx.ResolveName = "" ' ResolveName SHOULD NOT BE CHANGED

            If m_oCtx.Context.Contains(C_sDelimeterStart) = False Then
                Return
            End If
            m_oCtx.Context = StripClientSideGroupings(m_oCtx.Context, m_oCtx.EnvRq.ServiceNamespace, m_oCtx.EnvRq.ServiceName, m_oCtx.EnvRq.ServiceVersion)

        End Sub


        Function StripClientSideGroupings(ByVal sClientNames As String, Optional ByRef sServiceNamespace As String = "", Optional ByRef sServiceName As String = "", Optional ByRef sServiceVersion As String = "") As String
            Dim sParsedNames As String
            Dim C_sDelimeterStart As String = "CSWSDLs"
            Dim C_sDelimeterEnd As String = "CSWSDLe"




            'sClientNames = CSWSDLs_group_namespace_goes_here_CSWSDLe.au.com.keystroke.samples.banking.services.CSWSDLs_servicename_goes_here_CSWSDLe.RetrieveAccountPortfolio_v2_0_0_0

            'Remove the ClientNamespace
            sParsedNames = sClientNames.Substring(sClientNames.IndexOf(C_sDelimeterEnd) + C_sDelimeterEnd.Length + 1, sClientNames.Length - sClientNames.IndexOf(C_sDelimeterEnd) - C_sDelimeterEnd.Length - 1)

            'Now...
            'sParsedNames = au.com.keystroke.samples.banking.services.CSWSDLs_servicename_goes_here_CSWSDLe.RetrieveAccountPortfolio_v2_0_0_0

            If sParsedNames.Contains(C_sDelimeterStart) Then
                'both have...

                'Get the Server Namespace
                sServiceNamespace = sParsedNames.Substring(0, sParsedNames.IndexOf(C_sDelimeterStart) - 1)
                'sServerNamespace = au.com.keystroke.samples.banking.services.

                Dim i As Integer = sParsedNames.IndexOf(C_sDelimeterStart)
                Dim sDelim As String = sParsedNames.Substring(i - 1, 1)


                'Remove the Client Service name
                sServiceName = sParsedNames.Substring(sParsedNames.IndexOf(C_sDelimeterEnd) + C_sDelimeterEnd.Length + 1, sParsedNames.Length - sParsedNames.IndexOf(C_sDelimeterEnd) - C_sDelimeterEnd.Length - 1)

                'Add the Server namespace to the server service name
                sParsedNames = sServiceNamespace & sDelim & sServiceName

                sServiceVersion = ""

                Return sParsedNames

            Else
                '
                sServiceNamespace = ""
                sServiceVersion = ""
                sServiceName = sParsedNames
                Return sParsedNames

            End If

        End Function


    End Class
End Namespace
