' ===============================================================================
' Microsoft Configuration Management Application Block for .NET
' http://msdn.microsoft.com/library/en-us/dnbda/html/cmab.asp
'
' CustomSectionHandler.vb
'
' The section handler that uses the XmlSerializer class to store to convert
' the CCustomConfigurationData class into an XmlNode
'
' For more information see the Configuration Management Application Block Implementation Overview. 
' 
' ===============================================================================
' Copyright (C) 2000-2001 Microsoft Corporation
' All rights reserved.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
' OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
' LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
' FITNESS FOR A PARTICULAR PURPOSE.
' ==============================================================================

Imports System
Imports System.Configuration
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Xml
Imports System.Xml.Serialization

Imports Microsoft.ApplicationBlocks.ConfigurationManagement

<ComVisible(False)> _
   Public Class CustomSectionHandler
    Implements IConfigurationSectionHandlerWriter
    Private xs As New XmlSerializer(GetType(RequestReMapping.CustomConfigurationData.RequestReMaps))


    Public Function Create(ByVal parent As Object, ByVal hmm As Object, ByVal configSection As XmlNode) As Object _
        Implements IConfigurationSectionHandlerWriter.Create

        Dim tmpObj As Object = Nothing
        tmpObj = xs.Deserialize(New StringReader(configSection.OuterXml))
        Return CType(tmpObj, RequestReMapping.CustomConfigurationData.RequestReMaps)
    End Function 'Create


    Public Function Serialize(ByVal value As Object) As XmlNode _
        Implements IConfigurationSectionHandlerWriter.Serialize

        Try
            Dim sw As New StringWriter(System.Globalization.CultureInfo.CurrentUICulture)
            xs.Serialize(sw, value)
            Dim doc As New XmlDocument
            doc.LoadXml(sw.ToString())
            Return doc.ChildNodes(1)
        Catch e As Exception
            Throw New ConfigurationErrorsException("The section handler can't be serialized", e)
        End Try
    End Function 'Serialize
End Class 'CustomSectionHandler
