''-----------------------------------------------------------------------------
'' <summary>
'' Copyright Keystroke IT 2003
'' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
'' </summary>
''-----------------------------------------------------------------------------

Imports ESB.Core.Services
Imports ESB.Core.Interfaces.ServerContext
Imports Microsoft.ApplicationBlocks.ConfigurationManagement

Public Class ReturnSpecifiedFileHandler
    Inherits ESBComponent

    Protected m_oCfgData As CustomConfigurationData

    'todo: Change name to: ESB.Adaptors.Application.TestTxns
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()

        Try
            If GetContext.ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then : LogMsg(LogDefs.eLogLevel.eLOG_TRACE, oEnv.XML) : End If
            'LogMsg(LogDefs.eLogLevel.eLOG_TRACE, oEnv.XML)

            Dim oEnvRs As New ESBEnvelope.Envelope '= oEnv.CreateResponse()
            Dim sFilePath As String = oEnv.GetCustomParam("ESBCore", "ReturnSpecifiedFile")
            oEnvRs.XML = ESB.Core.Util.File.Read(Utils.ExpandRelativePath(sFilePath))
            If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then : LogMsg(LogDefs.eLogLevel.eLOG_TRACE, oEnvRs.XML) : End If

            'TODO: Add a flag to add this input file into the body of an envelope
            'To be used by the Generic SOAP Transport Adaptor...



            Return oEnvRs
        Catch ex As Exception
            LogError(eLogLevel.eLOG_ERROR, ex.ToString)
            ExceptionManager.Publish(ex)
            Throw
        Finally
            EndMethod()
        End Try
    End Function


    Protected Overridable Sub GetConfigData()
        'Dim sourceSection As String = "OtherConfigFile"
        'can change this to be the assembly namespace if we use that convention...
        Dim m_sSourceSection As String = "ESB.Testing.TestTxns"
        m_oCfgData = CType(ConfigurationManager.Read(m_sSourceSection), CustomConfigurationData)
        If m_oCfgData Is Nothing Then
            Throw New ApplicationException("no config on provider.")
        End If
    End Sub
End Class
