'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Imports ESB.Core.Services
Imports ESB.Core.Interfaces.ServerContext
Imports Microsoft.ApplicationBlocks.ConfigurationManagement
Imports System.Threading



Public Class TestTxn1
    Inherits ESBComponent

    Protected m_oCfgData As CustomConfigurationData


    'todo: Change name to: ESB.Adaptors.Application.TestTxns
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()
        Dim oEnvRs As ESBEnvelope.Envelope = Nothing

        Try
            If GetContext.ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then
                If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then : LogMsg(LogDefs.eLogLevel.eLOG_TRACE, oEnv.MessageID) : End If
            End If
            If GetContext.ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then
                If ShouldLog(LogDefs.eLogLevel.eLOG_TRACE) Then : LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "Request XML", "", oEnv.XML) : End If
            End If

           
            'Dim oEnvRs As IEnvelope = oEnv.CreateResponse
            'Dim oEnvRs As ESBEnvelope.Envelope = CType(oEnv.CreateResponse(), IEnvelope)
            'Dim oEnvRs As New ESBEnvelope.Envelope(oEnv.CreateResponse)
            oEnvRs = oEnv.CreateResponse()
            'Dim oenvx As New ESBEnvelope.Envelope

            oEnvRs.SystemName = "Request Succeeded"
            'oEnvRs.MessageID = oEnv.MessageID & "Some other MsgID Appended"
            oEnvRs.Environment = oEnvRs.Environment & "Some Env Appended"
            Dim oErr As New ErrorXML.ErrorXML

            'If (oEnv.Environment <> "Error") And (oEnv.Environment <> "Error") And (oEnv.Environment <> "ErrorAndWarning") Then
            If oEnv.Environment = "Warning" Then
                Dim oWarningEntry As New ErrorXML.WarningEntry
                With oWarningEntry
                    .Code = "testcode"
                    .Description = "if you get this message then the test txn worked."
                    .Description = .Description & "ESBSoapRpcUrlkey=" & System.Configuration.ConfigurationManager.AppSettings("ESBSoapRpcUrlkey")
                    .Source = System.Reflection.Assembly.GetExecutingAssembly.ToString
                End With
                oErr.WarningEntry.Add(oWarningEntry)
            ElseIf oEnv.Environment = "Error" Then
                Dim oErrorEntry As New ErrorXML.ErrorEntry
                With oErrorEntry
                    .Code = "testcode"
                    .Description = "if you get this message then the test txn worked."
                    .Description = .Description & "ESBSoapRpcUrlkey=" & System.Configuration.ConfigurationManager.AppSettings("ESBSoapRpcUrlkey")
                    .Source = System.Reflection.Assembly.GetExecutingAssembly.ToString
                End With
                oErr.ErrorEntry.Add(oErrorEntry)
            ElseIf oEnv.Environment = "ErrorAndWarning" Then
                Dim oWarningEntry As New ErrorXML.WarningEntry
                With oWarningEntry
                    .Code = "testcode"
                    .Description = "if you get this message then the test txn worked."
                    .Description = .Description & "ESBSoapRpcUrlkey=" & System.Configuration.ConfigurationManager.AppSettings("ESBSoapRpcUrlkey")
                    .Source = System.Reflection.Assembly.GetExecutingAssembly.ToString
                End With
                oErr.WarningEntry.Add(oWarningEntry)
                Dim oErrorEntry As New ErrorXML.ErrorEntry
                With oErrorEntry
                    .Code = "testcode"
                    .Description = "if you get this message then the test txn worked."
                    .Description = .Description & "ESBSoapRpcUrlkey=" & System.Configuration.ConfigurationManager.AppSettings("ESBSoapRpcUrlkey")
                    .Source = System.Reflection.Assembly.GetExecutingAssembly.ToString
                End With
                oErr.ErrorEntry.Add(oErrorEntry)
            End If

            Dim sSleep As String = oEnv.GetCustomParam(ESB.Core.Util.C_sCustomParamESBCore, "Sleep")
            If sSleep <> "" Then
                Try
                    Threading.Thread.Sleep(sSleep)

                  
                    oEnvRs.AddDocument(New InlineDocument("<Sleep>" & sSleep & "</Sleep>"))
                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.ToString)
                    Throw
                End Try

            End If

            Dim sNativeSleep As String = oEnv.GetCustomParam(ESB.Core.Util.C_sCustomParamESBCore, "NativeSleep")
            If sNativeSleep <> "" Then
                Try

                    Win32APIDeclarations.Sleep(sNativeSleep)


                    oEnvRs.AddDocument(New InlineDocument("<NativeSleep>" & sNativeSleep & "</NativeSleep>"))
                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.ToString)
                    Throw
                End Try

            End If

            Dim sWaitOne As String = oEnv.GetCustomParam(ESB.Core.Util.C_sCustomParamESBCore, "WaitOne")
            If sWaitOne <> "" Then
                Try

                    Dim autoEvent As New System.Threading.AutoResetEvent(False)

                    If autoEvent.WaitOne(New TimeSpan(0, 0, 0, 0, sWaitOne), False) Then
                        Console.WriteLine("Work method signaled.")
                    Else
                        Console.WriteLine("Timed out waiting for work " & _
                            "method to signal.")
                    End If


                    oEnvRs.AddDocument(New InlineDocument("<WaitOne>" & sWaitOne & "</WaitOne>"))
                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.ToString)
                    Throw
                End Try

            End If


            Dim sSpinWait As String = oEnv.GetCustomParam(ESB.Core.Util.C_sCustomParamESBCore, "SpinWait")
            If sSpinWait <> "" Then
                Try
                    Threading.Thread.SpinWait(sSpinWait)
                    oEnvRs.AddDocument(New InlineDocument("<SpinWait>" & sSpinWait & "</SpinWait>"))
                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.ToString)
                    Throw
                End Try

            End If

            If oEnv.GetCustomParam(ESB.Core.Util.C_sCustomParamESBCore, "XsltTest") = "1" Then
                Try
                    'do some xslt testing...
                    'Dim oContext As ESB.Core.Interfaces.ServerContext.IServerContext
                    Dim sResolveNameCustomParamName As String = "TestResolveName"
                    Dim sContextCustomParamName As String = "TestContext"

                    Dim sResolveName As String = oEnv.GetCustomParam(ESB.Core.Util.C_sCustomParamESBCore, "TestResolveName")
                    Dim sContext As String = oEnv.GetCustomParam(ESB.Core.Util.C_sCustomParamESBCore, "TestContext")

                    Dim sXmlToTransform As String = oEnv.GetDocument(1).GetAsString()
                    Dim sTransformResult As String = ""

                    GetContext.Transform(sResolveName, sContext, sXmlToTransform, sTransformResult)

                    If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(eLogLevel.eLOG_DATAXFER, "sTransformResult=" & sTransformResult) : End If

                    oEnvRs.AddDocument(New InlineDocument(sTransformResult))

                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.ToString)
                    Throw
                End Try

            End If

            If oEnv.GetCustomParam(ESB.Core.Util.C_sCustomParamESBCore, "ConfigTest") = "1" Then
                Try
                    'do some Config Application Block testing...
                    'Dim oContext As ESB.Core.Interfaces.ServerContext.IServerContext
                    Dim sTmp As String


                    GetConfigData()
                    sTmp = m_oCfgData.ContextManager.ClientContextManagerObjectImplementation.AssemblyPath()

                    Dim oWarningEntry As New ErrorXML.WarningEntry
                    With oWarningEntry
                        .Code = "testcode"
                        .Description = "if you get this message then the test txn worked."
                        .Description = .Description & "ConfigTest Value=" & sTmp
                        .Source = System.Reflection.Assembly.GetExecutingAssembly.ToString
                    End With
                    oErr.WarningEntry.Add(oWarningEntry)

                    If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(eLogLevel.eLOG_DATAXFER, "sTmp=" & sTmp) : End If


                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.ToString)
                    Throw
                End Try

            End If


            If oEnv.Context = "TestAddToPipelineTransitionData" Then
                Dim sPTD As String = oEnv.GetCustomParam(ESB.Core.Util.C_sCustomParamESBCore, "TestAddToPipelineTransitionData")
                Try
                    Dim oWarningEntry As New ErrorXML.WarningEntry
                    With oWarningEntry
                        .Code = sPTD
                        .Description = "PipelineTransitionData instance " & sPTD
                        .Source = System.Reflection.Assembly.GetExecutingAssembly.ToString
                    End With
                    oErr.WarningEntry.Add(oWarningEntry)

                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.ToString)
                    Throw
                End Try

                Dim lIndex As String = oEnv.GetCustomParam(ESB.Core.Util.C_sCustomParamESBCore, "PipelineTransitionDataRSIndex")
                If oEnv.GetCustomParam(ESB.Core.Util.C_sCustomParamESBCore, "TestAddToPipelineTransitionData") = "3" Then
                    Try
                        Dim oWarningEntry As New ErrorXML.WarningEntry
                        With oWarningEntry
                            .Code = sPTD
                            .Description = "output of PipelineItem " & lIndex & " (handler) was" & GetContext.PipelineTransitionData.HandlerPipeline.m_oVertical.m_oRsEnvelopesCol(lIndex).XML
                            .Source = System.Reflection.Assembly.GetExecutingAssembly.ToString
                        End With
                        oErr.WarningEntry.Add(oWarningEntry)
                    Catch ex As Exception
                        ExceptionManager.Publish(ex)
                        LogError(eLogLevel.eLOG_ERROR, ex.ToString)
                        Throw
                    End Try
                End If
            End If

            oEnvRs.AddDocument(New InlineDocument(CType(oErr, Object)))
            Return oEnvRs
        Catch ex As Exception
            LogError(eLogLevel.eLOG_ERROR, ex.ToString)
            ExceptionManager.Publish(ex)

            Dim oErr As New ErrorXML.ErrorXML

            Dim oErrorEntry As New ErrorXML.ErrorEntry
            With oErrorEntry
                .Code = "testcode"
                .Description = "if you get this message then the test txn ran and threw an exception." & ex.ToString
                '.Description = .Description & "ESBSoapRpcUrlkey=" & System.Configuration.ConfigurationManager.AppSettings("ESBSoapRpcUrlkey")
                .Source = System.Reflection.Assembly.GetExecutingAssembly.ToString
            End With
            oErr.ErrorEntry.Add(oErrorEntry)

            If Not oEnvRs Is Nothing Then
                oEnvRs.AddDocument(New InlineDocument(DirectCast(oErr, Object)))
            End If
            Return oEnvRs

        Finally
            EndMethod()

        End Try

    End Function


    Protected Overridable Sub GetConfigData()
        'can change this to be the assembly namespace if we use that convention...
        Dim m_sSourceSection As String = "ESB.Testing.TestTxns"
        m_oCfgData = CType(ConfigurationManager.Read(m_sSourceSection), CustomConfigurationData)
        If m_oCfgData Is Nothing Then
            Throw New ApplicationException("no config on provider.")
        End If
    End Sub
End Class
