'''-----------------------------------------------------------------------------
''' <summary>
''' Copyright Keystroke IT 2003
''' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
''' </summary>
'''-----------------------------------------------------------------------------

Public MustInherit Class BaseSend
    Implements ESB.Core.Interfaces.ProcessMsg.IProcessMsg

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Derived classes should use this value for the URL...
    ''' It will be set to custom param values if they are set, otherwise it'll be set
    ''' to the envelope value (toAddress...)
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <history>
    ''' 	[MINA]	3/04/2004	Created
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Protected m_sUrl As String
    Public Sub New()

    End Sub
    'Public MustOverride Sub ProcessMsgAsync(ByRef oEnv As IEnvelope) Implements Interfaces.ProcessMsg.IProcessMsg.ProcessMsgAsync
    'Public MustOverride Function ProcessMsgSync(ByRef oEnv As IEnvelope) As IEnvelope Implements Interfaces.ProcessMsg.IProcessMsg.ProcessMsgSync
    Public Overridable Sub ProcessMsgAsync(ByVal oEnv As IEnvelope) Implements Interfaces.ProcessMsg.IProcessMsg.ProcessMsgAsync
        SetUrl(oEnv)

    End Sub
    Public Overridable Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope Implements Interfaces.ProcessMsg.IProcessMsg.ProcessMsgSync
        SetUrl(oEnv)
        Return Nothing

    End Function
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="oEnv"></param>
    ''' <remarks>
    ''' </remarks>
    ''' <history>
    ''' 	[MINA]	3/04/2004	Created
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Protected Overridable Sub SetUrl(ByRef oEnv As IEnvelope)

        'Set url by:
        ' 1 look at custom params
        ' 2 look at override in constructor?     ...naaahhhh...
        ' 3 look at envelope toAddress...

        m_sUrl = oEnv.GetCustomParam(C_sCustomParamESBCore, C_sCustomParamOverrideDestinationServerURL)
        If m_sUrl = "" Then
            m_sUrl = oEnv.ToAddress
        End If

        'Already done in the calling class...
        'oEnv.GetCustomParam(C_sCustomParamESBCore, C_sCustomParamOverrideTransportType)

    End Sub
    Public Overridable Function GetBaseContext() As ESB.Core.Services.BaseContext
        Dim oContext As ESB.Core.Services.BaseContext
        oContext = CType(CType(ESB.Core.Services.ContextManager.getContextManager(), ESB.Core.Services.ContextManager).GetExistingContext, ESB.Core.Services.BaseContext)
        Return oContext
    End Function
End Class
