'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Option Strict On


Namespace Wcf

    Public Class ESBSoapXmlDocTransportWcfSender
        Inherits ProxyAwareSender


        Protected m_oContext As ESB.Core.Services.BaseContext
        Protected m_oAttMgr As New AttachmentManagerSend

        Public Sub New()
            m_oAttMgr = New AttachmentManagerSend
            m_oContext = ESB.Core.Services.ContextManager.getContextManager.GetExistingContext()
            'm_oContext = ESB.Core.Services.ContextManager.getContextManager.GetContext("")
        End Sub

        Public Overrides Sub ProcessMsgAsync(ByVal oEnv As IEnvelope)
            StartMethod()
            MyBase.ProcessMsgAsync(oEnv)


            'Wcf supports multiple EndPoint names, so we'll pass in a Custom Param from the Client to the Adaptor
            'telling it which one to use...
            Dim sWcfEndPointName As String


            'Get from Custom Params (Request specific)
            sWcfEndPointName = oEnv.GetCustomParam(C_sInprocClientEndPointName)

            'Get from Config (Config Default setting)
            If sWcfEndPointName = "" Then
                sWcfEndPointName = System.Configuration.ConfigurationManager.AppSettings(C_sInprocClientEndPointName)
            End If

            'If no config - uses this..
            If sWcfEndPointName = "" Then
                sWcfEndPointName = "ESBSoapXmlDocTransportSoap"
            End If


            Dim oTx As New ESB.Core.Adaptors.Transport.Send.ESBSoapXmlDocTransportWcfProxyClasses.ProcessMsgClient(sWcfEndPointName, m_sUrl)
            oTx.Open()

            'Create an ESBMessage to encapsulate the request ESBEnvelope and any MTOM attachments
            Dim oESBMessageRequest As New ESBSoapXmlDocTransportWcfProxyClasses.ESBMessage
            oESBMessageRequest.EnvelopeXML = oEnv.ToXMLDocument.DocumentElement

            'Add the attachments  to the ESBMessage
            m_oAttMgr.SendAttachments(oESBMessageRequest, DirectCast(oEnv, Envelope), m_oContext)

            Dim oTimer As New ESB.Core.Util.Timer
            oTimer.StartTimer()

            'Make the WCF SOAP call which will do the MTOM attachment send for us...
            oTx.ProcessMsgSync(oESBMessageRequest)
            oTx.Close()
            'oTx.ProcessMsgSyncAsync(oESBMessageRequest)

            oTimer.StopTimer()
            Dim oCtx As ESB.Core.Services.BaseContext = GetBaseContext()
            oCtx.ExecutionTime = oTimer.Duration()

            EndMethod()

        End Sub

        Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
            StartMethod()

            Dim oESBMessageRequest As New ESBSoapXmlDocTransportWcfProxyClasses.ESBMessage
            Dim oESBMessageResponse As ESBSoapXmlDocTransportWcfProxyClasses.ESBMessage
            Dim sXMLrs As String
            Dim oTx As ESB.Core.Adaptors.Transport.Send.ESBSoapXmlDocTransportWcfProxyClasses.ProcessMsgClient

            Try
                'Sort out URL initialisation...
                MyBase.ProcessMsgSync(oEnv)


                'Wcf supports multiple EndPoint names, so we'll pass in a Custom Param from the Client to the Adaptor
                'telling it which one to use...
                Dim sWcfEndPointName As String


                'Get from Custom Params (Request specific)
                sWcfEndPointName = oEnv.GetCustomParam(C_sInprocClientEndPointName)

                'Get from Config (Config Default setting)
                If sWcfEndPointName = "" Then
                    sWcfEndPointName = System.Configuration.ConfigurationManager.AppSettings(C_sInprocClientEndPointName)
                End If

                'If no config - uses this..
                If sWcfEndPointName = "" Then
                    sWcfEndPointName = "ESBSoapXmlDocTransportSoap"
                End If

                oTx = New ESB.Core.Adaptors.Transport.Send.ESBSoapXmlDocTransportWcfProxyClasses.ProcessMsgClient(sWcfEndPointName, m_sUrl)
                'oTx.Endpoint.Address. = m_sUrl

                'Paul Glavich's thing'z not working - try commenting out the Open/Close...
                'Nope! Dodgy!!! Try later...
                oTx.Open()

                'Create an ESBMessage to encapsulate the request ESBEnvelope and any MTOM attachments
                oESBMessageRequest.EnvelopeXML = oEnv.ToXMLDocument.DocumentElement

                'Add the attachments to the ESBMessage
                m_oAttMgr.SendAttachments(oESBMessageRequest, DirectCast(oEnv, Envelope), m_oContext)

                Dim nExecutionTimes As Integer = 1
                Dim sCustomparamNumExecutionTimes As String = oEnv.GetCustomParam(C_sClientNumExecutionTimes)
                If sCustomparamNumExecutionTimes <> "" Then
                    nExecutionTimes = Integer.Parse(sCustomparamNumExecutionTimes)
                End If


                If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "Request XML==>" & oEnv.XML & "<==") : End If
                If ShouldLog(LogDefs.eLogLevel.eLOG_INFO) Then : LogMsg(LogDefs.eLogLevel.eLOG_INFO, "Sending Request ==>" & sCustomparamNumExecutionTimes & "<== times") : End If

                Dim oTimer As New ESB.Core.Util.Timer
                oTimer.StartTimer()


                For i As Integer = 1 To nExecutionTimes
                    'Make the Wcf SOAP call which will do the MTOM attachment send for us...
                    oESBMessageResponse = oTx.ProcessMsgSync(oESBMessageRequest)
                Next

                oTimer.StopTimer()
                Dim oCtx As ESB.Core.Services.BaseContext = GetBaseContext()
                oCtx.ExecutionTime = oTimer.Duration()

                'Create new ESBEnvelope & populate it from the response
                sXMLrs = oESBMessageResponse.EnvelopeXML.OuterXml
                If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "Response XML==>" & sXMLrs & "<==") : End If

                If sXMLrs = "" Then
                    Throw New Exception("Received an empty string instead of an envelope.")
                End If

                'Deserialize string into Envelope
                Dim oEnvRs As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope
                oEnvRs.XML = sXMLrs

                'Save the attachments & adjust Envelope attachment references to point locally
                m_oAttMgr.ReceiveAttachments(oESBMessageResponse, oEnvRs, m_oContext)

                oTx.Close()

                Return oEnvRs

            Catch ex As Exception

                ExceptionManager.Publish(ex)
                If ShouldLog(LogDefs.eLogLevel.eLOG_ERROR) Then : LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString) : End If
                If ShouldLog(LogDefs.eLogLevel.eLOG_ERROR) Then : LogError(LogDefs.eLogLevel.eLOG_ERROR, "Request XML==>" & oEnv.XML & "<==") : End If
                If ShouldLog(LogDefs.eLogLevel.eLOG_ERROR) Then : LogError(LogDefs.eLogLevel.eLOG_ERROR, "Response XML==>" & sXMLrs & "<==") : End If

                Throw  'should probably create an error doc & add it in to a new envelope etc...
            Finally

                EndMethod()
            End Try

        End Function
    End Class
End Namespace
