'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Option Strict On

Public Class ESBSoapXmlDocTransportWse3Sender
    Inherits ProxyAwareSender


    Protected m_oContext As ESB.Core.Services.BaseContext
    Protected m_oAttMgr As New AttachmentManagerSend

    Public Sub New()
        m_oAttMgr = New AttachmentManagerSend
        m_oContext = ESB.Core.Services.ContextManager.getContextManager.GetExistingContext()
        'm_oContext = ESB.Core.Services.ContextManager.getContextManager.GetContext("")
    End Sub

    Public Overrides Sub ProcessMsgAsync(ByVal oEnv As IEnvelope)
        StartMethod()
        MyBase.ProcessMsgAsync(oEnv)

        Dim oTx As New ESB.Core.Adaptors.Transport.Send.ESBSoapXmlDocTransportWse(m_sUrl)
        Dim sClientPolicy As String = System.Configuration.ConfigurationManager.AppSettings(C_sWSE3ClientPolicyConfigEntryName)

        'Only set if specified in config!
        'Note, *** I THINK - need to verify *** this has a high overhead ~ 200ms or so for each invocation on the client side for initial call!!!
        If sClientPolicy <> "" Then
            oTx.SetPolicy(sClientPolicy)
        End If
        MyBase.SetProxyServerSettings(oTx.Proxy)
        oTx.Timeout = Integer.Parse(System.Configuration.ConfigurationManager.AppSettings(C_sSoapDocumentTimeout))



        'Create an ESBMessage to encapsulate the request ESBEnvelope and any MTOM attachments
        Dim oESBMessageRequest As New ESBMessage
        oESBMessageRequest.EnvelopeXML = oEnv.ToXMLDocument.DocumentElement

        'Add the attachments  to the ESBMessage
        m_oAttMgr.SendAttachments(oESBMessageRequest, DirectCast(oEnv, Envelope), m_oContext)

        Dim oTimer As New ESB.Core.Util.Timer
        oTimer.StartTimer()

        'Make the WSE 3 SOAP call which will do the MTOM attachment send for us...
        oTx.ProcessMsgSyncAsync(oESBMessageRequest)

        oTimer.StopTimer()
        Dim oCtx As ESB.Core.Services.BaseContext = GetBaseContext()
        oCtx.ExecutionTime = oTimer.Duration()

        EndMethod()

    End Sub

    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()

        Dim oESBMessageRequest As New ESBMessage
        Dim oESBMessageResponse As ESBMessage
        Dim sXMLrs As String
        Try
            'Sort out URL initialisation...
            MyBase.ProcessMsgSync(oEnv)

            Dim oTx As New ESB.Core.Adaptors.Transport.Send.ESBSoapXmlDocTransportWse(m_sUrl)
            'oTx.SetPolicy("ClientPolicy")
            oTx.Timeout = Integer.Parse(System.Configuration.ConfigurationManager.AppSettings(C_sSoapDocumentTimeout))

            'Setup any proxy server settings
            MyBase.SetProxyServerSettings(oTx.Proxy)

            'Create an ESBMessage to encapsulate the request ESBEnvelope and any MTOM attachments
            oESBMessageRequest.EnvelopeXML = oEnv.ToXMLDocument.DocumentElement

            'Add the attachments  to the ESBMessage
            m_oAttMgr.SendAttachments(oESBMessageRequest, DirectCast(oEnv, Envelope), m_oContext)

            Dim nExecutionTimes As Integer = 1
            Dim sCustomparamNumExecutionTimes As String = oEnv.GetCustomParam(C_sClientNumExecutionTimes)
            If sCustomparamNumExecutionTimes <> "" Then
                nExecutionTimes = Integer.Parse(sCustomparamNumExecutionTimes)
            End If

            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "Request XML==>" & oEnv.XML & "<==") : End If
            If ShouldLog(LogDefs.eLogLevel.eLOG_INFO) Then : LogMsg(LogDefs.eLogLevel.eLOG_INFO, "Sending Request ==>" & sCustomparamNumExecutionTimes & "<== times") : End If

            Dim oTimer As New ESB.Core.Util.Timer
            oTimer.StartTimer()

            For i As Integer = 1 To nExecutionTimes
                'Make the WSE 3 SOAP call which will do the MTOM attachment send for us...
                oESBMessageResponse = oTx.ProcessMsgSync(oESBMessageRequest)
            Next

            oTimer.StopTimer()
            Dim oCtx As ESB.Core.Services.BaseContext = GetBaseContext()
            oCtx.ExecutionTime = oTimer.Duration()

            'Create new ESBEnvelope & populate it from the response
            sXMLrs = oESBMessageResponse.EnvelopeXML.OuterXml
            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "Response XML==>" & sXMLrs & "<==") : End If

            If sXMLrs = "" Then
                Throw New Exception("Received an empty string instead of an envelope.")
            End If

            'Deserialize string into Envelope
            Dim oEnvRs As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope
            oEnvRs.XML = sXMLrs

            'Save the attachments & adjust Envelope attachment references to point locally
            m_oAttMgr.ReceiveAttachments(oESBMessageResponse, oEnvRs, m_oContext)

            Return oEnvRs

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            If ShouldLog(LogDefs.eLogLevel.eLOG_ERROR) Then : LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString) : End If
            If ShouldLog(LogDefs.eLogLevel.eLOG_ERROR) Then : LogError(LogDefs.eLogLevel.eLOG_ERROR, "Request XML==>" & oEnv.XML & "<==") : End If
            If ShouldLog(LogDefs.eLogLevel.eLOG_ERROR) Then : LogError(LogDefs.eLogLevel.eLOG_ERROR, "Response XML==>" & sXMLrs & "<==") : End If

            Throw  'should probably create an error doc & add it in to a new envelope etc...
        Finally
            EndMethod()
        End Try

    End Function
End Class
