'''-----------------------------------------------------------------------------
''' <summary>
''' Copyright Keystroke IT 2003
''' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
''' </summary>
'''-----------------------------------------------------------------------------
Public Class HTTPSender
    Inherits ProxyAwareSender

    Public Overrides Sub ProcessMsgAsync(ByVal oEnv As IEnvelope)
        StartMethod()
        Dim oTx As New ESB.Core.HTTPClient.XMLHttpRequest
        MyBase.ProcessMsgAsync(oEnv)

        Try
            oTx = New ESB.Core.HTTPClient.XMLHttpRequest
            'Dim urlSetting As String = System.Configuration.ConfigurationManager.AppSettings("ESBHTTPUrlkey")
            oTx.Open("POST", m_sUrl, False, "", "")
            MyBase.SetProxyServerSettings(oTx.lgRequest.Proxy)
            oTx.lgRequest.Timeout = System.Configuration.ConfigurationManager.AppSettings(C_sHttpTimeout)

            Dim sXMLrq As String = oEnv.XML
            Dim sXMLrs As String
            Dim nExecutionTimes As Integer = 1
            Dim sCustomparamNumExecutionTimes As String = oEnv.GetCustomParam(C_sClientNumExecutionTimes)
            If sCustomparamNumExecutionTimes <> "" Then
                nExecutionTimes = Integer.Parse(sCustomparamNumExecutionTimes)
            End If

            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "Request XML==>" & sXMLrq & "<==") : End If
            If ShouldLog(LogDefs.eLogLevel.eLOG_INFO) Then : LogMsg(LogDefs.eLogLevel.eLOG_INFO, "Sending Request ==>" & sCustomparamNumExecutionTimes & "<== times") : End If

            Dim oTimer As New ESB.Core.Util.Timer
            oTimer.StartTimer()

            For i As Integer = 1 To nExecutionTimes
                oTx.Send(sXMLrq)
            Next

            oTimer.StopTimer()
            Dim oCtx As ESB.Core.Services.BaseContext = GetBaseContext()
            oCtx.ExecutionTime = oTimer.Duration()
            Dim oEnvRs As New Envelope
            sXMLrs = oTx.GetResponseText()

            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "Response XML==>" & sXMLrs & "<==") : End If

            If sXMLrs = "" Then
                Throw New Exception("Received an empty string instead of an envelope.")
            End If

            oEnvRs.XML = sXMLrs


        Catch ex As Exception
            ExceptionManager.Publish(ex)
        Finally
            oTx.Dispose()
            EndMethod()
        End Try
    End Sub
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()

        MyBase.ProcessMsgSync(oEnv)
        Dim oTx As ESB.Core.HTTPClient.XMLHttpRequest

        Try

            Dim nExecutionTimes As Integer = 1
            Dim sCustomparamNumExecutionTimes As String = oEnv.GetCustomParam(C_sClientNumExecutionTimes)
            If sCustomparamNumExecutionTimes <> "" Then
                nExecutionTimes = Integer.Parse(sCustomparamNumExecutionTimes)
            End If
            Dim sXmlRq As String = oEnv.XML

            If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "Request XML==>" & sXmlRq & "<==") : End If
            If ShouldLog(LogDefs.eLogLevel.eLOG_INFO) Then : LogMsg(LogDefs.eLogLevel.eLOG_INFO, "Sending Request ==>" & sCustomparamNumExecutionTimes & "<== times") : End If

            Dim oTimer As New ESB.Core.Util.Timer
            oTimer.StartTimer()
            Dim sXmlRs As String = ""
            For i As Integer = 1 To nExecutionTimes
                oTx = New ESB.Core.HTTPClient.XMLHttpRequest
                'Dim urlSetting As String = System.Configuration.ConfigurationManager.AppSettings("ESBHTTPUrlkey")
                oTx.Open("POST", m_sUrl, False, "", "")
                MyBase.SetProxyServerSettings(oTx.lgRequest.Proxy)
                oTx.lgRequest.Timeout = System.Configuration.ConfigurationManager.AppSettings(C_sHttpTimeout)
                'oTx.lgRequest.Headers.Add("Host", 
                oTx.Send(sXmlRq)
                sXmlRs = oTx.GetResponseText()
            Next
            oTimer.StopTimer()

            Dim oCtx As ESB.Core.Services.BaseContext = GetBaseContext()
            oCtx.ExecutionTime = oTimer.Duration()

            Dim oEnvRs As New Envelope
            oEnvRs.XML = sXmlRs

            Return oEnvRs
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Throw
        Finally
            oTx.Dispose()
            EndMethod()
        End Try
    End Function
End Class
