'''-----------------------------------------------------------------------------
''' <summary>
''' Copyright Keystroke IT 2003
''' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
''' </summary>
'''-----------------------------------------------------------------------------
Public Class SOAPDocument
    Inherits ProxyAwareSender


    Protected m_oContext As ESB.Core.Services.BaseContext
    Protected m_oAttMgr As New AttachmentManagerSend

    Public Sub New()
        m_oAttMgr = New AttachmentManagerSend
        m_oContext = ESB.Core.Services.ContextManager.getContextManager.GetContext("")
    End Sub

    Public Overrides Sub ProcessMsgAsync(ByRef oEnv As IEnvelope)
        StartMethod()
        MyBase.ProcessMsgAsync(oEnv)

        Dim oTx As New ESB.Core.Adaptors.Transport.Send.ESBSoapDocTransport(m_surl)
        MyBase.SetProxyServerSettings(oTx.Proxy)
        oTx.Timeout = System.Configuration.ConfigurationManager.AppSettings(C_sSoapDocumentTimeout)

        m_oAttMgr.SendAttachments(oTx.RequestSoapContext.Current, oEnv)
        Dim oTimer As New ESB.core.Util.Timer
        oTimer.StartTimer()
        oTx.ProcessMsgASync(oEnv.XML)
        oTimer.StopTimer()
        Dim oCtx As ESB.Core.Services.BaseContext = GetBaseContext()
        oCtx.m_sExecutionTime = oTimer.Duration()
        EndMethod()

    End Sub

    Public Overrides Function ProcessMsgSync(ByRef oEnv As IEnvelope) As IEnvelope
        StartMethod()
        MyBase.ProcessMsgSync(oEnv)

        Dim oTx As New ESB.Core.Adaptors.Transport.Send.ESBSoapDocTransport(m_surl)
        oTx.Timeout = System.Configuration.ConfigurationManager.AppSettings(C_sSoapDocumentTimeout)
        MyBase.SetProxyServerSettings(oTx.Proxy)

        m_oAttMgr.SendAttachments(oTx.RequestSoapContext, oEnv, m_oContext)

        Dim oEnvRs As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope
        Dim sXMLrq As String = oEnv.XML
        Dim sXMLrs As String

        If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "Request XML==>" & sXMLrq & "<==") : End If
        Dim oTimer As New ESB.core.Util.Timer
        oTimer.StartTimer()
        sXMLrs = oTx.ProcessMsgSync(sXMLrq)
        oTimer.StopTimer()
        Dim oCtx As ESB.Core.Services.BaseContext = GetBaseContext()
        oCtx.m_sExecutionTime = oTimer.Duration()
        If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "Response XML==>" & sXMLrs & "<==") : End If

        If sXMLrs = "" Then
            Throw New Exception("Received an empty string instead of an envelope.")
        End If

        oEnvRs.XML = sXMLrs

        m_oAttMgr.ReceiveAttachments(oTx.ResponseSoapContext, oEnvRs, m_oContext)

        EndMethod()

        Return oEnvRs

    End Function
End Class
