'''-----------------------------------------------------------------------------
''' <summary>
''' Copyright Keystroke IT 2003
''' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
''' </summary>
'''-----------------------------------------------------------------------------
Public Class SOAPRpc
    Inherits ProxyAwareSender

    Protected m_oContext As ESB.Core.Services.BaseContext
    Protected m_oAttMgr As New AttachmentManagerSend

    Public Sub New()
        m_oAttMgr = New AttachmentManagerSend
        m_oContext = ESB.Core.Services.ContextManager.getContextManager.GetContext("")
    End Sub

    Public Overrides Sub ProcessMsgAsync(ByRef oEnv As IEnvelope)
        StartMethod()
        MyBase.ProcessMsgAsync(oEnv)
        Dim oTx As New ESB.Core.Adaptors.Transport.Send.ESBSoapRpcTransport(m_surl)
        oTx.Timeout = System.Configuration.ConfigurationManager.AppSettings(C_sSoapRpcTimeout)
        MyBase.SetProxyServerSettings(oTx.Proxy)

        m_oAttMgr.SendAttachments(oTx.RequestSoapContext.Current, oEnv)
        Dim oTimer As New ESB.core.Util.Timer
        oTimer.StartTimer()
        oTx.ProcessMsgASynch(oEnv.XML)
        oTimer.StopTimer()
        Dim oCtx As ESB.Core.Services.BaseContext = GetBaseContext()
        oCtx.m_sExecutionTime = oTimer.Duration()
        EndMethod()


        'TODO: set a timeout value parameter...
        'read it from the config file & also have it overridden from the custom params...
        '#If DEBUG Then
        '        oTx.Timeout = -1
        '#End If

        'm_oAttMgr.ReceiveAttachments(oTx.ResponseSoapContext.Current, oEnv, m_oContext.m_sMessageID)
    End Sub

    Public Overrides Function ProcessMsgSync(ByRef oEnv As IEnvelope) As IEnvelope
        StartMethod()
        MyBase.ProcessMsgSync(oEnv)

        Dim oTx As New ESB.Core.Adaptors.Transport.Send.ESBSoapRpcTransport(m_surl)
        oTx.Timeout = System.Configuration.ConfigurationManager.AppSettings(C_sSoapRpcTimeout)
        MyBase.SetProxyServerSettings(oTx.Proxy)

        m_oAttMgr.SendAttachments(oTx.RequestSoapContext, oEnv, m_oContext)
        Dim oEnvRs As New ESB.Core.XMLSchemaClasses.ESBEnvelope.Envelope
        'oTx.Proxy =
        Dim sXMLrq As String = oEnv.XML
        Dim sXMLrs As String

        If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then : LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "Request XML==>" & sXMLrq & "<==") : End If
        Dim oTimer As New ESB.core.Util.Timer
        oTimer.StartTimer()
        sXMLrs = oTx.ProcessMsgSynch(sXMLrq)
        oTimer.StopTimer()
        Dim oCtx As ESB.Core.Services.BaseContext = GetBaseContext()
        oCtx.m_sExecutionTime = oTimer.Duration()
        LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, "Response XML==>" & sXMLrs & "<==")

        If sXMLrs = "" Then
            Throw New Exception("Received an empty string instead of an envelope.")
        End If

        oEnvRs.XML = sXMLrs

        m_oAttMgr.ReceiveAttachments(oTx.ResponseSoapContext, oEnvRs, m_oContext)

        'TODO: set a timeout value parameter...
        'read it from the config file & also have it overridden from the custom params...
        '#If DEBUG Then
        '        oTx.Timeout = -1
        '#End If

        'm_oAttMgr.ReceiveAttachments(oTx.ResponseSoapContext.Current, oEnv, m_oContext.m_sMessageID)
        EndMethod()

        Return oEnvRs
    End Function
End Class
