'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Imports System.Messaging
Imports System.Text

<ComClass(ComServer.ClassId, ComServer.InterfaceId, ComServer.EventsId), System.Runtime.InteropServices.ProgId("ESB.Core.Async.MSMQTriggersEntryPoint.ComServer")> _
Public Class ComServer
#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "EC6F7F9D-E684-43F4-9EE2-EBB1A62C7F53"
    Public Const InterfaceId As String = "872F604A-D8C8-4FE9-8E04-E545EFE3984C"
    Public Const EventsId As String = "86E081C6-26ED-4431-81C4-EC62C5C887BE"
#End Region
    ' A creatable COM class must have a Public Sub New() 
    ' with no parameters, otherwise, the class will not be 
    ' registered in the COM registry and cannot be created 
    ' via CreateObject.
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub ProcessMsg(ByVal sQPath As String, ByVal sESBInstanceName As String)

        Dim sXMLrq As String
        Dim sXMLRs As String
        Dim sURL As String

        Try
            'Just sent the QPath Name - let the Transport Adaptor pick the message up from the queue - for reliability
            'This way, at most, we lose the notification. The message is still in the queue...
            sXMLrq = sQPath
            sURL = "http://localhost/ESB/" & sESBInstanceName & "/CoreInternetTransportAdaptors/Wse3/ESBHttpTransportInternalAsync.aspx"
            sXMLRs = ProcessMsgSync(sURL, sQPath)
        Catch ex As Exception
            ExceptionManager.Publish(ex)
        Finally
        End Try
    End Sub

    'Public Sub ProcessMsg(ByVal sQPath As String, ByVal sUrl As String)

    '    Dim sXMLrq As String
    '    Dim sXMLRs As String

    '    Try
    '        'sXMLrq = GetNextMsgFromQueue(sQPath)

    '        'Just sent the QPath Name - let the Transport Adaptor pick the message up from the queue - for reliability
    '        'This way, at most, we lose the notification. The message is still in the queue...
    '        sXMLrq = sQPath
    '        'better make sure it's not got the 
    '        'call synchronization type set to async!!!
    '        'Do in Pipeline etc. so that we don't have to
    '        'include envelope libraries here!
    '        'sXMLRs = ProcessMsgSync(sSoapRpcUrl, sXMLrq)
    '        sXMLRs = ProcessMsgSync(sUrl, sQPath)

    '    Catch ex As Exception
    '        ExceptionManager.Publish(ex)
    '    Finally
    '    End Try
    'End Sub
    Public Function GetNextMsgFromQueue(ByRef sQPath As String) As String

        Dim msg As Message
        Dim mq As MessageQueue

        Try
            If (Not MessageQueue.Exists(sQPath)) Then
                Throw New Exception("The queue " & sQPath & " does not exist!")
                Exit Function
            End If

            mq = New MessageQueue(sQPath)

            Dim ts As New TimeSpan(0, 0, 0, 0, 1000)
            Try
                ' Since message will be stored in XML fashion in MSMQ, you are formatting it
                Dim formatter As XmlMessageFormatter = CType(mq.Formatter, XmlMessageFormatter)
                formatter.TargetTypeNames = New String() {"System.String,mscorlib"}

                msg = mq.Receive()

                Return CStr(msg.Body())

            Catch ex As MessageQueueException
                ExceptionManager.Publish(ex)
                Throw

            Catch ex As InvalidOperationException
                ExceptionManager.Publish(ex)
                Throw
            End Try
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Return ""
        Finally
            If Not mq Is Nothing Then
                mq.Close()
            End If
        End Try

    End Function
    Public Function ProcessMsgSync(ByRef sUrl As String, ByRef sMsg As String) As String

        Dim oTx As ESB.Core.HTTPClient.XMLHttpRequest
        Try
            oTx = New ESB.Core.HTTPClient.XMLHttpRequest
            'Dim urlSetting As String = System.Configuration.ConfigurationManager.AppSettings("ESBHTTPUrlkey")
            oTx.Open("POST", sUrl, False, "", "")
            oTx.lgRequest.Timeout = 100000  ' System.Configuration.ConfigurationManager.AppSettings(C_sHttpTimeout)

            oTx.Send(sMsg)
            Return oTx.GetResponseText()
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            Return ex.ToString
        Finally
            oTx.Dispose()
        End Try
    End Function
End Class


