'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------



Option Strict Off
Option Explicit On

Imports System
Imports System.ComponentModel
Imports System.Diagnostics
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.Xml.Serialization
Imports System.Xml
Imports System.ServiceModel
Imports System.ServiceModel.Activation

Namespace ESB.Core.Adaptors.Transport.Internet.Receive.Wcf
    <ServiceContract([Namespace]:="http://ESB.Keystroke.com.au/ESB/wsdl/")> <System.Runtime.InteropServices.ComVisible(False)> _
    Public Interface IProcessMsg
        <OperationContract(Action:="http://ESB.Keystroke.com.au/ESB/wsdl/ProcessMsgSync"), _
         XmlSerializerFormat()> _
        Function ProcessMsgSync(ByVal request As ProcessMsgSyncRequest) As ProcessMsgSyncResponse

    End Interface
    <AspNetCompatibilityRequirements([RequirementsMode]:=AspNetCompatibilityRequirementsMode.Allowed)> _
    <System.Runtime.InteropServices.ComVisible(False)> _
    <ServiceBehavior([InstanceContextMode]:=InstanceContextMode.PerCall)> _
    Public Class ESBSoapXmlDocTransport : Implements IProcessMsg
        Private m_sXMLrs As String
        Private m_oContext As ServerContext
        Private Shared m_bInitialised As Boolean = False
        Private Shared m_bGotInstanceName As Boolean = False


        Shared Sub New()
            'Only wanna do this first time through...(need to look at multithreading etc. issues
            If Not m_bInitialised Then
                Dim oUri As System.Uri
                oUri = GetInstanceName()

                'Kick off async logger...async'ly...:)
                Threading.ThreadPool.QueueUserWorkItem(AddressOf StartAsyncLogger, oUri)

                m_bInitialised = True
            End If

        End Sub
        <OperationBehavior([Impersonation]:=ImpersonationOption.Allowed, [ReleaseInstanceMode]:=ReleaseInstanceMode.None)> _
        Public Function ProcessMsgSync(ByVal request As ProcessMsgSyncRequest) As ProcessMsgSyncResponse Implements IProcessMsg.ProcessMsgSync
            Dim oProcessMsgSyncResponse As New ProcessMsgSyncResponse
            Dim Response As New ESBMessage
            Try
                Dim oTimer As New Stopwatch
                oTimer.Start()


                ContextManager.IsServerContextmanager = True
                'DirectCast(ContextManager.getContextManager(True), Server.ServerContextManager).Start()
                Using oScm As Server.ServerContextManager = DirectCast(ContextManager.getContextManager(True), Server.ServerContextManager)
                    oScm.Start()

                    'Won't work till Start (above) is called...
                    StartMethod()

                    Response = ProcessMsgSyncInternal(request.Request)
                End Using 'the finalizer will call the dispose which will call the Finish() method...

                oProcessMsgSyncResponse.ProcessMsgSyncResult = Response

                '10,000 ticks in 1 millisecond
                '10 ticks in 1 micro second
                oTimer.Stop()
                Dim sTime As String = String.Format("{0} Ticks = {1} microseconds = {2} milliseconds", oTimer.Elapsed.Ticks, oTimer.Elapsed.Ticks / 10, oTimer.Elapsed.Ticks / 10000)

                Try
                    Dim oPerfmon As New PerfMonManager()
                    oPerfmon.Init("Wcf", m_oContext)
                    oPerfmon.SetCounterValues(True, oTimer.ElapsedTicks)
                    oTimer.Reset()

                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.Message)
                    'Swallow the exception...
                End Try

                Return oProcessMsgSyncResponse

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                Throw
            Finally
                'DirectCast(ContextManager.getContextManager(True), Server.ServerContextManager).Finish()
                If Not m_oContext Is Nothing Then
                    If Not m_oContext.threadLogDetail Is Nothing Then
                        m_oContext.threadLogDetail.sRequestSourceHost = ""
                        m_oContext.RequestSourceHost = ""
                    End If
                End If
                EndMethod()
            End Try

            'Return oProcessMsgSyncResponse
        End Function
        Private Function ProcessMsgSyncInternal(ByVal Request As ESBMessage) As ESBMessage
            StartMethod()
            Dim oEnvRs As ESBEnvelope.Envelope
            Dim sXMLrq As String
            Dim sXMLrs As String

            Dim Response As New ESBMessage

            Try

                '                If Not m_bGotInstanceName Then : GetInstanceName() : End If

                '++ Setup Transport Specific Properties...
                Dim oTransportProperties As New Core.Services.BaseContext.TransportProperties
                Dim oChannel As IContextChannel = System.ServiceModel.OperationContext.Current.Channel

                oTransportProperties.m_sRequestSourceHost = oChannel.LocalAddress.Uri.Host.ToString
                oTransportProperties.m_sTransportUrl = oChannel.LocalAddress.Uri.AbsoluteUri.ToString
                oTransportProperties.m_sTransportProfile = System.ServiceModel.OperationContext.Current.EndpointDispatcher.ChannelDispatcher.BindingName
                oTransportProperties.m_sServerDnsSafeHost = oChannel.LocalAddress.Uri.DnsSafeHost

                oTransportProperties.m_sTransportType = "SOAP (WCF)" 'm_oContext.envRq.ToAddressType

                'TODO - sort this out...
                'm_oContext.threadLogDetail.sRequestSourceHost = oChannel.LocalAddress.Uri.Host.ToString

                '!!! Need to be in context before    GetContextForRequest is called!!!!!  In order to get logged on the LogStart/SystemEntryPoint...
                'Otherwise, need to log on the LogFinish etc.../SystemExitPoint...   !!!NO...
                'So for the moment, pass them in...

                'TODO - Get this thing later...used to get if from the WSE3 Filter...
                'See if this thinggy gets it for us...
                'm_oContext.threadLogDetail.sRequestSourceHost = Context.Request.UserHostAddress
                'This thing's empty!!!
                'm_oContext.threadLogDetail.sRequestSourceHost = System.ServiceModel.OperationContext.Current.Channel.RemoteAddress.ToString

                'm_oContext.m_sRequestSourceHost = oChannel.LocalAddress.Uri.Host.ToString
                'm_oContext.m_sRequestSourceHost = oChannel.RemoteAddress.Uri.Host.ToString
                'm_oContext.m_sRequestSourceUserAgent = System.ServiceModel.OperationContext.Current.EndpointDispatcher.ContractName
                'm_oContext.m_sRequestSourceUrlReferrer = Context.Request.UrlReferrer.AbsoluteUri

                '-- Setup Transport Specific Properties...

                Dim sXmlDecl As String = "<?xml version=""1.0"" encoding=""utf-8""?>"

                sXMLrq = sXmlDecl & Request.EnvelopeXML.OuterXml
                m_oContext = CType(ContextManager.getContextManager(True), Server.ServerContextManager).GetContextForRequest(sXMLrq, oTransportProperties)


                If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, sXMLrq)

                'Dim x As New ESB.Utils.PerformanceMonitoring.PerfMon 
                Dim oAttMgr As New AttachmentManagerReceive


                oAttMgr.ReceiveAttachments(Request, m_oContext)
                Response.EnvelopeXML = m_oContext.ProcessMsgSync(m_oContext.envRq).ToXMLDocument.DocumentElement
                oAttMgr.SendAttachments(Response, m_oContext)
                If ShouldLog(eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, sXMLrs)

                Return Response

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString)

                'Need to make the logdefs an Assembly...
                Dim oErr As New ErrorXML.ErrorXML
                Dim oErrEntry As New ErrorXML.ErrorEntry
                oErr.ErrorEntry.Add(oErrEntry)
                oErrEntry.Code = "42"
                oErrEntry.Description = ex.ToString
                oErrEntry.Source = "ESB.Core.Adaptors.Transport.Internet.Receive.Wcf.ESBSoapXmlDocumentTransport.ProcessMsgSync()"

                oEnvRs = New ESBEnvelope.Envelope
                oEnvRs.AddDocument(New InlineDocument(oErr))
                Response.EnvelopeXML = oEnvRs.ToXMLDocument.DocumentElement
                Return Response

            Finally
                EndMethod()

                'oTimer.StopTimer()
                'LogError(eLogLevel.eLOG_TIMING, oTimer.Duration)
            End Try

        End Function
        Public Sub ProcessMsgASync(ByVal Request As ESBMessage) 'Implements IProcessMsg.ProcessMsgAsync

            Try
                ContextManager.IsServerContextmanager = True
                CType(ContextManager.getContextManager(True), Server.ServerContextManager).Start()

                StartMethod()

                'Response not needed here...
                ProcessMsgSyncInternal(Request)

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                Throw

            Finally
                DirectCast(ContextManager.getContextManager(True), Server.ServerContextManager).Finish()
                EndMethod()
                m_oContext.threadLogDetail.sRequestSourceHost = ""
                m_oContext.RequestSourceHost = ""

            End Try

        End Sub

        ''' <summary>
        ''' Get the Instance Name of this Transport Adaptor and write it out to the Global Variables in the Utils...
        ''' </summary>
        ''' <remarks>Only need to run this once and then cache it...</remarks>
        Private Shared Function GetInstanceName() As System.Uri
            If Not m_bGotInstanceName Then

                'Get the Query String so that we can figure out the Instance name...then cache it to the Utils.GlobalVariables...
                Dim oMessageProperties As System.ServiceModel.Channels.MessageProperties = OperationContext.Current.IncomingMessageProperties
                Dim oUri As System.Uri = DirectCast(oMessageProperties("Via"), System.Uri)

                'Dim oHttpRequestMessageProperty As System.ServiceModel.Channels.HttpRequestMessageProperty = DirectCast(oMessageProperties(System.ServiceModel.Channels.HttpRequestMessageProperty.Name), System.ServiceModel.Channels.HttpRequestMessageProperty)
                'Dim sQueryString As String = oHttpRequestMessageProperty.QueryString
                Dim sThisInstanceName As String = Utils.GetInstanceName(oUri.AbsoluteUri) '?Request.ApplicationPath?
                Util.ESBGlobalVariables.ESBInstanceName = sThisInstanceName
                Util.ESBGlobalVariables.DnsSafeHostName = oUri.DnsSafeHost
                Util.ESBGlobalVariables.RequestAbsoluteUri = oUri.AbsoluteUri

                m_bGotInstanceName = True
                Return oUri
            Else
                Return Nothing
            End If


        End Function



        ''' <summary>
        ''' Calls to the ASP.NET url which starts a background process to start listening on the MSMQ queues, and copies them to the 
        ''' SQL Server logs...
        ''' </summary>
        ''' <remarks></remarks>
        Shared Sub StartAsyncLogger(ByVal oUri As System.Uri)
            Dim sUrl As String
            Try

                Dim oHttpClient As New System.Net.WebClient
                sUrl = Utils.GetAsyncLoggerUrl(oUri.AbsoluteUri)
                Dim sAsyncLoggerUri As New System.Uri(sUrl)

                'oHttpClient.DownloadStringAsync(sAsyncLoggerUri)
                Dim sRs As String = oHttpClient.DownloadString(sAsyncLoggerUri)

            Catch ex As Exception
                EventLog.WriteEntry("ESB.NET", "Could not invoke start async logger URL : " & sUrl & ". Service URL invoking is:" & oUri.AbsoluteUri, EventLogEntryType.Information)
            End Try
        End Sub

    End Class

#Region "Slightly Modified Auto-Generate Code"

    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0"), _
     System.ServiceModel.ServiceContractAttribute([Namespace]:="http://ESB.Keystroke.com.au/ESB/wsdl/", ConfigurationName:="ESBSoapXmlDocTransportSoap")> _
    Public Interface ESBSoapXmlDocTransportSoap

        'CODEGEN: Generating message contract since message part namespace (http://www.keystroke.com.au/ESB) does not match the default value (http://ESB.Keystroke.com.au/ESB/wsdl/)
        <System.ServiceModel.OperationContractAttribute(Action:="http://ESB.Keystroke.com.au/ESB/wsdl/ProcessMsgSync", ReplyAction:="*"), _
         System.ServiceModel.XmlSerializerFormatAttribute()> _
        Function ProcessMsgSync(ByVal request As ProcessMsgSyncRequest) As ProcessMsgSyncResponse

        'CODEGEN: Generating message contract since message part namespace (http://www.keystroke.com.au/ESB) does not match the default value (http://ESB.Keystroke.com.au/ESB/wsdl/)
        <System.ServiceModel.OperationContractAttribute(Action:="http://ESB.Keystroke.com.au/ESB/wsdl/ProcessMsgASync", ReplyAction:="*"), _
         System.ServiceModel.XmlSerializerFormatAttribute()> _
        Function ProcessMsgASync(ByVal request As ProcessMsgASyncRequest) As ProcessMsgASyncResponse
    End Interface

    '''<remarks/>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("svcutil", "4.0.0.0"), _
     System.SerializableAttribute(), _
     System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.ComponentModel.DesignerCategoryAttribute("code"), _
     System.Xml.Serialization.XmlTypeAttribute([Namespace]:="http://www.keystroke.com.au/ESB")> _
    Partial Public Class ESBMessage
        Private envelopeXMLField As System.Xml.XmlElement
        Private attachmentField As New System.Collections.Generic.List(Of Byte())

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute(Order:=0)> _
        Public Property EnvelopeXML() As System.Xml.XmlElement
            Get
                Return Me.envelopeXMLField
            End Get
            Set(ByVal value As System.Xml.XmlElement)
                Me.envelopeXMLField = value
            End Set
        End Property

        '''<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("Attachment", DataType:="base64Binary", Order:=1)> _
        Public Property Attachment() As System.Collections.Generic.List(Of Byte())
            Get
                Return Me.attachmentField
            End Get

            Set(ByVal value As System.Collections.Generic.List(Of Byte()))
                Me.attachmentField = value
            End Set
        End Property
    End Class

    <System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0"), _
     System.ServiceModel.MessageContractAttribute(WrapperName:="ProcessMsgSync", WrapperNamespace:="http://ESB.Keystroke.com.au/ESB/wsdl/", IsWrapped:=True)> _
    Partial Public Class ProcessMsgSyncRequest

        <System.ServiceModel.MessageBodyMemberAttribute([Namespace]:="http://www.keystroke.com.au/ESB", Order:=0), _
         System.Xml.Serialization.XmlElementAttribute(IsNullable:=True)> _
        Public Request As ESBMessage

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal Request As ESBMessage)
            MyBase.New()
            Me.Request = Request
        End Sub
    End Class

    <System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0"), _
     System.ServiceModel.MessageContractAttribute(WrapperName:="ProcessMsgSyncResponse", WrapperNamespace:="http://ESB.Keystroke.com.au/ESB/wsdl/", IsWrapped:=True)> _
    Partial Public Class ProcessMsgSyncResponse

        <System.ServiceModel.MessageBodyMemberAttribute([Namespace]:="http://www.keystroke.com.au/ESB", Order:=0), _
         System.Xml.Serialization.XmlElementAttribute(IsNullable:=True)> _
        Public ProcessMsgSyncResult As ESBMessage

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal ProcessMsgSyncResult As ESBMessage)
            MyBase.New()
            Me.ProcessMsgSyncResult = ProcessMsgSyncResult
        End Sub
    End Class

    <System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0"), _
     System.ServiceModel.MessageContractAttribute(WrapperName:="ProcessMsgASync", WrapperNamespace:="http://ESB.Keystroke.com.au/ESB/wsdl/", IsWrapped:=True)> _
    Partial Public Class ProcessMsgASyncRequest

        <System.ServiceModel.MessageBodyMemberAttribute([Namespace]:="http://www.keystroke.com.au/ESB", Order:=0), _
         System.Xml.Serialization.XmlElementAttribute(IsNullable:=True)> _
        Public Request As ESBMessage

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal Request As ESBMessage)
            MyBase.New()
            Me.Request = Request
        End Sub
    End Class

    <System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0"), _
     System.ServiceModel.MessageContractAttribute(WrapperName:="ProcessMsgASyncResponse", WrapperNamespace:="http://ESB.Keystroke.com.au/ESB/wsdl/", IsWrapped:=True)> _
    Partial Public Class ProcessMsgASyncResponse

        Public Sub New()
            MyBase.New()
        End Sub
    End Class

    <System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0")> _
    Public Interface ESBSoapXmlDocTransportSoapChannel
        Inherits ESBSoapXmlDocTransportSoap, System.ServiceModel.IClientChannel
    End Interface

    <System.Diagnostics.DebuggerStepThroughAttribute(), _
     System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0")> _
    Partial Public Class ESBSoapXmlDocTransportSoapClient
        Inherits System.ServiceModel.ClientBase(Of ESBSoapXmlDocTransportSoap)
        Implements ESBSoapXmlDocTransportSoap

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal endpointConfigurationName As String)
            MyBase.New(endpointConfigurationName)
        End Sub

        Public Sub New(ByVal endpointConfigurationName As String, ByVal remoteAddress As String)
            MyBase.New(endpointConfigurationName, remoteAddress)
        End Sub

        Public Sub New(ByVal endpointConfigurationName As String, ByVal remoteAddress As System.ServiceModel.EndpointAddress)
            MyBase.New(endpointConfigurationName, remoteAddress)
        End Sub

        Public Sub New(ByVal binding As System.ServiceModel.Channels.Binding, ByVal remoteAddress As System.ServiceModel.EndpointAddress)
            MyBase.New(binding, remoteAddress)
        End Sub

        Function ESBSoapXmlDocTransportSoap_ProcessMsgSync(ByVal request As ProcessMsgSyncRequest) As ProcessMsgSyncResponse Implements ESBSoapXmlDocTransportSoap.ProcessMsgSync
            Return MyBase.Channel.ProcessMsgSync(request)
        End Function

        Public Function ProcessMsgSync(ByVal Request As ESBMessage) As ESBMessage
            Dim inValue As ProcessMsgSyncRequest = New ProcessMsgSyncRequest
            inValue.Request = Request
            Dim retVal As ProcessMsgSyncResponse = CType(Me, ESBSoapXmlDocTransportSoap).ProcessMsgSync(inValue)
            Return retVal.ProcessMsgSyncResult
        End Function

        Function ESBSoapXmlDocTransportSoap_ProcessMsgASync(ByVal request As ProcessMsgASyncRequest) As ProcessMsgASyncResponse Implements ESBSoapXmlDocTransportSoap.ProcessMsgASync
            Return MyBase.Channel.ProcessMsgASync(request)
        End Function

        Public Sub ProcessMsgASync(ByVal Request As ESBMessage)
            Dim inValue As ProcessMsgASyncRequest = New ProcessMsgASyncRequest
            inValue.Request = Request
            Dim retVal As ProcessMsgASyncResponse = CType(Me, ESBSoapXmlDocTransportSoap).ProcessMsgASync(inValue)
        End Sub
    End Class


#End Region

End Namespace

