''-----------------------------------------------------------------------------
'' <summary>
'' Copyright Keystroke IT 2003
'' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
'' </summary>
''-----------------------------------------------------------------------------
#Region "Imports"
Imports System
Imports System.IO
Imports System.Xml
Imports System.Xml.XPath

Imports ESB.Core.Services.Logger
Imports ESB.core.XMLSchemaClasses.ESBEnvelope
Imports ESB.Core.Interfaces.ServerContext
#End Region


Namespace ESB.Core.Adaptors.Transport.Internet.Receive.WSE3

    Partial Class ESBHTTPGenericWebServiceTransport
        Inherits System.Web.UI.Page

        Private Shared m_bGotInstanceName As Boolean = False

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub


        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private m_oContext As ESB.Core.Services.Server.ServerContext

        ''' <summary>
        ''' Accepts SOAP Messages over Raw HTTP, constructs an ESBEnvelope containing the SOAP Body
        ''' and invokes normal processing.
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        ''' <remarks>
        ''' - Expects a Wrapped SOAP Document/Literal style message.
        ''' Envelope parameters set in the following manner:
        ''' - The Service Name in the Envelope is extracted from the SOAP Service Namespace
        ''' - The Default Document is the First Document in the SOAP Body Element (i.e. the Service Schema)
        ''' Note that both the namespace of the document, and the Service Namespace are the same, as we're
        ''' not interested in the Body (Data Model Schema) details in this case...
        ''' We just want to put the Raw SOAP Data straight into an Envelope...
        ''' 
        ''' - The Context is not set
        ''' - The System is not set
        ''' </remarks>
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                Dim oTimer As New Stopwatch
                oTimer.Start()

                If Not m_bGotInstanceName Then : GetInstanceName() : End If
                ContextManager.IsServerContextmanager = True
                Dim sSoapXmlResponse As String
                'DirectCast(ContextManager.getContextManager(True), Server.ServerContextManager).Start()
                Using oScm As Server.ServerContextManager = DirectCast(ContextManager.getContextManager(True), Server.ServerContextManager)
                    oScm.Start()
                    StartMethod()

                    Response.Buffer = True
                    Response.ContentType = "text/xml"

                    'LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "SourceHost=" & Request.Headers("Host"))

                    'Create Envelope and populate 

                    Dim oEnvRq As ESBEnvelope.Envelope = CreateESBEnvelopeFromSOAPEnvelope(Request.InputStream)


                    Dim oTransportProperties As New ESB.Core.Services.BaseContext.TransportProperties
                    oTransportProperties.m_sRequestSourceHost = Context.Request.UserHostAddress
                    oTransportProperties.m_sServerDnsSafeHost = Context.Request.Url.DnsSafeHost
                    oTransportProperties.m_sRequestSourceUserAgent = Context.Request.UserAgent

                    'm_oContext.m_sRequestSourceUserAgent = Context.Request.UserAgent
                    'm_oContext.m_sRequestSourceUrlReferrer = Context.Request.UrlReferrer.AbsoluteUri
                    'm_oContext.m_sTransportUrl = Context.Request.RawUrl
                    'm_oContext.m_sTransportUrl = Context.Request.Url.AbsoluteUri
                    'oTransportProperties.m_sTransportUrl = "ESBHTTPGenericWebServiceTransport.aspx"
                    oTransportProperties.m_sTransportUrl = Context.Request.Url.AbsoluteUri

                    oTransportProperties.m_sTransportType = "HTTP" 'm_oContext.envRq.ToAddressType
                    'LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "SourceHost=" & Request.Headers("Host"))
                    '-- Setup Transport Specific Properties...

                    'Also shoves the envelope into the envelope in the context for us...
                    m_oContext = DirectCast(ESB.Core.Services.ContextManager.getContextManager(True), Server.ServerContextManager).GetContextForRequest(oEnvRq, oTransportProperties)

                    Dim sXMLResponse As String = m_oContext.ProcessMsgSync(m_oContext.envRq).XML

                    LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, sXMLResponse)

                    'Response.Write(sXMLResponse)'Response wrapped in ESBEnvelope


                    'Write out the First Response Document - this will be the SOAP Response...
                    Dim oEnvRs As New ESBEnvelope.Envelope(sXMLResponse)
                    sSoapXmlResponse = oEnvRs.GetDocument(0).GetAsString()

                    LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, sSoapXmlResponse)
                End Using 'the finalizer will call the dispose which will call the Finish() method...

                '10,000 ticks in 1 millisecond
                '10 ticks in 1 micro second
                oTimer.Stop()
                Dim sTime As String = String.Format("{0} Ticks = {1} microseconds = {2} milliseconds", oTimer.Elapsed.Ticks, oTimer.Elapsed.Ticks / 10, oTimer.Elapsed.Ticks / 10000)

                Try

                    Dim oPerfmon As New PerfMonManager()
                    oPerfmon.Init("HttpGenericWebSvc", m_oContext)
                    oPerfmon.SetCounterValues(True, oTimer.ElapsedTicks)

                    oTimer.Reset()

                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.Message)
                    'Swallow the exception...
                End Try

                Response.Write(sSoapXmlResponse)

            Catch ex As Exception
                LogError(eLogLevel.eLOG_ERROR, ex.Message)
            Finally

                ' CType(ESB.Core.Services.ContextManager.getContextManager(True), Server.ServerContextManager).Finish()
                EndMethod()
                m_oContext.threadLogDetail.sRequestSourceHost = ""
            End Try

        End Sub


        ''' <summary>
        ''' Get the Instance Name of this Transport Adaptor and write it out to the Global Variables in the Utils...
        ''' </summary>
        ''' <remarks>Only need to run this once and then cache it...</remarks>
        Private Sub GetInstanceName()
            If Not m_bGotInstanceName Then

                'Get the Query String so that we can figure out the Instance name...then cache it to the Utils.GlobalVariables...

                Dim sQueryString As String = Me.Context.Request.ApplicationPath
                Dim sThisInstanceName As String = Utils.GetInstanceName(sQueryString) '?Request.ApplicationPath?
                Util.ESBGlobalVariables.ESBInstanceName = sThisInstanceName
                Util.ESBGlobalVariables.DnsSafeHostName = Request.Url.DnsSafeHost
                Util.ESBGlobalVariables.RequestAbsoluteUri = Request.Url.AbsoluteUri

                m_bGotInstanceName = True
            End If

        End Sub



        Private Function CreateESBEnvelopeFromSOAPEnvelope(ByVal oSoapEnv As System.IO.Stream) As ESBEnvelope.Envelope
            'need to get SOAPEnvelope (Request.InputStream) 
            Dim oXmlDomDoc As New System.Xml.XmlDocument
            Dim oEnvRq As New ESBEnvelope.Envelope

            Try

                oXmlDomDoc.Load(Request.InputStream)
                Dim oBodyDoc As XmlNode

                Dim oXMLDocPipelineCfg As XmlDocument
                oXMLDocPipelineCfg = New XmlDocument
                Dim oNsMgr As New XmlNamespaceManager(oXMLDocPipelineCfg.NameTable)

                oNsMgr.AddNamespace("soap", "http://schemas.xmlsoap.org/soap/envelope/")
                oBodyDoc = oXmlDomDoc.SelectSingleNode("soap:Envelope/soap:Body/node()", oNsMgr)

                oEnvRq.AddDocument(New InlineDocument(oBodyDoc))
                'Sets the:
                '   oBodyDoc.Name
                '   oBodyDoc.NamespaceURI

                oEnvRq.ServiceName = oBodyDoc.Name 'The Service Name....Use the RootNode Name and Namespace here...
                oEnvRq.MessageContext = oBodyDoc.NamespaceURI 'and Namespace here...

                Return oEnvRq
            Catch ex As Exception
                Throw
            End Try

        End Function


    End Class

End Namespace

'Sample SOAP Envelope

'<?xml version="1.0" encoding="utf-8"?>
'<soap:Envelope xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/03/addressing" xmlns:wsse="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd">
'  <soap:Header>
'    <wsa:Action>http://ESB.Keystroke.com.au/ESB/wsdl/ProcessMsgSync</wsa:Action>
'    <wsa:MessageID>uuid:e074776f-8af8-4ee2-9013-4bd788213ca8</wsa:MessageID>
'    <wsa:ReplyTo>
'      <wsa:Address>http://schemas.xmlsoap.org/ws/2004/03/addressing/role/anonymous</wsa:Address>
'    </wsa:ReplyTo>
'    <wsa:To>http://baby/ESB/Source/CoreInternetTransportAdaptors/Wcf/ESBSoapXmlDocTransport.svc</wsa:To>
'    <wsse:Security>
'      <wsu:Timestamp wsu:Id="Timestamp-32c6924a-b3a9-4801-bdc1-30af3254bcee">
'        <wsu:Created>2006-12-21T13:45:51Z</wsu:Created>
'        <wsu:Expires>2006-12-21T13:50:51Z</wsu:Expires>
'      </wsu:Timestamp>
'    </wsse:Security>
'  </soap:Header>
'  <soap:Body>
'    <ProcessMsgSync xmlns="http://ESB.Keystroke.com.au/ESB/wsdl/">
'      <Request>
'        <ESBEnvelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0">
'          <header>
'            <delivery>
'              <message>
'                <senderMessageID />
'                <receiverMessageID />
'                <sent />
'                <subject />
'              </message>
'              <to>
'                <address>http://baby/ESB/Source/CoreInternetTransportAdaptors/Wcf/ESBSoapXmlDocTransport.svc</address>
'                <state>
'                  <handle />
'                  <process />
'                  <referenceID />
'                </state>
'                <addressType>SOAP-XMLDOCUMENT</addressType>
'              </to>
'              <from>
'                <address />
'                <state>
'                  <handle />
'                  <process />
'                  <referenceID />
'                </state>
'                <addressType />
'              </from>
'              <callSynchronizationType>0</callSynchronizationType>
'            </delivery>
'            <manifest>
'              <document>
'                <name>BuildCmd2</name>
'                <description>Test Document</description>
'                <documentNamespace>urn:schemas-biztalk-org:biztalk:BuildCmd2:BuildCmd2</documentNamespace>
'              </document>
'            </manifest>
'            <systems>
'              <system>
'                <adminID />
'                <systemID>Some System ID</systemID>
'                <url />
'                <environment />
'                <systemType />
'                <systemVersion />
'              </system>
'            </systems>
'            <service>
'              <name />
'              <version />
'              <context />
'              <description>Test Service</description>
'            </service>
'          </header>
'          <body>
'            <documentBody>
'              <BuildCmd2 xmlns="urn:schemas-biztalk-org:biztalk:BuildCmd2:BuildCmd2">
'                <BuildCmdString>0</BuildCmdString>
'              </BuildCmd2>
'            </documentBody>
'          </body>
'        </ESBEnvelope>
'      </Request>
'    </ProcessMsgSync>
'  </soap:Body>
'</soap:Envelope>


'SOAP 1.1
'Request
'<?xml version="1.0" encoding="utf-8"?>
'<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
'  <soap:Body>
'    <HelloWorld xmlns="http://tempuri.org/" />
'  </soap:Body>
'</soap:Envelope>

'Response
'<?xml version="1.0" encoding="utf-8"?>
'<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
'  <soap:Body>
'    <HelloWorldResponse xmlns="http://tempuri.org/">
'      <HelloWorldResult>string</HelloWorldResult>
'    </HelloWorldResponse>
'  </soap:Body>
'</soap:Envelope>

'SOAP 1.2
'Request
'<?xml version="1.0" encoding="utf-8"?>
'<soap12:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap12="http://www.w3.org/2003/05/soap-envelope">
'  <soap12:Body>
'    <HelloWorld xmlns="http://tempuri.org/" />
'  </soap12:Body>
'</soap12:Envelope>

'Response
'<?xml version="1.0" encoding="utf-8"?>
'<soap12:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap12="http://www.w3.org/2003/05/soap-envelope">
'  <soap12:Body>
'    <HelloWorldResponse xmlns="http://tempuri.org/">
'      <HelloWorldResult>string</HelloWorldResult>
'    </HelloWorldResponse>
'  </soap12:Body>
'</soap12:Envelope>



'<?xml version="1.0" encoding="UTF-8"?>
'<soap:Envelope xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
'<soap:Body>
'<gs:doGoogleSearch xmlns:gs="urn:GoogleSearch">
'<key>%(key)s</key>
'<q>%(q)s</q>
'<start>0</start>
'<maxResults>10</maxResults>
'<filter>true</filter>
'<restrict/>
'<safeSearch>false</safeSearch>
'<lr/>
'<ie>latin1</ie>
'<oe>latin1</oe>
'</gs:doGoogleSearch>
'</soap:Body>
'</soap:Envelope>