'''-----------------------------------------------------------------------------
''' <summary>
''' Copyright Keystroke IT 2003
''' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
''' </summary>
'''-----------------------------------------------------------------------------
#Region "Imports"

Imports System
Imports System.IO
Imports System.Xml
Imports System.Xml.XPath

Imports ESB.Core.Services.Logger
Imports ESB.Core.XMLSchemaClasses.ESBEnvelope
Imports ESB.Core.Interfaces.ServerContext

Imports System.Xml.Serialization
Imports System.Text
Imports ESB.Core.Util
Imports System.Xml.Schema
Imports System.Xml.Linq

#End Region


Namespace ESB.Core.Adaptors.Transport.Internet.Receive.WSE3

    Partial Class ESBHTTPGenericWebServiceTransport_TF
        Inherits System.Web.UI.Page

        Private Shared m_bGotInstanceName As Boolean = False

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub


        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private m_oContext As ESB.Core.Services.Server.ServerContext

        ''' <summary>
        ''' Accepts SOAP Messages over Raw HTTP, constructs an ESBEnvelope containing the SOAP Body
        ''' and invokes normal processing.
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        ''' <remarks>
        ''' - Expects a Wrapped SOAP Document/Literal style message.
        ''' Envelope parameters set in the following manner:
        ''' - The Service Name in the Envelope is extracted from the SOAP Service Namespace
        ''' - The Default Document is the First Document in the SOAP Body Element (i.e. the Service Schema)
        ''' Note that both the namespace of the document, and the Service Namespace are the same, as we're
        ''' not interested in the Body (Data Model Schema) details in this case...
        ''' We just want to put the Raw SOAP Data straight into an Envelope...
        ''' 
        ''' - The Context is not set
        ''' - The System is not set
        ''' </remarks>
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                Dim oTimer As New Stopwatch
                oTimer.Start()

                If Not m_bGotInstanceName Then : GetInstanceName() : End If
                ContextManager.IsServerContextmanager = True
                Dim sSoapXmlResponse As String
                'DirectCast(ContextManager.getContextManager(True), Server.ServerContextManager).Start()
                Using oScm As Server.ServerContextManager = DirectCast(ContextManager.getContextManager(True), Server.ServerContextManager)
                    oScm.Start()
                    StartMethod()

                    Response.Buffer = True
                    'Response.ContentType = "text/xml"
                    'application/soap+xml; charset=utf-8
                    Response.ContentType = "application/soap+xml; charset=utf-8"

                    'LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "SourceHost=" & Request.Headers("Host"))

                    'Create Envelope and populate 

                    Dim oEnvRq As ESBEnvelope.Envelope = CreateESBEnvelopeFromSOAPEnvelope(Request.InputStream)


                    Dim oTransportProperties As New ESB.Core.Services.BaseContext.TransportProperties
                    oTransportProperties.m_sRequestSourceHost = Context.Request.UserHostAddress
                    oTransportProperties.m_sServerDnsSafeHost = Context.Request.Url.DnsSafeHost
                    oTransportProperties.m_sRequestSourceUserAgent = Context.Request.UserAgent

                    'm_oContext.m_sRequestSourceUserAgent = Context.Request.UserAgent
                    'm_oContext.m_sRequestSourceUrlReferrer = Context.Request.UrlReferrer.AbsoluteUri
                    'm_oContext.m_sTransportUrl = Context.Request.RawUrl
                    'm_oContext.m_sTransportUrl = Context.Request.Url.AbsoluteUri
                    'oTransportProperties.m_sTransportUrl = "ESBHTTPGenericWebServiceTransport.aspx"
                    oTransportProperties.m_sTransportUrl = Context.Request.Url.AbsoluteUri

                    oTransportProperties.m_sTransportType = "HTTP" 'm_oContext.envRq.ToAddressType
                    'LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "SourceHost=" & Request.Headers("Host"))
                    '-- Setup Transport Specific Properties...

                    'Also shoves the envelope into the envelope in the context for us...
                    m_oContext = DirectCast(ESB.Core.Services.ContextManager.getContextManager(True), Server.ServerContextManager).GetContextForRequest(oEnvRq, oTransportProperties)

                    Dim sXMLResponse As String = m_oContext.ProcessMsgSync(m_oContext.envRq).XML

                    LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, sXMLResponse)

                    'Response.Write(sXMLResponse)'Response wrapped in ESBEnvelope


                    'Write out the First Response Document - this will be the SOAP Response...
                    Dim oEnvRs As New ESBEnvelope.Envelope(sXMLResponse)
                    sSoapXmlResponse = CreateSOAPEnvelopeFromESBEnvelope(oEnvRs)
                    'sSoapXmlResponse = oEnvRs.GetDocument(0).GetAsString()

                    LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, sSoapXmlResponse)
                End Using 'the finalizer will call the dispose which will call the Finish() method...

                '10,000 ticks in 1 millisecond
                '10 ticks in 1 micro second
                oTimer.Stop()
                Dim sTime As String = String.Format("{0} Ticks = {1} microseconds = {2} milliseconds", oTimer.Elapsed.Ticks, oTimer.Elapsed.Ticks / 10, oTimer.Elapsed.Ticks / 10000)

                Try

                    Dim oPerfmon As New PerfMonManager()
                    oPerfmon.Init("HttpGenericWebSvc", m_oContext)
                    oPerfmon.SetCounterValues(True, oTimer.ElapsedTicks)

                    oTimer.Reset()

                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.Message)
                    'Swallow the exception...
                End Try

                Response.Write(sSoapXmlResponse)

            Catch ex As Exception
                LogError(eLogLevel.eLOG_ERROR, ex.Message)
            Finally

                ' CType(ESB.Core.Services.ContextManager.getContextManager(True), Server.ServerContextManager).Finish()
                EndMethod()
                m_oContext.threadLogDetail.sRequestSourceHost = ""
            End Try

        End Sub


        ''' <summary>
        ''' Get the Instance Name of this Transport Adaptor and write it out to the Global Variables in the Utils...
        ''' </summary>
        ''' <remarks>Only need to run this once and then cache it...</remarks>
        Private Sub GetInstanceName()
            If Not m_bGotInstanceName Then

                'Get the Query String so that we can figure out the Instance name...then cache it to the Utils.GlobalVariables...

                Dim sQueryString As String = Me.Context.Request.ApplicationPath
                Dim sThisInstanceName As String = Utils.GetInstanceName(sQueryString) '?Request.ApplicationPath?
                Util.ESBGlobalVariables.ESBInstanceName = sThisInstanceName
                Util.ESBGlobalVariables.DnsSafeHostName = Request.Url.DnsSafeHost
                Util.ESBGlobalVariables.RequestAbsoluteUri = Request.Url.AbsoluteUri

                m_bGotInstanceName = True
            End If

        End Sub



        Private Function CreateESBEnvelopeFromSOAPEnvelope(ByVal oSoapEnv As System.IO.Stream) As ESBEnvelope.Envelope
            'need to get SOAPEnvelope (Request.InputStream) 
            Dim oXmlDomDoc As New System.Xml.XmlDocument
            Dim oEnvRq As New ESBEnvelope.Envelope

            Try

                oXmlDomDoc.Load(Request.InputStream)
                Dim oBodyDoc As XmlNode

                Dim oXMLDocPipelineCfg As XmlDocument
                oXMLDocPipelineCfg = New XmlDocument
                Dim oNsMgr As New XmlNamespaceManager(oXMLDocPipelineCfg.NameTable)

                'oNsMgr.AddNamespace("soap", "http://schemas.xmlsoap.org/soap/envelope/")
                oNsMgr.AddNamespace("soap", "http://www.w3.org/2003/05/soap-envelope")
                oBodyDoc = oXmlDomDoc.SelectSingleNode("soap:Envelope/soap:Body/node()", oNsMgr)

                oEnvRq.AddDocument(New InlineDocument(oBodyDoc.InnerXml))
                'Sets the:
                '   oBodyDoc.Name
                '   oBodyDoc.NamespaceURI

                oEnvRq.ServiceName = oBodyDoc.Name 'The Service Name....Use the RootNode Name and Namespace here...
                'oEnvRq.MessageContext = oBodyDoc.NamespaceURI 'and Namespace here...
                oEnvRq.ServiceNamespace = oBodyDoc.NamespaceURI
                Return oEnvRq
            Catch ex As Exception
                Throw
            End Try

        End Function


        Private Function CreateSOAPEnvelopeFromESBEnvelope(ByVal oEsbEnv As ESBEnvelope.Envelope) As String


            Dim sSoapEnv As String
            Dim sSoapEnvPre As String = "<?xml version=""1.0"" encoding=""utf-8""?><s:Envelope xmlns:s=""http://www.w3.org/2003/05/soap-envelope""><s:Body xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"">"
            Dim sSoapEnvPost As String = "</s:Body></s:Envelope>"

            Dim sDoc As String
            Dim lNumDocs As Integer = oEsbEnv.GetDocuments().Count
            If oEsbEnv.IsError() Then
                'Construct a SOAP Fault
                Dim oErrorDoc As ErrorXML.ErrorXML = oEsbEnv.GetDocumentAsObject(GetType(ErrorXML.ErrorXML))


                Dim xdFault As XDocument = <?xml version="1.0" encoding="utf-8"?>
                                           <env:Envelope xmlns:env="http://www.w3.org/2003/05/soap-envelope"
                                               xmlns:err="urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"
                                               xmlns:xml="http://www.w3.org/XML/1998/namespace">
                                               <env:Body>
                                                   <env:Fault>
                                                       <env:Code>
                                                           <!--<env:Value><%= ESB.Core.Util.Utils.EscapeXmlString(oErrorDoc.ErrorEntry(0).Source) %></env:Value>-->
                                                           <env:Value>env:Receiver</env:Value>
                                                           <env:Subcode>
                                                               <!--<env:Value><%= oErrorDoc.ErrorEntry(0).Code %></env:Value>-->
                                                               <env:Value>Error</env:Value>
                                                           </env:Subcode>
                                                       </env:Code>
                                                       <env:Reason>
                                                           <env:Text xml:lang="en"><%= ESB.Core.Util.Utils.EscapeXmlString(oErrorDoc.ErrorEntry(0).Description) %></env:Text>
                                                       </env:Reason>
                                                       <env:Detail>
                                                           <err:Code><%= oErrorDoc.ErrorEntry(0).Code %></err:Code>
                                                           <err:Description><%= ESB.Core.Util.Utils.EscapeXmlString(oErrorDoc.ErrorEntry(0).Description) & ESB.Core.Util.EscapeXmlString(oEsbEnv.GetDocument(GetType(ErrorXML.ErrorXML)).GetAsString) %></err:Description>
                                                           <err:ExceptionType></err:ExceptionType>
                                                           <err:ErrorSource><%= oErrorDoc.ErrorEntry(0).Source %></err:ErrorSource>
                                                           <!--<%= oEsbEnv.GetDocument(GetType(ErrorXML.ErrorXML)).GetAsString %>-->
                                                       </env:Detail>
                                                   </env:Fault>
                                               </env:Body>
                                           </env:Envelope>

                sSoapEnv = xdFault.ToString
                Return sSoapEnv

            ElseIf oEsbEnv.GetDocuments().Count > 0 Then
                'Construct a SOAP Envelope Response containing the First Document in the ESBEnvelope Response
                sDoc = oEsbEnv.GetDocument(0).GetAsXMLDocument.OuterXml

                Dim sSvcPre As String = "<" & oEsbEnv.ServiceName & "Response xmlns=""" & oEsbEnv.ServiceNamespace & """>"
                Dim sSvcPost As String = "</" & oEsbEnv.ServiceName & "Response>"

                sSoapEnv = sSoapEnvPre & sSvcPre & sDoc & sSvcPost & sSoapEnvPost

                Return sSoapEnv
            Else
                'Construct a SOAP Fault
                Dim xdFault As XDocument = <?xml version="1.0" encoding="utf-8"?>
                                           <env:Envelope xmlns:env="http://www.w3.org/2003/05/soap-envelope"
                                               xmlns:err="urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"
                                               xmlns:xml="http://www.w3.org/XML/1998/namespace">
                                               <env:Body>
                                                   <env:Fault>
                                                       <env:Code>
                                                           <env:Value>42</env:Value>
                                                           <env:Subcode>
                                                               <env:Value></env:Value>
                                                           </env:Subcode>
                                                       </env:Code>
                                                       <env:Reason>
                                                           <env:Text xml:lang="en">Unhandled Error</env:Text>
                                                       </env:Reason>
                                                       <env:Detail></env:Detail>
                                                   </env:Fault>
                                               </env:Body>
                                           </env:Envelope>

                sSoapEnv = xdFault.ToString
                Return sSoapEnv
            End If


        End Function


    End Class


End Namespace


'<s:Envelope xmlns:s="http://www.w3.org/2003/05/soap-envelope"><s:Body xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><services.activity.basic11.TFwsdl.Service1 xmlns="services.activity.basic11.TFwsdl"><BuildCmd2 xmlns="urn:keystroke.com.au.esb.buildCmd2.version_1_0_0_0"><BuildCmdString xmlns="">42</BuildCmdString></BuildCmd2></services.activity.basic11.TFwsdl.Service1></s:Body></s:Envelope>


'<s:Envelope xmlns:s="http://www.w3.org/2003/05/soap-envelope"><s:Body xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
'Sample SOAP Envelope

'<?xml version="1.0" encoding="utf-8"?>
'<soap:Envelope xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/03/addressing" xmlns:wsse="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd">
'  <soap:Header>
'    <wsa:Action>http://ESB.Keystroke.com.au/ESB/wsdl/ProcessMsgSync</wsa:Action>
'    <wsa:MessageID>uuid:e074776f-8af8-4ee2-9013-4bd788213ca8</wsa:MessageID>
'    <wsa:ReplyTo>
'      <wsa:Address>http://schemas.xmlsoap.org/ws/2004/03/addressing/role/anonymous</wsa:Address>
'    </wsa:ReplyTo>
'    <wsa:To>http://baby/ESB/Source/CoreInternetTransportAdaptors/Wcf/ESBSoapXmlDocTransport.svc</wsa:To>
'    <wsse:Security>
'      <wsu:Timestamp wsu:Id="Timestamp-32c6924a-b3a9-4801-bdc1-30af3254bcee">
'        <wsu:Created>2006-12-21T13:45:51Z</wsu:Created>
'        <wsu:Expires>2006-12-21T13:50:51Z</wsu:Expires>
'      </wsu:Timestamp>
'    </wsse:Security>
'  </soap:Header>
'  <soap:Body>
'    <ProcessMsgSync xmlns="http://ESB.Keystroke.com.au/ESB/wsdl/">
'      <Request>
'        <ESBEnvelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0">
'          <header>
'            <delivery>
'              <message>
'                <senderMessageID />
'                <receiverMessageID />
'                <sent />
'                <subject />
'              </message>
'              <to>
'                <address>http://baby/ESB/Source/CoreInternetTransportAdaptors/Wcf/ESBSoapXmlDocTransport.svc</address>
'                <state>
'                  <handle />
'                  <process />
'                  <referenceID />
'                </state>
'                <addressType>SOAP-XMLDOCUMENT</addressType>
'              </to>
'              <from>
'                <address />
'                <state>
'                  <handle />
'                  <process />
'                  <referenceID />
'                </state>
'                <addressType />
'              </from>
'              <callSynchronizationType>0</callSynchronizationType>
'            </delivery>
'            <manifest>
'              <document>
'                <name>BuildCmd2</name>
'                <description>Test Document</description>
'                <documentNamespace>urn:schemas-biztalk-org:biztalk:BuildCmd2:BuildCmd2</documentNamespace>
'              </document>
'            </manifest>
'            <systems>
'              <system>
'                <adminID />
'                <systemID>Some System ID</systemID>
'                <url />
'                <environment />
'                <systemType />
'                <systemVersion />
'              </system>
'            </systems>
'            <service>
'              <name />
'              <version />
'              <context />
'              <description>Test Service</description>
'            </service>
'          </header>
'          <body>
'            <documentBody>
'              <BuildCmd2 xmlns="urn:schemas-biztalk-org:biztalk:BuildCmd2:BuildCmd2">
'                <BuildCmdString>0</BuildCmdString>
'              </BuildCmd2>
'            </documentBody>
'          </body>
'        </ESBEnvelope>
'      </Request>
'    </ProcessMsgSync>
'  </soap:Body>
'</soap:Envelope>


'SOAP 1.1
'Request
'<?xml version="1.0" encoding="utf-8"?>
'<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
'  <soap:Body>
'    <HelloWorld xmlns="http://tempuri.org/" />
'  </soap:Body>
'</soap:Envelope>

'Response
'<?xml version="1.0" encoding="utf-8"?>
'<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
'  <soap:Body>
'    <HelloWorldResponse xmlns="http://tempuri.org/">
'      <HelloWorldResult>string</HelloWorldResult>
'    </HelloWorldResponse>
'  </soap:Body>
'</soap:Envelope>

'SOAP 1.2
'Request
'<?xml version="1.0" encoding="utf-8"?>
'<soap12:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap12="http://www.w3.org/2003/05/soap-envelope">
'  <soap12:Body>
'    <HelloWorld xmlns="http://tempuri.org/" />
'  </soap12:Body>
'</soap12:Envelope>

'Response
'<?xml version="1.0" encoding="utf-8"?>
'<soap12:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap12="http://www.w3.org/2003/05/soap-envelope">
'  <soap12:Body>
'    <HelloWorldResponse xmlns="http://tempuri.org/">
'      <HelloWorldResult>string</HelloWorldResult>
'    </HelloWorldResponse>
'  </soap12:Body>
'</soap12:Envelope>



'<?xml version="1.0" encoding="UTF-8"?>
'<soap:Envelope xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
'<soap:Body>
'<gs:doGoogleSearch xmlns:gs="urn:GoogleSearch">
'<key>%(key)s</key>
'<q>%(q)s</q>
'<start>0</start>
'<maxResults>10</maxResults>
'<filter>true</filter>
'<restrict/>
'<safeSearch>false</safeSearch>
'<lr/>
'<ie>latin1</ie>
'<oe>latin1</oe>
'</gs:doGoogleSearch>
'</soap:Body>
'</soap:Envelope>


''For i As Integer = 0 To lNumDocs - 1
''    sDoc += oEsbEnv.GetDocument(i).GetAsXMLDocument.OuterXml
''Next


''For i As Integer = 0 To lNumDocs - 1
''    AddDocument(oEsbEnv.GetDocument(i).GetAsXMLDocument)
''Next

''Dim sSvcPre As String = "<" & oEsbEnv.ServiceName & " xmlns=""" & oEsbEnv.ServiceNamespace & """>"
''Dim sSvcPost As String = "</" & oEsbEnv.ServiceName & ">"

''Dim sSvcPre As String = "<" & oEsbEnv.ServiceName & "Response xmlns=""" & oEsbEnv.ServiceNamespace & """ xmlns:ns2=""urn:keystroke.com.au.esb.buildCmd2.version_1_0_0_0"">"


''xmlns:ns2="urn:keystroke.com.au.esb.buildCmd2.version_1_0_0_0"
''<services.activity.basic11.TFwsdl.Service1Response xmlns="services.activity.basic11.TFwsdl">  </services.activity.basic11.TFwsdl.Service1Response>

''  sDoc = "<ns2:BuildCmd2><BuildCmdString/></ns2:BuildCmd2><ns1:ErrorXML><ns1:ErrorEntry/><ns1:ErrorEntry/><ns1:WarningEntry/><ns1:WarningEntry/></ns1:ErrorXML><ns1:ErrorXML><ns1:ErrorEntry/><ns1:ErrorEntry/><ns1:WarningEntry/><ns1:WarningEntry/></ns1:ErrorXML>"
''sDoc = "<ns2:BuildCmd2 xmlns:ns2=""urn:keystroke.com.au.esb.buildCmd2.version_1_0_0_0""><BuildCmdString>String</BuildCmdString></ns2:BuildCmd2>	<ns1:ErrorXML xmlns:ns1=""urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"">		<ns1:ErrorEntry ns1:Description=""String"" ns1:Source=""String"" ns1:Code=""String""/>		<ns1:ErrorEntry ns1:Description=""String"" ns1:Source=""String"" ns1:Code=""String""/>		<ns1:WarningEntry ns1:Description=""String"" ns1:Source=""String"" ns1:Code=""String""/>		<ns1:WarningEntry ns1:Description=""String"" ns1:Source=""String"" ns1:Code=""String""/>	</ns1:ErrorXML>	<ns1:ErrorXML>		<ns1:ErrorEntry ns1:Description=""String"" ns1:Source=""String"" ns1:Code=""String""/>		<ns1:ErrorEntry ns1:Description=""String"" ns1:Source=""String"" ns1:Code=""String""/>		<ns1:WarningEntry ns1:Description=""String"" ns1:Source=""String"" ns1:Code=""String""/>		<ns1:WarningEntry ns1:Description=""String"" ns1:Source=""String"" ns1:Code=""String""/>	</ns1:ErrorXML>"
''sDoc = "<servicesactivitybasic11TFwsdlService1Response xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema""><BuildCmd2>    <BuildCmdString>42</BuildCmdString></BuildCmd2>  <ErrorXML>    <ErrorEntry d3p1:Code=""42"" d3p1:Description=""aaa"" d3p1:Source=""somewhere"" xmlns:d3p1=""urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"" xmlns=""urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"" />  </ErrorXML></servicesactivitybasic11TFwsdlService1Response>"

''Error works (no namespace for BuildCMD...
''sDoc = "<BuildCmd2><BuildCmdString>42</BuildCmdString></BuildCmd2><ErrorXML><ErrorEntry d3p1:Code=""42"" d3p1:Description=""aaa"" d3p1:Source=""somewhere"" xmlns:d3p1=""urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"" xmlns=""urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"" /></ErrorXML>"
''sDoc = "<ns2:BuildCmd2 xmlns:ns2=""urn:keystroke.com.au.esb.buildCmd2.version_1_0_0_0""><ns2:BuildCmdString>String</ns2:BuildCmdString></ns2:BuildCmd2><ErrorXML><ErrorEntry d3p1:Code=""42"" d3p1:Description=""aaa"" d3p1:Source=""somewhere"" xmlns:d3p1=""urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"" xmlns=""urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"" /></ErrorXML>"



''works  !!!
''Dim s1 As XElement = <ns2:BuildCmd2 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:ns2="urn:keystroke.com.au.esb.buildCmd2.version_1_0_0_0">
''                         <ns2:BuildCmdString>String</ns2:BuildCmdString>
''                     </ns2:BuildCmd2>
' ''Dim s2 As XElement = <ErrorXML>
''                         <ErrorEntry d3p1:Code="42" d3p1:Description="aaa" d3p1:Source="somewhere" xmlns:d3p1="urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0" xmlns="urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"/>
''                     </ErrorXML>


' ''Spat out from serialiser... 
''Dim s1 As XElement = <BuildCmd2 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns="urn:keystroke.com.au.esb.buildCmd2.version_1_0_0_0">
''                         <BuildCmdString>43</BuildCmdString>
''                     </BuildCmd2>

''Dim s2 As XElement = <ErrorXML xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns="urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0">
''                         <ErrorEntry d2p1:Code="444" d2p1:Description="aaaaa" d2p1:Source="sssssss" xmlns:d2p1="urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"/>
''                     </ErrorXML>


''Dim s1 As XElement = <BuildCmd2 xmlns="urn:keystroke.com.au.esb.buildCmd2.version_1_0_0_0">
''                         <BuildCmdString>43</BuildCmdString>
''                     </BuildCmd2>

''Dim s2 As XElement = <ErrorXML xmlns:err="urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
''                         <err:ErrorEntry err:Code="444" err:Description="aaaaa" err:Source="sssssss"/>
''                     </ErrorXML>




''Spat out from serialiser...    modified namespaces...      works...
''Dim s1 As XElement = <ns1:BuildCmd2 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:ns1="urn:keystroke.com.au.esb.buildCmd2.version_1_0_0_0">
''                         <ns1:BuildCmdString>43</ns1:BuildCmdString>
''                     </ns1:BuildCmd2>

''Dim s2 As XElement = <ErrorXML xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:ns2="urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0">
''                         <ns2:ErrorEntry ns2:Code="444" ns2:Description="aaaaa" ns2:Source="sssssss"/>
''                     </ErrorXML>


''Spat out from serialiser... 
''Dim s1 As XElement = <BuildCmd2 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
''                         <BuildCmdString>43</BuildCmdString>
''                     </BuildCmd2>

''Dim s2 As XElement = <ErrorXML xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
''                         <ErrorEntry d2p1:Code="444" d2p1:Description="aaaaa" d2p1:Source="sssssss" xmlns:d2p1="urn:keystroke-com-au:ESB:ErrorXML:Version:1-0-0"/>
''                     </ErrorXML>

''sDoc = s1.ToString & s2.ToString
'Dim x As New ESB.Core.XMLSchemaClasses.XMLUtil
'            sDoc = x.Serialize(m_elBody)


''sSoapEnv = sPre & sDoc & sPost
'            sSoapEnv = sPre & sSvcPre & sDoc & sSvcPost & sPost
''Dim xSoapEnv As XDocument = XDocument.Parse(sSoapEnv)
''sSoapEnv = xSoapEnv.ToString

''Dim xSoapEnv As XElement = XElement.Parse(sSoapEnv)
''sSoapEnv = xSoapEnv.ToString
'' Dim oXmlDoc As New XmlDocument()
'' oXmlDoc.LoadXml(sSoapEnv)
''sSoapEnv = oXmlDoc.OuterXml
