'''-----------------------------------------------------------------------------
''' <summary>
''' Copyright Keystroke IT 2003
''' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
''' </summary>
'''-----------------------------------------------------------------------------
Imports ESB.Core.Services.Logger

Namespace ESB.Core.Adaptors.Transport.Internet.Receive.WSE3

    Partial Class ESBHTTPTransport
        Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub


        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private m_oContext As ESB.Core.Services.Server.ServerContext
        Private Shared m_bGotInstanceName As Boolean = False

        ''' <summary>
        ''' Accepts IEnvelope compliant messages over Raw HTTP
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        ''' <remarks></remarks>
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                Dim oTimer As New Stopwatch
                oTimer.Start()


                If Not m_bGotInstanceName Then
                    Dim sRawUrl As String = GetInstanceName()
                    System.Threading.ThreadPool.QueueUserWorkItem(AddressOf StartAsyncLogger, sRawUrl)
                End If

                Dim sXMLResponse As String

                ContextManager.IsServerContextmanager = True
                Using oScm As Server.ServerContextManager = DirectCast(ContextManager.getContextManager(True), Server.ServerContextManager)
                    oScm.Start()
                    StartMethod()

                    Response.Buffer = True
                    Response.ContentType = "text/xml"

                    '++ Setup Transport Specific Properties...

                    Dim oTransportProperties As New ESB.Core.Services.BaseContext.TransportProperties
                    oTransportProperties.m_sRequestSourceHost = Context.Request.UserHostAddress
                    'm_oContext.m_sRequestSourceUserAgent = Context.Request.UserAgent
                    'm_oContext.m_sRequestSourceUrlReferrer = Context.Request.UrlReferrer.AbsoluteUri
                    'm_oContext.m_sTransportUrl = Context.Request.RawUrl
                    'm_oContext.m_sTransportUrl = Context.Request.Url.AbsoluteUri
                    'oTransportProperties.m_sTransportUrl = "ESBHTTPTransport.aspx"
                    oTransportProperties.m_sTransportUrl = Context.Request.Url.AbsoluteUri
                    oTransportProperties.m_sServerDnsSafeHost = Context.Request.Url.DnsSafeHost
                    oTransportProperties.m_sRequestSourceUserAgent = Context.Request.UserAgent

                    oTransportProperties.m_sTransportType = "HTTP" 'm_oContext.envRq.ToAddressType
                    'LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "SourceHost=" & Request.Headers("Host"))
                    '-- Setup Transport Specific Properties...

                    'Also shoves the envelope into the envelope in the context for us...
                    m_oContext = DirectCast(ESB.Core.Services.ContextManager.getContextManager(True), Server.ServerContextManager).GetContextForRequest(Request.InputStream, oTransportProperties)

                    sXMLResponse = m_oContext.ProcessMsgSync(m_oContext.envRq).XML

                    If ShouldLog(LogDefs.eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, sXMLResponse)

                End Using 'the finalizer will call the dispose which will call the Finish() method...

                '10,000 ticks in 1 millisecond
                '10 ticks in 1 micro second
                oTimer.Stop()
                Dim sTime As String = String.Format("{0} Ticks = {1} microseconds = {2} milliseconds", oTimer.Elapsed.Ticks, oTimer.Elapsed.Ticks / 10, oTimer.Elapsed.Ticks / 10000)

                Try

                    Dim oPerfmon As New PerfMonManager()
                    oPerfmon.Init("Http", m_oContext)
                    oPerfmon.SetCounterValues(True, oTimer.ElapsedTicks)

                    oTimer.Reset()

                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.Message)
                    'Swallow the exception...
                End Try

                Response.Write(sXMLResponse)

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(eLogLevel.eLOG_ERROR, ex.Message)
                Throw
            Finally

                '   CType(ESB.Core.Services.ContextManager.getContextManager(True), Server.ServerContextManager).Finish()
                EndMethod()
                m_oContext.threadLogDetail.sRequestSourceHost = ""

                '++ TODO - Remove MINA - TEST
                'Application("GcCollectCounter") += 1
                'Dim x As Integer
                'If 0 = Math.DivRem(Application("GcCollectCounter"), 1000, x) Then
                '    GC.Collect()
                'End If
                '-- TODO - Remove MINA - TEST
            End Try

        End Sub
        ''' <summary>
        ''' Get the Instance Name of this Transport Adaptor and write it out to the Global Variables in the Utils...
        ''' </summary>
        ''' <remarks>Only need to run this once and then cache it...</remarks>
        Private Function GetInstanceName() As String
            If Not m_bGotInstanceName Then

                'Get the Query String so that we can figure out the Instance name...then cache it to the Utils.GlobalVariables...

                Dim sQueryString As String = Me.Context.Request.ApplicationPath
                Dim sRawUrl As String = Me.Context.Request.RawUrl
                Dim sThisInstanceName As String = Utils.GetInstanceName(sQueryString) '?Request.ApplicationPath?
                Util.ESBGlobalVariables.ESBInstanceName = sThisInstanceName


                '!!! Request specific... so should NOT be cached, nor put here...
                'Should go into ServerContext!!!
                Util.ESBGlobalVariables.DnsSafeHostName = Request.Url.DnsSafeHost
                Util.ESBGlobalVariables.RequestAbsoluteUri = Request.Url.AbsoluteUri

                m_bGotInstanceName = True
                Return sRawUrl
            Else
                Return ""
            End If

        End Function


        ''' <summary>
        ''' Calls to the ASP.NET url which starts a background process to start listening on the MSMQ queues, and copies them to the 
        ''' SQL Server logs...
        ''' </summary>
        ''' <remarks></remarks>
        Shared Sub StartAsyncLogger(ByVal sRawUrl As String)
            Dim sUrl As String = ""
            Try

                Dim oHttpClient As New System.Net.WebClient
                sUrl = Utils.GetAsyncLoggerUrl(sRawUrl)
                Dim sAsyncLoggerUri As New System.Uri(sUrl)

                'oHttpClient.DownloadStringAsync(sAsyncLoggerUri)
                Dim sRs As String = oHttpClient.DownloadString(sAsyncLoggerUri)

            Catch ex As Exception
                EventLog.WriteEntry("ESB.NET", "Could not invoke start async logger URL : " & sUrl & ". Service URL invoking is:" & sRawUrl, EventLogEntryType.Information)
            End Try
        End Sub
    End Class

End Namespace
