'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Imports System.Messaging
Imports System.Text
Imports ESB.Core.Services.Logger

Namespace ESB.Core.Adaptors.Transport.Internet.Receive.WSE3

    Partial Class ESBHTTPTransportInternalAsync
        Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub


        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private m_oContext As ESB.Core.Services.Server.ServerContext
        Private Shared m_bGotInstanceName As Boolean = False

        ''' <summary>
        ''' Accepts IEnvelope compliant messages over Raw HTTP
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        ''' <remarks></remarks>
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

            ' Execute this in a background thread, such that the MSMQ Triggers thread is released immediately.
            ' i.e. Help make this as asynchronous as possible from the server side...
            ' System.Threading.ThreadPool.QueueUserWorkItem(AddressOf ProcessMsg)

            ProcessMsg()

        End Sub

        ''' <summary>
        ''' Inspect the message request, looking for a queue name from which to receive a message.
        ''' Retrieve the message and process it.
        ''' </summary>
        ''' <remarks></remarks>
        Private Sub ProcessMsg()
            'Private Sub ProcessMsg(ByVal state As Object)

            Try
                Dim oTimer As New Stopwatch
                oTimer.Start()

                If Not m_bGotInstanceName Then : GetInstanceName() : End If
                Dim sXMLResponse As String

                ContextManager.IsServerContextmanager = True
                Using oScm As Server.ServerContextManager = DirectCast(ContextManager.getContextManager(True), Server.ServerContextManager)
                    oScm.Start()
                    StartMethod()

                    Response.Buffer = True
                    Response.ContentType = "text/xml"

                    Dim sXMLrq As String
                    Dim sQPath As String = GetQPathFromStream(Request.InputStream)

                    sXMLrq = GetNextMsgFromQueue(sQPath)

                    'LogMsg(LogDefs.eLogLevel.eLOG_TRACE, "SourceHost=" & Request.Headers("Host"))

                    '++ Setup Transport Specific Properties...

                    Dim oTransportProperties As New ESB.Core.Services.BaseContext.TransportProperties
                    'oTransportProperties.m_sRequestSourceHost = Context.Request.UserHostAddress
                    'oTransportProperties.m_sRequestSourceUserAgent = Context.Request.UserAgent
                    ''m_oContext.m_sRequestSourceUrlReferrer = Context.Request.UrlReferrer.AbsoluteUri
                    ''m_oContext.m_sTransportUrl = Context.Request.RawUrl
                    ''m_oContext.m_sTransportUrl = Context.Request.Url.AbsoluteUri

                    'oTransportProperties.m_sTransportUrl = "ESBSoapXmlDocTransport.asmx"
                    'oTransportProperties.m_sTransportType = "SOAP-WSE3_hard_coded" 'm_oContext.envRq.ToAddressType

                    oTransportProperties.m_sRequestSourceHost = Context.Request.UserHostAddress
                    oTransportProperties.m_sRequestSourceUserAgent = Context.Request.UserAgent
                    oTransportProperties.m_sServerDnsSafeHost = Context.Request.Url.DnsSafeHost

                    'm_oContext.m_sRequestSourceUrlReferrer = Context.Request.UrlReferrer.AbsoluteUri

                    'm_oContext.m_sTransportUrl = Context.Request.RawUrl
                    'm_oContext.m_sTransportType = m_oContext.envRq.ToAddressType

                    'oTransportProperties.m_sTransportUrl = "ESBHTTPTransportInternalAsync.aspx"
                    'oTransportProperties.m_sTransportUrl = Context.Request.Url.AbsolutePath
                    oTransportProperties.m_sTransportUrl = Context.Request.Url.AbsoluteUri

                    oTransportProperties.m_sTransportType = "HTTP" 'm_oContext.envRq.ToAddressType
                    '-- Setup Transport Specific Properties...

                    'Also shoves the envelope into the envelope in the context for us...
                    m_oContext = CType(ESB.Core.Services.ContextManager.getContextManager(True), Server.ServerContextManager).GetContextForRequest(sXMLrq, oTransportProperties)


                    sXMLResponse = m_oContext.ProcessMsgSync(m_oContext.envRq).XML
                End Using 'the finalizer will call the dispose which will call the Finish() method...

                '10,000 ticks in 1 millisecond
                '10 ticks in 1 micro second
                oTimer.Stop()
                Dim sTime As String = String.Format("{0} Ticks = {1} microseconds = {2} milliseconds", oTimer.Elapsed.Ticks, oTimer.Elapsed.Ticks / 10, oTimer.Elapsed.Ticks / 10000)

                Try

                    Dim oPerfmon As New PerfMonManager()
                    oPerfmon.Init("HttpInternalAsync", m_oContext)
                    oPerfmon.SetCounterValues(True, oTimer.ElapsedTicks)

                    oTimer.Reset()

                Catch ex As Exception
                    ExceptionManager.Publish(ex)
                    LogError(eLogLevel.eLOG_ERROR, ex.Message)
                    'Swallow the exception...
                End Try
                Response.Write(sXMLResponse)

            Catch ex As Exception
                LogError(eLogLevel.eLOG_ERROR, ex.Message)
            Finally

                'CType(ESB.Core.Services.ContextManager.getContextManager(True), Server.ServerContextManager).Finish()
                EndMethod()
                ' m_oContext.threadLogDetail.sRequestSourceHost = ""
            End Try

        End Sub
        ''' <summary>
        ''' Get the Instance Name of this Transport Adaptor and write it out to the Global Variables in the Utils...
        ''' </summary>
        ''' <remarks>Only need to run this once and then cache it...</remarks>
        Private Sub GetInstanceName()
            If Not m_bGotInstanceName Then

                'Get the Query String so that we can figure out the Instance name...then cache it to the Utils.GlobalVariables...

                Dim sQueryString As String = Me.Context.Request.ApplicationPath
                Dim sThisInstanceName As String = Utils.GetInstanceName(sQueryString) '?Request.ApplicationPath?
                Util.ESBGlobalVariables.ESBInstanceName = sThisInstanceName
                Util.ESBGlobalVariables.DnsSafeHostName = Request.Url.DnsSafeHost
                Util.ESBGlobalVariables.RequestAbsoluteUri = Request.Url.AbsoluteUri

                m_bGotInstanceName = True
            End If

        End Sub


        Private Function GetQPathFromStream(ByVal oStream As System.IO.Stream) As String
            Dim sMsg As String
            Dim inputByteArray(oStream.Length - 1) As Byte
            oStream.Read(inputByteArray, 0, oStream.Length)

            Dim encoding As System.Text.Encoding = System.Text.Encoding.UTF8
            sMsg = encoding.UTF8.GetString(inputByteArray)
            Return sMsg
        End Function

        Public Function GetNextMsgFromQueue(ByRef sQPath As String) As String

            Dim msg As Message = Nothing
            Dim mq As MessageQueue = Nothing

            Try
                If (Not MessageQueue.Exists(sQPath)) Then
                    Throw New Exception("The queue " & sQPath & " does not exist!")
                    Exit Function
                End If

                mq = New MessageQueue(sQPath)

                Dim ts As New TimeSpan(0, 0, 0, 0, 1000)
                Try
                    ' Since message will be stored in XML fashion in MSMQ, you are formatting it
                    Dim formatter As XmlMessageFormatter = CType(mq.Formatter, XmlMessageFormatter)
                    formatter.TargetTypeNames = New String() {"System.String,mscorlib"}

                    msg = mq.Receive()

                    Return CStr(msg.Body())

                Catch ex As MessageQueueException
                    ExceptionManager.Publish(ex)
                    Throw

                Catch ex As InvalidOperationException
                    ExceptionManager.Publish(ex)
                    Throw
                End Try
            Catch ex As Exception
                ExceptionManager.Publish(ex)
                Return ""
            Finally
                If Not mq Is Nothing Then
                    mq.Close()
                End If
            End Try

        End Function


    End Class

End Namespace
