''-----------------------------------------------------------------------------
'' <summary>
'' Copyright Keystroke IT 2003
'' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
'' </summary>
''-----------------------------------------------------------------------------
Imports System
Imports System.IO
Imports System.Xml
Imports System.Text
Imports System.Security.Cryptography

Public Class Encryption

    ' Use DES CryptoService with Private key pair
    Private key() As Byte = {} ' we are going to pass in the key portion in our method calls
    Private IV() As Byte = {&H12, &H34, &H56, &H78, &H90, &HAB, &HCD, &HEF}
    Private m_sKey As String = "765&^(%HGYFteu27^5452ewe"
    Public Function DecryptFromBase64String(ByVal stringToDecrypt As String, ByVal sEncryptionKey As String) As String
        Dim inputByteArray(stringToDecrypt.Length) As Byte
        ' Note: The DES CryptoService only accepts certain key byte lengths
        ' We are going to make things easy by insisting on an 8 byte legal key length

        Try
            'if we don't get a key passed in, then use the internal one
            If sEncryptionKey.Length = 0 Then
                key = System.Text.Encoding.UTF8.GetBytes(Left(m_sKey, 24))
            Else
                key = System.Text.Encoding.UTF8.GetBytes(Left(sEncryptionKey, 24))
            End If
            'Dim CSPSym As New DESCryptoServiceProvider()
            Dim CSPSym As New TripleDESCryptoServiceProvider


            ' we have a base 64 encoded string so first must decode to regular unencoded (encrypted) string
            inputByteArray = Convert.FromBase64String(stringToDecrypt)
            ' now decrypt the regular string
            Dim ms As New MemoryStream
            Dim cs As New CryptoStream(ms, CSPSym.CreateDecryptor(key, IV), CryptoStreamMode.Write)
            'Dim cs As New CryptoStream(ms,  CSPAsym. .CreateDecryptor(key, IV), CryptoStreamMode.Write)

            cs.Write(inputByteArray, 0, inputByteArray.Length)
            cs.FlushFinalBlock()
            Dim encoding As System.Text.Encoding = System.Text.Encoding.UTF8
            Return encoding.GetString(ms.ToArray())
        Catch e As Exception
            Return e.Message
        End Try
    End Function

    Public Function EncryptToBase64String(ByVal stringToEncrypt As String, ByVal sEncryptionKey As String) As String
        Try

            'if we don't get a key passed in, then use the internal one
            If sEncryptionKey.Length = 0 Then
                key = System.Text.Encoding.UTF8.GetBytes(Left(m_sKey, 24))
            Else
                key = System.Text.Encoding.UTF8.GetBytes(Left(sEncryptionKey, 24))
            End If

            'Dim CSPSym As New DESCryptoServiceProvider()
            Dim CSPSym As New TripleDESCryptoServiceProvider

            ' convert our input string to a byte array
            Dim inputByteArray() As Byte = Encoding.UTF8.GetBytes(stringToEncrypt)
            'now encrypt the bytearray
            Dim ms As New MemoryStream
            Dim cs As New CryptoStream(ms, CSPSym.CreateEncryptor(key, IV), CryptoStreamMode.Write)
            cs.Write(inputByteArray, 0, inputByteArray.Length)
            cs.FlushFinalBlock()
            ' now return the byte array as a "safe for XMLDOM" Base64 String
            Return Convert.ToBase64String(ms.ToArray())
        Catch e As Exception
            Return e.Message
        End Try
    End Function


    Public Function DecryptFromBase64StringRSA(ByVal stringToDecrypt As String, ByVal sPathToEncryptionKey As String) As String

        Try
            Dim inputByteArray(stringToDecrypt.Length) As Byte
            Dim RSAKey As New RSACryptoServiceProvider(512)
            Dim sRSAKeyXML As String
            Dim XMLr As New XmlTextReader(sPathToEncryptionKey)

            XMLr.MoveToContent()
            sRSAKeyXML = XMLr.ReadOuterXml()
            XMLr.Close()
            RSAKey.FromXmlString(sRSAKeyXML)

            ' we have a base 64 encoded string so first must decode to regular unencoded (encrypted) string
            inputByteArray = Convert.FromBase64String(stringToDecrypt)

            Dim outputByteArray() As Byte

            'encrypt the bytearray
            outputByteArray = RSAKey.Decrypt(inputByteArray, False)

            'If we started with a string, then we should finish with a string...
            'Extract the data as a simple string
            Dim encoding As System.Text.Encoding = System.Text.Encoding.UTF8
            Return encoding.GetString(outputByteArray)

        Catch e As Exception
            Return e.Message
        End Try
    End Function

    Public Function EncryptToBase64StringRSA(ByVal stringToEncrypt As String, ByVal sPathToEncryptionKey As String) As String
        Try
            'Creating this object also generates an RSA Key - 
            'which we don't want to use right now! This is expensive
            'in terms of CPU usage, So, create a small one...
            Dim RSAKey As New RSACryptoServiceProvider(512)

            Dim sRSAKeyXML As String

            Dim XMLr As New XmlTextReader(sPathToEncryptionKey)

            XMLr.MoveToContent()
            sRSAKeyXML = XMLr.ReadOuterXml()
            XMLr.Close()
            RSAKey.FromXmlString(sRSAKeyXML)

            ' convert our input string to a byte array
            Dim inputByteArray() As Byte = Encoding.UTF8.GetBytes(stringToEncrypt)
            Dim outputByteArray() As Byte

            'encrypt the bytearray
            outputByteArray = RSAKey.Encrypt(inputByteArray, False)

            'return the byte array as a "safe for XMLDOM" Base64 String
            Return Convert.ToBase64String(outputByteArray)
        Catch e As Exception
            Return e.Message
        End Try
    End Function


End Class