'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Namespace Attributes
    ''' <summary>
    ''' Specifies the Request Document Root Element and Namespace. 
    ''' This indirectly specifies the ResolveName used to match up the request with this
    ''' Service Handler.
    ''' </summary>
    ''' <remarks></remarks>
    <AttributeUsage(AttributeTargets.Class)> _
        Public Class DocumentsAttribute
        Inherits Attribute

        Private m_sRequestDocumentRootElementName As String
        Public Property RequestDocumentRootElementName() As String
            Get
                Return m_sRequestDocumentRootElementName
            End Get
            Set(ByVal value As String)
                m_sRequestDocumentRootElementName = value
            End Set
        End Property

        Private m_sRequestDocumentNamespace As String
        Public Property RequestDocumentNamespace() As String
            Get
                Return m_sRequestDocumentNamespace
            End Get
            Set(ByVal value As String)
                m_sRequestDocumentNamespace = value
            End Set
        End Property

        Public Sub New(Optional ByVal RequestDocumentRootElementName As String = "", Optional ByVal RequestDocumentNamespace As String = "")
            m_sRequestDocumentRootElementName = RequestDocumentRootElementName
            m_sRequestDocumentNamespace = RequestDocumentNamespace
        End Sub
    End Class
End Namespace
