'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------

Imports Microsoft.Win32.Registry

Public Class ESBRegistryConfig
    'This will later be changed to write the config entry either directly to the registry
    'or to an XML document for processing via a ESB Application Adaptor (which will write to the registry...)
    Shared oReg As Microsoft.Win32.Registry

    Public Shared Function Read(ByVal Path As String, ByVal Entry As String) As String
        Return Read("", Path, Entry)
    End Function

    Public Shared Function Read(ByVal Path As String, ByVal Entry As String, ByVal EntryType As eRegType) As String

        Select Case EntryType
            Case eRegType.eDWord
                Dim dwVal As Int32 = Read("", Path, Entry)
                'dwVal = Value
                Return dwVal
            Case eRegType.eString, eRegType.eStringExpand
                Dim sVal As String = Read("", Path, Entry)
                Return sVal
            Case eRegType.eBoolean
                Dim dwVal As Int32 = Read("", Path, Entry)

                If dwVal = 0 Then
                    Return False
                Else
                    Return True
                End If

            Case Else
                Return False

        End Select

    End Function

    Public Shared Function Read(ByVal Section As String, ByVal Path As String, ByVal Entry As String) As String 'Implements ESBConfig.Read
        Return Microsoft.Win32.Registry.LocalMachine.OpenSubKey(Path, False).GetValue(Entry)
    End Function

    Public Shared Sub Write(ByVal Path As String, ByVal Entry As String, ByVal Value As Object, ByVal EntryType As eRegType)  'Implements ESBConfig.Write
        Write("", Path, Entry, Value, EntryType)
    End Sub

    Public Shared Sub Write(ByVal Section As String, ByVal Path As String, ByVal Entry As String, ByVal Value As Object, ByVal EntryType As eRegType) 'Implements ESBConfig.Write
        Select Case EntryType
            Case eRegType.eDWord
                Dim dwVal As Int32 = 0
                dwVal = Value
                LocalMachine.OpenSubKey(Path, True).SetValue(Entry, dwVal)
            Case eRegType.eString, eRegType.eStringExpand
                Dim sVal As String = ""
                sVal = Value
                LocalMachine.OpenSubKey(Path, True).SetValue(Entry, sVal)
            Case eRegType.eBoolean
                Dim dwVal As Int32 = 0

                If Value = False Then
                    dwVal = 0
                Else
                    dwVal = 1
                End If
                LocalMachine.OpenSubKey(Path, True).SetValue(Entry, dwVal)

        End Select
    End Sub

End Class

Public Enum eRegType
    eString = 1
    eDWord = 2
    eStringExpand = 3
    eBoolean = 4
End Enum

