''-----------------------------------------------------------------------------
'' <summary>
'' Copyright Keystroke IT 2003
'' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
'' </summary>
''-----------------------------------------------------------------------------
Option Strict Off
Option Explicit On

Imports System.Xml
Imports System.Xml.Serialization
Imports System.Text
Imports System.IO

Public Module Utils


    Public Function TrimStr(ByRef sOverallStringToSearch As String, ByRef sPartialStringToTrimOut As String) As String

        Dim sTemp As String
        sTemp = LTrimStr(sOverallStringToSearch, sPartialStringToTrimOut)
        sTemp = RTrimStr(sTemp, sPartialStringToTrimOut)

        TrimStr = sTemp

    End Function

    Public Function RTrimStr(ByRef sOverallStringToSearch As String, ByRef sPartialStringToTrimOut As String) As String


        Dim lPos As Integer
        Dim sTemp As String

        If Len(sOverallStringToSearch) = 0 Then
            RTrimStr = ""
            Exit Function
        End If

        sTemp = sOverallStringToSearch

        Do
            lPos = InStr(Len(sTemp), sTemp, sPartialStringToTrimOut, 0)
            If lPos = Len(sTemp) Then
                sTemp = Left(sTemp, Len(sTemp) - 1)
            End If
        Loop Until lPos <> Len(sTemp) + 1

        RTrimStr = sTemp



    End Function
    Public Function LTrimStr(ByRef sOverallStringToSearch As String, ByRef sPartialStringToTrimOut As String) As String

        Dim lPos As Integer
        Dim sTemp As String

        If Len(sOverallStringToSearch) = 0 Then
            LTrimStr = ""
            Exit Function
        End If


        sTemp = sOverallStringToSearch

        Do
            lPos = InStr(1, sTemp, sPartialStringToTrimOut, 0)
            If lPos = 1 Then
                sTemp = Right(sTemp, Len(sTemp) - 1)
            End If
        Loop Until lPos <> 1

        LTrimStr = sTemp

    End Function

    Public Function GetThisComputerName() As String
        Return System.Environment.MachineName
    End Function

    Public Function EscapeXmlString(ByRef sXMLraw As String) As String
        Dim oMemStream As New MemoryStream
        Dim w As New XmlTextWriter(oMemStream, New System.Text.UTF8Encoding)
        w.WriteString(sXMLraw)
        w.Close()
        Return Encoding.UTF8.GetString(oMemStream.ToArray())
    End Function

    Public Function ExpandRelativePath(ByRef sPath As String, Optional ByRef sRootPath As String = "") As String
        If sPath <> "" Then
            If (Not Path.IsPathRooted(sPath)) Then
                sPath = Path.GetFullPath(Path.Combine(ESB.Core.Util.ESBGlobalVariables.ESBRootPath, sPath))
            End If
        End If
        Return sPath
    End Function

    Public Function GetInstanceName(ByVal sApplicationPath As String) As String
        Dim sThisInstance As String = ""
        Dim i As Integer = 0
        Dim sAppPath As String
        Dim sSeparator As String = Format(Path.DirectorySeparatorChar)

        'Request.ApplicationPath = "/ESB/ThisInstance/Manage"
        If InStr(sApplicationPath, "/") > 0 Then
            sAppPath = Replace(sApplicationPath, "/", sSeparator)
        End If

        If InStr(sApplicationPath, "\") > 0 Then
            sAppPath = Replace(sApplicationPath, "\", sSeparator)
        End If

        Dim myArray() As String = Split(sAppPath, sSeparator)

        For i = 0 To myArray.Length - 1
            If myArray(i).ToLower = "esb" Then
                sThisInstance = myArray(i + 1)
                Exit For
            End If
        Next i

        Return sThisInstance

    End Function

    Public Function GetAsyncLoggerUrl(ByVal sApplicationPath As String) As String
        'http://lightning3/ESB/Source/CoreInternetTransportAdaptors/Wcf/ESBSoapXmlDocTransport.svc/Default
        'append ... "/AsyncLogger/ESB/Source/AsyncLogger/MsmqToMsSql.aspx" to URL path after instance name...
        Dim sThisInstance As String = ""
        Dim i As Integer = 0
        Dim sAppPath As String
        Dim sSeparator As String = Format(Path.DirectorySeparatorChar)

        'Request.ApplicationPath = "/ESB/ThisInstance/Manage"
        If InStr(sApplicationPath, "/") > 0 Then
            sAppPath = Replace(sApplicationPath, "/", sSeparator)
        End If

        If InStr(sApplicationPath, "\") > 0 Then
            sAppPath = Replace(sApplicationPath, "\", sSeparator)
        End If

        Dim myArray() As String = Split(sAppPath, sSeparator)

        For i = 0 To myArray.Length - 1
            If myArray(i).ToLower = "esb" Then
                sThisInstance = myArray(i + 1)
                Exit For
            End If
        Next i

        Dim myArray2() As String = Split(sApplicationPath, "/esb/" & sThisInstance & "/")

        Dim sAsyncLoggerUrl As String = myArray2(0) & "/esb/" & sThisInstance & "/AsyncLogger/MsmqToMsSql.aspx"

        Return sAsyncLoggerUrl

    End Function

      Public Function GetHttpEndpointUrl(ByVal sAbsoluteUri As String) As String
        'http://lightning3/ESB/Source/CoreInternetTransportAdaptors/Wcf/ESBSoapXmlDocTransport.svc/Default
        Dim sThisInstance As String = ""
        Dim i As Integer = 0
        Dim sAppPath As String
        Dim sSeparator As String = Format(Path.DirectorySeparatorChar)

        'Request.ApplicationPath = "/ESB/ThisInstance/Manage"
        If InStr(sAbsoluteUri, "/") > 0 Then
            sAppPath = Replace(sAbsoluteUri, "/", sSeparator)
        End If

        If InStr(sAbsoluteUri, "\") > 0 Then
            sAppPath = Replace(sAbsoluteUri, "\", sSeparator)
        End If

        Dim myArray() As String = Split(sAppPath, sSeparator)

        For i = 0 To myArray.Length - 1
            If myArray(i).ToLower = "esb" Then
                sThisInstance = myArray(i + 1)
                Exit For
            End If
        Next i

        Dim myArray2() As String = Split(sAbsoluteUri, "/esb/" & sThisInstance & "/")

        Dim sAsyncLoggerUrl As String = myArray2(0) & "/esb/" & sThisInstance & "/CoreInternetTransportAdaptors/Wse3/ESBHttpTransport.aspx"

        Return sAsyncLoggerUrl

    End Function

    Public Function GetDNSName(ByVal sAbsoluteUri As String) As String
        'http://lightning3/ESB/Source/CoreInternetTransportAdaptors/Wcf/ESBSoapXmlDocTransport.svc/Default
        Dim sThisInstance As String = ""
        Dim i As Integer = 0
        Dim sAppPath As String = sAbsoluteUri
        Dim sSeparator As String = Format(Path.DirectorySeparatorChar)

        If InStr(sAbsoluteUri, "/") > 0 Then
            sAppPath = Replace(sAbsoluteUri, "/", sSeparator)
        End If

        If InStr(sAbsoluteUri, "\") > 0 Then
            sAppPath = Replace(sAbsoluteUri, "\", sSeparator)
        End If

        Dim myArray() As String = Split(sAppPath, sSeparator)

        Return myArray(2)

    End Function

End Module