﻿'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Strict Off ' leave it off - otherwise you need to do CType casts everywhere!!!
Option Explicit On

Imports System.Xml.Serialization
Imports System
Imports System.Xml
Imports System.Xml.Xsl
Imports System.IO
Imports Microsoft.VisualBasic
Imports System.Reflection
Imports System.Text
Imports ESB.Core.XMLSchemaClasses.ESBEnvelope
Imports System.Collections.Generic
Imports Wintellect.PowerCollections

Namespace ESBEnvelope
    '<remarks/>                                                             
    <System.Xml.Serialization.XmlTypeAttribute("ESBEnvelope", [Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
     System.Xml.Serialization.XmlRootAttribute("ESBEnvelope", [Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
    Public Class ESBEnvelopeProvider : Inherits ESBEnvelope.EnvelopeBase
        '        Implements Serialization.IXmlSerializable



        <System.Xml.Serialization.XmlIgnore()> _
        Friend m_lNumDocs As Integer = 0
        '<remarks/>
        Public header As header
        '<remarks/>
        Public body As New body

        Public Shared ReadOnly m_csEnvelopeName As String = "ESB.Core.XMLSchemaClasses.ESBEnvelope.ESBEnvelopeProvider"


        Public Sub New()
            header = New header(Me)

            'make sure the attachments are somehow linked as well...

        End Sub

        'Declare these properties with the XmlIgnoreAttribute in the implementing envelope classes...

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides ReadOnly Property XMLSchemaName() As String
            'The XMLSchema name of the default document - this is one of the parameters used on the 
            'ESB server to construct the pipeline for the request
            Get
                If m_lNumDocs <= 0 Then
                    Return ""
                Else
                    Return GetDocument(0).GetAsXMLDocument.DocumentElement.LocalName.Trim
                End If
            End Get
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides ReadOnly Property XMLSchemaNamespace() As String
            'The XMLSchema Namespace of the default document - this may be one of the parameters used on the 
            'ESB server to construct the pipeline for the request
            Get
                If m_lNumDocs <= 0 Then
                    Return ""
                Else
                    Return GetDocument(0).GetAsXMLDocument.DocumentElement.NamespaceURI
                End If
            End Get
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property ServiceName() As String
            'This is one of the parameters used on the 
            'ESB server to construct the pipeline for the request
            Get
                Return Me.header.service.name
            End Get
            Set(ByVal Value As String)
                Me.header.service.name = Trim(Value)
            End Set
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property ServiceNamespace() As String
            'This is one of the parameters used on the 
            'ESB server to construct the pipeline for the request
            Get
                Return Me.header.service.namespace
            End Get
            Set(ByVal Value As String)
                Me.header.service.namespace = Trim(Value)
            End Set
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property ServiceVersion() As String
            'This is one of the parameters used on the 
            'ESB server to construct the pipeline for the request
            Get
                Return Me.header.service.version
            End Get
            Set(ByVal Value As String)
                Me.header.service.version = Trim(Value)
            End Set
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides ReadOnly Property Context() As String
            Get
                Dim sTempContext As String
                sTempContext = Replace(Me.header.service.context, vbCrLf, "")
                sTempContext = Replace(sTempContext, vbTab, "")
                sTempContext = Replace(sTempContext, Chr(10), "")
                sTempContext = Replace(sTempContext, Chr(13), "")
                sTempContext = Trim(sTempContext)

                If Trim(Me.ServiceNamespace) = "" Then
                    Return ESB.Core.Util.Utils.TrimStr(Trim(Me.SystemType) & Trim(Me.SystemVersion) & "." & Trim(sTempContext) & "." & Trim(Me.ServiceName) & Trim(Me.header.service.version), ".")
                Else
                    Return ESB.Core.Util.Utils.TrimStr(Trim(Me.SystemType) & Trim(Me.SystemVersion) & "." & Trim(sTempContext) & "." & Trim(Me.ServiceNamespace) & "." & Trim(Me.ServiceName) & Trim(Me.header.service.version), ".")
                End If
            End Get
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property MessageContext() As String
            Get
                Return Trim(header.service.context)
            End Get

            Set(ByVal Value As String)
                header.service.context = Trim(Value)
            End Set
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property ToAddress() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.to Is Nothing Then
                    Return ""
                End If
                Return Me.header.delivery.to.address
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                If Me.header.delivery.to Is Nothing Then
                    Me.header.delivery.to = New [to]
                End If
                Me.header.delivery.to.address = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property ToAddressType() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.to Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.to.addressType = "" Then
                    'get it out of the url...
                    If Me.header.delivery.to.address = "" Then
                        Return ""
                    Else
                        Return Me.header.delivery.to.address.Substring(0, Me.header.delivery.to.address.IndexOf(":"))
                    End If
                Else
                    Return Me.header.delivery.to.addressType
                End If
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                If Me.header.delivery.to Is Nothing Then
                    Me.header.delivery.to = New [to]
                End If
                Me.header.delivery.to.addressType = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property FromAddress() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.from Is Nothing Then
                    Return ""
                End If
                Return Me.header.delivery.from.address
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                If Me.header.delivery.from Is Nothing Then
                    Me.header.delivery.from = New from
                End If
                Me.header.delivery.from.address = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property FromAddressType() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.from Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.from.addressType = "" Then
                    'get it out of the url...
                    If Me.header.delivery.from.address = "" Then
                        Return ""
                    Else
                        Return Me.header.delivery.from.address.Substring(0, Me.header.delivery.from.address.IndexOf(":"))
                    End If
                Else
                    Return Me.header.delivery.from.addressType
                End If
            End Get
            Set(ByVal Value As String)
                Me.header.delivery.from.addressType = Trim(Value)
            End Set
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property ConversationID() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.to Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.to.state Is Nothing Then
                    Return ""
                End If
                Return Me.header.delivery.to.state.process
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                If Me.header.delivery.to Is Nothing Then
                    Me.header.delivery.to = New [to]
                End If
                If Me.header.delivery.to.state Is Nothing Then
                    Me.header.delivery.to.state = New state
                End If
                Me.header.delivery.to.state.process = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property MessageID() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.message Is Nothing Then
                    Return ""
                End If
                Return Me.header.delivery.message.senderMessageID
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                If Me.header.delivery.message Is Nothing Then
                    Me.header.delivery.message = New message
                End If
                Me.header.delivery.message.senderMessageID = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property Environment() As String
            Get
                If Me.header.targetSystems.Count = 0 Then
                    Return ""
                Else
                    Return Me.header.targetSystems(0).environment
                End If
            End Get
            Set(ByVal Value As String)
                If Me.header.targetSystems.Count = 0 Then
                    Me.header.targetSystems.Add(New targetSystem)
                End If
                Me.header.targetSystems(0).environment = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property SystemName() As String
            Get
                If Me.header.targetSystems.Count = 0 Then
                    Return ""
                Else
                    Return Me.header.targetSystems(0).systemID
                End If
            End Get
            Set(ByVal Value As String)
                If header.targetSystems.Count = 0 Then
                    header.targetSystems.Add(New targetSystem)
                End If
                header.targetSystems(0).systemID = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property SystemType() As String
            Get
                If Me.header.targetSystems.Count = 0 Then
                    Return ""
                Else
                    Return Me.header.targetSystems(0).systemType
                End If

            End Get
            Set(ByVal Value As String)
                If header.targetSystems.Count = 0 Then
                    header.targetSystems.Add(New targetSystem)
                End If
                header.targetSystems(0).systemType = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property SystemVersion() As String
            Get
                If Me.header.targetSystems.Count = 0 Then
                    Return ""
                Else
                    Return Me.header.targetSystems(0).systemVersion
                End If
            End Get
            Set(ByVal Value As String)
                If Me.header.targetSystems.Count = 0 Then
                    Me.header.targetSystems.Add(New targetSystem)
                End If
                Me.header.targetSystems(0).systemVersion = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property CallSynchronizationType() As String
            Get

                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.message Is Nothing Then
                    Return ""
                End If
                Return Me.header.delivery.messageExchangePattern
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                Me.header.delivery.messageExchangePattern = Value
            End Set
        End Property


        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property FromName() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.from Is Nothing Then
                    Return ""
                End If
                Return Me.header.delivery.from.name
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                If Me.header.delivery.from Is Nothing Then
                    Me.header.delivery.from = New from
                End If
                Me.header.delivery.from.name = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property ToName() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.to Is Nothing Then
                    Return ""
                End If
                Return Me.header.delivery.to.name
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                If Me.header.delivery.to Is Nothing Then
                    Me.header.delivery.to = New [to]
                End If
                Me.header.delivery.to.name = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property Channel() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.from Is Nothing Then
                    Return ""
                End If
                Return Me.header.delivery.from.channel
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                If Me.header.delivery.from Is Nothing Then
                    Me.header.delivery.from = New from
                End If
                Me.header.delivery.from.channel = Trim(Value)
            End Set
        End Property


        '--Routing

        Public Overloads Overrides Function Serialize(ByVal oObjectToSerialize As System.Object) As String
            Dim oXMLUtil As New XMLUtil
            Return oXMLUtil.Serialize(oObjectToSerialize)
        End Function
        Public Overrides Function DeSerialize(ByVal sXMLStringToDeSerialize As String, ByVal tType As Type) As Object
            Dim oXMLUtil As New XMLUtil
            Return oXMLUtil.DeSerialize(sXMLStringToDeSerialize, tType)
        End Function
        Public Overrides Function ToXML() As String
            Dim sSerialisedXML As String = Serialize(Me)
            Dim sXSDValidationErrors As String
            If ShouldValidateXMLEnvelopeAgainstXSD("ValidationOnSerialize") Then
                If ValidateXMLAgainstXSD(sSerialisedXML, "ValidationOnSerialize", sXSDValidationErrors) = False Then
                    'If there is a validation error, depending upon the configuration
                    'flag for validation - ESB.ESBEnvelopeProvider.IgnoreInputSchemaValidationErrors
                    'either an exception will be thrown, or just an error returned in which case
                    'only the log entry below will be invoked.
                    'Note that even with validation turned off, (via the ESB.ESBEnvelopeProvider.ValidationOnSerialize configuration entry),
                    'the Serialization classes still do some form of validation
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, sXSDValidationErrors)
                End If
            End If
            Return sSerialisedXML

        End Function
        Public Overrides Function Tostring() As String
            Return Me.ToXML()
        End Function
        Public Overrides Function ToXMLDocument() As XmlDocument
            Dim oXmlDoc As New Xml.XmlDocument
            oXmlDoc.LoadXml(ToXML)
            Return oXmlDoc
        End Function
        Public Overrides Sub FromXMLDocument(ByVal oXMLdoc As XmlDocument)
            '   Me.FromXML(oXML.OuterXml)
            'Duplicated for optimization

            'need to pull out documents out of the DocumentBodies nodes
            'and put them into the XMLDocuments
            'and remove them from the XML Envelope
            'Then we can deserialize the ESBEnvelopeProvider...
            Dim sXMLEnv As String = ""

            If oXMLdoc Is Nothing Then
                Throw New Exception("XMLDocument Received is Nothing.")
            End If

            Dim sXSDValidationErrors As String = ""
            If ShouldValidateXMLEnvelopeAgainstXSD("ValidationOnDeserialize") Then
                sXMLEnv = oXMLdoc.OuterXml
                If ValidateXMLAgainstXSD(sXMLEnv, "ValidationOnDeserialize", sXSDValidationErrors) = False Then
                    'If there is a validation error, depending upon the configuration
                    'flag for validation - ESB.ESBEnvelopeProvider.IgnoreInputSchemaValidationErrors
                    'either an exception will be thrown, or just an error returned in which case
                    'only the log entry below will be invoked.
                    'Note that even with validation turned off, (via the ESB.ESBEnvelopeProvider.ValidationOnDeserialize configuration entry),
                    'the Serialization classes still do some form of validation
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, sXSDValidationErrors)
                End If
            End If

            'Dim oXMLDoc As New XmlDocument
            'oXMLDoc.LoadXml(sXMLEnv)

            'do some XPath here & replace those nodes with nothing...
            Dim oDocumentBodyNL As XmlNodeList
            Dim nsmgr As New XmlNamespaceManager(oXMLdoc.NameTable)
            nsmgr.AddNamespace("esb", "urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0")
            oDocumentBodyNL = oXMLdoc.SelectNodes("/esb:ESBEnvelope/esb:body/esb:documentBody/node()", nsmgr)

            Dim oDocBodyXMLNode As XmlNode
            Dim i As Long = 0

            For Each oDocBodyXMLNode In oDocumentBodyNL
                'Add an entry to the documents in the envelope
                AddDocument(New InlineDocument(oDocBodyXMLNode))
                i += 1
            Next

            'Deserialize the header
            Dim oEnvTmp As ESBEnvelopeProvider
            If sXMLEnv = "" Then
                sXMLEnv = oXMLdoc.OuterXml
            End If
            oEnvTmp = DeSerialize(sXMLEnv, GetType(ESBEnvelopeProvider))
            Me.header = oEnvTmp.header
            Me.header.m_oParent = Me
            Me.header.manifest.m_oParent = Me
            If Not Me.header.manifest.document Is Nothing Then
                Me.header.manifest.document.m_oParent = Me
            End If

        End Sub

        Public Overrides Sub FromXML(ByVal sXMLEnv As String)
            'need to pull out documents out of the DocumentBodies nodes
            'and put them into the XMLDocuments
            'and remove them from the XML Envelope
            'Then we can deserialize the ESBEnvelopeProvider...

            If sXMLEnv = "" Then
                Throw New Exception("Received an empty string instead of an envelope.")
            End If

            Dim sXSDValidationErrors As String
            If ShouldValidateXMLEnvelopeAgainstXSD("ValidationOnDeserialize") Then
                If ValidateXMLAgainstXSD(sXMLEnv, "ValidationOnDeserialize", sXSDValidationErrors) = False Then
                    'If there is a validation error, depending upon the configuration
                    'flag for validation - ESB.ESBEnvelopeProvider.IgnoreInputSchemaValidationErrors
                    'either an exception will be thrown, or just an error returned in which case
                    'only the log entry below will be invoked.
                    'Note that even with validation turned off, (via the ESB.ESBEnvelopeProvider.ValidationOnDeserialize configuration entry),
                    'the Serialization classes still do some form of validation
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, sXSDValidationErrors)
                End If
            End If

            Dim oXMLDoc As New XmlDocument
            oXMLDoc.LoadXml(sXMLEnv)

            'do some XPath here & replace those nodes with nothing...
            Dim oDocumentBodyNL As XmlNodeList
            Dim nsmgr As New XmlNamespaceManager(oXMLDoc.NameTable)
            nsmgr.AddNamespace("esb", "urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0")
            oDocumentBodyNL = oXMLDoc.SelectNodes("/esb:ESBEnvelope/esb:body/esb:documentBody/node()", nsmgr)

            Dim oDocBodyXMLNode As XmlNode
            Dim i As Long = 0

            For Each oDocBodyXMLNode In oDocumentBodyNL
                'Add an entry to the documents in the envelope
                AddDocument(New InlineDocument(oDocBodyXMLNode))
                i += 1
            Next

            'Deserialize the header
            Dim oEnvTmp As ESBEnvelopeProvider
            oEnvTmp = DeSerialize(sXMLEnv, GetType(ESBEnvelopeProvider))
            Me.header = oEnvTmp.header
            Me.header.m_oParent = Me
            Me.header.manifest.m_oParent = Me
            If Not Me.header.manifest.document Is Nothing Then
                Me.header.manifest.document.m_oParent = Me
            End If



        End Sub
        Public Function ShouldValidateXMLEnvelopeAgainstXSD(ByVal ValidationContext As String) As Boolean
            If System.Configuration.ConfigurationManager.AppSettings("ESB.ESBEnvelopeProvider." & ValidationContext) = "1" Then
                Return True
            Else : Return False : End If
        End Function
        Public Function ValidateXMLAgainstXSD(ByVal sXmlToValidate As String, ByVal ValidationContext As String, Optional ByVal sErrors As String = "") As Boolean
            'If System.Configuration.ConfigurationManager.AppSettings("ESB.ESBEnvelopeProvider." & ValidationContext) = "1" Then
            Dim oXmlUtil As New XMLUtil
            Dim sPath As String = System.Configuration.ConfigurationManager.AppSettings("ESB.ESBEnvelopeProvider.XSDFilePath")
            Dim sXSDPath As String = Path.Combine(ESB.Core.Util.ExpandRelativePath(sPath), "ESBEnvelopeProvider.xsd")
            Return oXmlUtil.ValidateXMLAgainstXSD(sXSDPath, sXmlToValidate, sErrors)
            'Else
            'Return True
            'End If
        End Function

        Public Overloads Overrides Function AddDocument(ByVal oDoc As IInlineDocument, Optional ByVal bCopyDocument As Boolean = False) As Long
            Return AddDocumentInternal(oDoc.GetAsXMLDocument, , bCopyDocument)
        End Function
        Public Overloads Overrides Function AddDocument(ByVal oDoc As IInlineDocument, ByVal lDocumentIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As Long
            Return AddDocumentInternal(oDoc.GetAsXMLDocument, lDocumentIndex, bCopyDocument)
        End Function
        Public Overloads Overrides Function GetDocument(ByVal lIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Dim oXmlDoc As XmlDocument = GetDocumentInternal(, lIndex, False)
            If Not oXmlDoc Is Nothing Then
                Return New InlineDocument(oXmlDoc, bCopyDocument)
            Else
                Return Nothing
            End If
        End Function
        Public Overloads Overrides Function GetDocument(ByVal sDocumentName As String, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Dim oXmlDoc As XmlDocument = GetDocumentInternal(sDocumentName, False)
            If Not oXmlDoc Is Nothing Then
                Return New InlineDocument(oXmlDoc, bCopyDocument)
            Else
                Return Nothing
            End If
        End Function
        Public Overloads Overrides Function GetDocument(ByVal sDocumentName As String, ByVal lIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Dim oXmlDoc As XmlDocument = GetDocumentInternal(sDocumentName, lIndex, False)
            If Not oXmlDoc Is Nothing Then
                Return New InlineDocument(oXmlDoc, bCopyDocument)
            Else
                Return Nothing
            End If
        End Function
        Public Overloads Overrides Function GetDocument(ByVal sDocumentName As String, ByVal lIndex As Long, ByRef lReturnedDocIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Dim oXmlDoc As XmlDocument = GetDocumentInternal(sDocumentName, lIndex, False, lReturnedDocIndex)
            If Not oXmlDoc Is Nothing Then
                Return New InlineDocument(oXmlDoc, bCopyDocument)
            Else
                Return Nothing
            End If

        End Function

        Public Overloads Function AddDocumentInternal(ByVal oXmlDocument As System.Xml.XmlDocument, Optional ByVal lDocumentIndex As Long = -1, Optional ByVal bCopyDocument As Boolean = False) As Long

            Dim oNewDoc As XmlDocument

            If bCopyDocument = True Then
                '++Make a copy of the Document...before adding
                oNewDoc = New XmlDocument
                Dim sXMLNewDoc As String = GetXMLAsString(oXmlDocument)
                oNewDoc.LoadXml(sXMLNewDoc)
            Else
                oNewDoc = oXmlDocument
            End If

            Dim oNode As XmlNode

            'Remove the XML Declaration node if one exists - can only have one in an XML document...
            For Each oNode In oNewDoc.ChildNodes()
                If oNode.Name.ToUpper = "XML" Then
                    oNewDoc.RemoveChild(oNode)
                End If
            Next

            'Determine whether to insert at a given position or at the end of the list of any existing documents...
            If lDocumentIndex <> -1 Then
                'insert at a given location - potentially overwrite an existing document...
                If lDocumentIndex > m_lNumDocs Then
                    'error
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Cannot insert document at a position more than 1 greater than the current document count!")
                    Return -1
                End If

                'insert at a specified index
                If body.documentBody Is Nothing Then
                    body.documentBody = New Collections.Generic.List(Of System.Xml.XmlDocument)
                    'body.documentBody = New documentBodiesCol
                End If

                body.documentBody.Insert(lDocumentIndex, oNewDoc)

                If header.manifest.document Is Nothing Then
                    header.manifest.document = New documentCol
                End If

                header.manifest.document(lDocumentIndex) = New document
                'header.manifest.document(lDocumentIndex).description = oNewDoc.NamespaceURI
                header.manifest.document(lDocumentIndex).documentNamespace = oNewDoc.NamespaceURI
                header.manifest.document(lDocumentIndex).name = oNewDoc.DocumentElement.LocalName
                Return m_lNumDocs - 1 'return the document index - zero based

            Else
                'just insert at next index
                If body.documentBody Is Nothing Then
                    body.documentBody = New Collections.Generic.List(Of System.Xml.XmlDocument)
                    'body.documentBody = New documentBodiesCol
                End If

                body.documentBody.Add(oNewDoc)

                If header.manifest.document Is Nothing Then
                    header.manifest.document = New documentCol
                End If

                header.manifest.document(m_lNumDocs) = New document
                header.manifest.document(m_lNumDocs).documentNamespace = oNewDoc.DocumentElement.NamespaceURI
                header.manifest.document(m_lNumDocs).name = oNewDoc.DocumentElement.LocalName

                m_lNumDocs += 1
                Return m_lNumDocs - 1 'return the document index - zero based
            End If
        End Function

        Public Overloads Function AddDocumentInternal(ByVal oXMLClassWrapperObj As Object) As Long
            'Currently, I only know how to serialize & pass the XML on to AddDocumentInternal(ByVal sXMLDoc As String)
            'Later, I'll try & figure out a way to have the document attached & still be able to modify it!
            Dim sXMLDoc As String
            sXMLDoc = Serialize(oXMLClassWrapperObj)

            Return AddDocumentInternal(sXMLDoc)
        End Function
        Public Overloads Function AddDocumentInternal(ByVal oXmlNode As System.Xml.XmlNode) As Long
            'need to remove the DocumentBody node...
            Dim oXMLDoc As New XmlDocument
            Dim oXMLNodeForThisDoc As XmlNode
            oXMLNodeForThisDoc = oXMLDoc.ImportNode(oXmlNode, True)

            oXMLDoc.AppendChild(oXMLNodeForThisDoc)

            Return AddDocumentInternal(oXMLDoc)

        End Function
        Public Overloads Function AddDocumentInternal(ByVal sXMLDoc As String) As Long
            Dim oDoc As New XmlDocument
            oDoc.LoadXml(sXMLDoc)
            Return AddDocumentInternal(oDoc)

        End Function

        Public Overrides Function DocumentCount() As Long
            'Starts off zero, when you add a document, this gets incremented...
            Return Me.m_lNumDocs
        End Function
        Public Overloads Function GetDocumentInternal(Optional ByVal sDocumentName As String = "", Optional ByVal lDocIndex As Long = -1, Optional ByVal bCopyDocument As Boolean = False, Optional ByVal lReturnedDocIndex As Long = -1) As XmlDocument

            Dim eStatus As eEnvelopeStatus = eEnvelopeStatus.eSuccess
            Dim i As Long = 0
            Dim oDoc As XmlDocument

            Dim lMatchIndex As Long = 0

            If (sDocumentName = "" And lDocIndex = -1) Then
                Throw New Exception("Invalid parameters specified - sDocumentName = "" And lDocIndex = -1")
            End If
            If Me.header.manifest.document.Count <> Me.m_lNumDocs Then
                Throw New Exception("Inconsistent Envelope - Document Body count(" & Me.m_lNumDocs & ") does not match header manifest document count (" & Me.header.manifest.document.Count & ")")
            End If

            Try
                For i = 0 To Me.m_lNumDocs - 1
                    'Check to see if there's an instance of the document asked for present...

                    If (sDocumentName = "" And lDocIndex <> -1) Or Me.header.manifest.document(i).name = sDocumentName Then
                        'there's a match in the manifest - or we don't care to match on a document name...
                        'try & get the doc out of the body now...
                        If sDocumentName = "" Then 'just get the document at the requested index...
                            Try
                                oDoc = body.documentBody(lDocIndex)
                                If Not oDoc Is Nothing Then
                                    lReturnedDocIndex = i
                                    Return oDoc
                                Else
                                    eStatus = eEnvelopeStatus.eWarnings
                                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Index out of range")
                                End If
                            Catch

                            End Try
                        End If
                        If lMatchIndex = lDocIndex Then
                            Try
                                oDoc = body.documentBody(i)
                                If Not oDoc Is Nothing Then
                                    lReturnedDocIndex = i
                                    Return oDoc
                                Else
                                    eStatus = eEnvelopeStatus.eInconsistentEnvelope
                                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Inconsistent Envelope - Body does not match header - ")

                                    'bad envelope - Manifest does not match body etc.
                                    'Also need to count docs in Manifest & Body etc...

                                    'Dim oDocBody As System.Xml.XmlDocument
                                    'protected... for each odocbody in ojskenv.elbody
                                    'Return Nothing
                                    Throw New Exception("Inconsistent Envelope - Body does not match header - ")
                                End If
                            Catch ex As Exception
                                ExceptionManager.Publish(ex)
                                eStatus = eEnvelopeStatus.eInconsistentEnvelope
                                LogError(LogDefs.eLogLevel.eLOG_ERROR, "Inconsistent Envelope - Body does not match header - " & ex.ToString)
                                Throw ex
                            Finally

                            End Try
                        End If
                        lMatchIndex += 1

                    End If
                    'i += 1
                Next i

                Return Nothing

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(LogDefs.eLogLevel.eLOG_ERROR, "Inconsistent Envelope - Body does not match header - " & ex.ToString)
                Throw ex
            End Try

        End Function

        '++ Helper Functions
        Public Overloads Overrides Function IsError(ByVal sXML As String) As Boolean
            Return Not ((GetMsgStatus(sXML) = eEnvelopeStatus.eSuccess) Or (GetMsgStatus(sXML) = eEnvelopeStatus.eWarnings))
        End Function
        Public Overloads Function IsError(ByVal oesbEnv As ESBEnvelopeProvider) As Boolean
            Return Not ((GetMsgStatus(oesbEnv) = eEnvelopeStatus.eSuccess) Or (GetMsgStatus(oesbEnv) = eEnvelopeStatus.eWarnings))
        End Function
        Public Overloads Overrides Function IsWarning(ByVal sXML As String) As Boolean
            Return GetMsgStatus(sXML) = eEnvelopeStatus.eWarnings
        End Function
        Public Overloads Function IsWarning(ByVal oesbEnv As ESBEnvelopeProvider) As Boolean

            Return GetMsgStatus(oesbEnv) = eEnvelopeStatus.eWarnings
        End Function
        Public Overloads Overrides Function GetMsgStatus(ByVal sXML As String) As eEnvelopeStatus
            Dim oesbEnv As New ESBEnvelopeProvider
            oesbEnv.FromXML(sXML)

            Return GetMsgStatus(oesbEnv)
        End Function

        ''' <summary>
        ''' Should maybe use XPATH here...
        ''' </summary>
        ''' <param name="oesbEnv"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Overloads Function GetMsgStatus(ByVal oesbEnv As ESBEnvelopeProvider) As eEnvelopeStatus
            Dim eStatus As eEnvelopeStatus = eEnvelopeStatus.eSuccess
            Dim i As Long = 0


            Try

                For i = 0 To oesbEnv.m_lNumDocs - 1
                    'Check to see if there's an instance of the ErrorXMl document present
                    If oesbEnv.header.manifest.document(i).name = "ErrorXML" Then

                        Try
                            Dim oPlgErr As ErrorXML.ErrorXML
                            'oPlgErr = oesbEnv.GetDocument(i, GetType(ErrorXML.ErrorXML))
                            oPlgErr = oesbEnv.GetDocument(i).GetAsObject(GetType(ErrorXML.ErrorXML))
                            If Not oPlgErr Is Nothing Then
                                If oPlgErr.ErrorEntry.Count > 0 Then
                                    eStatus = eEnvelopeStatus.eFailed
                                    Exit For
                                End If
                                If oPlgErr.WarningEntry.Count > 0 Then
                                    eStatus = eEnvelopeStatus.eWarnings
                                    'check to see if there's any other ErrorXML documents...that would possibly increase the severity...
                                    Exit Try
                                End If

                                'eStatus = eEnvelopeStatus.eSuccess
                            Else
                                'bad envelope - Manifest does not match body etc.
                                'Also need to count docs in Manifest & Body etc...

                                Exit For
                            End If
                        Catch ex As Exception
                            ExceptionManager.Publish(ex)
                            LogError(eLogLevel.eLOG_ERROR, "eEnvelopeStatus.eInconsistentEnvelope. " & ex.ToString)
                            eStatus = eEnvelopeStatus.eInconsistentEnvelope
                            Exit For
                        Finally

                        End Try
                    Else
                        eStatus = eEnvelopeStatus.eSuccess
                    End If
                    'i += 1
                Next

                Return eStatus

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(eLogLevel.eLOG_ERROR, ex.ToString)
                Throw ex
            End Try

        End Function
        '-- Helper Functions

        Public Overrides Function IsCorrectEnvelopeType(ByVal sXML As String) As Boolean
            Try

                Dim settings As New XmlReaderSettings()
                settings.ConformanceLevel = ConformanceLevel.Document
                settings.IgnoreWhitespace = True
                settings.IgnoreComments = True

                Dim reader As XmlReader = XmlReader.Create(XMLUtil.StringToStream(sXML), settings)


                Dim sEnvelopeNodeName As String
                Dim sEnvelopeNamespace As String

                reader.Read()
                sEnvelopeNodeName = reader.Name
                sEnvelopeNamespace = reader.NamespaceURI

                If sEnvelopeNodeName = "" Or sEnvelopeNamespace = "" Then
                    reader.Read()
                    sEnvelopeNodeName = reader.Name
                    sEnvelopeNamespace = reader.NamespaceURI
                End If

                If sEnvelopeNodeName = "ESBEnvelope" And sEnvelopeNamespace = "urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0" Then
                    Return True
                Else
                    Return False
                    Return True
                End If


            Catch e As Exception
                LogError(LogDefs.eLogLevel.eLOG_ERROR, "Error Parsing envelope:" & e.Message)
                Return False
            End Try


        End Function


        'Public Overrides Function IsCorrectEnvelopeType(ByVal sXML As String) As Boolean
        '    Try

        '        Dim oXMLDoc As New XmlDocument
        '        oXMLDoc.LoadXml(sXML)

        '        If oXMLDoc.DocumentElement.LocalName = "ESBEnvelope" Then
        '            If oXMLDoc.DocumentElement.NamespaceURI = "urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0" Then
        '                Return True
        '            Else
        '                Return False
        '            End If
        '        Else
        '            Return False
        '        End If
        '    Catch e As Exception
        '        LogError(LogDefs.eLogLevel.eLOG_ERROR, "Error Parsing envelope:" & e.Message)
        '        Return False
        '    End Try


        'End Function

        Public Overloads Function GetEnvelopeNodeName(Optional ByVal sXML As String = "") As Boolean
            Return True
        End Function
        Public Overloads Function GetEnvelopeNameSpace(Optional ByVal sXML As String = "") As Boolean
            Return True
        End Function
        Public Overloads Function GetEnvelopeVersion(Optional ByVal sXML As String = "") As Boolean
            Return True
        End Function

        Public Overrides Function AddAttachment(Optional ByVal sAttachmentName As String = "", Optional ByVal sAttachmentPath As String = "", Optional ByVal lIndex As Long = 0, Optional ByVal sType As String = "", Optional ByVal sUrl As String = "") As Long
            'todo: test
            Dim oAtt As New attachment
            With oAtt
                .description = sAttachmentName
                .filename = sAttachmentPath
                .index = lIndex
                .type = sType
                .url = sUrl
            End With

            header.manifest.attachment.Add(oAtt)
            Return True
        End Function
        Public Overrides Function GetAttachment(ByVal lIndex As Long) As IAttachment
            Return header.manifest.attachment(lIndex)
        End Function
        Public Overrides Function GetAttachments() As System.Collections.Generic.IList(Of IAttachment)
            Return Algorithms.TypedAs(Of IAttachment)(Me.header.manifest.attachment)
        End Function
        Public Overrides Function GetCustomParams() As IList
            Return CType(header.custom, IList)
        End Function
        Public Overrides Sub ClearCustomParams()
            header.custom.Clear()
        End Sub
        Public Overrides Function GetDocuments() As System.Collections.Generic.IList(Of IInlineDocument)
            'Return CType(header.manifest.document, IList)
            Return Algorithms.TypedAs(Of IInlineDocument)(Me.header.manifest.document)

            'Dim oDocumentBodyInlineDocs As New Collections.Generic.List(Of IInlineDocument)
            'For Each oXmlDoc As XmlDocument In Me.body.documentBody
            '    oDocumentBodyInlineDocs.Add(New InlineDocument(oXmlDoc))
            'Next

            'Return Algorithms.TypedAs(Of IInlineDocument)(oDocumentBodyInlineDocs)

        End Function
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides ReadOnly Property AttachmentsExist() As Boolean
            Get
                If header.manifest.attachment.Count > 0 Then
                    Return True
                Else
                    Return False
                End If
            End Get
        End Property

        Public Overrides Function GetEnvelopeType(Optional ByVal sXML As String = "", Optional ByRef oEnvOut As IEnvelopeProvider = Nothing) As String
            If sXML = "" Then
                Return m_csEnvelopeName
            Else
                Return MyBase.GetEnvelopeType(sXML)
            End If
        End Function

        Public Overloads Overrides Sub SetCustomParam(ByVal sParamName As String, ByVal sParamValue As String)
            StartMethod()
            Try
                If header.custom Is Nothing Then
                    header.custom = New List(Of custom)
                End If
                'try to find a param with that name first. Should not be that many
                'so don't bother with HashTables etc...
                Dim oCustom As custom
                Dim bFoundExisting As Boolean = False

                For Each oCustom In Me.header.custom
                    If oCustom.name = sParamName Then
                        oCustom.value = Trim(sParamValue)
                        bFoundExisting = True
                        Exit For
                    End If
                Next

                'none found by that name, so add one...
                If bFoundExisting = False Then
                    oCustom = New custom
                    oCustom.name = sParamName
                    oCustom.value = Trim(sParamValue)
                    Me.header.custom.Add(oCustom)
                End If
            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(eLogLevel.eLOG_ERROR, ex.ToString)
            Finally
                EndMethod()
            End Try

        End Sub
        Public Overloads Overrides Function GetCustomParam(ByVal sParamName As String) As String
            StartMethod()
            Try
                Dim oCustom As custom
                For Each oCustom In Me.header.custom
                    If oCustom.name = sParamName Then
                        Return Trim(oCustom.value)
                    End If
                Next
                'if no match found, then return an empty string...
                Return ""
            Catch ex As Exception
                ExceptionManager.Publish(ex)
                Return ""
            Finally
                EndMethod()
            End Try
        End Function
        Public Overloads Overrides Sub SetCustomParam(ByVal sParamNodeName As String, ByVal sParamName As String, ByVal sParamValue As String)
            StartMethod()
            Try
                SetCustomParam(sParamNodeName & "." & sParamName, sParamValue)
            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(eLogLevel.eLOG_ERROR, ex.ToString)
            Finally
                EndMethod()
            End Try

        End Sub

        Public Overloads Overrides Function GetCustomParam(ByVal sParamNodeName As String, ByVal sParamName As String) As String
            StartMethod()
            Try
                Return GetCustomParam(sParamNodeName & "." & sParamName)

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                Return ""
            Finally
                EndMethod()
            End Try
        End Function

        Public Overloads Overrides Function CreateResponse() As IEnvelope
            Dim oesbEnv As New ESBEnvelopeProvider

            'Should copy header over etc...
            'oesbEnv = Me.Clone()

            oesbEnv.header = DeSerialize(Serialize(Me.header), GetType(header))

            oesbEnv.header.delivery.message.sent = ESB.Core.Util.Timer.NowAsString
            'Remove other stuff...Just leave relavant bits of header...
            If Not oesbEnv.body.documentBody Is Nothing Then
                oesbEnv.body.documentBody.Clear()
            End If
            oesbEnv.header.manifest.attachment.Clear()
            If Not oesbEnv.header.manifest.document Is Nothing Then
                oesbEnv.header.manifest.document.Clear()
            End If
            oesbEnv.m_lNumDocs = 0

            Dim oEnv As New Envelope
            oEnv.SetInternalEnvelope(oesbEnv)
            oEnv.DefaultEnvelopeType = m_csEnvelopeName
            Return oEnv

        End Function

        'Public Overloads Overrides Function CreateResponse() As IEnvelope
        '    Dim oesbEnv As New ESBEnvelopeProvider

        '    'Should copy header over etc...
        '    oesbEnv = Me.Clone()

        '    oesbEnv.header.delivery.message.sent = ESB.Core.Util.Timer.NowAsString
        '    'Remove other stuff...Just leave relavant bits of header...
        '    If Not oesbEnv.body.documentBody Is Nothing Then
        '        oesbEnv.body.documentBody.Clear()
        '    End If
        '    oesbEnv.header.manifest.attachment.Clear()
        '    If Not oesbEnv.header.manifest.document Is Nothing Then
        '        oesbEnv.header.manifest.document.Clear()
        '    End If
        '    oesbEnv.m_lNumDocs = 0

        '    Dim oEnv As New Envelope
        '    oEnv.SetInternalEnvelope(oesbEnv)
        '    oEnv.DefaultEnvelopeType = m_csEnvelopeName
        '    Return oEnv

        'End Function

        Public Overrides Function Clone() As Object
            'Best way to Clone is probably to Serialise & Deserialize as is done below...
            Dim oEnv As New ESBEnvelopeProvider
            Dim sEnvXML As String = Me.ToXML
            oEnv.FromXML(sEnvXML)
            Return oEnv
        End Function

        Public Overloads Overrides Function IsWarning() As Boolean
            Return IsWarning(Me)
        End Function

        Public Overloads Overrides Function IsError() As Boolean
            Return IsError(Me)
        End Function

        Public Overloads Overrides Function GetMsgStatus() As eEnvelopeStatus
            Return GetMsgStatus(Me)
        End Function
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property InternalMessageID() As String
            Get
                Return Me.header.delivery.message.receiverMessageID
            End Get
            Set(ByVal Value As String)
                Me.header.delivery.message.receiverMessageID = Trim(Value)
            End Set
        End Property

        'Public Function GetSchema() As System.Xml.Schema.XmlSchema Implements System.Xml.Serialization.IXmlSerializable.GetSchema
        '    Return Nothing
        'End Function

        'Public Sub ReadXml(ByVal reader As System.Xml.XmlReader) Implements System.Xml.Serialization.IXmlSerializable.ReadXml
        '    'DeSerialize
        '    Me.FromXML(reader.ReadOuterXml())
        'End Sub

        'Public Sub WriteXml(ByVal writer As System.Xml.XmlWriter) Implements System.Xml.Serialization.IXmlSerializable.WriteXml
        '    'Serialize
        '    writer.WriteRaw(Me.ToXML)
        'End Sub
    End Class
    '<remarks/>
    <System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
    Public Class header

        Friend m_oParent As ESBEnvelopeProvider

        '-----------------------------------------------------------------------------
        ' <summary>
        ' Only allow this object to be created with a parent envelope reference
        ' so that we can manage deleting the accompanying DocumentBody object.
        ' </summary>
        ' <param name="oParent"></param>
        ' <remarks>
        ' When this object is deleted, the associated DocumentBody object will also need to be delted...
        ' </remarks>
        ' <history>
        ' 	[MINA] 	6/05/2004	Created
        ' </history>
        '-----------------------------------------------------------------------------
        Public Sub New()

        End Sub
        Public Sub New(ByVal oParent As ESBEnvelopeProvider)
            m_oParent = oParent
            manifest = New manifest(m_oParent)
        End Sub

        '<remarks/>
        Public delivery As New delivery

        '<remarks/>
        Public manifest As manifest

        '<remarks/>
        <System.Xml.Serialization.XmlArrayItemAttribute("targetSystem", IsNullable:=False)> _
        Public targetSystems As New List(Of targetSystem)
        'Public systems As New systemCol

        '<remarks/>

        '<remarks/>

        Public service As New service

        '==> Use this (XmlArrayItemAttribute) to have the custom nodes indented into an outer custom node
        '<System.Xml.Serialization.XmlArrayItemAttribute("custom", IsNullable:=False)> _

        '==> use this to have a flat array of custom noded, not under an outer custom node.
        <System.Xml.Serialization.XmlElementAttribute("custom")> _
        Public custom As List(Of custom)
        'Public custom As customCol

    End Class
    '<remarks/>
    <System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
    Public Class delivery

        '<remarks/>
        Public message As New message

        '<remarks/>
        Public [to] As [to]

        '<remarks/>
        Public from As from

        '<remarks/>
        Public messageExchangePattern As String
    End Class
    '<remarks/>
    <System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
Public Class message

        '<remarks/>
        '''-----------------------------------------------------------------------------
        ''' <summary>
        ''' This is the External MessageID, set by clients etc.
        ''' It may be the same for multiple requests, depending upon the client and test harnesses etc.
        ''' </summary>
        '''-----------------------------------------------------------------------------
        Public senderMessageID As String

        '''-----------------------------------------------------------------------------
        ''' <summary>
        ''' This is the internal MessageID, set by ESB Only, and is Guaranteed to be unique
        ''' for each request.
        ''' </summary>
        '''-----------------------------------------------------------------------------
        Public receiverMessageID As String

        '<remarks/>
        Public sent As String = ESB.Core.Util.Timer.NowAsString

        '<remarks/>
        Public subject As String
    End Class
    '<remarks/>
    <System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
    Public Class body
        <System.Xml.Serialization.XmlElementAttribute()> _
        Public documentBody As New Collections.Generic.List(Of System.Xml.XmlDocument)

        'Public m_oDocumentBodyInlineDocs As New Collections.Generic.List(Of InlineDocument)


    End Class

    'Need to rename the System class cos it interferes with the System namespace...
    <System.Xml.Serialization.XmlTypeAttribute("targetSystem", [Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
     System.Xml.Serialization.XmlRootAttribute("targetSystem", [Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
       Public Class targetSystem

        '<remarks/>
        Public adminID As String

        '<remarks/>
        Public systemID As String

        '<remarks/>
        Public url As String

        '<remarks/>
        Public environment As String

        '<remarks/>
        Public systemType As String = ""

        '<remarks/>
        Public systemVersion As String
    End Class

    <System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
    System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
    Public Class attachment : Implements IAttachment
        Protected sIndex As String
        Protected sFilename As String
        Protected sDescription As String
        Protected sType As String
        Protected sUrl As String


        '<remarks/>

        Public Property index() As String Implements IAttachment.index
            Get
                Return Trim(sIndex)
            End Get
            Set(ByVal Value As String)
                sIndex = Trim(Value)
            End Set
        End Property
        '<remarks/>
        Public Property filename() As String Implements IAttachment.filename
            Get
                Return Trim(sFilename)
            End Get
            Set(ByVal Value As String)
                sFilename = Trim(Value)
            End Set
        End Property
        '<remarks/>
        Public Property description() As String Implements IAttachment.description
            Get
                Return Trim(sDescription)
            End Get
            Set(ByVal Value As String)
                sDescription = Trim(Value)
            End Set
        End Property
        '<remarks/>
        Public Property type() As String Implements IAttachment.type
            Get
                Return Trim(sType)
            End Get
            Set(ByVal Value As String)
                sType = Trim(Value)
            End Set
        End Property
        '<remarks/>
        Public Property url() As String Implements IAttachment.url
            Get
                Return Trim(sUrl)
            End Get
            Set(ByVal Value As String)
                sUrl = Trim(Value)
            End Set
        End Property
    End Class



    '--The internal attachment & attachment classes

    '<remarks/>
    <Serializable()> _
    Public Class documentCol : Inherits Collections.CollectionBase

        Friend m_oParent As ESBEnvelopeProvider

        '!!!Bloody! Serialization doesn't work with a private constructor!!!
        'Private Sub New()
        'End Sub
        '''-----------------------------------------------------------------------------
        ''' <summary>
        ''' Only allow this object to be created with a parent envelope reference
        ''' so that we can manage deleting the accompanying DocumentBody object.
        ''' </summary>
        ''' <remarks>
        ''' When this object is deleted, the associated DocumentBody object will also need to be deleted...
        ''' </remarks>
        ''' <history>
        ''' 	[MINA] 	6/05/2004	Created
        ''' </history>
        '''-----------------------------------------------------------------------------
        Public Sub New()

        End Sub
        Public Sub New(ByVal oParent As ESBEnvelopeProvider)
            m_oParent = oParent
        End Sub

        Public Sub Add(ByVal item As document)
            List.Add(item)
        End Sub

        Public Sub Insert(ByVal index As Integer, ByVal item As document)
            If index > Count Or index < 0 Then
                'ERROR!!!
                Exit Sub
            End If
            List.Insert(index, item)
        End Sub

        Default Public Property Item(ByVal index As Integer) As document
            Get
                Return CType(List.Item(index), document)
            End Get
            Set(ByVal value As document)
                List.Insert(index, value)
            End Set

        End Property

        Protected Overrides Sub OnRemove(ByVal index As Integer, ByVal value As Object)
            'Also remove the appropriate item from the DocumentBodies Collection...
            m_oParent.body.documentBody.RemoveAt(index)
            m_oParent.m_lNumDocs = m_oParent.m_lNumDocs - 1
        End Sub
    End Class
    <System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
    Public Class document
        '<remarks/>
        Public name As String = ""

        '<remarks/>
        Public documentNamespace As String

        '<remarks/>
        Public description As String


    End Class



    '<remarks/>
    <System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
    Public Class manifest
        Friend m_oParent As ESBEnvelopeProvider
        'Private Sub New()
        'End Sub
        '''-----------------------------------------------------------------------------
        ''' <summary>
        ''' Only allow this object to be created with a parent envelope reference
        ''' so that we can manage deleting the accompanying DocumentBody object.
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <history>
        ''' 	[MINA] 	6/05/2004	Created
        ''' </history>
        '''-----------------------------------------------------------------------------
        Public Sub New()

        End Sub
        Public Sub New(ByVal oParent As ESBEnvelopeProvider)
            m_oParent = oParent
            document = New documentCol(m_oParent)
        End Sub

        '<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("document")> _
        Public document As documentCol

        '<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("attachment")> _
        Public attachment As New System.Collections.Generic.List(Of attachment)
    End Class

    '<remarks/>
    <System.Xml.Serialization.XmlTypeAttribute([namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
     System.Xml.Serialization.XmlRootAttribute([namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
    Public Class service

        '<remarks/>
        Public name As String = ""
        '<remarks/>
        Public [namespace] As String = ""
        '<remarks/>
        Public version As String
        '<remarks/>
        Public context As String
        '<remarks/>
        Public description As String

    End Class

    '<remarks/>
    <System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
      System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
     Public Class from
        '<remarks/>
        Public name As String

        '<remarks/>
        Public address As String

        '<remarks/>
        Public state As state

        '<remarks/>
        Public addressType As String

        '<remarks/>
        Public channel As String
    End Class
    '<remarks/>
    <System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
    Public Class state

        '<remarks/>
        Public handle As String

        '<remarks/>
        Public process As String

        '<remarks/>
        Public referenceID As String
    End Class
    '<remarks/>
    <System.Xml.Serialization.XmlTypeAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0"), _
     System.Xml.Serialization.XmlRootAttribute([Namespace]:="urn:keystroke.com.au.esb.envelope.esbEnvelope.version_1_0_7_0", IsNullable:=False)> _
    <Serializable()> _
    Public Class [to]
        '<remarks/>
        Public name As String

        '<remarks/>
        Public address As String

        '<remarks/>
        Public state As state

        '<remarks/>
        Public addressType As String

        '<remarks/>
        Public channel As String
    End Class

    <Serializable()> _
    Public Class custom
        '<remarks/>
        Public name As String

        '<remarks/>
        Public value As String

    End Class

End Namespace