'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Imports System.Xml
Imports System.Xml.Linq

Partial Public Class InlineDocument
    Implements IInlineDocument
    'This is a class that wraps the internal Document object
    'used in envelopes (currently the System.XML.XMLDocument object
    'This class adds some Conversion functions so that we
    'can get the document as certain types.

    'Envelope native type is a XMLDocument object...
    'Adding one of these results in least overhead etc.
    'Adding something else will result in a conversion of some type...
    'Can we have more than one native type???and manage them all...
    'Have a string, a stream, an object... an XMLElement...
    'When it's set, set the appropriate one & work with it...
    'Then,Only during serialization do we need to worry about the details...
    'Problem 1 - how do we serialize?
    '???Problem 2 - At time of adding etc. we must call into the 
    'base envelope implementation's AddDocument() method...
    'The envelope itself will decide upon how to store the document, - YES
    'including conversion etc.? - HMMM??? Yes - Conversion will need to be
    'done by the implementing class??? (which inherits from this class...
    'which means the conversion code can be put in this class...

    'When someone creates an envelope, calls the AddDocument() method etc.
    'passes in a Document od some sort... the InlineDocument in it's constructor 
    'will take the document type...
    'The AddDocument() method will then convert this document to its native
    'type if it so desires (by overriding this base class AddDocument() method...).
    'The implementation in this class will be to...convert to an XMLDocument...if it 
    'needs to...
    'Have this as the native type? & convert between it...
    'Note: 
    'bCopyDocument does not guarantee that the document does not get copied
    'down the line somewhere, as sometimes it is not always possible to 
    'not copy the document upon conversion between types etc.

    '++Currently using:
    Protected m_oXMLDoc As New XmlDocument
    '--Currently using:
    Protected m_oXMLElementDoc As XmlElement
    Protected m_oXMLNodeDoc As XmlNode
    Protected m_oStreamDoc As System.IO.MemoryStream

    Protected m_oXDoc As New XDocument
    Protected m_oObjDoc As Object
    Protected m_sStrDoc As String
    Protected m_oDataSetDoc As New System.Data.DataSet


  
    Enum eActiveDocumentRepresentationFormat
        eNotSet = 0
        eXmlDocument = 1
        eXmlElement = 2
        eXmlNode = 3
        eXDocument = 4
        eStream = 5
        eObject = 6
        eString = 7
        eDataSet = 8
    End Enum

    Private m_eActiveDocumentRepresentationFormat As eActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eNotSet
    Public Property ActiveDocumentRepresentationFormat() As eActiveDocumentRepresentationFormat
        Get
            Return m_eActiveDocumentRepresentationFormat
        End Get
        Set(ByVal value As eActiveDocumentRepresentationFormat)
            m_eActiveDocumentRepresentationFormat = value

            If m_eActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlDocument Then
                'm_oXMLDoc = nothing
                m_oXMLElementDoc = Nothing
                m_oXMLNodeDoc = Nothing
                m_oStreamDoc = Nothing
                m_oXDoc = Nothing
                m_oObjDoc = Nothing
                m_sStrDoc = Nothing
                m_oDataSetDoc = Nothing
                Return
            End If

            If m_eActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlElement Then
                m_oXMLDoc = Nothing
                'm_oXMLElementDoc  = nothing
                m_oXMLNodeDoc = Nothing
                m_oStreamDoc = Nothing
                m_oXDoc = Nothing
                m_oObjDoc = Nothing
                m_sStrDoc = Nothing
                m_oDataSetDoc = Nothing
                Return
            End If

            If m_eActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlNode Then
                m_oXMLDoc = Nothing
                m_oXMLElementDoc = Nothing
                'm_oXMLNodeDoc  = nothing
                m_oStreamDoc = Nothing
                m_oXDoc = Nothing
                m_oObjDoc = Nothing
                m_sStrDoc = Nothing
                m_oDataSetDoc = Nothing
                Return
            End If

            If m_eActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXDocument Then
                m_oXMLDoc = Nothing
                m_oXMLElementDoc = Nothing
                m_oXMLNodeDoc = Nothing
                m_oStreamDoc = Nothing
                'm_oXDoc  = nothing
                m_oObjDoc = Nothing
                m_sStrDoc = Nothing
                m_oDataSetDoc = Nothing
                Return
            End If

            If m_eActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eStream Then
                m_oXMLDoc = Nothing
                m_oXMLElementDoc = Nothing
                m_oXMLNodeDoc = Nothing
                'm_oStreamDoc  = nothing
                m_oXDoc = Nothing
                m_oObjDoc = Nothing
                m_sStrDoc = Nothing
                m_oDataSetDoc = Nothing
                Return
            End If

            If m_eActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eObject Then
                m_oXMLDoc = Nothing
                m_oXMLElementDoc = Nothing
                m_oXMLNodeDoc = Nothing
                m_oStreamDoc = Nothing
                m_oXDoc = Nothing
                'm_oObjDoc  = nothing
                m_sStrDoc = Nothing
                m_oDataSetDoc = Nothing
                Return
            End If

            If m_eActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eString Then
                m_oXMLDoc = Nothing
                m_oXMLElementDoc = Nothing
                m_oXMLNodeDoc = Nothing
                m_oStreamDoc = Nothing
                m_oXDoc = Nothing
                m_oObjDoc = Nothing
                'm_sStrDoc  = nothing
                m_oDataSetDoc = Nothing
                Return
            End If


            If m_eActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eDataSet Then
                m_oXMLDoc = Nothing
                m_oXMLElementDoc = Nothing
                m_oXMLNodeDoc = Nothing
                m_oStreamDoc = Nothing
                m_oXDoc = Nothing
                m_oObjDoc = Nothing
                m_sStrDoc = Nothing
                'm_oDataSetDoc  = nothing
                Return
            End If
        End Set
    End Property

    Public Sub New(ByVal oXMLDoc As XmlDocument, Optional ByVal bCopyDocument As Boolean = False)
        SetDocument(oXMLDoc, bCopyDocument)
    End Sub
    Public Sub New(ByVal oXMLElement As XmlElement, Optional ByVal bCopyDocument As Boolean = False)
        SetDocument(oXMLElement, bCopyDocument)
    End Sub
    Public Sub New(ByVal oXMLNode As XmlNode, Optional ByVal bCopyDocument As Boolean = False)
        SetDocument(oXMLNode, bCopyDocument)
    End Sub
    Public Sub New(ByVal sXMLString As String, Optional ByVal bCopyDocument As Boolean = False)
        SetDocument(sXMLString, bCopyDocument)
    End Sub
    Public Sub New(ByVal oXMLClassWrapper As Object, Optional ByVal bCopyDocument As Boolean = False)
        SetDocument(oXMLClassWrapper, bCopyDocument)
    End Sub
    Public Sub New(ByVal oStream As System.IO.Stream, Optional ByVal bCopyDocument As Boolean = False)
        SetDocument(oStream, bCopyDocument)
    End Sub
    Public Sub New(ByVal oDataSetDoc As System.Data.DataSet, Optional ByVal bCopyDocument As Boolean = False)
        SetDocument(oDataSetDoc, bCopyDocument)
    End Sub

    Public Function GetAsXMLDocument(Optional ByVal bCopyDocument As Boolean = False) As XmlDocument Implements IInlineDocument.GetAsXMLDocument
        ' ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlDocument
        Return ConvertToXmlDocument()
    End Function
    Public Function GetAsXMLElement(Optional ByVal bCopyDocument As Boolean = False) As XmlElement Implements IInlineDocument.GetAsXMLElement
        'ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eObject
        Return ConvertToXmlElement()
    End Function
    Public Function GetAsXMLNode(Optional ByVal bCopyDocument As Boolean = False) As XmlNode Implements IInlineDocument.GetAsXMLNode
        'ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlNode
        Return ConvertToXmlNode()
    End Function
    Public Function GetAsObject(ByVal tType As Type, Optional ByVal bCopyDocument As Boolean = False) As Object Implements IInlineDocument.GetAsObject
        'ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eObject
        Return ConvertToObject(tType, bCopyDocument)
    End Function
    Public Function GetAsObject(Optional ByVal bCopyDocument As Boolean = False) As Object Implements IInlineDocument.GetAsObject
        Throw New NotImplementedException
    End Function
    Public Function GetAsString(Optional ByVal bCopyDocument As Boolean = False) As String Implements IInlineDocument.GetAsString
        'ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eString
        Return ConvertToString()
    End Function
    Public Function GetAsStream(Optional ByVal bCopyDocument As Boolean = False) As System.IO.Stream Implements IInlineDocument.GetAsStream
        'ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eStream
        Return ConvertToStream()
    End Function

    Public Function GetAsDataSet(Optional ByVal bCopyDocument As Boolean = False) As System.Data.DataSet Implements IInlineDocument.GetAsDataSet
        'ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eDataSet
        Return ConvertToDataSet()
    End Function


    'sometimes... need to make a copy of this...!!!
    Public Function SetDocument(ByVal oXMLDocument As XmlDocument, Optional ByVal bCopyDocument As Boolean = False) As Long Implements IInlineDocument.SetDocument
        m_oXMLDoc = oXMLDocument
        ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlDocument
        Return 1
    End Function
    Public Function SetDocument(ByVal oXMLElement As XmlElement, Optional ByVal bCopyDocument As Boolean = False) As Long Implements IInlineDocument.SetDocument
        m_oXMLElementDoc = oXMLElement
        ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlElement
        Return 1
    End Function
    Public Function SetDocument(ByVal oXMLNode As XmlNode, Optional ByVal bCopyDocument As Boolean = False) As Long Implements IInlineDocument.SetDocument
        m_oXMLNodeDoc = oXMLNode
        ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlNode
        Return 1
    End Function

    Public Function SetDocument(ByVal obj As Object, Optional ByVal bCopyDocument As Boolean = False) As Long Implements IInlineDocument.SetDocument
        m_oObjDoc = obj
        ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eObject
        Return 1
    End Function
    Public Function SetDocument(ByVal sXMLDoc As String, Optional ByVal bCopyDocument As Boolean = False) As Long Implements IInlineDocument.SetDocument
        m_sStrDoc = sXMLDoc
        ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eString
        Return 1
    End Function
    Public Function SetDocument(ByVal oStream As System.IO.Stream, Optional ByVal bCopyDocument As Boolean = False) As Long Implements IInlineDocument.SetDocument
        m_oStreamDoc = oStream
        ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eStream
        Return 1
    End Function
    Public Function SetDocument(ByVal oDataSet As System.Data.DataSet, Optional ByVal bCopyDocument As Boolean = False) As Long Implements IInlineDocument.SetDocument
        m_oDataSetDoc = oDataSet
        ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eDataSet
        Return 1
    End Function
    Public Overrides Function ToString() As String Implements IInlineDocument.ToString
        Return Me.GetAsString()
    End Function

    Public Shared Widening Operator CType(ByVal oInlineDoc As InlineDocument) As XmlDocument
        Return oInlineDoc.m_oXMLDoc
    End Operator

    Public Shared Widening Operator CType(ByVal oXmlDoc As XmlDocument) As InlineDocument
        Return New InlineDocument(oXmlDoc)
    End Operator
    'Public Shared Narrowing Operator CType(ByVal oInlineDoc As InlineDocument) As XmlDocument
    '    Return oInlineDoc.m_oXMLDoc
    'End Operator

    'Public Shared Narrowing Operator CType(ByVal oXmlDoc As XmlDocument) As InlineDocument
    '    Return New InlineDocument(oXmlDoc)
    'End Operator
End Class



Partial Public Class InlineDocument
    'Looks at current type & converts from it to the target type accordingly.
    '...optimizing for certain scenarios as required.
    'By default, converts to XMLDocument as a canonical, then to the target.
    'Optimizations then override this...

    'Once setup, this then requires the SetDocument methods to be changes to just save to the type passed in, rathen than 
    'to currently convert to XMLDocument...    They also need to set other representations to nothing/empty...

    Function ConvertToXmlDocument() As XmlDocument
        'Convert from: 
        '+XMLDocument, ? XDocument, +Object, +String, DataSet, +XMLElement, +XMLNode, Stream...
        'To XMLDocument...
        Try


        'From XMLDocument
        If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlDocument Then
            Return m_oXMLDoc
        End If

        'From String
        If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eString Then
            m_oXMLDoc = New XmlDocument
            m_oXMLDoc.LoadXml(m_sStrDoc)
            Return m_oXMLDoc
        End If

        'From Object (To string, then to XMLDocument)
        If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eObject Then
            Dim sXMLDoc As String
            Dim oEnv As New ESBEnvelope.Envelope
            sXMLDoc = oEnv.Serialize(m_oObjDoc)

            m_oXMLDoc = New XmlDocument
                m_oXMLDoc.LoadXml(sXMLDoc)
            Return m_oXMLDoc
        End If

        'From XMLElement (To string, then to XMLDocument)
        If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlElement Then
            m_oXMLDoc = New XmlDocument
            m_oXMLDoc.LoadXml(m_oXMLElementDoc.OuterXml)
            Return m_oXMLDoc
        End If

        'From XMLNode (To string, then to XMLDocument)
        If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlNode Then
            'Cheat by serializing & deserializing...slow.. need to find better way...
            'try converting...?XMLNode to XMLDocument somehow...
            m_oXMLDoc = New XmlDocument
            m_oXMLDoc.LoadXml(m_oXMLNodeDoc.OuterXml)
            Return m_oXMLDoc
        End If

        'From Stream
        If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eStream Then
            m_oXMLDoc = New XmlDocument
            m_oStreamDoc.Position = 0
            m_oXMLDoc.Load(m_oStreamDoc)
            Return m_oXMLDoc
        End If

        'From DataSet (To stream, then to XMLDocument)
        If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eDataSet Then
            m_oXMLDoc = New XmlDocument
            Dim oStream As New System.IO.MemoryStream()
            m_oDataSetDoc.WriteXml(oStream)
            oStream.Position = 0
            m_oXMLDoc.Load(oStream)
            Return m_oXMLDoc
        End If

        'From XDocument
        If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXDocument Then
            'TODO - implement this
            Throw New NotImplementedException()
        End If

        'Catch all...
            Return Nothing 'Error!!!

        Finally
            ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlDocument
        End Try


    End Function

    Function ConvertToXmlElement() As XmlElement
        Throw New NotImplementedException()
    End Function

    Function ConvertToXmlNode() As XmlNode
        Throw New NotImplementedException()
    End Function

    Function ConvertToString() As String
        Try
            'Convert from: 
            '+XMLDocument, XDocument, +Object, +String, DataSet, XMLElement, XMLNode, Stream...
            'To String...

            'From XMLDocument (To String, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlDocument Then
                Dim oXMLUtil As New XMLUtil
                m_sStrDoc = oXMLUtil.GetXMLAsString(m_oXMLDoc)
                Return m_sStrDoc
            End If

            'From String
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eString Then
                Return m_sStrDoc
            End If

            'From Object
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eObject Then
                Dim oXMLUtil As New XMLUtil
                m_sStrDoc = oXMLUtil.Serialize(m_oObjDoc)
                Return m_sStrDoc

            End If

            'From XMLElement (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlElement Then
                Dim oXMLUtil As New XMLUtil
                m_sStrDoc = m_oXMLElementDoc.OuterXml
                Return m_sStrDoc
            End If

            'From XMLNode (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlNode Then
                Dim oXMLUtil As New XMLUtil
                m_sStrDoc = m_oXMLNodeDoc.OuterXml
                Return m_sStrDoc
            End If

            'From Stream (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eStream Then
                m_sStrDoc = XMLUtil.StreamToString(m_oStreamDoc)
                Return m_sStrDoc
            End If

            'From DataSet (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eDataSet Then
                Dim oXMLUtil As New XMLUtil
                m_sStrDoc = oXMLUtil.GetDatasetAsString(m_oDataSetDoc)
                Return m_sStrDoc
            End If

            'From XDocument
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXDocument Then
                'TODO - implement this
                Throw New NotImplementedException()
            End If

            'Catch all...
            Return Nothing
        Finally
            ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eString
        End Try

    End Function

    Function ConvertToStream() As System.IO.Stream
        Try
            'Convert from: 
            '+XMLDocument, XDocument, +Object, +String, DataSet, XMLElement, XMLNode, Stream...
            'To Stream...

            'From XMLDocument (To String, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlDocument Then
                m_oStreamDoc = New System.IO.MemoryStream
                m_oXMLDoc.Save(m_oStreamDoc)
                m_oStreamDoc.Position = 0
                Return m_oStreamDoc
            End If

            'From String
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eString Then
                Dim oXMLUtil As New XMLUtil
                m_oStreamDoc = XMLUtil.StringToStream(m_sStrDoc)
                Return m_oStreamDoc
            End If

            'From Object (To string, then to Stream)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eObject Then
                Dim oXMLUtil As New XMLUtil
                m_oStreamDoc = XMLUtil.StringToStream(oXMLUtil.Serialize(m_oObjDoc))
                Return m_oStreamDoc
            End If

            'From XMLElement (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlElement Then
                Dim oXMLUtil As New XMLUtil
                m_oStreamDoc = XMLUtil.StringToStream(m_oXMLElementDoc.OuterXml)
                Return m_oStreamDoc
            End If

            'From XMLNode (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlNode Then
                Dim oXMLUtil As New XMLUtil
                m_oStreamDoc = XMLUtil.StringToStream(m_oXMLNodeDoc.OuterXml)
                Return m_oStreamDoc
            End If

            'From Stream (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eStream Then
                Return m_oStreamDoc
            End If

            'From DataSet (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eDataSet Then
                Dim oXMLUtil As New XMLUtil
                m_oStreamDoc = XMLUtil.StringToStream(oXMLUtil.GetDatasetAsString(m_oDataSetDoc))
                Return m_oStreamDoc
            End If

            'From XDocument
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXDocument Then
                'TODO - implement this
                Throw New NotImplementedException()
            End If

            'Catch all...
            Return Nothing

        Finally
            ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eStream
        End Try

    End Function

    Function ConvertToXDocument() As XDocument
        Throw New NotImplementedException
    End Function

    Function ConvertToDataSet() As System.Data.DataSet
        Try

            'Convert from: 
            '+XMLDocument, XDocument, +Object, +String, DataSet, XMLElement, XMLNode, Stream...
            'To Dataset...

            'From XMLDocument (To String, then to Stream, then to Dataset)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlDocument Then
                'TODO: re-visit this for optimization

                Dim oXMLUtil As New XMLUtil
                m_oStreamDoc = XMLUtil.StringToStream(oXMLUtil.GetXMLAsString(m_oXMLDoc))
                m_oStreamDoc.Position = 0
                m_oDataSetDoc = New Data.DataSet
                m_oDataSetDoc.ReadXml(m_oStreamDoc)

                Return m_oDataSetDoc
            End If

            'From String  (To stream, to Dataset)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eString Then

                m_oStreamDoc = XMLUtil.StringToStream(m_sStrDoc)
                m_oStreamDoc.Position = 0
                m_oDataSetDoc = New Data.DataSet
                m_oDataSetDoc.ReadXml(m_oStreamDoc)

                Return m_oDataSetDoc
            End If

            'From Object   (To String, then to Stream, then to Dataset)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eObject Then
                'TODO: re-visit this for optimization
                Dim oXMLUtil As New XMLUtil
                m_oStreamDoc = XMLUtil.StringToStream(oXMLUtil.Serialize(m_oObjDoc))
                m_oStreamDoc.Position = 0
                m_oDataSetDoc = New Data.DataSet
                m_oDataSetDoc.ReadXml(m_oStreamDoc)
                Return m_oDataSetDoc

            End If

            'From XMLElement  (To String, then to Stream, then to Dataset)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlElement Then
                'TODO: re-visit this for optimization
                Dim oXMLUtil As New XMLUtil
                m_oStreamDoc = XMLUtil.StringToStream(m_oXMLElementDoc.OuterXml)
                m_oStreamDoc.Position = 0
                m_oDataSetDoc = New Data.DataSet
                m_oDataSetDoc.ReadXml(m_oStreamDoc)
                Return m_oDataSetDoc

            End If

            'From XMLNode  (To String, then to Stream, then to Dataset)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlNode Then
                'TODO: re-visit this for optimization
                Dim oXMLUtil As New XMLUtil
                m_oStreamDoc = XMLUtil.StringToStream(m_oXMLNodeDoc.OuterXml)
                m_oStreamDoc.Position = 0
                m_oDataSetDoc = New Data.DataSet
                m_oDataSetDoc.ReadXml(m_oStreamDoc)
                Return m_oDataSetDoc
            End If

            'From Stream (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eStream Then
                m_oStreamDoc = New System.IO.MemoryStream
                m_oXMLDoc.Save(m_oStreamDoc)
                m_oStreamDoc.Position = 0
                m_oDataSetDoc = New Data.DataSet
                m_oDataSetDoc.ReadXml(m_oStreamDoc)

                Return m_oDataSetDoc
            End If

            'From DataSet (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eDataSet Then
                Return m_oDataSetDoc
            End If

            'From XDocument
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXDocument Then
                'TODO - implement this
                Throw New NotImplementedException()
            End If

            'Catch all...
            Return Nothing

        Finally
            ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eDataSet
        End Try

    End Function

    Function ConvertToObject(ByVal tType As Type, Optional ByVal bCopyDocument As Boolean = False) As Object
        Try
            'Convert from: 
            '+XMLDocument, XDocument, +Object, +String, DataSet, XMLElement, XMLNode, Stream...
            'To Object...

            'From XMLDocument (To String, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlDocument Then
                Dim oXMLUtil As New XMLUtil
                m_oObjDoc = oXMLUtil.DeSerialize(oXMLUtil.GetXMLAsString(m_oXMLDoc), tType)
                Return m_oObjDoc
            End If

            'From String
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eString Then
                Dim oXMLUtil As New XMLUtil
                m_oObjDoc = oXMLUtil.DeSerialize(m_sStrDoc, tType)
                Return m_oObjDoc
            End If

            'From Object
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eObject Then
                'If we've previously stored this document as an object, and the type of document we're looking at 
                'deserialising into is the same as the stored document type, then just return the stored document type.
                'Otherwise, deserialise...

                'Also, if we've said "bCopyDocument=True" (this means do a deep copy), then don't return a reference to a cached 
                'document, deserialise again...
                If Not m_oObjDoc Is Nothing And bCopyDocument = False Then
                    If m_oObjDoc.GetType = tType Then
                        Return m_oObjDoc
                    End If
                End If

                Dim oXMLUtil As New XMLUtil
                m_oObjDoc = oXMLUtil.DeSerialize(oXMLUtil.GetXMLAsString(m_oXMLDoc), tType)
                Return m_oObjDoc

            End If

            'From XMLElement (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlElement Then
                Dim oXMLUtil As New XMLUtil
                m_oObjDoc = oXMLUtil.DeSerialize(m_oXMLElementDoc.OuterXml, tType)
                Return m_oObjDoc
            End If

            'From XMLNode (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXmlNode Then
                Dim oXMLUtil As New XMLUtil
                m_oObjDoc = oXMLUtil.DeSerialize(m_oXMLNodeDoc.OuterXml, tType)
                Return m_oObjDoc
            End If

            'From Stream (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eStream Then
                Dim oXMLUtil As New XMLUtil
                Dim enc As System.Text.Encoding = System.Text.Encoding.UTF8
                m_oObjDoc = oXMLUtil.DeSerialize(enc.GetString(m_oStreamDoc.ToArray()), tType)
                Return m_oObjDoc
            End If

            'From DataSet (To string, then to Object)
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eDataSet Then
                Dim oXMLUtil As New XMLUtil
                m_oObjDoc = oXMLUtil.DeSerialize(oXMLUtil.GetDatasetAsString(m_oDataSetDoc), tType)
                Return m_oObjDoc
            End If

            'From XDocument
            If ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eXDocument Then
                'TODO - implement this
                Throw New NotImplementedException()
            End If

            'Catch all...
            Return Nothing

        Finally
            ActiveDocumentRepresentationFormat = eActiveDocumentRepresentationFormat.eObject
        End Try

    End Function

End Class

