﻿'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Strict Off ' leave it off - otherwise you need to do CType casts everywhere!!!
Option Explicit On

Imports System.Xml.Serialization
Imports System
Imports System.Xml
Imports System.Xml.Xsl
Imports System.IO
Imports Microsoft.VisualBasic
Imports System.Reflection
Imports ESB.Core.XMLSchemaClasses.ESBEnvelope
'imports ESB.
Imports Wintellect.PowerCollections

Namespace JSKEnvelope
    <Serializable()> _
    Public Class JSKEnvelope : Inherits ESBEnvelope.EnvelopeBase
        'The number of documents in the docEnvelope
        Private lNumDocs As Long = 0
        Private m_doc As New XmlDocument
        '<remarks/>
        'The header object. This gets serialized for us by the serialization support
        'Note that if the body element was one level deeper, we'd be able to take advantage of
        'the serialization support for that node, as well as thw whole class! Would have made my life simpler!
        Public header As New header
        Protected docEnvelope As New System.Xml.XmlDocument
        Protected elBiztalk_1 As XmlElement
        Protected elHeader As System.Xml.XmlElement
        Protected elBody As System.Xml.XmlElement
        Protected elSubject As System.Xml.XmlElement

        Public Shared ReadOnly m_csEnvelopeName As String = "ESB.Core.XMLSchemaClasses.JSKEnvelope.JSKEnvelope"

        '++NEW
        'Declare these properties with the XmlIgnoreAttribute in the implementing envelope classes...

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property ToAddress() As String
            Get
                Return Trim(Me.header.delivery.to.address)
            End Get
            Set(ByVal value As String)
                Me.header.delivery.to.address = Trim(value)
            End Set
        End Property
        '<System.Xml.Serialization.XmlIgnore()> _
        'Public Overrides Property ToAddressType() As String
        '    Get
        'CUSTOM PARAM!!!& ToAddressType...URL ...
        '        Return Me.header.delivery.to.addressType
        '    End Get
        '    Set(ByVal Value As String)
        '        Me.header.delivery.to.addressType = Value
        '    End Set
        'End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property FromAddress() As String
            Get
                Return Trim(Me.header.delivery.from.address)
            End Get
            Set(ByVal value As String)
                Me.header.delivery.from.address = Trim(value)
            End Set
        End Property
        '<System.Xml.Serialization.XmlIgnore()> _
        'Public Overrides Property FromAddressType() As String
        '    Get
        'CUSTOM PARAM!!!& ToAddressType...URL ...
        '        Return Me.header.delivery.from.addressType
        '    End Get
        '    Set(ByVal Value As String)
        '        Me.header.delivery.from.addressType = Value
        '    End Set
        'End Property

        <System.Xml.Serialization.XmlIgnore()> _
      Public Overrides Property ConversationID() As String
            Get
                If Me.header.delivery Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.to Is Nothing Then
                    Return ""
                End If
                If Me.header.delivery.to.state Is Nothing Then
                    Return ""
                End If
                Return Me.header.delivery.to.state.process
            End Get
            Set(ByVal Value As String)
                If Me.header.delivery Is Nothing Then
                    Me.header.delivery = New delivery
                End If
                If Me.header.delivery.to Is Nothing Then
                    Me.header.delivery.to = New [to]
                End If
                If Me.header.delivery.to.state Is Nothing Then
                    Me.header.delivery.to.state = New state
                End If
                Me.header.delivery.to.state.process = Trim(Value)
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property MessageID() As String
            Get
                Return Trim(Me.header.delivery.message.messageID)
            End Get
            Set(ByVal Value As String)
                Me.header.delivery.message.messageID = Trim(Value)
            End Set
        End Property
        Public Overrides Property InternalMessageID() As String
            Get
                Return Me.GetCustomParam(C_sCustomParamESBCore, C_sCustomParamUniqueID)
            End Get
            Set(ByVal Value As String)
                Me.SetCustomParam(C_sCustomParamESBCore, C_sCustomParamUniqueID, Trim(Value))
            End Set
        End Property
        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property Environment() As String
            Get
                Dim sRefID As String
                sRefID = ""
                Try
                    If Not header.delivery.from.state.referenceID Is Nothing Then
                        sRefID = header.delivery.from.state.referenceID
                    End If
                    Return sRefID
                Catch
                    Return sRefID
                Finally

                End Try

            End Get
            Set(ByVal value As String)
                If header Is Nothing Then
                    'we have a big problem!
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Header is Nothing!")
                End If
                If header.delivery Is Nothing Then
                    header.delivery = New delivery
                End If
                If header.delivery.from Is Nothing Then
                    header.delivery.from = New from
                End If
                If header.delivery.from.state Is Nothing Then
                    header.delivery.from.state = New state
                End If

                header.delivery.from.state.referenceID = value

            End Set
        End Property
        'Systems not directly supported by JSK Envelope
        'Put into Custom Params etc...
        '<System.Xml.Serialization.XmlIgnore()> _
        'Public Overrides Property SystemName() As String
        '    Get
        '        Return Me.header.Systems(0).SystemID
        '    End Get
        '    Set(ByVal Value As String)
        '        Me.header.Systems(0).SystemID = Value
        '    End Set
        'End Property
        '<System.Xml.Serialization.XmlIgnore()> _
        'Public Overrides Property SystemType() As String
        '    Get
        '        Return Me.header.Systems(0).SystemType
        '    End Get
        '    Set(ByVal Value As String)
        '        Me.header.Systems(0).SystemType = Value
        '    End Set
        'End Property
        '<System.Xml.Serialization.XmlIgnore()> _
        'Public Overrides Property SystemVersion() As String
        '    Get
        '        Return Me.header.Systems(0).SystemVersion
        '    End Get
        '    Set(ByVal Value As String)
        '        Me.header.Systems(0).SystemVersion = Value
        '    End Set
        'End Property
        '--Routing


        '--NEW



        '++Old

        'Helper Accessors
        'Public Overrides Property FromAddress() As String
        '    Get
        '        Return header.delivery.from.address
        '    End Get
        '    Set(ByVal value As String)
        '        header.delivery.from.address = value
        '    End Set
        'End Property
        'Public Overrides Property ToAddress() As String
        '    Get
        '        Return header.delivery.to.address
        '    End Get
        '    Set(ByVal value As String)
        '        header.delivery.to.address = value
        '    End Set
        'End Property
        Public Property FromReferenceID() As String
            Get
                Dim sRefID As String
                sRefID = ""
                Try
                    If Not header.delivery.from.state.referenceID Is Nothing Then
                        sRefID = header.delivery.from.state.referenceID
                    End If
                    Return Trim(sRefID)
                Catch
                    Return sRefID
                Finally

                End Try

            End Get
            Set(ByVal value As String)
                If header Is Nothing Then
                    'we have a big problem!
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Header is Nothing!")
                End If
                If header.delivery Is Nothing Then
                    header.delivery = New delivery
                End If
                If header.delivery.from Is Nothing Then
                    header.delivery.from = New from
                End If
                If header.delivery.from.state Is Nothing Then
                    header.delivery.from.state = New state
                End If

                header.delivery.from.state.referenceID = Trim(value)

            End Set
        End Property
        Public Property ToReferenceID() As String
            Get
                Dim sRefID As String
                sRefID = ""
                Try
                    If Not header.delivery.to.state.referenceID Is Nothing Then
                        sRefID = header.delivery.to.state.referenceID
                    End If
                    Return Trim(sRefID)
                Catch
                    Return sRefID
                Finally

                End Try
            End Get
            Set(ByVal value As String)

                If header Is Nothing Then
                    'we have a big problem!
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Header is Nothing!")
                End If
                If header.delivery Is Nothing Then
                    header.delivery = New delivery
                End If
                If header.delivery.to Is Nothing Then
                    header.delivery.to = New [to]
                End If
                If header.delivery.to.state Is Nothing Then
                    header.delivery.to.state = New state
                End If

                header.delivery.to.state.referenceID = Trim(value)
            End Set
        End Property

        '--Old

        'Constructor
        Public Sub New()
            Dim xmldecl As XmlDeclaration

            xmldecl = docEnvelope.CreateXmlDeclaration("1.0", "utf-8", "yes")
            docEnvelope.InsertBefore(xmldecl, docEnvelope.DocumentElement)
            elBiztalk_1 = docEnvelope.CreateElement("biztalk_1")
            elBody = docEnvelope.CreateElement("body")
        End Sub

        '++ IEnvelope overrides...
        Public Overloads Overrides Function AddDocument(ByVal oEnvDoc As IInlineDocument, Optional ByVal bCopyDocument As Boolean = False) As Long
            Return AddDocumentInternal(oEnvDoc.GetAsXMLDocument())
        End Function
        Public Overloads Overrides Function AddDocument(ByVal oEnvDoc As IInlineDocument, ByVal lDocumentIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As Long
            Return AddDocumentInternal(oEnvDoc.GetAsXMLDocument(), lDocumentIndex)
        End Function
        'By default, work with references to the documents - this is best for performance...
        Public Overloads Overrides Function GetDocument(ByVal lIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Return New InlineDocument(GetDocumentInternal(lIndex, bCopyDocument), bCopyDocument)
        End Function
        Public Overloads Overrides Function GetDocument(ByVal sDocumentName As String, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Return New InlineDocument(GetDocumentInternal(sDocumentName, bCopyDocument), bCopyDocument)
        End Function
        Public Overloads Overrides Function GetDocument(ByVal sDocumentName As String, ByVal lIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Return New InlineDocument(GetDocumentInternal(sDocumentName, lIndex, bCopyDocument), bCopyDocument)
        End Function
        Public Overloads Overrides Function GetDocument(ByVal sDocumentName As String, ByVal lIndex As Long, ByRef lReturnedDocIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As IInlineDocument
            Return New InlineDocument(GetDocumentInternal(sDocumentName, lIndex, False, lReturnedDocIndex), bCopyDocument)
        End Function

        '-- IEnvelope overrides...
        Public Overloads Function AddDocumentInternal(ByVal sXMLDoc As String) As Long
            m_doc.LoadXml(sXMLDoc)
            Return AddDocumentInternal(m_doc)

        End Function
        Public Overloads Function AddDocumentInternal(ByVal sXMLDoc As String, ByVal lDocumentIndex As Long) As Long
            m_doc.LoadXml(sXMLDoc)
            Return AddDocumentInternal(m_doc, lDocumentIndex)

        End Function
        Public Overloads Function AddDocumentInternal(ByVal oXMLClassWrapperObj As Object) As Long
            'Currently, I only know how to serialize & pass the XML on to AddDocumentToEnvelope(byval sXMLDoc As String)
            'Later, I'll try & figure out a way to have the document attached & still be able to modify it!
            Dim sXMLDoc As String
            sXMLDoc = Serialize(oXMLClassWrapperObj)

            Return AddDocumentInternal(sXMLDoc)
        End Function
        Public Overloads Function AddDocumentInternal(ByVal oXMLClassWrapperObj As Object, ByVal lDocumentIndex As Long) As Long
            'Currently, I only know how to serialize & pass the XML on to AddDocumentToEnvelope(byval sXMLDoc As String)
            'Later, I'll try & figure out a way to have the document attached & still be able to modify it!
            Dim sXMLDoc As String
            sXMLDoc = Serialize(oXMLClassWrapperObj)

            Return AddDocumentInternal(sXMLDoc, lDocumentIndex)
        End Function
        Public Overloads Function AddDocumentInternal(ByVal oXmlDocument As XmlDocument, Optional ByVal bCopyDocument As Boolean = False) As Long

            Dim y As New XmlDocument
            Dim oNL As XmlNodeList
            Dim df As XmlDocumentFragment

            df = docEnvelope.CreateDocumentFragment
            oNL = oXmlDocument.SelectNodes("/*")

            Dim oEnvNL As XmlNode

            Dim l As Long
            For l = 1 To oNL.Count
                If oNL(l - 1).Name <> "xml" Then
                    oEnvNL = docEnvelope.ImportNode(oNL(l - 1), True)
                    df.AppendChild(oEnvNL)
                End If
            Next

            elBody.AppendChild(df.FirstChild)

            lNumDocs += 1

            header.manifest.document(lNumDocs - 1) = New document
            header.manifest.document(lNumDocs - 1).description = oEnvNL.NamespaceURI
            header.manifest.document(lNumDocs - 1).name = oEnvNL.Name

            'lNumDocs += 1
            Return lNumDocs - 1 'return the document index - zero based

        End Function
        Public Overloads Function AddDocumentInternal(ByVal oXmlDocument As XmlDocument, ByVal lDocumentIndex As Long, Optional ByVal bCopyDocument As Boolean = False) As Long

            Dim y As New XmlDocument
            Dim oNL As XmlNodeList
            Dim df As XmlDocumentFragment

            df = docEnvelope.CreateDocumentFragment
            oNL = oXmlDocument.SelectNodes("/*")

            Dim oEnvNL As XmlNode

            Dim l As Long
            For l = 1 To oNL.Count
                If oNL(l - 1).Name <> "xml" Then
                    oEnvNL = docEnvelope.ImportNode(oNL(l - 1), True)
                    df.AppendChild(oEnvNL)
                End If
            Next

            Dim oNode As XmlNode

            'Get the document at the current index, and insert the new one before it.
            'If there's no documents at the moment, then just append
            If elBody.ChildNodes.Count = 0 Then
                elBody.AppendChild(df.FirstChild)
            Else
                oNode = elBody.ChildNodes(lDocumentIndex)
                elBody.InsertBefore(df.FirstChild, oNode)
            End If


            lNumDocs += 1

            header.manifest.document.Insert(lDocumentIndex, New document)
            header.manifest.document(lDocumentIndex).description = oEnvNL.NamespaceURI
            header.manifest.document(lDocumentIndex).name = oEnvNL.Name

            Return lNumDocs - 1 'return the document index - zero based

        End Function

        Public Overloads Function GetDocumentInternal(ByVal lIndex As Long, ByVal bGetDocAsElement As Boolean) As XmlElement
            'we have a zero based array
            'valid indexes are 0 to (lNumDocs -1)
            If 0 <= lIndex < lNumDocs Then
                Return elBody.ChildNodes(lIndex)
            Else
                'throw an exception...
                Return Nothing
            End If
        End Function
        Public Overloads Function GetDocumentInternal(ByVal lIndex As Long) As String
            'we have a zero based array
            'valid indexes are 0 to (lNumDocs -1)
            If 0 <= lIndex < lNumDocs Then
                Return elBody.ChildNodes(lIndex).OuterXml.ToString
            Else
                'throw an exception...
                Return ""
            End If
        End Function
        Public Overloads Function GetDocumentInternal(ByVal lIndex As Long, ByVal tType As Type) As Object
            Dim sXMLDoc As String

            'Get the appropriate document out of the docEnvelope
            sXMLDoc = GetDocumentInternal(lIndex)

            'Attempt to Deserialize it to the requested type & return it
            Return DeSerialize(sXMLDoc, tType)

        End Function

        Public Overrides Function DocumentCount() As Long
            'Starts off zero, when you add a document, this gets incremented...
            Return lNumDocs
        End Function
        Public Overrides Function AddAttachment(Optional ByVal sAttachmentName As String = "", Optional ByVal sAttachmentPath As String = "", Optional ByVal lIndex As Long = 0, Optional ByVal sType As String = "", Optional ByVal sUrl As String = "") As Long
            'todo: test
            Dim oAtt As New attachment
            With oAtt
                .description = sAttachmentName
                .filename = sAttachmentPath
                .index = lIndex
                .type = sType
                .url = sUrl
            End With

            header.manifest.attachment.Add(oAtt)

        End Function
        Public Overrides Function GetAttachment(ByVal lIndex As Long) As IAttachment
            Return header.manifest.attachment(lIndex)
        End Function
        Public Overrides Function GetAttachments() As System.Collections.Generic.IList(Of IAttachment)
            Return Algorithms.TypedAs(Of IAttachment)(Me.header.manifest.attachment)
        End Function
        Public Overrides Function GetCustomParams() As IList
            Return Nothing ' CType(header.custom, IList)
        End Function

        Public Overrides Sub ClearCustomParams()
            header.delivery.message.subject = Nothing
        End Sub

        Public Overrides Function GetDocuments() As System.Collections.Generic.IList(Of IInlineDocument)
            'Return CType(header.manifest.document, IList)
            Return Algorithms.TypedAs(Of IInlineDocument)(Me.header.manifest.document)

        End Function

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides ReadOnly Property AttachmentsExist() As Boolean
            Get
                'If m_AttachmentsIf.m_AttachmentCol.Count > 0 Then
                If header.manifest.attachment.Count > 0 Then
                    Return True
                Else
                    Return False
                End If
            End Get
        End Property



        Public Overrides Function ToXML() As String
            Dim s As String
            AddHeaderToEnvelope()

            Dim attr As XmlAttribute

            'Not needed for backwards compatibility
            'Also, it screws this class up when we do a FromXML - the header spews
            'somehow, it gets this namespace added to the header & the header
            'deserialization spews! SO LEAVE IT OUT!!!
            '++
            attr = docEnvelope.CreateAttribute("xmlns")
            attr.Value = "urn:schemas-biztalk-org:biztalk:biztalk_1"
            docEnvelope.DocumentElement.Attributes.Append(attr)
            '--

            '++This spits out UTF-16 !!! in the XML Declaration - best leave it blank
            'The code that replaces this below does just that!
            'Dim w As New StringWriter()
            'docEnvelope.Save(w)
            's = w.ToString()
            '--This 

            Dim w As New StringWriter
            Dim mystream As New System.IO.MemoryStream

            'Dim writer As New XmlTextWriter(mystream, System.Text.UTF8Encoding.UTF8)

            'This part determines what encoding type to put in the XML Declaration
            Dim writer As New XmlTextWriter(mystream, Nothing)
            docEnvelope.Save(writer)
            's = writer.ToString()

            'This part determines the actual encoding type - use ASCII here, or UTF-8 etc.
            'Dim encoding As System.Text.Encoding = System.Text.Encoding.ASCII '.UTF8
            Dim encoding As System.Text.Encoding = System.Text.Encoding.UTF8  '.UTF8

            's = encoding.GetString(mystream.ToArray())
            s = encoding.UTF8.GetString(mystream.ToArray())

            Return s
        End Function
        Public Overrides Function ToXMLDocument() As XmlDocument
            Dim oXmlDoc As New Xml.XmlDocument
            oXmlDoc.LoadXml(ToXML)
            Return oXmlDoc
        End Function
        Public Overrides Sub FromXMLDocument(ByVal oXML As XmlDocument)
            Me.FromXML(oXML.OuterXml)
        End Sub
        Public Overrides Sub FromXML(ByVal sXML As String) 'As Envelope
            If sXML = "" Then
                Throw New Exception("Received an empty string instead of an envelope.")
            End If

            Dim sWhiteSpaceStrippedXML As String

            '++Get rid of all that whitespace!!!
            sWhiteSpaceStrippedXML = Replace(sXML, vbCrLf, "", , , CompareMethod.Binary)
            sWhiteSpaceStrippedXML = Replace(sWhiteSpaceStrippedXML, vbTab, "", , , CompareMethod.Binary)
            '--Get rid of all that whitespace!!!

            'Start

            Dim oXMLDoc As New XmlDocument
            oXMLDoc.PreserveWhitespace = False
            oXMLDoc.LoadXml(sWhiteSpaceStrippedXML)

            sWhiteSpaceStrippedXML = oXMLDoc.OuterXml()

            Dim sEnvelopeWithoutURI As String

            'sEnvelopeWithoutURI = Replace(sXML, oXMLDoc.DocumentElement.NamespaceURI(), "", , , CompareMethod.Text)
            Dim sStringToReplace As String
            sStringToReplace = "xmlns=""" & oXMLDoc.DocumentElement.NamespaceURI() & """"
            sEnvelopeWithoutURI = Replace(sWhiteSpaceStrippedXML, sStringToReplace, "", , , CompareMethod.Text)

            'remove:==>  xmlns=""
            sStringToReplace = "xmlns="""""
            sEnvelopeWithoutURI = Replace(sEnvelopeWithoutURI, sStringToReplace, "", , , CompareMethod.Text)

            docEnvelope.LoadXml(sEnvelopeWithoutURI)

            'Dim nsmgr As XmlNamespaceManager = New XmlNamespaceManager(docEnvelope.NameTable)
            'nsmgr.AddNamespace("bt", "urn:schemas-biztalk-org:biztalk:biztalk_1")

            'Select and display the value of all the ISBN attributes.
            Dim root As XmlElement = docEnvelope.DocumentElement
            elSubject = root.SelectSingleNode("/biztalk_1/header/delivery/message/subject/custom")
            'elSubject = root.SelectSingleNode("/biztalk_1/header/delivery/message/subject")


            'will select the biztalk/header node! ignoring namespaces...
            'Me.elHeader = docEnvelope.SelectSingleNode("/descendant::*/descendant::*")
            Me.elHeader = root.SelectSingleNode("/biztalk_1/header")

            'Need to point the body node to the correct place as well!!!
            'elBody = docEnvelope.SelectSingleNode("/descendant::body")
            elBody = root.SelectSingleNode("/biztalk_1/body")
            lNumDocs = elBody.ChildNodes.Count
            '++MINA - remove Namespaces for DeSerialization!???
            Dim sHeaderWithoutURI As String

            sHeaderWithoutURI = Replace(Me.elHeader.OuterXml, docEnvelope.DocumentElement.NamespaceURI(), "", , , CompareMethod.Text)
            header = DeSerialize(sHeaderWithoutURI, GetType(header))

            If Not elSubject Is Nothing Then

                header.delivery.message.subject = elSubject
                'Dim doc As New XmlDocument()
                'header.delivery.message.subject = doc.CreateElement("custom")

                'Dim oNode As System.Xml.XmlElement
                'For Each oNode In elSubject.ChildNodes

                '    header.delivery.message.subject.AppendChild(oNode)
                'Next
            End If



            'Need to add the documents to the header in the envelope?

        End Sub
        Public Overrides Function ToString() As String
            Return ToXML()
        End Function
        Public Overrides Function Serialize(ByVal oObjectToSerialize As System.Object) As String
            Dim oSer As System.Xml.Serialization.XmlSerializer
            oSer = New XmlSerializer(oObjectToSerialize.GetType())
            Dim oS As New MemoryStream
            Dim sw As New StringWriter
            Dim sXML As String
            oSer.Serialize(sw, oObjectToSerialize)
            sXML = sw.ToString

            Return sXML
        End Function
        Public Overrides Function DeSerialize(ByVal sXMLStringToDeSerialize As String, ByVal tType As Type) As Object
            'Deserialize to the original objects
            Dim sr As New StringReader(sXMLStringToDeSerialize)
            Dim x1 As Object

            Dim oSer As System.Xml.Serialization.XmlSerializer
            oSer = New XmlSerializer(tType)
            x1 = oSer.Deserialize(sr)

            Return x1
        End Function
        Public Overrides Function CopyDocumentSection(ByVal FromDoc1 As Object, ByVal tFromDoc1Type As Type, ByVal ToDoc2 As Object, ByVal tTODoc2Type As Type) As Boolean

            Dim oElFrom As XmlElement
            Dim oElTo As XmlElement

            Dim oEnv As New JSKEnvelope
            oEnv.AddDocument(FromDoc1)
            'If ToDoc2 Is Nothing Then
            '    ToDoc2 = Type.GetType(tTODoc2Type.AssemblyQualifiedName())
            'End If
            oEnv.AddDocument(ToDoc2)


            oElFrom = oEnv.GetDocumentInternal(0, True)
            oElTo = oEnv.GetDocumentInternal(1, True)

            Dim sFromDocumentSection As String
            Dim sToDocumentSection As String

            sFromDocumentSection = Serialize(FromDoc1)
            sToDocumentSection = Replace(sFromDocumentSection, oElFrom.NamespaceURI(), oElTo.NamespaceURI(), , , CompareMethod.Text)

            ToDoc2 = DeSerialize(sToDocumentSection, tTODoc2Type)

        End Function

        Protected Sub AddHeaderToEnvelope()
            Dim sXMLHeader As String

            'make sure the custom params get in!
            header.delivery.message.subject = elSubject

            'includes the XMLVersion stuff here!!! Neeed to remove it!
            sXMLHeader = Serialize(header)

            Dim oHeaderDoc As New XmlDocument
            Dim oNL As XmlNodeList

            oHeaderDoc.LoadXml(sXMLHeader)

            oNL = oHeaderDoc.SelectNodes("/*")

            Dim df As XmlDocumentFragment
            df = docEnvelope.CreateDocumentFragment

            Dim oEnvN As XmlNode

            'Should be only one node for the header
            Dim l As Long
            For l = 1 To oNL.Count
                If oNL(l - 1).Name <> "xml" Then
                    oEnvN = docEnvelope.ImportNode(oNL(l - 1), True)
                End If
            Next



            '++This will not work if you deserialize and then serialize
            'as there's some nodes already ther when you've deserialized
            'We need to replace the nodes if they're already there, otherwise add them in...

            '++Existing code
            'elBiztalk_1.AppendChild(oEnvN)  'the header
            'elBiztalk_1.AppendChild(elBody)
            'docEnvelope.AppendChild(elBiztalk_1)
            '--Existing code

            Dim oExistingHeaderNode As XmlNode
            Dim oExistingBodyNode As XmlNode
            Dim oExistingBiztalkNode As XmlNode
            Dim oExistingDocumentElementNode As XmlElement


            '++If there's a Document Element already, then leave it alone...
            oExistingDocumentElementNode = docEnvelope.DocumentElement
            If oExistingDocumentElementNode Is Nothing Then
                docEnvelope.AppendChild(elBiztalk_1)
            End If
            '--If there's a Document Element already, then leave it alone...

            '++if there's an existing header and body, then replace them
            Dim nsmgr As New XmlNamespaceManager(docEnvelope.NameTable)

            oExistingHeaderNode = docEnvelope.SelectSingleNode("/biztalk_1/header", nsmgr)
            oExistingBodyNode = docEnvelope.SelectSingleNode("/biztalk_1/body", nsmgr)
            oExistingBiztalkNode = docEnvelope.SelectSingleNode("/biztalk_1", nsmgr)

            If oExistingHeaderNode Is Nothing Then
                elBiztalk_1.AppendChild(oEnvN)  'the header
                elBiztalk_1.AppendChild(elBody) 'the body
                docEnvelope.AppendChild(elBiztalk_1)
            Else
                'if the header's there, then so is the DocumentElement...so don't add it in again...
                'just replace the Header and Body nodes...

                'Need to get oEnvN and elBody, to be part of the docEnvelope XMLDocument first! before doing the replace!
                Dim newOenvN As XmlNode
                Dim newelBody As XmlNode

                newOenvN = docEnvelope.ImportNode(oEnvN, True)
                newelBody = docEnvelope.ImportNode(elBody, True)

                oExistingBiztalkNode.ReplaceChild(newOenvN, oExistingHeaderNode)
                oExistingBiztalkNode.ReplaceChild(newelBody, oExistingBodyNode)


                elBiztalk_1 = oExistingBiztalkNode
                elHeader = newOenvN
                elBody = newelBody
            End If

            '--if there's an existing header and body, then replace them

        End Sub
        Private Sub InitElSubject()
            If elSubject Is Nothing Then
                'elSubject = docEnvelope.CreateElement("subject")
                elSubject = docEnvelope.CreateElement("custom")
            End If
        End Sub

        Public Overloads Overrides Sub SetCustomParam(ByVal sParamName As String, ByVal sParamValue As String)

            InitElSubject()

            Dim oElement As XmlElement
            oElement = elSubject.OwnerDocument.CreateElement(sParamName)
            oElement.InnerXml = Trim(sParamValue)
            elSubject.AppendChild(oElement)

        End Sub
        Public Overloads Overrides Sub SetCustomParam(ByVal sParamNodeName As String, ByVal sParamName As String, ByVal sParamValue As String)
            InitElSubject()
            Dim oElement As XmlElement

            'Get the sParamNodeName Node
            Dim oNode As XmlNode
            oNode = elSubject.SelectSingleNode(sParamNodeName)

            If oNode Is Nothing Then
                'create one with that name...
                oNode = elSubject.OwnerDocument.CreateElement(sParamNodeName)
                If elSubject.AppendChild(oNode) Is Nothing Then
                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Error trying to add custom node ==>" & sParamNodeName)
                    Throw New Exception("Error trying to add custom node ==>" & sParamNodeName)
                End If
            End If

            oElement = elSubject.OwnerDocument.CreateElement(sParamName)
            oElement.InnerXml = Trim(sParamValue)
            oNode.AppendChild(oElement)

        End Sub
        Public Overloads Overrides Function GetCustomParam(ByVal sParamName As String) As String
            Try
                Dim oNode As XmlNode
                oNode = elSubject.SelectSingleNode(sParamName)

                If oNode Is Nothing Then
                    Return ""
                Else
                    Return Trim(oNode.InnerXml)
                End If

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                Return ""
            End Try
        End Function
        Public Overloads Overrides Function GetCustomParam(ByVal sParamNodeName As String, ByVal sParamName As String) As String
            Try
                Dim oNode As XmlNode
                oNode = elSubject.SelectSingleNode(sParamNodeName & "/" & sParamName)

                If oNode Is Nothing Then
                    Return ""
                Else
                    Return Trim(oNode.InnerXml)
                End If

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                Return ""
            End Try
        End Function

        '++ Helper Functions

        Public Overloads Overrides Function IsWarning() As Boolean
            Return IsWarning(Me)
        End Function

        Public Overloads Overrides Function IsError() As Boolean
            Return IsError(Me)
        End Function

        Public Overloads Overrides Function GetMsgStatus() As eEnvelopeStatus
            Return GetMsgStatus(Me)
        End Function

        Public Overloads Overrides Function IsError(ByVal sXML As String) As Boolean
            Return Not ((GetMsgStatus(sXML) = eEnvelopeStatus.eSuccess) Or (GetMsgStatus(sXML) = eEnvelopeStatus.eWarnings))
        End Function
        Public Overloads Function IsError(ByVal oJskEnv As JSKEnvelope) As Boolean
            Return Not ((GetMsgStatus(oJskEnv) = eEnvelopeStatus.eSuccess) Or (GetMsgStatus(oJskEnv) = eEnvelopeStatus.eWarnings))
        End Function
        Public Overloads Overrides Function IsWarning(ByVal sXML As String) As Boolean
            Return GetMsgStatus(sXML) = eEnvelopeStatus.eWarnings
        End Function
        Public Overloads Function IsWarning(ByVal oJskEnv As JSKEnvelope) As Boolean
            Return GetMsgStatus(oJskEnv) = eEnvelopeStatus.eWarnings
        End Function
        Public Overloads Overrides Function GetMsgStatus(ByVal sXML As String) As eEnvelopeStatus
            Dim oJskEnv As New JSKEnvelope
            oJskEnv.FromXML(sXML)

            Return GetMsgStatus(oJskEnv)
        End Function
        Public Overloads Function GetMsgStatus(ByVal oJSKEnv As JSKEnvelope) As eEnvelopeStatus
            Dim eStatus As eEnvelopeStatus = eEnvelopeStatus.eSuccess
            Dim i As Long = 0

            Try
                Dim oJskEnvInternal As JSKEnvelope
                oJskEnvInternal = oJSKEnv

                For i = 0 To oJSKEnv.DocumentCount - 1
                    'Check to see if there's an instance of the ErrorXML document present
                    If oJskEnvInternal.header.manifest.document(i).name = "ErrorXML" Then

                        Try
                            Dim oPlgErr As ErrorXML.ErrorXML
                            oPlgErr = oJskEnvInternal.GetDocumentInternal(i, GetType(ErrorXML.ErrorXML))
                            If Not oPlgErr Is Nothing Then
                                If oPlgErr.ErrorEntry.Count > 0 Then
                                    eStatus = eEnvelopeStatus.eFailed
                                    Exit For
                                End If
                                If oPlgErr.WarningEntry.Count > 0 Then
                                    eStatus = eEnvelopeStatus.eWarnings
                                    Exit For
                                End If

                                'bad envelope - Manifest does not match body etc.
                                'Also need to count docs in Manifest & Body etc...

                                'Dim oDocBody As System.Xml.XmlDocument
                                'protected... for each odocbody in ojskenv.elbody
                                'Hard to do with JSK Envelope implementation - need to change envelope
                                'class - also try iheritance etc...

                                eStatus = eEnvelopeStatus.eSuccess

                            Else
                                eStatus = eEnvelopeStatus.eInconsistentEnvelope
                                Exit For
                            End If
                        Catch ex As Exception
                            ExceptionManager.Publish(ex)
                            eStatus = eEnvelopeStatus.eInconsistentEnvelope
                            Exit For
                        Finally

                        End Try
                    Else
                        eStatus = eEnvelopeStatus.eSuccess
                    End If
                    i += 1
                Next i

                Return eStatus

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(eLogLevel.eLOG_ERROR, ex.ToString)
                Throw ex

            End Try

        End Function
        Protected Overloads Function GetDocumentInternal(ByVal sDocumentName As String, ByVal tType As Type, Optional ByVal lDocIndex As Long = 0) As Object
            Return DeSerialize(GetDocumentInternal(sDocumentName, lDocIndex), tType)
        End Function
        Protected Overloads Function GetDocumentInternal(ByVal sDocumentName As String, Optional ByVal lDocIndex As Long = 0) As String
            Return GetDocumentInternal(sDocumentName, True, lDocIndex).OuterXml.ToString
        End Function


        Protected Overloads Function GetDocumentInternal(ByVal sDocumentName As String, ByVal bGetDocAsElement As Boolean, Optional ByVal lDocIndex As Long = 0, Optional ByVal lReturnedDocIndex As Long = -1) As XmlElement

            Dim eStatus As eEnvelopeStatus = eEnvelopeStatus.eSuccess
            Dim i As Long = 0
            Dim oDoc As XmlElement

            Dim lMatchIndex As Long = 0

            If (sDocumentName = "" And lDocIndex = -1) Then
                Throw New Exception("Invalid parameters specified - sDocumentName = "" And lDocIndex = -1")
            End If

            If Me.header.manifest.document.Count <> Me.DocumentCount Then
                Throw New Exception("Inconsistent Envelope - Document Body count(" & Me.DocumentCount & ") does not match header manifest document count (" & Me.header.manifest.document.Count & ")")
            End If

            Try
                For i = 0 To Me.DocumentCount - 1
                    'Check to see if there's an instance of the document asked for present...

                    If (sDocumentName = "" And lDocIndex <> -1) Or Me.header.manifest.document(i).name.Trim = sDocumentName Then
                        'there's a match in the manifest - or we don't care to match on a document name...
                        'try & get the doc out of the body now...
                        If sDocumentName = "" Then 'just get the document at the requested index...
                            Try
                                oDoc = Me.GetDocumentInternal(lDocIndex, True)
                                If Not oDoc Is Nothing Then
                                    lReturnedDocIndex = i
                                    Return oDoc
                                Else
                                    eStatus = eEnvelopeStatus.eWarnings
                                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Index out of range")
                                End If
                            Catch

                            End Try
                        End If
                        If lMatchIndex = lDocIndex Then
                            Try
                                oDoc = Me.GetDocumentInternal(lDocIndex, True)
                                If Not oDoc Is Nothing Then
                                    lReturnedDocIndex = i
                                    Return oDoc
                                Else
                                    eStatus = eEnvelopeStatus.eInconsistentEnvelope
                                    LogError(LogDefs.eLogLevel.eLOG_ERROR, "Inconsistent Envelope - Body does not match header - ")

                                    'bad envelope - Manifest does not match body etc.
                                    'Also need to count docs in Manifest & Body etc...

                                    'Dim oDocBody As System.Xml.XmlDocument
                                    'protected... for each odocbody in ojskenv.elbody
                                    'Return Nothing
                                    Throw New Exception("Inconsistent Envelope - Body does not match header - ")
                                End If
                            Catch ex As Exception
                                ExceptionManager.Publish(ex)
                                eStatus = eEnvelopeStatus.eInconsistentEnvelope
                                LogError(LogDefs.eLogLevel.eLOG_ERROR, "Inconsistent Envelope - Body does not match header - " & ex.ToString)
                                Throw ex
                            Finally

                            End Try
                        End If
                        lMatchIndex += 1

                    End If
                    'i += 1
                Next i

            Catch ex As Exception
                ExceptionManager.Publish(ex)
                LogError(LogDefs.eLogLevel.eLOG_ERROR, "Inconsistent Envelope - Body does not match header - " & ex.ToString)
                Throw ex
            End Try
        End Function
        '-- Helper Functions



        'Envelope Detection - new interface??? Not for now...
        Public Overrides Function IsCorrectEnvelopeType(ByVal sXML As String) As Boolean
            Try

                Dim oXMLDoc As New XmlDocument
                oXMLDoc.LoadXml(sXML)

                If oXMLDoc.DocumentElement.LocalName = "biztalk_1" Then
                    If oXMLDoc.DocumentElement.NamespaceURI = "urn:schemas-biztalk-org:biztalk:biztalk_1" Then
                        Return True
                    End If
                Else
                    Return False
                End If
            Catch e As Exception
                LogError(LogDefs.eLogLevel.eLOG_ERROR, "Error Parsing envelope:" & e.Message)
                Return False
            End Try


        End Function
        Public Overrides Function GetEnvelopeNodeName(Optional ByVal sXML As String = "") As Boolean

        End Function
        Public Overrides Function GetEnvelopeNameSpace(Optional ByVal sXML As String = "") As Boolean

        End Function
        Public Overrides Function GetEnvelopeVersion(Optional ByVal sXML As String = "") As Boolean

        End Function

        'Public Overrides Function GetEnvelopeType(Optional byval sXML As String = "", Optional byval oEnvOut As Envelope = Nothing) As eEnvelopeType
        '    If sXML = "" Then
        '        Return eEnvelopeType.eJSK
        '    End If
        'End Function
        Public Overrides Function GetEnvelopeType(Optional ByVal sXML As String = "", Optional ByRef oEnvOut As IEnvelopeProvider = Nothing) As String
            If sXML = "" Then
                Return m_csEnvelopeName
            Else
                Return MyBase.GetEnvelopeType(sXML)
            End If
        End Function

        'Replace this with Custom Params...
        '<System.Xml.Serialization.XmlIgnore()> _
        '        Public Overrides Property XMLSchemaName() As String
        '    'The XMLSchema name of the default document - this is one of the parameters used on the 
        '    'ESB server to construct the pipeline for the request
        '    Get
        '        'Return the Schema from the base class as the base class does...
        '        Return MyBase.XMLSchemaName
        '    End Get
        '    Set(ByVal Value As String)
        '        'This field is used to store...
        '        'the oCE.ResolveName in the PipelineManager...!!!Yuk...
        '        'Should change to use CustomParams...
        '        'Currently done this way to kep compatibility with COM Based version of JSKEnvelope...
        '        Me.header.delivery.to.state.handle = Value
        '    End Set
        'End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides ReadOnly Property XMLSchemaNamespace() As String
            'The XMLSchema Namespace of the default document - this may be one of the parameters used on the 
            'ESB server to construct the pipeline for the request
            Get
                If lNumDocs <= 0 Then
                    Return ""
                Else
                    Return GetDocument(0).GetAsXMLDocument.DocumentElement.NamespaceURI
                End If
            End Get
        End Property
        Public Overrides ReadOnly Property XMLSchemaName() As String
            Get
                If lNumDocs <= 0 Then
                    Return ""
                Else
                    Return Trim(GetDocument(0).GetAsXMLDocument.DocumentElement.LocalName.Trim)
                End If
            End Get

        End Property

        Public Overloads Overrides Function CreateResponse() As IEnvelope
            Dim oJSKEnv As New JSKEnvelope

            'Should copy header over etc...
            oJSKEnv = Me.Clone()

            'Remove other stuff...Just leave relavant bits of header...
            oJSKEnv.header.delivery.message.sent = ESB.Core.Util.Timer.NowAsString
            oJSKEnv.elBody = oJSKEnv.docEnvelope.CreateElement("body")
            oJSKEnv.header.manifest.attachment.Clear()
            oJSKEnv.header.manifest.document.Clear()
            oJSKEnv.lNumDocs = 0

            Dim oEnv As New Envelope
            oEnv.SetInternalEnvelope(oJSKEnv)
            oEnv.DefaultEnvelopeType = m_csEnvelopeName

            Return oEnv

        End Function

        Public Overrides Function Clone() As Object
            'Best way to Clone is probably to Serialise & Deserialize as is done below...
            Dim oEnv As New JSKEnvelope
            Dim sEnvXML As String = Me.ToXML()
            oEnv.FromXML(sEnvXML)
            Return oEnv
        End Function

        'Public Overloads Overrides Function CreateResponse(byval oEnv As IEnvelope) As IEnvelope

        'End Function

        'Public Overloads Overrides Function CreateResponse(byval oEnvXMLDoc As System.Xml.XmlDocument) As IEnvelope

        'End Function

        'Public Overloads Overrides Function CreateResponse(byval sEnvXMLStr As String) As IEnvelope

        'End Function


        Public Overrides Property Context() As String
            Get
                Return ESB.Core.Util.Utils.TrimStr(Trim(header.delivery.to.state.process), ".")
            End Get
            Set(ByVal Value As String)
                header.delivery.to.state.process = Trim(Value)
            End Set
        End Property

        Public Overrides Property SystemName() As String
            Get

            End Get
            Set(ByVal Value As String)

            End Set
        End Property

        Public Overrides Property SystemType() As String
            Get

            End Get
            Set(ByVal Value As String)

            End Set
        End Property

        Public Overrides Property SystemVersion() As String
            Get

            End Get
            Set(ByVal Value As String)

            End Set
        End Property

        <System.Xml.Serialization.XmlIgnore()> _
        Public Overrides Property CallSynchronizationType() As String
            Get
                Return GetCustomParam(C_sCustomParamESBCore, C_sRunAsyncOnSync)
            End Get
            Set(ByVal Value As String)
                SetCustomParam(C_sCustomParamESBCore, C_sRunAsyncOnSync, Trim(Value))
            End Set
        End Property

        Public Overrides Property ToAddressType() As String
            Get
                Dim sAddressType As String = GetCustomParam(C_sCustomParamESBCore, C_sCustomParamToAddressTransportType)
                If sAddressType = "" Then
                    'get it out of the url...
                    If Me.header.delivery.to.address = "" Then
                        sAddressType = ""
                    Else
                        sAddressType = Me.header.delivery.to.address.Substring(0, Me.header.delivery.to.address.IndexOf(":"))
                    End If
                End If
                Return Trim(sAddressType)
            End Get
            Set(ByVal Value As String)
                SetCustomParam(C_sCustomParamESBCore, C_sCustomParamToAddressTransportType, Trim(Value))
            End Set
        End Property

        Public Overrides Property FromAddressType() As String
            Get
                Dim sAddressType As String = GetCustomParam(C_sCustomParamESBCore, C_sCustomParamFromAddressTransportType)
                If sAddressType = "" Then
                    'get it out of the url...
                    If Me.header.delivery.from.address = "" Then
                        sAddressType = ""
                    Else
                        sAddressType = Me.header.delivery.from.address.Substring(0, Me.header.delivery.from.address.IndexOf(":"))
                    End If
                End If
                Return Trim(sAddressType)
                'Return GetCustomParam(C_sCustomParamESBCore, C_sCustomParamFromAddressTransportType)
            End Get
            Set(ByVal Value As String)
                SetCustomParam(C_sCustomParamESBCore, C_sCustomParamFromAddressTransportType, Value)
            End Set
        End Property
    End Class


    '<remarks/>
    <System.Xml.Serialization.XmlRootAttribute("", IsNullable:=False)> _
    <Serializable()> _
    Public Class header

        '<remarks/>
        Public delivery As New delivery

        '<remarks/>
        Public manifest As New manifest
    End Class

    '<remarks/>
    <System.Xml.Serialization.XmlRootAttribute("", IsNullable:=False)> _
    <Serializable()> _
    Public Class delivery

        '<remarks/>
        Public message As New message

        '<remarks/>
        Public [to] As New [to]

        '<remarks/>
        Public from As New from
    End Class

    '<remarks/>
    <System.Xml.Serialization.XmlRootAttribute("", IsNullable:=False)> _
    <Serializable()> _
    Public Class [to]

        '<remarks/>
        Public address As String = ""

        '<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("", IsNullable:=False)> _
        Public state As New state
    End Class

    '<remarks/>
    '<System.Xml.Serialization.XmlRootAttribute("", IsNullable:=False)> _
    <Serializable()> _
    Public Class state

        <System.Xml.Serialization.XmlElementAttribute("", IsNullable:=False)> _
        Public process As String = ""

        <System.Xml.Serialization.XmlElementAttribute("", IsNullable:=False)> _
        Public handle As String = ""

        '<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("", IsNullable:=False)> _
                Public referenceID As String = ""
    End Class

    '<System.Xml.Serialization.XmlRootAttribute("", IsNullable:=False)> _
    'Public Class MultiElementNode
    '    Public sSingleValue As String
    '    Public oXMLNode As System.Xml.XmlElement

    'End Class


    <System.Xml.Serialization.XmlRootAttribute("", IsNullable:=False)> _
    <Serializable()> _
    Public Class message

        '<remarks/>
        Public messageID As String = ""

        '<remarks/>
        Public sent As String = ESB.Core.Util.Timer.NowAsString

        '<remarks/>
        'Public subject As subject

        'Public subject As New MultiElementNode()
        Public subject As System.Xml.XmlElement

    End Class

    '<System.Xml.Serialization.XmlRootAttribute("", IsNullable:=False)> _
    'Public Class subject

    '    Public custom As String

    'End Class


    '<remarks/>

    <Serializable()> _
    Public Class documentCol : Inherits Collections.CollectionBase
        Public Sub Add(ByVal item As document)
            List.Add(item)
        End Sub

        'todo: When an item is removed from this collection, we also need to remove the appropriate item 
        'from the collection of documents in the m_doc object in the envelope
        'Consider re-writing envelope implementation to be similar to the e3/e4 one...
        Public Sub Remove(ByVal index As Integer)
            If index > Count - 1 Or index < 0 Then
                'ERROR!!!
                Exit Sub
            End If
            List.RemoveAt(index)

        End Sub

        Public Sub Insert(ByVal index As Integer, ByVal item As document)
            If index > Count Or index < 0 Then
                'ERROR!!!
                Exit Sub
            End If
            List.Insert(index, item)
        End Sub

        Default Public Property Item(ByVal index As Integer) As document
            Get
                Return CType(List.Item(index), document)
            End Get
            Set(ByVal value As document)
                List.Insert(index, value)
            End Set

        End Property

        Protected Overrides Sub OnRemove(ByVal index As Integer, ByVal value As Object)
            Throw New Exception("JSKEnvelope does not currently support Removing Documents.")
        End Sub
    End Class

    '<remarks/>
    <System.Xml.Serialization.XmlRootAttribute("", IsNullable:=False)> _
    <Serializable()> _
    Public Class document

        '<remarks/>
        Public name As String = ""

        '<remarks/>
        Public description As String = ""
    End Class

    '<remarks/>
    <System.Xml.Serialization.XmlRootAttribute("", IsNullable:=False)> _
    <Serializable()> _
    Public Class manifest

        '<remarks/>
        '<System.Xml.Serialization.XmlElementAttribute("document")> _
        <System.Xml.Serialization.XmlElementAttribute("document")> _
        Public document As New documentCol

        'Public document() As document

        '<remarks/>
        <System.Xml.Serialization.XmlElementAttribute("attachment")> _
        Public attachment As New System.Collections.Generic.List(Of attachment)
    End Class

    '<remarks/>
    <System.Xml.Serialization.XmlRootAttribute("", IsNullable:=False)> _
    <Serializable()> _
    Public Class from

        '<remarks/>
        Public address As String = ""

        '<remarks/>
        Public state As New state
    End Class

    ''++The internal attachment & attachment classes
    '<Serializable()> _
    'Public Class attachmentCol : Inherits Collections.CollectionBase
    '    Public Sub Add(ByVal item As attachment)
    '        List.Add(item)
    '    End Sub
    '    Public Sub Remove(ByVal index As Integer)
    '        If index > Count - 1 Or index < 0 Then
    '            'ERROR!!!
    '            Exit Sub
    '        End If
    '        List.RemoveAt(index)

    '    End Sub

    '    Public Sub Insert(ByVal index As Integer, ByVal item As attachment)
    '        If index > Count Or index < 0 Then
    '            'ERROR!!!
    '            Exit Sub
    '        End If
    '        List.Insert(index, item)
    '    End Sub

    '    Default Public Property Item(ByVal index As Integer) As attachment
    '        Get
    '            Return CType(List.Item(index), attachment)
    '        End Get
    '        Set(ByVal value As attachment)
    '            List.Insert(index, value)
    '        End Set

    '    End Property
    'End Class


    <System.Xml.Serialization.XmlRootAttribute("", IsNullable:=False)> _
    <Serializable()> _
    Public Class attachment : Implements IAttachment
        Protected sIndex As String = ""
        Protected sFilename As String = ""
        Protected sDescription As String = ""
        Protected sType As String = ""
        Protected sUrl As String = ""

        '<remarks/>

        Public Property index() As String Implements IAttachment.index
            Get
                Return Trim(sIndex)
            End Get
            Set(ByVal Value As String)
                sIndex = Trim(Value)
            End Set
        End Property
        '<remarks/>
        Public Property filename() As String Implements IAttachment.filename
            Get
                Return Trim(sFilename)
            End Get
            Set(ByVal Value As String)
                sFilename = Trim(Value)
            End Set
        End Property
        '<remarks/>
        Public Property description() As String Implements IAttachment.description
            Get
                Return Trim(sDescription)
            End Get
            Set(ByVal Value As String)
                sDescription = Trim(Value)
            End Set
        End Property
        '<remarks/>
        Public Property type() As String Implements IAttachment.type
            Get
                Return Trim(sType)
            End Get
            Set(ByVal Value As String)
                sType = Trim(Value)
            End Set
        End Property
        '<remarks/>
        Public Property url() As String Implements IAttachment.url
            Get
                Return Trim(sUrl)
            End Get
            Set(ByVal Value As String)
                sUrl = Trim(Value)
            End Set
        End Property
    End Class



    '--The internal attachment & attachment classes

    '<message xmlns=""><messageID>068D43E6-DAE9-4EE9-AA82-098CD2565D21</messageID><sent>2002-06-12T17:07:45:00-10:00</sent><subject>ds</subject></message>
    '<header>
    '	<delivery>
    '		<message>
    '			<messageID></messageID>
    '			<sent>
    '				2002-08-19T23:00:51:00-10:00
    '			</sent>
    '			<subject>
    '				<custom xmlns="">
    '					<!-- <ContinueProcessingPipeline>0</ContinueProcessingPipeline> -->
    '					<user>
    '						me
    '					</user>
    '					<pwd>
    '						let me in Pretty Please
    '					</pwd>
    '					<ESBCore>
    '						<ToAddressTransportType>
    '							SOAP
    '						</ToAddressTransportType>
    '						<FromAddressTransportType>
    '							SOAP
    '						</FromAddressTransportType>
    '					</ESBCore>
    '				</custom>
    '			</subject>
    '		</message>
    '		<to>
    '			<state>
    '				<process></process>
    '				<handle>
    '					BuildCmd
    '				</handle>
    '			</state>
    '			<address></address>
    '		</to>
    '		<from>
    '			<address>
    '				HTTP://localhost:84/ESB.wsdl
    '			</address>
    '		</from>
    '	</delivery>
    '	<manifest>
    '		<document>
    '			<name>
    '				BuildCmd
    '			</name>
    '			<description>
    '				urn:schemas-biztalk-org:biztalk:BuildCmd:BuildCmd
    '			</description>
    '		</document>
    '	</manifest>
    '</header>
End Namespace