'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Strict On

Imports System.Xml.Serialization
Imports System.IO
Imports System.Xml
Imports System.Text
Imports ESB.Core.Util
Imports System.Xml.Schema

Imports Microsoft.Xml.XMLGen


Public Class XMLUtil

    Dim m_sValidationResult As String

    Public Function Serialize(ByVal oObjectToSerialize As System.Object) As String
        Dim oSer As System.Xml.Serialization.XmlSerializer
        oSer = New XmlSerializer(oObjectToSerialize.GetType())
        Dim oMemStream As New MemoryStream
        Dim sw As New StreamWriter(oMemStream, New System.Text.UTF8Encoding)
        Dim sXML As String
        oSer.Serialize(sw, oObjectToSerialize)
        sXML = Encoding.UTF8.GetString(oMemStream.ToArray())
        oMemStream.Flush()
        oMemStream.Close()
        Return sXML
    End Function
    Public Function DeSerialize(ByVal sXMLStringToDeSerialize As String, ByVal tType As Type) As Object
        'Deserialize to the original objects
        Dim sr As New StringReader(sXMLStringToDeSerialize)

        Dim x1 As Object

        Dim oSer As System.Xml.Serialization.XmlSerializer
        oSer = New XmlSerializer(tType)

        x1 = oSer.Deserialize(sr)

        Return x1
    End Function
    Public Function PrettyFormatXML(ByVal oStream As MemoryStream, Optional ByVal bXMLDOMParseFirst As Boolean = True) As String
        'bXMLDOMParseFirst 
        'Not good for large XML (100's of KBytes,MBytes etc.) as it does an XMLDOM parse etc...
        'Default to using it though till we fix the other way. Not using the XMLDom 
        'results in non-well formed XML being produced for Empty XML nodes written in
        'shorthand such as <aaa/>. It leaves out the / at some point making the
        'XML useless...!!!

        'If bXMLDOMParseFirst = True Then
        Dim oXMLDoc As New XmlDocument
        oXMLDoc.Load(oStream)

        '++MINA - get rid of that UTF-16 stuff!!!
        Dim oMemStream As New MemoryStream
        Dim sw As New StreamWriter(oMemStream, New System.Text.UTF8Encoding)

        Dim xmlwriter As New XmlTextWriter(sw)
        xmlwriter.Formatting = Formatting.Indented
        oXMLDoc.Save(xmlwriter)

        Dim sXmlOut As String = Encoding.UTF8.GetString(oMemStream.ToArray())

        oMemStream.Flush()
        oMemStream.Close()

        Return sXmlOut
        '--MINA - get rid of that UTF-16 stuff!!!

        'End If


        'TODO: Fix this thing below...
        'results in non-well formed XML being produced for Empty XML nodes written in
        'shorthand such as <aaa/>. It leaves out the / at some point making the
        'XML useless...!!!

        'Dim reader As New XmlTextReader(oStream)
        'Dim writer As New StringWriter
        'Dim sTabPrefix As String = "" 'vbTab

        'While reader.Read()

        '    If reader.NodeType = XmlNodeType.Element Or reader.NodeType = XmlNodeType.XmlDeclaration Then
        '        sTabPrefix = New String(vbTab, reader.Depth)
        '        'writer.WriteLine("{0}<{1}>", sTabPrefix, reader.Name)



        '        If reader.NodeType = XmlNodeType.Element And reader.NodeType = XmlNodeType.EndElement Then
        '            writer.Write("{0}<{1}/>", sTabPrefix, Trim(reader.Name))
        '        Else
        '            writer.Write("{0}<{1}", sTabPrefix, Trim(reader.Name))
        '        End If

        '        If reader.HasAttributes Then
        '            While reader.MoveToNextAttribute()
        '                'Dim i As Long = 0
        '                'If i > 0 Then
        '                '    writer.Write(",")
        '                'End If
        '                writer.Write(" ")
        '                writer.Write(Trim(reader.Name))
        '                writer.Write("=""")
        '                writer.Write(Trim(reader.Value))
        '                writer.Write("""")
        '                'i += 1
        '            End While
        '            reader.MoveToElement()
        '        End If
        '        writer.WriteLine(">")

        '    Else
        '        If reader.NodeType = XmlNodeType.Text Then
        '            sTabPrefix = New String(vbTab, reader.Depth + 1)
        '            writer.WriteLine("{0}{1}", sTabPrefix, Trim(reader.Value))
        '        End If
        '        If reader.NodeType = XmlNodeType.EndElement Then
        '            sTabPrefix = New String(vbTab, reader.Depth)
        '            writer.WriteLine("{0}</{1}>", sTabPrefix, Trim(reader.Name))
        '        End If
        '    End If
        'End While

        'Dim buf As String = writer.ToString
        'writer.Close()
        'reader.Close()

        'Return buf

    End Function
    Public Function PrettyFormatXML(ByVal sXML As String, Optional ByVal bXMLDOMParseFirst As Boolean = True) As String
        Dim oStream As New MemoryStream
        'Dim inputByteArray() As Byte = Encoding.Unicode.GetBytes(sXML)
        Dim inputByteArray() As Byte = Encoding.UTF8.GetBytes(sXML)

        oStream.Write(inputByteArray, 0, inputByteArray.Length)
        oStream.Position = 0
        'oStream.Close()

        Return PrettyFormatXML(oStream, bXMLDOMParseFirst)
    End Function
    Public Function GetXMLAsString(ByVal oDoc As XmlDocument) As String
        Dim mystream As New System.IO.MemoryStream
        Dim writer As New XmlTextWriter(mystream, Nothing)
        'oDoc.PreserveWhitespace = False
        oDoc.Save(writer)

        'Dim enc As System.Text.Encoding = System.Text.Encoding.ASCII
        Dim enc As System.Text.Encoding = System.Text.Encoding.UTF8

        Dim sXML As String
        sXML = enc.GetString(mystream.ToArray())
        Return sXML
    End Function

    'TODO - test this works
    Public Function GetDatasetAsString(ByVal oDs As System.Data.DataSet) As String
        Dim oStream As New System.IO.MemoryStream()
        oDs.WriteXml(oStream)
        oStream.Position = 0
        Dim sXML As String
        Dim enc As System.Text.Encoding = System.Text.Encoding.UTF8
        sXML = enc.GetString(oStream.ToArray())
        Return sXML
    End Function

    'TODO: Need to add overload to take collection of schemas...
    Public Function ValidateXMLAgainstXSD(ByVal sXSDPath As String, ByVal sXmlToValidate As String, Optional ByRef sErrors As String = "", Optional ByVal bThrowExceptionOnValidationError As TriState = TriState.UseDefault) As Boolean
        m_sValidationResult = ""

        'Create the XmlNamespaceManager.
        Dim nt As NameTable = New NameTable
        Dim nsmgr As XmlNamespaceManager = New XmlNamespaceManager(nt)
        'Create the XmlParserContext.
        Dim context As XmlParserContext = New XmlParserContext(Nothing, nsmgr, Nothing, XmlSpace.None)
        'Create the reader. 
        Dim xml_text_reader As New XmlTextReader(sXmlToValidate, XmlNodeType.Element, context)

        Dim xml_validating_reader As New XmlValidatingReader(xml_text_reader)
        Dim xml_document As New XmlDocument

        ' Set the validation event handler
        AddHandler xml_validating_reader.ValidationEventHandler, AddressOf Me.ValidationEventHandler
        Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil()

        ' Load the schema.
        Try
            Dim xml_SOM As New XmlDocument

            xml_SOM.Load(ESB.Core.Util.Utils.ExpandRelativePath(sXSDPath))
            Dim sSchemaNamespace As String = xml_SOM.DocumentElement.Attributes("targetNamespace").Value()

            Dim xml_text_reader_for_XSD As New XmlTextReader(sXSDPath)
            xml_validating_reader.Schemas.Add(sSchemaNamespace, xml_text_reader_for_XSD)
            'xml_validating_reader.Schemas.Add("", xml_text_reader_for_XSD)
            'Load the XmlDocument using the XmlValidatingReader.
            xml_document.Load(xml_validating_reader)
            xml_validating_reader.Close()
            xml_text_reader.Close()
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            m_sValidationResult = m_sValidationResult & " *** Error loading schema" & ex.ToString()
            If ShouldLog(eLogLevel.eLOG_ERROR) Then LogError(LogDefs.eLogLevel.eLOG_ERROR, m_sValidationResult, "sXSDPath =" & sXSDPath, sXmlToValidate)

            Throw
        End Try

        If (m_sValidationResult <> "") Then

            If ShouldLog(eLogLevel.eLOG_ERROR) Then LogError(LogDefs.eLogLevel.eLOG_ERROR, m_sValidationResult, "XSDPath =" & sXSDPath, sXmlToValidate)
            If ShouldLog(eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, m_sValidationResult, "XSDPath =" & sXSDPath, sXmlToValidate)

            'Dim errMess As String
            'errMess = "XSD Error when validating input to XSL translation against schema found at " & _
            '            sXSDPath & _
            '            " - error details follow:"
            'LogError(LogDefs.eLogLevel.eLOG_ERROR, errMess)
            'Dim sXml As String
            'sXml = "<xsd>" & m_Results & "</xsd>"
            'Dim doc As New Xml.XmlDocument
            'doc.PreserveWhitespace = True
            'doc.LoadXml(sXml)
            'Dim elemList As Xml.XmlNodeList = doc.GetElementsByTagName("ValidationError")
            'Dim i As Integer
            'For i = 0 To elemList.Count - 1
            '    LogError(LogDefs.eLogLevel.eLOG_ERROR, "XSD ERROR - " & elemList(i).InnerXml())
            'Next i
            'LogError(LogDefs.eLogLevel.eLOG_INFO, "XML file was : " & sXmlToValidate)
            'errMess = "XSD Error when valicating input to XSL translation against " & _
            '            sXSDPath & _
            '            " - error details written to LOG.                          "

            If bThrowExceptionOnValidationError = TriState.UseDefault Then
                'use config setting
                If System.Configuration.ConfigurationManager.AppSettings("ESB.ESBEnvelope.IgnoreInputSchemaValidationErrors") <> "1" Then
                    Throw New ESBXSDException(m_sValidationResult)
                Else
                    sErrors = m_sValidationResult
                    Return False
                End If
            End If
            If bThrowExceptionOnValidationError = TriState.True Then
                Throw New ESBXSDException(m_sValidationResult)
            End If
            If bThrowExceptionOnValidationError = TriState.False Then
                sErrors = m_sValidationResult
                Return False
            End If

        End If
        Return True
    End Function

    Public Function ValidateXMLAgainstXSD(ByVal sColXSDPath As String(), ByVal sXmlToValidate As String, Optional ByRef sErrors As String = "", Optional ByVal bThrowExceptionOnValidationError As TriState = TriState.UseDefault) As Boolean
        m_sValidationResult = ""
        Dim sXSDPath As String

        'Create the XmlNamespaceManager.
        Dim nt As NameTable = New NameTable
        Dim nsmgr As XmlNamespaceManager = New XmlNamespaceManager(nt)
        'Create the XmlParserContext.
        Dim context As XmlParserContext = New XmlParserContext(Nothing, nsmgr, Nothing, XmlSpace.None)
        'Create the reader. 
        Dim xml_text_reader As New XmlTextReader(sXmlToValidate, XmlNodeType.Element, context)

        Dim xml_validating_reader As New XmlValidatingReader(xml_text_reader)
        Dim xml_document As New XmlDocument

        ' Set the validation event handler
        AddHandler xml_validating_reader.ValidationEventHandler, AddressOf Me.ValidationEventHandler

        Dim xml_SOM As XmlDocument
        Dim sSchemaNamespace As String
        Dim xml_text_reader_for_XSD As XmlTextReader
        Dim oXmlUtil As New ESB.Core.XMLSchemaClasses.XMLUtil()
        ' Load the schemas.
        Try
            xml_SOM = New XmlDocument
            For Each sXSDPath In sColXSDPath
                sXSDPath = ESB.Core.Util.Utils.ExpandRelativePath(sXSDPath)
                xml_SOM.Load(sXSDPath)
                sSchemaNamespace = xml_SOM.DocumentElement.Attributes("targetNamespace").Value()
                xml_text_reader_for_XSD = New XmlTextReader(sXSDPath)
                xml_validating_reader.Schemas.Add(sSchemaNamespace, xml_text_reader_for_XSD)
            Next

            'Load the XmlDocument using the XmlValidatingReader.
            xml_document.Load(xml_validating_reader)
            xml_validating_reader.Close()
            xml_text_reader.Close()
        Catch ex As Exception
            ExceptionManager.Publish(ex)
            m_sValidationResult = m_sValidationResult & " *** Error loading schema" & ex.ToString()
            Dim sXsds As String = ""
            For Each s As String In sColXSDPath
                sXsds += s
            Next
            If ShouldLog(eLogLevel.eLOG_ERROR) Then LogError(LogDefs.eLogLevel.eLOG_ERROR, m_sValidationResult, "XSDPath =" & sXsds, sXmlToValidate)
            Throw
        End Try

        If (m_sValidationResult <> "") Then

            Dim sXsds As String = ""
            For Each s As String In sColXSDPath
                sXsds += s
                sXsds += ";" & vbNewLine
            Next
            If ShouldLog(eLogLevel.eLOG_ERROR) Then LogError(LogDefs.eLogLevel.eLOG_ERROR, m_sValidationResult, "XSDPaths =" & sXsds, sXmlToValidate)
            If ShouldLog(eLogLevel.eLOG_DATAXFER) Then LogMsg(LogDefs.eLogLevel.eLOG_DATAXFER, m_sValidationResult, "XSDPaths =" & sXsds, sXmlToValidate)

            'Dim errMess As String
            'errMess = "XSD Error when validating input to XSL translation against schema found at " & _
            '            sXSDPath & _
            '            " - error details follow:"
            'LogError(LogDefs.eLogLevel.eLOG_ERROR, errMess)
            'Dim sXml As String
            'sXml = "<xsd>" & m_Results & "</xsd>"
            'Dim doc As New Xml.XmlDocument
            'doc.PreserveWhitespace = True
            'doc.LoadXml(sXml)
            'Dim elemList As Xml.XmlNodeList = doc.GetElementsByTagName("ValidationError")
            'Dim i As Integer
            'For i = 0 To elemList.Count - 1
            '    LogError(LogDefs.eLogLevel.eLOG_ERROR, "XSD ERROR - " & elemList(i).InnerXml())
            'Next i
            'LogError(LogDefs.eLogLevel.eLOG_INFO, "XML file was : " & sXmlToValidate)
            'errMess = "XSD Error when valicating input to XSL translation against " & _
            '            sXSDPath & _
            '            " - error details written to LOG.                          "

            If bThrowExceptionOnValidationError = TriState.UseDefault Then
                'use config setting
                If System.Configuration.ConfigurationManager.AppSettings("ESB.ESBEnvelope.IgnoreInputSchemaValidationErrors") <> "1" Then
                    Throw New ESBXSDException(m_sValidationResult)
                Else
                    sErrors = m_sValidationResult
                    Return False
                End If
            End If
            If bThrowExceptionOnValidationError = TriState.True Then
                Throw New ESBXSDException(m_sValidationResult)
            End If
            If bThrowExceptionOnValidationError = TriState.False Then
                sErrors = m_sValidationResult
                Return False
            End If
        End If

        Return True



    End Function
    ' The event handler called when there is a validation error.
    Public Sub ValidationEventHandler(ByVal sender As Object, ByVal args As ValidationEventArgs)

        m_sValidationResult = m_sValidationResult & _
                                "<ValidationError>" & _
                                args.Message & _
                                "</ValidationError>"

    End Sub


    Public Function CreateSampleXmlFromSchema(ByVal sXsdPath As String, ByVal sRootElementLocalName As String, ByVal sRootElementNamespace As String, ByVal nMaxElements As Integer, ByVal nMaxListItems As Integer) As String
        Dim schemas As New XmlSchemaSet()
        Dim qname As New XmlQualifiedName(sRootElementLocalName, sRootElementNamespace) ' = XmlQualifiedName.Empty
        'Dim localName As String = String.Empty
        Dim max As Integer = 0
        Dim listLength As Integer = 0

        'Dim ns As String = String.Empty
        Dim mystream As New System.IO.MemoryStream
        Dim textWriter As New XmlTextWriter(mystream, Nothing)


        schemas.Add(Nothing, sXsdPath)
        'schemas.Add(sRootElementNamespace, sXsdPath)


        'Do the stuff

        textWriter.Formatting = Formatting.Indented
        Dim genr As New XmlSampleGenerator(schemas, qname)
        If (nMaxElements > 0) Then genr.MaxThreshold = nMaxElements
        If (nMaxListItems > 0) Then genr.ListLength = nMaxListItems
        genr.WriteXml(textWriter)

        Dim enc As System.Text.Encoding = System.Text.Encoding.UTF8
        Dim sXML As String
        sXML = enc.GetString(mystream.ToArray())
        Return sXML

    End Function

    Public Shared Function StringToStream(ByVal sXml As String) As MemoryStream
        Dim oStream As New MemoryStream
        Dim inputByteArray() As Byte = Encoding.UTF8.GetBytes(sXml)
        oStream.Write(inputByteArray, 0, inputByteArray.Length)
        oStream.Position = 0

        Return oStream
    End Function

    Public Shared Function StreamToString(ByVal oStream As MemoryStream) As String
        Dim enc As System.Text.Encoding = System.Text.Encoding.UTF8
        Dim s As String = enc.GetString(oStream.ToArray())
        Return s
    End Function

   

End Class
