﻿Imports System.IO
Imports System.Text
Imports System.Net
Imports System.Security.Cryptography.X509Certificates
Imports System.Net.Security
Imports Newtonsoft.Json
Imports System.Xml

Public Class MobileServices : Inherits BaseMobileServices

    Private m_sAjaxUrl As String = "mobile/i/AjaxCalls.aspx"
    Public Property AjaxUrl() As String
        Get
            Return m_sAjaxUrl
        End Get
        Set(ByVal value As String)
            m_sAjaxUrl = value
        End Set
    End Property


    Private m_sAccountPortfolio As String
    Public Property AccountPortfolio() As String
        Get
            Return m_sAccountPortfolio
        End Get
        Set(ByVal value As String)
            m_sAccountPortfolio = value
        End Set
    End Property


#Region "Services"

    ''' <summary>
    '''  Pass in Uid/pwd
    ''' Need to set uid/pwd beforehand...
    ''' </summary>
    ''' <param name="bDoNotCache"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function RetrieveAccountPortfolio(Optional ByVal bDoNotCache As Boolean = False) As String
        Dim s As String = ConvertJsonDataToXml(SendData(Get_RetrieveAccountPortfolio_Request(MyBase.Username, MyBase.Password), MakeFullUrl(m_sAjaxUrl)))
        If Not bDoNotCache Then m_sAccountPortfolio = s
        Return s
    End Function

    ''' <summary>
    '''      Pass in XML in AccountProtfolioRq format
    ''' </summary>
    ''' <param name="sXmlRq"></param>
    ''' <param name="bDoNotCache"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function RetrieveAccountPortfolio(ByVal sXmlRq As String, Optional ByVal bDoNotCache As Boolean = False) As String
        Dim s As String = ConvertJsonDataToXml(SendData(ConvertXmlDataToJson(sXmlRq), MakeFullUrl(m_sAjaxUrl)))
        If Not bDoNotCache Then m_sAccountPortfolio = s
        Return s
    End Function

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="sAccountIndex">Index of Account as retrieved in the Account List</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function RetrieveTxnHistory(ByVal sAccountIndex As Integer) As String
        Return ConvertJsonDataToXml(SendData(Get_RetrieveTxnHistory_Request(sAccountIndex), MakeFullUrl(m_sAjaxUrl)))
    End Function

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="sAccountNumber">Account Number</param>
    ''' <returns></returns>
    ''' <remarks>
    ''' Using the Account Number, queries the AccountPortfolio and gets the AccountIndex, then calls the above services.
    ''' </remarks>    
    Public Function RetrieveTxnHistory(ByVal sAccountNumber As String) As String
        Dim sXpathAccountId As String = "/root/AccountGroups/ListAccount[AccountNumber=""" & sAccountNumber & """]/Id"

        Dim oXmlDocument As New XmlDocument()
        oXmlDocument.LoadXml(m_sAccountPortfolio)  'AccountPortfolio
        Dim sAccountId As String = oXmlDocument.SelectSingleNode(sXpathAccountId).InnerText


        Return ConvertJsonDataToXml(SendData(Get_RetrieveTxnHistory_Request(sAccountId), MakeFullUrl(m_sAjaxUrl)))
    End Function

    ''' <summary>
    ''' Send the Transfer Request which gets the Indexes of accounts...
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function InitTransfer() As String
        Return ConvertJsonDataToXml(SendData(Get_InitTransfer_Request(), MakeFullUrl(m_sAjaxUrl)))
    End Function

#End Region

#Region "Service Request Data"
    Public Function Get_RetrieveAccountPortfolio_Request(ByVal sUsername As String, ByVal sPassword As String) As String
        Return My.Resources.LoginStringPart1 & sUsername & My.Resources.LoginStringPart2 & sPassword & My.Resources.LoginStringPart3
    End Function

    Public Function Get_RetrieveTxnHistory_Request(ByVal sAccountIndex As Integer) As String
        Return My.Resources.GetTxnHistoryPart1 & sAccountIndex & My.Resources.GetTxnHistoryPart2
    End Function

    Public Function Get_InitTransfer_Request() As String
        Return My.Resources.InitTransferRq
    End Function

#End Region


End Class
