'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Explicit On

Imports System.Xml.Linq
Imports System.Xml

Public Class RetrieveAccountPortfolio2
    Inherits ServiceBase

    Dim m_oDocRq As data.xmlschemaclasses.AccountPortfolio.Rq.AccountPortfolioRq
    Dim m_oDocRs As data.xmlschemaclasses.AccountPortfolio.Rs.root
    ' Dim m_oDocRsJson As data.xmlschemaclasses.AccountPortfolio.Rs.json.root

    'Service Entry Point 
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()

        Try
            MyBase.ProcessMsgSync(oEnv)

            m_oDocRq = m_oEnvRq.GetDocument("AccountPortfolio.Rq").GetAsObject(GetType(data.xmlschemaclasses.AccountPortfolio.Rq.AccountPortfolioRq))

            Dim oMobSvc As New application.mobile.MobileServices()
            Dim x As New XMLUtil

            'Convert from json no_namespace to our namespace...
            Dim sXmlRs As String = oMobSvc.RetrieveAccountPortfolio(GetRequest())
            sXmlRs = Replace(sXmlRs, _
                                            "<root>", _
                                            "<tns:root xmlns:tns=""urn:au.com.keystroke.samples.banking.data.AccountPortfolioRs"">", _
                                            , _
                                            , CompareMethod.Text)

            sXmlRs = Replace(sXmlRs, _
                                           "</root>", _
                                           "</tns:root>", _
                                           , _
                                           , CompareMethod.Text)


            'm_oDocRsJson = x.DeSerialize(sXmlRs, GetType(data.xmlschemaclasses.AccountPortfolio.Rs.json.root))


            m_oDocRs = x.DeSerialize(sXmlRs, GetType(data.xmlschemaclasses.AccountPortfolio.Rs.root))

            If m_oDocRs.ErrorMessages <> "" Then
                m_oEnvRs.AddError(43, "Banking Services", m_oDocRs.ErrorMessages)
            Else
                m_oEnvRs.AddDocument(New InlineDocument(m_oDocRs))
            End If

            Return m_oEnvRs

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString())
            Throw

        Finally
            EndMethod()
        End Try
    End Function

    Protected Function GetRequest() As String

        Dim oXDocument As New XDocument
        oXDocument = <?xml version="1.0" encoding="utf-8"?>
                     <root xmlns="">
                         <Params>
                             <Name>Request</Name>
                             <Value>login</Value>
                         </Params>
                         <Params>
                             <Name>UserName</Name>
                             <Value><%= m_oDocRq.Username %></Value>
                         </Params>
                         <Params>
                             <Name>Password</Name>
                             <Value><%= m_oDocRq.Password %></Value>
                         </Params>
                         <Params>
                             <Name>Token</Name>
                             <Value>
                             </Value>
                         </Params>
                     </root>

        Return oXDocument.ToString

    End Function

End Class

