
Public Class EsbAwareSequentialWorkflowSample
    Inherits EsbWorkflowServiceBase

    Private Sub IsApproved(ByVal sender As System.Object, ByVal e As System.Workflow.Activities.ConditionalEventArgs)
        StartMethod()
        e.Result = m_oEnvRq.GetCustomParam("Amount") < 500
        EndMethod()
    End Sub

    Public Enum eStatusType
        None
        Approved
        Rejected
    End Enum

    Private Sub OnApproved(ByVal sender As System.Object, ByVal e As System.EventArgs)
        StartMethod()

        m_oEnvRs.SetCustomParam("Status", eStatusType.Approved)
        m_oEnvRs.AddDocument(New InlineDocument("<aaa>Hello from ESB Aware Sequential Workflow</aaa>"))
        Dim oerr As New ErrorXML
        oerr.WarningEntry = New WarningEntryCol
        Dim oWarningEntry As New WarningEntry
        oWarningEntry.Description = "Order Approved - order value was:" & m_oEnvRq.GetCustomParam("Amount")
        oerr.WarningEntry.Add(oWarningEntry)
        m_oEnvRs.AddDocument(New InlineDocument(oerr))

        EndMethod()
    End Sub

    Private Sub OnRejected(ByVal sender As System.Object, ByVal e As System.EventArgs)
        StartMethod()
        If ShouldLog(LogDefs.eLogLevel.eLOG_INFO) Then : LogMsg(LogDefs.eLogLevel.eLOG_INFO, "Hehe, got here!!!Yer inda workflow now!!!") : End If

        m_oEnvRs.SetCustomParam("Status", eStatusType.Rejected)
        m_oEnvRs.AddDocument(New InlineDocument("<aaa>Hello from ESB Aware Sequential Workflow</aaa>"))
        Dim oerr As New ErrorXML
        oerr.WarningEntry = New WarningEntryCol
        Dim oWarningEntry As New WarningEntry
        oWarningEntry.Description = "Order Rejected! Costs too much  - " & m_oEnvRq.GetCustomParam("Amount")
        oerr.WarningEntry.Add(oWarningEntry)
        m_oEnvRs.AddDocument(New InlineDocument(oerr))

        EndMethod()

    End Sub


    Public Overrides Sub ESBInitialized(ByVal sender As System.Object, ByVal e As System.EventArgs)
        MyBase.ESBInitialized(sender, e)
        StartMethod()
        EndMethod()
    End Sub
    Public Shared xsdValidationActivity1_ValidationErrors1Property As System.Workflow.ComponentModel.DependencyProperty = DependencyProperty.Register("xsdValidationActivity1_ValidationErrors1", GetType(System.String), GetType(au.com.keystroke.samples.banking.services.activity.orchestration.EsbAwareSequentialWorkflowSample))

    'Public Overrides Sub ESBCompleted(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    StartMethod()
    '    EndMethod()
    '    MyBase.ESBCompleted(sender, e)

    'End Sub

    <System.ComponentModel.DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <System.ComponentModel.BrowsableAttribute(True)> _
            <System.ComponentModel.CategoryAttribute("ESB Service in/out Parameters")> _
                Public Property xsdValidationActivity1_ValidationErrors1() As System.String
        Get
            Return CType(MyBase.GetValue(au.com.keystroke.samples.banking.services.activity.orchestration.EsbAwareSequentialWorkflowSample.xsdValidationActivity1_ValidationErrors1Property), String)

        End Get
        Set(ByVal value As System.String)
            MyBase.SetValue(au.com.keystroke.samples.banking.services.activity.orchestration.EsbAwareSequentialWorkflowSample.xsdValidationActivity1_ValidationErrors1Property, value)

        End Set
    End Property
    Public Shared xsdValidationActivity1_ValidationSucceeded1Property As System.Workflow.ComponentModel.DependencyProperty = DependencyProperty.Register("xsdValidationActivity1_ValidationSucceeded1", GetType(System.Boolean), GetType(au.com.keystroke.samples.banking.services.activity.orchestration.EsbAwareSequentialWorkflowSample))

    <System.ComponentModel.DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <System.ComponentModel.BrowsableAttribute(True)> _
            <System.ComponentModel.CategoryAttribute("ESB Service in/out Parameters")> _
                Public Property xsdValidationActivity1_ValidationSucceeded1() As System.Boolean
        Get
            Return CType(MyBase.GetValue(au.com.keystroke.samples.banking.services.activity.orchestration.EsbAwareSequentialWorkflowSample.xsdValidationActivity1_ValidationSucceeded1Property), Boolean)

        End Get
        Set(ByVal value As System.Boolean)
            MyBase.SetValue(au.com.keystroke.samples.banking.services.activity.orchestration.EsbAwareSequentialWorkflowSample.xsdValidationActivity1_ValidationSucceeded1Property, value)

        End Set
    End Property
    Public Shared xsltActivity1_TransformResult1Property As System.Workflow.ComponentModel.DependencyProperty = DependencyProperty.Register("xsltActivity1_TransformResult1", GetType(System.String), GetType(au.com.keystroke.samples.banking.services.activity.orchestration.EsbAwareSequentialWorkflowSample))

    <System.ComponentModel.DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <System.ComponentModel.BrowsableAttribute(True)> _
            <System.ComponentModel.CategoryAttribute("ESB Runtime")> _
                Public Property xsltActivity1_TransformResult1() As System.String
        Get
            Return CType(MyBase.GetValue(au.com.keystroke.samples.banking.services.activity.orchestration.EsbAwareSequentialWorkflowSample.xsltActivity1_TransformResult1Property), String)

        End Get
        Set(ByVal value As System.String)
            MyBase.SetValue(au.com.keystroke.samples.banking.services.activity.orchestration.EsbAwareSequentialWorkflowSample.xsltActivity1_TransformResult1Property, value)

        End Set
    End Property

    Private Sub ChuckAWobbly(ByVal sender As System.Object, ByVal e As System.EventArgs)
        StartMethod()

        'm_oEnvRs.SetCustomParam("Status", eStatusType.Approved)
        'm_oEnvRs.AddDocument(New InlineDocument("<aaa>Hello from ESB Aware Sequential Workflow</aaa>"))
        Dim oerr As New ErrorXML
        oerr.ErrorEntry = New ErrorEntryCol
        Dim oErrorEntry As New ErrorEntry
        oErrorEntry.Description = "XSD Validation failed:" & xsdValidationActivity1_ValidationErrors1
        oerr.ErrorEntry.Add(oErrorEntry)
        m_oEnvRs.AddDocument(New InlineDocument(oerr))

        EndMethod()

        'Throw New Exception("Aaaaarrgghh  XSD Validation Failed...")
    End Sub

    Private Sub RetuenSomething(ByVal sender As System.Object, ByVal e As System.EventArgs)
        StartMethod()

        Dim oerr As New ErrorXML
        oerr.warningEntry = New WarningEntryCol
        Dim owarningEntry As New WarningEntry
        owarningEntry.Description = "Test Sequential Workflow Succeeded..."
        oerr.warningEntry.Add(owarningEntry)
        m_oEnvRs.AddDocument(New InlineDocument(oerr))

        EndMethod()
    End Sub
End Class
