﻿Imports System.IO
Imports System.Text
Imports System.Net
Imports System.Security.Cryptography.X509Certificates
Imports System.Net.Security
Imports Newtonsoft.Json

Public Class BaseMobileServices


#Region "Basic Capabilities"
    Dim m_oHttpClient As ESB.Core.HTTPClient.XMLHttpRequest


    Private m_sBaseFilePath As String = "C:\Data\Projects\CBA\NetBankJsonApi\FOLMobileClient\Data\"
    Public Property BaseFilePath() As String
        Get
            Return m_sBaseFilePath
        End Get
        Set(ByVal value As String)
            m_sBaseFilePath = value
        End Set
    End Property


    Private m_sResponseTime As String
    Public Property ResponseTime() As String
        Get
            Return m_sResponseTime
        End Get
        Set(ByVal value As String)
            m_sResponseTime = value
        End Set
    End Property


    Private m_sUsername As String
    Public Property Username() As String
        Get
            Return m_sUsername
        End Get
        Set(ByVal value As String)
            m_sUsername = value
        End Set
    End Property

    Private m_sPassword As String
    Public Property Password() As String
        Get
            Return m_sPassword
        End Get
        Set(ByVal value As String)
            m_sPassword = value
        End Set
    End Property

    Public Sub New()
        System.Net.ServicePointManager.Expect100Continue = False
        System.Net.ServicePointManager.DefaultConnectionLimit = 20
        ServicePointManager.ServerCertificateValidationCallback = AddressOf RemoteCertificateValidationCallback
        m_oHttpClient = New ESB.Core.HTTPClient.XMLHttpRequest(True, True)
        m_oHttpClient.HonourProxyServer = True
    End Sub
    Public Function LoadData(ByVal sFileName As String) As String
        Return My.Computer.FileSystem.ReadAllText(m_sBaseFilePath & sFileName)
    End Function
    Public Function LoadData2() As String
        Return My.Resources.LoginStringPart1 & m_sUsername & My.Resources.LoginStringPart2 & m_sPassword & My.Resources.LoginStringPart3
    End Function
    Public Function LoadData3() As String
        Return My.Resources.GetTxnHistory
    End Function
    Public Function MakeFullUrl(ByVal sUrl As String)
        Dim sBaseUrl As String = "https://www2.my.commbank.com.au/"
        Return sBaseUrl & sUrl
    End Function

    ''' <summary>
    ''' Performs a HTTP GET on the Mobile website for the given URL
    ''' </summary>
    ''' <param name="sUrl"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetData(ByVal sUrl As String) As String
        m_oHttpClient.Open("GET", sUrl, False, "", "")
        m_oHttpClient.Send()
        Dim responseFromServer As String = m_oHttpClient.GetResponseText()
        Return responseFromServer
    End Function

    ''' <summary>
    ''' Sends JSON formated request data to the Mobile website using HTTP Post for the given URL
    ''' </summary>
    ''' <param name="sRqData"></param>
    ''' <param name="sUrl"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function SendData(ByVal sRqData As String, ByVal sUrl As String) As String
        Dim osw As New Stopwatch
        osw.Start()


        'Do the SID/RID thing to the URL...
        If Not m_oHttpClient.Cookies Is Nothing Then

            If Not m_oHttpClient.Cookies.GetCookies(New Uri(sUrl)) Is Nothing Then
                sUrl = sUrl & "?" & m_oHttpClient.Cookies.GetCookies(New Uri(sUrl))("_CBAPVCOOKIE").Value
            End If
        End If

        m_oHttpClient.Open("POST", sUrl, False, "", "")
        SetHeaders(m_oHttpClient)
        m_oHttpClient.Send(sRqData)

        Dim responseFromServer As String = m_oHttpClient.GetResponseText()
        m_oHttpClient.Response.Close()

        If responseFromServer = "" Then
            Throw New Exception("Server returned empty response for request = " & sRqData)
        End If
        osw.Stop()

        m_sResponseTime = osw.ElapsedMilliseconds.ToString
        Return responseFromServer

    End Function
    Public Sub SetHeaders(ByVal oHttpClient As ESB.Core.HTTPClient.XMLHttpRequest)
        With oHttpClient
            .SetRequestHeader("Content-Type", "application/json")
            .SetRequestHeader("Accept-Encoding", "gzip, deflate")
            .SetRequestHeader("Cache-Control", "no-cache")
            .SetRequestHeader("Accept-Language", "en-au")
            .SetRequestHeader("Accept", "*/*")
            .SetRequestHeader("UA-CPU", "x86")
            .SetRequestHeader("Referer", "https://www2.my.commbank.com.au/mobile/i/default.aspx")
            .SetRequestHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0; WOW64; SLCC1; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30618; InfoPath.2; OfficeLiveConnector.1.3; OfficeLivePatch.0.0)")
        End With
    End Sub
    Public Function RemoteCertificateValidationCallback(ByVal sender As Object, _
                                                         ByVal certificate As X509Certificate, _
                                                         ByVal chain As X509Chain, _
                                                         ByVal sslPolicyErrors As SslPolicyErrors _
                                                        ) As Boolean
        Return True
    End Function
    Public Function LoadData() As String
        Dim s As String
        s = LoadData("LoginToProfile_Response_Data.htm")
        's = LoadData("Rawdata2_Portfolio.txt")

        'strip /*       */
        s = Replace(s, "/*", "")
        s = Replace(s, "*/", "")
        Return s
    End Function
    Public Function JSONParseData(ByVal s As String) As String
        Dim o As Object = JsonConvert.DeserializeObject(s)
        Return JsonConvert.SerializeObject(o, Formatting.Indented)
    End Function
    Public Function JSONAddRoot(ByVal s As String) As String
        Return "{""root"":[" & s & "]}"
    End Function
    Public Function JSONRemoveComments(ByVal s As String) As String
        'strip /*       */
        s = Replace(s, "/*", "")
        s = Replace(s, "*/", "")
        Return s
    End Function
    Public Function ConvertJsonDataToXml(ByVal s As String) As String
        s = JSONRemoveComments(s)
        s = JSONAddRoot(s)
        Dim oXmlNode As System.Xml.XmlNode = JsonConvert.DeserializeXmlNode(s)
        Dim x As New ESB.Core.XMLSchemaClasses.XMLUtil()
        s = x.PrettyFormatXML(oXmlNode.OuterXml)
        Return s
    End Function

    Public Function ConvertXmlDataToJson(ByVal s As String) As String
        s = s.Replace("xmlns=""""", "")

        Dim oXmlNode As New System.Xml.XmlDocument
        oXmlNode.LoadXml(s)
        Dim sJson As String = JsonConvert.SerializeXmlNode(oXmlNode.DocumentElement)
        'need to remove root...
        sJson = sJson.Replace("""root"":{", "")

        'Remove trailing ]}...
        sJson = sJson.Remove(sJson.Length - 2)

        Return sJson
    End Function

    Public Function GetRequestFromFile(ByVal sFilename As String) As String
        Return My.Computer.FileSystem.ReadAllText(m_sBaseFilePath & sFilename)
    End Function

#End Region

End Class



