﻿Imports System.Activities
Imports ESB.Core.Interfaces.Envelope
Imports ESB.Core.XMLSchemaClasses

Public NotInheritable Class InterchangeValidationActivity
    Inherits CodeActivity(Of IEnvelope)  'Define the activity output argument as being of type IEnvelope

    'Define an activity input argument of type IEnvelope
    <RequiredArgument()> _
    Property EnvRq() As InArgument(Of IEnvelope)
    Property ValidationStatus() As InOutArgument(Of Boolean)

    Protected Overrides Function Execute(ByVal context As System.Activities.CodeActivityContext) As Core.Interfaces.Envelope.IEnvelope
        Dim oEnv As IEnvelope = Nothing

        Try
            oEnv = context.GetValue(Me.EnvRq)

            Dim oISO20022Doc As CBA.Payments.ISO20022.Document
            oISO20022Doc = oEnv.GetDocumentAsObject(GetType(CBA.Payments.ISO20022.Document))

            'Set the document back in the envelope as an object, so that subsequent get's as an Object
            'don't need to be deserialised...
            'oEnv.GetDocument(GetType(CBA.Payments.ISO20022.Document)).SetDocument(oISO20022Doc)

            'Test - see if it works. 
            'TODO: See if this actually avoids the deserialisation...
            ' oISO20022Doc = oEnv.GetDocumentAsObject(GetType(CBA.Payments.ISO20022.Document))

            Me.ValidationStatus.Set(context, True)

            oEnv.AddDocument(New InlineDocument("<AS:Ola xmlns:AS='urn:AnSt' >Interchange validation-parsing succeeded.</AS:Ola>"))

            Return oEnv

        Catch ex As Exception
            Me.ValidationStatus.Set(context, False)
            oEnv.AddDocument(New InlineDocument("<AS:Ola xmlns:AS='urn:AnSt'>" & Util.EscapeXmlString(ex.ToString) & "</AS:Ola>"))
            Return oEnv
        Finally

        End Try

    End Function
End Class
