﻿Imports System.Activities
Imports ESB.Core.Interfaces.Envelope
Imports ESB.Core.XMLSchemaClasses


Public NotInheritable Class SetWfInstanceStates
    Inherits CodeActivity

    <RequiredArgument()> Property WfStates As InOutArgument(Of WfStates)
    Property InInterchangeState() As InArgument(Of eInInterchangeStates)
    Property InInstructionState() As InArgument(Of eInInstructionStates)
    Property OutInterchangeState() As InArgument(Of eOutInterchangeStates)
    Property OutInstructionState() As InArgument(Of eOutInstructionStates)



    Protected Overrides Sub Execute(ByVal context As System.Activities.CodeActivityContext)
        Dim oWfs As WfStates
        oWfs = context.GetValue(Me.WfStates)
        If oWfs Is Nothing Then
            'should only get in here once, during initialization...
            oWfs = New WfStates
            WfStates.Set(context, oWfs)
        End If

        oWfs.InInterchangeState = context.GetValue(Me.InInterchangeState)
        oWfs.InInstructionState = context.GetValue(Me.InInstructionState)
        oWfs.OutInterchangeState = context.GetValue(Me.InInterchangeState)
        oWfs.OutInstructionState = context.GetValue(Me.OutInstructionState)

        'TODO: Make this an external reference - common to all workflows...
    End Sub
End Class
