'-----------------------------------------------------------------------------
' <summary>
' Copyright Keystroke IT 2003
' <WrittenBy>Minas Casiou, Keystroke IT Australia</WrittenBy>
' </summary>
'-----------------------------------------------------------------------------
Option Explicit On

''' 
'''  <summary>Update the Services.EnterprisePacks.Management.InstancesHeader etc. with information about this ESB instance.
''' 
''' </summary>
''' <remarks></remarks>

<ESB.Core.Util.Attributes.Service(), ESB.Core.Util.Attributes.Documents("", "")> _
Public Class PublishInstanceDetails
    Inherits ServiceBase

    Dim m_oDocRq As Object
    Dim m_oDocRs As Object

    'Service Entry Point 
    Public Overrides Function ProcessMsgSync(ByVal oEnv As IEnvelope) As IEnvelope
        StartMethod()

        Try
            MyBase.ProcessMsgSync(oEnv)

            'Ignore request. Just update the instance DB about info about this ESB instance...
            DoWork()
            'Dim x As String = Request.Url.DnsSafeHost


            m_oEnvRs.AddDocument(New InlineDocument("<a>Instance Publisher updated Instances DB with information about this instance.</a>"))


            Return m_oEnvRs

        Catch ex As Exception
            ExceptionManager.Publish(ex)
            LogError(LogDefs.eLogLevel.eLOG_ERROR, ex.ToString())
            Throw

        Finally
            EndMethod()
        End Try
    End Function

    Protected Sub DoWork()
        'Insert records into Instance Header 
        Dim oHeaderTableAdaptor As New ESBInstanceManagementTableAdapters.Services_EnterprisePacks_Management_InstancesHeaderTableAdapter()
        oHeaderTableAdaptor.Connection.ConnectionString = System.Configuration.ConfigurationManager.ConnectionStrings("ESBLogConnectionString").ConnectionString

        Dim oServerCtx As Server.ServerContext = GetContext.serverContext




        With GetContext.ThreadLogDetail
            Dim oHeaderDataRows As ESBInstanceManagement.Services_EnterprisePacks_Management_InstancesHeaderRow()
            oHeaderDataRows = oHeaderTableAdaptor.GetData().Select("host='" & oServerCtx.ServerDnsSafeHost & "' and ESBInstanceName='" & Util.ESBGlobalVariables.ESBInstanceName & "'")
            If oHeaderDataRows.GetLength(0) = 0 Then
                oHeaderTableAdaptor.Insert(oServerCtx.ServerDnsSafeHost, Util.ESBGlobalVariables.ESBInstanceName, Now, Now, .FullyQualifiedInstanceName, .sESBServiceDomainName, .sClusterName, .bIsServiceDomainEntryPoint)  'check for existing and update detail...
            Else
                If oHeaderDataRows.GetLength(0) = 1 Then
                    oHeaderDataRows(0).LastUpdated = Now
                    oHeaderTableAdaptor.Update(oHeaderDataRows(0))
                Else
                    Throw New Exception("More than one Row detected for host=" & oServerCtx.ServerDnsSafeHost & "and ESBInstanceName=" & Util.ESBGlobalVariables.ESBInstanceName)
                End If

            End If

        End With



    End Sub


End Class
