Imports System
Imports System.ComponentModel
Imports System.ComponentModel.Design
Imports System.Collections
Imports System.Drawing
Imports System.Net.Mail
Imports System.Workflow.ComponentModel.Compiler
Imports System.Workflow.ComponentModel.Serialization
Imports System.Workflow.ComponentModel
Imports System.Workflow.ComponentModel.Design
Imports System.Workflow.Runtime
Imports System.Workflow.Activities
Imports System.Workflow.Activities.Rules
Imports ESB.Core.Interfaces.ProcessMsg


Public Class EsbAwareSequentialWorkflowSampleWithESBServices
    Inherits EsbWorkflowServiceBase

    Private Sub IsApproved(ByVal sender As System.Object, ByVal e As System.Workflow.Activities.ConditionalEventArgs)
        StartMethod()
        e.Result = m_oEnvRq.GetCustomParam("Amount") < 500
        EndMethod()
    End Sub

    Public Enum eStatusType
        None
        Approved
        Rejected
    End Enum

    Private Sub OnApproved(ByVal sender As System.Object, ByVal e As System.EventArgs)
        StartMethod()

        m_oEnvRs.SetCustomParam("Status", eStatusType.Approved)
        m_oEnvRs.AddDocument(New InlineDocument("<aaa>Hello from ESB Aware Sequential Workflow</aaa>"))
        Dim oerr As New ErrorXML
        oerr.WarningEntry = New WarningEntryCol
        Dim oWarningEntry As New WarningEntry
        oWarningEntry.Description = "Order Approved - order value was:" & m_oEnvRq.GetCustomParam("Amount")
        oerr.WarningEntry.Add(oWarningEntry)
        m_oEnvRs.AddDocument(New InlineDocument(oerr))

        SetEmailBody()

        EndMethod()
    End Sub
    Private Sub SetEmailBody()
        sendEmail_Body = "Purchase Order was: "
        sendEmail_Body += CStr(IIf(m_oEnvRq.GetCustomParam("Amount") < 500, "Approved as", "Rejected because"))
        sendEmail_Body += vbNewLine
        sendEmail_Body += " Purchase Order amount was: $"
        sendEmail_Body += m_oEnvRq.GetCustomParam("Amount")
    End Sub
    Private Sub OnRejected(ByVal sender As System.Object, ByVal e As System.EventArgs)
        StartMethod()
        If ShouldLog(LogDefs.eLogLevel.eLOG_INFO) Then : LogMsg(LogDefs.eLogLevel.eLOG_INFO, "Hehe, got here!!!Yer inda workflow now!!!") : End If

        m_oEnvRs.SetCustomParam("Status", eStatusType.Rejected)
        m_oEnvRs.AddDocument(New InlineDocument("<aaa>Hello from ESB Aware Sequential Workflow</aaa>"))
        Dim oerr As New ErrorXML
        oerr.WarningEntry = New WarningEntryCol
        Dim oWarningEntry As New WarningEntry
        oWarningEntry.Description = "Order Rejected! Costs too much  - " & m_oEnvRq.GetCustomParam("Amount")
        oerr.WarningEntry.Add(oWarningEntry)
        m_oEnvRs.AddDocument(New InlineDocument(oerr))

        SetEmailBody()

        EndMethod()

    End Sub


    
    Public Shared sendEmail_BodyProperty As System.Workflow.ComponentModel.DependencyProperty = DependencyProperty.Register("sendEmail_Body", GetType(System.String), GetType(esb.net.services.activity.orchestrated4.EsbAwareSequentialWorkflowSampleWithESBServices))

    <System.ComponentModel.DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <System.ComponentModel.BrowsableAttribute(True)> _
            <System.ComponentModel.CategoryAttribute("Email Message")> _
                Public Property sendEmail_Body() As System.String
        Get
            Return CType(MyBase.GetValue(esb.net.services.activity.orchestrated4.EsbAwareSequentialWorkflowSampleWithESBServices.sendEmail_BodyProperty), String)

        End Get
        Set(ByVal value As System.String)
            MyBase.SetValue(esb.net.services.activity.orchestrated4.EsbAwareSequentialWorkflowSampleWithESBServices.sendEmail_BodyProperty, value)

        End Set
    End Property






    Private Sub populateEsbErrorDocument(ByVal sender As System.Object, ByVal e As System.EventArgs)
        m_oEnvRs.SetCustomParam("Status", eStatusType.None)
        m_oEnvRs.AddDocument(New InlineDocument("<aaa>ESB Aware Sequential Workflow FAILED</aaa>"))
        Dim oerr As New ErrorXML
        oerr.ErrorEntry = New ErrorEntryCol
        Dim oErrorEntry As New ErrorEntry
        oErrorEntry.Description = "Order Processing Failed:" & faultHandlerActivity1.Fault.ToString
        oerr.ErrorEntry.Add(oErrorEntry)
        m_oEnvRs.AddDocument(New InlineDocument(oerr))

    End Sub

    Private Sub delayActivity1_InitializeTimeoutDuration(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub
End Class
